![logo](https://github.com/MadNLP/MadNLP.jl/blob/master/logo-full.svg)

*A [nonlinear programming](https://en.wikipedia.org/wiki/Nonlinear_programming) solver based on the filter line-search [interior point method](https://en.wikipedia.org/wiki/Interior-point_method) (as in [Ipopt](https://github.com/coin-or/Ipopt)) that can handle/exploit diverse classes of data structures, either on [host](https://en.wikipedia.org/wiki/Central_processing_unit) or [device](https://en.wikipedia.org/wiki/Graphics_processing_unit) memories.*

---

| **License** | **Documentation** | **Build Status** | **Coverage** | **DOI** |
|:-----------:|:-----------------:|:----------------:|:------------:|:-------:|
| [![License: MIT][license-img]][license-url] | [![docs-stable][docs-stable-img]][docs-stable-url] [![docs-dev][docs-dev-img]][docs-dev-url] | [![build-gh][build-gh-img]][build-gh-url] | [![codecov][codecov-img]][codecov-url] | [![doi][doi-img]][doi-url] |

[license-img]: https://img.shields.io/badge/License-MIT-yellow.svg
[license-url]: https://github.com/MadNLP/MadNLP.jl/blob/master/LICENSE
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://madnlp.github.io/MadNLP.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-purple.svg
[docs-dev-url]: https://madnlp.github.io/MadNLP.jl/dev
[build-gh-img]: https://github.com/MadNLP/MadNLP.jl/actions/workflows/test.yml/badge.svg
[build-gh-url]: https://github.com/MadNLP/MadNLP.jl/actions/workflows/test.yml
[codecov-img]: https://codecov.io/gh/MadNLP/MadNLP.jl/branch/master/graph/badge.svg?token=MBxH2AAu8Z
[codecov-url]: https://codecov.io/gh/MadNLP/MadNLP.jl
[doi-img]: https://zenodo.org/badge/DOI/10.5281/zenodo.5825776.svg
[doi-url]: https://doi.org/10.5281/zenodo.5825776


## Quickstart

The following example shows how to solve the HS15 problem with JuMP and MadNLP:
```julia
using JuMP, MadNLP
model = Model()
@variable(model, x1 <= 0.5)
@variable(model, x2)
@objective(model, Min, 100.0 * (x2 - x1^2)^2 + (1.0 - x1)^2)
@constraint(model, x1 * x2 >= 1.0)
@constraint(model, x1 + x2^2 >= 0.0)
JuMP.set_optimizer(model, MadNLP.Optimizer)
JuMP.set_optimizer_attribute(model, "max_iter", 100)
JuMP.set_optimizer_attribute(model, "print_level", MadNLP.INFO)
optimize!(model)
```

## Installation

MadNLP can be installed directly via the Julia package manager:
```julia
pkg> add MadNLP
```
Furthermore, MadNLP comes with several extensions:

- `MadNLPGPU`: import GPU-accelerated linear solvers in MadNLP
- `MadNLPHSL`: import the HSL linear solvers in MadNLP
- `MadNLPPardiso`: import the Pardiso linear solver in MadNLP

## Citing MadNLP.jl

If you use MadNLP.jl in your research, we would greatly appreciate your citing it.

```bibtex
@article{shin2024accelerating,
  title     = {Accelerating optimal power flow with {GPU}s: {SIMD} abstraction of nonlinear programs and condensed-space interior-point methods},
  author    = {Shin, Sungho and Anitescu, Mihai and Pacaud, Fran{\c{c}}ois},
  journal   = {Electric Power Systems Research},
  volume    = {236},
  pages     = {110651},
  year      = {2024},
  publisher = {Elsevier}
}

@article{shin2021graph,
  title     = {Graph-based modeling and decomposition of energy infrastructures},
  author    = {Shin, Sungho and Coffrin, Carleton and Sundar, Kaarthik and Zavala, Victor M},
  journal   = {IFAC-PapersOnLine},
  volume    = {54},
  number    = {3},
  pages     = {693--698},
  year      = {2021},
  publisher = {Elsevier}
}
```

## Supporting MadNLP.jl
- Please report issues and feature requests via the [GitHub issue tracker](https://github.com/MadNLP/MadNLP.jl/issues).
- Questions are welcome at [GitHub discussion forum](https://github.com/MadNLP/MadNLP.jl/discussions).

## Install
```julia
pkg> add MadNLPPardiso
```

## Build

To use Pardiso, the user needs to obtain the Paridso shared libraries from <https://www.pardiso-project.org/>, provide the absolute path to the shared library:
```
julia> ENV["MADNLP_PARDISO_LIBRARY_PATH"] = "/usr/lib/libpardiso600-GNU800-X86-64.so"
```
and place the license file in the home directory.
After obtaining the libarary and the license file, run
```julia
pkg> build MadNLPPardiso
```

The build process requires a C compiler. If they are not installed, do:
```julia
shell> sudo apt install gcc # Ubuntu, Debian
shell> brew cask install gcc # MacOS
```
The compiler can be customized by:
```julia
julia> ENV["MADNLP_CC"] = "/usr/local/bin/gcc-9"    # default is "gcc"
```

## Install
```julia
pkg> add MadNLPHSL
```
Obtain a license and download HSL_jll.jl from https://licences.stfc.ac.uk/products/Software/HSL/LibHSL.

Install this download into your current environment using:

```julia
import Pkg
Pkg.develop(path = "/full/path/to/HSL_jll.jl")
```

Alternatively, one can use a custom-compiled HSL library by overriding the `HSL_jll.jl` artifact.
This can be done by editing `~/.julia/artifacts/Overrides.toml`
```
# replace HSL_jll.jl artifact /usr/local/lib/libhsl.so
ecece3e2c69a413a0e935cf52e03a3ad5492e137 = "/usr/local"
```

# Wrapping headers

This directory contains a script that can be used to automatically generate wrappers from C headers provided by [Panua-Pardiso](https://panua.ch/pardiso/).
This is done using Clang.jl.

# Setup

You need to create an `include` folder that contains the header files `pardiso.h`.

# Usage

Either run `julia wrapper.jl` directly, or include it and call the `main()` function.
Be sure to activate the project environment in this folder (`julia --project`), which will install `Clang.jl` and `JuliaFormatter.jl`.

ma27_default_icntl(INT) = INT[
    6,
    6,
    0,
    2139062143,
    1,
    32639,
    32639,
    32639,
    32639,
    14,
    9,
    8,
    8,
    9,
    10,
    32639,
    32639,
    32639,
    32689,
    24,
    11,
    9,
    8,
    9,
    10,
    0,
    0,
    0,
    0,
    0,
]
ma27_default_cntl(T) = T[0.1, 1.0, 0.0, 0.0, 0.0]

@kwdef mutable struct Ma27Options <: AbstractOptions
    ma27_pivtol::Float64 = 1e-8
    ma27_pivtolmax::Float64 = 1e-4
    ma27_liw_init_factor::Float64 = 5.0
    ma27_la_init_factor::Float64 = 5.0
    ma27_meminc_factor::Float64 = 2.0
end

mutable struct Ma27Solver{T,INT} <: AbstractLinearSolver{T}
    csc::SparseMatrixCSC{T,INT}
    I::Vector{INT}
    J::Vector{INT}

    icntl::Vector{INT}
    cntl::Vector{T}

    info::Vector{INT}

    a::Vector{T}
    a_view::SubArray{T,1,Vector{T},Tuple{UnitRange{Int64}},true}
    la::INT
    ikeep::Vector{INT}

    iw::Vector{INT}
    liw::INT
    iw1::Vector{INT}
    nsteps::Vector{INT}
    w::Vector{T}
    maxfrt::Vector{INT}

    opt::Ma27Options
    logger::MadNLPLogger
end

function Ma27Solver(
    csc::SparseMatrixCSC{T,INT};
    opt = Ma27Options(),
    logger = MadNLPLogger(),
) where {T,INT}
    I, J = findIJ(csc)
    nz = nnz(csc) |> INT

    liw = INT(2 * (2 * nz + 3 * csc.n + 1))
    iw = Vector{INT}(undef, liw)
    ikeep = Vector{INT}(undef, 3 * csc.n)
    iw1 = Vector{INT}(undef, 2 * csc.n)
    nsteps = INT[1]
    iflag = INT(0)

    icntl = ma27_default_icntl(INT)
    cntl = ma27_default_cntl(T)
    icntl[1:2] .= 0
    cntl[1] = opt.ma27_pivtol

    info = Vector{INT}(undef, 20)
    HSL.ma27ar(
        T,
        INT,
        csc.n,
        nz,
        I,
        J,
        iw,
        liw,
        ikeep,
        iw1,
        nsteps,
        iflag,
        icntl,
        cntl,
        info,
        zero(T),
    )
    info[1] < 0 && throw(SymbolicException())

    la = ceil(INT, max(nz, opt.ma27_la_init_factor * info[5]))
    a = Vector{T}(undef, la)
    a_view = view(a, 1:nnz(csc)) # _madnlp_unsafe_wrap is not used because we may resize a
    liw = ceil(INT, opt.ma27_liw_init_factor * info[6])
    resize!(iw, liw)
    maxfrt = INT[1]

    return Ma27Solver{T,INT}(
        csc,
        I,
        J,
        icntl,
        cntl,
        info,
        a,
        a_view,
        la,
        ikeep,
        iw,
        liw,
        iw1,
        nsteps,
        Vector{T}(),
        maxfrt,
        opt,
        logger,
    )
end


function factorize!(M::Ma27Solver{T,INT}) where {T,INT}
    M.a_view .= M.csc.nzval
    while true
        HSL.ma27br(
            T,
            INT,
            M.csc.n,
            nnz(M.csc),
            M.I,
            M.J,
            M.a,
            M.la,
            M.iw,
            M.liw,
            M.ikeep,
            M.nsteps,
            M.maxfrt,
            M.iw1,
            M.icntl,
            M.cntl,
            M.info,
        )
        if M.info[1] == -3
            M.liw = ceil(INT, M.opt.ma27_meminc_factor * M.liw)
            resize!(M.iw, M.liw)
            @debug(M.logger, "Reallocating memory: liw ($(M.liw))")
        elseif M.info[1] == -4
            M.la = ceil(INT, M.opt.ma27_meminc_factor * M.la)
            resize!(M.a, M.la)
            @debug(M.logger, "Reallocating memory: la ($(M.la))")
        elseif M.info[1] < 0
            throw(FactorizationException())
        else
            break
        end
    end
    return M
end

function solve_linear_system!(M::Ma27Solver{T,INT}, rhs::Vector{T}) where {T,INT}
    length(M.w) < M.maxfrt[1] && resize!(M.w, M.maxfrt[1])
    length(M.iw1) < M.nsteps[1] && resize!(M.iw1, M.nsteps[1])
    HSL.ma27cr(
        T,
        INT,
        M.csc.n,
        M.a,
        M.la,
        M.iw,
        M.liw,
        M.w,
        M.maxfrt,
        rhs,
        M.iw1,
        M.nsteps,
        M.icntl,
        M.info,
    )
    M.info[1] < 0 && throw(SolveException())
    return rhs
end

is_inertia(::Ma27Solver) = true
function inertia(M::Ma27Solver)
    dim = M.csc.n
    rank = (Int(M.info[1]) == 3) ? Int(M.info[2]) : dim
    neg = Int(M.info[15])

    return (rank - neg, dim - rank, neg)
end

function improve!(M::Ma27Solver)
    if M.cntl[1] == M.opt.ma27_pivtolmax
        @debug(M.logger, "improve quality failed.")
        return false
    end
    M.cntl[1] = min(M.opt.ma27_pivtolmax, M.cntl[1]^0.75)
    @debug(M.logger, "improved quality: pivtol = $(M.cntl[1])")
    return true
end

introduce(::Ma27Solver) = "ma27 v$(HSL.MA27_version())"
input_type(::Type{Ma27Solver}) = :csc
default_options(::Type{Ma27Solver}) = Ma27Options()
is_supported(::Type{Ma27Solver}, ::Type{T}) where T <: AbstractFloat = HSL.is_supported(Val(:ma27), T)

function RobustRestorer(solver::AbstractMadNLPSolver{T}) where {T}

    f_R = similar(get_y(solver), get_n(solver))
    x_ref = similar(get_y(solver), get_n(solver))
    D_R = similar(get_y(solver), get_n(solver))
    pp = similar(get_y(solver), get_m(solver))
    nn = similar(get_y(solver), get_m(solver))
    pp_trial = similar(get_y(solver), get_m(solver))
    nn_trial = similar(get_y(solver), get_m(solver))

    nn = similar(get_y(solver), get_m(solver))
    zp = similar(get_y(solver), get_m(solver))
    zn = similar(get_y(solver), get_m(solver))
    dpp= similar(get_y(solver), get_m(solver))
    dnn= similar(get_y(solver), get_m(solver))
    dzp= similar(get_y(solver), get_m(solver))
    dzn= similar(get_y(solver), get_m(solver))
    pp_trial = similar(get_y(solver), get_m(solver))
    nn_trial = similar(get_y(solver), get_m(solver))

    return RobustRestorer(
        zero(T), 
        f_R, 
        x_ref, 
        zero(T), 
        D_R, 
        zero(T), 
        pp, 
        nn, 
        zp, zn, 
        dpp, dnn, dzp, dzn, 
        pp_trial, 
        nn_trial, 
        zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), 
        Tuple{T, T}[], 
    )
end

function initialize_robust_restorer!(solver::AbstractMadNLPSolver{T}) where {T}
    @trace(get_logger(solver),"Initializing restoration phase variables.")
    get_RR(solver) == nothing && (set_RR!(solver, RobustRestorer(solver)))
    # Explicitly type otherwise we get type instability because compiler can't know RR != nothing
    RR::RobustRestorer = get_RR(solver)

    copyto!(RR.x_ref, full(get_x(solver)))
    RR.theta_ref = get_theta(get_c(solver))
    RR.D_R .= min.(one(T), one(T) ./ abs.(RR.x_ref))

    RR.mu_R = max(get_mu(solver), norm(get_c(solver), Inf))
    RR.tau_R= max(get_opt(solver).tau_min,1-RR.mu_R)
    RR.zeta = sqrt(RR.mu_R)

    rho = get_opt(solver).rho
    mu = RR.mu_R
    populate_RR_nn!(RR.nn, get_c(solver), mu, rho)
    RR.pp .= get_c(solver) .+ RR.nn
    RR.zp .= RR.mu_R ./ RR.pp
    RR.zn .= RR.mu_R ./ RR.nn

    RR.obj_val_R = get_obj_val_R(RR.pp,RR.nn,RR.D_R,full(get_x(solver)),RR.x_ref,get_opt(solver).rho,RR.zeta)
    fill!(RR.f_R, zero(T))
    empty!(RR.filter)
    push!(RR.filter, (get_theta_max(solver),-Inf))

    fill!(get_y(solver), zero(T))
    get_zl_r(solver) .= min.(get_opt(solver).rho, get_zl_r(solver))
    get_zu_r(solver) .= min.(get_opt(solver).rho, get_zu_r(solver))
    # fill!(get_zl_r(solver), one(T)) # Experimental
    # fill!(get_zu_r(solver), one(T)) # Experimental
    
    get_cnt(solver).t = 0

    # misc
    set_del_w!(solver, zero(T))
end

ma57_default_icntl(INT) =
    INT[0, 0, 6, 1, 0, 5, 1, 0, 10, 0, 16, 16, 10, 100, 0, 0, 0, 0, 0, 0]
ma57_default_cntl(T) = T[1e-8, 1.0e-20, 0.5, 0.0, 0.0]

@kwdef mutable struct Ma57Options <: AbstractOptions
    ma57_pivtol::Float64 = 1e-8
    ma57_pivtolmax::Float64 = 1e-4
    ma57_pre_alloc::Float64 = 1.05
    ma57_pivot_order::Int = 5
    ma57_automatic_scaling::Bool = false

    ma57_block_size::Int = 16
    ma57_node_amalgamation::Int = 16
    ma57_small_pivot_flag::Int = 0
end

mutable struct Ma57Solver{T,INT} <: AbstractLinearSolver{T}
    csc::SparseMatrixCSC{T,INT}
    I::Vector{INT}
    J::Vector{INT}

    icntl::Vector{INT}
    cntl::Vector{T}

    info::Vector{INT}
    rinfo::Vector{T}

    lkeep::INT
    keep::Vector{INT}

    lfact::INT
    fact::Vector{T}

    lifact::INT
    ifact::Vector{INT}

    iwork::Vector{INT}
    lwork::INT
    work::Vector{T}

    opt::Ma57Options
    logger::MadNLPLogger
end


function Ma57Solver(
    csc::SparseMatrixCSC{T,INT};
    opt = Ma57Options(),
    logger = MadNLPLogger(),
) where {T,INT}
    I, J = findIJ(csc)

    icntl = ma57_default_icntl(INT)
    cntl = ma57_default_cntl(T)

    cntl[1] = opt.ma57_pivtol
    icntl[1] = -1
    icntl[2] = -1
    icntl[3] = -1
    icntl[6] = opt.ma57_pivot_order
    icntl[15] = opt.ma57_automatic_scaling ? 1 : 0
    icntl[11] = opt.ma57_block_size
    icntl[12] = opt.ma57_node_amalgamation

    info = Vector{INT}(undef, 40)
    rinfo = Vector{T}(undef, 20)

    lkeep = INT(5 * csc.n + nnz(csc) + max(csc.n, nnz(csc)) + 42)
    keep = Vector{INT}(undef, lkeep)

    HSL.ma57ar(
        T,
        INT,
        INT(csc.n),
        INT(nnz(csc)),
        I,
        J,
        lkeep,
        keep,
        Vector{INT}(undef, 5 * csc.n),
        icntl,
        info,
        rinfo,
    )

    info[1] < 0 && throw(SymbolicException())

    lfact = ceil(INT, opt.ma57_pre_alloc * info[9])
    lifact = ceil(INT, opt.ma57_pre_alloc * info[10])

    fact = Vector{T}(undef, lfact)
    ifact = Vector{INT}(undef, lifact)
    iwork = Vector{INT}(undef, csc.n)
    lwork = INT(csc.n)
    work = Vector{T}(undef, lwork)

    return Ma57Solver{T,INT}(
        csc,
        I,
        J,
        icntl,
        cntl,
        info,
        rinfo,
        lkeep,
        keep,
        lfact,
        fact,
        lifact,
        ifact,
        iwork,
        lwork,
        work,
        opt,
        logger,
    )
end

function factorize!(M::Ma57Solver{T,INT}) where {T,INT}
    while true
        HSL.ma57br(
            T,
            INT,
            M.csc.n,
            nnz(M.csc),
            M.csc.nzval,
            M.fact,
            M.lfact,
            M.ifact,
            M.lifact,
            M.lkeep,
            M.keep,
            M.iwork,
            M.icntl,
            M.cntl,
            M.info,
            M.rinfo,
        )
        if M.info[1] == -3 || M.info[1] == 10
            M.lfact = ceil(INT, M.opt.ma57_pre_alloc * M.info[17])
            resize!(M.fact, M.lfact)
            @debug(M.logger, "Reallocating memory: lfact ($(M.lfact))")
        elseif M.info[1] == -4 || M.info[1] == 11
            M.lifact = ceil(INT, M.opt.ma57_pre_alloc * M.info[18])
            resize!(M.ifact, M.lifact)
            @debug(M.logger, "Reallocating memory: lifact ($(M.lifact))")
        elseif M.info[1] < 0
            throw(FactorizationException())
        else
            break
        end
    end
    return M
end

function solve_linear_system!(M::Ma57Solver{T,INT}, rhs::Vector{T}) where {T,INT}
    HSL.ma57cr(
        T,
        INT,
        one(INT),
        INT(M.csc.n),
        M.fact,
        M.lfact,
        M.ifact,
        M.lifact,
        one(INT),
        rhs,
        INT(M.csc.n),
        M.work,
        M.lwork,
        M.iwork,
        M.icntl,
        M.info,
    )
    M.info[1] < 0 && throw(SolveException())
    return rhs
end

is_inertia(::Ma57Solver) = true
function inertia(M::Ma57Solver)
    return (M.info[25] - M.info[24], Int64(M.csc.n) - M.info[25], M.info[24])
end
function improve!(M::Ma57Solver)
    if M.cntl[1] == M.opt.ma57_pivtolmax
        @debug(M.logger, "improve quality failed.")
        return false
    end
    M.cntl[1] = min(M.opt.ma57_pivtolmax, M.cntl[1]^0.75)
    @debug(M.logger, "improved quality: pivtol = $(M.cntl[1])")
    return true
end

introduce(::Ma57Solver) = "ma57 v$(HSL.MA57_version())"
input_type(::Type{Ma57Solver}) = :csc
default_options(::Type{Ma57Solver}) = Ma57Options()
is_supported(::Type{Ma57Solver}, ::Type{T}) where T <: AbstractFloat = HSL.is_supported(Val(:ma57), T)

@setup_workload begin
    # Putting some things in `@setup_workload` instead of `@compile_workload` can reduce the size of the
    # precompile file and potentially make loading faster.

    struct HS15Model{T} <: NLPModels.AbstractNLPModel{T,Vector{T}}
        meta::NLPModels.NLPModelMeta{T, Vector{T}}
        counters::NLPModels.Counters
    end

    function HS15Model(;T = Float64, x0=zeros(T,2), y0=zeros(T,2))
        return HS15Model(
            NLPModels.NLPModelMeta(
                2,     #nvar
                ncon = 2,
                nnzj = 4,
                nnzh = 3,
                x0 = x0,
                y0 = y0,
                lvar = T[-Inf, -Inf],
                uvar = T[0.5, Inf],
                lcon = T[1.0, 0.0],
                ucon = T[Inf, Inf],
                minimize = true
            ),
            NLPModels.Counters()
        )
    end

    function NLPModels.obj(nlp::HS15Model, x::AbstractVector)
        return 100.0 * (x[2] - x[1]^2)^2 + (1.0 - x[1])^2
    end

    function NLPModels.grad!(nlp::HS15Model, x::AbstractVector, g::AbstractVector)
        z = x[2] - x[1]^2
        g[1] = -400.0 * z * x[1] - 2.0 * (1.0 - x[1])
        g[2] = 200.0 * z
        return
    end

    function NLPModels.cons!(nlp::HS15Model, x::AbstractVector, c::AbstractVector)
        c[1] = x[1] * x[2]
        c[2] = x[1] + x[2]^2
    end

    function NLPModels.jac_structure!(nlp::HS15Model, I::AbstractVector{T}, J::AbstractVector{T}) where T
        copyto!(I, [1, 1, 2, 2])
        copyto!(J, [1, 2, 1, 2])
    end

    function NLPModels.jac_coord!(nlp::HS15Model, x::AbstractVector, J::AbstractVector)
        J[1] = x[2]    # (1, 1)
        J[2] = x[1]    # (1, 2)
        J[3] = 1.0     # (2, 1)
        J[4] = 2*x[2]  # (2, 2)
        return J
    end

    function NLPModels.jprod!(nlp::HS15Model, x::AbstractVector, v::AbstractVector, jv::AbstractVector)
        jv[1] = x[2] * v[1] + x[1] * v[2]
        jv[2] = v[1] + 2 * x[2] * v[2]
        return jv
    end

    function NLPModels.jtprod!(nlp::HS15Model, x::AbstractVector, v::AbstractVector, jv::AbstractVector)
        jv[1] = x[2] * v[1] + v[2]
        jv[2] = x[1] * v[1] + 2 * x[2] * v[2]
        return jv
    end

    function NLPModels.hess_structure!(nlp::HS15Model, I::AbstractVector{T}, J::AbstractVector{T}) where T
        copyto!(I, [1, 2, 2])
        copyto!(J, [1, 1, 2])
    end

    function NLPModels.hess_coord!(nlp::HS15Model, x, y, H::AbstractVector; obj_weight=1.0)
        # Objective
        H[1] = obj_weight * (-400.0 * x[2] + 1200.0 * x[1]^2 + 2.0)
        H[2] = obj_weight * (-400.0 * x[1])
        H[3] = obj_weight * 200.0
        # First constraint
        H[2] += y[1] * 1.0
        # Second constraint
        H[3] += y[2] * 2.0
        return H
    end

    nlp = HS15Model()
    __init__()
    
    @compile_workload begin
        madnlp(nlp; print_level=MadNLP.ERROR)
    end
end

atol = rtol = 1e-4

m = 2
n = 2
row = Int32[1,2,2]
col = Int32[1,1,2]
val = Float64[1.,.1,2.]

coo = MadNLP.SparseMatrixCOO(m,n,row,col,val)
csc = sparse(row,col,val,m,n)
dense = Array(csc)

b = [1.0,3.0]
x = similar(b)

@testset "SparseMatrixCOO" begin
    @test MadNLP.size(coo) == (2,2)
    @test coo[1,1] == 1.
end

@testset "LAPACK" begin
    sol= [0.8542713567839195, 1.4572864321608041]
    M = MadNLP.LapackCPUSolver(dense)
    MadNLP.introduce(M)
    MadNLP.improve!(M)
    MadNLP.factorize!(M)
    MadNLP.is_inertia(M) && (MadNLP.inertia(M) = (2,0,0))
    x = MadNLP.solve_linear_system!(M,copy(b))
    @test solcmp(x,sol)
end


MadNLPTests.test_linear_solver(LDLSolver,Float32)
MadNLPTests.test_linear_solver(LDLSolver,Float64)
MadNLPTests.test_linear_solver(LDLSolver,Float128)
MadNLPTests.test_linear_solver(UmfpackSolver,Float64)
MadNLPTests.test_linear_solver(CHOLMODSolver,Float64)
MadNLPTests.test_linear_solver(LapackCPUSolver,Float32)
MadNLPTests.test_linear_solver(LapackCPUSolver,Float64)

module MadNLPTests

# Standard packages
import LinearAlgebra: norm, I, mul!, dot
import SparseArrays: sparse
import Random
import Test: @test, @testset

# Optimization packages
import MadNLP
import NLPModels
import JuMP: Model, @variable, @constraint, @objective, optimize!, set_attribute,
    MOI, termination_status, LowerBoundRef, UpperBoundRef, value, dual, fix
import NLPModelsJuMP

export test_madnlp, solcmp, TwoStageQP, build_twostage_qp, schur_opts

function solcmp(x,sol;atol=1e-4,rtol=1e-4)
    aerr = norm(x-sol,Inf)
    rerr = aerr/norm(sol,Inf)
    return (aerr < atol || rerr < rtol)
end

function test_linear_solver(solver, T; kwargs...)
    m = 2
    n = 2
    row = Int32[1,2,2]
    col = Int32[1,1,2]
    val = T[1.,.1,2.]
    b = T[1.0,3.0]
    x = similar(b)
    sol= [0.8542713567839195, 1.4572864321608041]

    csc = sparse(row,col,val,m,n)
    if MadNLP.input_type(solver) == :csc
        opt = MadNLP.default_options(solver)
        M = solver(csc; opt=opt)
    elseif MadNLP.input_type(solver) == :dense
        dense = Array(csc)
        opt = MadNLP.default_options(solver)
        M = solver(dense; opt=opt)
    end
    MadNLP.introduce(M)
    MadNLP.improve!(M)
    MadNLP.factorize!(M)
    if MadNLP.is_inertia(M)
        @test MadNLP.inertia(M) == (2, 0, 0)
    end
    x = MadNLP.solve_linear_system!(M,copy(b))
    @test solcmp(x,sol)
end

function test_kkt_system(kkt, cb)
    # Getters
    n = MadNLP.num_variables(kkt)
    (m, p) = size(kkt)
    # system should be square
    @test m == p

    # Interface
    MadNLP.initialize!(kkt)

    # Update internal structure
    x0 = NLPModels.get_x0(cb.nlp)
    y0 = NLPModels.get_y0(cb.nlp)
    # Update Jacobian manually
    jac = MadNLP.get_jacobian(kkt)
    MadNLP._eval_jac_wrapper!(cb, x0, jac)
    MadNLP.compress_jacobian!(kkt)
    # Update Hessian manually
    hess = MadNLP.get_hessian(kkt)
    MadNLP._eval_lag_hess_wrapper!(cb, x0, y0, hess)
    MadNLP.compress_hessian!(kkt)

    # N.B.: set non-trivial dual's bounds to ensure
    # l_lower and u_lower are positive. If not we run into
    # an issue inside SparseUnreducedKKTSystem, which symmetrize
    # the system using the values in l_lower and u_lower.
    fill!(kkt.l_lower, 1e-3)
    fill!(kkt.u_lower, 1e-3)

    # Update diagonal terms manually.
    MadNLP._set_aug_diagonal!(kkt)

    # Factorization
    MadNLP.build_kkt!(kkt)
    MadNLP.factorize!(kkt.linear_solver)

    # Backsolve
    x = MadNLP.UnreducedKKTVector(kkt)
    fill!(MadNLP.full(x), 1.0)  # fill RHS with 1
    out1 = MadNLP.solve_kkt!(kkt, x)
    @test out1 === x

    y = copy(x)
    fill!(MadNLP.full(y), 0.0)
    out2 = mul!(y, kkt, x)
    @test out2 === y
    @test MadNLP.full(y) ≈ ones(length(x))

    if MadNLP.is_inertia(kkt.linear_solver)
        ni, mi, pi = MadNLP.inertia(kkt.linear_solver)
        @test MadNLP.is_inertia_correct(kkt, ni, mi, pi)
    end

    prim_reg, dual_reg = 1.0, 1.0
    MadNLP.regularize_diagonal!(kkt, prim_reg, dual_reg)

    return
end

function test_madnlp(name,optimizer_constructor::Function,exclude; Arr = Array)
    @testset "$name" begin
        for f in [infeasible, unbounded, lootsma, eigmina, lp_examodels_issue75, jump_array_type]
            !(string(f) in exclude) && f(optimizer_constructor; Arr = Arr)
        end
    end
end

function infeasible(optimizer_constructor::Function; Arr = Array)
    @testset "infeasible" begin
        m=Model(optimizer_constructor)
        @variable(m,x>=1)
        @constraint(m,x==0.)
        @objective(m,Min,x^2)

        nlp = MadNLP.SparseWrapperModel(
            Arr,
            NLPModelsJuMP.MathOptNLPModel(m)
        )
        optimizer = optimizer_constructor()
        result = MadNLP.madnlp(nlp; optimizer.options...)

        @test result.status == MadNLP.INFEASIBLE_PROBLEM_DETECTED
    end
end

function unbounded(optimizer_constructor::Function; Arr = Array)
    @testset "unbounded" begin
        m=Model(optimizer_constructor)
        @variable(m,x,start=1)
        @objective(m,Max,x^2)

        nlp = MadNLP.SparseWrapperModel(
            Arr,
            NLPModelsJuMP.MathOptNLPModel(m)
        )
        optimizer = optimizer_constructor()
        result = MadNLP.madnlp(nlp; optimizer.options...)

        @test result.status == MadNLP.DIVERGING_ITERATES
    end
end

function lootsma(optimizer_constructor::Function; Arr = Array)
    @testset "lootsma" begin
        m=Model()
        @variable(m, par == 6.)
        @variable(m,0 <= x[i=1:3] <= 5, start = 0.)
        l=[
            @constraint(m,-sqrt(x[1]) - sqrt(x[2]) + sqrt(x[3]) >= 0.)
            @constraint(m,sqrt(x[1]) + sqrt(x[2]) + sqrt(x[3]) >= 4.)
        ]
        @objective(m,Min,x[1]^3 + 11. *x[1] - par*sqrt(x[1])  +x[3] )


        nlp = MadNLP.SparseWrapperModel(
            Arr,
            NLPModelsJuMP.MathOptNLPModel(m)
        )

        optimizer = optimizer_constructor()
        result = MadNLP.madnlp(nlp; optimizer.options...)

        @test solcmp(
            Array(result.solution[2:4]),
            [0.07415998565403112,2.9848713863700236,4.0000304145340415];
            atol = sqrt(result.options.tol), rtol = sqrt(result.options.tol)
        )
        @test solcmp(
            Array(result.multipliers),
            [-2.000024518601535,-2.0000305441119535];
            atol = sqrt(result.options.tol), rtol = sqrt(result.options.tol)
        )
        @test solcmp(
            Array(result.multipliers_L[2:4]),
            [0.,0.,0.];
            atol = sqrt(result.options.tol), rtol = sqrt(result.options.tol)
        )
        @test solcmp(
            Array(result.multipliers_U[2:4]),
            [0.,0.,0.];
            atol = sqrt(result.options.tol), rtol = sqrt(result.options.tol)
        )

        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end
end

function eigmina(optimizer_constructor::Function; Arr = Array)
    @testset "eigmina" begin
        m=Model(optimizer_constructor)
        @variable(m,-1 <= x[1:101] <= 1,start = .1)
        @constraint(m, x[1]*x[1] + x[2]*x[2] + x[3]*x[3] + x[4]*x[4] + x[5]*x[5] + x[6]*x[6] +
            x[7]*x[7] + x[8]*x[8] + x[9]*x[9] + x[10]*x[10] + x[11]*x[11] + x[12]*x[12] +
            x[13]*x[13] + x[14]*x[14] + x[15]*x[15] + x[16]*x[16] + x[17]*x[17] + x[18]*x[18] +
            x[19]*x[19] + x[20]*x[20] + x[21]*x[21] + x[22]*x[22] + x[23]*x[23] + x[24]*x[24] +
            x[25]*x[25] + x[26]*x[26] + x[27]*x[27] + x[28]*x[28] + x[29]*x[29] + x[30]*x[30] +
            x[31]*x[31] + x[32]*x[32] + x[33]*x[33] + x[34]*x[34] + x[35]*x[35] + x[36]*x[36] +
            x[37]*x[37] + x[38]*x[38] + x[39]*x[39] + x[40]*x[40] + x[41]*x[41] + x[42]*x[42] +
            x[43]*x[43] + x[44]*x[44] + x[45]*x[45] + x[46]*x[46] + x[47]*x[47] + x[48]*x[48] +
            x[49]*x[49] + x[50]*x[50] + x[51]*x[51] + x[52]*x[52] + x[53]*x[53] + x[54]*x[54] +
            x[55]*x[55] + x[56]*x[56] + x[57]*x[57] + x[58]*x[58] + x[59]*x[59] + x[60]*x[60] +
            x[61]*x[61] + x[62]*x[62] + x[63]*x[63] + x[64]*x[64] + x[65]*x[65] + x[66]*x[66] +
            x[67]*x[67] + x[68]*x[68] + x[69]*x[69] + x[70]*x[70] + x[71]*x[71] + x[72]*x[72] +
            x[73]*x[73] + x[74]*x[74] + x[75]*x[75] + x[76]*x[76] + x[77]*x[77] + x[78]*x[78] +
            x[79]*x[79] + x[80]*x[80] + x[81]*x[81] + x[82]*x[82] + x[83]*x[83] + x[84]*x[84] +
            x[85]*x[85] + x[86]*x[86] + x[87]*x[87] + x[88]*x[88] + x[89]*x[89] + x[90]*x[90] +
            x[91]*x[91] + x[92]*x[92] + x[93]*x[93] + x[94]*x[94] + x[95]*x[95] + x[96]*x[96] +
            x[97]*x[97] + x[98]*x[98] + x[99]*x[99] + x[100]*x[100] == 1)
        @constraint(m, x[1]*x[101] - x[1] == 0)
        @constraint(m, x[2]*x[101] - 2*x[2] == 0)
        @constraint(m, x[3]*x[101] - 3*x[3] == 0)
        @constraint(m, x[4]*x[101] - 4*x[4] == 0)
        @constraint(m, x[5]*x[101] - 5*x[5] == 0)
        @constraint(m, x[6]*x[101] - 6*x[6] == 0)
        @constraint(m, x[7]*x[101] - 7*x[7] == 0)
        @constraint(m, x[8]*x[101] - 8*x[8] == 0)
        @constraint(m, x[9]*x[101] - 9*x[9] == 0)
        @constraint(m, x[10]*x[101] - 10*x[10] == 0)
        @constraint(m, x[11]*x[101] - 11*x[11] == 0)
        @constraint(m, x[12]*x[101] - 12*x[12] == 0)
        @constraint(m, x[13]*x[101] - 13*x[13] == 0)
        @constraint(m, x[14]*x[101] - 14*x[14] == 0)
        @constraint(m, x[15]*x[101] - 15*x[15] == 0)
        @constraint(m, x[16]*x[101] - 16*x[16] == 0)
        @constraint(m, x[17]*x[101] - 17*x[17] == 0)
        @constraint(m, x[18]*x[101] - 18*x[18] == 0)
        @constraint(m, x[19]*x[101] - 19*x[19] == 0)
        @constraint(m, x[20]*x[101] - 20*x[20] == 0)
        @constraint(m, x[21]*x[101] - 21*x[21] == 0)
        @constraint(m, x[22]*x[101] - 22*x[22] == 0)
        @constraint(m, x[23]*x[101] - 23*x[23] == 0)
        @constraint(m, x[24]*x[101] - 24*x[24] == 0)
        @constraint(m, x[25]*x[101] - 25*x[25] == 0)
        @constraint(m, x[26]*x[101] - 26*x[26] == 0)
        @constraint(m, x[27]*x[101] - 27*x[27] == 0)
        @constraint(m, x[28]*x[101] - 28*x[28] == 0)
        @constraint(m, x[29]*x[101] - 29*x[29] == 0)
        @constraint(m, x[30]*x[101] - 30*x[30] == 0)
        @constraint(m, x[31]*x[101] - 31*x[31] == 0)
        @constraint(m, x[32]*x[101] - 32*x[32] == 0)
        @constraint(m, x[33]*x[101] - 33*x[33] == 0)
        @constraint(m, x[34]*x[101] - 34*x[34] == 0)
        @constraint(m, x[35]*x[101] - 35*x[35] == 0)
        @constraint(m, x[36]*x[101] - 36*x[36] == 0)
        @constraint(m, x[37]*x[101] - 37*x[37] == 0)
        @constraint(m, x[38]*x[101] - 38*x[38] == 0)
        @constraint(m, x[39]*x[101] - 39*x[39] == 0)
        @constraint(m, x[40]*x[101] - 40*x[40] == 0)
        @constraint(m, x[41]*x[101] - 41*x[41] == 0)
        @constraint(m, x[42]*x[101] - 42*x[42] == 0)
        @constraint(m, x[43]*x[101] - 43*x[43] == 0)
        @constraint(m, x[44]*x[101] - 44*x[44] == 0)
        @constraint(m, x[45]*x[101] - 45*x[45] == 0)
        @constraint(m, x[46]*x[101] - 46*x[46] == 0)
        @constraint(m, x[47]*x[101] - 47*x[47] == 0)
        @constraint(m, x[48]*x[101] - 48*x[48] == 0)
        @constraint(m, x[49]*x[101] - 49*x[49] == 0)
        @constraint(m, x[50]*x[101] - 50*x[50] == 0)
        @constraint(m, x[51]*x[101] - 51*x[51] == 0)
        @constraint(m, x[52]*x[101] - 52*x[52] == 0)
        @constraint(m, x[53]*x[101] - 53*x[53] == 0)
        @constraint(m, x[54]*x[101] - 54*x[54] == 0)
        @constraint(m, x[55]*x[101] - 55*x[55] == 0)
        @constraint(m, x[56]*x[101] - 56*x[56] == 0)
        @constraint(m, x[57]*x[101] - 57*x[57] == 0)
        @constraint(m, x[58]*x[101] - 58*x[58] == 0)
        @constraint(m, x[59]*x[101] - 59*x[59] == 0)
        @constraint(m, x[60]*x[101] - 60*x[60] == 0)
        @constraint(m, x[61]*x[101] - 61*x[61] == 0)
        @constraint(m, x[62]*x[101] - 62*x[62] == 0)
        @constraint(m, x[63]*x[101] - 63*x[63] == 0)
        @constraint(m, x[64]*x[101] - 64*x[64] == 0)
        @constraint(m, x[65]*x[101] - 65*x[65] == 0)
        @constraint(m, x[66]*x[101] - 66*x[66] == 0)
        @constraint(m, x[67]*x[101] - 67*x[67] == 0)
        @constraint(m, x[68]*x[101] - 68*x[68] == 0)
        @constraint(m, x[69]*x[101] - 69*x[69] == 0)
        @constraint(m, x[70]*x[101] - 70*x[70] == 0)
        @constraint(m, x[71]*x[101] - 71*x[71] == 0)
        @constraint(m, x[72]*x[101] - 72*x[72] == 0)
        @constraint(m, x[73]*x[101] - 73*x[73] == 0)
        @constraint(m, x[74]*x[101] - 74*x[74] == 0)
        @constraint(m, x[75]*x[101] - 75*x[75] == 0)
        @constraint(m, x[76]*x[101] - 76*x[76] == 0)
        @constraint(m, x[77]*x[101] - 77*x[77] == 0)
        @constraint(m, x[78]*x[101] - 78*x[78] == 0)
        @constraint(m, x[79]*x[101] - 79*x[79] == 0)
        @constraint(m, x[80]*x[101] - 80*x[80] == 0)
        @constraint(m, x[81]*x[101] - 81*x[81] == 0)
        @constraint(m, x[82]*x[101] - 82*x[82] == 0)
        @constraint(m, x[83]*x[101] - 83*x[83] == 0)
        @constraint(m, x[84]*x[101] - 84*x[84] == 0)
        @constraint(m, x[85]*x[101] - 85*x[85] == 0)
        @constraint(m, x[86]*x[101] - 86*x[86] == 0)
        @constraint(m, x[87]*x[101] - 87*x[87] == 0)
        @constraint(m, x[88]*x[101] - 88*x[88] == 0)
        @constraint(m, x[89]*x[101] - 89*x[89] == 0)
        @constraint(m, x[90]*x[101] - 90*x[90] == 0)
        @constraint(m, x[91]*x[101] - 91*x[91] == 0)
        @constraint(m, x[92]*x[101] - 92*x[92] == 0)
        @constraint(m, x[93]*x[101] - 93*x[93] == 0)
        @constraint(m, x[94]*x[101] - 94*x[94] == 0)
        @constraint(m, x[95]*x[101] - 95*x[95] == 0)
        @constraint(m, x[96]*x[101] - 96*x[96] == 0)
        @constraint(m, x[97]*x[101] - 97*x[97] == 0)
        @constraint(m, x[98]*x[101] - 98*x[98] == 0)
        @constraint(m, x[99]*x[101] - 99*x[99] == 0)
        @constraint(m, x[100]*x[101] - 100*x[100] == 0)
        @objective(m, Min, x[101])

        nlp = MadNLP.SparseWrapperModel(
            Arr,
            NLPModelsJuMP.MathOptNLPModel(m)
        )
        optimizer = optimizer_constructor()
        result = MadNLP.madnlp(nlp; optimizer.options...)

        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end
end

function test_scaling()
    big_constant = 1e6
    # Write ill-conditioned NLP model and check MadNLP returns the un-scaled solution
    model = Model()
    @variable(model, 0.0 <= x[1:3])
    @constraint(model, big_constant * (x[1] + x[2] + x[3]) == big_constant)
    @objective(model, Min, big_constant * (x[1] + 2 * x[2] + 3 * x[3]))

    nlp = NLPModelsJuMP.MathOptNLPModel(model)
    solver = MadNLP.MadNLPSolver(nlp; print_level=MadNLP.ERROR)

    results = MadNLP.solve!(solver)

    # Check MadNLP is scaling the problem.
    @test solver.cb.obj_scale[] != 1.0
    @test solver.cb.con_scale[1] != 1.0

    # Check solution returned is correct
    @test results.solution ≈ [1.0, 0.0, 0.0] rtol=1e-7
    @test results.multipliers ≈ [-1.0] rtol=1e-7
    # the problem is ill-conditioned, meaning this multiplier is inaccurate.
    # We have to loosen the tolerancej
    @test results.multipliers_L[1] ≈ 0.0 atol=1e-3
    @test results.multipliers_L[2] ≈ big_constant rtol=1e-7
    @test results.multipliers_L[3] ≈ 2*big_constant rtol=1e-7

    return
end

function test_max_problem()
    model = Model()
    @variable(model, 0.0 <= x[1:3])
    @constraint(model, x[1] + x[2] + x[3] == 1.0)
    @objective(model, Max, x[1] + 2*x[2] + 3*x[3])

    nlp = NLPModelsJuMP.MathOptNLPModel(model)
    results = MadNLP.madnlp(nlp; print_level=MadNLP.ERROR)

    @test results.status == MadNLP.SOLVE_SUCCEEDED
    @test results.objective ≈ 3.0
    @test results.solution ≈ [0.0, 0.0, 1.0] rtol=1e-7
    @test results.multipliers[1] ≈ -3.0 rtol=1e-7
    @test results.multipliers_L[1] ≈ 2.0 rtol=1e-7
    @test results.multipliers_L[2] ≈ 1.0 rtol=1e-7
    @test results.multipliers_L[3] ≈ 0.0 atol=1e-7
    return
end

function test_fixed_variable()
    # Min problem
    model = Model()
    @variable(model, 0.0 <= x[1:3])
    fix(x[2], 0.5; force=true)
    @constraint(model, x[1] + x[2] + x[3] == 1.0)
    @objective(model, Min, x[1] + 2*x[2] + 3*x[3])

    nlp = NLPModelsJuMP.MathOptNLPModel(model)
    results = MadNLP.madnlp(nlp; print_level=MadNLP.ERROR)

    @test results.status == MadNLP.SOLVE_SUCCEEDED
    @test results.objective ≈ 1.5
    @test results.solution ≈ [0.5, 0.5, 0.0] rtol=1e-7
    @test results.multipliers[1] ≈ -1.0 rtol=1e-7
    @test results.multipliers_L[1] ≈ 0.0 atol=1e-7
    @test results.multipliers_L[2] ≈ 1.0 rtol=1e-7
    @test results.multipliers_U[2] ≈ 0.0 atol=1e-7
    @test results.multipliers_L[3] ≈ 2.0 rtol=1e-7

    # Max problem
    model = Model()
    @variable(model, 0.0 <= x[1:3])
    fix(x[2], 0.5; force=true)
    @constraint(model, x[1] + x[2] + x[3] == 1.0)
    @objective(model, Max, x[1] + 2*x[2] + 3*x[3])

    nlp = NLPModelsJuMP.MathOptNLPModel(model)
    results = MadNLP.madnlp(nlp; print_level=MadNLP.ERROR)

    @test results.status == MadNLP.SOLVE_SUCCEEDED
    @test results.objective ≈ 2.5
    @test results.solution ≈ [0.0, 0.5, 0.5] rtol=1e-7
    @test results.multipliers[1] ≈ -3.0 rtol=1e-7
    @test results.multipliers_L[1] ≈ 2.0 rtol=1e-7
    @test results.multipliers_L[2] ≈ 1.0 atol=1e-7
    @test results.multipliers_U[2] ≈ 0.0 rtol=1e-7
    @test results.multipliers_L[3] ≈ 0.0 atol=1e-7
end

function lp_examodels_issue75(optimizer_constructor::Function; Arr = Array)
    @testset "lp_examodels_issue75" begin

        m = Model()
        @variable(m, x >= 0)
        @variable(m, 0 <= y <= 3)
        @objective(m, Min, 12x + 20y)
        @constraint(m, c1, 6x + 8y >= 100)
        @constraint(m, c2, 7x + 12y >= 120)

        nlp = MadNLP.SparseWrapperModel(
            Arr,
            NLPModelsJuMP.MathOptNLPModel(m)
        )
        optimizer = optimizer_constructor()
        result = MadNLP.madnlp(nlp; optimizer.options...)

        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end
end

function jump_array_type(optimizer_constructor::Function; Arr = Array)
    @testset "jump_array_type" begin
        m = Model(optimizer_constructor)
        set_attribute(m, "array_type", Arr)
        @variable(m, x[1:2] >= 1)
        @objective(m, Min, x[1]^2 + x[2]^2)
        optimize!(m)

        @test termination_status(m) == MOI.LOCALLY_SOLVED
        @test solcmp(value.(x), [1.0, 1.0])
    end

    return nothing
end

include("Instances/dummy_qp.jl")
include("Instances/hs15.jl")
include("Instances/hs15nohessian.jl")
include("Instances/nls.jl")
include("Instances/twostage_qp.jl")

end # module

@kwdef mutable struct PardisoMKLOptions <: AbstractOptions
    pardisomkl_num_threads::Int = 1
    pardiso_matching_strategy::MatchingStrategy = COMPLETE2x2
    pardisomkl_max_iterative_refinement_steps::Int = 1
    pardisomkl_msglvl::Int = 0
    pardisomkl_order::Int = 2
end

mutable struct PardisoMKLSolver{T} <: AbstractLinearSolver{T}
    pt::Vector{Ptr{Cvoid}}
    iparm::Vector{Int32}
    perm::Vector{Int32}
    msglvl::Ref{Int32}
    err::Ref{Int32}
    csc::SparseMatrixCSC{T,Int32}
    w::Vector{T}
    opt::PardisoMKLOptions
    logger::MadNLPLogger
end

function pardisomkl_pardisoinit(pt, mtype::Ref{Cint}, iparm::Vector{Cint})
    return ccall(
        (:pardisoinit, libmkl_rt),
        Cvoid,
        (Ptr{Cvoid}, Ptr{Cint}, Ptr{Cint}),
        pt,
        mtype,
        iparm,
    )
end
function pardisomkl_pardiso(
    pt,
    maxfct::Ref{Cint},
    mnum::Ref{Cint},
    mtype::Ref{Cint},
    phase::Ref{Cint},
    n::Ref{Cint},
    a::Vector{T},
    ia::Vector{Cint},
    ja::Vector{Cint},
    perm::Vector{Cint},
    nrhs::Ref{Cint},
    iparm::Vector{Cint},
    msglvl::Ref{Cint},
    b::Vector{T},
    x::Vector{T},
    err::Ref{Cint},
) where {T}
    return ccall(
        (:pardiso, libmkl_rt),
        Cvoid,
        (
            Ptr{Cvoid},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{T},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{Cint},
            Ptr{T},
            Ptr{T},
            Ptr{Cint},
        ),
        pt,
        maxfct,
        mnum,
        mtype,
        phase,
        n,
        a,
        ia,
        ja,
        perm,
        nrhs,
        iparm,
        msglvl,
        b,
        x,
        err,
    )
end

function pardisomkl_set_num_threads!(n)
    ccall((:mkl_set_dynamic, libmkl_rt), Cvoid, (Ptr{Cint},), Ref{Cint}(0))
    return ccall((:mkl_set_num_threads, libmkl_rt), Cvoid, (Ptr{Cint},), Ref{Cint}(n))
end

function PardisoMKLSolver(
    csc::SparseMatrixCSC{T};
    opt = PardisoMKLOptions(),
    logger = MadNLPLogger(),
) where {T}
    w = Vector{T}(undef, csc.n)

    pt = Vector{Ptr{Cvoid}}(undef, 64)
    iparm = Vector{Int32}(undef, 64)

    perm = Vector{Int32}(undef, csc.n)
    msglvl = Ref{Int32}(0)
    err = Ref{Int32}(0)

    pt.=0
    iparm[1]=0

    pardisomkl_pardisoinit(pt, Ref{Int32}(-2), iparm)

    iparm[1]=1
    iparm[2]=opt.pardisomkl_order # METIS
    iparm[3]=0
    iparm[6]=1
    iparm[8]=opt.pardisomkl_max_iterative_refinement_steps
    iparm[10]=12
    iparm[11]=2
    iparm[13]=1 # matching strateg
    iparm[21]=3 # bunch-kaufman pivotin
    iparm[24]=1 # parallel factorization
    iparm[25]=0 # parallel solv
    iparm[28] = T == Float64 ? 0 : 1

    pardisomkl_set_num_threads!(opt.pardisomkl_num_threads)
    pardisomkl_pardiso(
        pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        Ref{Int32}(-2),
        Ref{Int32}(11),
        Ref{Int32}(csc.n),
        csc.nzval,
        csc.colptr,
        csc.rowval,
        perm,
        Ref{Int32}(1),
        iparm,
        msglvl,
        T[],
        T[],
        err,
    )
    pardisomkl_set_num_threads!(blas_num_threads[])

    err.x < 0 && throw(SymbolicException())

    M = PardisoMKLSolver{T}(pt, iparm, perm, msglvl, err, csc, w, opt, logger)

    finalizer(finalize, M)

    return M
end
function factorize!(M::PardisoMKLSolver{T}) where {T}
    pardisomkl_set_num_threads!(M.opt.pardisomkl_num_threads)
    pardisomkl_pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        Ref{Int32}(-2),
        Ref{Int32}(22),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        T[],
        T[],
        M.err,
    )
    M.err.x < 0 && throw(FactorizationException())
    pardisomkl_set_num_threads!(blas_num_threads[])

    M.iparm[14] == 0 && return M
    pardisomkl_set_num_threads!(M.opt.pardisomkl_num_threads)
    pardisomkl_pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        Ref{Int32}(-2),
        Ref{Int32}(12),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        T[],
        T[],
        M.err,
    )
    pardisomkl_set_num_threads!(blas_num_threads[])
    M.err.x < 0 && throw(FactorizationException())
    return M
end
function solve_linear_system!(M::PardisoMKLSolver{T}, rhs::Vector{T}) where {T}
    pardisomkl_set_num_threads!(M.opt.pardisomkl_num_threads)
    pardisomkl_pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        Ref{Int32}(-2),
        Ref{Int32}(33),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        rhs,
        M.w,
        M.err,
    )
    pardisomkl_set_num_threads!(blas_num_threads[])
    M.err.x < 0 && throw(SolveException())
    return rhs
end

function finalize(M::PardisoMKLSolver{T}) where {T}
    return pardisomkl_pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        Ref{Int32}(-2),
        Ref{Int32}(-1),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        T[],
        M.w,
        M.err,
    )
end
is_inertia(::PardisoMKLSolver)=true
function inertia(M::PardisoMKLSolver)
    pos = M.iparm[22]
    neg = M.iparm[23]
    return (pos, M.csc.n-pos-neg, neg)
end

function improve!(M::PardisoMKLSolver)
    @debug(M.logger, "improve quality failed.")
    return false
end
introduce(::PardisoMKLSolver)="pardiso-mkl"

input_type(::Type{PardisoMKLSolver}) = :csc
default_options(::Type{PardisoMKLSolver}) = PardisoMKLOptions()
is_supported(::Type{PardisoMKLSolver}, ::Type{Float32}) = true
is_supported(::Type{PardisoMKLSolver}, ::Type{Float64}) = true

function build_inertia_corrector(::Type{InertiaBased}, ::Type{VT}, n, m, nlb, nub, ind_lb, ind_ub) where VT
    return InertiaBased()
end
function build_inertia_corrector(::Type{InertiaIgnore}, ::Type{VT}, n, m, nlb, nub, ind_lb, ind_ub) where VT
    return InertiaIgnore()
end
function build_inertia_corrector(::Type{InertiaFree}, ::Type{VT}, n, m, nlb, nub, ind_lb, ind_ub) where VT
    p0 = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    d0 = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    t = VT(undef, n)
    wx= VT(undef, n)
    g = VT(undef, n)
    
    return InertiaFree(
        p0, d0, t, wx, g
    )
end

using CUDA
using MadNLPTests

@testset "MadNLP -- $SOLVER: $QN + $KKT" for QN in [
    MadNLP.CompactLBFGS,
], KKT in [
    MadNLP.SparseCondensedKKTSystem,
], SOLVER in [
    MadNLPGPU.CUDSSSolver,
    # MadNLPGPU.LapackCUDASolver,
]
    @testset "Size: ($n, $m)" for (n, m) in [(10, 0), (10, 5), (50, 10)]
        if SOLVER == MadNLPGPU.LapackCUDASolver
            nlp = MadNLPTests.DenseDummyQP(zeros(Float64, n); m=m)
            solver_exact = MadNLPSolver(
                nlp;
                callback=MadNLP.SparseCallback,
                print_level=MadNLP.ERROR,
                kkt_system=KKT,
                linear_solver=SOLVER,
            )
            results_ref = MadNLP.solve!(solver_exact)
        end

        nlp = MadNLPTests.DenseDummyQP(CUDA.zeros(Float64, n); m=m)
        solver_qn = MadNLPSolver(
            nlp;
            callback=MadNLP.SparseCallback,
            print_level=MadNLP.ERROR,
            kkt_system=KKT,
            hessian_approximation=QN,
            linear_solver=SOLVER,
        )
        results_qn = MadNLP.solve!(solver_qn)

        @test results_qn.status == MadNLP.SOLVE_SUCCEEDED
        @test results_qn.objective ≈ results_ref.objective atol=1e-6
        @test Array(results_qn.solution) ≈ Array(results_ref.solution) atol=1e-6
        @test solver_qn.cnt.lag_hess_cnt == 0
    end
end

using Test, MadNLP, MadNLPPardiso, MadNLPTests

testset = [
# TODO; Pardiso license has expired
# [
#     "Pardiso",
#     ()->MadNLP.Optimizer(
#         linear_solver=MadNLPPardiso,
#         print_level=MadNLP.ERROR),
#     [],
#     @isdefined(MadNLPPardiso)
# ],
    [
    "PardisoMKL",
    ()->MadNLP.Optimizer(linear_solver = PardisoMKLSolver, print_level = MadNLP.ERROR),
    ["eigmina"],
]]

@testset "MadNLPPardiso test" begin
    MadNLPTests.test_linear_solver(PardisoMKLSolver, Float32)
    MadNLPTests.test_linear_solver(PardisoMKLSolver, Float64)
    # TODO; Pardiso license has expired
    # MadNLPTests.test_linear_solver(PardisoSolver)

    for (name, optimizer_constructor, exclude) in testset
        test_madnlp(name, optimizer_constructor, exclude)
    end
end

######################################################
##### ROCm stubs for SparseCondensedKKTSystem    #####
##### (functions requiring concrete rocSPARSE types) #
######################################################

function MadNLP.transfer!(
    dest::rocSPARSE.ROCSparseMatrixCSC,
    src::MadNLP.SparseMatrixCOO,
    map,
)
    return copyto!(view(dest.nzVal, map), src.V)
end

MadNLP.nzval(H::rocSPARSE.ROCSparseMatrixCSC) = H.nzVal

function MadNLP._get_sparse_csc(dims, colptr::ROCVector, rowval, nzval)
    return rocSPARSE.ROCSparseMatrixCSC(colptr, rowval, nzval, dims)
end

function MadNLP._sym_length(Jt::rocSPARSE.ROCSparseMatrixCSC)
    return mapreduce(
        (x, y) -> begin
            z = x - y
            div(z^2 + z, 2)
        end,
        +,
        @view(Jt.colPtr[2:end]),
        @view(Jt.colPtr[1:(end - 1)])
    )
end

function MadNLP.get_tril_to_full(csc::rocSPARSE.ROCSparseMatrixCSC{Tv,Ti}) where {Tv,Ti}
    cscind = MadNLP.SparseMatrixCSC{Int,Ti}(
        Symmetric(
            MadNLP.SparseMatrixCSC{Int,Ti}(
                size(csc)...,
                Array(csc.colPtr),
                Array(csc.rowVal),
                collect(1:MadNLP.nnz(csc)),
            ),
            :L,
        ),
    )
    return rocSPARSE.ROCSparseMatrixCSC{Tv,Ti}(
        ROCArray(cscind.colptr),
        ROCArray(cscind.rowval),
        ROCVector{Tv}(undef, MadNLP.nnz(cscind)),
        size(csc),
    ),
    view(csc.nzVal, ROCArray(cscind.nzval))
end

######################################################################
##### GPU wrappers for DenseKKTSystem / DenseCondensedKKTSystem #####
######################################################################

#=
    MadNLP._madnlp_unsafe_wrap
=#

function MadNLP._madnlp_unsafe_wrap(vec::VT, n, shift = 1) where {T, VT <: AbstractGPUVector{T}}
    return view(vec, shift:(shift + n - 1))
end

#=
    MadNLP.diag!
=#

function MadNLP.diag!(dest::AbstractGPUVector{T}, src::AbstractGPUMatrix{T}) where {T}
    @assert length(dest) == size(src, 1)
    backend = get_backend(dest)
    MadNLPGPU._copy_diag_kernel!(backend)(dest, src, ndrange = length(dest))
    return
end

#=
    MadNLP.diag_add!
=#

function MadNLP.diag_add!(dest::AbstractGPUMatrix, src1::AbstractGPUVector, src2::AbstractGPUVector)
    backend = get_backend(dest)
    MadNLPGPU._add_diagonal_kernel!(backend)(dest, src1, src2, ndrange = size(dest, 1))
    return
end

#=
    MadNLP._set_diag!
=#

function MadNLP._set_diag!(A::AbstractGPUMatrix, inds, a)
    if !isempty(inds)
        backend = get_backend(A)
        MadNLPGPU._set_diag_kernel!(backend)(A, inds, a; ndrange = length(inds))

    end
    return
end

#=
    MadNLP._build_dense_kkt_system!
=#

function MadNLP._build_dense_kkt_system!(
        dest::AbstractGPUMatrix,
        hess::AbstractGPUMatrix,
        jac::AbstractGPUMatrix,
        pr_diag::AbstractGPUVector,
        du_diag::AbstractGPUVector,
        diag_hess::AbstractGPUVector,
        ind_ineq::AbstractVector,
        n,
        m,
        ns,
    )
    backend = get_backend(dest)
    ind_ineq_gpu = adapt(backend, ind_ineq)
    ndrange = (n + m + ns, n)
    MadNLPGPU._build_dense_kkt_system_kernel!(backend)(
        dest,
        hess,
        jac,
        pr_diag,
        du_diag,
        diag_hess,
        ind_ineq_gpu,
        n,
        m,
        ns,
        ndrange = ndrange,
    )
    return
end

#=
    MadNLP._build_ineq_jac!
=#

function MadNLP._build_ineq_jac!(
        dest::AbstractGPUMatrix,
        jac::AbstractGPUMatrix,
        diag_buffer::AbstractGPUVector,
        ind_ineq::AbstractVector,
        n,
        m_ineq,
    )
    (m_ineq == 0) && return # nothing to do if no ineq. constraints
    backend = get_backend(dest)
    ind_ineq_gpu = adapt(backend, ind_ineq)
    ndrange = (m_ineq, n)
    MadNLPGPU._build_jacobian_condensed_kernel!(backend)(
        dest,
        jac,
        diag_buffer,
        ind_ineq_gpu,
        m_ineq,
        ndrange = ndrange,
    )
    return
end

#=
    MadNLP._build_condensed_kkt_system!
=#

function MadNLP._build_condensed_kkt_system!(
        dest::AbstractGPUMatrix,
        hess::AbstractGPUMatrix,
        jac::AbstractGPUMatrix,
        pr_diag::AbstractGPUVector,
        du_diag::AbstractGPUVector,
        ind_eq::AbstractVector,
        n,
        m_eq,
    )
    backend = get_backend(dest)
    ind_eq_gpu = adapt(backend, ind_eq)
    ndrange = (n + m_eq, n)
    MadNLPGPU._build_condensed_kkt_system_kernel!(backend)(
        dest,
        hess,
        jac,
        pr_diag,
        du_diag,
        ind_eq_gpu,
        n,
        m_eq,
        ndrange = ndrange,
    )
    return
end

"""
    DenseKKTSystem{T, VT, MT, QN, VI} <: AbstractReducedKKTSystem{T, VT, MT, QN}

Implement [`AbstractReducedKKTSystem`](@ref) with dense matrices.

Requires a dense linear solver to be factorized (otherwise an error is returned).

"""
struct DenseKKTSystem{
    T,
    VT <: AbstractVector{T},
    MT <: AbstractMatrix{T},
    QN,
    LS,
    VI <: AbstractVector{Int},
    } <: AbstractReducedKKTSystem{T, VT, MT, QN}

    hess::MT
    jac::MT
    quasi_newton::QN
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT
    diag_hess::VT
    # KKT system
    aug_com::MT
    # Info
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
    # Linear Solver
    linear_solver::LS
    # Buffers
    etc::Dict{Symbol, Any}
end

function create_kkt_system(
    ::Type{DenseKKTSystem},
    cb::AbstractCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
) where {T, VT}

    ind_ineq = cb.ind_ineq
    ind_lb = cb.ind_lb
    ind_ub = cb.ind_ub

    n = cb.nvar
    m = cb.ncon
    ns = length(ind_ineq)
    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)

    hess = create_array(cb, n, n)
    jac = create_array(cb, m, n)
    aug_com = create_array(cb, n+ns+m, n+ns+m)
    reg = create_array(cb, n+ns)
    pr_diag = create_array(cb, n+ns)
    du_diag = create_array(cb, m)
    diag_hess = create_array(cb, n)

    l_diag = fill!(VT(undef, nlb), one(T))
    u_diag = fill!(VT(undef, nub), one(T))
    l_lower = fill!(VT(undef, nlb), zero(T))
    u_lower = fill!(VT(undef, nub), zero(T))

    # Init!
    fill!(aug_com, zero(T))
    fill!(hess,    zero(T))
    fill!(jac,     zero(T))
    fill!(reg,     zero(T))
    fill!(pr_diag, zero(T))
    fill!(du_diag, zero(T))
    fill!(diag_hess, zero(T))

    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    _linear_solver = linear_solver(aug_com; opt = opt_linear_solver)

    return DenseKKTSystem(
        hess, jac, quasi_newton,
        reg, pr_diag, du_diag, l_diag, u_diag, l_lower, u_lower,
        diag_hess, aug_com,
        ind_ineq, cb.ind_lb, cb.ind_ub,
        _linear_solver,
        Dict{Symbol, Any}(),
    )
end

num_variables(kkt::DenseKKTSystem) = length(kkt.pr_diag)

function mul!(y::AbstractVector, kkt::DenseKKTSystem{T}, x::AbstractVector) where T
    _symv!('L', one(T), kkt.aug_com, x, zero(T), y)
end

# Special getters for Jacobian
function get_jacobian(kkt::DenseKKTSystem)
    n = size(kkt.hess, 1)
    ns = length(kkt.ind_ineq)
    return view(kkt.jac, :, 1:n)
end

function diag_add!(dest::AbstractMatrix, d1::AbstractVector, d2::AbstractVector)
    n = length(d1)
    @inbounds for i in 1:n
        dest[i, i] = d1[i] + d2[i]
    end
end

function _build_dense_kkt_system!(dest::VT, hess, jac, pr_diag, du_diag, diag_hess, ind_ineq, n, m, ns) where {T, VT <: AbstractMatrix{T}}
    # Transfer Hessian
    for i in 1:n, j in 1:i
        if i == j
            dest[i, i] = pr_diag[i] + diag_hess[i]
        else
            dest[i, j] = hess[i, j]
            dest[j, i] = hess[j, i]
        end
    end
    # Transfer slack diagonal
    for i in 1:ns
        dest[i+n, i+n] = pr_diag[i+n]
    end
    # Transfer Jacobian / variables
    for i in 1:m, j in 1:n
        dest[i + n + ns, j] = jac[i, j]
        dest[j, i + n + ns] = jac[i, j]
    end
    # Transfer Jacobian / slacks
    for j in 1:ns
        is = ind_ineq[j]
        dest[is + n + ns, j + n] = - one(T)
        dest[j + n, is + n + ns] = - one(T)
    end
    # Transfer dual regularization
    for i in 1:m
        dest[i + n + ns, i + n + ns] = du_diag[i]
    end
end

function build_kkt!(kkt::DenseKKTSystem{T, VT, MT}) where {T, VT, MT}
    n = size(kkt.hess, 1)
    m = size(kkt.jac, 1)
    ns = length(kkt.ind_ineq)

    _build_dense_kkt_system!(kkt.aug_com, kkt.hess, kkt.jac,
                                kkt.pr_diag, kkt.du_diag, kkt.diag_hess,
                                kkt.ind_ineq,
                                n, m, ns)
end

function compress_hessian!(kkt::DenseKKTSystem)
    # Transfer diagonal term for future regularization
    diag!(kkt.diag_hess, kkt.hess)
end

@enum(MatchingStrategy::Int, COMPLETE=1, COMPLETE2x2=2, CONSTRAINTS=3)

@kwdef mutable struct PardisoOptions <: AbstractOptions
    pardiso_matching_strategy::MatchingStrategy = COMPLETE2x2
    pardiso_max_inner_refinement_steps::Int = 1
    pardiso_msglvl::Int = 0
    pardiso_order::Int = 2
    pardiso_log_level::String = ""
    pardiso_algorithm::MadNLP.LinearFactorization = MadNLP.BUNCHKAUFMAN
end

mutable struct PardisoSolver{T} <: AbstractLinearSolver{T}
    pt::Vector{Int}
    iparm::Vector{Int32}
    dparm::Vector{T}
    perm::Vector{Int32}
    msglvl::Ref{Int32}
    mtype::Ref{Int32}
    err::Ref{Int32}
    csc::SparseMatrixCSC{T,Int32}
    w::Vector{T}
    opt::PardisoOptions
    logger::MadNLPLogger
end

function _pardisoinit(
    pt::Vector{Int},
    mtype::Ref{Cint},
    solver::Ref{Cint},
    iparm::Vector{Cint},
    dparm::Vector{Cdouble},
    err::Ref{Cint},
)
    return pardisoinit(
        pt,
        mtype,
        solver,
        iparm,
        dparm,
        err,
    )
end

function _pardiso(
    pt::Vector{Int},
    maxfct::Ref{Cint},
    mnum::Ref{Cint},
    mtype::Ref{Cint},
    phase::Ref{Cint},
    n::Ref{Cint},
    a::Vector{Cdouble},
    ia::Vector{Cint},
    ja::Vector{Cint},
    perm::Vector{Cint},
    nrhs::Ref{Cint},
    iparm::Vector{Cint},
    msglvl::Ref{Cint},
    b::Vector{Cdouble},
    x::Vector{Cdouble},
    err::Ref{Cint},
    dparm::Vector{Cdouble},
)
    return pardiso(
        pt,
        maxfct,
        mnum,
        mtype,
        phase,
        n,
        a,
        ia,
        ja,
        perm,
        nrhs,
        iparm,
        msglvl,
        b,
        x,
        err,
        dparm,
    )
end

function PardisoSolver(
    csc::SparseMatrixCSC{T,Int32};
    opt = PardisoOptions(),
    logger = MadNLPLogger(),
    option_dict::Dict{Symbol,Any} = Dict{Symbol,Any}(),
    kwargs...,
) where {T}
    !isempty(kwargs) && (
        for (key, val) in kwargs
            ;
            option_dict[key]=val;
        end
    )
    set_options!(opt, option_dict)

    w = Vector{T}(undef, csc.n)

    pt = Vector{Int}(undef, 64)
    iparm = Vector{Int32}(undef, 64)
    dparm = Vector{T}(undef, 64)
    perm = Vector{Int32}(undef, csc.n)
    msglvl = Ref{Int32}(0)
    err = Ref{Int32}(0)

    mtype = if opt.pardiso_algorithm ∈ [MadNLP.BUNCHKAUFMAN, MadNLP.LDL]
        Ref{Int32}(-2) # real and symmetric indefinite
    elseif opt.pardiso_algorithm == MadNLP.CHOLESKY
        Ref{Int32}(2)  # real and symmetric positive definite
    else
        error("Only the factorizations CHOLESKY, LDL or BUNCHKAUFMAN are supported in MadNLPPardiso." *
              "Please change the option `pardiso_algorithm` accordingly.")
    end

    pt.=0
    iparm[1] = 0

    _pardisoinit(pt, mtype, Ref{Int32}(0), iparm, dparm, err)
    if err.x < 0
        throw(SymbolicException())
    end

    iparm[1] = 1
    iparm[2] = opt.pardiso_order # METIS
    iparm[3] = haskey(ENV,"OMP_NUM_THREADS") ? parse(Int32,ENV["OMP_NUM_THREADS"]) : 1
    iparm[6] = 1
    iparm[8] = opt.pardiso_max_inner_refinement_steps
    iparm[10] = 12 # pivot perturbation
    iparm[11] = 0 # disable scaling
    iparm[13] = 1 # matching strategy
    if opt.pardiso_algorithm == MadNLP.LDL
        iparm[21] = 0 # LDL pivoting
    elseif opt.pardiso_algorithm == MadNLP.BUNCHKAUFMAN
        iparm[21] = 1 # Bunch-Kaufman pivoting
    elseif opt.pardiso_algorithm == MadNLP.CHOLESKY
        iparm[21] = 0 # LDL pivoting
    end
    iparm[24] = 1 # parallel factorization
    iparm[25] = 1 # parallel solv
    iparm[29] = T == Float64 ? 0 : 1

    _pardiso(
        pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        mtype,
        Ref{Int32}(11),
        Ref{Int32}(csc.n),
        csc.nzval,
        csc.colptr,
        csc.rowval,
        perm,
        Ref{Int32}(1),
        iparm,
        msglvl,
        T[],
        T[],
        err,
        dparm,
    )
    err.x < 0 && throw(SymbolicException())

    M = PardisoSolver{T}(pt, iparm, dparm, perm, msglvl, mtype, err, csc, w, opt, logger)

    finalizer(finalize, M)

    return M
end

function factorize!(M::PardisoSolver{T}) where {T}
    _pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        M.mtype,
        Ref{Int32}(22),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        T[],
        T[],
        M.err,
        M.dparm,
    )
    # Get number of perturbed pivots
    perturbed_pivots = M.iparm[14]
    # If number of perturbed pivots is 0, stop the factorization.
    # Otherwise, recompute the symbolic factorization.
    if perturbed_pivots == 0
        return M
    end

    _pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        M.mtype,
        Ref{Int32}(12),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        T[],
        T[],
        M.err,
        M.dparm,
    )
    M.err.x < 0 && throw(FactorizationException())
    return M
end

function solve_linear_system!(M::PardisoSolver{T}, rhs::Vector{T}) where {T}
    _pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        M.mtype,
        Ref{Int32}(33),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        rhs,
        M.w,
        M.err,
        M.dparm,
    )
    M.err.x < 0 && throw(SolveException())
    return rhs
end

function finalize(M::PardisoSolver{T}) where {T}
    return _pardiso(
        M.pt,
        Ref{Int32}(1),
        Ref{Int32}(1),
        M.mtype,
        Ref{Int32}(-1),
        Ref{Int32}(M.csc.n),
        M.csc.nzval,
        M.csc.colptr,
        M.csc.rowval,
        M.perm,
        Ref{Int32}(1),
        M.iparm,
        M.msglvl,
        T[],
        M.w,
        M.err,
        M.dparm,
    )
end

is_inertia(::PardisoSolver)=true

function inertia(M::PardisoSolver)
    n = M.csc.n

    # If the factorization has failed, return an invalid inertia.
    if M.err.x < 0
        return (0, 0, n)
    else
        if M.opt.pardiso_algorithm == MadNLP.CHOLESKY
            return (n, 0, 0)
        else
            pos = M.iparm[22]
            neg = M.iparm[23]
            return (pos, n-pos-neg, neg)
        end
    end
end

function improve!(M::PardisoSolver)
    @debug(M.logger, "improve quality failed.")
    return false
end

introduce(::PardisoSolver)="pardiso"
input_type(::Type{PardisoSolver}) = :csc
default_options(::Type{PardisoSolver}) = PardisoOptions()
is_supported(::Type{PardisoSolver}, ::Type{Float32}) = true
is_supported(::Type{PardisoSolver}, ::Type{Float64}) = true

struct DenseDummyQP{
    T,
    VT <: AbstractVector{T},
    MT <: AbstractMatrix{T},
    VI <: AbstractVector{Int}
    } <: NLPModels.AbstractNLPModel{T,VT}
    meta::NLPModels.NLPModelMeta{T, VT}
    P::MT # primal hessian
    A::MT # constraint jacobian
    q::VT
    buffer::VT
    hrows::VI
    hcols::VI
    jrows::VI
    jcols::VI
    counters::NLPModels.Counters
end

function NLPModels.jac_structure!(qp::DenseDummyQP, I::AbstractVector{T}, J::AbstractVector{T}) where T
    copyto!(I, qp.jrows)
    copyto!(J, qp.jcols)
end
function NLPModels.hess_structure!(qp::DenseDummyQP, I::AbstractVector{T}, J::AbstractVector{T}) where T
    copyto!(I, qp.hrows)
    copyto!(J, qp.hcols)
end

function NLPModels.obj(qp::DenseDummyQP{T}, x::AbstractVector{T}) where T
    mul!(qp.buffer, qp.P, x)
    return T(0.5) * dot(x, qp.buffer) + dot(qp.q, x)
end

function NLPModels.grad!(qp::DenseDummyQP, x::AbstractVector, g::AbstractVector)
    mul!(g, qp.P, x)
    g .+= qp.q
    return
end

function NLPModels.cons!(qp::DenseDummyQP, x::AbstractVector, c::AbstractVector)
    mul!(c, qp.A, x)
end

# Jacobian: sparse callback
function NLPModels.jac_coord!(qp::DenseDummyQP, x::AbstractVector, J::AbstractVector)
    index = 1
    for (i, j) in zip(qp.jrows, qp.jcols)
        J[index] = qp.A[i, j]
        index += 1
    end
end

function NLPModels.jprod!(qp::DenseDummyQP, x::AbstractVector, v::AbstractVector, jv::AbstractVector)
    mul!(jv, qp.A, v)
    return jv
end

function NLPModels.jtprod!(qp::DenseDummyQP, x::AbstractVector, v::AbstractVector, jv::AbstractVector)
    mul!(jv, qp.A', v)
    return jv
end

# Jacobian: dense callback
NLPModels.jac_dense!(qp::DenseDummyQP, x, J::AbstractMatrix) = copyto!(J, qp.A)

# Hessian: sparse callback
function NLPModels.hess_coord!(qp::DenseDummyQP{T},x, l, hess::AbstractVector; obj_weight=one(T)) where T
    index = 1
    for i in 1:NLPModels.get_nvar(qp) , j in 1:i
        hess[index] = obj_weight * qp.P[j, i]
        index += 1
    end
end

# Hessian: dense callback
function NLPModels.hess_dense!(qp::DenseDummyQP{T}, x, l, hess::AbstractMatrix; obj_weight=one(T)) where T
    copyto!(hess, obj_weight .* qp.P)
end

function DenseDummyQP(
    x0::AbstractVector{T} = zeros(T,100);
    m=10, fixed_variables=similar(x0,Int,0), equality_cons=similar(x0,Int,0)
    ) where {T}

    n = length(x0)

    if m >= n
        error("The number of constraints `m` should be less than the number of variable `n`.")
    end

    Random.seed!(1)
    # Generate random values.
    # N.B.: we need to allocate the matrix P_ right after the vector
    # q_ if we want to obtain a deterministic behavior: the seed is not working
    # if we call the function `randn` after allocating vectors on the device.
    q_ = randn(n)
    P_ = randn(n, n)

    y0 = fill!(similar(x0, m), zero(T))
    q = copyto!(similar(x0, n), q_)
    buffer = similar(x0, n)

    # Bound constraints
    xl = fill!(similar(x0, n), zero(T))
    xu = fill!(similar(x0, n), one(T))
    gl = fill!(similar(x0, m), zero(T))
    gu = fill!(similar(x0, m), one(T))

    # Update gu to load equality constraints
    gu[equality_cons] .= zero(T)
    xl[fixed_variables] .= @view(xu[fixed_variables])

    # Build QP problem 0.5 * x' * P * x + q' * x
    P = copyto!(similar(x0, n , n), P_)
    P = P*P' # P is symmetric
    P += T(100.0) * I


    # Build constraints gl <= Ax <= gu
    A = fill!(similar(x0, m, n), zero(T))
    A[1:m+1:m^2] .= one(T)
    A[m+1:m+1:m^2+m] .=-one(T)

    nnzh = div(n * (n + 1), 2)
    hrows = copyto!(similar(x0, Int, nnzh), [i for i in 1:n for j in 1:i])
    hcols = copyto!(similar(x0, Int, nnzh), [j for i in 1:n for j in 1:i])

    nnzj = n * m
    jrows = copyto!(similar(x0, Int, nnzj), [j for i in 1:n for j in 1:m])
    jcols = copyto!(similar(x0, Int, nnzj), [i for i in 1:n for j in 1:m])

    return DenseDummyQP(
        NLPModels.NLPModelMeta(
            n,
            ncon = m,
            nnzj = nnzj,
            nnzh = nnzh,
            x0 = x0,
            y0 = y0,
            lvar = xl,
            uvar = xu,
            lcon = gl,
            ucon = gu,
            sparse_jacobian = false,
            sparse_hessian = false,
            minimize = true
        ),
        P,A,q,buffer,
        hrows,hcols,jrows,jcols,
        NLPModels.Counters()
    )
end

function pardisoinit(arg1, arg2, arg3, arg4, arg5, arg6)
    @ccall libpardiso.pardisoinit(arg1::Ptr{Cvoid}, arg2::Ptr{Cint}, arg3::Ptr{Cint},
                                  arg4::Ptr{Cint}, arg5::Ptr{Cdouble},
                                  arg6::Ptr{Cint})::Cvoid
end

function pardiso(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12,
                 arg13, arg14, arg15, arg16, arg17)
    @ccall libpardiso.pardiso(arg1::Ptr{Cvoid}, arg2::Ptr{Cint}, arg3::Ptr{Cint},
                              arg4::Ptr{Cint}, arg5::Ptr{Cint}, arg6::Ptr{Cint},
                              arg7::Ptr{Cvoid}, arg8::Ptr{Cint}, arg9::Ptr{Cint},
                              arg10::Ptr{Cint}, arg11::Ptr{Cint}, arg12::Ptr{Cint},
                              arg13::Ptr{Cint}, arg14::Ptr{Cvoid}, arg15::Ptr{Cvoid},
                              arg16::Ptr{Cint}, arg17::Ptr{Cdouble})::Cvoid
end

function pardiso_chkmatrix(arg1, arg2, arg3, arg4, arg5, arg6)
    @ccall libpardiso.pardiso_chkmatrix(arg1::Ptr{Cint}, arg2::Ptr{Cint},
                                        arg3::Ptr{Cdouble}, arg4::Ptr{Cint},
                                        arg5::Ptr{Cint}, arg6::Ptr{Cint})::Cvoid
end

function pardiso_chkvec(arg1, arg2, arg3, arg4)
    @ccall libpardiso.pardiso_chkvec(arg1::Ptr{Cint}, arg2::Ptr{Cint}, arg3::Ptr{Cdouble},
                                     arg4::Ptr{Cint})::Cvoid
end

function pardiso_printstats(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
    @ccall libpardiso.pardiso_printstats(arg1::Ptr{Cint}, arg2::Ptr{Cint},
                                         arg3::Ptr{Cdouble}, arg4::Ptr{Cint},
                                         arg5::Ptr{Cint}, arg6::Ptr{Cint},
                                         arg7::Ptr{Cdouble}, arg8::Ptr{Cint})::Cvoid
end

function pardisoinit_z(arg1, arg2, arg3, arg4, arg5, arg6)
    @ccall libpardiso.pardisoinit_z(arg1::Ptr{Cvoid}, arg2::Ptr{Cint}, arg3::Ptr{Cint},
                                    arg4::Ptr{Cint}, arg5::Ptr{Cdouble},
                                    arg6::Ptr{Cint})::Cvoid
end

function pardiso_z(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11,
                   arg12, arg13, arg14, arg15, arg16, arg17)
    @ccall libpardiso.pardiso_z(arg1::Ptr{Cvoid}, arg2::Ptr{Cint}, arg3::Ptr{Cint},
                                arg4::Ptr{Cint}, arg5::Ptr{Cint}, arg6::Ptr{Cint},
                                arg7::Ptr{Cvoid}, arg8::Ptr{Cint}, arg9::Ptr{Cint},
                                arg10::Ptr{Cint}, arg11::Ptr{Cint}, arg12::Ptr{Cint},
                                arg13::Ptr{Cint}, arg14::Ptr{Cvoid}, arg15::Ptr{Cvoid},
                                arg16::Ptr{Cint}, arg17::Ptr{Cdouble})::Cvoid
end

function pardiso_chkmatrix_z(arg1, arg2, arg3, arg4, arg5, arg6)
    @ccall libpardiso.pardiso_chkmatrix_z(arg1::Ptr{Cint}, arg2::Ptr{Cint},
                                          arg3::Ptr{Cvoid}, arg4::Ptr{Cint},
                                          arg5::Ptr{Cint}, arg6::Ptr{Cint})::Cvoid
end

function pardiso_chkvec_z(arg1, arg2, arg3, arg4)
    @ccall libpardiso.pardiso_chkvec_z(arg1::Ptr{Cint}, arg2::Ptr{Cint}, arg3::Ptr{Cvoid},
                                       arg4::Ptr{Cint})::Cvoid
end

function pardiso_printstats_z(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
    @ccall libpardiso.pardiso_printstats_z(arg1::Ptr{Cint}, arg2::Ptr{Cint},
                                           arg3::Ptr{Cvoid}, arg4::Ptr{Cint},
                                           arg5::Ptr{Cint}, arg6::Ptr{Cint},
                                           arg7::Ptr{Cvoid}, arg8::Ptr{Cint})::Cvoid
end

function pardiso_get_schur_z(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
    @ccall libpardiso.pardiso_get_schur_z(arg1::Ptr{Cvoid}, arg2::Ptr{Cint},
                                          arg3::Ptr{Cint}, arg4::Ptr{Cint},
                                          arg5::Ptr{Cvoid}, arg6::Ptr{Cint},
                                          arg7::Ptr{Cint})::Cvoid
end

function pardisoinit_d(arg1, arg2, arg3, arg4, arg5, arg6)
    @ccall libpardiso.pardisoinit_d(arg1::Ptr{Cvoid}, arg2::Ptr{Cint}, arg3::Ptr{Cint},
                                    arg4::Ptr{Cint}, arg5::Ptr{Cdouble},
                                    arg6::Ptr{Cint})::Cvoid
end

function pardiso_d(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11,
                   arg12, arg13, arg14, arg15, arg16, arg17)
    @ccall libpardiso.pardiso_d(arg1::Ptr{Cvoid}, arg2::Ptr{Cint}, arg3::Ptr{Cint},
                                arg4::Ptr{Cint}, arg5::Ptr{Cint}, arg6::Ptr{Cint},
                                arg7::Ptr{Cvoid}, arg8::Ptr{Cint}, arg9::Ptr{Cint},
                                arg10::Ptr{Cint}, arg11::Ptr{Cint}, arg12::Ptr{Cint},
                                arg13::Ptr{Cint}, arg14::Ptr{Cvoid}, arg15::Ptr{Cvoid},
                                arg16::Ptr{Cint}, arg17::Ptr{Cdouble})::Cvoid
end

function pardiso_chkmatrix_d(arg1, arg2, arg3, arg4, arg5, arg6)
    @ccall libpardiso.pardiso_chkmatrix_d(arg1::Ptr{Cint}, arg2::Ptr{Cint},
                                          arg3::Ptr{Cvoid}, arg4::Ptr{Cint},
                                          arg5::Ptr{Cint}, arg6::Ptr{Cint})::Cvoid
end

function pardiso_chkvec_d(arg1, arg2, arg3, arg4)
    @ccall libpardiso.pardiso_chkvec_d(arg1::Ptr{Cint}, arg2::Ptr{Cint}, arg3::Ptr{Cvoid},
                                       arg4::Ptr{Cint})::Cvoid
end

function pardiso_printstats_d(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
    @ccall libpardiso.pardiso_printstats_d(arg1::Ptr{Cint}, arg2::Ptr{Cint},
                                           arg3::Ptr{Cvoid}, arg4::Ptr{Cint},
                                           arg5::Ptr{Cint}, arg6::Ptr{Cint},
                                           arg7::Ptr{Cvoid}, arg8::Ptr{Cint})::Cvoid
end

function pardiso_get_schur_d(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
    @ccall libpardiso.pardiso_get_schur_d(arg1::Ptr{Cvoid}, arg2::Ptr{Cint},
                                          arg3::Ptr{Cint}, arg4::Ptr{Cint},
                                          arg5::Ptr{Cvoid}, arg6::Ptr{Cint},
                                          arg7::Ptr{Cint})::Cvoid
end

"""
    TwoStageQP{T, VT, MT, VI} <: NLPModels.AbstractNLPModel{T, VT}

Diagonal-Hessian two-stage stochastic QP, used to exercise
`SchurComplementKKTSystem` (CPU and GPU) without depending on ExaModels.

Variable layout:   `x = [v_{1,1},...,v_{1,nv}, v_{2,1},...,v_{ns,nv}, d_1,...,d_nd]`
Constraint layout: `c = [c_{1,1},...,c_{1,nc}, c_{2,1},...,c_{ns,nc}]`

Construct via [`build_twostage_qp`](@ref). Storage device follows the
`x0_template` argument (CPU `Vector{T}` or e.g. `CuVector{T}` for GPU tests).
"""
struct TwoStageQP{T, VT <: AbstractVector{T}, MT <: AbstractMatrix{T}, VI <: AbstractVector{Int}} <: NLPModels.AbstractNLPModel{T, VT}
    meta::NLPModels.NLPModelMeta{T, VT}
    counters::NLPModels.Counters
    H_diag::VT
    A::MT
    g0::VT
    hvals::VT      # precomputed Hessian COO values (= H_diag; constant in x)
    jvals::VT      # precomputed Jacobian COO values (constant in x)
    hrows::VI
    hcols::VI
    jrows::VI
    jcols::VI
end

function NLPModels.obj(qp::TwoStageQP{T}, x::AbstractVector{T}) where {T}
    return T(0.5) * dot(x, qp.H_diag .* x) + dot(qp.g0, x)
end

function NLPModels.grad!(qp::TwoStageQP, x::AbstractVector, g::AbstractVector)
    g .= qp.H_diag .* x .+ qp.g0
    return g
end

NLPModels.cons!(qp::TwoStageQP, x::AbstractVector, c::AbstractVector) = mul!(c, qp.A, x)

function NLPModels.jac_structure!(qp::TwoStageQP, I::AbstractVector, J::AbstractVector)
    copyto!(I, qp.jrows)
    copyto!(J, qp.jcols)
    return
end

function NLPModels.jac_coord!(qp::TwoStageQP, x::AbstractVector, J::AbstractVector)
    copyto!(J, qp.jvals)
    return J
end

function NLPModels.hess_structure!(qp::TwoStageQP, I::AbstractVector, J::AbstractVector)
    copyto!(I, qp.hrows)
    copyto!(J, qp.hcols)
    return
end

function NLPModels.hess_coord!(qp::TwoStageQP{T}, x::AbstractVector, l::AbstractVector, hess::AbstractVector; obj_weight = one(T)) where {T}
    hess .= obj_weight .* qp.hvals
    return hess
end

"""
    build_twostage_qp(x0_template = Vector{Float64}(); ns, nv, nd, nc, hess_v, hess_d, g_v, g_d, A_v, A_d, lcon, ucon, lvar_v, uvar_v, lvar_d, uvar_d) -> TwoStageQP

Build a `TwoStageQP` instance. Pass `x0_template` to select the storage device
(default CPU `Vector{Float64}`; pass e.g. `CUDA.zeros(Float64, n)` for GPU).

`hess_v`, `g_v` are size `(nv, ns)`. `hess_d`, `g_d` are size `(nd,)`.
`A_v` is `(nc, nv, ns)`, `A_d` is `(nc, nd, ns)`.
`lcon`, `ucon` are `(nc, ns)`. `lvar_v`, `uvar_v` are `(nv, ns)`.
`lvar_d`, `uvar_d` are `(nd,)`.
"""
function build_twostage_qp(
        x0_template::AbstractVector{T} = Vector{Float64}(undef, 0);
        ns::Int, nv::Int, nd::Int, nc::Int,
        hess_v::Matrix{T}, hess_d::Vector{T},
        g_v::Matrix{T}, g_d::Vector{T},
        A_v::Array{T, 3}, A_d::Array{T, 3},
        lcon::Matrix{T}, ucon::Matrix{T},
        lvar_v::Matrix{T}, uvar_v::Matrix{T},
        lvar_d::Vector{T}, uvar_d::Vector{T},
    ) where {T}
    n = ns * nv + nd
    m = ns * nc
    off = ns * nv

    # Stage everything on host first.
    x0_h = zeros(T, n)
    lvar_h = Vector{T}(undef, n)
    uvar_h = Vector{T}(undef, n)
    g0_h = Vector{T}(undef, n)
    H_diag_h = Vector{T}(undef, n)

    @inbounds for k in 1:ns, j in 1:nv
        i = (k - 1) * nv + j
        lvar_h[i] = lvar_v[j, k]
        uvar_h[i] = uvar_v[j, k]
        g0_h[i] = g_v[j, k]
        H_diag_h[i] = hess_v[j, k]
    end
    @inbounds for j in 1:nd
        i = off + j
        lvar_h[i] = lvar_d[j]
        uvar_h[i] = uvar_d[j]
        g0_h[i] = g_d[j]
        H_diag_h[i] = hess_d[j]
    end

    glcon_h = Vector{T}(undef, m)
    gucon_h = Vector{T}(undef, m)
    @inbounds for k in 1:ns, i in 1:nc
        idx = (k - 1) * nc + i
        glcon_h[idx] = lcon[i, k]
        gucon_h[idx] = ucon[i, k]
    end

    A_h = zeros(T, m, n)
    @inbounds for k in 1:ns, i in 1:nc
        row = (k - 1) * nc + i
        for j in 1:nv
            A_h[row, (k - 1) * nv + j] = A_v[i, j, k]
        end
        for j in 1:nd
            A_h[row, off + j] = A_d[i, j, k]
        end
    end

    nnzj = ns * nc * (nv + nd)
    jrows_h = Vector{Int}(undef, nnzj)
    jcols_h = Vector{Int}(undef, nnzj)
    p = 1
    @inbounds for k in 1:ns, i in 1:nc
        row = (k - 1) * nc + i
        for j in 1:nv
            jrows_h[p] = row; jcols_h[p] = (k - 1) * nv + j; p += 1
        end
        for j in 1:nd
            jrows_h[p] = row; jcols_h[p] = off + j; p += 1
        end
    end

    nnzh = n
    hrows_h = collect(1:n)
    hcols_h = collect(1:n)

    jvals_h = T[A_h[jrows_h[k], jcols_h[k]] for k in 1:nnzj]
    hvals_h = copy(H_diag_h)  # diagonal Hessian → values match H_diag

    to_device(v_h::AbstractVector) = (v = similar(x0_template, length(v_h)); copyto!(v, v_h); v)
    to_device(M_h::AbstractMatrix) = (M = similar(x0_template, size(M_h)...); copyto!(M, M_h); M)

    x0 = to_device(x0_h)
    lvar = to_device(lvar_h)
    uvar = to_device(uvar_h)
    g0 = to_device(g0_h)
    H_diag = to_device(H_diag_h)
    A = to_device(A_h)
    hvals = to_device(hvals_h)
    jvals = to_device(jvals_h)
    glcon = to_device(glcon_h)
    gucon = to_device(gucon_h)
    y0 = to_device(zeros(T, m))

    meta = NLPModels.NLPModelMeta(
        n;
        ncon = m,
        nnzj = nnzj,
        nnzh = nnzh,
        x0 = x0,
        y0 = y0,
        lvar = lvar,
        uvar = uvar,
        lcon = glcon,
        ucon = gucon,
        minimize = true,
    )

    return TwoStageQP(
        meta, NLPModels.Counters(),
        H_diag, A, g0, hvals, jvals,
        hrows_h, hcols_h, jrows_h, jcols_h,
    )
end

"""
    schur_opts(; ns, nv, nd, nc) -> Dict

Convenience: build the `kkt_options` dict for `SchurComplementKKTSystem`
with the four scenario dimensions.
"""
schur_opts(; ns, nv, nd, nc) = Dict{Symbol, Any}(
    :schur_ns => ns, :schur_nv => nv, :schur_nd => nd, :schur_nc => nc,
)

using MadNLP
using LinearAlgebra
import MadNLP: primal_dual, primal, dual, dual_lb, dual_ub

struct DiagonalHessianKKTSystem{T, VT, MT, QN, LS, VI, VI32} <: MadNLP.AbstractReducedKKTSystem{T, VT, MT, QN}
    # Nonzeroes values for Hessian and Jacobian
    hess::VT
    jac_callback::VT
    jac::VT
    # Diagonal matrices
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT
    # Augmented system K
    aug_raw::MadNLP.SparseMatrixCOO{T,Int32,VT, VI32}
    aug_com::MT
    aug_csc_map::Union{Nothing, VI}
    # Diagonal of the Hessian
    diag_hess::VT
    # Jacobian
    jac_raw::MadNLP.SparseMatrixCOO{T,Int32,VT, VI32}
    jac_com::MT
    jac_csc_map::Union{Nothing, VI}
    # LinearSolver
    linear_solver::LS
    # Info
    n_var::Int
    n_ineq::Int
    n_tot::Int
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
    # Quasi-Newton approximation
    quasi_newton::QN
end

function MadNLP.create_kkt_system(
    ::Type{DiagonalHessianKKTSystem},
    cb::MadNLP.SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=MadNLP.default_options(linear_solver),
    hessian_approximation=MadNLP.ExactHessian,
    qn_options=MadNLP.QuasiNewtonOptions(),
) where {T,VT}
    n = cb.nvar
    m = cb.ncon

    # ind_cons stores the indexes of all constraints
    n_slack = length(cb.ind_ineq)
    n_tot = n + n_slack

    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)
    ind_ineq = cb.ind_ineq

    #=
        Import Jacobian's sparsity pattern
    =#
    jac_sparsity_I = MadNLP.create_array(cb, Int32, cb.nnzj)
    jac_sparsity_J = MadNLP.create_array(cb, Int32, cb.nnzj)
    MadNLP._jac_sparsity_wrapper!(cb, jac_sparsity_I, jac_sparsity_J)

    #=
        Determine size of condensed KKT system
    =#
    n_hess = n_tot # Diagonal Hessian!
    n_jac = length(jac_sparsity_I)
    aug_vec_length = n_tot+m
    aug_mat_length = n_tot+m+n_hess+n_jac+n_slack

    #=
        Build augmented KKT system
    =#
    I = MadNLP.create_array(cb, Int32, aug_mat_length)
    J = MadNLP.create_array(cb, Int32, aug_mat_length)
    V = VT(undef, aug_mat_length)
    fill!(V, 0.0)  # Need to initiate V to avoid NaN

    offset = n_tot+n_jac+n_slack+n_hess+m

    I[1:n_tot] .= 1:n_tot
    I[n_tot+1:n_tot+n_hess] .= 1:n_tot # diagonal Hessian!
    I[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= (jac_sparsity_I.+n_tot)
    I[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= ind_ineq .+ n_tot
    I[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

    J[1:n_tot] .= 1:n_tot
    J[n_tot+1:n_tot+n_hess] .= 1:n_tot # diagonal Hessian!
    J[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= jac_sparsity_J
    J[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= (n+1:n+n_slack)
    J[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

    #=
        Diagonal matrices.
    =#
    pr_diag = MadNLP._madnlp_unsafe_wrap(V, n_tot)
    du_diag = VT(undef, m)
    reg = VT(undef, n_tot)
    l_diag = VT(undef, nlb)
    u_diag = VT(undef, nub)
    l_lower = VT(undef, nlb)
    u_lower = VT(undef, nub)

    #=
        Nonzeroes values for Hessian and Jacobian
    =#
    hess = VT(undef, cb.nnzh)
    jac = MadNLP._madnlp_unsafe_wrap(V, n_jac+n_slack, n_hess+n_tot+1)
    jac_callback = MadNLP._madnlp_unsafe_wrap(V, n_jac, n_hess+n_tot+1)

    diag_hess = MadNLP._madnlp_unsafe_wrap(V, n_hess, n_tot+1)

    #=
        Build condensed matrix and Jacobian in COO format
    =#
    aug_raw = MadNLP.SparseMatrixCOO(aug_vec_length,aug_vec_length,I,J,V)
    jac_raw = MadNLP.SparseMatrixCOO(
        m, n_tot,
        Int32[jac_sparsity_I; ind_ineq],
        Int32[jac_sparsity_J; n+1:n+n_slack],
        jac,
    )

    #=
        Build condensed matrix and Jacobian in CSC format for linear solver
    =#
    aug_com, aug_csc_map = MadNLP.coo_to_csc(aug_raw)
    jac_com, jac_csc_map = MadNLP.coo_to_csc(jac_raw)

    #=
        Initialize linear solver
    =#
    _linear_solver = linear_solver(
        aug_com; opt = opt_linear_solver
    )
    quasi_newton = MadNLP.ExactHessian{Float64, Vector{Float64}}()

    return DiagonalHessianKKTSystem(
        hess, jac_callback, jac, reg, pr_diag, du_diag,
        l_diag, u_diag, l_lower, u_lower,
        aug_raw, aug_com, aug_csc_map,
        diag_hess,
        jac_raw, jac_com, jac_csc_map,
        _linear_solver,
        n, n_slack, n_tot,
        ind_ineq, cb.ind_lb, cb.ind_ub,
        quasi_newton,
    )
end

# Getters
MadNLP.num_variables(kkt::DiagonalHessianKKTSystem) = length(kkt.diag_hess)
MadNLP.get_kkt(kkt::DiagonalHessianKKTSystem) = kkt.aug_com
MadNLP.get_jacobian(kkt::DiagonalHessianKKTSystem) = kkt.jac_callback
function MadNLP.jtprod!(y::AbstractVector, kkt::DiagonalHessianKKTSystem, x::AbstractVector)
    mul!(y, kkt.jac_com', x)
end

function MadNLP.initialize!(kkt::DiagonalHessianKKTSystem)
    fill!(kkt.reg, 1.0)
    fill!(kkt.pr_diag, 1.0)
    fill!(kkt.du_diag, 0.0)
    fill!(kkt.hess, 0.0)
    fill!(kkt.l_lower, 0.0)
    fill!(kkt.u_lower, 0.0)
    fill!(kkt.l_diag, 1.0)
    fill!(kkt.u_diag, 1.0)
    fill!(kkt.diag_hess, 0.)
end


function MadNLP.compress_jacobian!(kkt::DiagonalHessianKKTSystem)
    ns = length(kkt.ind_ineq)
    kkt.jac[end-ns+1:end] .= -1.0
    MadNLP.transfer!(kkt.jac_com, kkt.jac_raw, kkt.jac_csc_map)
    return
end

function MadNLP.compress_hessian!(kkt::DiagonalHessianKKTSystem)
    kkt.diag_hess .= 1.0
    return
end

function MadNLP.build_kkt!(kkt::DiagonalHessianKKTSystem)
    MadNLP.transfer!(kkt.aug_com, kkt.aug_raw, kkt.aug_csc_map)
end

function LinearAlgebra.mul!(
    w::MadNLP.AbstractKKTVector{T},
    kkt::DiagonalHessianKKTSystem,
    x::MadNLP.AbstractKKTVector{T},
    alpha = one(T),
    beta = zero(T),
) where {T}

    mul!(primal(w), Diagonal(kkt.diag_hess), primal(x), alpha, beta)
    mul!(primal(w), kkt.jac_com', dual(x), alpha, one(T))
    mul!(dual(w), kkt.jac_com,  primal(x), alpha, beta)

    # Reduce KKT vector
    MadNLP._kktmul!(w,x,kkt.reg,kkt.du_diag,kkt.l_lower,kkt.u_lower,kkt.l_diag,kkt.u_diag, alpha, beta)
    return w
end

function MadNLP.solve_kkt!(kkt::DiagonalHessianKKTSystem, w::MadNLP.AbstractKKTVector)
    MadNLP.reduce_rhs!(w.xp_lr, dual_lb(w), kkt.l_diag, w.xp_ur, dual_ub(w), kkt.u_diag)
    MadNLP.solve_linear_system!(kkt.linear_solver, primal_dual(w))
    MadNLP.finish_aug_solve!(kkt, w)
    return w
end

@testset "MadNLP: $QN + $KKT" for QN in [
    MadNLP.BFGS,
    MadNLP.DampedBFGS,
], KKT in [
    MadNLP.DenseKKTSystem,
    MadNLP.DenseCondensedKKTSystem,
]
    @testset "Size: ($n, $m)" for (n, m) in [(10, 0), (10, 5), (50, 10)]
        @testset "Precision = $T" for T in (Float32, Float64)
            x0 = zeros(T, n)
            nlp = MadNLPTests.DenseDummyQP(x0; m=m)
            solver_exact = MadNLP.MadNLPSolver(
                nlp;
                print_level=MadNLP.ERROR,
                kkt_system=MadNLP.DenseKKTSystem,
                linear_solver=LapackCPUSolver,
            )
            results_ref = MadNLP.solve!(solver_exact)

            solver_qn = MadNLP.MadNLPSolver(
                nlp;
                print_level=MadNLP.ERROR,
                kkt_system=KKT,
                hessian_approximation=QN,
                linear_solver=LapackCPUSolver,
            )
            results_qn = MadNLP.solve!(solver_qn)

            @test results_qn.status == MadNLP.SOLVE_SUCCEEDED
            if T == Float64
                @test results_qn.objective ≈ results_ref.objective atol=1e-6
                @test results_qn.solution ≈ results_ref.solution atol=1e-6
                @test solver_qn.cnt.lag_hess_cnt == 0
                @test solver_exact.y ≈ solver_qn.y atol=1e-4
            end
        end
    end
end

@testset "MadNLP: LBFGS" begin
    @testset "HS15" begin
        nlp = MadNLPTests.HS15NoHessianModel()
        solver_qn = MadNLP.MadNLPSolver(
            nlp;
            callback = MadNLP.SparseCallback,
            kkt_system = MadNLP.SparseKKTSystem,
            hessian_approximation=MadNLP.CompactLBFGS,
            print_level=MadNLP.ERROR,
        )
        results_qn = MadNLP.solve!(solver_qn)
        @test results_qn.status == MadNLP.SOLVE_SUCCEEDED

    end
    @testset "Size: ($n, $m)" for (n, m) in [(10, 0), (10, 5), (50, 10)]
        @testset "Precision = $T" for T in (Float32, Float64, Float128)
            x0 = zeros(T, n)
            nlp = MadNLPTests.DenseDummyQP(x0; m=m)
            # Reference solve with exact Hessian
            solver_exact = MadNLP.MadNLPSolver(
                nlp;
                linear_solver = (T == Float128) ? MadNLP.LDLSolver : MadNLP.MumpsSolver,
                callback = MadNLP.SparseCallback,
                kkt_system = MadNLP.SparseKKTSystem,
                print_level=MadNLP.ERROR,
            )
            results_ref = MadNLP.solve!(solver_exact)

            # LBFGS solve
            solver_qn = MadNLP.MadNLPSolver(
                nlp;
                linear_solver = (T == Float128) ? MadNLP.LDLSolver : MadNLP.MumpsSolver,
                callback = MadNLP.SparseCallback,
                kkt_system = MadNLP.SparseKKTSystem,
                hessian_approximation=MadNLP.CompactLBFGS,
                print_level=MadNLP.ERROR,
            )
            results_qn = MadNLP.solve!(solver_qn)

            @test results_qn.status == MadNLP.SOLVE_SUCCEEDED || results_qn.status == MadNLP.SOLVED_TO_ACCEPTABLE_LEVEL
            if T == Float64
                @test results_qn.objective ≈ results_ref.objective atol=1e-6
                @test results_qn.solution ≈ results_ref.solution atol=1e-6
                @test solver_qn.cnt.lag_hess_cnt == 0
                @test solver_exact.y ≈ solver_qn.y atol=1e-4
            end

            # Test accuracy of KKT solver with LBFGS
            b, x, w = solver_qn.p, solver_qn.d, solver_qn._w4
            fill!(b.values, one(T))
            MadNLP.solve_refine_wrapper!(x, solver_qn, b, w)
            mul!(w, solver_qn.kkt, x)
            if T == Float64
                @test norm(w.values .- b.values, Inf) <= 1e-6
            end
        end
    end
end

MadNLP.@kwdef mutable struct CudssSolverOptions <: MadNLP.AbstractOptions
    # Use LDLᵀ by default in CUDSS as Cholesky can lead to undefined behavior.
    cudss_algorithm::MadNLP.LinearFactorization = MadNLP.LDL
    cudss_ordering::ORDERING = DEFAULT_ORDERING
    cudss_perm::Vector{Cint} = Cint[]
    cudss_ir::Int = 0
    cudss_ir_tol::Float64 = 1.0e-8  # currently ignored in cuDSS 0.7
    cudss_pivot_threshold::Float64 = 0.0
    cudss_pivot_epsilon::Float64 = 0.0
    cudss_matching_alg::String = "default"
    cudss_reordering_alg::String = "default"
    cudss_factorization_alg::String = "default"
    cudss_solve_alg::String = "default"
    cudss_matching::Bool = false
    cudss_pivoting::Bool = true
    cudss_hybrid_execute::Bool = false
    cudss_hybrid_memory::Bool = false
    cudss_hybrid_memory_limit::Int = 0
    cudss_superpanels::Bool = true
    cudss_schur::Bool = false
    cudss_deterministic::Bool = false
    cudss_device_indices::Vector{Cint} = Cint[]
    cudss_asynchronous::Bool = true
end

function set_cudss_options!(solver::CUDSS.CudssSolver, opt::CudssSolverOptions)
    if opt.cudss_ir > 0
        CUDSS.cudss_set(solver, "ir_n_steps", opt.cudss_ir)
        CUDSS.cudss_set(solver, "ir_tol", opt.cudss_ir_tol)
    end
    if opt.cudss_hybrid_memory
        CUDSS.cudss_set(solver, "hybrid_memory_mode", 1)
        if opt.cudss_hybrid_memory_limit > 0
            CUDSS.cudss_set(solver, "hybrid_device_memory_limit", opt.cudss_hybrid_memory_limit)
        end
    end
    if opt.cudss_hybrid_execute
        CUDSS.cudss_set(solver, "hybrid_execute_mode", 1)
    end
    if !opt.cudss_pivoting
        CUDSS.cudss_set(solver, "pivot_type", 'N')
    end
    if opt.cudss_pivot_epsilon > 0.0
        CUDSS.cudss_set(solver, "pivot_epsilon", opt.cudss_pivot_epsilon)
    end
    if opt.cudss_pivot_threshold > 0.0
        CUDSS.cudss_set(solver, "pivot_threshold", opt.cudss_pivot_threshold)
    end
    if opt.cudss_matching
        CUDSS.cudss_set(solver, "use_matching", 1)
        if opt.cudss_matching_alg != "default"
            CUDSS.cudss_set(solver, "matching_alg", opt.cudss_matching_alg)
        end
    end
    if opt.cudss_reordering_alg != "default"
        CUDSS.cudss_set(solver, "reordering_alg", opt.cudss_reordering_alg)
    end
    if opt.cudss_factorization_alg != "default"
        CUDSS.cudss_set(solver, "factorization_alg", opt.cudss_factorization_alg)
    end
    if opt.cudss_solve_alg != "default"
        CUDSS.cudss_set(solver, "solve_alg", opt.cudss_solve_alg)
    end
    if !opt.cudss_superpanels
        CUDSS.cudss_set(solver, "use_superpanels", 0)
    end
    if opt.cudss_schur
        CUDSS.cudss_set(solver, "schur_mode", 1)
    end
    if opt.cudss_deterministic
        CUDSS.cudss_set(solver, "deterministic_mode", 1)
    end
    return if !isempty(opt.cudss_device_indices)
        cudss_device_count = length(opt.cudss_device_indices)
        CUDSS.cudss_set(solver, "device_count", cudss_device_count)
        CUDSS.cudss_set(solver, "device_indices", opt.cudss_device_indices)
    end
end

mutable struct CUDSSSolver{T, V} <: MadNLP.AbstractLinearSolver{T}
    inner::CUDSS.CudssSolver{T}
    tril::cuSPARSE.CuSparseMatrixCSC{T, Cint}
    x_gpu::CUDSS.CudssMatrix{T}
    b_gpu::CUDSS.CudssMatrix{T}
    buffer::V

    opt::CudssSolverOptions
    logger::MadNLP.MadNLPLogger
end

function CUDSSSolver(
        csc::cuSPARSE.CuSparseMatrixCSC{T, Cint};
        opt = CudssSolverOptions(),
        logger = MadNLP.MadNLPLogger(),
    ) where {T}
    n, m = size(csc)
    @assert n == m

    view = 'U'
    structure = 'G'
    # We need view = 'F' for the sparse LU decomposition
    (opt.cudss_algorithm == MadNLP.LU) && error(logger, "The sparse LU of cuDSS is not supported.")
    (opt.cudss_algorithm == MadNLP.CHOLESKY) && (structure = "SPD")
    (opt.cudss_algorithm == MadNLP.LDL) && (structure = "S")

    solver = CUDSS.CudssSolver(csc.colPtr, csc.rowVal, csc.nzVal, structure, view)
    set_cudss_options!(solver, opt)

    if opt.cudss_ordering != DEFAULT_ORDERING
        if opt.cudss_ordering == METIS_ORDERING
            A = SparseMatrixCSC(csc)
            A = A + A' - LinearAlgebra.Diagonal(A)
            G = Metis.graph(A, check_hermitian = false)
            opt.cudss_perm, _ = Metis.permutation(G)
        elseif opt.cudss_ordering == AMD_ORDERING
            A = SparseMatrixCSC(csc)
            opt.cudss_perm = AMD.amd(A)
        elseif opt.cudss_ordering == SYMAMD_ORDERING
            A = SparseMatrixCSC(csc)
            opt.cudss_perm = AMD.symamd(A)
        elseif opt.cudss_ordering == COLAMD_ORDERING
            A = SparseMatrixCSC(csc)
            opt.cudss_perm = AMD.colamd(A)
        elseif opt.cudss_ordering == USER_ORDERING
            (!isempty(opt.cudss_perm) && isperm(opt.cudss_perm)) || error(logger, "The vector opt.cudss_perm is not a valid permutation.")
        else
            error(logger, "The ordering $(opt.cudss_ordering) is not supported.")
        end
        CUDSS.cudss_set(solver, "user_perm", opt.cudss_perm)
    end

    # Check if we want to use the batch solver for matrices with a common sparsity pattern
    nbatch = solver.matrix.nbatch
    if nbatch > 1
        CUDSS.cudss_set(solver, "ubatch_size", nbatch)
    end

    # The phase "analysis" is "reordering" combined with "symbolic_factorization"
    x_gpu = CUDSS.CudssMatrix(T, n; nbatch = nbatch)
    b_gpu = CUDSS.CudssMatrix(T, n; nbatch = nbatch)
    CUDSS.cudss("analysis", solver, x_gpu, b_gpu, asynchronous = opt.cudss_asynchronous)

    # Allocate additional buffer for iterative refinement
    # Always allocate it to support dynamic updates to opt.cudss_ir
    buffer = CuVector{T}(undef, n * nbatch)

    return CUDSSSolver(
        solver, csc,
        x_gpu, b_gpu, buffer,
        opt, logger,
    )
end

function MadNLP.factorize!(M::CUDSSSolver)
    CUDSS.cudss_update(M.inner.matrix, nonzeros(M.tril))
    if M.inner.fresh_factorization
        CUDSS.cudss("factorization", M.inner, M.x_gpu, M.b_gpu, asynchronous = M.opt.cudss_asynchronous)
    else
        CUDSS.cudss("refactorization", M.inner, M.x_gpu, M.b_gpu, asynchronous = M.opt.cudss_asynchronous)
    end
    return M
end

function MadNLP.solve_linear_system!(M::CUDSSSolver{T, V}, xb::V) where {T, V}
    if M.opt.cudss_ir > 0
        copyto!(M.buffer, xb)
        CUDSS.cudss_update(M.b_gpu, M.buffer)
    else
        CUDSS.cudss_update(M.b_gpu, xb)
    end
    CUDSS.cudss_update(M.x_gpu, xb)
    CUDSS.cudss("solve", M.inner, M.x_gpu, M.b_gpu, asynchronous = M.opt.cudss_asynchronous)
    return xb
end

MadNLP.input_type(::Type{CUDSSSolver}) = :csc
MadNLP.default_options(::Type{CUDSSSolver}) = CudssSolverOptions()
MadNLP.is_inertia(M::CUDSSSolver) = (M.inner.matrix.nbatch == 1)  # Uncomment if MadNLP.LU is supported -- (M.opt.cudss_algorithm ∈ (MadNLP.CHOLESKY, MadNLP.LDL))
function MadNLP.inertia(M::CUDSSSolver)
    @assert M.inner.matrix.nbatch == 1
    n = size(M.tril, 1)
    info = CUDSS.cudss_get(M.inner, "info")

    # cudss_set(M.inner, "diag", buffer)  # specify the vector to update in `cudss_get`
    # cudss_get(M.inner, "diag")          # update the vector specified in `cudss_set`
    #
    # `buffer` contains the diagonal of the factorized matrix.

    return if M.opt.cudss_algorithm == MadNLP.CHOLESKY
        if info == 0
            return (n, 0, 0)
        else
            return (n - 2, 1, 1) # if factorization fails, return a dummy inertia
        end
    elseif M.opt.cudss_algorithm == MadNLP.LDL
        # N.B.: cuDSS does not always return the correct inertia.
        if info == 0
            (k, l) = CUDSS.cudss_get(M.inner, "inertia")
            @assert 0 ≤ k + l ≤ n
            return (k, n - k - l, l)
        else
            return (0, 1, n) # if factorization fails, return a dummy inertia
        end
    else
        error(M.logger, "Unsupported cudss_algorithm")
    end
end
MadNLP.improve!(M::CUDSSSolver) = false
MadNLP.is_supported(::Type{CUDSSSolver}, ::Type{Float32}) = true
MadNLP.is_supported(::Type{CUDSSSolver}, ::Type{Float64}) = true
MadNLP.introduce(M::CUDSSSolver) = "cuDSS v$(CUDSS.version())"
MadNLP.is_async(M::CUDSSSolver) = M.opt.cudss_asynchronous

# MadNLP.jl
# Created by Sungho Shin (sungho.shin@wisc.edu)

abstract type AbstractSparseMatrixCOO{Tv,Ti<:Integer} <: AbstractSparseMatrix{Tv,Ti} end

mutable struct SparseMatrixCOO{Tv,Ti,VTv<:AbstractVector{Tv},VTi<:AbstractVector{Ti}} <: AbstractSparseMatrixCOO{Tv,Ti}
    m::Int
    n::Int
    I::VTi
    J::VTi
    V::VTv
end
size(A::SparseMatrixCOO) = (A.m,A.n)
getindex(A::SparseMatrixCOO{Tv,Ti},i::Int,j::Int) where {Tv, Ti <: Integer} = sum(A.V[(A.I.==i) .* (A.J.==j)])
nnz(A::SparseMatrixCOO) = length(A.I)

function findIJ(S::SparseMatrixCSC{Tv,Ti}) where {Tv,Ti}
    numnz = nnz(S)
    I = Vector{Ti}(undef,numnz)
    J = Vector{Ti}(undef,numnz)

    cnt = 1
    @inbounds for col = 1 : size(S, 2), k = getcolptr(S)[col] : (getcolptr(S)[col+1]-1)
        I[cnt] = rowvals(S)[k]
        J[cnt] = col
        cnt += 1
    end

    return I,J
end

get_mapping(dest::Matrix{Tv}, src::SparseMatrixCOO{Tv,Ti}) where {Tv,Ti} = nothing

function diag!(dest::AbstractVector{T}, src::AbstractMatrix{T}) where T
    @assert length(dest) == size(src, 1)
    @inbounds for i in eachindex(dest)
        dest[i] = src[i, i]
    end
end
get_tril_to_full(csc::SparseMatrixCSC{Tv,Ti}) where {Tv, Ti} = get_tril_to_full(Tv,csc)
function get_tril_to_full(T,csc::SparseMatrixCSC{Tv,Ti}) where {Tv,Ti<:Integer}
    cscind = SparseMatrixCSC{Int,Ti}(Symmetric(
        SparseMatrixCSC{Int,Ti}(csc.m,csc.n,csc.colptr,csc.rowval,collect(1:nnz(csc))),:L))
    return SparseMatrixCSC{T,Ti}(
        csc.m,csc.n,cscind.colptr,cscind.rowval,Vector{T}(undef,nnz(cscind))),view(csc.nzval,cscind.nzval)
end
function tril_to_full!(dense::Matrix{T}) where T
    for i=1:size(dense,1)
        Threads.@threads for j=i:size(dense,2)
            @inbounds dense[i,j]=dense[j,i]
        end
    end
end

function coo_to_csc(coo::SparseMatrixCOO)
    cscind = sparse(
        coo.I,
        coo.J,
        fill!(similar(coo.I,nnz(coo)), 1),
        coo.m,
        coo.n
    )
    nzval = similar(coo.V, nnz(cscind))
    fill!(nzval, 0)
    
    csc = SparseMatrixCSC(
        coo.m,coo.n,cscind.colptr,cscind.rowval,nzval,
    )
    map = get_mapping(csc, coo)
    
    return csc, map
end

function _get_coo_to_csc(I,J,cscind,map)
    for i=1:length(I)
        @inbounds map[i] = cscind[I[i],J[i]]
    end
end
function _transfer!(vec1, vec2, map)
    fill!(vec1, 0.0)
    for i=1:length(map)
        @inbounds vec1[map[i]] += vec2[i]
    end
end

function transfer!(dest::SparseMatrixCSC, src::SparseMatrixCOO, map::Vector{Int})
    _transfer!(dest.nzval, src.V, map)
end

function get_mapping(dest::SparseMatrixCSC{Tv1,Ti1}, src::SparseMatrixCOO{Tv2,Ti2}) where {Tv1,Tv2,Ti1,Ti2}
    map = similar(src.V, Int, nnz(src))
    dest.nzval .= 1:nnz(dest)
    _get_coo_to_csc(src.I, src.J, dest, map)
    return map
end

function Matrix{Tv}(coo::SparseMatrixCOO{Tv,Ti}) where {Tv,Ti<:Integer}
    return Matrix{Tv}(undef,coo.m,coo.n)
end

Base.copyto!(dense::Matrix,coo::SparseMatrixCOO) = _copyto!(dense,coo.I,coo.J,coo.V)
function _copyto!(dense::Matrix{Tv},I,J,V) where Tv
    fill!(dense, zero(Tv))
    for i=1:length(I)
        @inbounds dense[I[i], J[i]] += V[i]
    end
    return dense
end

function get_cscsy_view(csc::SparseMatrixCSC{Tv,Ti},Ix;inds=collect(1:nnz(csc))) where {Tv,Ti<:Integer}
    cscind = SparseMatrixCSC{Int,Ti}(csc.m,csc.n,csc.colptr,csc.rowval,inds)
    cscindsub = cscind[Ix,Ix]
    return SparseMatrixCSC{Tv,Ti}(
        cscindsub.m,cscindsub.n,cscindsub.colptr,
        cscindsub.rowval,Vector{Tv}(undef,nnz(cscindsub))), view(csc.nzval,cscindsub.nzval)

end

function get_csc_view(csc::SparseMatrixCSC{Tv,Ti},Ix,Jx;inds=collect(1:nnz(csc))) where {Tv,Ti<:Integer}
    cscind = Symmetric(SparseMatrixCSC{Int,Ti}(csc.m,csc.n,csc.colptr,csc.rowval,inds),:L)
    cscindsub = cscind[Ix,Jx]
    resize!(cscindsub.rowval,cscindsub.colptr[end]-1)
    resize!(cscindsub.nzval,cscindsub.colptr[end]-1)
    return SparseMatrixCSC{Tv,Ti}(
        cscindsub.m,cscindsub.n,cscindsub.colptr,
        cscindsub.rowval,Vector{Tv}(undef,nnz(cscindsub))), view(csc.nzval,cscindsub.nzval)
end

function force_lower_triangular!(I,J)
    @simd for i=1:length(I)
        @inbounds if J[i] > I[i]
            tmp=J[i]
            J[i]=I[i]
            I[i]=tmp
        end
    end
end

"""
    ScaledSparseKKTSystem{T, VT, MT, QN} <: AbstractReducedKKTSystem{T, VT, MT, QN}

Scaled version of the [`AbstractReducedKKTSystem`](@ref) (using the K2.5 formulation introduced in [GOS]).

The K2.5 formulation of the augmented KKT system has a better conditioning
than the original (K2) formulation. It is recommend switching to a `ScaledSparseKKTSystem`
if you encounter numerical difficulties in MadNLP.

At a primal-dual iterate ``(x, s, y, z)``, the matrix writes
```
[√Ξₓ Wₓₓ √Ξₓ + Δₓ   0      √Ξₓ Aₑ'   √Ξₓ Aᵢ']  [√Ξₓ⁻¹ Δx]
[0                  Δₛ     0           -√Ξₛ ]  [√Ξₛ⁻¹ Δs]
[Aₑ√Ξₓ              0      0              0 ]  [Δy      ]
[Aᵢ√Ξₓ             -√Ξₛ    0              0 ]  [Δz      ]
```
with
* ``Wₓₓ``: Hessian of the Lagrangian.
* ``Aₑ``: Jacobian of the equality constraints
* ``Aᵢ``: Jacobian of the inequality constraints
* ``Δₓ = Xᵤ Zₗˣ + Xₗ Zᵤˣ``
* ``Δₛ = Sᵤ Zₗˢ + Sₗ Zᵤˢ``
* ``Ξₓ = Xₗ Xᵤ``
* ``Ξₛ = Sₗ Sᵤ``

# References
[GOS] Ghannad, Alexandre, Dominique Orban, and Michael A. Saunders.
"Linear systems arising in interior methods for convex optimization: a symmetric formulation with bounded condition number."
Optimization Methods and Software 37, no. 4 (2022): 1344-1369.

"""
struct ScaledSparseKKTSystem{T, VT, MT, QN, LS, VI, VI32} <: AbstractReducedKKTSystem{T, VT, MT, QN}
    hess::VT
    jac_callback::VT
    jac::VT
    quasi_newton::QN
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT
    scaling_factor::VT
    buffer1::VT
    buffer2::VT
    # Augmented system
    aug_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    aug_com::MT
    aug_csc_map::Union{Nothing, VI}
    scaled_aug_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    # Hessian
    hess_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    hess_com::MT
    hess_csc_map::Union{Nothing, VI}
    # Jacobian
    jac_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    jac_com::MT
    jac_csc_map::Union{Nothing, VI}
    # LinearSolver
    linear_solver::LS
    # Info
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
end

# Build KKT system directly from SparseCallback
function create_kkt_system(
    ::Type{ScaledSparseKKTSystem},
    cb::SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
) where {T,VT}

    n_slack = length(cb.ind_ineq)
    # Deduce KKT size.

    n = cb.nvar
    m = cb.ncon
    # Evaluate sparsity pattern
    jac_sparsity_I = create_array(cb, Int32, cb.nnzj)
    jac_sparsity_J = create_array(cb, Int32, cb.nnzj)
    _jac_sparsity_wrapper!(cb,jac_sparsity_I, jac_sparsity_J)

    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    hess_sparsity_I, hess_sparsity_J = build_hessian_structure(cb, hessian_approximation)

    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)

    force_lower_triangular!(hess_sparsity_I,hess_sparsity_J)

    ind_ineq = cb.ind_ineq

    n_slack = length(ind_ineq)
    n_jac = length(jac_sparsity_I)
    n_hess = length(hess_sparsity_I)
    n_tot = n + n_slack


    aug_vec_length = n_tot+m
    aug_mat_length = n_tot+m+n_hess+n_jac+n_slack

    I = create_array(cb, Int32, aug_mat_length)
    J = create_array(cb, Int32, aug_mat_length)
    V = VT(undef, aug_mat_length)
    fill!(V, 0.0)  # Need to initiate V to avoid NaN

    offset = n_tot+n_jac+n_slack+n_hess+m

    I[1:n_tot] .= 1:n_tot
    I[n_tot+1:n_tot+n_hess] = hess_sparsity_I
    I[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= (jac_sparsity_I.+n_tot)
    I[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= ind_ineq .+ n_tot
    I[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

    J[1:n_tot] .= 1:n_tot
    J[n_tot+1:n_tot+n_hess] = hess_sparsity_J
    J[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= jac_sparsity_J
    J[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= (n+1:n+n_slack)
    J[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

    pr_diag = _madnlp_unsafe_wrap(V, n_tot)
    du_diag = _madnlp_unsafe_wrap(V, m, n_jac+n_slack+n_hess+n_tot+1)

    reg = VT(undef, n_tot)
    l_diag = VT(undef, nlb)
    u_diag = VT(undef, nub)
    l_lower = VT(undef, nlb)
    u_lower = VT(undef, nub)

    scaling_factor = VT(undef, n_tot)
    buffer1 = VT(undef, n_tot)
    buffer2 = VT(undef, n_tot)

    hess = _madnlp_unsafe_wrap(V, n_hess, n_tot+1)
    jac = _madnlp_unsafe_wrap(V, n_jac+n_slack, n_hess+n_tot+1)
    jac_callback = _madnlp_unsafe_wrap(V, n_jac, n_hess+n_tot+1)

    aug_raw = SparseMatrixCOO(aug_vec_length,aug_vec_length,I,J,V)
    jac_raw = SparseMatrixCOO(
        m, n_tot,
        Int32[jac_sparsity_I; ind_ineq],
        Int32[jac_sparsity_J; n+1:n+n_slack],
        jac,
    )
    hess_raw = SparseMatrixCOO(
        n_tot, n_tot,
        hess_sparsity_I,
        hess_sparsity_J,
        hess,
    )
    scaled_aug_raw = SparseMatrixCOO(aug_vec_length,aug_vec_length,I,J,copy(V))

    aug_com, aug_csc_map = coo_to_csc(aug_raw)
    jac_com, jac_csc_map = coo_to_csc(jac_raw)
    hess_com, hess_csc_map = coo_to_csc(hess_raw)

    _linear_solver = linear_solver(
        aug_com; opt = opt_linear_solver
    )

    return ScaledSparseKKTSystem(
        hess, jac_callback, jac, quasi_newton, reg, pr_diag, du_diag,
        l_diag, u_diag, l_lower, u_lower,
        scaling_factor, buffer1, buffer2,
        aug_raw, aug_com, aug_csc_map, scaled_aug_raw,
        hess_raw, hess_com, hess_csc_map,
        jac_raw, jac_com, jac_csc_map,
        _linear_solver,
        ind_ineq, cb.ind_lb, cb.ind_ub,
    )
end

num_variables(kkt::ScaledSparseKKTSystem) = length(kkt.pr_diag)
get_jacobian(kkt::ScaledSparseKKTSystem) = kkt.jac_callback

function initialize!(kkt::ScaledSparseKKTSystem{T}) where T
    fill!(kkt.reg, one(T))
    fill!(kkt.pr_diag, one(T))
    fill!(kkt.du_diag, zero(T))
    fill!(kkt.hess, zero(T))
    fill!(kkt.l_lower, zero(T))
    fill!(kkt.u_lower, zero(T))
    fill!(kkt.l_diag, one(T))
    fill!(kkt.u_diag, one(T))
    fill!(kkt.scaling_factor, one(T))
    fill!(nonzeros(kkt.hess_com), zero(T)) # so that mul! in the initial primal-dual solve has no effect
end

function jtprod!(y::AbstractVector, kkt::ScaledSparseKKTSystem, x::AbstractVector)
    mul!(y, kkt.jac_com', x)
end

function compress_jacobian!(kkt::ScaledSparseKKTSystem)
    ns = length(kkt.ind_ineq)
    kkt.jac[end-ns+1:end] .= -1.0
    transfer!(kkt.jac_com, kkt.jac_raw, kkt.jac_csc_map)
end

function compress_hessian!(kkt::ScaledSparseKKTSystem)
    transfer!(kkt.hess_com, kkt.hess_raw, kkt.hess_csc_map)
end

# N.B. Matrices are assumed to have an augmented KKT structure and be lower-triangular.
function _build_scale_augmented_system_coo!(dest, src, scaling, n, m)
    for (k, i, j) in zip(1:nnz(src), src.I, src.J)
        # Primal regularization pr_diag
        if k <= n
            dest.V[k] = src.V[k]
        # Hessian block
        elseif i <= n && j <= n
            dest.V[k] = src.V[k] * scaling[i] * scaling[j]
        # Jacobian block
        elseif n + 1 <= i <= n + m && j <= n
            dest.V[k] = src.V[k] * scaling[j]
        # Dual regularization du_diag
        elseif n + 1 <= i <= n + m && n + 1 <= j <= n + m
            dest.V[k] = src.V[k]
        end
    end
end

function build_kkt!(kkt::ScaledSparseKKTSystem)
    m, n = size(kkt.jac_raw)
    _build_scale_augmented_system_coo!(
        kkt.scaled_aug_raw,
        kkt.aug_raw,
        kkt.scaling_factor,
        n, m,
    )
    transfer!(kkt.aug_com, kkt.scaled_aug_raw, kkt.aug_csc_map)
end

function regularize_diagonal!(kkt::ScaledSparseKKTSystem, primal, dual)
    kkt.reg .+= primal
    kkt.pr_diag .+= primal .* kkt.scaling_factor.^2
    kkt.du_diag .-= dual
end

module MadNLPKrylov

import MadNLP:
    @kwdef, MadNLPLogger, @debug, @warn, @error,
    AbstractOptions, AbstractIterator, set_options!, @sprintf,
    solve_refine!, mul!, ldiv!, size, default_options
import IterativeSolvers:
    FastHessenberg, ArnoldiDecomp, Residual, init!, init_residual!, expand!, Identity,
    orthogonalize_and_normalize!, update_residual!, gmres_iterable!, GMRESIterable, converged,
    ModifiedGramSchmidt


@kwdef mutable struct KrylovOptions <: AbstractOptions
    krylov_restart::Int = 5
    krylov_max_iter::Int = 10
    krylov_tol::Float64 = 1e-10
    krylov_acceptable_tol::Float64 = 1e-5
end

struct VirtualMatrix
    mul!::Function
    m::Int
    n::Int
end
mul!(y,A::VirtualMatrix,x) = A.mul!(y,x)
size(A::VirtualMatrix,i) = (A.m,A.n)[i]

struct VirtualPreconditioner
    ldiv!::Function
end
ldiv!(Pl::VirtualPreconditioner,x::Vector{Float64}) = Pl.ldiv!(x)

mutable struct KrylovIterator{T} <: AbstractIterator{T}
    g::Union{Nothing,GMRESIterable}
    res::Vector{T}
    opt::KrylovOptions
    logger::MadNLPLogger
end

function KrylovIterator(res::Vector{T},_mul!,_ldiv!;
    opt=KrylovOptions(),logger=MadNLPLogger(),
) where T
    !isempty(kwargs) && (for (key,val) in kwargs; option_dict[key]=val; end)

    g = GMRESIterable(VirtualPreconditioner(_ldiv!),
                      Identity(),T[],T[],res,
                      ArnoldiDecomp(VirtualMatrix(_mul!,length(res),length(res)),opt.krylov_restart, T),
                      Residual(opt.krylov_restart, T),
                      0,opt.krylov_restart,1,
                      opt.krylov_max_iter,opt.krylov_tol,0.,
                      ModifiedGramSchmidt())

    return KrylovIterator{T}(g,res,opt,logger)
end

function solve_refine!(x::StridedVector{Float64},
                       is::KrylovIterator,
                       b::AbstractVector{Float64})
    @debug(is.logger,"Iterator initiated")
    is.res.=0
    x.=0
    gmres_iterable_update!(is.g,x,b)

    noprogress = 0
    oldres = Inf
    iter = 0
    @debug(is.logger,"iter ||res||")
    @debug(is.logger,@sprintf("%4i %6.2e",iter,is.g.residual.current))
    for (~,res) in enumerate(is.g)
        iter += 1
        mod(iter,10)==0 && @debug(is.logger,"iter ||res||")
        @debug(is.logger,@sprintf("%4i %6.2e",iter,res))
        # res >= oldres && res > is.opt.krylov_acceptable_tol && (noprogress += 1)
        # oldres = res
        # if noprogress >= 3
        #     @debug(is.logger,@sprintf(
        #         "Iterative solver terminated with %4i refinement steps and residual = %6.2e",
        #         iter,res))
        #     return :Singular
        # end
    end
    @debug(is.logger,@sprintf(
        "Iterative solver terminated with %4i refinement steps and residual = %6.2e",iter,is.g.residual.current))

    return (is.g.residual.current < is.opt.krylov_acceptable_tol ? :Solved : :Failed)
end

function gmres_iterable_update!(g,x,b)
    g.x=x
    g.b=b
    g.mv_products = 0
    g.residual.current = init!(g.arnoldi,g.x,g.b,g.Pl,g.Ax,initially_zero = true)
    init_residual!(g.residual, g.residual.current)
    g.k=1
    g.β=g.residual.current
end

default_options(::Type{KrylovIterator}) = KrylovOptions()

end # module

using Test
using LinearAlgebra
using MadNLP
using MadNLPTests

@testset "SchurComplementKKTSystem" begin

    @testset "Basic convergence — quadratic with coupling" begin
        # min sum_k (v_k - θ_k)^2 + (d - 1)^2
        # s.t. v_k + d = 0 for k = 1..ns
        ns, nv, nd, nc = 3, 1, 1, 1
        θ = [4.0, 6.0, 8.0]

        qp = build_twostage_qp(;
            ns, nv, nd, nc,
            hess_v = fill(2.0, nv, ns),
            hess_d = fill(2.0, nd),
            g_v = reshape(-2 .* θ, nv, ns),
            g_d = [-2.0],
            A_v = fill(1.0, nc, nv, ns),
            A_d = fill(1.0, nc, nd, ns),
            lcon = zeros(nc, ns), ucon = zeros(nc, ns),
            lvar_v = fill(-100.0, nv, ns), uvar_v = fill(100.0, nv, ns),
            lvar_d = fill(-100.0, nd), uvar_d = fill(100.0, nd),
        )

        result = madnlp(
            qp;
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCPUSolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
        # Analytic optimum: d* = (1 - sum θ) / (ns + 1), v_k* = -d*
        d_star = (1.0 - sum(θ)) / (ns + 1)
        @test isapprox(result.solution[end], d_star; atol = 1.0e-3)
        @test all(isapprox(result.solution[k], -d_star; atol = 1.0e-3) for k in 1:ns)
    end

    @testset "Match SparseKKT reference" begin
        # min sum_{k,j} (v_{k,j} - θ_{k,j})^2 + d^2
        # s.t. v_{k,1} + v_{k,2} + d = 0
        ns, nv, nd, nc = 2, 2, 1, 1
        θ = [1.0 3.0; 2.0 4.0]   # θ[j, k]

        function mk()
            build_twostage_qp(;
                ns, nv, nd, nc,
                hess_v = fill(2.0, nv, ns),
                hess_d = fill(2.0, nd),
                g_v = -2 .* θ,
                g_d = [0.0],
                A_v = fill(1.0, nc, nv, ns),
                A_d = fill(1.0, nc, nd, ns),
                lcon = zeros(nc, ns), ucon = zeros(nc, ns),
                lvar_v = fill(-50.0, nv, ns), uvar_v = fill(50.0, nv, ns),
                lvar_d = fill(-50.0, nd), uvar_d = fill(50.0, nd),
            )
        end

        ref = madnlp(mk(); linear_solver = LapackCPUSolver, print_level = MadNLP.ERROR)
        schur = madnlp(
            mk();
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCPUSolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )

        @test ref.status == MadNLP.SOLVE_SUCCEEDED
        @test schur.status == MadNLP.SOLVE_SUCCEEDED
        @test isapprox(schur.objective, ref.objective; atol = 1.0e-6)
        @test isapprox(schur.solution, ref.solution; atol = 1.0e-4)
    end

    @testset "Multiple recourse vars and design vars" begin
        # min sum_{k,j} θ_k * v_{k,j}^2 + sum_j d_j^2
        # s.t. v_{k,1} + v_{k,2} + d_1 + d_2 = 1
        ns, nv, nd, nc = 2, 2, 2, 1
        θ = [1.0, 2.0]

        H_v = zeros(nv, ns)
        for k in 1:ns, j in 1:nv
            H_v[j, k] = 2θ[k]
        end

        qp = build_twostage_qp(;
            ns, nv, nd, nc,
            hess_v = H_v, hess_d = fill(2.0, nd),
            g_v = zeros(nv, ns), g_d = zeros(nd),
            A_v = fill(1.0, nc, nv, ns),
            A_d = fill(1.0, nc, nd, ns),
            lcon = ones(nc, ns), ucon = ones(nc, ns),
            lvar_v = fill(-50.0, nv, ns), uvar_v = fill(50.0, nv, ns),
            lvar_d = fill(-50.0, nd), uvar_d = fill(50.0, nd),
        )

        result = madnlp(
            qp;
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCPUSolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end

    @testset "Known solution with inactive constraints" begin
        # min sum_k (v_k - θ_k)^2 + (d - 5)^2
        # s.t. -100 <= v_k + d <= 100  (inactive at optimum)
        # Solution: v_k* = θ_k, d* = 5
        ns, nv, nd, nc = 2, 1, 1, 1
        θ = [3.0, 7.0]

        qp = build_twostage_qp(;
            ns, nv, nd, nc,
            hess_v = fill(2.0, nv, ns), hess_d = fill(2.0, nd),
            g_v = reshape(-2 .* θ, nv, ns), g_d = [-10.0],
            A_v = fill(1.0, nc, nv, ns), A_d = fill(1.0, nc, nd, ns),
            lcon = fill(-100.0, nc, ns), ucon = fill(100.0, nc, ns),
            lvar_v = fill(-100.0, nv, ns), uvar_v = fill(100.0, nv, ns),
            lvar_d = fill(-100.0, nd), uvar_d = fill(100.0, nd),
        )

        result = madnlp(
            qp;
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCPUSolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
        @test isapprox(result.solution[1], 3.0; atol = 1.0e-3)
        @test isapprox(result.solution[2], 7.0; atol = 1.0e-3)
        @test isapprox(result.solution[3], 5.0; atol = 1.0e-3)
    end

    @testset "Autodetect dims via tags" begin
        # Fake `cb` exposing the tag interface that _resolve_schur_dims expects.
        mkcb(tags) = (; nlp = (; tags))

        # Happy case: ns=2, nv=1, nd=1, nc=1 → var_scen [1, 2, 0], con_scen [1, 2]
        ok = (; ns = 2, var_scenario = [1, 2, 0], con_scenario = [1, 2])
        @test MadNLP._resolve_schur_dims(mkcb(ok), 3, 2, 0, 0, 0, 0) == (2, 1, 1, 1)

        # Out-of-range variable tag
        bad_tag = (; ns = 2, var_scenario = [1, 5, 0], con_scenario = [1, 2])
        @test_throws ErrorException MadNLP._resolve_schur_dims(mkcb(bad_tag), 3, 2, 0, 0, 0, 0)

        # Non-uniform per-scenario variable count: scenario 2 has 2 vars, scenario 1 has 1.
        nu_var = (; ns = 2, var_scenario = [1, 2, 2, 0], con_scenario = [1, 2])
        @test_throws ErrorException MadNLP._resolve_schur_dims(mkcb(nu_var), 4, 2, 0, 0, 0, 0)

        # Non-uniform per-scenario constraint count.
        nu_con = (; ns = 2, var_scenario = [1, 2, 0], con_scenario = [1, 2, 2])
        @test_throws ErrorException MadNLP._resolve_schur_dims(mkcb(nu_con), 3, 3, 0, 0, 0, 0)

        # Design-only constraint (con tag 0) is rejected.
        d_only = (; ns = 2, var_scenario = [1, 2, 0], con_scenario = [1, 2, 0])
        @test_throws ErrorException MadNLP._resolve_schur_dims(mkcb(d_only), 3, 3, 0, 0, 0, 0)
    end

    @testset "Layout validation" begin
        # ns=2, nv=1, nd=1, nc=1: vars [v1, v2, d], cons [c1, c2]
        ns, nv, nd, nc = 2, 1, 1, 1
        n, m = ns*nv + nd, ns*nc

        # Happy case as a baseline: diagonal Hessian, each constraint touches its own
        # scenario var and the design var, all equality.
        hess_I_ok = Int32[1, 2, 3]; hess_J_ok = Int32[1, 2, 3]
        jac_I_ok  = Int32[1, 1, 2, 2]; jac_J_ok = Int32[1, 3, 2, 3]
        ind_eq    = Int32[1, 2]
        ind_ineq  = Int32[]
        @test MadNLP._build_schur_symbolic(
            Float64, n, m, ns, nv, nd, nc,
            hess_I_ok, hess_J_ok, jac_I_ok, jac_J_ok, ind_eq, ind_ineq,
        ) isa NamedTuple

        # Cross-scenario Hessian coupling: entry at (row=2, col=1) couples scenarios 1 and 2.
        hess_I_bad = Int32[1, 2, 3, 2]
        hess_J_bad = Int32[1, 2, 3, 1]
        @test_throws ErrorException MadNLP._build_schur_symbolic(
            Float64, n, m, ns, nv, nd, nc,
            hess_I_bad, hess_J_bad, jac_I_ok, jac_J_ok, ind_eq, ind_ineq,
        )

        # Cross-scenario Jacobian coupling: c_1 reaches v_2 (scenario 2's variable).
        jac_I_bad = Int32[1, 1, 1, 2, 2]
        jac_J_bad = Int32[1, 2, 3, 2, 3]
        @test_throws ErrorException MadNLP._build_schur_symbolic(
            Float64, n, m, ns, nv, nd, nc,
            hess_I_ok, hess_J_ok, jac_I_bad, jac_J_bad, ind_eq, ind_ineq,
        )

        # Non-uniform eq/ineq counts: c_1 is equality, c_2 is inequality.
        @test_throws ErrorException MadNLP._build_schur_symbolic(
            Float64, n, m, ns, nv, nd, nc,
            hess_I_ok, hess_J_ok, jac_I_ok, jac_J_ok, Int32[1], Int32[2],
        )

        # Non-uniform sparsity: scenario 2 has an extra off-diagonal Hessian entry
        # at local (2,1) that scenario 1 doesn't, but the entry wouldn't exist in
        # this 1-var-per-scenario layout. Use nv=2 instead.
        ns2, nv2, nd2, nc2 = 2, 2, 1, 1
        n2, m2 = ns2*nv2 + nd2, ns2*nc2
        # vars: [v1_1, v1_2, v2_1, v2_2, d], cons: [c1, c2]
        # Scenario 1 has Hessian entries at (1,1),(2,2) only.
        # Scenario 2 has Hessian entries at (3,3),(4,4) AND off-diag (4,3).
        hess_I_nu = Int32[1, 2, 3, 4, 4, 5]
        hess_J_nu = Int32[1, 2, 3, 4, 3, 5]
        jac_I_nu  = Int32[1, 1, 1, 2, 2, 2]
        jac_J_nu  = Int32[1, 2, 5, 3, 4, 5]
        @test_throws ErrorException MadNLP._build_schur_symbolic(
            Float64, n2, m2, ns2, nv2, nd2, nc2,
            hess_I_nu, hess_J_nu, jac_I_nu, jac_J_nu, Int32[1, 2], Int32[],
        )
    end
end

"""
    SparseKKTSystem{T, VT, MT, QN} <: AbstractReducedKKTSystem{T, VT, MT, QN}

Implement the [`AbstractReducedKKTSystem`](@ref) in sparse COO format.

"""
struct SparseKKTSystem{T, VT, MT, QN, LS, VI, VI32} <: AbstractReducedKKTSystem{T, VT, MT, QN}
    hess::VT
    jac_callback::VT
    jac::VT
    quasi_newton::QN
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT
    # Augmented system
    aug_raw::SparseMatrixCOO{T, Int32, VT, VI32}
    aug_com::MT
    aug_csc_map::Union{Nothing, VI}
    # Hessian
    hess_raw::SparseMatrixCOO{T, Int32, VT, VI32}
    hess_com::MT
    hess_csc_map::Union{Nothing, VI}
    # Jacobian
    jac_raw::SparseMatrixCOO{T, Int32, VT, VI32}
    jac_com::MT
    jac_csc_map::Union{Nothing, VI}
    # LinearSolver
    linear_solver::LS
    # Info
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
end

# Build KKT system directly from SparseCallback
function create_kkt_system(
    ::Type{SparseKKTSystem},
    cb::SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
) where {T,VT}

    n_slack = length(cb.ind_ineq)
    # Deduce KKT size.

    n = cb.nvar
    m = cb.ncon
    # Evaluate sparsity pattern
    jac_sparsity_I = create_array(cb, Int32, cb.nnzj)
    jac_sparsity_J = create_array(cb, Int32, cb.nnzj)
    _jac_sparsity_wrapper!(cb,jac_sparsity_I, jac_sparsity_J)

    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    hess_sparsity_I, hess_sparsity_J = build_hessian_structure(cb, hessian_approximation)

    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)

    force_lower_triangular!(hess_sparsity_I,hess_sparsity_J)

    ind_ineq = cb.ind_ineq

    n_slack = length(ind_ineq)
    n_jac = length(jac_sparsity_I)
    n_hess = length(hess_sparsity_I)
    n_tot = n + n_slack

    aug_vec_length = n_tot+m
    aug_mat_length = n_tot+m+n_hess+n_jac+n_slack

    I = create_array(cb, Int32, aug_mat_length)
    J = create_array(cb, Int32, aug_mat_length)
    V = VT(undef, aug_mat_length)
    fill!(V, 0.0)  # Need to initiate V to avoid NaN

    offset = n_tot+n_jac+n_slack+n_hess+m

    I[1:n_tot] .= 1:n_tot
    I[n_tot+1:n_tot+n_hess] = hess_sparsity_I
    I[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= (jac_sparsity_I.+n_tot)
    I[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= ind_ineq .+ n_tot
    I[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

    J[1:n_tot] .= 1:n_tot
    J[n_tot+1:n_tot+n_hess] = hess_sparsity_J
    J[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= jac_sparsity_J
    J[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= (n+1:n+n_slack)
    J[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

    pr_diag = _madnlp_unsafe_wrap(V, n_tot)
    du_diag = _madnlp_unsafe_wrap(V, m, n_jac+n_slack+n_hess+n_tot+1)

    reg = VT(undef, n_tot)
    l_diag = VT(undef, nlb)
    u_diag = VT(undef, nub)
    l_lower = VT(undef, nlb)
    u_lower = VT(undef, nub)

    hess = _madnlp_unsafe_wrap(V, n_hess, n_tot+1)
    jac = _madnlp_unsafe_wrap(V, n_jac+n_slack, n_hess+n_tot+1)
    jac_callback = _madnlp_unsafe_wrap(V, n_jac, n_hess+n_tot+1)

    aug_raw = SparseMatrixCOO(aug_vec_length,aug_vec_length,I,J,V)
    jac_raw = SparseMatrixCOO(
        m, n_tot,
        Int32[jac_sparsity_I; ind_ineq],
        Int32[jac_sparsity_J; n+1:n+n_slack],
        jac,
    )

    hess_raw = SparseMatrixCOO(
        n_tot, n_tot,
        hess_sparsity_I,
        hess_sparsity_J,
        hess,
    )

    aug_com, aug_csc_map = coo_to_csc(aug_raw)
    jac_com, jac_csc_map = coo_to_csc(jac_raw)
    hess_com, hess_csc_map = coo_to_csc(hess_raw)

    _linear_solver = linear_solver(
        aug_com; opt = opt_linear_solver
    )

    return SparseKKTSystem(
        hess, jac_callback, jac, quasi_newton, reg, pr_diag, du_diag,
        l_diag, u_diag, l_lower, u_lower,
        aug_raw, aug_com, aug_csc_map,
        hess_raw, hess_com, hess_csc_map,
        jac_raw, jac_com, jac_csc_map,
        _linear_solver,
        ind_ineq, cb.ind_lb, cb.ind_ub,
    )

end

num_variables(kkt::SparseKKTSystem) = length(kkt.pr_diag)

function build_kkt!(kkt::SparseKKTSystem)
    transfer!(kkt.aug_com, kkt.aug_raw, kkt.aug_csc_map)
end

"""
    MadNLPExecutionStats{T, VT} <: AbstractExecutionStats

Store the results returned by MadNLP once the interior-point
algorithm has terminated.

"""
mutable struct MadNLPExecutionStats{T, VT} <: AbstractExecutionStats
    options::AbstractOptions
    status::Status
    solution::VT
    objective::T
    constraints::VT
    dual_feas::T
    primal_feas::T
    multipliers::VT
    multipliers_L::VT
    multipliers_U::VT
    iter::Int
    counters::MadNLPCounters
end

function MadNLPExecutionStats(solver::AbstractMadNLPSolver{T}) where {T}
    n, m = get_nvar(get_nlp(solver)), get_ncon(get_nlp(solver))
    VT = typeof(get_x0(get_nlp(solver)))
    x = similar(VT, n)
    zl = similar(VT, n)
    zu = similar(VT, n)
    c = similar(VT, m)
    unpack_cons!(c, get_cb(solver), get_c(solver))
    unpack_x!(x, get_cb(solver), variable(get_x(solver)))
    unpack_z!(zl, get_cb(solver), variable(get_zl(solver)))
    unpack_z!(zu, get_cb(solver), variable(get_zu(solver)))
    return MadNLPExecutionStats(
        get_opt(solver),
        get_status(solver),
        x,
        unpack_obj(get_cb(solver), get_obj_val(solver)),
        c,
        get_inf_du(solver),
        get_inf_pr(solver),
        copy(get_y(solver)),
        zl,
        zu,
        0,
        get_cnt(solver),
    )
end

function update!(stats::MadNLPExecutionStats, solver::AbstractMadNLPSolver)
    stats.status = get_status(solver)
    unpack_x!(stats.solution, get_cb(solver), variable(get_x(solver)))
    unpack_y!(stats.multipliers, get_cb(solver), get_y(solver))
    unpack_z!(stats.multipliers_L, get_cb(solver), variable(get_zl(solver)))
    unpack_z!(stats.multipliers_U, get_cb(solver), variable(get_zu(solver)))
    stats.objective = unpack_obj(get_cb(solver), get_obj_val(solver))
    unpack_cons!(stats.constraints, get_cb(solver), get_c(solver))
    stats.constraints .+= get_rhs(solver)
    stats.constraints[get_ind_ineq(solver)] .+= slack(get_x(solver))
    stats.dual_feas = get_inf_du(solver)
    stats.primal_feas = get_inf_pr(solver)
    update_z!(get_cb(solver), stats.solution, stats.multipliers, stats.multipliers_L, stats.multipliers_U, get_jacl(solver))
    stats.iter = get_cnt(solver).k
    return stats
end

get_counters(nlp::NLPModels.AbstractNLPModel) = nlp.counters
get_counters(nlp::NLPModels.AbstractNLSModel) = nlp.counters.counters
getStatus(result::MadNLPExecutionStats) = get_status_output(result.status, result.options)

# Exceptions
struct InvalidNumberException <: Exception
    callback::Symbol
end
struct NotEnoughDegreesOfFreedomException <: Exception end

# Utilities
has_constraints(solver) = get_m(solver) != 0

@inline function count_lu_bounds(lb::AbstractVector, ub::AbstractVector)
    num_lu_bounds = 0
    num_le_bounds = 0
    num_ue_bounds = 0
    for ii in eachindex(lb)
        if (lb[ii] !=-Inf) && (ub[ii] != Inf)
            num_lu_bounds += 1
        elseif (lb[ii] == -Inf)
            num_ue_bounds += 1
        elseif (ub[ii] == Inf)
            num_le_bounds += 1
        end
    end
    return num_lu_bounds, num_le_bounds, num_ue_bounds
end


function get_vars_info(solver::AbstractMadNLPSolver)
    nlp = get_nlp(solver)

    x_lb = get_lvar(nlp)
    x_ub = get_uvar(nlp)
    num_fixed = length(get_ind_fixed(solver))
    num_var = get_nvar(nlp) - num_fixed
    num_llb_vars = length(get_ind_llb(solver))

    num_lu_vars,_,_ = count_lu_bounds(x_lb, x_ub)
    num_lu_vars = num_lu_vars - num_fixed
    num_uub_vars = length(get_ind_uub(solver))
    return (
        n_free=num_var,
        n_fixed=num_fixed,
        n_only_lb=num_llb_vars,
        n_only_ub=num_uub_vars,
        n_bounded=num_lu_vars,
    )
end

function get_cons_info(solver::AbstractMadNLPSolver)
    nlp = get_nlp(solver)

    g_lb = get_lcon(nlp)
    g_ub = get_ucon(nlp)

    num_eq_cons = length(solver.cb.ind_eq)
    num_ineq_cons = length(solver.cb.ind_ineq)
    _,num_le_cons,num_ue_cons = count_lu_bounds(g_lb, g_ub)
    num_lu_cons = num_ineq_cons - num_le_cons - num_ue_cons

    return (
        n_eq=num_eq_cons,
        n_ineq=num_ineq_cons,
        n_only_lb=num_le_cons,
        n_only_ub=num_ue_cons,
        n_bounded=num_lu_cons,
    )
end

# Print functions -----------------------------------------------------------
function print_init(solver::AbstractMadNLPSolver)
    @notice(get_logger(solver),@sprintf("Number of nonzeros in constraint Jacobian............: %8i", get_nnzj(get_nlp(solver).meta)))
    @notice(get_logger(solver),@sprintf("Number of nonzeros in Lagrangian Hessian.............: %8i\n", get_nnzh(get_nlp(solver).meta)))
    var_info = get_vars_info(solver)
    con_info = get_cons_info(solver)

    if get_nvar(get_nlp(solver)) < con_info.n_eq
        throw(NotEnoughDegreesOfFreedomException())
    end

    @notice(get_logger(solver),@sprintf("Total number of variables............................: %8i",var_info.n_free))
    @notice(get_logger(solver),@sprintf("                     variables with only lower bounds: %8i",var_info.n_only_lb))
    @notice(get_logger(solver),@sprintf("                variables with lower and upper bounds: %8i",var_info.n_bounded))
    @notice(get_logger(solver),@sprintf("                     variables with only upper bounds: %8i",var_info.n_only_ub))
    @notice(get_logger(solver),@sprintf("Total number of equality constraints.................: %8i",con_info.n_eq))
    @notice(get_logger(solver),@sprintf("Total number of inequality constraints...............: %8i",con_info.n_ineq))
    @notice(get_logger(solver),@sprintf("        inequality constraints with only lower bounds: %8i",con_info.n_only_lb))
    @notice(get_logger(solver),@sprintf("   inequality constraints with lower and upper bounds: %8i",con_info.n_bounded))
    @notice(get_logger(solver),@sprintf("        inequality constraints with only upper bounds: %8i\n",con_info.n_only_ub))
    return
end

function print_iter(solver::AbstractMadNLPSolver; is_resto=false)
    obj_scale = get_cb(solver).obj_scale[]
    mod(get_cnt(solver).k,10)==0&& @info(get_logger(solver),@sprintf(
        "iter    objective    inf_pr   inf_du inf_compl lg(mu) lg(rg) alpha_pr ir ls"))
    if is_resto
        RR = get_RR(solver)::RobustRestorer
        inf_du = RR.inf_du_R
        inf_pr = RR.inf_pr_R
        inf_compl = RR.inf_compl_R
        mu = log10(RR.mu_R)
    else
        inf_du = get_inf_du(solver)
        inf_pr = get_inf_pr(solver)
        inf_compl = get_inf_compl(solver)
        mu = log10(get_mu(solver))
    end
    @info(get_logger(solver),@sprintf(
        "%4i%s% 10.7e %6.2e %6.2e %7.2e %5.1f  %s  %6.2e %2i %2i%s",
        get_cnt(solver).k,is_resto ? "r" : " ",get_obj_val(solver)/obj_scale,
        inf_pr, inf_du, inf_compl, mu,
        # get_cnt(solver).k == 0 ? 0. : norm(primal(get_d(solver)),Inf),
        get_del_w(solver) == 0 ? "   - " : @sprintf("%5.1f",log(10,get_del_w(solver))),
        get_alpha(solver),
        get_cnt(solver).ir,
        get_cnt(solver).l,
        get_ftype(solver),))
    return
end

function print_summary(solver::AbstractMadNLPSolver)
    # TODO inquire this from nlpmodel wrapper
    obj_scale = get_cb(solver).obj_scale[]
    get_cnt(solver).solver_time = get_cnt(solver).total_time-get_cnt(solver).linear_solver_time-get_cnt(solver).eval_function_time

    @notice(get_logger(solver),"")
    @notice(get_logger(solver),"Number of Iterations....: $(get_cnt(solver).k)\n")
    @notice(get_logger(solver),"                                   (scaled)                 (unscaled)")
    @notice(get_logger(solver),@sprintf("Objective...............:  % 1.16e   % 1.16e",get_obj_val(solver),get_obj_val(solver)/obj_scale))
    @notice(get_logger(solver),@sprintf("Dual infeasibility......:   %1.16e    %1.16e",get_inf_du(solver),get_inf_du(solver)/obj_scale))
    @notice(get_logger(solver),@sprintf("Constraint violation....:   %1.16e    %1.16e",norm(get_c(solver),Inf),get_inf_pr(solver)))
    @notice(get_logger(solver),@sprintf("Complementarity.........:   %1.16e    %1.16e",
                                get_inf_compl(solver)*obj_scale,get_inf_compl(solver)))
    @notice(get_logger(solver),@sprintf("Overall NLP error.......:   %1.16e    %1.16e\n",
                                max(get_inf_du(solver)*obj_scale,norm(get_c(solver),Inf),get_inf_compl(solver)),
                                max(get_inf_du(solver),get_inf_pr(solver),get_inf_compl(solver))))

    @notice(get_logger(solver),"Number of objective function evaluations              = $(get_cnt(solver).obj_cnt)")
    @notice(get_logger(solver),"Number of objective gradient evaluations              = $(get_cnt(solver).obj_grad_cnt)")
    @notice(get_logger(solver),"Number of constraint evaluations                      = $(get_cnt(solver).con_cnt)")
    @notice(get_logger(solver),"Number of constraint Jacobian evaluations             = $(get_cnt(solver).con_jac_cnt)")
    @notice(get_logger(solver),"Number of Lagrangian Hessian evaluations              = $(get_cnt(solver).lag_hess_cnt)")
    @notice(get_logger(solver),"Number of KKT factorizations                          = $(get_cnt(solver).factorization_cnt)")
    @notice(get_logger(solver),"Number of KKT backsolves                              = $(get_cnt(solver).backsolve_cnt)\n")
    @notice(get_logger(solver),"Total wall secs in initialization                     = $(format_time(get_cnt(solver).init_time))")
    @notice(get_logger(solver),"Total wall secs in linear solver                      = $(format_time(get_cnt(solver).linear_solver_time))")
    @notice(get_logger(solver),"Total wall secs in NLP function evaluations           = $(format_time(get_cnt(solver).eval_function_time))")
    @notice(get_logger(solver),"Total wall secs in solver (w/o init./fun./lin. alg.)  = $(format_time(get_cnt(solver).total_time - get_cnt(solver).init_time - get_cnt(solver).linear_solver_time - get_cnt(solver).eval_function_time))")
    @notice(get_logger(solver),"Total wall secs                                       = $(format_time(get_cnt(solver).total_time))\n")
end

format_time(t::Float64) = isnan(t) ? " unavailable" : @sprintf("%6.3f s", t)

function string(solver::AbstractMadNLPSolver)
    """
                Interior point solver

                number of variables......................: $(get_nvar(get_nlp(solver)))
                number of constraints....................: $(get_ncon(get_nlp(solver)))
                number of nonzeros in Lagrangian Hessian.: $(get_nnzh(get_nlp(solver).meta))
                number of nonzeros in constraint Jacobian: $(get_nnzj(get_nlp(solver).meta))
                status...................................: $(get_status(solver))
                """
end
print(io::IO,solver::AbstractMadNLPSolver) = print(io, string(solver))
show(io::IO,solver::AbstractMadNLPSolver) = print(io,solver)

mutable struct LapackROCmSolver{T, MT, Alg} <: MadNLP.AbstractLapackSolver{T, Alg}
    A::MT
    fact::ROCMatrix{T}
    n::Int64
    sol::ROCVector{T}
    tau::ROCVector{T}
    Λ::ROCVector{T}
    info::ROCVector{Cint}
    ipiv::ROCVector{Int64}
    alpha::Base.RefValue{T}
    beta::Base.RefValue{T}
    opt::MadNLP.LapackOptions
    logger::MadNLP.MadNLPLogger

    function LapackROCmSolver(
        A::MT;
        option_dict::Dict{Symbol,Any} = Dict{Symbol,Any}(),
        opt = MadNLP.LapackOptions(),
        logger = MadNLP.MadNLPLogger(),
        kwargs...,
    ) where {MT<:AbstractMatrix}
        MadNLP.set_options!(opt, option_dict, kwargs...)
        T = eltype(A)
        m,n = size(A)
        @assert m == n
        fact = ROCMatrix{T}(undef, m, n)
        sol = ROCVector{T}(undef, 0)
        tau = ROCVector{T}(undef, 0)
        Λ = ROCVector{T}(undef, 0)
        info = ROCVector{Cint}(undef, 1)
        ipiv = ROCVector{Int64}(undef, 0)
        alpha = Ref{T}(1)
        beta = Ref{T}(0)
        alg = opt.lapack_algorithm
        solver = new{T, MT, alg}(A, fact, n, sol, tau, Λ, info, ipiv, alpha, beta, opt, logger)
        MadNLP.setup!(solver)
        return solver
    end
end

MadNLP.transfer_matrix!(M::LapackROCmSolver) = MadNLPGPU.gpu_transfer!(M.fact, M.A)
MadNLP._get_info(M::LapackROCmSolver) = sum(M.info)
MadNLP.default_options(::Type{LapackROCmSolver}) = MadNLP.LapackOptions(MadNLP.EVD)
MadNLP.introduce(M::LapackROCmSolver) = "rocSOLVER v$(rocSOLVER.version()) -- ($(M.opt.lapack_algorithm))"
MadNLP.solve!(M::LapackROCmSolver{T}, x::ROCVector{T}) where {T} = MadNLP._solve!(M, x)

for (potrf, potrs, T) in
    ((:rocsolver_dpotrf_64, :rocsolver_dpotrs_64, :Float64),
     (:rocsolver_spotrf_64, :rocsolver_spotrs_64, :Float32))
    @eval begin
        MadNLP.setup_cholesky!(M::LapackROCmSolver{$T}) = M

        function MadNLP.factorize_cholesky!(M::LapackROCmSolver{$T})
            rocSOLVER.$potrf(
                rocBLAS.handle(),
                rocBLAS.rocblas_fill_lower,
                M.n,
                M.fact,
                M.n,
                M.info,
            )
            return M
        end

        function MadNLP.solve_cholesky!(M::LapackROCmSolver{$T}, x::ROCVector{$T})
            rocSOLVER.$potrs(
                rocBLAS.handle(),
                rocBLAS.rocblas_fill_lower,
                M.n,
                one(Int64),
                M.fact,
                M.n,
                x,
                M.n,
            )
            return x
        end
    end
end

for (getrf, getrs, T) in
    ((:rocsolver_dgetrf_64, :rocsolver_dgetrs_64, :Float64),
     (:rocsolver_sgetrf_64, :rocsolver_sgetrs_64, :Float32))
    @eval begin
        function MadNLP.setup_lu!(M::LapackROCmSolver{$T})
            resize!(M.ipiv, M.n)
            return M
        end

        function MadNLP.factorize_lu!(M::LapackROCmSolver{$T})
            rocSOLVER.$getrf(
                rocBLAS.handle(),
                M.n,
                M.n,
                M.fact,
                M.n,
                M.ipiv,
                M.info,
            )
            return M
        end

        function MadNLP.solve_lu!(M::LapackROCmSolver{$T}, x::ROCVector{$T})
            rocSOLVER.$getrs(
                rocBLAS.handle(),
                rocBLAS.rocblas_operation_none,
                M.n,
                one(Int64),
                M.fact,
                M.n,
                M.ipiv,
                x,
                M.n,
            )
            return x
        end
    end
end

for (geqrf, ormqr, trsv, T) in
    ((:rocsolver_dgeqrf_64, :rocsolver_dormqr, :rocblas_dtrsv_64, :Float64),
     (:rocsolver_sgeqrf_64, :rocsolver_sormqr, :rocblas_strsv_64, :Float32))
    @eval begin
        function MadNLP.setup_qr!(M::LapackROCmSolver{$T})
            resize!(M.tau, M.n)
            return M
        end

        function MadNLP.factorize_qr!(M::LapackROCmSolver{$T})
            rocSOLVER.$geqrf(
                rocBLAS.handle(),
                M.n,
                M.n,
                M.fact,
                M.n,
                M.tau,
            )
            return M
        end

        function MadNLP.solve_qr!(M::LapackROCmSolver{$T}, x::ROCVector{$T})
            rocSOLVER.$ormqr(
                rocBLAS.handle(),
                rocBLAS.rocblas_side_left,
                rocBLAS.rocblas_operation_transpose,
                Cint(M.n),
                Cint(1),
                Cint(M.n),
                M.fact,
                Cint(M.n),
                M.tau,
                x,
                Cint(M.n),
            )
            rocBLAS.$trsv(
                rocBLAS.handle(),
                rocBLAS.rocblas_fill_upper,
                rocBLAS.rocblas_operation_none,
                rocBLAS.rocblas_diagonal_non_unit,
                M.n,
                M.fact,
                M.n,
                x,
                one(Int64),
            )
            return x
        end
    end
end

for (syevd, gemv, T) in
    ((:rocsolver_dsyevd, :rocblas_dgemv_64, :Float64),
     (:rocsolver_ssyevd, :rocblas_sgemv_64, :Float32))
    @eval begin
        function MadNLP.setup_evd!(M::LapackROCmSolver{$T})
            resize!(M.tau, M.n)
            resize!(M.Λ, M.n)
            return M
        end

        function MadNLP.factorize_evd!(M::LapackROCmSolver{$T})
            rocSOLVER.$syevd(
                rocBLAS.handle(),
                rocSOLVER.rocblas_evect_original,
                rocBLAS.rocblas_fill_lower,
                Cint(M.n),
                M.fact,
                Cint(M.n),
                M.Λ,
                M.tau,
                M.info,
            )
            return M
        end

        function MadNLP.solve_evd!(M::LapackROCmSolver{$T}, x::ROCVector{$T})
            rocBLAS.$gemv(
                rocBLAS.handle(),
                rocBLAS.rocblas_operation_transpose,
                M.n,
                M.n,
                M.alpha,
                M.fact,
                M.n,
                x,
                one(Int64),
                M.beta,
                M.tau,
                one(Int64),
            )
            M.tau ./= M.Λ
            rocBLAS.$gemv(
                rocBLAS.handle(),
                rocBLAS.rocblas_operation_none,
                M.n,
                M.n,
                M.alpha,
                M.fact,
                M.n,
                M.tau,
                one(Int64),
                M.beta,
                x,
                one(Int64),
            )
            return x
        end
    end
end

"""
    DenseCondensedKKTSystem{T, VT, MT, QN} <: AbstractCondensedKKTSystem{T, VT, MT, QN}

Implement [`AbstractCondensedKKTSystem`](@ref) with dense matrices.

Requires a dense linear solver to factorize the associated KKT system (otherwise an error is returned).

"""
struct DenseCondensedKKTSystem{
    T,
    VT <: AbstractVector{T},
    MT <: AbstractMatrix{T},
    QN,
    LS,
    VI <: AbstractVector{Int}
    } <: AbstractCondensedKKTSystem{T, VT, MT, QN}

    hess::MT
    jac::MT
    quasi_newton::QN
    jac_ineq::MT

    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT

    pd_buffer::VT
    diag_buffer::VT
    buffer::VT
    # KKT system
    aug_com::MT
    # Info
    n_eq::Int
    ind_eq::VI
    ind_eq_shifted::VI
    n_ineq::Int
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
    ind_ineq_shifted::VI
    # Linear Solver
    linear_solver::LS
    # Buffers
    etc::Dict{Symbol, Any}
end

function create_kkt_system(
    ::Type{DenseCondensedKKTSystem},
    cb::AbstractCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
) where {T, VT}

    n = cb.nvar
    m = cb.ncon
    ns = length(cb.ind_ineq)
    n_eq = m - ns
    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)

    aug_com  = create_array(cb, n+m-ns, n+m-ns)
    hess     = create_array(cb, n, n)
    jac      = create_array(cb, m, n)
    jac_ineq = create_array(cb, ns, n)

    reg  = VT(undef, n+ns)
    pr_diag  = VT(undef, n+ns)
    du_diag  = VT(undef, m)
    l_diag = fill!(VT(undef, nlb), one(T))
    u_diag = fill!(VT(undef, nub), one(T))
    l_lower = fill!(VT(undef, nlb), zero(T))
    u_lower = fill!(VT(undef, nub), zero(T))

    pd_buffer = VT(undef, n + n_eq)
    diag_buffer = VT(undef, ns)
    buffer = VT(undef, m)

    # Init!
    fill!(aug_com, zero(T))
    fill!(hess,    zero(T))
    fill!(jac,     zero(T))
    fill!(pr_diag, zero(T))
    fill!(du_diag, zero(T))

    # Shift indexes to avoid additional allocation in views
    ind_eq_shifted = cb.ind_eq .+ n .+ ns
    ind_ineq_shifted = cb.ind_ineq .+ n .+ ns

    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    _linear_solver = linear_solver(aug_com; opt = opt_linear_solver)

    return DenseCondensedKKTSystem(
        hess, jac, quasi_newton, jac_ineq,
        reg, pr_diag, du_diag, l_diag, u_diag, l_lower, u_lower,
        pd_buffer, diag_buffer, buffer,
        aug_com,
        n_eq, cb.ind_eq, ind_eq_shifted,
        ns,
        cb.ind_ineq, cb.ind_lb, cb.ind_ub,
        ind_ineq_shifted,
        _linear_solver,
        Dict{Symbol, Any}(),
    )
end

num_variables(kkt::DenseCondensedKKTSystem) = size(kkt.hess, 1)

function get_slack_regularization(kkt::DenseCondensedKKTSystem)
    n, ns = num_variables(kkt), kkt.n_ineq
    return view(kkt.pr_diag, n+1:n+ns)
end

function _build_condensed_kkt_system!(
    dest::AbstractMatrix, hess::AbstractMatrix, jac::AbstractMatrix,
    pr_diag::AbstractVector, du_diag::AbstractVector, ind_eq::AbstractVector, n, m_eq,
)
    # Transfer Hessian
    @inbounds for i in 1:n, j in 1:i
        if i == j
            dest[i, i] += pr_diag[i] + hess[i, i]
        else
            dest[i, j] += hess[i, j]
            dest[j, i] += hess[j, i]
        end
    end
    # Transfer Jacobian / variables
    @inbounds for i in 1:m_eq, j in 1:n
        is = ind_eq[i]
        dest[i + n, j] = jac[is, j]
        dest[j, i + n] = jac[is, j]
    end
    # Transfer dual regularization
    @inbounds for i in 1:m_eq
        is = ind_eq[i]
        dest[i + n, i + n] = du_diag[is]
    end
end

function _build_ineq_jac!(
    dest::AbstractMatrix, jac::AbstractMatrix, diag_buffer::AbstractVector,
    ind_ineq::AbstractVector,
    n, m_ineq,
)
    @inbounds for i in 1:m_ineq, j in 1:n
        is = ind_ineq[i]
        dest[i, j] = jac[is, j] * sqrt(diag_buffer[i])
    end
end

function build_kkt!(kkt::DenseCondensedKKTSystem{T, VT, MT}) where {T, VT, MT}
    n = size(kkt.hess, 1)
    ns = kkt.n_ineq
    n_eq = length(kkt.ind_eq)
    m = size(kkt.jac, 1)

    fill!(kkt.aug_com, zero(T))

    # Build √Σₛ * J
    Σs = view(kkt.pr_diag, n+1:n+ns)
    Σd = @view(kkt.du_diag[kkt.ind_ineq])
    kkt.diag_buffer .= Σs ./ ( 1 .- Σd .* Σs)
    _build_ineq_jac!(kkt.jac_ineq, kkt.jac, kkt.diag_buffer, kkt.ind_ineq, n, ns)

    # Select upper-left block
    W = if n_eq > 0
        view(kkt.aug_com, 1:n, 1:n) # TODO: does not work on GPU
    else
        kkt.aug_com
    end
    # Build J' * Σₛ * J
    mul!(W, kkt.jac_ineq', kkt.jac_ineq)


    _build_condensed_kkt_system!(
        kkt.aug_com, kkt.hess, kkt.jac,
        kkt.pr_diag, kkt.du_diag,
        kkt.ind_eq, n, kkt.n_eq,
    )
end

# TODO: check how to handle inertia with the condensed form
function is_inertia_correct(kkt::DenseCondensedKKTSystem, num_pos, num_zero, num_neg)
    return (num_zero == 0 && num_neg == kkt.n_eq)
end

# For inertia-free regularization
function _mul_expanded!(y::AbstractVector, kkt::DenseCondensedKKTSystem{T}, x::AbstractVector) where T
    n = size(kkt.hess, 1)
    ns = kkt.n_ineq
    m = size(kkt.jac, 1)

    Σx = view(kkt.pr_diag, 1:n)
    Σs = view(kkt.pr_diag, 1+n:n+ns)
    Σd = kkt.du_diag

    # Decompose x
    xx = view(x, 1:n)
    xs = view(x, 1+n:n+ns)
    xy = view(x, 1+n+ns:n+ns+m)

    # Decompose y
    yx = view(y, 1:n)
    ys = view(y, 1+n:n+ns)
    yy = view(y, 1+n+ns:n+ns+m)

    # / x (variable)
    yx .= Σx .* xx
    _symv!('L', one(T), kkt.hess, xx, zero(T), yx)
    mul!(yx, kkt.jac', xy, one(T), one(T))

    # / s (slack)
    ys .= Σs .* xs
    ys .-= xy[kkt.ind_ineq]

    # / y (multiplier)
    yy .= Σd .* xy
    mul!(yy, kkt.jac, xx, one(T), one(T))
    yy[kkt.ind_ineq] .-= xs
    return
end

function mul!(y::AbstractVector, kkt::DenseCondensedKKTSystem{T}, x::AbstractVector) where T
    # TODO: implement properly with AbstractKKTRHS
    if length(y) == length(x) == size(kkt.aug_com, 1)
        _symv!('L', one(T), kkt.aug_com, x, zero(T), y)
    else
        _mul_expanded!(y, kkt, x)
    end
end

function jprod_ineq!(y::AbstractVector, kkt::DenseCondensedKKTSystem, x::AbstractVector)
    mul!(y, kkt.jac_ineq, x)
end

# Shared methods for all LAPACK-based dense linear solvers.
# Each backend (CPU, CUDA, ROCm, oneAPI) subtypes AbstractLapackSolver
# and provides per-algorithm primitives (setup_*/factorize_*/solve_*).

# Per-algorithm primitives that each backend must implement.
function setup_cholesky! end
function setup_lu! end
function setup_qr! end
function setup_evd! end
function setup_bunchkaufman! end
function factorize_cholesky! end
function factorize_lu! end
function factorize_qr! end
function factorize_evd! end
function factorize_bunchkaufman! end
function solve_cholesky! end
function solve_lu! end
function solve_qr! end
function solve_evd! end
function solve_bunchkaufman! end

"""
    transfer_matrix!(M::AbstractLapackSolver)

Copy the matrix `M.A` into the factorization buffer `M.fact`.
GPU backends override this to use `gpu_transfer!`.
"""
transfer_matrix!(M::AbstractLapackSolver) = copyto!(M.fact, M.A)

"""
    supports_bunchkaufman_inertia(M::AbstractLapackSolver)

Return `true` if the solver supports inertia computation for Bunch-Kaufman.
Only the CPU backend overrides this to `true`.
"""
supports_bunchkaufman_inertia(::AbstractLapackSolver) = false

"""
    _get_info(M::AbstractLapackSolver)

Return the scalar info value from the factorization.
CPU uses `M.info[]` (Ref); GPU backends override to `sum(M.info)`.
"""
_get_info(M::AbstractLapackSolver) = M.info[]

# setup! dispatch
setup!(M::AbstractLapackSolver{T, BUNCHKAUFMAN}) where {T} = setup_bunchkaufman!(M)
setup!(M::AbstractLapackSolver{T, LU}) where {T} = setup_lu!(M)
setup!(M::AbstractLapackSolver{T, QR}) where {T} = setup_qr!(M)
setup!(M::AbstractLapackSolver{T, CHOLESKY}) where {T} = setup_cholesky!(M)
setup!(M::AbstractLapackSolver{T, EVD}) where {T} = setup_evd!(M)

# factorize! dispatch
factorize!(M::AbstractLapackSolver{T, BUNCHKAUFMAN}) where {T} = (transfer_matrix!(M); factorize_bunchkaufman!(M))
function factorize!(M::AbstractLapackSolver{T, LU}) where {T}
    transfer_matrix!(M)
    tril_to_full!(M.fact)
    return factorize_lu!(M)
end
function factorize!(M::AbstractLapackSolver{T, QR}) where {T}
    transfer_matrix!(M)
    tril_to_full!(M.fact)
    return factorize_qr!(M)
end
factorize!(M::AbstractLapackSolver{T, CHOLESKY}) where {T} = (transfer_matrix!(M); factorize_cholesky!(M))
factorize!(M::AbstractLapackSolver{T, EVD}) where {T} = (transfer_matrix!(M); factorize_evd!(M))

# solve! dispatch
_solve!(M::AbstractLapackSolver{T, BUNCHKAUFMAN}, x) where {T} = solve_bunchkaufman!(M, x)
_solve!(M::AbstractLapackSolver{T, LU}, x) where {T} = solve_lu!(M, x)
_solve!(M::AbstractLapackSolver{T, QR}, x) where {T} = solve_qr!(M, x)
_solve!(M::AbstractLapackSolver{T, CHOLESKY}, x) where {T} = solve_cholesky!(M, x)
_solve!(M::AbstractLapackSolver{T, EVD}, x) where {T} = solve_evd!(M, x)

function solve_linear_system!(M::AbstractLapackSolver, x::AbstractVector)
    isempty(M.sol) && resize!(M.sol, M.n)
    copyto!(M.sol, x)
    _solve!(M, M.sol)
    copyto!(x, M.sol)
    return x
end

improve!(M::AbstractLapackSolver) = false
input_type(::Type{<:AbstractLapackSolver}) = :dense
default_options(::Type{<:AbstractLapackSolver}) = LapackOptions()

for T in (:Float32, :Float64)
    @eval is_supported(::Type{<:AbstractLapackSolver}, ::Type{$T}) = true
end

is_inertia(::AbstractLapackSolver) = false
is_inertia(::AbstractLapackSolver{T, CHOLESKY}) where {T} = true
is_inertia(::AbstractLapackSolver{T, EVD}) where {T} = true
is_inertia(M::AbstractLapackSolver{T, BUNCHKAUFMAN}) where {T} = supports_bunchkaufman_inertia(M)

inertia(M::AbstractLapackSolver{T, CHOLESKY}) where {T} = inertia_cholesky(M)
inertia(M::AbstractLapackSolver{T, EVD}) where {T} = inertia_evd(M)
inertia(M::AbstractLapackSolver{T, BUNCHKAUFMAN}) where {T} = inertia_bunchkaufman(M)

function inertia_cholesky(M::AbstractLapackSolver)
    return _get_info(M) == 0 ? (M.n, 0, 0) : (0, M.n, 0)
end

function inertia_evd(M::AbstractLapackSolver)
    numpos = count(λ -> λ > 0, M.Λ)
    numneg = count(λ -> λ < 0, M.Λ)
    numzero = M.n - numpos - numneg
    return (numpos, numzero, numneg)
end

const _PARAMETER_OFFSET = 0x00f0000000000000

_is_parameter(x::MOI.VariableIndex) = x.value >= _PARAMETER_OFFSET
_is_parameter(term::MOI.ScalarAffineTerm) = _is_parameter(term.variable)
_is_parameter(term::MOI.ScalarQuadraticTerm) = _is_parameter(term.variable_1) || _is_parameter(term.variable_2)

mutable struct _VectorNonlinearOracleCache
    set::MOI.VectorNonlinearOracle{Float64}
    x::Vector{Float64}
    J_nzval::Vector{Float64}
    start::Union{Nothing,Vector{Float64}}
    eval_f_timer::Float64
    eval_jacobian_timer::Float64
    eval_hessian_lagrangian_timer::Float64

    function _VectorNonlinearOracleCache(set::MOI.VectorNonlinearOracle{Float64})
        nnzJ = length(set.jacobian_structure)
        return new(set, zeros(set.input_dimension), zeros(nnzJ), nothing, 0.0, 0.0, 0.0)
    end
end

"""
    Optimizer()

Create a new MadNLP optimizer.
"""
mutable struct Optimizer <: MOI.AbstractOptimizer
    solver::Union{Nothing,MadNLP.MadNLPSolver}
    nlp::Union{Nothing,NLPModels.AbstractNLPModel}
    result::Union{Nothing,MadNLP.MadNLPExecutionStats{Float64}}

    name::String
    invalid_model::Bool
    silent::Bool
    options::Dict{Symbol,Any}
    solve_time::Float64
    solve_iterations::Int
    sense::MOI.OptimizationSense

    parameters::Dict{MOI.VariableIndex,MOI.Nonlinear.ParameterIndex}
    variables::MOI.Utilities.VariablesContainer{Float64}
    list_of_variable_indices::Vector{MOI.VariableIndex}
    variable_primal_start::Vector{Union{Nothing,Float64}}

    nlp_data::MOI.NLPBlockData
    nlp_dual_start::Union{Nothing,Vector{Float64}}
    mult_g_nlp::Dict{MOI.Nonlinear.ConstraintIndex,Float64}

    qp_data::QPBlockData{Float64}
    nlp_model::Union{Nothing,MOI.Nonlinear.Model}
    ad_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation
    vector_nonlinear_oracle_constraints::Vector{Tuple{MOI.VectorOfVariables,_VectorNonlinearOracleCache}}

    jrows::Vector{Int}
    jcols::Vector{Int}
    hrows::Vector{Int}
    hcols::Vector{Int}
    needs_new_nlp::Bool
    has_only_linear_constraints::Bool
    islp::Bool
    jprod_available::Bool
    hprod_available::Bool
    hess_available::Bool
end

function Optimizer(; kwargs...)
    option_dict = Dict{Symbol, Any}()
    for (name, value) in kwargs
        option_dict[name] = value
    end
    return Optimizer(
        nothing,
        nothing,
        nothing,
        "",
        false,
        false,
        option_dict,
        NaN,
        0,
        MOI.FEASIBILITY_SENSE,
        Dict{MOI.VariableIndex,Float64}(),
        MOI.Utilities.VariablesContainer{Float64}(),
        MOI.VariableIndex[],
        Union{Nothing,Float64}[],
        MOI.NLPBlockData([], _EmptyNLPEvaluator(), false),
        nothing,
        Dict{MOI.Nonlinear.ConstraintIndex,Float64}(),
        QPBlockData{Float64}(),
        nothing,
        MOI.Nonlinear.SparseReverseMode(),
        Tuple{MOI.VectorOfVariables,_VectorNonlinearOracleCache}[],
        Int[],
        Int[],
        Int[],
        Int[],
        true,
        false,
        false,
        false,
        false,
        false,
    )
end

const _SETS = Union{
    MOI.GreaterThan{Float64},
    MOI.LessThan{Float64},
    MOI.EqualTo{Float64},
    MOI.Interval{Float64},
}

const _FUNCTIONS = Union{
    MOI.ScalarAffineFunction{Float64},
    MOI.ScalarQuadraticFunction{Float64},
    MOI.ScalarNonlinearFunction,
}

MOI.get(::Optimizer, ::MOI.SolverVersion) = MadNLP.version()

### _EmptyNLPEvaluator

struct _EmptyNLPEvaluator <: MOI.AbstractNLPEvaluator end

MOI.features_available(::_EmptyNLPEvaluator) = [:Grad, :Jac, :Hess, :JacVec, :HessVec]
MOI.initialize(::_EmptyNLPEvaluator, ::Any) = nothing
MOI.eval_constraint(::_EmptyNLPEvaluator, g, x) = nothing
MOI.jacobian_structure(::_EmptyNLPEvaluator) = Tuple{Int64,Int64}[]
MOI.hessian_lagrangian_structure(::_EmptyNLPEvaluator) = Tuple{Int64,Int64}[]
MOI.eval_constraint_jacobian(::_EmptyNLPEvaluator, J, x) = nothing
MOI.eval_hessian_lagrangian(::_EmptyNLPEvaluator, H, x, σ, μ) = nothing
MOI.eval_constraint_jacobian_product(d::_EmptyNLPEvaluator, Jv, x, v) = nothing
MOI.eval_constraint_jacobian_transpose_product(::_EmptyNLPEvaluator, Jtv, x, v) = nothing
MOI.eval_hessian_lagrangian_product(::_EmptyNLPEvaluator, Hv, x, v, σ, μ) = nothing

function MOI.empty!(model::Optimizer)
    model.solver = nothing
    model.nlp = nothing
    model.result = nothing
    model.invalid_model = false
    model.solve_time = NaN
    model.solve_iterations = 0
    model.sense = MOI.FEASIBILITY_SENSE
    empty!(model.parameters)
    MOI.empty!(model.variables)
    empty!(model.list_of_variable_indices)
    empty!(model.variable_primal_start)
    model.nlp_data = MOI.NLPBlockData([], _EmptyNLPEvaluator(), false)
    model.nlp_dual_start = nothing
    empty!(model.mult_g_nlp)
    model.qp_data = QPBlockData{Float64}()
    model.nlp_model = nothing
    # SKIP: model.ad_backend
    empty!(model.vector_nonlinear_oracle_constraints)
    empty!(model.jrows)
    empty!(model.jcols)
    empty!(model.hrows)
    empty!(model.hcols)
    model.needs_new_nlp = true
    model.has_only_linear_constraints = false
    model.islp = false
    model.jprod_available = false
    model.hprod_available = false
    model.hess_available = false
    return
end

function MOI.is_empty(model::Optimizer)
    return MOI.is_empty(model.variables) &&
           isempty(model.variable_primal_start) &&
           model.nlp_data.evaluator isa _EmptyNLPEvaluator &&
           model.sense == MOI.FEASIBILITY_SENSE &&
           isempty(model.vector_nonlinear_oracle_constraints)
end

MOI.supports_incremental_interface(::Optimizer) = true

function MOI.copy_to(model::Optimizer, src::MOI.ModelLike)
    return MOI.Utilities.default_copy_to(model, src)
end

MOI.get(::Optimizer, ::MOI.SolverName) = "MadNLP"

function _init_nlp_model(model)
    if model.nlp_model === nothing
        if !(model.nlp_data.evaluator isa _EmptyNLPEvaluator)
            error("Cannot mix the new and legacy nonlinear APIs")
        end
        model.nlp_model = MOI.Nonlinear.Model()
    end
    return
end

function MOI.supports_add_constrained_variable(
    ::Optimizer,
    ::Type{MOI.Parameter{Float64}},
)
    return true
end

function MOI.add_constrained_variable(
    model::Optimizer,
    set::MOI.Parameter{Float64},
)
    _init_nlp_model(model)
    p = MOI.VariableIndex(_PARAMETER_OFFSET + length(model.parameters))
    push!(model.list_of_variable_indices, p)
    model.parameters[p] =
        MOI.Nonlinear.add_parameter(model.nlp_model, set.value)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,typeof(set)}(p.value)
    return p, ci
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex, MOI.Parameter{Float64}}
)
    p = MOI.VariableIndex(ci.value)
    return haskey(model.parameters, MOI.VariableIndex(ci.value))
end

function MOI.get(
    model::Optimizer,
    ::MOI.ListOfConstraintIndices{F,S},
) where {F<:MOI.VariableIndex,S<:MOI.Parameter{Float64}}
    ret = [MOI.ConstraintIndex{F,S}(p.value) for p in keys(model.parameters)]
    sort!(ret; by = x -> x.value)
    return ret
end

function MOI.get(
    model::Optimizer,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Parameter{Float64}},
)
    return length(model.parameters)
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Parameter{Float64}},
    set::MOI.Parameter{Float64},
)
    p = model.parameters[MOI.VariableIndex(ci.value)]
    model.nlp_model[p] = set.value
    return
end

_replace_parameters(model::Optimizer, f) = f

function _replace_parameters(model::Optimizer, f::MOI.VariableIndex)
    if _is_parameter(f)
        return model.parameters[f]
    end
    return f
end

function _replace_parameters(model::Optimizer, f::MOI.ScalarAffineFunction)
    if any(_is_parameter, f.terms)
        g = convert(MOI.ScalarNonlinearFunction, f)
        return _replace_parameters(model, g)
    end
    return f
end

function _replace_parameters(model::Optimizer, f::MOI.ScalarQuadraticFunction)
    if any(_is_parameter, f.affine_terms) ||
       any(_is_parameter, f.quadratic_terms)
        g = convert(MOI.ScalarNonlinearFunction, f)
        return _replace_parameters(model, g)
    end
    return f
end

function _replace_parameters(model::Optimizer, f::MOI.ScalarNonlinearFunction)
    for (i, arg) in enumerate(f.args)
        f.args[i] = _replace_parameters(model, arg)
    end
    return f
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{<:Union{MOI.VariableIndex,_FUNCTIONS}},
    ::Type{<:_SETS},
)
    return true
end

### MOI.ListOfConstraintTypesPresent

_add_scalar_nonlinear_constraints(ret, ::Nothing) = nothing

function _add_scalar_nonlinear_constraints(ret, nlp_model::MOI.Nonlinear.Model)
    for v in values(nlp_model.constraints)
        F, S = MOI.ScalarNonlinearFunction, typeof(v.set)
        if !((F, S) in ret)
            push!(ret, (F, S))
        end
    end
    return
end

function MOI.get(model::Optimizer, attr::MOI.ListOfConstraintTypesPresent)
    ret = MOI.get(model.variables, attr)
    append!(ret, MOI.get(model.qp_data, attr))
    _add_scalar_nonlinear_constraints(ret, model.nlp_model)
    if !isempty(model.vector_nonlinear_oracle_constraints)
        push!(ret, (MOI.VectorOfVariables, MOI.VectorNonlinearOracle{Float64}))
    end
    if !isempty(model.parameters)
        push!(ret, (MOI.VariableIndex, MOI.Parameter{Float64}))
    end
    return ret
end

### MOI.Name

MOI.supports(::Optimizer, ::MOI.Name) = true

function MOI.set(model::Optimizer, ::MOI.Name, value::String)
    model.name = value
    return
end

MOI.get(model::Optimizer, ::MOI.Name) = model.name

### MOI.Silent

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.set(model::Optimizer, ::MOI.Silent, value)
    model.silent = value
    return
end

MOI.get(model::Optimizer, ::MOI.Silent) = model.silent

### MOI.TimeLimitSec

MOI.supports(::Optimizer, ::MOI.TimeLimitSec) = true

function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, value::Real)
    MOI.set(model, MOI.RawOptimizerAttribute("max_cpu_time"), Float64(value))
    return
end

function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, ::Nothing)
    delete!(model.options, :max_cpu_time)
    return
end

function MOI.get(model::Optimizer, ::MOI.TimeLimitSec)
    return get(model.options, :max_cpu_time, nothing)
end

### MOI.RawOptimizerAttribute

MOI.supports(::Optimizer, ::MOI.RawOptimizerAttribute) = true

function MOI.set(model::Optimizer, p::MOI.RawOptimizerAttribute, value)
    model.options[Symbol(p.name)] = value
    # No need to reset model.solver because this gets handled in optimize!.
    return
end

function MOI.get(model::Optimizer, p::MOI.RawOptimizerAttribute)
    if !haskey(model.options, p.name)
        msg = "RawOptimizerAttribute with name $(p.name) is not set."
        throw(MOI.GetAttributeNotAllowed(p, msg))
    end
    return model.options[p.name]
end

### Variables

"""
    column(x::MOI.VariableIndex)

Return the column associated with a variable.
"""
column(x::MOI.VariableIndex) = x.value

function MOI.add_variable(model::Optimizer)
    push!(model.variable_primal_start, nothing)
    model.solver = nothing
    x = MOI.add_variable(model.variables)
    push!(model.list_of_variable_indices, x)
    return x
end

function MOI.is_valid(model::Optimizer, x::MOI.VariableIndex)
    if _is_parameter(x)
        return haskey(model.parameters, x)
    end
    return MOI.is_valid(model.variables, x)
end

function MOI.get(model::Optimizer, ::MOI.ListOfVariableIndices)
    return model.list_of_variable_indices
end

function MOI.get(model::Optimizer, ::MOI.NumberOfVariables)
    return length(model.list_of_variable_indices)
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    return MOI.is_valid(model.variables, ci)
end

function MOI.get(
    model::Optimizer,
    attr::Union{
        MOI.NumberOfConstraints{MOI.VariableIndex,<:_SETS},
        MOI.ListOfConstraintIndices{MOI.VariableIndex,<:_SETS},
    },
)
    return MOI.get(model.variables, attr)
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    c::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    return MOI.get(model.variables, attr, c)
end

function MOI.add_constraint(model::Optimizer, x::MOI.VariableIndex, set::_SETS)
    index = MOI.add_constraint(model.variables, x, set)
    model.solver = nothing
    return index
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
    set::S,
) where {S<:_SETS}
    MOI.set(model.variables, MOI.ConstraintSet(), ci, set)
    model.needs_new_nlp = true
    return
end

function MOI.delete(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    MOI.delete(model.variables, ci)
    model.solver = nothing
    return
end

### ScalarAffineFunction and ScalarQuadraticFunction constraints

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F,<:_SETS},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return MOI.is_valid(model.qp_data, ci)
end

function MOI.add_constraint(
    model::Optimizer,
    func::Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    set::_SETS,
)
    index = MOI.add_constraint(model.qp_data, func, set)
    model.solver = nothing
    return index
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.NumberOfConstraints{F,S},MOI.ListOfConstraintIndices{F,S}},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:_SETS,
}
    return MOI.get(model.qp_data, attr)
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    c::MOI.ConstraintIndex{F,<:_SETS},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return MOI.get(model.qp_data, attr, c)
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{F,S},
    set::S,
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:_SETS,
}
    MOI.set(model.qp_data, MOI.ConstraintSet(), ci, set)
    model.needs_new_nlp = true
    return
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ConstraintDualStart,
    ::Type{<:MOI.ConstraintIndex{F,<:_SETS}},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    c::MOI.ConstraintIndex{F,<:_SETS},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return MOI.get(model.qp_data, attr, c)
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    ci::MOI.ConstraintIndex{F,<:_SETS},
    value::Union{Real,Nothing},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    MOI.throw_if_not_valid(model, ci)
    MOI.set(model.qp_data, attr, ci, value)
    model.needs_new_nlp = true
    return
end

### ScalarNonlinearFunction

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
)
    if model.nlp_model === nothing
        return false
    end
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return MOI.is_valid(model.nlp_model, index)
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.ScalarNonlinearFunction,
    s::_SETS,
)
    _init_nlp_model(model)
    if !isempty(model.parameters)
        _replace_parameters(model, f)
    end
    index = MOI.Nonlinear.add_constraint(model.nlp_model, f, s)
    model.solver = nothing
    return MOI.ConstraintIndex{typeof(f),typeof(s)}(index.value)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ListOfConstraintIndices{F,S},
) where {F<:MOI.ScalarNonlinearFunction,S<:_SETS}
    ret = MOI.ConstraintIndex{F,S}[]
    if model.nlp_model === nothing
        return ret
    end
    for (k, v) in model.nlp_model.constraints
        if v.set isa S
            push!(ret, MOI.ConstraintIndex{F,S}(k.value))
        end
    end
    return ret
end

function MOI.get(
    model::Optimizer,
    attr::MOI.NumberOfConstraints{F,S},
) where {F<:MOI.ScalarNonlinearFunction,S<:_SETS}
    if model.nlp_model === nothing
        return 0
    end
    return count(v.set isa S for v in values(model.nlp_model.constraints))
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
)
    return true
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
    func::MOI.ScalarNonlinearFunction,
)
    _init_nlp_model(model)
    if !isempty(model.parameters)
        _replace_parameters(model, func)
    end
    MOI.Nonlinear.set_objective(model.nlp_model, func)
    model.solver = nothing
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
)
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return model.nlp_model[index].set
end

function MOI.set(
    model::Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,S},
    set::S,
) where {S<:_SETS}
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    func = model.nlp_model[index].expression
    model.nlp_model.constraints[index] = MOI.Nonlinear.Constraint(func, set)
    model.needs_new_nlp = true
    return
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ConstraintDualStart,
    ::Type{<:MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS}},
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
)
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return get(model.mult_g_nlp, index, nothing)
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ConstraintDualStart,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,<:_SETS},
    value::Union{Real,Nothing},
)
    MOI.throw_if_not_valid(model, ci)
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    if value === nothing
        delete!(model.mult_g_nlp, index)
    else
        model.mult_g_nlp[index] = convert(Float64, value)
    end
    model.needs_new_nlp = true
    return
end

### MOI.VectorOfVariables in MOI.VectorNonlinearOracle{Float64}

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.VectorNonlinearOracle{Float64}},
)
    return true
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{
        MOI.VectorOfVariables,
        MOI.VectorNonlinearOracle{Float64},
    },
)
    return 1 <= ci.value <= length(model.vector_nonlinear_oracle_constraints)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ListOfConstraintIndices{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    n = length(model.vector_nonlinear_oracle_constraints)
    return MOI.ConstraintIndex{F,S}.(1:n)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.NumberOfConstraints{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    return length(model.vector_nonlinear_oracle_constraints)
end

function MOI.add_constraint(
    model::Optimizer,
    f::F,
    s::S,
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    model.solver = nothing
    cache = _VectorNonlinearOracleCache(s)
    push!(model.vector_nonlinear_oracle_constraints, (f, cache))
    n = length(model.vector_nonlinear_oracle_constraints)
    return MOI.ConstraintIndex{F,S}(n)
end

function row(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    offset = length(model.qp_data)
    for i in 1:(ci.value-1)
        _, s = model.vector_nonlinear_oracle_constraints[i]
        offset += s.set.output_dimension
    end
    _, s = model.vector_nonlinear_oracle_constraints[ci.value]
    return offset .+ (1:s.set.output_dimension)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    f, _ = model.vector_nonlinear_oracle_constraints[ci.value]
    return MOI.get.(model, MOI.VariablePrimal(attr.result_index), f.variables)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    sign = -_dual_multiplier(model)
    f, s = model.vector_nonlinear_oracle_constraints[ci.value]
    λ = model.result.multipliers[row(model, ci)]
    λ .*= sign
    dual = zeros(MOI.dimension(s.set))
    # dual = λ' * J(x)
    _eval_constraint_transpose_jacobian_product(dual, model.result.solution, 0, f, s, λ)
    return dual
end

function MOI.get(
    model::Optimizer,
    attr::MOI.LagrangeMultiplier,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    sign = -_dual_multiplier(model)
    return sign * model.result.multipliers[row(model, ci)]
end

function MOI.supports(
    ::Optimizer,
    ::MOI.LagrangeMultiplierStart,
    ::Type{MOI.ConstraintIndex{F,S}},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.LagrangeMultiplierStart,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    _, cache = model.vector_nonlinear_oracle_constraints[ci.value]
    return cache.start
end

function MOI.set(
    model::Optimizer,
    attr::MOI.LagrangeMultiplierStart,
    ci::MOI.ConstraintIndex{F,S},
    start::Union{Nothing,Vector{Float64}},
) where {F<:MOI.VectorOfVariables,S<:MOI.VectorNonlinearOracle{Float64}}
    _, cache = model.vector_nonlinear_oracle_constraints[ci.value]
    cache.start = start
    model.needs_new_nlp = true
    return
end

### UserDefinedFunction

MOI.supports(model::Optimizer, ::MOI.UserDefinedFunction) = true

function MOI.set(model::Optimizer, attr::MOI.UserDefinedFunction, args)
    _init_nlp_model(model)
    MOI.Nonlinear.register_operator(
        model.nlp_model,
        attr.name,
        attr.arity,
        args...,
    )
    return
end

### ListOfSupportedNonlinearOperators

function MOI.get(model::Optimizer, attr::MOI.ListOfSupportedNonlinearOperators)
    _init_nlp_model(model)
    return MOI.get(model.nlp_model, attr)
end

### MOI.VariablePrimalStart

function MOI.supports(
    ::Optimizer,
    ::MOI.VariablePrimalStart,
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
)
    if _is_parameter(vi)
        throw(MOI.GetAttributeNotAllowed(attr, "Variable is a Parameter"))
    end
    MOI.throw_if_not_valid(model, vi)
    return model.variable_primal_start[column(vi)]
end

function MOI.set(
    model::Optimizer,
    attr::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
    value::Union{Real,Nothing},
)
    if _is_parameter(vi)
        throw(MOI.SetAttributeNotAllowed(attr, "Variable is a Parameter"))
    end
    MOI.throw_if_not_valid(model, vi)
    model.variable_primal_start[column(vi)] = value
    model.needs_new_nlp = true
    return
end

### MOI.ConstraintDualStart

_dual_start(::Optimizer, ::Nothing, ::Int = 1) = 0.0

function _dual_start(model::Optimizer, value::Real, scale::Int = 1)
    return _dual_multiplier(model) * value * scale
end

### MOI.NLPBlockDualStart

MOI.supports(::Optimizer, ::MOI.NLPBlockDualStart) = true

function MOI.set(
    model::Optimizer,
    ::MOI.NLPBlockDualStart,
    values::Union{Nothing,Vector},
)
    model.nlp_dual_start = values
    model.needs_new_nlp = true
    return
end

MOI.get(model::Optimizer, ::MOI.NLPBlockDualStart) = model.nlp_dual_start

### MOI.NLPBlock

MOI.supports(::Optimizer, ::MOI.NLPBlock) = true

# This may also be set by `optimize!` and contain the block created from
# ScalarNonlinearFunction
MOI.get(model::Optimizer, ::MOI.NLPBlock) = model.nlp_data

function MOI.set(model::Optimizer, ::MOI.NLPBlock, nlp_data::MOI.NLPBlockData)
    if model.nlp_model !== nothing
        error("Cannot mix the new and legacy nonlinear APIs")
    end
    model.nlp_data = nlp_data
    model.solver = nothing
    return
end

### ObjectiveSense

MOI.supports(::Optimizer, ::MOI.ObjectiveSense) = true

function MOI.set(
    model::Optimizer,
    ::MOI.ObjectiveSense,
    sense::MOI.OptimizationSense,
)
    model.sense = sense
    model.needs_new_nlp = true
    return
end

MOI.get(model::Optimizer, ::MOI.ObjectiveSense) = model.sense

### ObjectiveFunction

function MOI.get(model::Optimizer, attr::MOI.ObjectiveFunctionType)
    if model.nlp_model !== nothing && model.nlp_model.objective !== nothing
        return MOI.ScalarNonlinearFunction
    end
    return MOI.get(model.qp_data, attr)
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{Float64},
            MOI.ScalarQuadraticFunction{Float64},
        },
    },
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{F},
) where {
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return convert(F, MOI.get(model.qp_data, attr))
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{F},
    func::F,
) where {
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    MOI.set(model.qp_data, attr, func)
    if model.nlp_model !== nothing
        MOI.Nonlinear.set_objective(model.nlp_model, nothing)
    end
    model.solver = nothing
    return
end

### Eval_F_CB

function MOI.eval_objective(model::Optimizer, x)
    if model.sense == MOI.FEASIBILITY_SENSE
        return 0.0
    elseif model.nlp_data.has_objective
        return MOI.eval_objective(model.nlp_data.evaluator, x)
    end
    return MOI.eval_objective(model.qp_data, x)
end

### Eval_Grad_F_CB

function MOI.eval_objective_gradient(model::Optimizer, grad, x)
    if model.sense == MOI.FEASIBILITY_SENSE
        grad .= zero(eltype(grad))
    elseif model.nlp_data.has_objective
        MOI.eval_objective_gradient(model.nlp_data.evaluator, grad, x)
    else
        MOI.eval_objective_gradient(model.qp_data, grad, x)
    end
    return
end

### Eval_G_CB

function _eval_constraint(
    g::AbstractVector,
    offset::Int,
    x::AbstractVector,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for i in 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    ret = view(g, offset .+ (1:s.set.output_dimension))
    s.eval_f_timer += @elapsed s.set.eval_f(ret, s.x)
    return offset + s.set.output_dimension
end

function MOI.eval_constraint(model::Optimizer, g, x)
    MOI.eval_constraint(model.qp_data, g, x)
    offset = length(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset = _eval_constraint(g, offset, x, f, s)
    end
    g_nlp = view(g, (offset+1):length(g))
    MOI.eval_constraint(model.nlp_data.evaluator, g_nlp, x)
    return
end

### Eval_Jac_G_CB

function _jacobian_structure(
    ret::AbstractVector,
    row_offset::Int,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for (i, j) in s.set.jacobian_structure
        push!(ret, (row_offset + i, f.variables[j].value))
    end
    return row_offset + s.set.output_dimension
end

function MOI.jacobian_structure(model::Optimizer)
    J = MOI.jacobian_structure(model.qp_data)
    offset = length(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset = _jacobian_structure(J, offset, f, s)
    end
    if length(model.nlp_data.constraint_bounds) > 0
        J_nlp = MOI.jacobian_structure(
            model.nlp_data.evaluator,
        )::Vector{Tuple{Int64,Int64}}
        for (row, col) in J_nlp
            push!(J, (row + offset, col))
        end
    end
    return J
end

function _eval_constraint_jacobian(
    values::AbstractVector,
    offset::Int,
    x::AbstractVector,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for i in 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    nnz = length(s.set.jacobian_structure)
    s.eval_jacobian_timer +=
        @elapsed s.set.eval_jacobian(view(values, offset .+ (1:nnz)), s.x)
    return offset + nnz
end

function MOI.eval_constraint_jacobian(model::Optimizer, values, x)
    offset = MOI.eval_constraint_jacobian(model.qp_data, values, x)
    offset -= 1  # .qp_data returns one-indexed offset
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset = _eval_constraint_jacobian(values, offset, x, f, s)
    end
    nlp_values = view(values, (offset+1):length(values))
    MOI.eval_constraint_jacobian(model.nlp_data.evaluator, nlp_values, x)
    return
end

# N.B.: VectorNonlinearOracle does not support transposed-Jacobian vector-product by default.
# This function uses the original Jacobian when we have to compute the product in MadNLP.
# This can be slow on large-scale instances.
function _eval_constraint_transpose_jacobian_product(
    Jtv::AbstractVector,
    x::AbstractVector,
    offset::Integer,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
    v::AbstractVector,
)
    for i = 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    s.set.eval_jacobian(s.J_nzval, s.x)
    k = 0
    for (r, c) in s.set.jacobian_structure
        k += 1
        row = offset + r
        col = f.variables[c].value
        Jtv[col] += s.J_nzval[k] * v[row]
    end
    return
end

function MOI.eval_constraint_jacobian_transpose_product(model::Optimizer, Jtv, x, v)
    fill!(Jtv, 0.0)
    offset = length(model.qp_data)
    v_qp = view(v, 1:offset)
    # Evaluate jtprod for linear-quadratic part of the model.
    MOI.eval_constraint_jacobian_transpose_product(model.qp_data, Jtv, x, v_qp)
    # Evaluate jtprod for all VectorNonlinearOracle.
    for (f, s) in model.vector_nonlinear_oracle_constraints
        _eval_constraint_transpose_jacobian_product(Jtv, x, offset, f, s, v)
        offset += s.set.output_dimension
    end
    # Evaluate jtprod for remaining nonlinear expressions.
    v_nlp = view(v, (offset+1):length(v))
    MOI.eval_constraint_jacobian_transpose_product(model.nlp_data.evaluator, Jtv, x, v_nlp)
    return
end

function MOI.eval_constraint_jacobian_product(model::Optimizer, Jv, x, v)
    @assert isempty(model.vector_nonlinear_oracle_constraints)
    fill!(Jv, 0.0)
    qp_offset = length(model.qp_data)
    Jv_qp = view(Jv, 1:qp_offset)
    Jv_nlp = view(Jv, (qp_offset+1):length(Jv))
    MOI.eval_constraint_jacobian_product(model.nlp_data.evaluator, Jv_nlp, x, v)
    MOI.eval_constraint_jacobian_product(model.qp_data, Jv_qp, x, v)
    return
end

### Eval_H_CB

function _hessian_lagrangian_structure(
    ret::AbstractVector,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for (i, j) in s.set.hessian_lagrangian_structure
        push!(ret, (f.variables[i].value, f.variables[j].value))
    end
    return
end

function MOI.hessian_lagrangian_structure(model::Optimizer)
    H = MOI.hessian_lagrangian_structure(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        _hessian_lagrangian_structure(H, f, s)
    end
    append!(H, MOI.hessian_lagrangian_structure(model.nlp_data.evaluator))
    return H
end

function _eval_hessian_lagrangian(
    H::AbstractVector,
    H_offset::Int,
    x::AbstractVector,
    μ::AbstractVector,
    μ_offset::Int,
    f::MOI.VectorOfVariables,
    s::_VectorNonlinearOracleCache,
)
    for i in 1:s.set.input_dimension
        s.x[i] = x[f.variables[i].value]
    end
    H_nnz = length(s.set.hessian_lagrangian_structure)
    H_view = view(H, H_offset .+ (1:H_nnz))
    μ_view = view(μ, μ_offset .+ (1:s.set.output_dimension))
    s.eval_hessian_lagrangian_timer +=
        @elapsed s.set.eval_hessian_lagrangian(H_view, s.x, μ_view)
    return H_offset + H_nnz, μ_offset + s.set.output_dimension
end

function MOI.eval_hessian_lagrangian(model::Optimizer, H, x, σ, μ)
    offset = MOI.eval_hessian_lagrangian(model.qp_data, H, x, σ, μ)
    offset -= 1  # model.qp_data returns one-indexed offset
    μ_offset = length(model.qp_data)
    for (f, s) in model.vector_nonlinear_oracle_constraints
        offset, μ_offset =
            _eval_hessian_lagrangian(H, offset, x, μ, μ_offset, f, s)
    end
    H_nlp = view(H, (offset+1):length(H))
    μ_nlp = view(μ, (μ_offset+1):length(μ))
    MOI.eval_hessian_lagrangian(model.nlp_data.evaluator, H_nlp, x, σ, μ_nlp)
    return
end

function MOI.eval_hessian_lagrangian_product(model::Optimizer, Hv, x, v, σ, μ)
    @assert isempty(model.vector_nonlinear_oracle_constraints)
    fill!(Hv, 0.0)
    qp_offset = length(model.qp_data)
    μ_nlp = view(μ, (qp_offset+1):length(μ))
    MOI.eval_hessian_lagrangian_product(model.nlp_data.evaluator, Hv, x, v, σ, μ_nlp)
    MOI.eval_hessian_lagrangian_product(model.qp_data, Hv, x, v, σ, μ)
    return
end

### MOI.AutomaticDifferentiationBackend

MOI.supports(::Optimizer, ::MOI.AutomaticDifferentiationBackend) = true

function MOI.get(model::Optimizer, ::MOI.AutomaticDifferentiationBackend)
    return model.ad_backend
end

function MOI.set(
    model::Optimizer,
    ::MOI.AutomaticDifferentiationBackend,
    backend::MOI.Nonlinear.AbstractAutomaticDifferentiation,
)
    # Setting the backend will invalidate the model if it is different. But we
    # don't requrire == for `::MOI.Nonlinear.AutomaticDifferentiationBackend` so
    # act defensive and invalidate regardless.
    model.solver = nothing
    model.ad_backend = backend
    return
end

### NLPModels wrapper
struct MOIModel{T} <: NLPModels.AbstractNLPModel{T,Vector{T}}
    meta::NLPModels.NLPModelMeta{T, Vector{T}}
    model::Optimizer
    counters::NLPModels.Counters
end

NLPModels.obj(nlp::MOIModel, x::AbstractVector{Float64}) = MOI.eval_objective(nlp.model,x)

function NLPModels.grad!(nlp::MOIModel, x::AbstractVector{Float64}, g::AbstractVector{Float64})
    MOI.eval_objective_gradient(nlp.model, g, x)
end

function NLPModels.cons!(nlp::MOIModel, x::AbstractVector{Float64}, c::AbstractVector{Float64})
    MOI.eval_constraint(nlp.model, c, x)
end

function NLPModels.jac_coord!(nlp::MOIModel, x::AbstractVector{Float64}, jac::AbstractVector{Float64})
    MOI.eval_constraint_jacobian(nlp.model, jac, x)
end

function NLPModels.jprod!(nlp::MOIModel, x::AbstractVector{Float64}, v::AbstractVector{Float64}, Jv::AbstractVector{Float64})
    MOI.eval_constraint_jacobian_product(nlp.model, Jv, x, v)
end

function NLPModels.jtprod!(nlp::MOIModel, x::AbstractVector{Float64}, v::Vector{Float64}, Jtv::AbstractVector{Float64})
    MOI.eval_constraint_jacobian_transpose_product(nlp.model, Jtv, x, v)
end

function NLPModels.hess_coord!(nlp::MOIModel, x::AbstractVector{Float64}, l::AbstractVector{Float64}, hess::AbstractVector{Float64}; obj_weight::Float64=1.0)
    MOI.eval_hessian_lagrangian(nlp.model, hess, x, obj_weight, l)
end

function NLPModels.hprod!(nlp::MOIModel, x::AbstractVector{Float64}, l::AbstractVector{Float64}, v::AbstractVector{Float64}, Hv::AbstractVector{Float64}; obj_weight::Float64=1.0)
  MOI.eval_hessian_lagrangian_product(nlp.model, Hv, x, v, obj_weight, l)
end

function NLPModels.hess_structure!(nlp::MOIModel, I::AbstractVector{T}, J::AbstractVector{T}) where T
    @assert length(I) == length(J) == length(nlp.model.hrows) == length(nlp.model.hcols)
    copyto!(I, nlp.model.hrows)
    copyto!(J, nlp.model.hcols)
    return
end

function NLPModels.jac_structure!(nlp::MOIModel, I::AbstractVector{T}, J::AbstractVector{T}) where T
    @assert length(I) == length(J) == length(nlp.model.jrows) == length(nlp.model.jcols)
    copyto!(I, nlp.model.jrows)
    copyto!(J, nlp.model.jcols)
    return
end

### MOI.optimize!

function _setup_model(model::Optimizer)
    vars = MOI.get(model.variables, MOI.ListOfVariableIndices())
    if isempty(vars)
        model.invalid_model = true
        return
    end
    # Create NLP backend.
    if model.nlp_model !== nothing
        evaluator = MOI.Nonlinear.Evaluator(model.nlp_model, model.ad_backend, vars)
        model.nlp_data = MOI.NLPBlockData(evaluator)
    end
    # Check model's structure.
    has_oracle = !isempty(model.vector_nonlinear_oracle_constraints)
    has_quadratic_constraints =
        any(isequal(_kFunctionTypeScalarQuadratic), model.qp_data.function_type)
    has_nlp_constraints = !isempty(model.nlp_data.constraint_bounds) || has_oracle
    has_nlp_objective = model.nlp_data.has_objective
    has_hessian = :Hess in MOI.features_available(model.nlp_data.evaluator)
    has_jacobian_operator = :JacVec in MOI.features_available(model.nlp_data.evaluator)
    has_hessian_operator = :HessVec in MOI.features_available(model.nlp_data.evaluator)
    for (_, s) in model.vector_nonlinear_oracle_constraints
        if s.set.eval_hessian_lagrangian === nothing
            has_hessian = false
            break
        end
    end

    model.has_only_linear_constraints = !has_quadratic_constraints && !has_nlp_constraints
    model.islp = model.has_only_linear_constraints && !has_nlp_objective
    model.jprod_available = has_jacobian_operator && !has_oracle
    model.hprod_available = has_hessian_operator && !has_oracle
    model.hess_available = has_hessian

    # Initialize evaluator using model's structure.
    init_feat = [:Grad]
    if has_hessian
        push!(init_feat, :Hess)
    end
    if has_hessian_operator
        push!(init_feat, :HessVec)
    end
    if has_nlp_constraints
        push!(init_feat, :Jac)
    end
    if has_jacobian_operator
        push!(init_feat, :JacVec)
    end
    MOI.initialize(model.nlp_data.evaluator, init_feat)

    # Sparsity
    jacobian_sparsity = MOI.jacobian_structure(model)
    nnzj = length(jacobian_sparsity)
    jrows = Vector{Int}(undef, nnzj)
    jcols = Vector{Int}(undef, nnzj)
    for k in 1:nnzj
        jrows[k], jcols[k] = jacobian_sparsity[k]
    end
    model.jrows = jrows
    model.jcols = jcols

    hessian_sparsity = has_hessian ? MOI.hessian_lagrangian_structure(model) : Tuple{Int,Int}[]
    nnzh = length(hessian_sparsity)
    hrows = Vector{Int}(undef, nnzh)
    hcols = Vector{Int}(undef, nnzh)
    for k in 1:nnzh
        hrows[k], hcols[k] = hessian_sparsity[k]
    end
    model.hrows = hrows
    model.hcols = hcols

    model.needs_new_nlp = true
    return
end

function _setup_nlp(model::Optimizer; array_type = nothing)
    if !model.needs_new_nlp
        return model.nlp
    end

    # Number of nonzeros for the jacobian and hessian of the Lagrangian
    nnzj = length(model.jrows)
    nnzh = length(model.hrows)

    # Initial variable
    nvar = length(model.variables.lower)
    x0 = zeros(Float64, nvar)
    for i in 1:length(model.variable_primal_start)
        x0[i] = if model.variable_primal_start[i] !== nothing
            model.variable_primal_start[i]
        else
            clamp(0.0, model.variables.lower[i], model.variables.upper[i])
        end
    end

    # Constraints bounds
    g_L, g_U = copy(model.qp_data.g_L), copy(model.qp_data.g_U)
    for (_, s) in model.vector_nonlinear_oracle_constraints
        append!(g_L, s.set.l)
        append!(g_U, s.set.u)
    end
    for bound in model.nlp_data.constraint_bounds
        push!(g_L, bound.lower)
        push!(g_U, bound.upper)
    end
    ncon = length(g_L)

    # Dual multipliers
    y0 = zeros(Float64, ncon)
    for (i, start) in enumerate(model.qp_data.mult_g)
        y0[i] = _dual_start(model, start, -1)
    end
    offset = length(model.qp_data.mult_g)
    if model.nlp_dual_start === nothing
        # First there is VectorNonlinearOracle...
        for (_, cache) in model.vector_nonlinear_oracle_constraints
            if cache.start !== nothing
                for i in 1:cache.set.output_dimension
                    y0[offset+i] = _dual_start(model, cache.start[i], -1)
                end
            end
            offset += cache.set.output_dimension
        end
        # ...then come the ScalarNonlinearFunctions
        for (key, val) in model.mult_g_nlp
            y0[offset+key.value] = _dual_start(model, val, -1)
        end
    else
        for (i, start) in enumerate(model.nlp_dual_start::Vector{Float64})
            y0[offset+i] = _dual_start(model, start, -1)
        end
    end

    nlp = MOIModel(
        NLPModels.NLPModelMeta(
            nvar,
            x0 = x0,
            lvar = model.variables.lower,
            uvar = model.variables.upper,
            ncon = ncon,
            y0 = y0,
            lcon = g_L,
            ucon = g_U,
            nnzj = nnzj,
            nnzh = nnzh,
            minimize = model.sense == MOI.MIN_SENSE,
            islp = model.islp,
            name = "MOIModel",
            variable_bounds_analysis=false,
            constraint_bounds_analysis=false,
            jprod_available = model.jprod_available,
            hprod_available = model.hprod_available,
            hess_available = model.hess_available,
        ),
        model,
        NLPModels.Counters(),
    )

    model.nlp = if isnothing(array_type)
        nlp
    else
        MadNLP.SparseWrapperModel(array_type, nlp)
    end

    model.needs_new_nlp = false
    return model.nlp
end

function MOI.optimize!(model::Optimizer)
    if model.solver === nothing
        _setup_model(model)
    end
    if model.invalid_model
        return
    end

    if model.nlp_model !== nothing
        empty!(model.qp_data.parameters)
        for (p, index) in model.parameters
            model.qp_data.parameters[p.value] = model.nlp_model[index]
        end
    end

    array_type = pop!(model.options, :array_type, nothing)
    _setup_nlp(model; array_type = array_type)

    if model.silent
        model.options[:print_level] = MadNLP.ERROR
    end
    options = copy(model.options)
    # Specific options depending on problem's structure.
    if !model.hess_available
        options[:hessian_approximation] = MadNLP.CompactLBFGS
    end
    # Set Jacobian to constant if all constraints are linear.
    if model.has_only_linear_constraints
        options[:jacobian_constant] = true
    end
    # Clear timers
    for (_, s) in model.vector_nonlinear_oracle_constraints
        s.eval_f_timer = 0.0
        s.eval_jacobian_timer = 0.0
        s.eval_hessian_lagrangian_timer = 0.0
    end
    # Instantiate MadNLP.
    model.solver = MadNLP.MadNLPSolver(model.nlp; options...)
    result = MadNLP.solve!(model.solver)
    model.result = if isnothing(array_type)
        result
    else
        model.options[:array_type] = array_type
        copy_result_to_cpu(result)
    end
    model.solve_time = model.solver.cnt.total_time
    model.solve_iterations = model.solver.cnt.k
    return
end


function copy_result_to_cpu(stats::MadNLP.MadNLPExecutionStats)
    return MadNLP.MadNLPExecutionStats(
        stats.options,
        stats.status,
        Array(stats.solution),
        stats.objective,
        Array(stats.constraints),
        stats.dual_feas,
        stats.primal_feas,
        Array(stats.multipliers),
        Array(stats.multipliers_L),
        Array(stats.multipliers_U),
        stats.iter,
        stats.counters,
    )
end

const _STATUS_CODES = Dict{MadNLP.Status,MOI.TerminationStatusCode}(
    MadNLP.SOLVE_SUCCEEDED => MOI.LOCALLY_SOLVED,
    MadNLP.SOLVED_TO_ACCEPTABLE_LEVEL => MOI.ALMOST_LOCALLY_SOLVED,
    MadNLP.SEARCH_DIRECTION_BECOMES_TOO_SMALL => MOI.SLOW_PROGRESS,
    MadNLP.DIVERGING_ITERATES => MOI.INFEASIBLE_OR_UNBOUNDED,
    MadNLP.INFEASIBLE_PROBLEM_DETECTED => MOI.LOCALLY_INFEASIBLE,
    MadNLP.MAXIMUM_ITERATIONS_EXCEEDED => MOI.ITERATION_LIMIT,
    MadNLP.MAXIMUM_WALLTIME_EXCEEDED => MOI.TIME_LIMIT,
    MadNLP.INITIAL => MOI.OPTIMIZE_NOT_CALLED,
    MadNLP.RESTORATION_FAILED => MOI.NUMERICAL_ERROR,
    MadNLP.INVALID_NUMBER_DETECTED => MOI.INVALID_MODEL,
    MadNLP.ERROR_IN_STEP_COMPUTATION => MOI.NUMERICAL_ERROR,
    MadNLP.NOT_ENOUGH_DEGREES_OF_FREEDOM => MOI.INVALID_MODEL,
    MadNLP.USER_REQUESTED_STOP => MOI.INTERRUPTED,
    MadNLP.INTERNAL_ERROR => MOI.OTHER_ERROR,
    MadNLP.INVALID_NUMBER_OBJECTIVE => MOI.INVALID_MODEL,
    MadNLP.INVALID_NUMBER_GRADIENT => MOI.INVALID_MODEL,
    MadNLP.INVALID_NUMBER_CONSTRAINTS => MOI.INVALID_MODEL,
    MadNLP.INVALID_NUMBER_JACOBIAN => MOI.INVALID_MODEL,
    MadNLP.INVALID_NUMBER_HESSIAN_LAGRANGIAN => MOI.INVALID_MODEL,
)

### MOI.ResultCount

# Ipopt always has an iterate available.
function MOI.get(model::Optimizer, ::MOI.ResultCount)
    return (model.solver !== nothing) ? 1 : 0
end

### MOI.TerminationStatus

function MOI.get(model::Optimizer, ::MOI.TerminationStatus)
    if model.invalid_model
        return MOI.INVALID_MODEL
    elseif model.solver === nothing
        return MOI.OPTIMIZE_NOT_CALLED
    end
    return get(_STATUS_CODES, model.result.status, MOI.OTHER_ERROR)
end

### MOI.RawStatusString

function MOI.get(model::Optimizer, ::MOI.RawStatusString)
    if model.invalid_model
        return "The model has no variable"
    elseif model.solver === nothing
        return "Optimize not called"
    end
    return MadNLP.get_status_output(model.result.status, model.result.options)
end


### MOI.PrimalStatus

function MOI.get(model::Optimizer, attr::MOI.PrimalStatus)
    if !(1 <= attr.result_index <= MOI.get(model, MOI.ResultCount()))
        return MOI.NO_SOLUTION
    end
    status = model.result.status
    if status == MadNLP.SOLVE_SUCCEEDED
        return MOI.FEASIBLE_POINT
    elseif status == MadNLP.SOLVED_TO_ACCEPTABLE_LEVEL
        return MOI.NEARLY_FEASIBLE_POINT
    elseif status == MadNLP.INFEASIBLE_PROBLEM_DETECTED
        return MOI.INFEASIBLE_POINT
    else
        return MOI.UNKNOWN_RESULT_STATUS
    end
end

### MOI.DualStatus

function MOI.get(model::Optimizer, attr::MOI.DualStatus)
    if !(1 <= attr.result_index <= MOI.get(model, MOI.ResultCount()))
        return MOI.NO_SOLUTION
    end
    status = model.result.status
    if status == MadNLP.SOLVE_SUCCEEDED
        return MOI.FEASIBLE_POINT
    elseif status == MadNLP.SOLVED_TO_ACCEPTABLE_LEVEL
        return MOI.NEARLY_FEASIBLE_POINT
    elseif status == MadNLP.INFEASIBLE_PROBLEM_DETECTED
        return MOI.INFEASIBLE_POINT
    else
        return MOI.UNKNOWN_RESULT_STATUS
    end
end

### MOI.SolveTimeSec

MOI.get(model::Optimizer, ::MOI.SolveTimeSec) = model.solve_time

### MOI.BarrierIterations

MOI.get(model::Optimizer,::MOI.BarrierIterations) = model.solve_iterations

### MOI.ObjectiveValue

function MOI.get(model::Optimizer, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(model, attr)
    return model.result.objective
end

### MOI.VariablePrimal

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimal,
    vi::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, vi)
    if _is_parameter(vi)
        p = model.parameters[vi]
        return model.nlp_model[p]
    end
    return model.result.solution[vi.value]
end

### MOI.ConstraintPrimal

function row(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    return ci.value
end

function row(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction},
)
    offset = length(model.qp_data)
    for (_, s) in model.vector_nonlinear_oracle_constraints
        offset += s.set.output_dimension
    end
    return offset + ci.value
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{<:_FUNCTIONS,<:_SETS},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return model.result.constraints[row(model, ci)]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:_SETS},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return model.result.solution[ci.value]
end

### MOI.ConstraintDual

_dual_multiplier(model::Optimizer) = model.sense == MOI.MIN_SENSE ? 1.0 : -1.0

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{<:_FUNCTIONS,<:_SETS},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    s = -_dual_multiplier(model)
    return s * model.result.multipliers[row(model, ci)]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return -model.result.multipliers_U[ci.value]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return model.result.multipliers_L[ci.value]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return model.result.multipliers_L[ci.value] - model.result.multipliers_U[ci.value]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}},
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return model.result.multipliers_L[ci.value] - model.result.multipliers_U[ci.value]
end

### MOI.NLPBlockDual

function MOI.get(model::Optimizer, attr::MOI.NLPBlockDual)
    MOI.check_result_index_bounds(model, attr)
    s = -_dual_multiplier(model)
    offset = length(model.qp_data)
    return s .* model.result.multipliers[(offset+1):end]
end

@kwdef mutable struct LapackOptions <: AbstractOptions
    lapack_algorithm::LinearFactorization = BUNCHKAUFMAN
end

mutable struct LapackCPUSolver{T, MT, Alg} <: AbstractLapackSolver{T, Alg}
    A::MT
    fact::Matrix{T}
    n::Int64
    sol::Vector{T}
    tau::Vector{T}
    Λ::Vector{T}
    work::Vector{T}
    lwork::BlasInt
    iwork::Vector{BlasInt}
    liwork::BlasInt
    info::Base.RefValue{BlasInt}
    ipiv::Vector{BlasInt}
    opt::LapackOptions
    logger::MadNLPLogger

    function LapackCPUSolver(
        A::MT;
        opt=LapackOptions(),
        logger=MadNLPLogger(),
    ) where {MT <: AbstractMatrix}
        T = eltype(A)
        m,n = size(A)
        @assert m == n
        fact = Matrix{T}(undef, m, n)
        sol = Vector{T}(undef, 0)
        tau = Vector{T}(undef, 0)
        Λ = Vector{T}(undef, 0)
        work = Vector{T}(undef, 1)
        lwork = BlasInt(-1)
        iwork = Vector{BlasInt}(undef, 1)
        liwork = BlasInt(-1)
        info = Ref{BlasInt}(0)
        ipiv = Vector{BlasInt}(undef, 0)
        alg = opt.lapack_algorithm
        solver = new{T, MT, alg}(A, fact, n, sol, tau, Λ, work, lwork, iwork, liwork, info, ipiv, opt, logger)
        setup!(solver)
        return solver
    end
end

solve!(M::LapackCPUSolver{T}, x::Vector{T}) where {T} = _solve!(M, x)
supports_bunchkaufman_inertia(::LapackCPUSolver) = true
inertia_bunchkaufman(M::LapackCPUSolver) = inertia(M.fact, M.ipiv, M.info[])

for (potrf, potrs, getrf, getrs, sytrf, sytrs, geqrf, ormqr, trsv, syevd, gemv, T) in
    ((:spotrf_, :spotrs_, :sgetrf_, :sgetrs_, :ssytrf_, :ssytrs_, :sgeqrf_, :sormqr_, :strsv_, :ssyevd_, :sgemv_, :Float32),
     (:dpotrf_, :dpotrs_, :dgetrf_, :dgetrs_, :dsytrf_, :dsytrs_, :dgeqrf_, :dormqr_, :dtrsv_, :dsyevd_, :dgemv_, :Float64))
    @eval begin
        # potrf
        function $potrf(uplo, n, a, lda, info)
            return ccall((@blasfunc($potrf), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ref{BlasInt}, Clong),
                          uplo, n, a, lda, info, 1)
        end

        # potrs
        function $potrs(uplo, n, nrhs, a, lda, b, ldb, info)
            return ccall((@blasfunc($potrs), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{$T},
                          Ref{BlasInt}, Ref{BlasInt}, Clong),
                          uplo, n, nrhs, a, lda, b, ldb, info, 1)
        end

        # getrf
        function $getrf(m, n, a, lda, ipiv, info)
            return ccall((@blasfunc($getrf), libblastrampoline), Cvoid,
                         (Ref{BlasInt}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt}),
                          m, n, a, lda, ipiv, info)
        end

        # getrs
        function $getrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
            return ccall((@blasfunc($getrs), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{BlasInt},
                          Ptr{$T}, Ref{BlasInt}, Ref{BlasInt}, Clong),
                          trans, n, nrhs, a, lda, ipiv, b, ldb, info, 1)
        end

        # sytrf
        function $sytrf(uplo, n, a, lda, ipiv, work, lwork, info)
            return ccall((@blasfunc($sytrf), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{BlasInt}, Ptr{$T},
                          Ref{BlasInt}, Ref{BlasInt}, Clong),
                          uplo, n, a, lda, ipiv, work, lwork, info, 1)
        end

        # sytrs
        function $sytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
            return ccall((@blasfunc($sytrs), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{BlasInt},
                          Ptr{$T}, Ref{BlasInt}, Ref{BlasInt}, Clong), uplo, n, nrhs, a, lda, ipiv,
                          b, ldb, info, 1)
        end

        # geqrf
        function $geqrf(m, n, a, lda, tau, work, lwork, info)
            return ccall((@blasfunc($geqrf), libblastrampoline), Cvoid,
                         (Ref{BlasInt}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{$T}, Ptr{$T},
                          Ref{BlasInt}, Ref{BlasInt}),
                          m, n, a, lda, tau, work, lwork, info)
        end

        # ormqr
        function $ormqr(side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info)
            return ccall((@blasfunc($ormqr), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$T},
                          Ref{BlasInt}, Ptr{$T}, Ptr{$T}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt},
                          Ref{BlasInt}, Clong, Clong),
                          side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info, 1, 1)
        end

        # trsv
        function $trsv(uplo, trans, diag, n, a, lda, x, incx)
            return ccall((@blasfunc($trsv), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt},
                          Ptr{$T}, Ref{BlasInt}, Clong, Clong, Clong),
                          uplo, trans, diag, n, a, lda, x, incx, 1, 1, 1)
        end

        # syevd
        function $syevd(jobz, uplo, n, a, lda, w, work, lwork, iwork, liwork, info)
            return ccall((@blasfunc($syevd), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{$T},
                          Ptr{$T}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Clong, Clong),
                          jobz, uplo, n, a, lda, w, work, lwork, iwork, liwork, info, 1, 1)
        end

        # gemv
        function $gemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
            return ccall((@blasfunc($gemv), libblastrampoline), Cvoid,
                         (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{$T}, Ptr{$T}, Ref{BlasInt},
                          Ptr{$T}, Ref{BlasInt}, Ref{$T}, Ptr{$T}, Ref{BlasInt}, Clong),
                          trans, m, n, alpha, a, lda, x, incx, beta, y, incy, 1)
        end

        function setup_cholesky!(M::LapackCPUSolver{$T})
            return M
        end

        function factorize_cholesky!(M::LapackCPUSolver{$T})
            $potrf('L', M.n, M.fact, M.n, M.info)
            return M
        end

        function solve_cholesky!(M::LapackCPUSolver{$T}, x::Vector{$T})
            $potrs('L', M.n, one(BlasInt), M.fact, M.n, x, M.n, M.info)
            return x
        end

        function setup_bunchkaufman!(M::LapackCPUSolver{$T})
            resize!(M.ipiv, M.n)
            $sytrf('L', M.n, M.fact, M.n, M.ipiv, M.work, M.lwork, M.info)
            buffer_size_sytrf = M.work[1] |> BlasInt
            M.lwork = buffer_size_sytrf
            resize!(M.work, M.lwork)
            return M
        end

        function factorize_bunchkaufman!(M::LapackCPUSolver{$T})
            $sytrf('L', M.n, M.fact, M.n, M.ipiv, M.work, M.lwork, M.info)
            return M
        end

        function solve_bunchkaufman!(M::LapackCPUSolver{$T}, x::Vector{$T})
            $sytrs('L', M.n, one(BlasInt), M.fact, M.n, M.ipiv, x, M.n, M.info)
            return x
        end

        function setup_lu!(M::LapackCPUSolver{$T})
            resize!(M.ipiv, M.n)
            return M
        end

        function factorize_lu!(M::LapackCPUSolver{$T})
            $getrf(M.n, M.n, M.fact, M.n, M.ipiv, M.info)
            return M
        end

        function solve_lu!(M::LapackCPUSolver{$T}, x::Vector{$T})
            $getrs('N', M.n, one(BlasInt), M.fact, M.n, M.ipiv, x, M.n, M.info)
            return x
        end

        function setup_qr!(M::LapackCPUSolver{$T})
            resize!(M.tau, M.n)
            $geqrf(M.n, M.n, M.fact, M.n, M.tau, M.work, M.lwork, M.info)
            buffer_size_geqrf = M.work[1] |> BlasInt
            $ormqr('L', 'T', M.n, one(BlasInt), M.n, M.fact, M.n, M.tau, M.tau, M.n, M.work, M.lwork, M.info)
            buffer_size_ormqr = M.work[1] |> BlasInt
            M.lwork = max(buffer_size_geqrf, buffer_size_ormqr)
            resize!(M.work, M.lwork)
            return M
        end

        function factorize_qr!(M::LapackCPUSolver{$T})
            $geqrf(M.n, M.n, M.fact, M.n, M.tau, M.work, M.lwork, M.info)
            return M
        end

        function solve_qr!(M::LapackCPUSolver{$T}, x::Vector{$T})
            $ormqr('L', 'T', M.n, one(BlasInt), M.n, M.fact, M.n, M.tau, x, M.n, M.work, M.lwork, M.info)
            $trsv('U', 'N', 'N' , M.n, M.fact, M.n, x, one(BlasInt))
            return x
        end

        function setup_evd!(M::LapackCPUSolver{$T})
            resize!(M.tau, M.n)
            resize!(M.Λ, M.n)
            $syevd('V', 'L', M.n, M.fact, M.n, M.Λ, M.work, M.lwork, M.iwork, M.liwork, M.info)
            buffer_size_syevd = M.work[1] |> BlasInt
            buffer2_size_syevd = M.iwork[1] |> BlasInt
            M.lwork = buffer_size_syevd
            M.liwork = buffer2_size_syevd
            resize!(M.work, M.lwork)
            resize!(M.iwork, M.liwork)
            return M
        end

        function factorize_evd!(M::LapackCPUSolver{$T})
            $syevd('V', 'L', M.n, M.fact, M.n, M.Λ, M.work, M.lwork, M.iwork, M.liwork, M.info)
            return M
        end

        function solve_evd!(M::LapackCPUSolver{$T}, x::Vector{$T})
            $gemv('T', M.n, M.n, one($T), M.fact, M.n, x, one(BlasInt), zero($T), M.tau, one(BlasInt))
            M.tau ./= M.Λ
            $gemv('N', M.n, M.n, one($T), M.fact, M.n, M.tau, one(BlasInt), zero($T), x, one(BlasInt))
            return x
        end
    end
end

introduce(M::LapackCPUSolver) = "Lapack-CPU ($(M.opt.lapack_algorithm))"

function inertia(fact, ipiv, info)
    numneg = num_neg_ev(size(fact,1), fact, ipiv)
    numzero = info > 0 ? 1 : 0
    numpos = size(fact,1) - numneg - numzero
    return (numpos, numzero, numneg)
end

function num_neg_ev(n, D, ipiv)
    numneg = 0
    t = 0
    for k=1:n
        d = D[k,k]
        if ipiv[k] < 0
            if t == 0
                t = abs(D[k+1,k])
                d = (d/t) * D[k+1,k+1] - t
            else
                d = t
                t = 0
            end
        end
        d < 0 && (numneg += 1)
        if d == 0
            numneg = -1
            break
        end
    end
    return numneg
end

using LinearAlgebra

@testset "[KKT vector] $KKTVector" for KKTVector in [
    MadNLP.UnreducedKKTVector,
]
    T = Float64
    VT = Vector{Float64}
    n, m = 10, 20
    nlb, nub = 5, 6

    ind_lb = [2,3,4]
    ind_ub = [4,5,6]
    rhs = KKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    @test length(rhs) == length(MadNLP.full(rhs))
    @test MadNLP.number_primal(rhs) == length(MadNLP.primal(rhs)) == n
    @test MadNLP.number_dual(rhs) == length(MadNLP.dual(rhs)) == m
    @test norm(rhs) == 0

    fill!(rhs, one(T))
    @test norm(rhs) == sqrt(length(rhs))

    # Test copy
    copy_rhs = copy(rhs)
    @test MadNLP.full(rhs) == MadNLP.full(copy_rhs)
end

@testset "[KKT system] $(KKTSystem)" for (KKTSystem, Callback) in [
    (MadNLP.SparseKKTSystem, MadNLP.SparseCallback),
    (MadNLP.SparseUnreducedKKTSystem, MadNLP.SparseCallback),
    (MadNLP.SparseCondensedKKTSystem, MadNLP.SparseCallback),
    (MadNLP.ScaledSparseKKTSystem, MadNLP.SparseCallback),
    (MadNLP.DenseKKTSystem, MadNLP.DenseCallback),
    (MadNLP.DenseCondensedKKTSystem, MadNLP.DenseCallback),
]
    linear_solver = MadNLP.LapackCPUSolver

    nlp = MadNLPTests.HS15Model()
    cb = MadNLP.create_callback(
        Callback, nlp,
    )

    kkt = MadNLP.create_kkt_system(
        KKTSystem,
        cb,
        linear_solver;
    )
    MadNLPTests.test_kkt_system(kkt, cb)
end

@testset "[KKT system] $(KKTSystem)+LBFGS" for (KKTSystem, Callback) in [
    (MadNLP.SparseKKTSystem, MadNLP.SparseCallback),
    (MadNLP.SparseUnreducedKKTSystem, MadNLP.SparseCallback),
    (MadNLP.SparseCondensedKKTSystem, MadNLP.SparseCallback),
    (MadNLP.ScaledSparseKKTSystem, MadNLP.SparseCallback),
]
    linear_solver = MadNLP.LapackCPUSolver
    nlp = MadNLPTests.HS15Model()
    cb = MadNLP.create_callback(Callback, nlp)
    # Define options for LBFGS
    p = 20
    qn_options = MadNLP.QuasiNewtonOptions(; max_history=p)

    kkt = MadNLP.create_kkt_system(
        KKTSystem,
        cb,
        linear_solver;
        hessian_approximation=MadNLP.CompactLBFGS,
        qn_options=qn_options,
    )
    @test isa(kkt.quasi_newton, MadNLP.CompactLBFGS)
    # Test options are correctly passed to MadNLP
    @test kkt.quasi_newton.max_mem == p
end

struct HS15Model{T} <: NLPModels.AbstractNLPModel{T,Vector{T}}
    meta::NLPModels.NLPModelMeta{T, Vector{T}}
    counters::NLPModels.Counters
end

function HS15Model(;T = Float64, x0=zeros(T,2), y0=zeros(T,2))
    return HS15Model(
        NLPModels.NLPModelMeta(
            2,     #nvar
            ncon = 2,
            nnzj = 4,
            nnzh = 3,
            x0 = x0,
            y0 = y0,
            lvar = T[-Inf, -Inf],
            uvar = T[0.5, Inf],
            lcon = T[1.0, 0.0],
            ucon = T[Inf, Inf],
            sparse_jacobian = false,
            sparse_hessian = false,
            minimize = true
        ),
        NLPModels.Counters()
    )
end

function NLPModels.obj(nlp::HS15Model, x::AbstractVector)
    return 100.0 * (x[2] - x[1]^2)^2 + (1.0 - x[1])^2
end

function NLPModels.grad!(nlp::HS15Model, x::AbstractVector, g::AbstractVector)
    z = x[2] - x[1]^2
    g[1] = -400.0 * z * x[1] - 2.0 * (1.0 - x[1])
    g[2] = 200.0 * z
    return
end

function NLPModels.cons!(nlp::HS15Model, x::AbstractVector, c::AbstractVector)
    c[1] = x[1] * x[2]
    c[2] = x[1] + x[2]^2
end

function NLPModels.jac_structure!(nlp::HS15Model, I::AbstractVector{T}, J::AbstractVector{T}) where T
    copyto!(I, [1, 1, 2, 2])
    copyto!(J, [1, 2, 1, 2])
end

function NLPModels.jac_coord!(nlp::HS15Model, x::AbstractVector, J::AbstractVector)
    J[1] = x[2]    # (1, 1)
    J[2] = x[1]    # (1, 2)
    J[3] = 1.0     # (2, 1)
    J[4] = 2*x[2]  # (2, 2)
    return J
end

function NLPModels.jprod!(nlp::HS15Model, x::AbstractVector, v::AbstractVector, jv::AbstractVector)
    jv[1] = x[2] * v[1] + x[1] * v[2]
    jv[2] = v[1] + 2 * x[2] * v[2]
    return jv
end

function NLPModels.jtprod!(nlp::HS15Model, x::AbstractVector, v::AbstractVector, jv::AbstractVector)
    jv[1] = x[2] * v[1] + v[2]
    jv[2] = x[1] * v[1] + 2 * x[2] * v[2]
    return jv
end

function NLPModels.jac_dense!(nlp::HS15Model, x::AbstractVector, J::AbstractMatrix)
    J[1, 1] = x[2]    # (1, 1)
    J[1, 2] = x[1]    # (1, 2)
    J[2, 1] = 1.0     # (2, 1)
    J[2, 2] = 2*x[2]  # (2, 2)
    return J
end

function NLPModels.hess_structure!(nlp::HS15Model, I::AbstractVector{T}, J::AbstractVector{T}) where T
    copyto!(I, [1, 2, 2])
    copyto!(J, [1, 1, 2])
end

function NLPModels.hess_coord!(nlp::HS15Model, x, y, H::AbstractVector; obj_weight=1.0)
    # Objective
    H[1] = obj_weight * (-400.0 * x[2] + 1200.0 * x[1]^2 + 2.0)
    H[2] = obj_weight * (-400.0 * x[1])
    H[3] = obj_weight * 200.0
    # First constraint
    H[2] += y[1] * 1.0
    # Second constraint
    H[3] += y[2] * 2.0
    return H
end

function NLPModels.hess_dense!(nlp::HS15Model, x, y, H::AbstractMatrix; obj_weight=1.0)
    H[1, 1] = obj_weight * (-400.0 * x[2] + 1200.0 * x[1]^2 + 2.0)
    H[2, 1] = obj_weight * (-400.0 * x[1])
    H[2, 2] = obj_weight * 200.0
    # First constraint
    H[2, 1] += y[1] * 1.0
    # Second constraint
    H[2, 2] += y[2] * 2.0
    H[1, 2] = H[2, 1]
    return H
end

using Test, MadNLP, MadNLPKrylov, MadNLPTests

testset = [
    [
        "Iterative",
        ()->MadNLP.Optimizer(
            iterative_solver=MadNLPKrylov.KrylovIterator,
            print_level=MadNLP.ERROR),
        []
    ],
]

@testset "MadNLPKrylov test" begin
    for (name,optimizer_constructor,exclude) in testset
        test_madnlp(name,optimizer_constructor,exclude)
    end
end

@kwdef mutable struct Ma97Options <: AbstractOptions
    ma97_num_threads::Int = 1
    ma97_print_level::Int = -1
    ma97_nemin::Int = 8
    ma97_small::Float64 = 1e-20
    ma97_order::Ordering = METIS
    ma97_scaling::Scaling = SCALING_NONE
    ma97_u::Float64 = 1e-8
    ma97_umax::Float64 = 1e-4
end

mutable struct Ma97Solver{T,INT} <: AbstractLinearSolver{T}
    n::INT

    csc::SparseMatrixCSC{T,INT}

    control::Ma97Control{T,INT}
    info::Ma97Info{T,INT}

    akeep::Vector{Ptr{Cvoid}}
    fkeep::Vector{Ptr{Cvoid}}

    opt::Ma97Options
    logger::MadNLPLogger
end

ma97_set_num_threads(n) = HSL.omp_set_num_threads(n)

function Ma97Solver(
    csc::SparseMatrixCSC{T,INT};
    opt = Ma97Options(),
    logger = MadNLPLogger(),
) where {T,INT}

    ma97_set_num_threads(opt.ma97_num_threads)

    n = INT(csc.n)

    info = Ma97Info{T,INT}()
    control = Ma97Control{T,INT}()
    HSL.ma97_default_control(T, INT, control)

    control.print_level = opt.ma97_print_level
    control.f_arrays = 1
    control.nemin = opt.ma97_nemin
    control.ordering = INT(opt.ma97_order)
    control.small = opt.ma97_small
    control.u = opt.ma97_u
    control.scaling = INT(opt.ma97_scaling)

    akeep = [C_NULL]
    fkeep = [C_NULL]

    HSL.ma97_analyse(
        T,
        INT,
        INT(1),
        n,
        csc.colptr,
        csc.rowval,
        C_NULL,
        akeep,
        control,
        info,
        C_NULL,
    )
    info.flag < 0 && throw(SymbolicException())
    M = Ma97Solver{T,INT}(n, csc, control, info, akeep, fkeep, opt, logger)
    finalizer(finalize, M)
    return M
end
function factorize!(M::Ma97Solver{T,INT}) where {T,INT}
    HSL.ma97_factor(
        T,
        INT,
        INT(4),
        C_NULL,
        C_NULL,
        M.csc.nzval,
        M.akeep,
        M.fkeep,
        M.control,
        M.info,
        C_NULL,
    )
    M.info.flag < 0 && throw(FactorizationException())
    return M
end
function solve_linear_system!(M::Ma97Solver{T,INT}, rhs::Vector{T}) where {T,INT}
    HSL.ma97_solve(T, INT, INT(0), INT(1), rhs, M.n, M.akeep, M.fkeep, M.control, M.info)
    M.info.flag < 0 && throw(SolveException())
    return rhs
end
is_inertia(::Ma97Solver) = true
function inertia(M::Ma97Solver)
    return (M.info.matrix_rank - M.info.num_neg, M.n - M.info.matrix_rank, M.info.num_neg)
end

function finalize(M::Ma97Solver{T,INT}) where {T,INT}
    HSL.ma97_finalise(T, INT, M.akeep, M.fkeep)
end

function improve!(M::Ma97Solver)
    if M.control.u == M.opt.ma97_umax
        @debug(M.logger, "improve quality failed.")
        return false
    end
    M.control.u = min(M.opt.ma97_umax, M.control.u^0.75)
    @debug(M.logger, "improved quality: pivtol = $(M.control.u)")
    return true
end
introduce(::Ma97Solver) = "ma97 v$(HSL.HSL_MA97_version())"
input_type(::Type{Ma97Solver}) = :csc
default_options(::Type{Ma97Solver}) = Ma97Options()
is_supported(::Type{Ma97Solver}, ::Type{T}) where T <: AbstractFloat = HSL.is_supported(Val(:hsl_ma97), T)

using Test, MadNLP, MadNLPHSL, MadNLPTests, HSL, Quadmath

testset = [
    [
        "HSL-Ma27",
        ()->MadNLP.Optimizer(
            linear_solver=Ma27Solver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "HSL-Ma57",
        ()->MadNLP.Optimizer(
            linear_solver=Ma57Solver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "HSL-Ma77",
        ()->MadNLP.Optimizer(
            linear_solver=Ma77Solver,
            print_level=MadNLP.ERROR),
        ["unbounded"]
    ],
    [
        "HSL-Ma86",
        ()->MadNLP.Optimizer(
            linear_solver=Ma86Solver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "HSL-Ma97",
        ()->MadNLP.Optimizer(
            linear_solver=Ma97Solver,
            print_level=MadNLP.ERROR),
        []
    ],
]

@testset "MadNLPHSL test" begin
    if LIBHSL_isfunctional()
        for (hsl_solver, package) in [(Ma27Solver, "ma27"),
                                      (Ma57Solver, "ma57"),
                                      (Ma77Solver, "ma77"),
                                      (Ma86Solver, "ma86"),
                                      (Ma97Solver, "ma97")]
            @testset "$package" begin
                # MadNLPTests.test_linear_solver(hsl_solver,Float32)
                @testset "Float64" begin
                    MadNLPTests.test_linear_solver(hsl_solver,Float64)
                end
                if MadNLPHSL.is_supported(hsl_solver, Float128)
                    @testset "Float128" begin
                        MadNLPTests.test_linear_solver(hsl_solver,Float128)
                    end
                end
            end
        end
        for (name,optimizer_constructor,exclude) in testset
            test_madnlp(name,optimizer_constructor,exclude)
        end
    end
end

# ordering
@enum ORDERING begin
    DEFAULT_ORDERING = 0
    METIS_ORDERING = 1
    AMD_ORDERING = 2
    USER_ORDERING = 3
    SYMAMD_ORDERING = 4
    COLAMD_ORDERING = 5
end

# Local function to move data on the device.
gpu_transfer!(x::AbstractArray, y::AbstractArray) = copyto!(x, y)

# GPU sparse CSC to dense matrix transfer (uses _csc_to_dense_kernel! from kernels_sparse.jl).
# Works for any GPU sparse CSC type with .colPtr, .rowVal, .nzVal fields.
# Called from per-backend gpu_transfer! stubs that dispatch on concrete sparse CSC types.
function _gpu_sparse_csc_to_dense!(y::AbstractGPUMatrix{T}, x) where {T}
    n = size(y, 2)
    fill!(y, zero(T))
    backend = get_backend(y)
    _csc_to_dense_kernel!(backend)(y, x.colPtr, x.rowVal, x.nzVal, ndrange = n)
    return
end

# Workaround for broken norm() on views of GPU arrays.
# See: https://github.com/JuliaGPU/CUDA.jl/issues/2811
#      https://github.com/JuliaGPU/AMDGPU.jl/issues/607
if VERSION > v"1.11"
    _my1norm(x) = mapreduce(abs, +, x)
    function MadNLP.get_sd(l::AbstractGPUVector{T}, zl_r, zu_r, s_max) where {T}
        return max(
            s_max,
            (_my1norm(l) + _my1norm(zl_r) + _my1norm(zu_r)) / max(1, (length(l) + length(zl_r) + length(zu_r))),
        ) / s_max
    end
    function MadNLP.get_sc(zl_r::SubArray{T, 1, VT}, zu_r, s_max) where {T, VT <: AbstractGPUVector{T}}
        return max(
            s_max,
            (_my1norm(zl_r) + _my1norm(zu_r)) / max(1, length(zl_r) + length(zu_r)),
        ) / s_max
    end
end

"""
    madnlp(model::AbstractNLPModel; options...)

Build a [`MadNLPSolver`](@ref) and solve it using
the interior-point method. Return the solution
as a [`MadNLPExecutionStats`](@ref).

"""
function madnlp(model::AbstractNLPModel; kwargs...)
    solver = MadNLPSolver(model; kwargs...)
    return solve!(solver)
end

function initialize!(solver::AbstractMadNLPSolver{T}) where T

    nlp = get_nlp(solver)
    opt = get_opt(solver)

    # Initializing variables
    @trace(get_logger(solver),"Initializing variables.")
    initialize!(
        get_cb(solver),
        get_x(solver),
        get_xl(solver),
        get_xu(solver),
        get_y(solver),
        get_rhs(solver),
        get_ind_ineq(solver);
        tol=opt.bound_relax_factor,
        bound_push=opt.bound_push,
        bound_fac=opt.bound_fac,
    )
    fill!(get_jacl(solver), zero(T))
    fill!(get_zl_r(solver), one(T))
    fill!(get_zu_r(solver), one(T))

    # Initializing scaling factors
    if opt.nlp_scaling
        set_scaling!(
            get_cb(solver),
            get_x(solver),
            get_xl(solver),
            get_xu(solver),
            get_y(solver),
            get_rhs(solver),
            get_ind_ineq(solver),
            opt.nlp_scaling_max_gradient
        )
    end

    # Initializing KKT system
    initialize!(get_kkt(solver))

    # Initializing jacobian and gradient
    eval_jac_wrapper!(solver, get_kkt(solver), get_x(solver))
    eval_grad_f_wrapper!(solver, get_f(solver),get_x(solver))


    @trace(get_logger(solver),"Initializing constraint duals.")
    if !get_opt(solver).dual_initialized
        initialize_dual(solver, opt.dual_initialization_method)
    end

    # Initializing
    set_obj_val!(solver, eval_f_wrapper(solver, get_x(solver)))
    eval_cons_wrapper!(solver, get_c(solver), get_x(solver))
    eval_lag_hess_wrapper!(solver, get_kkt(solver), get_x(solver), get_y(solver))

    theta = get_theta(get_c(solver))
    set_theta_max!(solver, T(1e4)*max(one(T),theta))
    set_theta_min!(solver, T(1e-4)*max(one(T),theta))
    set_mu!(solver, get_opt(solver).barrier.mu_init)
    set_tau!(solver, max(get_opt(solver).tau_min,one(T)-get_opt(solver).barrier.mu_init))
    push!(get_filter(solver), (get_theta_max(solver),-T(Inf)))

    return REGULAR
end

abstract type DualInitializeOptions end
struct DualInitializeSetZero <: DualInitializeOptions end
struct DualInitializeLeastSquares <: DualInitializeOptions end

function initialize_dual(solver::AbstractMadNLPSolver{T}, ::Type{DualInitializeSetZero}) where T
    fill!(get_y(solver), zero(T))
end
function initialize_dual(solver::AbstractMadNLPSolver{T}, ::Type{DualInitializeLeastSquares}) where T
    set_initial_rhs!(solver, get_kkt(solver))
    factorize_wrapper!(solver)
    is_solved = solve_refine_wrapper!(
        get_d(solver), solver, get_p(solver), get__w4(solver)
    )
    if !is_solved || (norm(dual(get_d(solver)), T(Inf)) > get_opt(solver).constr_mult_init_max)
        fill!(get_y(solver), zero(T))
    else
        copyto!(get_y(solver), dual(get_d(solver)))
    end
end

function reinitialize!(solver::AbstractMadNLPSolver)
    variable(get_x(solver)) .= get_x0(get_nlp(solver))

    set_obj_val!(solver, eval_f_wrapper(solver, get_x(solver)))
    eval_grad_f_wrapper!(solver, get_f(solver), get_x(solver))
    eval_cons_wrapper!(solver, get_c(solver), get_x(solver))
    eval_jac_wrapper!(solver, get_kkt(solver), get_x(solver))
    eval_lag_hess_wrapper!(solver, get_kkt(solver), get_x(solver), get_y(solver))

    theta = get_theta(get_c(solver))
    set_theta_max!(solver, 1e4*max(1,theta))
    set_theta_min!(solver, 1e-4*max(1,theta))
    set_mu!(solver, get_opt(solver).barrier.mu_init)
    set_tau!(solver, max(get_opt(solver).tau_min,1-get_opt(solver).barrier.mu_init))
    empty!(get_filter(solver))
    push!(get_filter(solver), (get_theta_max(solver),-Inf))

    return REGULAR
end

# major loops ---------------------------------------------------------
"""
    solve!(
        solver::AbstractMadNLPSolver,
        stats::MadNLPExecutionStats;
        kwargs...
    )

Solve the problem formulated inside `solver`. Return the solution
in `stats` by modifying inplace the values. The options are specified in `kwargs`.

"""
solve!(solver::AbstractMadNLPSolver; kwargs...) = solve!(solver, MadNLPExecutionStats(solver); kwargs...)
function solve!(
    solver::AbstractMadNLPSolver,
    stats::MadNLPExecutionStats;
    kwargs...
)
    if !isempty(kwargs)
        @warn(get_logger(solver),"The options set during resolve may not have an effect")
        set_options!(get_opt(solver), kwargs)
    end

    # If the problem has no free variable, do nothing
    if get_n(solver) == 0
        update!(stats, solver)
        return stats
    end

    try
        if get_status(solver) == INITIAL
            @notice(get_logger(solver),"This is $(introduce()), running with $(introduce(get_kkt(solver).linear_solver))\n")
            print_init(solver)
            set_status!(solver, initialize!(solver))
        else # resolving the problem
            set_status!(solver, reinitialize!(solver))
        end

        if is_async(get_kkt(solver).linear_solver)
            @trace(get_logger(solver), "linear solver time is not available for asynchronous linear solvers.")
            get_cnt(solver).linear_solver_time = NaN
        end

        while get_status(solver) >= REGULAR
            get_status(solver) == REGULAR && (set_status!(solver, regular!(solver)))
            get_status(solver) == RESTORE && (set_status!(solver, restore!(solver)))
            get_status(solver) == ROBUST && (set_status!(solver, robust!(solver)))
        end
    catch e
        if e isa InvalidNumberException
            if e.callback == :obj
                set_status!(solver, INVALID_NUMBER_OBJECTIVE)
            elseif e.callback == :grad
                set_status!(solver, INVALID_NUMBER_GRADIENT)
            elseif e.callback == :cons
                set_status!(solver, INVALID_NUMBER_CONSTRAINTS)
            elseif e.callback == :jac
                set_status!(solver, INVALID_NUMBER_JACOBIAN)
            elseif e.callback == :hess
                set_status!(solver, INVALID_NUMBER_HESSIAN_LAGRANGIAN)
            else
                set_status!(solver, INVALID_NUMBER_DETECTED)
            end
        elseif e isa NotEnoughDegreesOfFreedomException
            set_status!(solver, NOT_ENOUGH_DEGREES_OF_FREEDOM)
        elseif e isa LinearSolverException
            set_status!(solver, ERROR_IN_STEP_COMPUTATION;)
            get_opt(solver).rethrow_error && rethrow(e)
        elseif e isa InterruptException
            set_status!(solver, USER_REQUESTED_STOP)
            get_opt(solver).rethrow_error && rethrow(e)
        else
            set_status!(solver, INTERNAL_ERROR)
            get_opt(solver).rethrow_error && rethrow(e)
        end
    finally
        get_cnt(solver).total_time = time() - get_cnt(solver).start_time
        if !(get_status(solver) < SOLVE_SUCCEEDED)
            print_summary(solver)
        end
        @notice(get_logger(solver),"$(Base.text_colors[color_status(get_status(solver))])EXIT: $(get_status_output(get_status(solver), get_opt(solver)))$(Base.text_colors[:normal])")
        get_opt(solver).disable_garbage_collector &&
            (GC.enable(true); @warn(get_logger(solver),"Julia garbage collector is turned back on"))
        finalize(get_logger(solver))

        update!(stats,solver)
    end


    return stats
end

color_status(status::Status) =
    status <= SOLVE_SUCCEEDED ? :green :
    status <= SOLVED_TO_ACCEPTABLE_LEVEL ? :blue : :red


function regular!(solver::AbstractMadNLPSolver{T}) where T
    while true
        if (get_cnt(solver).k!=0 && !get_opt(solver).jacobian_constant)
            eval_jac_wrapper!(solver, get_kkt(solver), get_x(solver))
        end

        jtprod!(get_jacl(solver), get_kkt(solver), get_y(solver))
        sd = get_sd(get_y(solver),get_zl_r(solver),get_zu_r(solver),T(get_opt(solver).s_max))
        sc = get_sc(get_zl_r(solver),get_zu_r(solver),T(get_opt(solver).s_max))
        set_inf_pr!(solver, get_inf_pr(get_c(solver)))
        set_inf_du!(solver, get_inf_du(
            full(get_f(solver)),
            full(get_zl(solver)),
            full(get_zu(solver)),
            get_jacl(solver),
            sd,
        ))
        set_inf_compl!(solver, get_inf_compl(solver, sc; mu=zero(T)))

        print_iter(solver)

        # evaluate termination criteria
        @trace(get_logger(solver),"Evaluating termination criteria.")
        !(get_intermediate_callback(solver)(solver, UserCallbackRegular()) :: Bool) && return USER_REQUESTED_STOP
        get_inf_total(solver) <= get_opt(solver).tol && return SOLVE_SUCCEEDED
        get_inf_total(solver) <= get_opt(solver).acceptable_tol ?
            (get_cnt(solver).acceptable_cnt < get_opt(solver).acceptable_iter ?
            get_cnt(solver).acceptable_cnt+=1 : return SOLVED_TO_ACCEPTABLE_LEVEL) : (get_cnt(solver).acceptable_cnt = 0)
        get_inf_total(solver) >= get_opt(solver).diverging_iterates_tol && return DIVERGING_ITERATES
        get_cnt(solver).k>=get_opt(solver).max_iter && return MAXIMUM_ITERATIONS_EXCEEDED
        time()-get_cnt(solver).start_time>=get_opt(solver).max_wall_time && return MAXIMUM_WALLTIME_EXCEEDED

        # evaluate Hessian
        if (get_cnt(solver).k!=0 && !get_opt(solver).hessian_constant)
            eval_lag_hess_wrapper!(solver, get_kkt(solver), get_x(solver), get_y(solver))
        end

        # update the barrier parameter
        @trace(get_logger(solver),"Updating the barrier parameter.")
        update_barrier!(get_opt(solver).barrier, solver, sc)

        # factorize the KKT system and solve Newton step
        @trace(get_logger(solver),"Computing the Newton step.")
        set_aug_diagonal!(get_kkt(solver),solver)
        set_aug_rhs!(solver, get_kkt(solver), get_c(solver), get_mu(solver))
        dual_inf_perturbation!(primal(get_p(solver)),get_ind_llb(solver),get_ind_uub(solver),get_mu(solver),get_opt(solver).kappa_d)
        inertia_correction!(get_inertia_corrector(solver), solver) || return ROBUST

        @trace(get_logger(solver),"Backtracking line search initiated.")
        status = filter_line_search!(solver)
        if status != LINESEARCH_SUCCEEDED
            return status
        end

        @trace(get_logger(solver),"Updating primal-dual variables.")
        copyto!(full(get_x(solver)), full(get_x_trial(solver)))
        copyto!(get_c(solver), get_c_trial(solver))
        set_obj_val!(solver, get_obj_val_trial(solver))
        adjust_boundary!(get_x_lr(solver),get_xl_r(solver),get_x_ur(solver),get_xu_r(solver),get_mu(solver))

        axpy!(get_alpha(solver),dual(get_d(solver)),get_y(solver))

        get_zl_r(solver) .+= get_alpha_z(solver) .* dual_lb(get_d(solver))
        get_zu_r(solver) .+= get_alpha_z(solver) .* dual_ub(get_d(solver))
        reset_bound_dual!(
            primal(get_zl(solver)),
            primal(get_x(solver)),
            primal(get_xl(solver)),
            get_mu(solver),get_opt(solver).kappa_sigma,
        )
        reset_bound_dual!(
            primal(get_zu(solver)),
            primal(get_xu(solver)),
            primal(get_x(solver)),
            get_mu(solver),get_opt(solver).kappa_sigma,
        )

        eval_grad_f_wrapper!(solver, get_f(solver),get_x(solver))

        get_cnt(solver).k+=1
        @trace(get_logger(solver),"Proceeding to the next interior point iteration.")
    end
end

function restore!(solver::AbstractMadNLPSolver{T}) where T
    set_del_w!(solver, zero(T))
    # Backup the previous primal iterate
    copyto!(primal(get__w1(solver)), full(get_x(solver)))
    copyto!(dual(get__w1(solver)), get_y(solver))
    copyto!(dual(get__w2(solver)), get_c(solver))

    F = get_F(
        get_c(solver),
        primal(get_f(solver)),
        primal(get_zl(solver)),
        primal(get_zu(solver)),
        get_jacl(solver),
        get_x_lr(solver),
        get_xl_r(solver),
        get_zl_r(solver),
        get_xu_r(solver),
        get_x_ur(solver),
        get_zu_r(solver),
        get_mu(solver),
    )
    set_alpha_z!(solver, zero(T))
    set_ftype!(solver, "R")
    while true
        alpha_max = get_alpha_max(
            primal(get_x(solver)),
            primal(get_xl(solver)),
            primal(get_xu(solver)),
            primal(get_d(solver)),
            get_tau(solver),
        )
        set_alpha!(solver,min(
            alpha_max,
            get_alpha_z(get_zl_r(solver),get_zu_r(solver),dual_lb(get_d(solver)),dual_ub(get_d(solver)),get_tau(solver)),
        ))

        axpy!(get_alpha(solver), primal(get_d(solver)), full(get_x(solver)))
        axpy!(get_alpha(solver), dual(get_d(solver)), get_y(solver))
        get_zl_r(solver) .+= get_alpha(solver) .* dual_lb(get_d(solver))
        get_zu_r(solver) .+= get_alpha(solver) .* dual_ub(get_d(solver))

        eval_cons_wrapper!(solver,get_c(solver),get_x(solver))
        eval_grad_f_wrapper!(solver,get_f(solver),get_x(solver))
        set_obj_val!(solver, eval_f_wrapper(solver,get_x(solver)))

        !get_opt(solver).jacobian_constant && eval_jac_wrapper!(solver,get_kkt(solver),get_x(solver))
        jtprod!(get_jacl(solver),get_kkt(solver),get_y(solver))

        F_trial = get_F(
            get_c(solver),
            primal(get_f(solver)),
            primal(get_zl(solver)),
            primal(get_zu(solver)),
            get_jacl(solver),
            get_x_lr(solver),
            get_xl_r(solver),
            get_zl_r(solver),
            get_xu_r(solver),
            get_x_ur(solver),
            get_zu_r(solver),
            get_mu(solver),
        )
        if F_trial > get_opt(solver).soft_resto_pderror_reduction_factor*F
            copyto!(primal(get_x(solver)), primal(get__w1(solver)))
            copyto!(get_y(solver), dual(get__w1(solver)))
            copyto!(get_c(solver), dual(get__w2(solver))) # backup the previous primal iterate
            return ROBUST
        end

        adjust_boundary!(get_x_lr(solver),get_xl_r(solver),get_x_ur(solver),get_xu_r(solver),get_mu(solver))

        F = F_trial

        theta = get_theta(get_c(solver))
        varphi= get_varphi(get_obj_val(solver),get_x_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_ur(solver),get_mu(solver))

        get_cnt(solver).k+=1
        !(get_intermediate_callback(solver)(solver, UserCallbackRestore()) :: Bool) && return USER_REQUESTED_STOP

        is_filter_acceptable(get_filter(solver),theta,varphi) ? (return REGULAR) : (get_cnt(solver).t+=1)
        get_cnt(solver).k>=get_opt(solver).max_iter && return MAXIMUM_ITERATIONS_EXCEEDED
        time()-get_cnt(solver).start_time>=get_opt(solver).max_wall_time && return MAXIMUM_WALLTIME_EXCEEDED


        sd = get_sd(get_y(solver),get_zl_r(solver),get_zu_r(solver),get_opt(solver).s_max)
        sc = get_sc(get_zl_r(solver),get_zu_r(solver),get_opt(solver).s_max)
        set_inf_pr!(solver, get_inf_pr(get_c(solver)))
        set_inf_du!(solver, get_inf_du(
            primal(get_f(solver)),
            primal(get_zl(solver)),
            primal(get_zu(solver)),
            get_jacl(solver),
            sd,
        ))

        set_inf_compl!(solver, get_inf_compl(get_x_lr(solver),get_xl_r(solver),get_zl_r(solver),get_xu_r(solver),get_x_ur(solver),get_zu_r(solver),zero(T),sc))
        set_inf_compl_mu!(solver, get_inf_compl(get_x_lr(solver),get_xl_r(solver),get_zl_r(solver),get_xu_r(solver),get_x_ur(solver),get_zu_r(solver),get_mu(solver),sc))
        print_iter(solver)

        !get_opt(solver).hessian_constant && eval_lag_hess_wrapper!(solver,get_kkt(solver),get_x(solver),get_y(solver))
        set_aug_diagonal!(get_kkt(solver),solver)
        set_aug_rhs!(solver, get_kkt(solver), get_c(solver), get_mu(solver))

        dual_inf_perturbation!(primal(get_p(solver)),get_ind_llb(solver),get_ind_uub(solver),get_mu(solver),get_opt(solver).kappa_d)
        factorize_wrapper!(solver)
        solve_refine_wrapper!(
            get_d(solver), solver, get_p(solver), get__w4(solver)
        )

        set_ftype!(solver, "f")
    end
end

function robust!(solver::AbstractMadNLPSolver{T}) where T
    initialize_robust_restorer!(solver)
    RR = get_RR(solver)
    while true
        if !get_opt(solver).jacobian_constant
            eval_jac_wrapper!(solver, get_kkt(solver), get_x(solver))
        end
        jtprod!(get_jacl(solver), get_kkt(solver), get_y(solver))

        # evaluate termination criteria
        @trace(get_logger(solver),"Evaluating restoration phase termination criteria.")
        sd = get_sd(get_y(solver),get_zl_r(solver),get_zu_r(solver),get_opt(solver).s_max)
        sc = get_sc(get_zl_r(solver),get_zu_r(solver),get_opt(solver).s_max)
        set_inf_pr!(solver, get_inf_pr(get_c(solver)))
        set_inf_du!(solver, get_inf_du(
            primal(get_f(solver)),
            primal(get_zl(solver)),
            primal(get_zu(solver)),
            get_jacl(solver),
            sd,
        ))
        set_inf_compl!(solver, get_inf_compl(get_x_lr(solver),get_xl_r(solver),get_zl_r(solver),get_xu_r(solver),get_x_ur(solver),get_zu_r(solver),zero(T),sc))

        # Robust restoration phase error
        RR.inf_pr_R = get_inf_pr_R(get_c(solver),RR.pp,RR.nn)
        RR.inf_du_R = get_inf_du_R(RR.f_R,get_y(solver),primal(get_zl(solver)),primal(get_zu(solver)),get_jacl(solver),RR.zp,RR.zn,get_opt(solver).rho,sd)
        RR.inf_compl_R = get_inf_compl_R(
            get_x_lr(solver),get_xl_r(solver),get_zl_r(solver),get_xu_r(solver),get_x_ur(solver),get_zu_r(solver),RR.pp,RR.zp,RR.nn,RR.zn,zero(T),sc)

        print_iter(solver;is_resto=true)
        !(get_intermediate_callback(solver)(solver, UserCallbackRobust()) :: Bool) && return USER_REQUESTED_STOP

        max(RR.inf_pr_R,RR.inf_du_R,RR.inf_compl_R) <= get_opt(solver).tol && return INFEASIBLE_PROBLEM_DETECTED
        get_cnt(solver).k>=get_opt(solver).max_iter && return MAXIMUM_ITERATIONS_EXCEEDED
        time()-get_cnt(solver).start_time>=get_opt(solver).max_wall_time && return MAXIMUM_WALLTIME_EXCEEDED

        # update the barrier parameter
        @trace(get_logger(solver),"Updating restoration phase barrier parameter.")
        _update_monotone_RR!(get_opt(solver).barrier, solver, sc)

        # compute the Newton step
        if !get_opt(solver).hessian_constant
            eval_lag_hess_wrapper!(solver, get_kkt(solver), get_x(solver), get_y(solver); is_resto=true)
        end

        # without inertia correction,
        @trace(get_logger(solver),"Solving restoration phase primal-dual system.")
        set_aug_RR!(get_kkt(solver), solver, RR)
        set_aug_rhs_RR!(solver, get_kkt(solver), RR, get_opt(solver).rho)
        inertia_correction!(get_inertia_corrector(solver), solver) || return RESTORATION_FAILED
        finish_aug_solve_RR!(
            RR.dpp,RR.dnn,RR.dzp,RR.dzn,get_y(solver),dual(get_d(solver)),
            RR.pp,RR.nn,RR.zp,RR.zn,RR.mu_R,get_opt(solver).rho
        )

        # filter start
        @trace(get_logger(solver),"Backtracking line search initiated.")
        status = filter_line_search_RR!(solver)
        if status != LINESEARCH_SUCCEEDED
            return status
        end

        @trace(get_logger(solver),"Updating primal-dual variables.")
        copyto!(full(get_x(solver)), full(get_x_trial(solver)))
        copyto!(get_c(solver), get_c_trial(solver))
        copyto!(RR.pp, RR.pp_trial)
        copyto!(RR.nn, RR.nn_trial)

        RR.obj_val_R=RR.obj_val_R_trial
        set_f_RR!(solver,RR)

        axpy!(get_alpha(solver), dual(get_d(solver)), get_y(solver))
        axpy!(get_alpha_z(solver), RR.dzp,RR.zp)
        axpy!(get_alpha_z(solver), RR.dzn,RR.zn)

        get_zl_r(solver) .+= get_alpha_z(solver) .* dual_lb(get_d(solver))
        get_zu_r(solver) .+= get_alpha_z(solver) .* dual_ub(get_d(solver))

        reset_bound_dual!(
            primal(get_zl(solver)),
            primal(get_x(solver)),
            primal(get_xl(solver)),
            RR.mu_R, get_opt(solver).kappa_sigma,
        )
        reset_bound_dual!(
            primal(get_zu(solver)),
            primal(get_xu(solver)),
            primal(get_x(solver)),
            RR.mu_R, get_opt(solver).kappa_sigma,
        )
        reset_bound_dual!(RR.zp,RR.pp,RR.mu_R,get_opt(solver).kappa_sigma)
        reset_bound_dual!(RR.zn,RR.nn,RR.mu_R,get_opt(solver).kappa_sigma)

        adjust_boundary!(get_x_lr(solver),get_xl_r(solver),get_x_ur(solver),get_xu_r(solver),get_mu(solver))

        # check if going back to regular phase
        @trace(get_logger(solver),"Checking if going back to regular phase.")
        set_obj_val!(solver, eval_f_wrapper(solver, get_x(solver)))
        eval_grad_f_wrapper!(solver, get_f(solver), get_x(solver))
        theta = get_theta(get_c(solver))
        varphi= get_varphi(get_obj_val(solver),get_x_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_ur(solver),get_mu(solver))

        if is_filter_acceptable(get_filter(solver),theta,varphi) &&
            theta <= get_opt(solver).required_infeasibility_reduction * RR.theta_ref

            @trace(get_logger(solver),"Going back to the regular phase.")
            set_initial_rhs!(solver, get_kkt(solver))
            initialize!(get_kkt(solver))

            factorize_wrapper!(solver)
            solve_refine_wrapper!(
                get_d(solver), solver, get_p(solver), get__w4(solver)
            )
            if norm(dual(get_d(solver)), Inf)>get_opt(solver).constr_mult_init_max
                fill!(get_y(solver), zero(T))
            else
                copyto!(get_y(solver), dual(get_d(solver)))
            end

            get_cnt(solver).k+=1
            get_cnt(solver).t+=1

            return REGULAR
        end

        get_cnt(solver).k>=get_opt(solver).max_iter && return MAXIMUM_ITERATIONS_EXCEEDED
        time()-get_cnt(solver).start_time>=get_opt(solver).max_wall_time && return MAXIMUM_WALLTIME_EXCEEDED

        @trace(get_logger(solver),"Proceeding to the next restoration phase iteration.")
        get_cnt(solver).k+=1
        get_cnt(solver).t+=1
    end
end

function second_order_correction(solver::AbstractMadNLPSolver,alpha_max,theta,varphi,
                                 theta_trial,varphi_d,switching_condition::Bool)
    @trace(get_logger(solver),"Second-order correction started.")

    wx = primal(get__w1(solver))
    wy = dual(get__w1(solver))
    copyto!(wy, get_c_trial(solver))
    axpy!(alpha_max, get_c(solver), wy)

    theta_soc_old = theta_trial
    for p=1:get_opt(solver).max_soc
        # compute second order correction
        set_aug_rhs!(solver, get_kkt(solver), wy, get_mu(solver))
        dual_inf_perturbation!(
            primal(get_p(solver)),
            get_ind_llb(solver),get_ind_uub(solver),get_mu(solver),get_opt(solver).kappa_d,
        )
        solve_refine_wrapper!(
            get__w1(solver), solver, get_p(solver), get__w4(solver)
        )
        alpha_soc = get_alpha_max(
            primal(get_x(solver)),
            primal(get_xl(solver)),
            primal(get_xu(solver)),
            wx,get_tau(solver)
        )

        copyto!(primal(get_x_trial(solver)), primal(get_x(solver)))
        axpy!(alpha_soc, wx, primal(get_x_trial(solver)))
        eval_cons_wrapper!(solver, get_c_trial(solver), get_x_trial(solver))
        set_obj_val_trial!(solver, eval_f_wrapper(solver, get_x_trial(solver)))

        theta_soc = get_theta(get_c_trial(solver))
        varphi_soc= get_varphi(get_obj_val_trial(solver),get_x_trial_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_trial_ur(solver),get_mu(solver))

        !is_filter_acceptable(get_filter(solver),theta_soc,varphi_soc) && break

        if theta <=get_theta_min(solver) && switching_condition
            # Case I
            if is_armijo(varphi_soc,varphi,get_opt(solver).eta_phi,get_alpha(solver),varphi_d)
                @trace(get_logger(solver),"Step in second order correction accepted by armijo condition.")
                set_ftype!(solver, "F")
                set_alpha!(solver, alpha_soc)
                return true
            end
        else
            # Case II
            if is_sufficient_progress(theta_soc,theta,get_opt(solver).gamma_theta,varphi_soc,varphi,get_opt(solver).gamma_phi,has_constraints(solver))
                @trace(get_logger(solver),"Step in second order correction accepted by sufficient progress.")
                set_ftype!(solver, "H")
                set_alpha!(solver, alpha_soc)
                return true
            end
        end

        theta_soc>get_opt(solver).kappa_soc*theta_soc_old && break
        theta_soc_old = theta_soc
    end
    @trace(get_logger(solver),"Second-order correction terminated.")

    return false
end


function inertia_correction!(
    inertia_corrector::InertiaBased,
    solver::AbstractMadNLPSolver{T}
) where {T}

    n_trial = 0
    del_w_prev = zero(T)
    del_c_prev = zero(T)
    set_del_w!(solver, zero(T))
    set_del_c!(solver, zero(T))

    @trace(get_logger(solver),"Inertia-based regularization started.")

    factorize_wrapper!(solver)

    num_pos,num_zero,num_neg = inertia(get_kkt(solver).linear_solver)


    solve_status = if is_inertia_correct(get_kkt(solver), num_pos, num_zero, num_neg)
        # Try a backsolve. If the factorization has failed, solve_refine_wrapper returns false.
        solve_refine_wrapper!(get_d(solver), solver, get_p(solver), get__w4(solver))
    else
        false
    end

    while !solve_status
        @debug(get_logger(solver),"Primal-dual perturbed.")

        if n_trial == 0
            set_del_w!(solver, get_del_w_last(solver)==zero(T) ? get_opt(solver).first_hessian_perturbation :
                max(get_opt(solver).min_hessian_perturbation,get_opt(solver).perturb_dec_fact*get_del_w_last(solver))
                    )
        else
            set_del_w!(solver, get_del_w(solver) * (get_del_w_last(solver)==zero(T) ? get_opt(solver).perturb_inc_fact_first : get_opt(solver).perturb_inc_fact))
            if get_del_w(solver)>get_opt(solver).max_hessian_perturbation
                get_cnt(solver).k+=1
                @debug(get_logger(solver),"Primal regularization is too big. Switching to restoration phase.")
                return false
            end
        end
        set_del_c!(solver, should_regularize_dual(get_kkt(solver), num_pos, num_zero, num_neg) ? get_opt(solver).jacobian_regularization_value * get_mu(solver)^(get_opt(solver).jacobian_regularization_exponent) : zero(T))
        regularize_diagonal!(get_kkt(solver), get_del_w(solver) - del_w_prev, get_del_c(solver) - del_c_prev)
        del_w_prev = get_del_w(solver)
        del_c_prev = get_del_c(solver)

        factorize_wrapper!(solver)
        num_pos,num_zero,num_neg = inertia(get_kkt(solver).linear_solver)

        solve_status = if is_inertia_correct(get_kkt(solver), num_pos, num_zero, num_neg)
            solve_refine_wrapper!(get_d(solver), solver, get_p(solver), get__w4(solver))
        else
            false
        end

        n_trial += 1
    end

    get_del_w(solver) != 0 && (set_del_w_last!(solver, get_del_w(solver)))
    return true
end

function inertia_correction!(
    inertia_corrector::InertiaFree,
    solver::AbstractMadNLPSolver{T}
    ) where T
    n_trial = 0
    del_w_prev = zero(T)
    del_c_prev = zero(T)
    set_del_w!(solver, zero(T))
    set_del_c!(solver, zero(T))

    @trace(get_logger(solver),"Inertia-free regularization started.")
    dx = primal(get_d(solver))
    p0 = inertia_corrector.p0
    d0 = inertia_corrector.d0
    t = inertia_corrector.t
    n = primal(d0)
    wx= inertia_corrector.wx
    g = inertia_corrector.g

    set_g_ifr!(solver,g)
    set_aug_rhs_ifr!(solver, get_kkt(solver), p0)

    factorize_wrapper!(solver)

    solve_status = solve_refine_wrapper!(
        d0, solver, p0, get__w3(solver),
    ) && solve_refine_wrapper!(
        get_d(solver), solver, get_p(solver), get__w4(solver),
    )
    copyto!(t,dx)
    axpy!(-1.,n,t)

    while !curv_test(t,n,g,get_kkt(solver),wx,get_opt(solver).inertia_free_tol) || !solve_status
        @debug(get_logger(solver),"Primal-dual perturbed.")
        if n_trial == 0
            set_del_w!(solver, get_del_w_last(solver)==.0 ? get_opt(solver).first_hessian_perturbation :
                max(get_opt(solver).min_hessian_perturbation,get_opt(solver).perturb_dec_fact*get_del_w_last(solver))
                    )
        else
            set_del_w!(solver, get_del_w(solver) * (get_del_w_last(solver)==.0 ? get_opt(solver).perturb_inc_fact_first : get_opt(solver).perturb_inc_fact))
            if get_del_w(solver)>get_opt(solver).max_hessian_perturbation
                get_cnt(solver).k+=1
                @debug(get_logger(solver),"Primal regularization is too big. Switching to restoration phase.")
                return false
            end
        end
        set_del_c!(solver, get_opt(solver).jacobian_regularization_value * get_mu(solver)^(get_opt(solver).jacobian_regularization_exponent))
        regularize_diagonal!(get_kkt(solver), get_del_w(solver) - del_w_prev, get_del_c(solver) - del_c_prev)
        del_w_prev = get_del_w(solver)
        del_c_prev = get_del_c(solver)

        factorize_wrapper!(solver)
        solve_status = solve_refine_wrapper!(
            d0, solver, p0, get__w3(solver)
        ) && solve_refine_wrapper!(
            get_d(solver), solver, get_p(solver), get__w4(solver)
        )
        copyto!(t,dx)
        axpy!(-1.,n,t)

        n_trial += 1
    end

    get_del_w(solver) != 0 && (set_del_w_last!(solver, get_del_w(solver)))
    return true
end

function inertia_correction!(
    inertia_corrector::InertiaIgnore,
    solver::AbstractMadNLPSolver{T}
    ) where T

    n_trial = 0
    del_w_prev = zero(T)
    del_c_prev = zero(T)
    set_del_w!(solver, zero(T))
    set_del_c!(solver, zero(T))

    @trace(get_logger(solver),"Inertia-based regularization started.")

    factorize_wrapper!(solver)

    solve_status = solve_refine_wrapper!(
        get_d(solver), solver, get_p(solver), get__w4(solver),
    )
    while !solve_status
        @debug(get_logger(solver),"Primal-dual perturbed.")
        if n_trial == 0
            set_del_w!(solver, get_del_w_last(solver)==zero(T) ? get_opt(solver).first_hessian_perturbation :
                max(get_opt(solver).min_hessian_perturbation,get_opt(solver).perturb_dec_fact*get_del_w_last(solver)))
        else
            set_del_w!(solver, get_del_w(solver) * (get_del_w_last(solver)==zero(T) ? get_opt(solver).perturb_inc_fact_first : get_opt(solver).perturb_inc_fact))
            if get_del_w(solver)>get_opt(solver).max_hessian_perturbation
                get_cnt(solver).k+=1
                @debug(get_logger(solver),"Primal regularization is too big. Switching to restoration phase.")
                return false
            end
        end
        set_del_c!(solver, get_opt(solver).jacobian_regularization_value * get_mu(solver)^(get_opt(solver).jacobian_regularization_exponent))
        regularize_diagonal!(get_kkt(solver), get_del_w(solver) - del_w_prev, get_del_c(solver) - del_c_prev)
        del_w_prev = get_del_w(solver)
        del_c_prev = get_del_c(solver)

        factorize_wrapper!(solver)
        solve_status = solve_refine_wrapper!(
            get_d(solver), solver, get_p(solver), get__w4(solver)
        )
        n_trial += 1
    end
    get_del_w(solver) != 0 && (set_del_w_last!(solver, get_del_w(solver)))
    return true
end

function curv_test(t,n,g,kkt,wx,inertia_free_tol)
    mul_hess_blk!(wx, kkt, t)
    dot(wx,t) + max(dot(wx,n)-dot(g,n),0) - inertia_free_tol*dot(t,t) >=0
end

abstract type AbstractOptions end

# Pass MadNLP current status to the user callback
abstract type AbstractUserCallbackStatus end
struct UserCallbackRegular <: AbstractUserCallbackStatus end
struct UserCallbackRestore <: AbstractUserCallbackStatus end
struct UserCallbackRobust <: AbstractUserCallbackStatus end

abstract type AbstractUserCallback end
# By default, the user callback is deactivated
struct NoUserCallback <: AbstractUserCallback end
function (cb::NoUserCallback)(solver, mode::AbstractUserCallbackStatus)
    return true
end


# MadNLPLogger
@kwdef mutable struct MadNLPLogger
    print_level::LogLevels = INFO
    file_print_level::LogLevels = INFO
    file::Union{IOStream,Nothing} = nothing
end

get_level(logger::MadNLPLogger) = logger.print_level
get_file_level(logger::MadNLPLogger) = logger.file_print_level
get_file(logger::MadNLPLogger) = logger.file
finalize(logger::MadNLPLogger) = logger.file != nothing && close(logger.file)

for (name,level,color) in [(:trace,TRACE,7),(:debug,DEBUG,6),(:info,INFO,256),(:notice,NOTICE,256),(:warn,WARN,5),(:error,ERROR,9)]
    @eval begin
        macro $name(logger,str)
            gl = $get_level
            gfl= $get_file_level
            gf = $get_file
            l = $level
            c = $color
            code = quote
                if $gl($logger) <= $l
                    if $c == 256
                        println($str)
                    else
                        printstyled($str,"\n",color=$c)
                    end
                end
                if $gf($logger) != nothing && $gfl($logger) <= $l
                    println($gf($logger),$str)
                end
            end
            esc(code)
        end
    end
end

# Two-arguments BLAS.scal! is not supported in Julia 1.6.
function _scal!(a::T, x::AbstractVector{T}) where T
    return BLAS.scal!(length(x), a, x, 1)
end

# BLAS
# _ger! wraps ger! to dispatch on the data type.
_ger!(alpha::T, x::AbstractVector{T}, y::AbstractVector{T}, A::AbstractMatrix{T}) where T = BLAS.ger!(alpha, x, y, A)

# Similarly, _syr! wraps syr! to dispatch on the data type.
_syr!(uplo::Char, alpha::T, x::AbstractVector{T}, A::AbstractMatrix{T}) where T = BLAS.syr!(uplo, alpha, x, A)

# Similarly, _symv! wraps symv! and dispatch based on the data type
function _symv!(uplo::Char, alpha::T, A::AbstractMatrix{T}, x::AbstractVector{T}, beta::T, y::AbstractVector{T}) where T
    return BLAS.symv!(uplo, alpha, A, x, beta, y)
end

# Similarly, _syrk! wraps syrk! to dispatch on the data type.
function _syrk!(uplo::Char, trans::Char, alpha::T, A::AbstractMatrix{T}, beta::T, C::AbstractMatrix{T}) where T
    return BLAS.syrk!(uplo, trans, alpha, A, beta, C)
end

# Similarly, _trsm! wraps trsm! to dispatch on the data type.
function _trsm!(side::Char, uplo::Char, transa::Char, diag::Char, alpha::T, A::AbstractMatrix{T}, B::AbstractMatrix{T}) where T
    return BLAS.trsm!(side, uplo, transa, diag, alpha, A, B)
end

# Similarly, _dgmm! wraps dgmm! to dispatch on the data type.
function _dgmm!(side::Char, A::AbstractMatrix{T}, x::AbstractVector{T}, B::AbstractMatrix{T}) where T
    if side == 'L'
        copyto!(B, A)
        lmul!(Diagonal(x), B)
    elseif side == 'R'
        copyto!(B, A)
        rmul!(B, Diagonal(x))
    else
        error("Unsupported side = $side.")
    end
end

const blas_num_threads = Ref{Int}(1)
function set_blas_num_threads(n::Integer;permanent::Bool=false)
    permanent && (blas_num_threads[]=n)
    BLAS.set_num_threads(n)
end
macro blas_safe_threads(args...)
    code = quote
        set_blas_num_threads(1)
        Threads.@threads($(args...))
        set_blas_num_threads(blas_num_threads[])
    end
    return esc(code)
end

# unsafe wrap
function _madnlp_unsafe_wrap(vec::VT, n, shift=1) where VT
    return unsafe_wrap(VT, pointer(vec,shift), n)
end

# Type definitions for noncontiguous views
const SubVector{Tv,VT, VI} = SubArray{Tv, 1, VT, Tuple{VI}, false}

@kwdef mutable struct MadNLPCounters
    k::Int = 0 # total iteration counter
    l::Int = 0 # backtracking line search counter
    t::Int = 0 # restoration phase counter
    ir::Int = 0 # iterative refinement counter

    start_time::Float64

    linear_solver_time::Float64 = 0.
    eval_function_time::Float64 = 0.
    solver_time::Float64 = 0.
    total_time::Float64 = 0.
    init_time::Float64 = 0.

    obj_cnt::Int = 0
    obj_grad_cnt::Int = 0
    con_cnt::Int = 0
    con_jac_cnt::Int = 0
    lag_hess_cnt::Int = 0

    factorization_cnt::Int = 0
    backsolve_cnt::Int = 0

    t1::Float64 = 0.
    t2::Float64 = 0.
    t3::Float64 = 0.
    t4::Float64 = 0.
    t5::Float64 = 0.
    t6::Float64 = 0.
    t7::Float64 = 0.
    t8::Float64 = 0.

    acceptable_cnt::Int = 0
    unsuccessful_iterate::Int = 0
    restoration_fail_count::Int = 0
end

"""
    timing_callbacks(ips::InteriorPointSolver; ntrials=10)

Return the average timings spent in each callback for `ntrials` different trials.
Results are returned inside a named-tuple.

"""
function timing_callbacks(ips; ntrials=10)
    t_f, t_c, t_g, t_j, t_h = (0.0, 0.0, 0.0, 0.0, 0.0)
    for _ in 1:ntrials
        t_f += @elapsed eval_f_wrapper(ips, ips.x)
        t_c += @elapsed eval_cons_wrapper!(ips, ips.c, ips.x)
        t_g += @elapsed eval_grad_f_wrapper!(ips, ips.f,ips.x)
        t_j += @elapsed eval_jac_wrapper!(ips, ips.kkt, ips.x)
        t_h += @elapsed eval_lag_hess_wrapper!(ips, ips.kkt, ips.x, ips.y)
    end
    return (
        time_eval_objective   = t_f / ntrials,
        time_eval_constraints = t_c / ntrials,
        time_eval_gradient    = t_g / ntrials,
        time_eval_jacobian    = t_j / ntrials,
        time_eval_hessian     = t_h / ntrials,
    )
end

"""
    timing_linear_solver(ips::InteriorPointSolver; ntrials=10)

Return the average timings spent in the linear solver for `ntrials` different trials.
Results are returned inside a named-tuple.

"""
function timing_linear_solver(ips; ntrials=10)
    t_build, t_factorize, t_backsolve = (0.0, 0.0, 0.0)
    for _ in 1:ntrials
        t_build     += @elapsed build_kkt!(ips.kkt)
        t_factorize += @elapsed factorize_kkt!(ips.kkt)
        t_backsolve += @elapsed solve_kkt!(ips.kkt, ips.d)
    end
    return (
        time_build_kkt = t_build / ntrials,
        time_factorization = t_factorize / ntrials,
        time_backsolve = t_backsolve / ntrials,
    )
end

"""
    timing_madnlp(ips::InteriorPointSolver; ntrials=10)

Return the average time spent in the callbacks and in the linear solver,
for `ntrials` different trials.

Results are returned as a named-tuple.

"""
function timing_madnlp(ips; ntrials=10)
    return (
        time_linear_solver=timing_linear_solver(ips; ntrials=ntrials),
        time_callbacks=timing_callbacks(ips; ntrials=ntrials),
    )
end

module MadNLP

import Pkg.TOML: parsefile
import Printf: @sprintf
import LinearAlgebra: BLAS, LAPACK, Adjoint, Symmetric, Diagonal, mul!, ldiv!, rdiv!, lmul!, rmul!, norm, dot, diagind, normInf, transpose!, issuccess
import LinearAlgebra: BlasReal, bunchkaufman, cholesky, qr, lu, bunchkaufman!, cholesky!, axpy!, LowerTriangular
import LinearAlgebra.BLAS: libblastrampoline, BlasInt, @blasfunc
import SparseArrays: SparseArrays, AbstractSparseMatrix, SparseMatrixCSC, sparse, getcolptr, rowvals, nnz, nonzeros
import Base: string, show, print, size, getindex, copyto!, @kwdef
Base.USE_GPL_LIBS && import SuiteSparse: UMFPACK, CHOLMOD
import NLPModels
import NLPModels: finalize, AbstractNLPModel, obj, grad!, cons!, jac_coord!, hess_coord!, hess_structure!, jac_structure!, hess_dense!, jac_dense!, NLPModelMeta, get_nvar, get_ncon, get_minimize, get_x0, get_y0, get_nnzj, get_nnzh, get_lvar, get_uvar, get_lcon, get_ucon
import SolverCore: getStatus, AbstractOptimizationSolver, AbstractExecutionStats, solve!
import LDLFactorizations
import MUMPS_seq_jll, OpenBLAS32_jll

export MadNLPSolver, MadNLPOptions, LDLSolver, LapackCPUSolver, MumpsSolver, MadNLPExecutionStats, madnlp, solve!, madsuite, SchurComplementKKTSystem
Base.USE_GPL_LIBS && export UmfpackSolver, CHOLMODSolver

function __init__()
    config = BLAS.lbt_get_config()
    if !any(lib -> lib.interface == :lp64, config.loaded_libs)
        BLAS.lbt_forward(OpenBLAS32_jll.libopenblas_path)
    end
end
using PrecompileTools: @setup_workload, @compile_workload

# Version info
version() = string(pkgversion(@__MODULE__))
introduce() = "\033[34mMad\033[31mN\033[32mL\033[35mP\033[0m version v$(version())"

include("enums.jl")
include("utils.jl")
include("matrixtools.jl")
include(joinpath("Callbacks", "nlpmodels.jl"))
include(joinpath("Callbacks", "wrappers.jl"))
include("quasi_newton.jl")
include(joinpath("KKT", "KKTsystem.jl"))
include(joinpath("LinearSolvers", "linearsolvers.jl"))
include(joinpath("IPM", "IPM.jl"))
include("precompile.jl")

madsuite(::Val{:madnlp}, args...; kwargs...) = madnlp(args...; kwargs...)

global Optimizer

end # end module

mutable struct LapackCUDASolver{T, MT, Alg} <: MadNLP.AbstractLapackSolver{T, Alg}
    A::MT
    fact::CuMatrix{T}
    n::Int64
    sol::CuVector{T}
    tau::CuVector{T}
    Λ::CuVector{T}
    work_gpu::CuVector{UInt8}
    lwork_gpu::Csize_t
    work_cpu::Vector{UInt8}
    lwork_cpu::Csize_t
    info::CuVector{Cint}
    ipiv::CuVector{Cint}
    ipiv64::CuVector{Int64}
    opt::MadNLP.LapackOptions
    logger::MadNLP.MadNLPLogger
    legacy::Bool
    params::CuSolverParameters

    function LapackCUDASolver(
            A::MT;
            option_dict::Dict{Symbol, Any} = Dict{Symbol, Any}(),
            opt = MadNLP.LapackOptions(),
            logger = MadNLP.MadNLPLogger(),
            legacy::Bool = true,
            kwargs...,
        ) where {MT <: AbstractMatrix}
        MadNLP.set_options!(opt, option_dict, kwargs...)
        T = eltype(A)
        m, n = size(A)
        @assert m == n
        fact = CuMatrix{T}(undef, m, n)
        sol = CuVector{T}(undef, 0)
        tau = CuVector{T}(undef, 0)
        Λ = CuVector{T}(undef, 0)
        work_gpu = CuVector{UInt8}(undef, 0)
        lwork_gpu = zero(Int64)
        work_cpu = Vector{UInt8}(undef, 0)
        lwork_cpu = zero(Int64)
        info = CuVector{Cint}(undef, 1)
        ipiv = CuVector{Cint}(undef, 0)
        ipiv64 = CuVector{Int64}(undef, 0)
        params = CuSolverParameters()
        alg = opt.lapack_algorithm
        solver = new{T, MT, alg}(
            A, fact, n, sol, tau, Λ, work_gpu, lwork_gpu, work_cpu, lwork_cpu,
            info, ipiv, ipiv64, opt, logger, legacy, params
        )
        MadNLP.setup!(solver)
        return solver
    end
end

MadNLP.transfer_matrix!(M::LapackCUDASolver) = MadNLPGPU.gpu_transfer!(M.fact, M.A)
MadNLP._get_info(M::LapackCUDASolver) = sum(M.info)
MadNLP.solve!(M::LapackCUDASolver{T}, x::CuVector{T}) where {T} = MadNLP._solve!(M, x)
MadNLP.introduce(M::LapackCUDASolver) = "cuSOLVER v$(cuSOLVER.version()) -- ($(M.opt.lapack_algorithm))"

module MadNLPGPUCUDAExt

import LinearAlgebra
import SparseArrays: SparseMatrixCSC, nonzeros, nnz
import LinearAlgebra: Symmetric, mul!

import MadNLP
import MadNLP: NLPModels
import MadNLP:
    @kwdef, MadNLPLogger, @debug, @warn, @error,
    AbstractOptions, AbstractLinearSolver, AbstractNLPModel, set_options!,
    SymbolicException, FactorizationException, SolveException, InertiaException,
    introduce, factorize!, solve!, improve!, is_inertia, inertia, tril_to_full!,
    LapackOptions, input_type, is_supported, default_options,
    setup_cholesky!, setup_lu!, setup_qr!, setup_evd!, setup_bunchkaufman!,
    factorize_cholesky!, factorize_lu!, factorize_qr!, factorize_evd!, factorize_bunchkaufman!,
    solve_cholesky!, solve_lu!, solve_qr!, solve_evd!, solve_bunchkaufman!

import MadNLPGPU
import MadNLPGPU: ORDERING, DEFAULT_ORDERING, METIS_ORDERING, AMD_ORDERING,
    USER_ORDERING, SYMAMD_ORDERING, COLAMD_ORDERING, gpu_transfer!

import KernelAbstractions: @kernel, @index, @Const, synchronize, get_backend

using CUDACore
using cuSPARSE, cuBLAS, cuSOLVER
import CUDSS

import AMD, Metis

import .cuSOLVER: cusolverStatus_t, CuPtr, cudaDataType, cublasFillMode_t, cusolverDnHandle_t,
    dense_handle, CuSolverParameters, CUSOLVER_EIG_MODE_VECTOR
import .cuBLAS: handle, CUBLAS_DIAG_NON_UNIT,
    CUBLAS_FILL_MODE_LOWER, CUBLAS_FILL_MODE_UPPER, CUBLAS_SIDE_LEFT, CUBLAS_OP_N, CUBLAS_OP_T

function __init__()
    setglobal!(MadNLPGPU, :LapackCUDASolver, LapackCUDASolver)
    setglobal!(MadNLPGPU, :CUDSSSolver, CUDSSSolver)
    return
end

include("cuda_sparse.jl")
include("lapackgpu.jl")
include("cusolver.jl")
include("cudss.jl")
include("cuda.jl")
include("kernels_schur.jl")
include("cuda_schur.jl")

end

module MadNLPMOI

import MadNLP
import NLPModels
import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function __init__()
    setglobal!(MadNLP, :Optimizer, Optimizer)
    return
end

include("MOI_utils.jl")
include("MOI_wrapper.jl")

end # module MadNLPMOI

# NOTE: All of these could probably be made more efficient via custom kernels or nonallocating mapreduce.
#       For now we just use the standard mapreduce functionality which may allocate.

function get_varphi(
    obj_val,
    x_lr::VT,
    xl_r::VT,
    xu_r::VT,
    x_ur::VT,
    mu
) where {T, VT <: AbstractGPUVectorOrSubVector{T}}
    return obj_val + mapreduce(
        (x1,x2) -> _get_varphi(x1,x2,mu), +, x_lr, xl_r
    ) + mapreduce(
        (x1,x2) -> _get_varphi(x1,x2,mu), +, xu_r, x_ur
    )
end

function get_inf_du(f::VT, zl::VT, zu::VT, jacl::VT, sd) where {VT <: AbstractGPUVectorOrSubVector}
    return mapreduce((f,zl,zu,jacl) -> abs(f-zl+zu+jacl), max, f, zl, zu, jacl; init = zero(eltype(f))) / sd
end


function get_inf_compl(x_lr::VT, xl_r::VT, zl_r::VT, xu_r::VT, x_ur::VT, zu_r::VT, mu, sc) where {VT <: AbstractGPUVectorOrSubVector}
    return max(
        mapreduce(
            (x_lr, xl_r, zl_r) -> abs((x_lr-xl_r)*zl_r-mu),
            max,
            x_lr, xl_r, zl_r;
            init = zero(eltype(x_lr))
        ),
        mapreduce(
            (xu_r, x_ur, zu_r) -> abs((xu_r-x_ur)*zu_r-mu),
            max,
            xu_r, x_ur, zu_r;
            init = zero(eltype(x_lr))
        )
    ) / sc
end

function get_min_complementarity(
    x_lr::AbstractGPUVectorOrSubVector{T},
    xl_r::AbstractGPUVectorOrSubVector{T},
    zl_r::AbstractGPUVectorOrSubVector{T},
    x_ur::AbstractGPUVectorOrSubVector{T},
    xu_r::AbstractGPUVectorOrSubVector{T},
    zu_r::AbstractGPUVectorOrSubVector{T}
) where T
    cc_lb = mapreduce((x_l, xl, zl) -> (x_l-xl)*zl, min, x_lr, xl_r, zl_r, init=T(Inf))
    cc_ub = mapreduce((x_u, xu, zu) -> (xu-x_u)*zu, min, x_ur, xu_r, zu_r, init=T(Inf))
    return min(cc_lb,cc_ub)
end

function get_varphi_d(
    f::AbstractGPUVectorOrSubVector{T},
    x::AbstractGPUVectorOrSubVector{T},
    xl::AbstractGPUVectorOrSubVector{T},
    xu::AbstractGPUVectorOrSubVector{T},
    dx::AbstractGPUVectorOrSubVector{T},
    mu,
) where T
    return mapreduce(
        (f,x,xl,xu,dx)-> (f - mu/(x-xl) + mu/(xu-x)) * dx,
        +,
        f, x, xl, xu, dx;
        init = zero(T)
    )
end

function get_alpha_max(
    x::AbstractGPUVectorOrSubVector{T},
    xl::AbstractGPUVectorOrSubVector{T},
    xu::AbstractGPUVectorOrSubVector{T},
    dx::AbstractGPUVectorOrSubVector{T},
    tau,
) where T
    return min(
        mapreduce(
            (x, xl, dx) -> dx < 0 ? (-x+xl)*tau/dx : T(Inf),
            min,

            x, xl, dx,
            init = one(T)
        ),
        mapreduce(
            (x, xu, dx) -> dx > 0 ? (-x+xu)*tau/dx : T(Inf),
            min,
            x, xu, dx,
            init = one(T)
        )
    )
end

function get_alpha_z(
    zl_r::AbstractGPUVectorOrSubVector{T},
    zu_r::AbstractGPUVectorOrSubVector{T},
    dzl::AbstractGPUVectorOrSubVector{T},
    dzu::AbstractGPUVectorOrSubVector{T},
    tau,
)  where T
    return min(
        mapreduce(
            (zl_r, dzl) -> dzl < 0 ? (-zl_r)*tau/dzl : T(Inf),
            min,
            zl_r, dzl,
            init = one(T)
        ),
        mapreduce(
            (zu_r, dzu) -> dzu < 0 ? (-zu_r)*tau/dzu : T(Inf),
            min,
            zu_r, dzu,
            init = one(T)
        )
    )
end

function get_obj_val_R(
    p::AbstractGPUVectorOrSubVector{T},
    n::AbstractGPUVectorOrSubVector{T},
    D_R::AbstractGPUVectorOrSubVector{T},
    x::AbstractGPUVectorOrSubVector{T},
    x_ref::AbstractGPUVectorOrSubVector{T},
    rho,
    zeta,
) where T
    return mapreduce(
        (p,n) -> rho*(p+n),
        +,
        p,n;
        init = zero(T)
    ) +
        mapreduce(
            (D_R,x,x_ref) -> zeta/2*D_R^2*(x-x_ref)^2,
            +,
            D_R,x,x_ref;
            init = zero(T)
        )
end

function get_theta_R(
    c::AbstractGPUVectorOrSubVector{T},
    p::AbstractGPUVectorOrSubVector{T},
    n::AbstractGPUVectorOrSubVector{T},
) where T
    return mapreduce(
        (c,p,n) -> abs(c-p+n),
        +,
        c,p,n;
        init = zero(T)
    )
end

function get_inf_pr_R(
    c::AbstractGPUVectorOrSubVector{T},
    p::AbstractGPUVectorOrSubVector{T},
    n::AbstractGPUVectorOrSubVector{T},
) where T
    return mapreduce(
        (c,p,n) -> abs(c-p+n),
        max,
        c,p,n;
        init = zero(T)
    )
end

function get_inf_du_R(
    f_R::AbstractGPUVectorOrSubVector{T},
    l::AbstractGPUVectorOrSubVector{T},
    zl::AbstractGPUVectorOrSubVector{T},
    zu::AbstractGPUVectorOrSubVector{T},
    jacl::AbstractGPUVectorOrSubVector{T},
    zp::AbstractGPUVectorOrSubVector{T},
    zn::AbstractGPUVectorOrSubVector{T},
    rho,
    sd,
)  where T
    return max(
        mapreduce(
            (f_R, zl, zu, jacl) -> abs(f_R-zl+zu+jacl),
            max,
            f_R, zl, zu, jacl;
            init = zero(T)
        ),
        mapreduce(
            (l, zp) -> abs(rho-l-zp),
            max,
            l, zp;
            init = zero(T)
        ),
        mapreduce(
            (l, zn) -> abs(rho+l-zn),
            max,
            l, zn;
            init = zero(T)
        )
    ) / sd
end


function get_inf_compl_R(
    x_lr::AbstractGPUVectorOrSubVector{T},
    xl_r,
    zl_r,
    xu_r,
    x_ur,
    zu_r,
    pp,
    zp,
    nn,
    zn,
    mu_R,
    sc
) where {T}
    return max(
        mapreduce(
            (x_lr, xl_r, zl_r) -> abs((x_lr-xl_r)*zl_r-mu_R),
            max,
            x_lr, xl_r, zl_r;
            init = zero(T)
        ),
        mapreduce(
            (xu_r, x_ur, zu_r) -> abs((xu_r-x_ur)*zu_r-mu_R),
            max,
            xu_r, x_ur, zu_r;
            init = zero(T)
        ),
        mapreduce(
            (pp, zp) -> abs(pp*zp-mu_R),
            max,
            pp, zp;
            init = zero(T)
        ),
        mapreduce(
            (nn, zn) -> abs(nn*zn-mu_R),
            max,
            nn, zn;
            init = zero(T)
        ),
    ) / sc
end

function get_alpha_max_R(
    x::AbstractGPUVectorOrSubVector{T},
    xl::AbstractGPUVectorOrSubVector{T},
    xu::AbstractGPUVectorOrSubVector{T},
    dx::AbstractGPUVectorOrSubVector{T},
    pp::AbstractGPUVectorOrSubVector{T},
    dpp::AbstractGPUVectorOrSubVector{T},
    nn::AbstractGPUVectorOrSubVector{T},
    dnn::AbstractGPUVectorOrSubVector{T},
    tau_R,
) where T
    return min(
        mapreduce(
            (x,xl,xu,dx) -> if dx < 0
                (-x+xl)*tau_R/dx
            elseif dx > 0
                (-x+xu)*tau_R/dx
            else
                T(Inf)
            end,
            min,
            x,xl,xu,dx;
            init = one(T)
        ),
        mapreduce(
            (pp, dpp)-> if dpp < 0
                -pp*tau_R/dpp
            else
                T(Inf)
            end,
            min,
            pp, dpp;
            init = one(T)
        ),
        mapreduce(
            (nn, dnn)-> if dnn < 0
                -nn*tau_R/dnn
            else
                T(Inf)
            end,
            min,
            nn, dnn;
            init = one(T)
        )
    )
end

function get_alpha_z_R(
    zl_r::AbstractGPUVectorOrSubVector{T},
    zu_r,
    dzl,
    dzu,
    zp,
    dzp,
    zn,
    dzn,
    tau_R,
) where {T}

    f(d,z) = d < 0 ? -z*tau_R/d : T(Inf)
    return min(
        mapreduce(
            f,
            min,
            dzl, zl_r;
            init = one(T)
        ),
        mapreduce(
            f,
            min,
            dzu, zu_r;
            init = one(T)
        ),
        mapreduce(
            f,
            min,
            dzp, zp;
            init = one(T)
        ),
        mapreduce(
            f,
            min,
            dzn, zn;
            init = one(T)
        )
    )
end

function get_varphi_R(
    obj_val,
    x_lr::AbstractGPUVectorOrSubVector{T},
    xl_r,
    xu_r,
    x_ur,
    pp,
    nn,
    mu_R,
)  where {T}
    varphi_R = obj_val
    f1(x) = x < 0 ? T(Inf) : mu_R*log(x)
    function f2(x,y)
        d = x - y
        d < 0 ? T(Inf) : mu_R * log(d)
    end

    return obj_val - +(
        mapreduce(
            f2,
            +,
            x_lr, xl_r;
            init = zero(T)
        ),
        mapreduce(
            f2,
            +,
            xu_r, x_ur;
            init = zero(T)
        ),
        mapreduce(
            f1,
            +,
            pp;
            init = zero(T)
        ),
        mapreduce(
            f1,
            +,
            nn;
            init = zero(T)
        )
    )
end

function get_F(
    c::AbstractGPUVectorOrSubVector{T},
    f,
    zl,
    zu,
    jacl,
    x_lr,
    xl_r,
    zl_r,
    xu_r,
    x_ur,
    zu_r,
    mu,
) where T
    F1 = mapreduce(
        abs,
        +,
        c;
        init = zero(T)
    )
    F2 = mapreduce(
        (f,zl,zu,jacl) -> abs(f-zl+zu+jacl),
        +,
        f,zl,zu,jacl;
        init = zero(T)
    )
    F3 = mapreduce(
        (x_lr,xl_r,zl_r) -> (x_lr >= xl_r && zl_r >= 0) ? abs((x_lr-xl_r)*zl_r-mu) : T(Inf),
        +,
        x_lr,xl_r,zl_r;
        init = zero(T)
    )
    F4 = mapreduce(
        (xu_r,x_ur,zu_r) -> (xu_r >= x_ur && zu_r >= 0) ? abs((xu_r-xu_r)*zu_r-mu) : T(Inf),
        +,
        xu_r,xu_r,zu_r;
        init = zero(T)
    )
    return F1 + F2 + F3 + F4
end

function get_varphi_d_R(
    f_R::AbstractGPUVectorOrSubVector{T},
    x::AbstractGPUVectorOrSubVector{T},
    xl::AbstractGPUVectorOrSubVector{T},
    xu::AbstractGPUVectorOrSubVector{T},
    dx::AbstractGPUVectorOrSubVector{T},
    pp::AbstractGPUVectorOrSubVector{T},
    nn::AbstractGPUVectorOrSubVector{T},
    dpp::AbstractGPUVectorOrSubVector{T},
    dnn::AbstractGPUVectorOrSubVector{T},
    mu_R,
    rho,
) where T
    f(x,dx) = (rho - mu_R/x) * dx
    return +(
        mapreduce(
            (f_R, x, xl, xu, dx) -> (f_R - mu_R/(x-xl) + mu_R/(xu-x)) * dx,
            +,
            f_R, x, xl, xu, dx;
            init = zero(T)
        ),
        mapreduce(
            f,
            +,
            pp,dpp;
            init = zero(T)
        ),
        mapreduce(
            f,
            +,
            nn,dnn;
            init = zero(T)
        ),
    )
end

function get_rel_search_norm(x::AbstractGPUVectorOrSubVector{T}, dx::AbstractGPUVectorOrSubVector{T}) where T
    return mapreduce(
        (x,dx) -> abs(dx) / (one(T) + abs(x)),
        max,
        x, dx
    )
end

function populate_RR_nn!(nn::AbstractGPUVectorOrSubVector{T}, c::AbstractGPUVectorOrSubVector{T}, mu, rho) where T
    map!((c) -> (mu - rho*c)/(2*rho)+sqrt(((mu-rho*c)/(2*rho))^2 + mu*c/(2*rho)), nn, c)
end

module MadNLPGPU

import LinearAlgebra
import SparseArrays: SparseMatrixCSC, nonzeros, nnz
import LinearAlgebra: Symmetric, mul!, norm, dot

# GPU abstractions
import Adapt: adapt
import GPUArraysCore: AbstractGPUVector, AbstractGPUMatrix, AbstractGPUArray, @allowscalar
# Kernels
import KernelAbstractions: @kernel, @index, synchronize, @Const, get_backend

import MadNLP: NLPModels
import MadNLP
import MadNLP:
    @kwdef, MadNLPLogger, @debug, @warn, @error,
    AbstractOptions, AbstractLinearSolver, AbstractNLPModel, set_options!,
    SymbolicException,FactorizationException,SolveException,InertiaException,
    introduce, factorize!, solve!, improve!, is_inertia, inertia, tril_to_full!,
    LapackOptions, input_type, is_supported, default_options,
    setup_cholesky!, setup_lu!, setup_qr!, setup_evd!, setup_bunchkaufman!,
    factorize_cholesky!, factorize_lu!, factorize_qr!, factorize_evd!, factorize_bunchkaufman!,
    solve_cholesky!, solve_lu!, solve_qr!, solve_evd!, solve_bunchkaufman!
import MadNLP:
    _get_varphi, get_varphi, get_inf_du, get_inf_compl, get_min_complementarity,
    get_varphi_d, get_alpha_max, get_alpha_z, get_obj_val_R, get_theta_R, get_inf_pr_R,
    get_inf_du_R, get_inf_compl_R, get_alpha_max_R, get_alpha_z_R, get_varphi_R, get_F,
    get_varphi_d_R, get_rel_search_norm, populate_RR_nn!, SubVector, count_lu_bounds
# AMD and Metis
import AMD, Metis

const AbstractGPUVectorOrSubVector{T,VT<:AbstractGPUVector{T}} = Union{AbstractGPUVector{T}, SubVector{T, VT}}

include("KKT/kernels_dense.jl")
include("KKT/kernels_sparse.jl")
include("KKT/kernels_qn.jl")
include("utils.jl")
include("KKT/gpu_dense.jl")
include("KKT/gpu_sparse.jl")
include("KKT/gpu_qn.jl")
include("IPM/utils.jl")
include("IPM/kernels.jl")

global LapackCUDASolver::Any = nothing
global CUDSSSolver::Any = nothing
global LapackROCmSolver::Any = nothing
export LapackCUDASolver, CUDSSSolver, LapackROCmSolver

# re-export MadNLP, including deprecated names
for name in names(MadNLP, all=true)
    if Base.isexported(MadNLP, name)
        @eval using MadNLP: $(name)
        @eval export $(name)
    end
end

end # module

mutable struct RobustRestorer{T, VT}
    obj_val_R::T
    f_R::VT
    x_ref::VT

    theta_ref::T
    D_R::VT
    obj_val_R_trial::T

    pp::VT
    nn::VT
    zp::VT
    zn::VT

    dpp::VT
    dnn::VT
    dzp::VT
    dzn::VT

    pp_trial::VT
    nn_trial::VT

    inf_pr_R::T
    inf_du_R::T
    inf_compl_R::T

    mu_R::T
    tau_R::T
    zeta::T

    filter::Vector{Tuple{T,T}}
end

abstract type AbstractInertiaCorrector end
struct InertiaAuto <: AbstractInertiaCorrector end
struct InertiaBased <: AbstractInertiaCorrector end
struct InertiaIgnore <: AbstractInertiaCorrector end
struct InertiaFree{
    T,
    VT <: AbstractVector{T},
    KKTVec <: AbstractKKTVector{T, VT}
} <: AbstractInertiaCorrector 
    p0::KKTVec
    d0::KKTVec
    t::VT
    wx::VT
    g::VT
end


"""
    AbstractBarrierUpdate{T}

Abstraction used to implement the different rules to update the barrier parameter.
The barrier is updated using either a monotone rule or an adaptive rule.

"""
abstract type AbstractBarrierUpdate{T} end

"""
    MonotoneUpdate{T} <: AbstractBarrierUpdate{T}

Update the barrier parameter using the classical Fiacco-McCormick monotone rule.

"""
@kwdef mutable struct MonotoneUpdate{T} <: AbstractBarrierUpdate{T}
    mu_init::T = 1e-1
    mu_min::T = 1e-11
    mu_superlinear_decrease_power::T = 1.5
    mu_linear_decrease_factor::T = .2
end
function MonotoneUpdate(tol::T, barrier_tol_factor) where T
    return MonotoneUpdate{T}(; mu_min=min(1e-4, tol ) / (barrier_tol_factor + 1))
end

"""
    AbstractAdaptiveUpdate{T} <: AbstractBarrierUpdate{T}

Abstraction used to implement the adaptive barrier updates described in [Nocedal2009].

## References
[Nocedal2009] Nocedal, J., Wächter, A., & Waltz, R. A. (2009).
Adaptive barrier update strategies for nonlinear interior methods.
SIAM Journal on Optimization, 19(4), 1674-1693.

"""
abstract type AbstractAdaptiveUpdate{T} <: AbstractBarrierUpdate{T} end

"""
    QualityFunctionUpdate{T} <: AbstractAdaptiveUpdate{T}

Find the barrier parameter using a quality function encoding the ℓ1-norm of the KKT violations.
At each IPM iteration, the minimum of the quality function is found using a Golden search algorithm.

If no sufficient progress is made, the barrier fallbacks to a monotone rule.

## References
The algorithm is described in [Nocedal2009, Section 4].

"""
@kwdef mutable struct QualityFunctionUpdate{T} <: AbstractAdaptiveUpdate{T}
    mu_init::T = 1e-1
    mu_min::T = 1e-11
    mu_max::T = 1e5
    sigma_min::T = 1e-6
    sigma_max::T = 1e2
    sigma_tol::T = 1e-2
    gamma::T = 1.0
    max_gs_iter::Int = 8
    # For non-free mode
    mu_superlinear_decrease_power::T = 1.5
    mu_linear_decrease_factor::T = .2
    free_mode::Bool = true
    globalization::Bool = true
    n_update::Int = 0
end
function QualityFunctionUpdate(tol::T, barrier_tol_factor) where T
    return QualityFunctionUpdate{T}(; mu_min=min(1e-4, tol ) / (barrier_tol_factor + 1))
end

"""
    LOQOUpdate{T} <: AbstractAdaptiveUpdate{T}

Find the barrier parameter using the rule used in the LOQO solver.
The rule is explicited in [Nocedal2009, Eq (3.6)].

If no sufficient progress is made, the barrier fallbacks to a monotone rule.

## References
The algorithm is described in [Nocedal2009, Section 3].

"""
@kwdef mutable struct LOQOUpdate{T} <: AbstractAdaptiveUpdate{T}
    mu_init::T = 1e-1
    mu_min::T = 1e-11
    mu_max::T = 1e5
    gamma::T = 0.1 # scale factor
    r::T = .95 # Steplength param
    mu_superlinear_decrease_power::T = 1.5
    mu_linear_decrease_factor::T = .2
    free_mode::Bool = true
    globalization::Bool = true
end
function LOQOUpdate(tol::T, barrier_tol_factor) where T
    return LOQOUpdate{T}(; mu_min=min(1e-4, tol ) / (barrier_tol_factor + 1))
end

@kwdef mutable struct Ma77Options <: AbstractOptions
    ma77_buffer_lpage::Int = 4096
    ma77_buffer_npage::Int = 1600
    ma77_file_size::Int = 2097152
    ma77_maxstore::Int = 0
    ma77_nemin::Int = 8
    ma77_order::Ordering = METIS
    ma77_print_level::Int = -1
    ma77_small::Float64 = 1e-20
    ma77_static::Float64 = 0.0
    ma77_u::Float64 = 1e-8
    ma77_umax::Float64 = 1e-4
end

mutable struct Ma77Solver{T,INT} <: AbstractLinearSolver{T}
    tril::SparseMatrixCSC{T,INT}
    full::SparseMatrixCSC{T,INT}
    tril_to_full_view::SubVector{T}

    control::Ma77Control{T,INT}
    info::Ma77Info{T,INT}

    mc68_control::Mc68Control{INT}
    mc68_info::Mc68Info{INT}

    order::Vector{INT}
    keep::Vector{Ptr{Cvoid}}

    opt::Ma77Options
    logger::MadNLPLogger
end

function Ma77Solver(
    csc::SparseMatrixCSC{T,INT};
    opt = Ma77Options(),
    logger = MadNLPLogger(),
) where {T,INT}
    full, tril_to_full_view = get_tril_to_full(csc)
    order = Vector{INT}(undef, csc.n)

    mc68info = Mc68Info{INT}()
    mc68control = Mc68Control{INT}()
    HSL.mc68_default_control(INT, mc68control)

    keep = [C_NULL]

    mc68control.f_array_in = 1
    mc68control.f_array_out = 1
    HSL.mc68_order(
        INT,
        INT(opt.ma77_order),
        INT(csc.n),
        csc.colptr,
        csc.rowval,
        order,
        mc68control,
        mc68info,
    )

    info = Ma77Info{T,INT}()
    control = Ma77Control{T,INT}()
    HSL.ma77_default_control(T, INT, control)
    control.f_arrays = 1
    control.bits = 32
    control.file_size = opt.ma77_file_size
    control.maxstore = opt.ma77_maxstore
    control.print_level = -1

    control.buffer_lpage = (opt.ma77_buffer_lpage, opt.ma77_buffer_lpage)
    control.buffer_npage = (opt.ma77_buffer_npage, opt.ma77_buffer_npage)

    control.nemin = opt.ma77_nemin
    control.small = opt.ma77_small
    control.static_ = opt.ma77_static
    control.u = opt.ma77_u

    HSL.ma77_open(
        T,
        INT,
        INT(full.n),
        tempname(cleanup = false),
        tempname(cleanup = false),
        tempname(cleanup = false),
        tempname(cleanup = false),
        keep,
        control,
        info,
    )

    info.flag < 0 && throw(SymbolicException())

    for i = 1:full.n
        HSL.ma77_input_vars(
            T,
            INT,
            INT(i),
            full.colptr[i+1] - full.colptr[i],
            _madnlp_unsafe_wrap(
                full.rowval,
                full.colptr[i+1] - full.colptr[i],
                full.colptr[i],
            ),
            keep,
            control,
            info,
        )
        info.flag < 0 && throw(LinearSymbolicException())
    end

    HSL.ma77_analyse(T, INT, order, keep, control, info)
    info.flag < 0 && throw(SymbolicException())

    M = Ma77Solver{T,INT}(
        csc,
        full,
        tril_to_full_view,
        control,
        info,
        mc68control,
        mc68info,
        order,
        keep,
        opt,
        logger,
    )
    finalizer(finalize, M)
    return M
end

function factorize!(M::Ma77Solver{T,INT}) where {T,INT}
    M.full.nzval .= M.tril_to_full_view
    for i = 1:M.full.n
        HSL.ma77_input_reals(
            T,
            INT,
            INT(i),
            M.full.colptr[i+1] - M.full.colptr[i],
            _madnlp_unsafe_wrap(
                M.full.nzval,
                M.full.colptr[i+1] - M.full.colptr[i],
                M.full.colptr[i],
            ),
            M.keep,
            M.control,
            M.info,
        )
        M.info.flag < 0 && throw(FactorizationException())
    end
    HSL.ma77_factor(T, INT, INT(0), M.keep, M.control, M.info, C_NULL)
    M.info.flag < 0 && throw(FactorizationException())
    return M
end
function solve_linear_system!(M::Ma77Solver{T,INT}, rhs::Vector{T}) where {T,INT}
    HSL.ma77_solve(
        T,
        INT,
        INT(0),
        INT(1),
        INT(M.full.n),
        rhs,
        M.keep,
        M.control,
        M.info,
        C_NULL,
    )
    M.info.flag < 0 && throw(SolveException())
    return rhs
end

is_inertia(::Ma77Solver) = true
function inertia(M::Ma77Solver)
    return (
        M.info.matrix_rank - M.info.num_neg,
        M.full.n - M.info.matrix_rank,
        M.info.num_neg,
    )
end

function finalize(M::Ma77Solver{T,INT}) where {T,INT}
    HSL.ma77_finalise(T, INT, M.keep, M.control, M.info)
end

function improve!(M::Ma77Solver)
    if M.control.u == M.opt.ma77_umax
        @debug(M.logger, "improve quality failed.")
        return false
    end
    M.control.u = min(M.opt.ma77_umax, M.control.u^0.75)
    @debug(M.logger, "improved quality: pivtol = $(M.control.u)")
    return true
end

introduce(::Ma77Solver) = "ma77 v$(HSL.HSL_MA77_version())"
input_type(::Type{Ma77Solver}) = :csc
default_options(::Type{Ma77Solver}) = Ma77Options()
is_supported(::Type{Ma77Solver}, ::Type{T}) where T <: AbstractFloat = HSL.is_supported(Val(:hsl_ma77), T)

module MadNLPPardiso

include(joinpath("..", "deps", "deps.jl"))
const libpardiso = PARDISO_PATH

import Libdl: dlopen, RTLD_DEEPBIND
import MadNLP:
    MadNLP,
    @kwdef,
    MadNLPLogger,
    @debug,
    @warn,
    @error,
    SubVector,
    SparseMatrixCSC,
    SymbolicException,
    FactorizationException,
    SolveException,
    InertiaException,
    AbstractOptions,
    AbstractLinearSolver,
    set_options!,
    introduce,
    factorize!,
    solve_linear_system!,
    improve!,
    is_inertia,
    inertia,
    input_type,
    blas_num_threads,
    is_supported,
    default_options
import MKL_jll: libmkl_rt

if @isdefined(libpardiso)
    include("libpardiso.jl")
    include("pardiso.jl")
end
include("pardisomkl.jl")

function __init__()
    # check_deps()
    return @isdefined(libpardiso) && dlopen(libpardiso, RTLD_DEEPBIND)
end

export PardisoSolver, PardisoMKLSolver

# re-export MadNLP, including deprecated names
for name in names(MadNLP, all = true)
    if Base.isexported(MadNLP, name)
        @eval using MadNLP: $(name)
        @eval export $(name)
    end
end

end # module

module MadNLPHSL

import MadNLP:
    MadNLP,
    @kwdef,
    MadNLPLogger,
    @debug,
    @warn,
    @error,
    AbstractOptions,
    AbstractLinearSolver,
    set_options!,
    SparseMatrixCSC,
    SubVector,
    SymbolicException,
    FactorizationException,
    SolveException,
    InertiaException,
    introduce,
    factorize!,
    solve_linear_system!,
    improve!,
    is_inertia,
    inertia,
    findIJ,
    nnz,
    get_tril_to_full,
    transfer!,
    input_type,
    _madnlp_unsafe_wrap,
    is_supported,
    default_options

import HSL
import HSL:
    Mc68Control,
    Mc68Info,
    Ma77Control,
    Ma77Info,
    Ma86Control,
    Ma86Info,
    Ma97Control,
    Ma97Info

import LinearAlgebra

include("common.jl")
include("ma27.jl")
include("ma57.jl")
include("ma77.jl")
include("ma86.jl")
include("ma97.jl")

export Ma27Solver, Ma57Solver, Ma77Solver, Ma86Solver, Ma97Solver

# re-export MadNLP, including deprecated names
for name in names(MadNLP, all = true)
    if Base.isexported(MadNLP, name)
        @eval using MadNLP: $(name)
        @eval export $(name)
    end
end

end # module

######################################################
##### CUDA stubs for SparseCondensedKKTSystem    #####
##### (functions requiring concrete CUSPARSE types) ##
######################################################

function MadNLP.transfer!(
        dest::cuSPARSE.CuSparseMatrixCSC,
        src::MadNLP.SparseMatrixCOO,
        map,
    )
    return copyto!(view(dest.nzVal, map), src.V)
end

MadNLP.nzval(H::cuSPARSE.CuSparseMatrixCSC) = H.nzVal

function MadNLP._get_sparse_csc(dims, colptr::CuVector, rowval, nzval)
    return cuSPARSE.CuSparseMatrixCSC(colptr, rowval, nzval, dims)
end

function MadNLP._sym_length(Jt::cuSPARSE.CuSparseMatrixCSC)
    return mapreduce(
        (x, y) -> begin
            z = x - y
            div(z^2 + z, 2)
        end,
        +,
        @view(Jt.colPtr[2:end]),
        @view(Jt.colPtr[1:(end - 1)])
    )
end

function MadNLP.get_tril_to_full(csc::cuSPARSE.CuSparseMatrixCSC{Tv, Ti}) where {Tv, Ti}
    cscind = MadNLP.SparseMatrixCSC{Int, Ti}(
        Symmetric(
            MadNLP.SparseMatrixCSC{Int, Ti}(
                size(csc)...,
                Array(csc.colPtr),
                Array(csc.rowVal),
                collect(1:MadNLP.nnz(csc)),
            ),
            :L,
        ),
    )
    return cuSPARSE.CuSparseMatrixCSC{Tv, Ti}(
            CuArray(cscind.colptr),
            CuArray(cscind.rowval),
            CuVector{Tv}(undef, MadNLP.nnz(cscind)),
            size(csc),
        ),
        view(csc.nzVal, CuArray(cscind.nzval))
end

###########################################################
##### CUDA wrappers for SchurComplementKKTSystem ##########
###########################################################

"""
    GPUSchurComplementKKTSystem

GPU-native Schur complement KKT system, the CUDA counterpart of CPU
[`MadNLP.SchurComplementKKTSystem`](@ref). Uses a single batched
`CuSparseMatrixCSC` holding all `ns` scenario blocks (factored by `CUDSSSolver`
with uniform batching) and CUBLAS strided batched GEMM for the Schur complement
accumulation.

Variable layout: `[v_1, ..., v_ns, d]`, `v_k ∈ R^nv`, `d ∈ R^nd`.
Constraint layout: `[c_1, ..., c_ns]`, `c_k ∈ R^nc`.

The CPU version's `Vector{ScenarioBlockMap}` is flattened here into a set of
device vectors, one per (block-target × source-tensor) pair, with all `ns`
scenarios concatenated in scenario order. Each `n_per_s_*` field stores the
per-scenario length; the matching `gpu_*` vector then has length `ns * n_per_s_*`
and is indexed directly by the kernel global index.
"""
struct GPUSchurComplementKKTSystem{
    T,
    VT <: AbstractVector{T},
    MT <: AbstractMatrix{T},
    QN,
    LS,   # linear solver for Schur complement S (LapackCUDASolver)
    LS2,  # batched scenario solver (CUDSSSolver)
    COO_T,   # SparseMatrixCOO type for hess_raw
    COO_JT,  # SparseMatrixCOO type for jt_coo
    CSC_T,   # CuSparseMatrixCSC type
    VI <: AbstractVector{Int},
} <: MadNLP.AbstractCondensedKKTSystem{T, VT, MT, QN}

    # COO value buffers on GPU
    hess::VT
    jac::VT

    # COO structures
    hess_raw::COO_T
    jt_coo::COO_JT

    # CSC representations on GPU
    hess_csc::CSC_T
    hess_csc_map::VI
    jt_csc::CSC_T
    jt_csc_map::VI

    quasi_newton::QN

    # Standard diagonals on GPU
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT

    # Two-stage dimensions
    ns::Int
    nv::Int
    nd::Int
    nc::Int
    nc_eq_per_s::Int
    nc_ineq_per_s::Int
    blk_size::Int

    # Batched scenario block
    A_kk_batched::CSC_T
    nnz_per_scenario::Int

    # Dense blocks
    C_dk_batched::CuArray{T, 3}     # (blk_size, nd, ns) — per-scenario cross-block stored
                                    # with scenario-var dim first, so each slice
                                    # C_dk[:, :, k] is directly usable as the cuDSS
                                    # multi-RHS input for `A_kk \ C_dk'`.
    aug_com::MT                     # (nd, nd) — Schur complement S

    # Buffers
    diag_buffer::VT
    buffer::VT
    wy_eq_buf::VT                       # ns*nc_eq_per_s — preserves eq duals across J*Δx round-trip
    rhs_d::VT
    rhs_k_batched::MT                   # (blk_size, ns)
    tmp_blk_nd_batched::CuArray{T, 3}   # (blk_size, nd, ns)
    solve_buffer::VT                    # blk_size * ns

    # Flattened GPU index maps (all scenarios concatenated in scenario order).
    # See struct docstring for the layout convention.
    n_per_s_hess_Akk::Int
    gpu_hess_Akk_coo::VI
    gpu_hess_Akk_nzpos::VI

    n_per_s_hess_Cdk::Int
    gpu_hess_Cdk_coo::VI
    gpu_hess_Cdk_row::VI
    gpu_hess_Cdk_col::VI

    n_per_s_pr_diag::Int
    gpu_pr_diag_global::VI
    gpu_pr_diag_nzpos::VI

    n_per_s_du_diag::Int
    gpu_du_diag_global::VI
    gpu_du_diag_nzpos::VI

    n_per_s_jeq_Akk::Int
    gpu_jeq_Akk_coo::VI
    gpu_jeq_Akk_nzpos::VI

    n_per_s_jeq_Cdk::Int
    gpu_jeq_Cdk_coo::VI
    gpu_jeq_Cdk_row::VI
    gpu_jeq_Cdk_col::VI

    n_per_s_ineq_Akk::Int
    gpu_ineq_Akk_nzpos::VI
    gpu_ineq_Akk_jcoo1::VI
    gpu_ineq_Akk_jcoo2::VI
    gpu_ineq_Akk_bufidx::VI

    n_per_s_ineq_Cdk::Int
    gpu_ineq_Cdk_row::VI
    gpu_ineq_Cdk_col::VI
    gpu_ineq_Cdk_jcoo_d::VI
    gpu_ineq_Cdk_jcoo_v::VI
    gpu_ineq_Cdk_bufidx::VI

    n_per_s_ineq_S::Int
    gpu_ineq_S_row::VI
    gpu_ineq_S_col::VI
    gpu_ineq_S_jcoo1::VI
    gpu_ineq_S_jcoo2::VI
    gpu_ineq_S_bufidx::VI

    hess_S_coo::VI
    hess_S_row::VI
    hess_S_col::VI

    eq_global_indices::VI

    # Inequality/equality/bound indices
    n_eq::Int
    ind_eq::VI
    n_ineq::Int
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI

    # Solvers
    scenario_solver::LS2
    linear_solver::LS

    # Multi-RHS descriptors over `C_dk_batched` / `tmp_blk_nd_batched`, used to
    # solve A_kk * tmp[:, :, k] = C_dk[:, :, k] for all k in a single cuDSS
    # call (nd right-hand sides per scenario, ns batch). Zero-copy: both are
    # `cudss_update`'d onto the existing `(blk, nd, ns)` buffers each iteration.
    scenario_x_multi::CUDSS.CudssMatrix{T}
    scenario_b_multi::CUDSS.CudssMatrix{T}
end

# --- Dispatch: GPU path when callback uses CuVector ---
function MadNLP.create_kkt_system(
    ::Type{MadNLP.SchurComplementKKTSystem},
    cb::MadNLP.SparseCallback{T, VT},
    linear_solver::Type;
    opt_linear_solver=MadNLP.default_options(linear_solver),
    hessian_approximation=MadNLP.ExactHessian,
    qn_options=MadNLP.QuasiNewtonOptions(),
    schur_ns::Int=0,
    schur_nv::Int=0,
    schur_nd::Int=0,
    schur_nc::Int=0,
    schur_scenario_opt_linear_solver=MadNLP.default_options(CUDSSSolver),
) where {T, VT <: CuVector{T}}

    n = cb.nvar
    m = cb.ncon
    ns_ineq = length(cb.ind_ineq)
    n_eq_total = m - ns_ineq
    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)

    ns, nv, nd, nc = MadNLP._resolve_schur_dims(cb, n, m, schur_ns, schur_nv, schur_nd, schur_nc)

    # --- Get sparsity patterns on CPU ---
    jac_sparsity_I = Vector{Int32}(undef, cb.nnzj)
    jac_sparsity_J = Vector{Int32}(undef, cb.nnzj)
    MadNLP._jac_sparsity_wrapper!(cb, jac_sparsity_I, jac_sparsity_J)

    hess_sparsity_I_gpu, hess_sparsity_J_gpu = MadNLP.build_hessian_structure(cb, hessian_approximation)
    # Convert to CPU for construction-time classification loops
    hess_sparsity_I = Vector{Int32}(Array(hess_sparsity_I_gpu))
    hess_sparsity_J = Vector{Int32}(Array(hess_sparsity_J_gpu))
    MadNLP.force_lower_triangular!(hess_sparsity_I, hess_sparsity_J)

    n_hess = length(hess_sparsity_I)
    n_jac = length(jac_sparsity_I)

    # --- COO value buffers on GPU ---
    hess = CuVector{T}(undef, n_hess)
    jac = CuVector{T}(undef, n_jac)
    fill!(hess, zero(T))
    fill!(jac, zero(T))

    # --- Build global COO + CSC on GPU ---
    hess_I_gpu = CuVector{Int32}(hess_sparsity_I)
    hess_J_gpu = CuVector{Int32}(hess_sparsity_J)
    jac_I_gpu = CuVector{Int32}(jac_sparsity_I)
    jac_J_gpu = CuVector{Int32}(jac_sparsity_J)

    hess_raw = MadNLP.SparseMatrixCOO(n, n, hess_I_gpu, hess_J_gpu, hess)
    jt_coo = MadNLP.SparseMatrixCOO(n, m, jac_J_gpu, jac_I_gpu, jac)

    hess_csc, hess_csc_map = MadNLP.coo_to_csc(hess_raw)
    jt_csc, jt_csc_map = MadNLP.coo_to_csc(jt_coo)

    # --- Classify constraints per scenario and build per-scenario maps (CPU) ---
    cpu_ind_eq = Array(cb.ind_eq)
    cpu_ind_ineq = Array(cb.ind_ineq)
    cpu_ind_lb = Array(cb.ind_lb)
    cpu_ind_ub = Array(cb.ind_ub)

    sym = MadNLP._build_schur_symbolic(
        T, n, m, ns, nv, nd, nc,
        hess_sparsity_I, hess_sparsity_J,
        jac_sparsity_I, jac_sparsity_J,
        cpu_ind_eq, cpu_ind_ineq,
    )
    nc_eq_per_s = sym.nc_eq_per_s
    nc_ineq_per_s = sym.nc_ineq_per_s
    blk_size = sym.blk_size
    nnz_per_scenario = sym.nnz_per_scenario
    akk_csc_cpu = sym.akk_csc_template

    # Flatten per-scenario block_maps into the per-field concatenated CPU vectors
    # the GPU struct stores (one upload per field below).
    flat = MadNLP._flatten_block_maps(sym.block_maps)

    # --- Create batched CSC on GPU (shared colptr/rowval, per-scenario nzval slabs) ---
    batched_colPtr = CuVector{Cint}(Vector{Cint}(akk_csc_cpu.colptr))
    batched_rowVal = CuVector{Cint}(Vector{Cint}(akk_csc_cpu.rowval))
    batched_nzVal = CUDACore.fill(zero(T), ns * nnz_per_scenario)

    A_kk_batched = cuSPARSE.CuSparseMatrixCSC{T, Cint}(
        batched_colPtr, batched_rowVal, batched_nzVal, (blk_size, blk_size),
    )

    # --- Dense arrays on GPU ---
    aug_com = CuMatrix{T}(undef, nd, nd)
    fill!(aug_com, zero(T))
    C_dk_batched = CuArray{T, 3}(undef, blk_size, nd, ns)
    fill!(C_dk_batched, zero(T))
    tmp_blk_nd_batched = CuArray{T, 3}(undef, blk_size, nd, ns)

    # --- Diagonal vectors on GPU ---
    reg     = CuVector{T}(undef, n + ns_ineq)
    pr_diag = CuVector{T}(undef, n + ns_ineq)
    du_diag = CuVector{T}(undef, m)
    l_diag  = CUDACore.fill(one(T), nlb)
    u_diag  = CUDACore.fill(one(T), nub)
    l_lower = CUDACore.fill(zero(T), nlb)
    u_lower = CUDACore.fill(zero(T), nub)

    fill!(pr_diag, zero(T))
    fill!(du_diag, zero(T))

    # --- Buffers ---
    diag_buffer = CuVector{T}(undef, max(ns_ineq, 1))
    buffer      = CuVector{T}(undef, m)
    # Size matches the eq_global_indices gather/scatter shape used in
    # solve_kkt! step 7. ns * nc_eq_per_s == n_eq_total under the uniform-
    # scenario invariant validated in _build_schur_symbolic.
    wy_eq_buf   = CuVector{T}(undef, ns * nc_eq_per_s)
    rhs_d       = CuVector{T}(undef, nd)
    rhs_k_batched = CuMatrix{T}(undef, blk_size, ns)
    solve_buffer = CuVector{T}(undef, blk_size * ns)

    # --- Transfer flattened index maps to GPU ---
    gpu_hess_Akk_coo    = CuVector{Int}(flat.all_hess_Akk_coo)
    gpu_hess_Akk_nzpos  = CuVector{Int}(flat.all_hess_Akk_nzpos)
    gpu_hess_Cdk_coo    = CuVector{Int}(flat.all_hess_Cdk_coo)
    gpu_hess_Cdk_row    = CuVector{Int}(flat.all_hess_Cdk_row)
    gpu_hess_Cdk_col    = CuVector{Int}(flat.all_hess_Cdk_col)
    gpu_pr_diag_global  = CuVector{Int}(flat.all_pr_diag_global)
    gpu_pr_diag_nzpos   = CuVector{Int}(flat.all_pr_diag_nzpos)
    gpu_du_diag_global  = CuVector{Int}(flat.all_du_diag_global)
    gpu_du_diag_nzpos   = CuVector{Int}(flat.all_du_diag_nzpos)
    gpu_jeq_Akk_coo     = CuVector{Int}(flat.all_jeq_Akk_coo)
    gpu_jeq_Akk_nzpos   = CuVector{Int}(flat.all_jeq_Akk_nzpos)
    gpu_jeq_Cdk_coo     = CuVector{Int}(flat.all_jeq_Cdk_coo)
    gpu_jeq_Cdk_row     = CuVector{Int}(flat.all_jeq_Cdk_row)
    gpu_jeq_Cdk_col     = CuVector{Int}(flat.all_jeq_Cdk_col)
    gpu_ineq_Akk_nzpos  = CuVector{Int}(flat.all_ineq_Akk_nzpos)
    gpu_ineq_Akk_jcoo1  = CuVector{Int}(flat.all_ineq_Akk_jcoo1)
    gpu_ineq_Akk_jcoo2  = CuVector{Int}(flat.all_ineq_Akk_jcoo2)
    gpu_ineq_Akk_bufidx = CuVector{Int}(flat.all_ineq_Akk_bufidx)
    gpu_ineq_Cdk_row    = CuVector{Int}(flat.all_ineq_Cdk_row)
    gpu_ineq_Cdk_col    = CuVector{Int}(flat.all_ineq_Cdk_col)
    gpu_ineq_Cdk_jcoo_d = CuVector{Int}(flat.all_ineq_Cdk_jcoo_d)
    gpu_ineq_Cdk_jcoo_v = CuVector{Int}(flat.all_ineq_Cdk_jcoo_v)
    gpu_ineq_Cdk_bufidx = CuVector{Int}(flat.all_ineq_Cdk_bufidx)
    gpu_ineq_S_row      = CuVector{Int}(flat.all_ineq_S_row)
    gpu_ineq_S_col      = CuVector{Int}(flat.all_ineq_S_col)
    gpu_ineq_S_jcoo1    = CuVector{Int}(flat.all_ineq_S_jcoo1)
    gpu_ineq_S_jcoo2    = CuVector{Int}(flat.all_ineq_S_jcoo2)
    gpu_ineq_S_bufidx   = CuVector{Int}(flat.all_ineq_S_bufidx)
    gpu_hess_S_coo      = CuVector{Int}(sym.hess_S_coo)
    gpu_hess_S_row      = CuVector{Int}(sym.hess_S_row)
    gpu_hess_S_col      = CuVector{Int}(sym.hess_S_col)
    gpu_eq_global_indices = CuVector{Int}(sym.eq_global_flat)

    # --- Create solvers ---
    quasi_newton = MadNLP.create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    # cuDSS is the only sparse batched solver wired into this path; users tune it
    # via `schur_scenario_opt_linear_solver` rather than swapping the type.
    scenario_solver = CUDSSSolver(A_kk_batched; opt=schur_scenario_opt_linear_solver)
    _linear_solver = linear_solver(aug_com; opt=opt_linear_solver)

    # --- Multi-RHS cuDSS descriptors for batched A_kk \ C_dk' ---
    # The descriptors hold the (blk × nd) shape per scenario and point at the
    # existing buffers each iteration.
    scenario_b_multi = CUDSS.CudssMatrix(T, blk_size, nd; nbatch=ns)
    scenario_x_multi = CUDSS.CudssMatrix(T, blk_size, nd; nbatch=ns)
    # Re-analyze for the multi-RHS shape so cuDSS plans enough workspace.
    # This is the LARGEST RHS shape we will ever solve with on this handle;
    # the later single-RHS solve at `solve_kkt!` step 3 reuses the same handle
    # with a (blk × 1) × ns descriptor, which relies on the invariant that
    # "analysis planned for a larger RHS accepts a smaller RHS at solve time".
    # If that breaks on a future cuDSS version (e.g. a strict shape check or
    # per-column IR state), the single-RHS path would need its own handle or
    # padding. The `schur_cudss_ir` test exercises `cudss_ir > 0` — the config
    # most likely to surface such a regression — as a tripwire.
    CUDSS.cudss(
        "analysis", scenario_solver.inner,
        scenario_x_multi, scenario_b_multi;
        asynchronous=scenario_solver.opt.cudss_asynchronous,
    )

    return GPUSchurComplementKKTSystem(
        hess, jac,
        hess_raw, jt_coo,
        hess_csc, hess_csc_map, jt_csc, jt_csc_map,
        quasi_newton,
        reg, pr_diag, du_diag, l_diag, u_diag, l_lower, u_lower,
        ns, nv, nd, nc, nc_eq_per_s, nc_ineq_per_s, blk_size,
        A_kk_batched, nnz_per_scenario,
        C_dk_batched, aug_com,
        diag_buffer, buffer, wy_eq_buf, rhs_d, rhs_k_batched, tmp_blk_nd_batched, solve_buffer,
        flat.n_per_s_hess_Akk, gpu_hess_Akk_coo, gpu_hess_Akk_nzpos,
        flat.n_per_s_hess_Cdk, gpu_hess_Cdk_coo, gpu_hess_Cdk_row, gpu_hess_Cdk_col,
        flat.n_per_s_pr_diag, gpu_pr_diag_global, gpu_pr_diag_nzpos,
        flat.n_per_s_du_diag, gpu_du_diag_global, gpu_du_diag_nzpos,
        flat.n_per_s_jeq_Akk, gpu_jeq_Akk_coo, gpu_jeq_Akk_nzpos,
        flat.n_per_s_jeq_Cdk, gpu_jeq_Cdk_coo, gpu_jeq_Cdk_row, gpu_jeq_Cdk_col,
        flat.n_per_s_ineq_Akk, gpu_ineq_Akk_nzpos, gpu_ineq_Akk_jcoo1, gpu_ineq_Akk_jcoo2, gpu_ineq_Akk_bufidx,
        flat.n_per_s_ineq_Cdk, gpu_ineq_Cdk_row, gpu_ineq_Cdk_col, gpu_ineq_Cdk_jcoo_d, gpu_ineq_Cdk_jcoo_v, gpu_ineq_Cdk_bufidx,
        flat.n_per_s_ineq_S, gpu_ineq_S_row, gpu_ineq_S_col, gpu_ineq_S_jcoo1, gpu_ineq_S_jcoo2, gpu_ineq_S_bufidx,
        gpu_hess_S_coo, gpu_hess_S_row, gpu_hess_S_col,
        gpu_eq_global_indices,
        n_eq_total, CuVector{Int}(cpu_ind_eq),
        ns_ineq, CuVector{Int}(cpu_ind_ineq), CuVector{Int}(cpu_ind_lb), CuVector{Int}(cpu_ind_ub),
        scenario_solver, _linear_solver,
        scenario_x_multi, scenario_b_multi,
    )
end

# --- Trivial accessors ---
MadNLP.num_variables(kkt::GPUSchurComplementKKTSystem) = size(kkt.hess_csc, 1)

function MadNLP.get_slack_regularization(kkt::GPUSchurComplementKKTSystem)
    n = MadNLP.num_variables(kkt)
    return view(kkt.pr_diag, n+1:n+kkt.n_ineq)
end

function MadNLP.is_inertia_correct(kkt::GPUSchurComplementKKTSystem, num_pos, num_zero, num_neg)
    return (num_zero == 0) && (num_pos == size(kkt.aug_com, 1))
end

MadNLP.should_regularize_dual(kkt::GPUSchurComplementKKTSystem, num_pos, num_zero, num_neg) = true

MadNLP.nnz_jacobian(kkt::GPUSchurComplementKKTSystem) = MadNLP.nnz(kkt.jt_coo)

function MadNLP.jtprod!(y::VT, kkt::GPUSchurComplementKKTSystem, x::VT) where {VT <: CuVector}
    nx = MadNLP.num_variables(kkt)
    ns_ineq = kkt.n_ineq
    yx = view(y, 1:nx)
    ys = view(y, 1+nx:nx+ns_ineq)
    mul!(yx, kkt.jt_csc, x)
    ys .= -@view(x[kkt.ind_ineq])
    return
end

function MadNLP.compress_jacobian!(kkt::GPUSchurComplementKKTSystem)
    MadNLP.transfer!(kkt.jt_csc, kkt.jt_coo, kkt.jt_csc_map)
end

function MadNLP.compress_hessian!(kkt::GPUSchurComplementKKTSystem)
    MadNLP.transfer!(kkt.hess_csc, kkt.hess_raw, kkt.hess_csc_map)
end

# --- build_kkt! ---
function MadNLP.build_kkt!(kkt::GPUSchurComplementKKTSystem{T}) where T
    ns = kkt.ns
    nv = kkt.nv
    nd = kkt.nd
    n = MadNLP.num_variables(kkt)
    blk = kkt.blk_size
    backend = CUDABackend()
    nzval = kkt.A_kk_batched.nzVal
    nnz_s = kkt.nnz_per_scenario

    # Compute condensing diagonal for inequalities
    if kkt.n_ineq > 0
        Sigma_s = view(kkt.pr_diag, n+1:n+kkt.n_ineq)
        Sigma_d = @view(kkt.du_diag[kkt.ind_ineq])
        kkt.diag_buffer .= Sigma_s ./ (one(T) .- Sigma_d .* Sigma_s)
    end

    # Zero out assembly targets
    fill!(kkt.aug_com, zero(T))
    fill!(nzval, zero(T))
    fill!(kkt.C_dk_batched, zero(T))

    # Initialize S from design-design Hessian
    n_hess_S = length(kkt.hess_S_coo)
    if n_hess_S > 0
        _init_S_hess_kernel!(backend)(
            kkt.aug_com, kkt.hess, kkt.hess_S_coo, kkt.hess_S_row, kkt.hess_S_col;
            ndrange=n_hess_S,
        )
    end
    if nd > 0
        _init_S_diag_kernel!(backend)(kkt.aug_com, kkt.pr_diag, ns * nv, nd; ndrange=nd)
    end

    # Scatter Hessian diagonal → A_kk (flattened maps)
    n_hA = kkt.n_per_s_hess_Akk
    if n_hA > 0
        _scatter_to_Akk_batched!(backend)(
            nzval, kkt.hess, kkt.gpu_hess_Akk_coo, kkt.gpu_hess_Akk_nzpos,
            nnz_s, n_hA;
            ndrange=ns * n_hA,
        )
    end

    # Scatter Hessian coupling → C_dk
    n_hC = kkt.n_per_s_hess_Cdk
    if n_hC > 0
        _scatter_to_Cdk_batched!(backend)(
            kkt.C_dk_batched, kkt.hess, kkt.gpu_hess_Cdk_coo,
            kkt.gpu_hess_Cdk_col, kkt.gpu_hess_Cdk_row, n_hC;
            ndrange=ns * n_hC,
        )
    end

    # Scatter pr_diag → A_kk diagonal
    n_pr = kkt.n_per_s_pr_diag
    if n_pr > 0
        _scatter_to_Akk_batched!(backend)(
            nzval, kkt.pr_diag, kkt.gpu_pr_diag_global, kkt.gpu_pr_diag_nzpos,
            nnz_s, n_pr;
            ndrange=ns * n_pr,
        )
    end

    # Scatter du_diag → A_kk diagonal
    n_du = kkt.n_per_s_du_diag
    if n_du > 0
        _scatter_to_Akk_batched!(backend)(
            nzval, kkt.du_diag, kkt.gpu_du_diag_global, kkt.gpu_du_diag_nzpos,
            nnz_s, n_du;
            ndrange=ns * n_du,
        )
    end

    # Scatter equality Jacobian → A_kk
    n_jA = kkt.n_per_s_jeq_Akk
    if n_jA > 0
        _scatter_to_Akk_batched!(backend)(
            nzval, kkt.jac, kkt.gpu_jeq_Akk_coo, kkt.gpu_jeq_Akk_nzpos,
            nnz_s, n_jA;
            ndrange=ns * n_jA,
        )
    end

    # Scatter equality Jacobian coupling → C_dk
    n_jC = kkt.n_per_s_jeq_Cdk
    if n_jC > 0
        _scatter_to_Cdk_batched!(backend)(
            kkt.C_dk_batched, kkt.jac, kkt.gpu_jeq_Cdk_coo,
            kkt.gpu_jeq_Cdk_col, kkt.gpu_jeq_Cdk_row, n_jC;
            ndrange=ns * n_jC,
        )
    end

    # Inequality condensation → A_kk
    n_iA = kkt.n_per_s_ineq_Akk
    if n_iA > 0
        _ineq_condense_Akk_kernel!(backend)(
            nzval, kkt.jac, kkt.diag_buffer,
            kkt.gpu_ineq_Akk_nzpos, kkt.gpu_ineq_Akk_jcoo1,
            kkt.gpu_ineq_Akk_jcoo2, kkt.gpu_ineq_Akk_bufidx,
            nnz_s, n_iA;
            ndrange=ns * n_iA,
        )
    end

    # Inequality condensation → C_dk
    n_iC = kkt.n_per_s_ineq_Cdk
    if n_iC > 0
        _ineq_condense_Cdk_kernel!(backend)(
            kkt.C_dk_batched, kkt.jac, kkt.diag_buffer,
            kkt.gpu_ineq_Cdk_col, kkt.gpu_ineq_Cdk_row,
            kkt.gpu_ineq_Cdk_jcoo_d, kkt.gpu_ineq_Cdk_jcoo_v,
            kkt.gpu_ineq_Cdk_bufidx, n_iC;
            ndrange=ns * n_iC,
        )
    end

    # Inequality condensation → S (atomic adds)
    n_iS = kkt.n_per_s_ineq_S
    if n_iS > 0
        _ineq_condense_S_kernel!(backend)(
            kkt.aug_com, kkt.jac, kkt.diag_buffer,
            kkt.gpu_ineq_S_row, kkt.gpu_ineq_S_col,
            kkt.gpu_ineq_S_jcoo1, kkt.gpu_ineq_S_jcoo2,
            kkt.gpu_ineq_S_bufidx;
            ndrange=ns * n_iS,
        )
    end

    # Factorize all scenario blocks in one batched cuDSS call
    MadNLP.factorize!(kkt.scenario_solver)

    # Compute tmp = A_kk^{-1} * C_dk' in one batched multi-RHS cuDSS solve:
    # for each scenario k, solve the (blk × blk) system with nd right-hand sides
    # packed as the columns of C_dk_batched[:, :, k]. The (blk, nd, ns) layouts
    # of both buffers line up directly with a cuDSS batched dense descriptor, so
    # this is zero-copy — we only retarget the matrix descriptors each iteration.
    CUDSS.cudss_update(kkt.scenario_b_multi, kkt.C_dk_batched)
    CUDSS.cudss_update(kkt.scenario_x_multi, kkt.tmp_blk_nd_batched)
    CUDSS.cudss(
        "solve", kkt.scenario_solver.inner,
        kkt.scenario_x_multi, kkt.scenario_b_multi;
        asynchronous=kkt.scenario_solver.opt.cudss_asynchronous,
    )

    # S -= Σ_k C_dk[:,:,k]' * tmp[:,:,k]
    # Reshape the (blk, nd, ns) buffers as (blk*ns, nd): column-major flattening
    # collapses the per-scenario contributions into a single GEMM, since
    # (C_2d' * tmp_2d)[a, b] = Σ_{i,k} C[i,a,k] * tmp[i,b,k] = Σ_k (C_dk[:,:,k]' * tmp[:,:,k])[a, b].
    # Avoids both the (nd × nd × ns) S_contrib buffer and the per-iteration
    # `dropdims(sum(...))` allocation that the batched-GEMM path required.
    C_2d = reshape(kkt.C_dk_batched, blk * ns, nd)
    tmp_2d = reshape(kkt.tmp_blk_nd_batched, blk * ns, nd)
    mul!(kkt.aug_com, C_2d', tmp_2d, -one(T), one(T))

    return
end

# --- factorize_kkt! ---
function MadNLP.factorize_kkt!(kkt::GPUSchurComplementKKTSystem)
    return MadNLP.factorize!(kkt.linear_solver)
end

# --- solve_kkt! ---
function MadNLP.solve_kkt!(
    kkt::GPUSchurComplementKKTSystem{T},
    w::MadNLP.AbstractKKTVector{T},
) where T

    ns = kkt.ns
    nv = kkt.nv
    nd = kkt.nd
    n = MadNLP.num_variables(kkt)
    blk = kkt.blk_size
    nc_eq = kkt.nc_eq_per_s
    backend = CUDABackend()

    wx = view(MadNLP.full(w), 1:n)
    ws = view(MadNLP.full(w), n+1:n+kkt.n_ineq)
    wy = MadNLP.dual(w)

    Sigma_s = MadNLP.get_slack_regularization(kkt)

    MadNLP.reduce_rhs!(kkt, w)

    # Step 1: condense inequality contributions
    fill!(kkt.buffer, zero(T))
    if kkt.n_ineq > 0
        kkt.buffer[kkt.ind_ineq] .= kkt.diag_buffer .* (wy[kkt.ind_ineq] .+ ws ./ Sigma_s)
        mul!(wx, kkt.jt_csc, kkt.buffer, one(T), one(T))
    end

    # Step 2: Extract per-scenario RHS blocks via kernel
    if blk * ns > 0
        _extract_rhs_kernel!(backend)(
            kkt.rhs_k_batched, wx, wy, kkt.eq_global_indices,
            nv, nc_eq, ns, blk;
            ndrange=blk * ns,
        )
    end
    copyto!(kkt.rhs_d, view(wx, ns*nv+1:ns*nv+nd))

    # Step 3: Forward elimination — batched solve
    copyto!(kkt.solve_buffer, vec(kkt.rhs_k_batched))
    MadNLP.solve_linear_system!(kkt.scenario_solver, kkt.solve_buffer)
    copyto!(vec(kkt.rhs_k_batched), kkt.solve_buffer)

    # rhs_d -= Σ_k C_dk[:,:,k]' * rhs_k[:,k]: same column-major reshape trick as
    # build_kkt!. C_2d' * vec(rhs_k_batched) == Σ_k C_dk[:,:,k]' * rhs_k[:,k].
    # One launch instead of ns.
    C_2d = reshape(kkt.C_dk_batched, blk * ns, nd)
    mul!(kkt.rhs_d, C_2d', vec(kkt.rhs_k_batched), -one(T), one(T))

    # Step 4: Solve Schur complement
    MadNLP.solve_linear_system!(kkt.linear_solver, kkt.rhs_d)

    # Step 5: Back-substitution. rhs_k[:,k] -= tmp[:,:,k] * rhs_d for all k;
    # reshape tmp as (blk*ns, nd) so a single GEMV updates the flattened
    # rhs_k_batched in place.
    tmp_2d = reshape(kkt.tmp_blk_nd_batched, blk * ns, nd)
    mul!(vec(kkt.rhs_k_batched), tmp_2d, kkt.rhs_d, -one(T), one(T))

    # Step 6: Write back to w via kernel
    if blk * ns > 0
        _writeback_rhs_kernel!(backend)(
            wx, wy, kkt.rhs_k_batched, kkt.eq_global_indices,
            nv, nc_eq, ns, blk;
            ndrange=blk * ns,
        )
    end
    copyto!(view(wx, ns*nv+1:ns*nv+nd), kkt.rhs_d)

    # Step 7: Recover inequality duals and slacks
    if kkt.n_ineq > 0
        # Stash eq duals; mul! below overwrites all of wy.
        # Vectorized GPU gather/scatter — no @allowscalar.
        copyto!(kkt.wy_eq_buf, view(wy, kkt.eq_global_indices))

        # J * Δx
        mul!(wy, kkt.jt_csc', wx)

        # Restore equality duals
        view(wy, kkt.eq_global_indices) .= kkt.wy_eq_buf

        # Inequality dual recovery
        wy[kkt.ind_ineq] .= kkt.diag_buffer .* wy[kkt.ind_ineq] .- kkt.buffer[kkt.ind_ineq]
        ws .= (ws .+ view(wy, kkt.ind_ineq)) ./ Sigma_s
    end

    MadNLP.finish_aug_solve!(kkt, w)
    return w
end

# --- mul! for iterative refinement ---
function MadNLP.mul!(
    w::MadNLP.AbstractKKTVector{T, VT},
    kkt::GPUSchurComplementKKTSystem{T},
    x::MadNLP.AbstractKKTVector,
    alpha = one(T),
    beta = zero(T),
) where {T, VT <: CuVector{T}}
    n = MadNLP.num_variables(kkt)

    wx = @view(MadNLP.primal(w)[1:n])
    ws = @view(MadNLP.primal(w)[n+1:end])
    wy = MadNLP.dual(w)

    xx = @view(MadNLP.primal(x)[1:n])
    xs = @view(MadNLP.primal(x)[n+1:end])
    xz = @view(MadNLP.dual(x)[kkt.ind_ineq])

    wx .= beta .* wx
    mul!(wx, Symmetric(kkt.hess_csc, :L), xx, alpha, one(T))

    m = size(kkt.jt_csc, 2)
    if m > 0
        mul!(wx, kkt.jt_csc, MadNLP.dual(x), alpha, one(T))
        mul!(wy, kkt.jt_csc', xx, alpha, beta)
    else
        wy .= beta .* wy
    end
    ws .= beta .* ws .- alpha .* xz
    @view(MadNLP.dual(w)[kkt.ind_ineq]) .-= alpha .* xs
    MadNLP._kktmul!(w, x, kkt.reg, kkt.du_diag, kkt.l_lower, kkt.u_lower, kkt.l_diag, kkt.u_diag, alpha, beta)
    return w
end

function MadNLP.mul_hess_blk!(wx::VT, kkt::GPUSchurComplementKKTSystem{T}, t) where {T, VT <: CuVector{T}}
    n = MadNLP.num_variables(kkt)
    mul!(@view(wx[1:n]), Symmetric(kkt.hess_csc, :L), @view(t[1:n]))
    fill!(@view(wx[n+1:end]), 0)
    wx .+= t .* kkt.pr_diag
end

# Script to parse the Pardiso header and generate Julia wrappers.
using Clang
using Clang.Generators
using JuliaFormatter

function main()
  @info "Wrapping Pardiso"

  cd(@__DIR__)
  include_dir = joinpath(pwd(), "include")
  headers = joinpath(include_dir, "pardiso.h")

  options = load_options(joinpath(@__DIR__, "generator.toml"))
  options["general"]["output_file_path"] = joinpath("..", "src", "libpardiso.jl")
  options["general"]["library_name"] = "libpardiso"
  options["general"]["output_ignorelist"] = ["doublecomplex"]

  args = get_default_args()
  push!(args, "-I$include_dir")

  ctx = create_context(headers, args, options)
  build!(ctx)

  path = options["general"]["output_file_path"]
  format_file(path, YASStyle())

  text = read(path, String)
  # text = replace(text, "Clong" => "SS_Int")
  # text = replace(text, "end\n\nconst" => "end\n\n\nconst")
  # text = replace(text, "\n\nconst" => "\nconst")
  write(path, text)
  return nothing
end

# If we want to use the file as a script with `julia wrapper.jl`
if abspath(PROGRAM_FILE) == @__FILE__
  main()
end

#=
    MadNLP.MadNLPOptions
=#

function MadNLP.MadNLPOptions{T}(
    nlp::MadNLP.AbstractNLPModel{T,VT};
    dense_callback = MadNLP.is_dense_callback(nlp),
    callback = dense_callback ? MadNLP.DenseCallback : MadNLP.SparseCallback,
    kkt_system = dense_callback ? MadNLP.DenseCondensedKKTSystem : MadNLP.SparseCondensedKKTSystem,
    linear_solver = MadNLPGPU.LapackROCmSolver,
    tol = MadNLP.get_tolerance(T,kkt_system),
    bound_relax_factor = tol,
) where {T, VT <: ROCVector{T}}
    return MadNLP.MadNLPOptions{T}(
        tol = tol,
        callback = callback,
        kkt_system = kkt_system,
        linear_solver = linear_solver,
        bound_relax_factor = bound_relax_factor,
    )
end

#=
    SparseMatrixCSC to ROCSparseMatrixCSC
=#

function rocSPARSE.ROCSparseMatrixCSC{Tv,Ti}(A::SparseMatrixCSC{Tv,Ti}) where {Tv,Ti}
    return rocSPARSE.ROCSparseMatrixCSC{Tv,Ti}(
        ROCVector(A.colptr),
        ROCVector(A.rowval),
        ROCVector(A.nzval),
        size(A),
    )
end

#=
    ROCSparseMatrixCSC to ROCMatrix
=#

MadNLPGPU.gpu_transfer!(y::ROCMatrix{T}, x::rocSPARSE.ROCSparseMatrixCSC{T}) where {T} =
    MadNLPGPU._gpu_sparse_csc_to_dense!(y, x)

#=
    MadNLP._ger!
=#

MadNLP._ger!(alpha::T, x::ROCVector{T}, y::ROCVector{T}, A::ROCMatrix{T}) where T = rocBLAS.ger!(alpha, x, y, A)

#=
    MadNLP._syr!
=#

MadNLP._syr!(uplo::Char, alpha::T, x::ROCVector{T}, A::ROCMatrix{T}) where T = rocBLAS.syr!(uplo, alpha, x, A)

#=
    MadNLP._symv!
=#

MadNLP._symv!(uplo::Char, alpha::T, A::ROCMatrix{T}, x::ROCVector{T}, beta::T, y::ROCVector{T}) where T = rocBLAS.symv!(uplo, alpha, A, x, beta, y)

#=
    MadNLP._syrk!
=#

MadNLP._syrk!(uplo::Char, trans::Char, alpha::T, A::ROCMatrix{T}, beta::T, C::ROCMatrix{T}) where T = rocBLAS.syrk!(uplo, trans, alpha, A, beta, C)

#=
    MadNLP._trsm!
=#

MadNLP._trsm!(side::Char, uplo::Char, transa::Char, diag::Char, alpha::T, A::ROCMatrix{T}, B::ROCMatrix{T}) where T = rocBLAS.trsm!(side, uplo, transa, diag, alpha, A, B)

#=
    MadNLP._dgmm!
=#

MadNLP._dgmm!(side::Char, A::ROCMatrix{T}, x::ROCVector{T}, B::ROCMatrix{T}) where T = rocBLAS.dgmm!(side, A, x, B)

"""
    ScenarioBlockMap

Precomputed index mappings for one scenario — maps from global COO indices
to per-block positions in A_kk (sparse), C_dk (dense), and S (dense).
"""
struct ScenarioBlockMap
    # Hessian diagonal block: global hess COO index → A_kk nzval position
    hess_Akk_coo::Vector{Int}
    hess_Akk_nzpos::Vector{Int}

    # Hessian coupling block: global hess COO index → (C_dk row, C_dk col)
    hess_Cdk_coo::Vector{Int}
    hess_Cdk_row::Vector{Int}
    hess_Cdk_col::Vector{Int}

    # Equality Jacobian, scenario vars → A_kk lower triangle only
    jeq_Akk_coo::Vector{Int}
    jeq_Akk_nzpos::Vector{Int}

    # Equality Jacobian, design vars → C_dk
    jeq_Cdk_coo::Vector{Int}
    jeq_Cdk_row::Vector{Int}   # design var index (1:nd)
    jeq_Cdk_col::Vector{Int}   # nv + eq_local_idx

    # Inequality condensation → A_kk (lower triangle)
    ineq_Akk_nzpos::Vector{Int}
    ineq_Akk_jcoo1::Vector{Int}
    ineq_Akk_jcoo2::Vector{Int}
    ineq_Akk_bufidx::Vector{Int}

    # Inequality condensation → C_dk
    ineq_Cdk_row::Vector{Int}     # design var index (1:nd)
    ineq_Cdk_col::Vector{Int}     # scenario local var (1:nv)
    ineq_Cdk_jcoo_d::Vector{Int}  # jac COO for design var
    ineq_Cdk_jcoo_v::Vector{Int}  # jac COO for scenario var
    ineq_Cdk_bufidx::Vector{Int}

    # Inequality condensation → S (full, both triangles)
    ineq_S_row::Vector{Int}
    ineq_S_col::Vector{Int}
    ineq_S_jcoo1::Vector{Int}
    ineq_S_jcoo2::Vector{Int}
    ineq_S_bufidx::Vector{Int}

    # Diagonal positions in A_kk nzval for pr_diag (nv entries)
    pr_diag_global::Vector{Int}
    pr_diag_nzpos::Vector{Int}

    # Diagonal positions in A_kk nzval for du_diag (nc_eq entries)
    du_diag_global::Vector{Int}
    du_diag_nzpos::Vector{Int}
end

"""
    SchurComplementKKTSystem{T, VT, MT, QN, LS, LS2, VI} <: AbstractCondensedKKTSystem{T, VT, MT, QN}

KKT system exploiting block-arrowhead structure from two-stage stochastic programs
via Schur complement decomposition, using sparse COO/CSC storage for the global
Hessian and Jacobian and sparse per-scenario block solvers.

Variable layout: `[v_1, ..., v_ns, d]` where `v_k ∈ R^nv`, `d ∈ R^nd`.
Constraint layout: `[c_1, ..., c_ns]` where `c_k ∈ R^nc`.

The augmented per-scenario block `A_k` (size `blk_size × blk_size`) is stored
as a sparse lower-triangular `SparseMatrixCSC` and factored by a configurable
sparse solver (default `MumpsSolver` — each `A_k` is symmetric indefinite, not
SQD in general). The coupling blocks `C_dk` remain dense. The Schur complement
`S = aug_com` (size `nd × nd`) is dense.
"""
struct SchurComplementKKTSystem{
    T,
    VT <: AbstractVector{T},
    MT <: AbstractMatrix{T},
    QN,
    LS,
    LS2,
    VI <: AbstractVector{Int}
    } <: AbstractCondensedKKTSystem{T, VT, MT, QN}

    # COO value buffers (filled by NLP callback via jac_coord!/hess_coord!)
    hess::VT                        # length cb.nnzh
    jac::VT                         # length cb.nnzj

    # COO structures (share value buffers above)
    hess_raw::SparseMatrixCOO{T, Int32, VT, Vector{Int32}}
    jt_coo::SparseMatrixCOO{T, Int32, VT, Vector{Int32}}

    # CSC representations (for jtprod, mul, dual recovery)
    hess_csc::SparseMatrixCSC{T, Int32}
    hess_csc_map::Vector{Int}
    jt_csc::SparseMatrixCSC{T, Int32}
    jt_csc_map::Vector{Int}

    quasi_newton::QN

    # Standard MadNLP diagonal vectors
    reg::VT                         # n_total + n_ineq
    pr_diag::VT                     # n_total + n_ineq
    du_diag::VT                     # m_total
    l_diag::VT                      # nlb
    u_diag::VT                      # nub
    l_lower::VT                     # nlb
    u_lower::VT                     # nub

    # Two-stage dimensions
    ns::Int
    nv::Int
    nd::Int
    nc::Int
    nc_eq_per_s::Int
    nc_ineq_per_s::Int
    blk_size::Int                   # = nv + nc_eq_per_s

    # Per-scenario sparse augmented blocks (lower triangle only)
    A_kk::Vector{SparseMatrixCSC{T, Int32}}
    C_dk::Vector{MT}                # ns × (nd × blk_size) — dense

    # Schur complement (what the dense linear solver sees)
    aug_com::MT                     # nd × nd

    # Buffers
    diag_buffer::VT                 # n_ineq — condensing diagonal
    buffer::VT                      # m_total — general
    wy_eq_buf::VT                   # ns*nc_eq_per_s — preserves eq duals across J*Δx round-trip
    rhs_d::VT                       # nd — design RHS
    rhs_k::Vector{VT}              # ns × blk_size — scenario RHS buffers
    tmp_blk_nd::Vector{MT}         # ns × (blk_size × nd)
    solve_buffers::Vector{VT}      # ns × blk_size — per-scenario column-by-column solve buffers

    # Precomputed index maps
    block_maps::Vector{ScenarioBlockMap}
    hess_S_coo::Vector{Int}         # COO indices for design-design Hessian
    hess_S_row::Vector{Int}         # S row (1:nd)
    hess_S_col::Vector{Int}         # S col (1:nd)

    # Flat per-scenario equality indices (length ns * nc_eq_per_s).
    # Scenario k's indices live at (k-1)*nc_eq_per_s+1 : k*nc_eq_per_s.
    eq_global_indices::Vector{Int}

    # Inequality/equality/bound index info
    n_eq::Int
    ind_eq::VI
    n_ineq::Int
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI

    # Solvers
    scenario_solvers::Vector{LS2}
    linear_solver::LS               # for Schur complement S (dense)
end

"""
    _resolve_schur_dims(cb, n, m, schur_ns, schur_nv, schur_nd, schur_nc)
    -> (ns, nv, nd, nc)

Resolve two-stage stochastic dimensions for a SchurComplementKKTSystem.

If `schur_ns == 0`, attempt to auto-detect from `cb.nlp.tags::TwoStageTags`
(an ExaModel convention): `tags.var_scenario[i] == 0` flags design variables,
`== 1` flags scenario variables; same encoding for `con_scenario`.

Asserts that the resolved dimensions are consistent with `n` and `m`.
"""
function _resolve_schur_dims(cb, n, m, schur_ns, schur_nv, schur_nd, schur_nc)
    if schur_ns == 0 && hasproperty(cb.nlp, :tags)
        tags = cb.nlp.tags
        if hasproperty(tags, :ns) && hasproperty(tags, :var_scenario) && hasproperty(tags, :con_scenario)
            schur_ns = tags.ns
            var_scen = Array(tags.var_scenario)
            con_scen = Array(tags.con_scenario)

            # Single-pass histograms over the scenario tags. Index 1 is the design
            # bucket (tag 0); 1+k is scenario k. Cheaper than the previous three
            # `count(==(·))` passes and lets us validate per-scenario uniformity
            # in the same pass — important because a malformed model whose global
            # aggregates happen to satisfy n == ns*nv + nd would otherwise drive
            # downstream symbolic build into garbage territory.
            var_hist = zeros(Int, schur_ns + 1)
            for tag in var_scen
                t = Int(tag)
                (0 <= t <= schur_ns) || error(
                    "var_scenario tag $t out of range [0, $schur_ns]; " *
                    "0 = design, 1..$schur_ns = scenario index."
                )
                @inbounds var_hist[t + 1] += 1
            end
            con_hist = zeros(Int, schur_ns + 1)
            for tag in con_scen
                t = Int(tag)
                (0 <= t <= schur_ns) || error(
                    "con_scenario tag $t out of range [0, $schur_ns]; " *
                    "1..$schur_ns = scenario index."
                )
                @inbounds con_hist[t + 1] += 1
            end

            schur_nd = var_hist[1]
            schur_nv = var_hist[2]
            schur_nc = con_hist[2]

            # Reject design-only constraints — the Schur reduction has no slot
            # for them.
            con_hist[1] == 0 || error(
                "$(con_hist[1]) constraints have con_scenario tag 0; " *
                "design-only constraints are not supported by SchurComplementKKTSystem."
            )

            # Per-scenario uniformity. Cheap loop, fires before any symbolic
            # work and points at the offending scenario.
            for k in 2:schur_ns
                @inbounds nv_k = var_hist[k + 1]
                @inbounds nc_k = con_hist[k + 1]
                nv_k == schur_nv || error(
                    "Scenario $k has $nv_k variables; scenario 1 has $schur_nv. " *
                    "SchurComplementKKTSystem requires uniform per-scenario sizes."
                )
                nc_k == schur_nc || error(
                    "Scenario $k has $nc_k constraints; scenario 1 has $schur_nc. " *
                    "SchurComplementKKTSystem requires uniform per-scenario sizes."
                )
            end
        end
    end

    @assert schur_ns > 0 "schur_ns must be specified and positive (or use TwoStageTags for auto-detection)"
    @assert schur_nv > 0 "schur_nv must be specified and positive"
    @assert schur_nd > 0 "schur_nd must be specified and positive"
    @assert n == schur_ns * schur_nv + schur_nd "Variable count mismatch: n=$n != ns*nv+nd=$(schur_ns*schur_nv+schur_nd)"
    @assert m == schur_ns * schur_nc "Constraint count mismatch: m=$m != ns*nc=$(schur_ns*schur_nc)"

    return schur_ns, schur_nv, schur_nd, schur_nc
end

# --- Index-driven scatter helpers used by build_kkt! ---
# Each call site reads as a one-liner instead of an open-coded for loop.

@inline function _scatter_add!(dst::AbstractVector, src::AbstractVector, src_idx, dst_idx)
    @inbounds for i in eachindex(src_idx)
        dst[dst_idx[i]] += src[src_idx[i]]
    end
end

@inline function _scatter_add!(dst::AbstractMatrix, src::AbstractVector, src_idx, row, col)
    @inbounds for i in eachindex(src_idx)
        dst[row[i], col[i]] += src[src_idx[i]]
    end
end

@inline function _scatter_quad_add!(dst::AbstractVector, src::AbstractVector, diag, dst_idx, idx1, idx2, bufidx)
    @inbounds for i in eachindex(dst_idx)
        dst[dst_idx[i]] += diag[bufidx[i]] * src[idx1[i]] * src[idx2[i]]
    end
end

@inline function _scatter_quad_add!(dst::AbstractMatrix, src::AbstractVector, diag, row, col, idx1, idx2, bufidx)
    @inbounds for i in eachindex(row)
        dst[row[i], col[i]] += diag[bufidx[i]] * src[idx1[i]] * src[idx2[i]]
    end
end

"""
    _build_schur_symbolic(T, n, m, ns, nv, nd, nc,
                          hess_I, hess_J, jac_I, jac_J,
                          ind_eq, ind_ineq) -> NamedTuple

Pure-CPU symbolic construction shared by the CPU `SchurComplementKKTSystem`
and GPU `GPUSchurComplementKKTSystem` constructors. Inputs are CPU-resident
sparsity arrays (the GPU side downloads its sparsity before calling).

**Assumes uniform per-scenario structure** (same A_kk pattern for every k).
This matches typical two-stage stochastic models and is what the GPU batched
cuDSS path requires; CPU follows the same assumption.

Returns a NamedTuple with:
- `eq_per_scenario`, `ineq_per_scenario` — `Vector{Vector{Int}}` of global indices
- `nc_eq_per_s`, `nc_ineq_per_s`, `blk_size` — per-scenario sizes
- `block_maps::Vector{ScenarioBlockMap}` — per-scenario index maps
- `hess_S_coo`, `hess_S_row`, `hess_S_col` — design-design Hessian COO maps
- `akk_csc_template::SparseMatrixCSC{T, Int32}` — shared A_kk sparsity (zero values)
- `nnz_per_scenario::Int`
- `eq_global_flat::Vector{Int}` — flattened eq indices in scenario order (for GPU)
"""
function _build_schur_symbolic(
        ::Type{T},
        n::Int, m::Int, ns::Int, nv::Int, nd::Int, nc::Int,
        hess_I::AbstractVector{<:Integer}, hess_J::AbstractVector{<:Integer},
        jac_I::AbstractVector{<:Integer}, jac_J::AbstractVector{<:Integer},
        ind_eq::AbstractVector{<:Integer},
        ind_ineq::AbstractVector{<:Integer},
    ) where {T}

    n_hess = length(hess_I)
    n_jac = length(jac_I)

    # --- Classify constraints per scenario ---
    ind_eq_set = Set(ind_eq)
    ind_ineq_set = Set(ind_ineq)

    eq_per_scenario = Vector{Vector{Int}}(undef, ns)
    ineq_per_scenario = Vector{Vector{Int}}(undef, ns)

    for k in 1:ns
        cr = (k-1)*nc+1 : k*nc
        eq_per_scenario[k] = Int[]
        ineq_per_scenario[k] = Int[]
        for gi in cr
            if gi in ind_eq_set
                push!(eq_per_scenario[k], gi)
            end
            if gi in ind_ineq_set
                push!(ineq_per_scenario[k], gi)
            end
        end
    end

    # Scenario 1 sets the canonical per-scenario constraint count; reject any
    # scenario that disagrees, since downstream code (and the GPU batched layout)
    # assumes uniform per-scenario shape.
    nc_eq_per_s = length(eq_per_scenario[1])
    nc_ineq_per_s = length(ineq_per_scenario[1])
    for k in 2:ns
        n_eq_k = length(eq_per_scenario[k])
        n_in_k = length(ineq_per_scenario[k])
        if n_eq_k != nc_eq_per_s || n_in_k != nc_ineq_per_s
            error(
                "SchurComplementKKTSystem requires uniform per-scenario constraint counts. " *
                "Scenario 1 has (eq=$nc_eq_per_s, ineq=$nc_ineq_per_s); " *
                "scenario $k has (eq=$n_eq_k, ineq=$n_in_k)."
            )
        end
    end

    blk_size = nv + nc_eq_per_s

    # Lookup: global ineq index → diag_buffer index
    ineq_to_bufidx = Dict{Int,Int}()
    for idx in 1:length(ind_ineq)
        ineq_to_bufidx[Int(ind_ineq[idx])] = idx
    end

    # Lookup: constraint global row → list of (jac_coo_idx, col)
    jac_by_constraint = Dict{Int, Vector{Tuple{Int,Int}}}()
    for ci in 1:n_jac
        row = Int(jac_I[ci])
        col = Int(jac_J[ci])
        entries = get!(Vector{Tuple{Int,Int}}, jac_by_constraint, row)
        push!(entries, (ci, col))
    end

    d_start = ns * nv + 1
    d_end = ns * nv + nd

    # --- Classify Hessian COO entries ---
    hess_S_coo = Int[]
    hess_S_row = Int[]
    hess_S_col = Int[]

    hess_per_scenario_diag = [Tuple{Int,Int,Int}[] for _ in 1:ns]      # (coo, local_i, local_j)
    hess_per_scenario_coupling = [Tuple{Int,Int,Int}[] for _ in 1:ns]  # (coo, design_local, var_local)
    hess_classified = falses(n_hess)

    for ci in 1:n_hess
        ri = Int(hess_I[ci])
        rj = Int(hess_J[ci])  # lower triangle: ri >= rj

        # Both design vars → S entry (write both triangles for dense S)
        if ri >= d_start && ri <= d_end && rj >= d_start && rj <= d_end
            di = ri - d_start + 1
            dj = rj - d_start + 1
            push!(hess_S_coo, ci); push!(hess_S_row, di); push!(hess_S_col, dj)
            if di != dj
                push!(hess_S_coo, ci); push!(hess_S_row, dj); push!(hess_S_col, di)
            end
            hess_classified[ci] = true
            continue
        end

        # One design + one scenario var → coupling block
        if ri >= d_start && ri <= d_end && rj < d_start
            di = ri - d_start + 1
            k = div(rj - 1, nv) + 1
            if k >= 1 && k <= ns
                vj = rj - (k-1)*nv
                push!(hess_per_scenario_coupling[k], (ci, di, vj))
                hess_classified[ci] = true
            end
            continue
        end

        # Both within the same scenario → A_kk diagonal block
        if ri < d_start && rj < d_start
            ki = div(ri - 1, nv) + 1
            kj = div(rj - 1, nv) + 1
            if ki == kj && ki >= 1 && ki <= ns
                li = ri - (ki-1)*nv
                lj = rj - (ki-1)*nv
                push!(hess_per_scenario_diag[ki], (ci, li, lj))
                hess_classified[ci] = true
            end
        end
    end

    # Anything left unclassified is a Hessian entry that doesn't fit the
    # block-arrowhead pattern — typically cross-scenario coupling. Silently
    # dropping it would converge the IPM to a wrong optimum, so error loudly.
    n_bad_hess = count(!, hess_classified)
    if n_bad_hess > 0
        bad = findall(!, hess_classified)
        sample = first(bad, min(5, length(bad)))
        details = join(("(row=$(Int(hess_I[ci])), col=$(Int(hess_J[ci])))" for ci in sample), ", ")
        error(
            "$n_bad_hess Hessian COO entries do not fit the SchurComplementKKTSystem " *
            "block-arrowhead pattern (likely cross-scenario coupling). First few: " *
            details
        )
    end

    # --- Build shared A_kk template from scenario 1 ---
    eq_cons_1 = eq_per_scenario[1]
    ineq_cons_1 = ineq_per_scenario[1]
    eq_local_1 = Dict{Int,Int}()
    for (ci, gi) in enumerate(eq_cons_1)
        eq_local_1[gi] = ci
    end

    akk_entries = Dict{Tuple{Int,Int}, Nothing}()

    # Hessian diagonal
    for (_, li, lj) in hess_per_scenario_diag[1]
        akk_entries[(li, lj)] = nothing
    end
    # pr_diag (always nv diagonal entries)
    for i in 1:nv
        akk_entries[(i, i)] = nothing
    end
    # Equality Jacobian: row = nv + eq_local, col = local_var
    for gi in eq_cons_1
        for (_, col) in get(jac_by_constraint, gi, Tuple{Int,Int}[])
            if col >= 1 && col <= nv
                akk_entries[(nv + eq_local_1[gi], col)] = nothing
            end
        end
    end
    # du_diag for eq constraints
    for ci in 1:length(eq_cons_1)
        akk_entries[(nv + ci, nv + ci)] = nothing
    end
    # Inequality condensation fill-in (lower triangle pairs of scenario vars)
    for gi in ineq_cons_1
        local_vars = Int[]
        for (_, col) in get(jac_by_constraint, gi, Tuple{Int,Int}[])
            if col >= 1 && col <= nv
                push!(local_vars, col)
            end
        end
        for a in local_vars, b in local_vars
            if a >= b
                akk_entries[(a, b)] = nothing
            end
        end
    end

    akk_nnz = length(akk_entries)
    akk_I = Vector{Int32}(undef, akk_nnz)
    akk_J = Vector{Int32}(undef, akk_nnz)
    akk_V = zeros(T, akk_nnz)
    for (idx, ((ri, rj), _)) in enumerate(akk_entries)
        akk_I[idx] = Int32(ri)
        akk_J[idx] = Int32(rj)
    end
    akk_coo = SparseMatrixCOO(blk_size, blk_size, akk_I, akk_J, akk_V)
    akk_csc_template, _ = coo_to_csc(akk_coo)

    # nzval position lookup, shared across scenarios (uniform structure)
    akk_lookup = Dict{Tuple{Int,Int}, Int}()
    for col in 1:blk_size
        for p in akk_csc_template.colptr[col]:(akk_csc_template.colptr[col+1]-1)
            row = akk_csc_template.rowval[p]
            akk_lookup[(Int(row), Int(col))] = Int(p)
        end
    end

    # Wrap lookups so a missing key (scenario k has a sparsity entry absent from
    # scenario 1's template) surfaces as a meaningful error instead of KeyError.
    @inline akk_pos(key, k) = let p = get(akk_lookup, key, 0)
        p == 0 && error(
            "SchurComplementKKTSystem: scenario $k has an A_kk entry at local " *
            "(row=$(key[1]), col=$(key[2])) absent from scenario 1's template. " *
            "Per-scenario Hessian/Jacobian sparsity must be uniform."
        )
        p
    end

    nnz_per_scenario = length(akk_csc_template.nzval)

    # --- Build per-scenario ScenarioBlockMaps ---
    block_maps = Vector{ScenarioBlockMap}(undef, ns)
    eq_global_flat = Int[]
    jac_classified = falses(n_jac)

    for k in 1:ns
        vr_start = (k-1)*nv + 1
        eq_cons = eq_per_scenario[k]
        ineq_cons = ineq_per_scenario[k]

        eq_local = Dict{Int,Int}()
        for (ci, gi) in enumerate(eq_cons)
            eq_local[gi] = ci
        end

        # Hessian diagonal → A_kk
        hess_Akk_coo_vec = Int[]
        hess_Akk_nzpos_vec = Int[]
        for (ci, li, lj) in hess_per_scenario_diag[k]
            push!(hess_Akk_coo_vec, ci)
            push!(hess_Akk_nzpos_vec, akk_pos((li, lj), k))
        end

        # Hessian coupling → C_dk
        hess_Cdk_coo_vec = Int[]
        hess_Cdk_row_vec = Int[]
        hess_Cdk_col_vec = Int[]
        for (ci, di, vj) in hess_per_scenario_coupling[k]
            push!(hess_Cdk_coo_vec, ci)
            push!(hess_Cdk_row_vec, di)
            push!(hess_Cdk_col_vec, vj)
        end

        # Equality Jacobian → A_kk and C_dk
        jeq_Akk_coo_vec = Int[]
        jeq_Akk_nzpos_vec = Int[]
        jeq_Cdk_coo_vec = Int[]
        jeq_Cdk_row_vec = Int[]
        jeq_Cdk_col_vec = Int[]

        for gi in eq_cons
            local_eq = eq_local[gi]
            for (coo_idx, col) in get(jac_by_constraint, gi, Tuple{Int,Int}[])
                if col >= vr_start && col < vr_start + nv
                    local_var = col - vr_start + 1
                    push!(jeq_Akk_coo_vec, coo_idx)
                    push!(jeq_Akk_nzpos_vec, akk_pos((nv + local_eq, local_var), k))
                    jac_classified[coo_idx] = true
                elseif col >= d_start && col <= d_end
                    di = col - d_start + 1
                    push!(jeq_Cdk_coo_vec, coo_idx)
                    push!(jeq_Cdk_row_vec, di)
                    push!(jeq_Cdk_col_vec, nv + local_eq)
                    jac_classified[coo_idx] = true
                end
            end
        end

        # pr_diag → A_kk diagonal
        pr_diag_global_vec = Int[]
        pr_diag_nzpos_vec = Int[]
        for i in 1:nv
            push!(pr_diag_global_vec, vr_start + i - 1)
            push!(pr_diag_nzpos_vec, akk_pos((i, i), k))
        end

        # du_diag → A_kk diagonal
        du_diag_global_vec = Int[]
        du_diag_nzpos_vec = Int[]
        for (ci, gi) in enumerate(eq_cons)
            push!(du_diag_global_vec, gi)
            push!(du_diag_nzpos_vec, akk_pos((nv + ci, nv + ci), k))
        end

        # Inequality condensation
        ineq_Akk_nzpos_vec = Int[]
        ineq_Akk_jcoo1_vec = Int[]
        ineq_Akk_jcoo2_vec = Int[]
        ineq_Akk_bufidx_vec = Int[]

        ineq_Cdk_row_vec = Int[]
        ineq_Cdk_col_vec = Int[]
        ineq_Cdk_jcoo_d_vec = Int[]
        ineq_Cdk_jcoo_v_vec = Int[]
        ineq_Cdk_bufidx_vec = Int[]

        ineq_S_row_vec = Int[]
        ineq_S_col_vec = Int[]
        ineq_S_jcoo1_vec = Int[]
        ineq_S_jcoo2_vec = Int[]
        ineq_S_bufidx_vec = Int[]

        for gi in ineq_cons
            bidx = ineq_to_bufidx[gi]
            v_entries = Tuple{Int,Int}[]
            d_entries = Tuple{Int,Int}[]

            for (coo_idx, col) in get(jac_by_constraint, gi, Tuple{Int,Int}[])
                if col >= vr_start && col < vr_start + nv
                    push!(v_entries, (coo_idx, col - vr_start + 1))
                    jac_classified[coo_idx] = true
                elseif col >= d_start && col <= d_end
                    push!(d_entries, (coo_idx, col - d_start + 1))
                    jac_classified[coo_idx] = true
                end
            end

            # A_kk: lower-triangle pairs of scenario vars
            for (coo_a, la) in v_entries, (coo_b, lb) in v_entries
                if la >= lb
                    push!(ineq_Akk_nzpos_vec, akk_pos((la, lb), k))
                    push!(ineq_Akk_jcoo1_vec, coo_a)
                    push!(ineq_Akk_jcoo2_vec, coo_b)
                    push!(ineq_Akk_bufidx_vec, bidx)
                end
            end

            # C_dk: design × scenario
            for (coo_d, di) in d_entries, (coo_v, lv) in v_entries
                push!(ineq_Cdk_row_vec, di)
                push!(ineq_Cdk_col_vec, lv)
                push!(ineq_Cdk_jcoo_d_vec, coo_d)
                push!(ineq_Cdk_jcoo_v_vec, coo_v)
                push!(ineq_Cdk_bufidx_vec, bidx)
            end

            # S: design × design (full)
            for (coo_a, da) in d_entries, (coo_b, db) in d_entries
                push!(ineq_S_row_vec, da)
                push!(ineq_S_col_vec, db)
                push!(ineq_S_jcoo1_vec, coo_a)
                push!(ineq_S_jcoo2_vec, coo_b)
                push!(ineq_S_bufidx_vec, bidx)
            end
        end

        block_maps[k] = ScenarioBlockMap(
            hess_Akk_coo_vec, hess_Akk_nzpos_vec,
            hess_Cdk_coo_vec, hess_Cdk_row_vec, hess_Cdk_col_vec,
            jeq_Akk_coo_vec, jeq_Akk_nzpos_vec,
            jeq_Cdk_coo_vec, jeq_Cdk_row_vec, jeq_Cdk_col_vec,
            ineq_Akk_nzpos_vec, ineq_Akk_jcoo1_vec, ineq_Akk_jcoo2_vec, ineq_Akk_bufidx_vec,
            ineq_Cdk_row_vec, ineq_Cdk_col_vec, ineq_Cdk_jcoo_d_vec, ineq_Cdk_jcoo_v_vec, ineq_Cdk_bufidx_vec,
            ineq_S_row_vec, ineq_S_col_vec, ineq_S_jcoo1_vec, ineq_S_jcoo2_vec, ineq_S_bufidx_vec,
            pr_diag_global_vec, pr_diag_nzpos_vec,
            du_diag_global_vec, du_diag_nzpos_vec,
        )

        append!(eq_global_flat, eq_cons)
    end

    # Catch Jacobian entries whose column doesn't match the constraint's own
    # scenario stripe or the design stripe (cross-scenario coupling).
    n_bad_jac = count(!, jac_classified)
    if n_bad_jac > 0
        bad = findall(!, jac_classified)
        sample = first(bad, min(5, length(bad)))
        details = join(("(row=$(Int(jac_I[ci])), col=$(Int(jac_J[ci])))" for ci in sample), ", ")
        error(
            "$n_bad_jac Jacobian COO entries do not fit the SchurComplementKKTSystem " *
            "block-arrowhead pattern (column belongs to a different scenario). First few: " *
            details
        )
    end

    # Per-scenario field cardinalities must match scenario 1, otherwise the GPU
    # batched layout (which uses scenario-1 lengths as the per-scenario stride)
    # would silently drop entries on longer scenarios. This catches non-uniform
    # Hessian/Jacobian sparsity that still passes the aggregate count checks.
    bm1 = block_maps[1]
    fields_to_check = (
        :hess_Akk_coo, :hess_Cdk_coo,
        :jeq_Akk_coo, :jeq_Cdk_coo,
        :ineq_Akk_nzpos, :ineq_Cdk_row, :ineq_S_row,
        :pr_diag_global, :du_diag_global,
    )
    for k in 2:ns, f in fields_to_check
        n1 = length(getfield(bm1, f))
        nk = length(getfield(block_maps[k], f))
        if nk != n1
            error(
                "SchurComplementKKTSystem requires uniform per-scenario sparsity. " *
                "Scenario 1 has $n1 entries in $f; scenario $k has $nk."
            )
        end
    end

    return (
        eq_per_scenario = eq_per_scenario,
        ineq_per_scenario = ineq_per_scenario,
        nc_eq_per_s = nc_eq_per_s,
        nc_ineq_per_s = nc_ineq_per_s,
        blk_size = blk_size,
        block_maps = block_maps,
        hess_S_coo = hess_S_coo,
        hess_S_row = hess_S_row,
        hess_S_col = hess_S_col,
        akk_csc_template = akk_csc_template,
        nnz_per_scenario = nnz_per_scenario,
        eq_global_flat = eq_global_flat,
    )
end

"""
    _flatten_block_maps(block_maps) -> NamedTuple

Flatten `Vector{ScenarioBlockMap}` into the per-field concatenated CPU
`Vector{Int}`s the GPU constructor uploads to device. Also returns the
per-scenario count (`n_per_s_*`) for each map type, taken from scenario 1
under the uniform-structure assumption.
"""
function _flatten_block_maps(block_maps::Vector{ScenarioBlockMap})
    bm1 = block_maps[1]
    n_per_s_hess_Akk = length(bm1.hess_Akk_coo)
    n_per_s_hess_Cdk = length(bm1.hess_Cdk_coo)
    n_per_s_pr_diag  = length(bm1.pr_diag_global)
    n_per_s_du_diag  = length(bm1.du_diag_global)
    n_per_s_jeq_Akk  = length(bm1.jeq_Akk_coo)
    n_per_s_jeq_Cdk  = length(bm1.jeq_Cdk_coo)
    n_per_s_ineq_Akk = length(bm1.ineq_Akk_nzpos)
    n_per_s_ineq_Cdk = length(bm1.ineq_Cdk_row)
    n_per_s_ineq_S   = length(bm1.ineq_S_row)

    cat_int(get) = reduce(vcat, (get(bm) for bm in block_maps); init = Int[])

    return (
        n_per_s_hess_Akk = n_per_s_hess_Akk,
        all_hess_Akk_coo   = cat_int(bm -> bm.hess_Akk_coo),
        all_hess_Akk_nzpos = cat_int(bm -> bm.hess_Akk_nzpos),

        n_per_s_hess_Cdk = n_per_s_hess_Cdk,
        all_hess_Cdk_coo = cat_int(bm -> bm.hess_Cdk_coo),
        all_hess_Cdk_row = cat_int(bm -> bm.hess_Cdk_row),
        all_hess_Cdk_col = cat_int(bm -> bm.hess_Cdk_col),

        n_per_s_pr_diag    = n_per_s_pr_diag,
        all_pr_diag_global = cat_int(bm -> bm.pr_diag_global),
        all_pr_diag_nzpos  = cat_int(bm -> bm.pr_diag_nzpos),

        n_per_s_du_diag    = n_per_s_du_diag,
        all_du_diag_global = cat_int(bm -> bm.du_diag_global),
        all_du_diag_nzpos  = cat_int(bm -> bm.du_diag_nzpos),

        n_per_s_jeq_Akk   = n_per_s_jeq_Akk,
        all_jeq_Akk_coo   = cat_int(bm -> bm.jeq_Akk_coo),
        all_jeq_Akk_nzpos = cat_int(bm -> bm.jeq_Akk_nzpos),

        n_per_s_jeq_Cdk = n_per_s_jeq_Cdk,
        all_jeq_Cdk_coo = cat_int(bm -> bm.jeq_Cdk_coo),
        all_jeq_Cdk_row = cat_int(bm -> bm.jeq_Cdk_row),
        all_jeq_Cdk_col = cat_int(bm -> bm.jeq_Cdk_col),

        n_per_s_ineq_Akk    = n_per_s_ineq_Akk,
        all_ineq_Akk_nzpos  = cat_int(bm -> bm.ineq_Akk_nzpos),
        all_ineq_Akk_jcoo1  = cat_int(bm -> bm.ineq_Akk_jcoo1),
        all_ineq_Akk_jcoo2  = cat_int(bm -> bm.ineq_Akk_jcoo2),
        all_ineq_Akk_bufidx = cat_int(bm -> bm.ineq_Akk_bufidx),

        n_per_s_ineq_Cdk    = n_per_s_ineq_Cdk,
        all_ineq_Cdk_row    = cat_int(bm -> bm.ineq_Cdk_row),
        all_ineq_Cdk_col    = cat_int(bm -> bm.ineq_Cdk_col),
        all_ineq_Cdk_jcoo_d = cat_int(bm -> bm.ineq_Cdk_jcoo_d),
        all_ineq_Cdk_jcoo_v = cat_int(bm -> bm.ineq_Cdk_jcoo_v),
        all_ineq_Cdk_bufidx = cat_int(bm -> bm.ineq_Cdk_bufidx),

        n_per_s_ineq_S     = n_per_s_ineq_S,
        all_ineq_S_row     = cat_int(bm -> bm.ineq_S_row),
        all_ineq_S_col     = cat_int(bm -> bm.ineq_S_col),
        all_ineq_S_jcoo1   = cat_int(bm -> bm.ineq_S_jcoo1),
        all_ineq_S_jcoo2   = cat_int(bm -> bm.ineq_S_jcoo2),
        all_ineq_S_bufidx  = cat_int(bm -> bm.ineq_S_bufidx),
    )
end

function create_kkt_system(
    ::Type{SchurComplementKKTSystem},
    cb::SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
    schur_ns::Int=0,
    schur_nv::Int=0,
    schur_nd::Int=0,
    schur_nc::Int=0,
    schur_scenario_linear_solver::Type=MumpsSolver,
) where {T, VT}

    n = cb.nvar
    m = cb.ncon
    ns_ineq = length(cb.ind_ineq)
    n_eq = m - ns_ineq
    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)

    ns, nv, nd, nc = _resolve_schur_dims(cb, n, m, schur_ns, schur_nv, schur_nd, schur_nc)

    # --- Get sparsity patterns ---
    jac_sparsity_I = Vector{Int32}(undef, cb.nnzj)
    jac_sparsity_J = Vector{Int32}(undef, cb.nnzj)
    _jac_sparsity_wrapper!(cb, jac_sparsity_I, jac_sparsity_J)

    hess_sparsity_I, hess_sparsity_J = build_hessian_structure(cb, hessian_approximation)
    force_lower_triangular!(hess_sparsity_I, hess_sparsity_J)

    n_hess = length(hess_sparsity_I)
    n_jac = length(jac_sparsity_I)

    # --- COO value buffers ---
    hess = VT(undef, n_hess)
    jac = VT(undef, n_jac)
    fill!(hess, zero(T))
    fill!(jac, zero(T))

    # --- Build global COO + CSC ---
    hess_raw = SparseMatrixCOO(n, n, hess_sparsity_I, hess_sparsity_J, hess)
    jt_coo = SparseMatrixCOO(n, m, jac_sparsity_J, jac_sparsity_I, jac)  # transposed

    hess_csc, hess_csc_map = coo_to_csc(hess_raw)
    jt_csc, jt_csc_map = coo_to_csc(jt_coo)

    # --- Shared symbolic construction (constraints, Hessian classification, A_kk template, block_maps) ---
    sym = _build_schur_symbolic(
        T, n, m, ns, nv, nd, nc,
        hess_sparsity_I, hess_sparsity_J,
        jac_sparsity_I, jac_sparsity_J,
        cb.ind_eq, cb.ind_ineq,
    )
    nc_eq_per_s = sym.nc_eq_per_s
    nc_ineq_per_s = sym.nc_ineq_per_s
    blk_size = sym.blk_size
    block_maps = sym.block_maps

    # Per-scenario A_kk: independent copies of the shared template (same sparsity, fresh nzval).
    A_kk_vec = [copy(sym.akk_csc_template) for _ in 1:ns]

    # --- Dense matrices ---
    aug_com = Matrix{T}(undef, nd, nd)
    C_dk = [Matrix{T}(undef, nd, blk_size) for _ in 1:ns]
    tmp_blk_nd = [Matrix{T}(undef, blk_size, nd) for _ in 1:ns]

    # --- Diagonal vectors ---
    reg     = VT(undef, n + ns_ineq)
    pr_diag = VT(undef, n + ns_ineq)
    du_diag = VT(undef, m)
    l_diag  = fill!(VT(undef, nlb), one(T))
    u_diag  = fill!(VT(undef, nub), one(T))
    l_lower = fill!(VT(undef, nlb), zero(T))
    u_lower = fill!(VT(undef, nub), zero(T))

    # --- Buffers ---
    diag_buffer = VT(undef, ns_ineq)
    buffer      = VT(undef, m)
    # Size from the per-scenario invariant rather than the global eq count: the
    # uniform-scenario validation in `_build_schur_symbolic` guarantees these
    # are equal, but tying the buffer to `ns * nc_eq_per_s` keeps the
    # round-trip in `solve_kkt!` (gather/scatter via the eq index list) shape-
    # consistent by construction.
    wy_eq_buf   = VT(undef, ns * nc_eq_per_s)
    rhs_d       = VT(undef, nd)
    rhs_k       = [VT(undef, blk_size) for _ in 1:ns]
    solve_buffers = [VT(undef, blk_size) for _ in 1:ns]

    # --- Init ---
    fill!(aug_com, zero(T))
    fill!(pr_diag, zero(T))
    fill!(du_diag, zero(T))

    # --- Create solvers ---
    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    scenario_solvers = [schur_scenario_linear_solver(A_kk_vec[k]) for k in 1:ns]
    _linear_solver = linear_solver(aug_com; opt = opt_linear_solver)

    return SchurComplementKKTSystem(
        hess, jac,
        hess_raw, jt_coo,
        hess_csc, hess_csc_map, jt_csc, jt_csc_map,
        quasi_newton,
        reg, pr_diag, du_diag, l_diag, u_diag, l_lower, u_lower,
        ns, nv, nd, nc,
        nc_eq_per_s, nc_ineq_per_s, blk_size,
        A_kk_vec, C_dk,
        aug_com,
        diag_buffer, buffer, wy_eq_buf, rhs_d, rhs_k, tmp_blk_nd, solve_buffers,
        block_maps,
        sym.hess_S_coo, sym.hess_S_row, sym.hess_S_col,
        sym.eq_global_flat,
        n_eq, cb.ind_eq,
        ns_ineq, cb.ind_ineq, cb.ind_lb, cb.ind_ub,
        scenario_solvers,
        _linear_solver,
    )
end

num_variables(kkt::SchurComplementKKTSystem) = size(kkt.hess_csc, 1)

function get_slack_regularization(kkt::SchurComplementKKTSystem)
    n = num_variables(kkt)
    ns_ineq = kkt.n_ineq
    return view(kkt.pr_diag, n+1:n+ns_ineq)
end

function is_inertia_correct(kkt::SchurComplementKKTSystem, num_pos, num_zero, num_neg)
    return (num_zero == 0) && (num_pos == size(kkt.aug_com, 1))
end

should_regularize_dual(kkt::SchurComplementKKTSystem, num_pos, num_zero, num_neg) = true

function jtprod!(y::AbstractVector, kkt::SchurComplementKKTSystem, x::AbstractVector)
    nx = num_variables(kkt)
    ns_ineq = kkt.n_ineq
    yx = view(y, 1:nx)
    ys = view(y, 1+nx:nx+ns_ineq)
    mul!(yx, kkt.jt_csc, x)
    ys .= -@view(x[kkt.ind_ineq])
    return
end

function compress_jacobian!(kkt::SchurComplementKKTSystem)
    transfer!(kkt.jt_csc, kkt.jt_coo, kkt.jt_csc_map)
end

function compress_hessian!(kkt::SchurComplementKKTSystem)
    transfer!(kkt.hess_csc, kkt.hess_raw, kkt.hess_csc_map)
end

nnz_jacobian(kkt::SchurComplementKKTSystem) = nnz(kkt.jt_coo)

function build_kkt!(kkt::SchurComplementKKTSystem{T, VT, MT}) where {T, VT, MT}
    ns = kkt.ns
    nv = kkt.nv
    nd = kkt.nd
    n = num_variables(kkt)
    blk = kkt.blk_size

    # Compute condensing diagonal for inequalities
    if kkt.n_ineq > 0
        Sigma_s = view(kkt.pr_diag, n+1:n+kkt.n_ineq)
        Sigma_d = @view(kkt.du_diag[kkt.ind_ineq])
        kkt.diag_buffer .= Sigma_s ./ (one(T) .- Sigma_d .* Sigma_s)
    end

    # Initialize Schur complement S = H_dd + diag(pr_diag_dd)
    S = kkt.aug_com
    fill!(S, zero(T))
    _scatter_add!(S, kkt.hess, kkt.hess_S_coo, kkt.hess_S_row, kkt.hess_S_col)
    @inbounds for i in 1:nd
        S[i, i] += kkt.pr_diag[ns*nv+i]
    end

    # Phase 1 (parallel): assemble per-scenario blocks, factorize, compute A_kk^{-1} * C_dk'.
    # `@blas_safe_threads` runs `Threads.@threads` over scenarios while pinning
    # BLAS to a single thread per task to avoid oversubscription with the
    # per-scenario `mul!` / `factorize!` calls inside the loop.
    @blas_safe_threads for k in 1:ns
        bm = kkt.block_maps[k]
        A_kk = kkt.A_kk[k]
        C_dk = kkt.C_dk[k]
        nz = A_kk.nzval

        fill!(nz, zero(T))
        fill!(C_dk, zero(T))

        _scatter_add!(nz,   kkt.hess,    bm.hess_Akk_coo,    bm.hess_Akk_nzpos)
        _scatter_add!(C_dk, kkt.hess,    bm.hess_Cdk_coo,    bm.hess_Cdk_row, bm.hess_Cdk_col)
        _scatter_add!(nz,   kkt.pr_diag, bm.pr_diag_global,  bm.pr_diag_nzpos)
        _scatter_add!(nz,   kkt.du_diag, bm.du_diag_global,  bm.du_diag_nzpos)
        _scatter_add!(nz,   kkt.jac,     bm.jeq_Akk_coo,     bm.jeq_Akk_nzpos)
        _scatter_add!(C_dk, kkt.jac,     bm.jeq_Cdk_coo,     bm.jeq_Cdk_row, bm.jeq_Cdk_col)
        _scatter_quad_add!(nz,   kkt.jac, kkt.diag_buffer,
                           bm.ineq_Akk_nzpos, bm.ineq_Akk_jcoo1, bm.ineq_Akk_jcoo2, bm.ineq_Akk_bufidx)
        _scatter_quad_add!(C_dk, kkt.jac, kkt.diag_buffer,
                           bm.ineq_Cdk_row, bm.ineq_Cdk_col,
                           bm.ineq_Cdk_jcoo_d, bm.ineq_Cdk_jcoo_v, bm.ineq_Cdk_bufidx)

        # Factor A_kk
        factorize!(kkt.scenario_solvers[k])

        # Compute tmp = A_kk^{-1} * C_dk'  (blk × nd)
        buf = kkt.solve_buffers[k]
        for j in 1:nd
            @inbounds for i in 1:blk
                buf[i] = C_dk[j, i]  # C_dk' column j
            end
            solve_linear_system!(kkt.scenario_solvers[k], buf)
            @inbounds for i in 1:blk
                kkt.tmp_blk_nd[k][i, j] = buf[i]
            end
        end
    end

    # Phase 2 (sequential): accumulate into shared Schur complement S
    for k in 1:ns
        bm = kkt.block_maps[k]
        _scatter_quad_add!(S, kkt.jac, kkt.diag_buffer,
                           bm.ineq_S_row, bm.ineq_S_col,
                           bm.ineq_S_jcoo1, bm.ineq_S_jcoo2, bm.ineq_S_bufidx)
        # S -= C_dk * A_kk^{-1} * C_dk'
        mul!(S, kkt.C_dk[k], kkt.tmp_blk_nd[k], -one(T), one(T))
    end

    return
end

function factorize_kkt!(kkt::SchurComplementKKTSystem)
    return factorize!(kkt.linear_solver)
end

function solve_kkt!(
    kkt::SchurComplementKKTSystem,
    w::AbstractKKTVector{T},
) where T

    ns = kkt.ns
    nv = kkt.nv
    nd = kkt.nd
    nc = kkt.nc
    n = num_variables(kkt)
    blk = kkt.blk_size

    wx = _madnlp_unsafe_wrap(full(w), n)
    ws = view(full(w), n+1:n+kkt.n_ineq)
    wy = dual(w)

    Sigma_s = get_slack_regularization(kkt)

    reduce_rhs!(kkt, w)

    # Step 1: condense inequality contributions
    fill!(kkt.buffer, zero(T))
    if kkt.n_ineq > 0
        kkt.buffer[kkt.ind_ineq] .= kkt.diag_buffer .* (wy[kkt.ind_ineq] .+ ws ./ Sigma_s)
        # J' * buffer → wx (using sparse jt_csc)
        mul!(wx, kkt.jt_csc, kkt.buffer, one(T), one(T))
    end

    # Step 2: Extract per-scenario RHS blocks
    # NOTE: writes to disjoint slices of wx/wy → safe to @blas_safe_threads,
    # but per-iteration work is just a few scalar copies; profile before threading.
    nc_eq = kkt.nc_eq_per_s
    @inbounds for k in 1:ns
        vr_start = (k-1)*nv
        rhs = kkt.rhs_k[k]
        for i in 1:nv
            rhs[i] = wx[vr_start + i]
        end
        eq_base = (k-1)*nc_eq
        for ci in 1:nc_eq
            rhs[nv+ci] = wy[kkt.eq_global_indices[eq_base + ci]]
        end
    end
    @inbounds for i in 1:nd
        kkt.rhs_d[i] = wx[ns*nv+i]
    end

    # Step 3: Forward elimination
    # Phase 1 (parallel): solve per-scenario systems
    @blas_safe_threads for k in 1:ns
        solve_linear_system!(kkt.scenario_solvers[k], kkt.rhs_k[k])
    end
    # Phase 2 (sequential): accumulate into shared rhs_d
    for k in 1:ns
        mul!(kkt.rhs_d, kkt.C_dk[k], kkt.rhs_k[k], -one(T), one(T))
    end

    # Step 4: Solve Schur complement
    solve_linear_system!(kkt.linear_solver, kkt.rhs_d)

    # Step 5: Back-substitution (parallel — reads shared rhs_d, writes per-scenario rhs_k)
    @blas_safe_threads for k in 1:ns
        mul!(kkt.rhs_k[k], kkt.tmp_blk_nd[k], kkt.rhs_d, -one(T), one(T))
    end

    # Step 6: Write back to w (same threading note as Step 2 above)
    @inbounds for k in 1:ns
        vr_start = (k-1)*nv
        rhs = kkt.rhs_k[k]
        for i in 1:nv
            wx[vr_start + i] = rhs[i]
        end
        eq_base = (k-1)*nc_eq
        for ci in 1:nc_eq
            wy[kkt.eq_global_indices[eq_base + ci]] = rhs[nv+ci]
        end
    end
    @inbounds for i in 1:nd
        wx[ns*nv+i] = kkt.rhs_d[i]
    end

    # Step 7: Recover inequality duals and slacks
    if kkt.n_ineq > 0
        # Stash eq duals; mul! below overwrites all of wy
        copyto!(kkt.wy_eq_buf, view(wy, kkt.ind_eq))

        # J * Δx via sparse: (jt_csc)' * wx
        mul!(wy, kkt.jt_csc', wx)

        # Restore equality duals
        view(wy, kkt.ind_eq) .= kkt.wy_eq_buf

        # Inequality dual recovery
        @inbounds for idx in 1:length(kkt.ind_ineq)
            gi = kkt.ind_ineq[idx]
            wy[gi] = kkt.diag_buffer[idx] * wy[gi] - kkt.buffer[gi]
        end
        ws .= (ws .+ view(wy, kkt.ind_ineq)) ./ Sigma_s
    end

    finish_aug_solve!(kkt, w)
    return w
end

# KKT matrix-vector product for iterative refinement
function mul!(w::AbstractKKTVector{T}, kkt::SchurComplementKKTSystem{T}, x::AbstractKKTVector, alpha = one(T), beta = zero(T)) where T
    n = num_variables(kkt)
    ns_ineq = kkt.n_ineq
    wx = @view(primal(w)[1:n])
    ws = @view(primal(w)[n+1:end])
    wy = dual(w)

    xx = @view(primal(x)[1:n])
    xs = @view(primal(x)[n+1:end])
    xy = dual(x)
    xz = @view(dual(x)[kkt.ind_ineq])

    # H * xx → wx (using sparse symmetric Hessian)
    wx .= beta .* wx
    mul!(wx, Symmetric(kkt.hess_csc, :L), xx, alpha, one(T))

    m = size(kkt.jt_csc, 2)
    if m > 0
        mul!(wx, kkt.jt_csc, dual(x), alpha, one(T))       # J' * xy
        mul!(wy, kkt.jt_csc', xx, alpha, beta)              # J * xx
    else
        wy .= beta .* wy
    end
    ws .= beta.*ws .- alpha.* xz
    @view(dual(w)[kkt.ind_ineq]) .-= alpha.* xs
    _kktmul!(w, x, kkt.reg, kkt.du_diag, kkt.l_lower, kkt.u_lower, kkt.l_diag, kkt.u_diag, alpha, beta)
    return w
end

function mul_hess_blk!(wx, kkt::SchurComplementKKTSystem, t)
    n = num_variables(kkt)
    mul!(@view(wx[1:n]), Symmetric(kkt.hess_csc, :L), @view(t[1:n]))
    fill!(@view(wx[n+1:end]), 0)
    wx .+= t .* kkt.pr_diag
end

####################################################################
##### GPU kernels for DenseKKTSystem / DenseCondensedKKTSystem #####
####################################################################

#=
    MadNLP.diag!
=#

@kernel function _copy_diag_kernel!(dest, src)
    i = @index(Global)
    @inbounds dest[i] = src[i, i]
end

#=
    MadNLP.diag_add!
=#

@kernel function _add_diagonal_kernel!(dest, src1, src2)
    i = @index(Global)
    @inbounds dest[i, i] = src1[i] + src2[i]
end

#=
    MadNLP._set_diag!
=#

@kernel function _set_diag_kernel!(A, inds, a)
    i = @index(Global)
    @inbounds begin
        index = inds[i]
        A[index, index] = a
    end
end

#=
    MadNLP._build_dense_kkt_system!
=#

@kernel function _build_dense_kkt_system_kernel!(
    dest,
    hess,
    jac,
    pr_diag,
    du_diag,
    diag_hess,
    ind_ineq,
    n,
    m,
    ns,
)
    i, j = @index(Global, NTuple)
    @inbounds if (i <= n)
        # Transfer Hessian
        if (i == j)
            dest[i, i] = pr_diag[i] + diag_hess[i]
        else
            dest[i, j] = hess[i, j]
        end
    elseif i <= n + ns
        # Transfer slack diagonal
        dest[i, i] = pr_diag[i]
        # Transfer Jacobian wrt slack
        js = i - n
        is = ind_ineq[js]
        dest[is+n+ns, is+n] = -1
        dest[is+n, is+n+ns] = -1
    elseif i <= n + ns + m
        # Transfer Jacobian wrt variable x
        i_ = i - n - ns
        dest[i, j] = jac[i_, j]
        dest[j, i] = jac[i_, j]
        # Transfer dual regularization
        dest[i, i] = du_diag[i_]
    end
end

#=
    MadNLP._build_ineq_jac!
=#

@kernel function _build_jacobian_condensed_kernel!(dest, jac, diag_buffer, ind_ineq, m_ineq)
    i, j = @index(Global, NTuple)
    @inbounds is = ind_ineq[i]
    @inbounds dest[i, j] = jac[is, j] * sqrt(diag_buffer[i])
end

#=
    MadNLP._build_condensed_kkt_system!
=#

@kernel function _build_condensed_kkt_system_kernel!(
    dest,
    hess,
    jac,
    pr_diag,
    du_diag,
    ind_eq,
    n,
    m_eq,
)
    i, j = @index(Global, NTuple)

    # Transfer Hessian
    @inbounds if i <= n
        if i == j
            dest[i, i] += pr_diag[i] + hess[i, i]
        else
            dest[i, j] += hess[i, j]
        end
    elseif i <= n + m_eq
        i_ = i - n
        is = ind_eq[i_]
        # Jacobian / equality
        dest[i_+n, j] = jac[is, j]
        dest[j, i_+n] = jac[is, j]
        # Transfer dual regularization
        dest[i_+n, i_+n] = du_diag[is]
    end
end

# Template to dispatch on sparse representation
const AbstractSparseKKTSystem{T, VT, MT, QN} = Union{
    SparseKKTSystem{T, VT, MT, QN},
    SparseCondensedKKTSystem{T, VT, MT, QN},
    SparseUnreducedKKTSystem{T, VT, MT, QN},
}

#=
    Generic sparse methods
=#
function build_hessian_structure(cb::SparseCallback, ::Type{<:ExactHessian})
    hess_I = create_array(cb, Int32, cb.nnzh)
    hess_J = create_array(cb, Int32, cb.nnzh)
    _hess_sparsity_wrapper!(cb,hess_I,hess_J)
    return hess_I, hess_J
end
# NB. Quasi-Newton methods require only the sparsity pattern
#     of the diagonal term to store the term ξ I.
function build_hessian_structure(cb::SparseCallback, ::Type{<:AbstractQuasiNewton})
    hess_I = create_array(cb, Int32, cb.nvar)
    hess_J = create_array(cb, Int32, cb.nvar)
    hess_I .= 1:cb.nvar
    hess_J .= 1:cb.nvar
    return hess_I, hess_J
end

function jtprod!(y::AbstractVector, kkt::AbstractSparseKKTSystem, x::AbstractVector)
    mul!(y, kkt.jac_com', x)
end

get_jacobian(kkt::AbstractSparseKKTSystem) = kkt.jac_callback

nnz_jacobian(kkt::AbstractSparseKKTSystem) = nnz(kkt.jac_raw)

function compress_jacobian!(kkt::AbstractSparseKKTSystem)
    ns = length(kkt.ind_ineq)
    kkt.jac[end-ns+1:end] .= -1.0
    transfer!(kkt.jac_com, kkt.jac_raw, kkt.jac_csc_map)
end

function compress_jacobian!(kkt::AbstractSparseKKTSystem{T, VT, MT}) where {T, VT, MT<:Matrix{T}}
    ns = length(kkt.ind_ineq)
    kkt.jac[end-ns+1:end] .= -1.0
    copyto!(kkt.jac_com, kkt.jac_raw)
end

function compress_hessian!(kkt::AbstractSparseKKTSystem)
    transfer!(kkt.hess_com, kkt.hess_raw, kkt.hess_csc_map)
end

function initialize!(kkt::AbstractSparseKKTSystem{T}) where T
    fill!(kkt.reg, one(T))
    fill!(kkt.pr_diag, one(T))
    fill!(kkt.du_diag, zero(T))
    fill!(kkt.hess, zero(T))
    fill!(kkt.l_lower, zero(T))
    fill!(kkt.u_lower, zero(T))
    fill!(kkt.l_diag, one(T))
    fill!(kkt.u_diag, one(T))
    fill!(nonzeros(kkt.hess_com), zero(T)) # so that mul! in the initial primal-dual solve has no effect
end

using CUDA
using MadNLPTests

function _compare_gpu_with_cpu(KKTSystem, n, m, ind_fixed)
    for (T,tol,atol) in [
        (Float32,1e-4,1e1),
        (Float64,1e-8,1e-6)
        ]
        madnlp_options = Dict{Symbol, Any}(
            :callback=>MadNLP.DenseCallback,
            :kkt_system=>KKTSystem,
            :linear_solver => MadNLPGPU.LapackCUDASolver,
            :print_level=>MadNLP.ERROR,
            :tol=>tol
        )

        # Host evaluator
        nlph = MadNLPTests.DenseDummyQP(zeros(T,n); m=m, fixed_variables=ind_fixed)
        # Device evaluator
        nlpd = MadNLPTests.DenseDummyQP(CUDA.zeros(T,n); m=m, fixed_variables=CuArray(ind_fixed))

        # Solve on CPU
        h_solver = MadNLPSolver(nlph; madnlp_options...)
        results_cpu = MadNLP.solve!(h_solver)

        # Solve on GPU
        d_solver = MadNLPSolver(nlpd; madnlp_options...)
        results_gpu = MadNLP.solve!(d_solver)

        @test isa(d_solver.kkt, KKTSystem{T})
        # Check that both results match exactly
        @test h_solver.cnt.k == d_solver.cnt.k
        @test results_cpu.objective ≈ results_gpu.objective
        @test results_cpu.solution ≈ Array(results_gpu.solution) atol=atol
        @test results_cpu.multipliers ≈ Array(results_gpu.multipliers) atol=atol
    end
end

@testset "MadNLPGPU -- LapackCUDASolver -- ($(kkt_system))" for kkt_system in [
        MadNLP.DenseKKTSystem,
        MadNLP.DenseCondensedKKTSystem,
    ]
    @testset "Size: ($n, $m)" for (n, m) in [(10, 0), (10, 5), (50, 10)]
        _compare_gpu_with_cpu(kkt_system, n, m, Int[])
    end
    @testset "Fixed variables" for (n,m) in [(10, 0), (10, 5), (50, 10)]
        _compare_gpu_with_cpu(kkt_system, n, m, Int[1, 2])
    end
end

@testset "MadNLP -- LapackCUDASolver: $QN + $KKT" for QN in [
    MadNLP.BFGS,
    MadNLP.DampedBFGS,
], KKT in [
    MadNLP.DenseKKTSystem,
    MadNLP.DenseCondensedKKTSystem,
]
    @testset "Size: ($n, $m)" for (n, m) in [(10, 0), (10, 5), (50, 10)]
        nlp = MadNLPTests.DenseDummyQP(zeros(Float64, n); m=m)
        solver_exact = MadNLPSolver(
            nlp;
            callback=MadNLP.DenseCallback,
            print_level=MadNLP.ERROR,
            kkt_system=KKT,
            linear_solver = MadNLPGPU.LapackCUDASolver,
        )
        results_ref = MadNLP.solve!(solver_exact)

        nlp = MadNLPTests.DenseDummyQP(CUDA.zeros(Float64, n); m=m)
        solver_qn = MadNLPSolver(
            nlp;
            callback=MadNLP.DenseCallback,
            print_level=MadNLP.ERROR,
            kkt_system=KKT,
            hessian_approximation=QN,
            linear_solver = MadNLPGPU.LapackCUDASolver,
        )
        results_qn = MadNLP.solve!(solver_qn)

        @test results_qn.status == MadNLP.SOLVE_SUCCEEDED
        @test results_qn.objective ≈ results_ref.objective atol=1e-6
        @test Array(results_qn.solution) ≈ Array(results_ref.solution) atol=1e-6
        @test solver_qn.cnt.lag_hess_cnt == 0
    end
end

# MadNLP.jl
# Created by Sungho Shin (sungho.shin@wisc.edu)

abstract type AbstractMadNLPSolver{T} end

include("types.jl")
include("options.jl")

mutable struct MadNLPSolver{
    T,
    VT <: AbstractVector{T},
    VI <: AbstractVector{Int},
    KKTSystem <: AbstractKKTSystem{T},
    Model <: AbstractNLPModel{T,VT},
    CB <: AbstractCallback{T},
    Iterator <: AbstractIterator{T},
    IC <: AbstractInertiaCorrector,
    KKTVec <: AbstractKKTVector{T, VT},
    ICB
    } <: AbstractMadNLPSolver{T}

    nlp::Model
    cb::CB
    kkt::KKTSystem

    opt::MadNLPOptions{T}
    cnt::MadNLPCounters
    logger::MadNLPLogger

    n::Int # number of variables (after reformulation)
    m::Int # number of cons
    nlb::Int
    nub::Int

    x::PrimalVector{T, VT, VI} # primal (after reformulation)
    y::VT # dual
    zl::PrimalVector{T, VT, VI} # dual (after reformulation)
    zu::PrimalVector{T, VT, VI} # dual (after reformulation)
    xl::PrimalVector{T, VT, VI} # primal lower bound (after reformulation)
    xu::PrimalVector{T, VT, VI} # primal upper bound (after reformulation)

    obj_val::T
    f::PrimalVector{T, VT, VI}
    c::VT

    jacl::VT

    d::KKTVec
    p::KKTVec

    _w1::KKTVec
    _w2::KKTVec
    _w3::KKTVec
    _w4::KKTVec

    x_trial::PrimalVector{T, VT, VI}
    c_trial::VT
    obj_val_trial::T

    c_slk::SubVector{T,VT,VI}
    rhs::VT

    ind_ineq::VI
    ind_fixed::VI
    ind_llb::VI
    ind_uub::VI

    x_lr::SubVector{T,VT,VI}
    x_ur::SubVector{T,VT,VI}
    xl_r::SubVector{T,VT,VI}
    xu_r::SubVector{T,VT,VI}
    zl_r::SubVector{T,VT,VI}
    zu_r::SubVector{T,VT,VI}
    dx_lr::SubVector{T,VT,VI}
    dx_ur::SubVector{T,VT,VI}
    x_trial_lr::SubVector{T,VT,VI}
    x_trial_ur::SubVector{T,VT,VI}

    iterator::Iterator

    inf_pr::T
    inf_du::T
    inf_compl::T
    inf_compl_mu::T

    theta_min::T
    theta_max::T
    mu::T
    tau::T

    alpha::T
    alpha_z::T
    ftype::String

    del_w::T
    del_w_last::T
    del_c::T

    filter::Vector{Tuple{T,T}}

    inertia_corrector::IC
    RR::Union{Nothing,RobustRestorer{T,VT}}
    intermediate_callback::ICB
    status::Status
    output::Dict
end

include("api.jl")
include("restoration.jl")
include("inertiacorrector.jl")
include("barrier.jl")


"""
    MadNLPSolver(nlp::AbstractNLPModel{T, VT}; options...) where {T, VT}

Instantiate a new `MadNLPSolver` associated to the nonlinear program
`nlp::AbstractNLPModel`. The options are passed as optional arguments.

The constructor allocates all the memory required in the interior-point
algorithm, so the main algorithm remains allocation free.

"""
function MadNLPSolver(nlp::AbstractNLPModel{T,VT}; kwargs...) where {T, VT}

    options = load_options(nlp; kwargs...)

    ipm_opt = options.interior_point
    logger = options.logger
    @assert is_supported(ipm_opt.linear_solver, T)

    cnt = MadNLPCounters(start_time=time())
    cb = create_callback(
        ipm_opt.callback,
        nlp;
        fixed_variable_treatment=ipm_opt.fixed_variable_treatment,
        equality_treatment=ipm_opt.equality_treatment,
    )

    # generic options
    ipm_opt.disable_garbage_collector &&
        (GC.enable(false); @warn(logger,"Julia garbage collector is temporarily disabled"))
    set_blas_num_threads(ipm_opt.blas_num_threads; permanent=true)
    @trace(logger,"Initializing variables.")

    ind_lb = cb.ind_lb
    ind_ub = cb.ind_ub

    ns = length(cb.ind_ineq)
    nx = n_variables(cb)
    n = nx+ns
    m = n_constraints(cb)
    nlb = length(ind_lb)
    nub = length(ind_ub)

    @trace(logger,"Initializing KKT system.")
    kkt = create_kkt_system(
        ipm_opt.kkt_system,
        cb,
        ipm_opt.linear_solver;
        hessian_approximation=ipm_opt.hessian_approximation,
        opt_linear_solver=options.linear_solver,
        qn_options=ipm_opt.quasi_newton_options,
        ipm_opt.kkt_options...,
    )

    @trace(logger,"Initializing iterative solver.")
    iterator = ipm_opt.iterator(kkt; cnt = cnt, logger = logger, opt = options.iterative_refinement)

    x = PrimalVector(VT, nx, ns, ind_lb, ind_ub)
    xl = PrimalVector(VT, nx, ns, ind_lb, ind_ub)
    xu = PrimalVector(VT, nx, ns, ind_lb, ind_ub)
    zl = PrimalVector(VT, nx, ns, ind_lb, ind_ub)
    zu = PrimalVector(VT, nx, ns, ind_lb, ind_ub)
    f = PrimalVector(VT, nx, ns, ind_lb, ind_ub)
    x_trial = PrimalVector(VT, nx, ns, ind_lb, ind_ub)

    d = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    p = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    _w1 = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    _w2 = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    _w3 = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)
    _w4 = UnreducedKKTVector(VT, n, m, nlb, nub, ind_lb, ind_ub)

    jacl = VT(undef,n)
    c_trial = VT(undef, m)
    y = VT(undef, m)
    c = VT(undef, m)
    rhs = VT(undef, m)

    c_slk = view(c,cb.ind_ineq)
    x_lr = view(full(x), cb.ind_lb)
    x_ur = view(full(x), cb.ind_ub)
    xl_r = view(full(xl), cb.ind_lb)
    xu_r = view(full(xu), cb.ind_ub)
    zl_r = view(full(zl), cb.ind_lb)
    zu_r = view(full(zu), cb.ind_ub)
    x_trial_lr = view(full(x_trial), cb.ind_lb)
    x_trial_ur = view(full(x_trial), cb.ind_ub)
    dx_lr = view(d.xp, cb.ind_lb) # TODO
    dx_ur = view(d.xp, cb.ind_ub) # TODO

    inertia_correction_method = if ipm_opt.inertia_correction_method == InertiaAuto
        is_inertia(kkt.linear_solver)::Bool ? InertiaBased : InertiaFree
    else
        ipm_opt.inertia_correction_method
    end

    inertia_corrector = build_inertia_corrector(
        inertia_correction_method,
        VT,
        n, m, nlb, nub, ind_lb, ind_ub
    )

    cnt.init_time = time() - cnt.start_time

    return MadNLPSolver(
        nlp, cb, kkt,
        ipm_opt, cnt, options.logger,
        n, m, nlb, nub,
        x, y, zl, zu, xl, xu,
        zero(T), f, c,
        jacl,
        d, p,
        _w1, _w2, _w3, _w4,
        x_trial, c_trial, zero(T), c_slk, rhs,
        cb.ind_ineq, cb.ind_fixed, cb.ind_llb, cb.ind_uub,
        x_lr, x_ur, xl_r, xu_r, zl_r, zu_r, dx_lr, dx_ur, x_trial_lr, x_trial_ur,
        iterator,
        zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T),
        " ",
        zero(T), zero(T), zero(T),
        Tuple{T, T}[],
        inertia_corrector, nothing,
        options.intermediate_callback,
        INITIAL, Dict(),
    )

end

include("utils.jl")
include("kernels.jl")
include("callbacks.jl")
include("factorization.jl")
include("line_search.jl")
include("solver.jl")

function solve_refine_wrapper!(d, solver, p, w)
    result = false

    get_cnt(solver).linear_solver_time += @elapsed begin
        if solve_refine!(d, get_iterator(solver), p, w)
            result = true
        else
            if improve!(get_kkt(solver).linear_solver)
                if solve_refine!(d, get_iterator(solver), p, w)
                    result = true
                end
            end
        end
    end
    # Get number of iterations in Richardson's iterative refinement
    iter_richardson = get_cnt(solver).ir
    get_cnt(solver).backsolve_cnt += iter_richardson
    return result
end

function factorize_wrapper!(solver::AbstractMadNLPSolver)
    @trace(get_logger(solver),"Factorization started.")
    build_kkt!(get_kkt(solver))
    get_cnt(solver).linear_solver_time += @elapsed factorize!(get_kkt(solver).linear_solver)
    get_cnt(solver).factorization_cnt += 1
    return
end

function solve_kkt!(kkt::SparseUnreducedKKTSystem, w::AbstractKKTVector)
    wzl = dual_lb(w)
    wzu = dual_ub(w)
    f(x,y) = iszero(y) ? x : x/y
    wzl .= f.(wzl, kkt.l_lower_aug)
    wzu .= f.(wzu, kkt.u_lower_aug)
    solve_linear_system!(kkt.linear_solver, full(w))
    wzl .*= .-kkt.l_lower_aug
    wzu .*= kkt.u_lower_aug
    return w
end

function solve_kkt!(kkt::AbstractReducedKKTSystem, w::AbstractKKTVector)
    reduce_rhs!(kkt, w)
    solve_linear_system!(kkt.linear_solver, primal_dual(w))
    finish_aug_solve!(kkt, w)
    return w
end

function solve_kkt!(kkt::ScaledSparseKKTSystem, w::AbstractKKTVector)
    r3 = kkt.buffer1
    r4 = kkt.buffer2
    fill!(r3, 0.0)
    fill!(r4, 0.0)

    wzl = dual_lb(w)  # size nlb
    wzu = dual_ub(w)  # size nub

    r3[kkt.ind_lb] .= wzl
    r3[kkt.ind_ub] .*= sqrt.(kkt.u_diag)
    r3[kkt.ind_lb] ./= sqrt.(kkt.l_diag)
    r4[kkt.ind_ub] .= wzu
    r4[kkt.ind_lb] .*= sqrt.(kkt.l_diag)
    r4[kkt.ind_ub] ./= sqrt.(kkt.u_diag)
    # Build RHS
    w.xp .*= kkt.scaling_factor
    w.xp .+= (r3 .+ r4)
    # Backsolve
    solve_linear_system!(kkt.linear_solver, primal_dual(w))
    # Unpack solution
    w.xp .*= kkt.scaling_factor

    wzl .= (wzl .- kkt.l_lower .* w.xp_lr) ./ kkt.l_diag
    wzu .= (.-wzu .+ kkt.u_lower .* w.xp_ur) ./ kkt.u_diag
    return w
end

function solve_kkt!(
    kkt::SparseKKTSystem{T, VT, MT, QN},
    w::AbstractKKTVector
    ) where {T, VT, MT, QN<:CompactLBFGS}

    qn = kkt.quasi_newton
    n, p = size(qn)
    # Load buffers
    xr = qn._w2
    Tk = qn.Tk
    w_ = primal_dual(w)
    nn = length(w_)

    fill!(Tk, zero(T))
    reduce_rhs!(kkt, w)

    # Resize arrays with correct dimension
    if size(qn.E) != (nn, 2*p)
        qn.E = zeros(T, nn, 2*p)
        qn.H = zeros(T, nn, 2*p)
    else
        fill!(qn.E, zero(T))
        fill!(qn.H, zero(T))
    end

    # Solve LBFGS system with Sherman-Morrison-Woodbury formula
    # (C + E P Eᵀ)⁻¹ = C⁻¹ - C⁻¹ E (P + Eᵀ C⁻¹ E) Eᵀ C⁻¹
    #
    # P = [ -Iₚ  0  ] (size 2p × 2p) and E = [ U  V ] (size (n+m) × 2p)
    #     [  0   Iₚ ]                        [ 0  0 ]

    # Solve linear system without low-rank part
    solve_linear_system!(kkt.linear_solver, w_)  # w_ stores the solution of Cx = b

    # Add low-rank correction
    if p > 0
        @inbounds for i in 1:n, j in 1:p
            qn.E[i, j] = qn.U[i, j]
            qn.E[i, j+p] = qn.V[i, j]
        end
        copyto!(qn.H, qn.E)

        solve_linear_system!(kkt.linear_solver, qn.H)  # H = C⁻¹ E

        for i = 1:p
            Tk[i,i] = -one(T)                  # Tₖ = P
            Tk[i+p,i+p] = one(T)
        end
        mul!(Tk, qn.E', qn.H, one(T), one(T))  # Tₖ = (P + Eᵀ C⁻¹ E)
        mul!(xr, qn.E', w_)                    # xᵣ = Eᵀ C⁻¹ b

        if T <: BlasReal
            F, ipiv, info = LAPACK.sytrf!('L', Tk)  # Tₖ⁻¹
            LAPACK.sytrs!('L', F, ipiv, xr)         # xᵣ = (P + Eᵀ C⁻¹ E)⁻¹ Eᵀ C⁻¹ b
        else
            F = bunchkaufman!(Symmetric(Tk, :L))    # Tₖ⁻¹
            ldiv!(F, xr)                            # xᵣ = (P + Eᵀ C⁻¹ E)⁻¹ Eᵀ C⁻¹ b
        end

        mul!(w_, qn.H, xr, -one(T), one(T))    # x = x - C⁻¹ E xᵣ
    end

    finish_aug_solve!(kkt, w)
    return w
end


function solve_kkt!(kkt::SparseCondensedKKTSystem{T}, w::AbstractKKTVector)  where T

    (n,m) = size(kkt.jt_csc)

    # Decompose buffers
    wx = _madnlp_unsafe_wrap(full(w), n)
    ws = view(full(w), n+1:n+m)
    wz = view(full(w), n+m+1:n+2*m)
    Σs = view(kkt.pr_diag, n+1:n+m)

    reduce_rhs!(kkt, w)

    kkt.buffer .= kkt.diag_buffer .* (wz .+ ws ./ Σs)

    mul!(wx, kkt.jt_csc, kkt.buffer, one(T), one(T))
    solve_linear_system!(kkt.linear_solver, wx)

    mul!(kkt.buffer2, kkt.jt_csc', wx) # TODO: investigate why directly using wz here is causing an error

    wz .= .- kkt.buffer .+ kkt.diag_buffer .* kkt.buffer2
    ws .= (ws .+ wz) ./ Σs

    finish_aug_solve!(kkt, w)
    return w
end

function solve_kkt!(
    kkt::SparseUnreducedKKTSystem{T, VT, MT, QN},
    w::AbstractKKTVector
    ) where {T, VT, MT, QN<:CompactLBFGS}
    error("Quasi-Newton approximation of the Hessian is not supported by the KKT formulation SparseUnreducedKKTSystem. Please use SparseKKTSystem instead.")
end

function solve_kkt!(
    kkt::SparseCondensedKKTSystem{T, VT, MT, QN},
    w::AbstractKKTVector
    ) where {T, VT, MT, QN<:CompactLBFGS}
    error("Quasi-Newton approximation of the Hessian is not supported by the KKT formulation SparseCondensedKKTSystem. Please use SparseKKTSystem instead.")
end

function solve_kkt!(
    kkt::ScaledSparseKKTSystem{T, VT, MT, QN},
    w::AbstractKKTVector
    ) where {T, VT, MT, QN<:CompactLBFGS}
    error("Quasi-Newton approximation of the Hessian is not supported by the KKT formulation ScaledSparseKKTSystem. Please use SparseKKTSystem instead.")
end

function solve_kkt!(
    kkt::DenseCondensedKKTSystem,
    w::AbstractKKTVector{T},
    ) where T

    n = num_variables(kkt)
    n_eq, ns = kkt.n_eq, kkt.n_ineq
    n_condensed = n + n_eq

    # Decompose rhs
    wx = view(full(w), 1:n)
    ws = view(full(w), n+1:n+ns)
    wy = view(full(w), kkt.ind_eq_shifted)
    wz = view(full(w), kkt.ind_ineq_shifted)

    x = kkt.pd_buffer
    xx = view(x, 1:n)
    xy = view(x, n+1:n+n_eq)

    Σs = get_slack_regularization(kkt)

    reduce_rhs!(kkt, w)

    fill!(kkt.buffer, zero(T))
    kkt.buffer[kkt.ind_ineq] .= kkt.diag_buffer .* (wz .+ ws ./ Σs)
    mul!(xx, kkt.jac', kkt.buffer)
    xx .+= wx
    xy .= wy
    solve_linear_system!(kkt.linear_solver, x)

    wx .= xx
    mul!(dual(w), kkt.jac, wx)
    wy .= xy
    wz .*= kkt.diag_buffer
    dual(w) .-= kkt.buffer
    ws .= (ws .+ wz) ./ Σs

    finish_aug_solve!(kkt, w)
    return w
end

function mul!(w::AbstractKKTVector{T}, kkt::Union{SparseKKTSystem{T,VT,MT,QN},SparseUnreducedKKTSystem{T,VT,MT,QN}}, x::AbstractKKTVector, alpha = one(T), beta = zero(T)) where {T, VT, MT, QN<:ExactHessian}
    mul!(primal(w), Symmetric(kkt.hess_com, :L), primal(x), alpha, beta)
    mul!(primal(w), kkt.jac_com', dual(x), alpha, one(T))
    mul!(dual(w), kkt.jac_com,  primal(x), alpha, beta)
    _kktmul!(w,x,kkt.reg,kkt.du_diag,kkt.l_lower,kkt.u_lower,kkt.l_diag,kkt.u_diag, alpha, beta)
    return w
end

function mul!(w::AbstractKKTVector{T}, kkt::ScaledSparseKKTSystem{T,VT,MT,QN}, x::AbstractKKTVector, alpha = one(T), beta = zero(T)) where {T, VT, MT, QN<:ExactHessian}
    mul!(primal(w), Symmetric(kkt.hess_com, :L), primal(x), alpha, beta)
    mul!(primal(w), kkt.jac_com', dual(x), alpha, one(T))
    mul!(dual(w), kkt.jac_com,  primal(x), alpha, beta)
    # Custom reduction
    primal(w) .+= alpha .* kkt.reg .* primal(x)
    dual(w) .+= alpha .* kkt.du_diag .* dual(x)
    w.xp_lr .-= alpha .* dual_lb(x)
    w.xp_ur .+= alpha .* dual_ub(x)
    dual_lb(w) .= beta .* dual_lb(w) .+ alpha .* (x.xp_lr .* kkt.l_lower .+ dual_lb(x) .* kkt.l_diag)
    dual_ub(w) .= beta .* dual_ub(w) .+ alpha .* (x.xp_ur .* kkt.u_lower .- dual_ub(x) .* kkt.u_diag)
    return w
end

function mul!(w::AbstractKKTVector{T}, kkt::Union{SparseKKTSystem{T,VT,MT,QN},SparseUnreducedKKTSystem{T,VT,MT,QN}}, x::AbstractKKTVector, alpha = one(T), beta = zero(T)) where {T, VT, MT, QN<:CompactLBFGS}
    qn = kkt.quasi_newton
    n, p = size(qn)
    nn = length(primal_dual(w))
    # Load buffers (size: 2p)
    vx = qn._w2
    # Reset E
    fill!(qn.E, zero(T))
    @inbounds for i in 1:n, j in 1:p
        qn.E[i, j] = qn.U[i, j]
        qn.E[i, j+p] = qn.V[i, j]
    end
    # Upper-left block is B = ξI - UUᵀ + VVᵀ
    mul!(primal(w), Symmetric(kkt.hess_com, :L), primal(x), alpha, beta)
    mul!(primal(w), kkt.jac_com', dual(x), alpha, one(T))
    mul!(dual(w), kkt.jac_com,  primal(x), alpha, beta)
    mul!(vx, qn.E', primal_dual(x))
    @inbounds for k in 1:p
        vx[k] = -vx[k]
    end
    mul!(primal_dual(w), qn.E, vx, alpha, one(T))

    _kktmul!(w,x,kkt.reg,kkt.du_diag,kkt.l_lower,kkt.u_lower,kkt.l_diag,kkt.u_diag, alpha, beta)
end

function mul!(w::AbstractKKTVector{T}, kkt::SparseCondensedKKTSystem, x::AbstractKKTVector, alpha, beta) where T
    n = size(kkt.hess_com, 1)
    m = size(kkt.jt_csc, 2)

    # Decompose results
    xx = view(full(x), 1:n)
    xs = view(full(x), n+1:n+m)
    xz = view(full(x), n+m+1:n+2*m)

    # Decompose buffers
    wx = _madnlp_unsafe_wrap(full(w), n)
    ws = view(full(w), n+1:n+m)
    wz = view(full(w), n+m+1:n+2*m)

    mul!(wx, Symmetric(kkt.hess_com, :L), xx, alpha, beta) # TODO: make this symmetric

    mul!(wx, kkt.jt_csc,  xz, alpha, one(T))
    mul!(wz, kkt.jt_csc', xx, alpha, beta)
    axpy!(-alpha, xs, wz)
    ws .= beta.*ws .- alpha.* xz

    _kktmul!(w,x,kkt.reg,kkt.du_diag,kkt.l_lower,kkt.u_lower,kkt.l_diag,kkt.u_diag, alpha, beta)
    return w
end

function mul!(w::AbstractKKTVector{T}, kkt::AbstractDenseKKTSystem, x::AbstractKKTVector, alpha = one(T), beta = zero(T)) where T
    (m, n) = size(kkt.jac)
    wx = @view(primal(w)[1:n])
    ws = @view(primal(w)[n+1:end])
    wy = dual(w)
    wz = @view(dual(w)[kkt.ind_ineq])

    xx = @view(primal(x)[1:n])
    xs = @view(primal(x)[n+1:end])
    xy = dual(x)
    xz = @view(dual(x)[kkt.ind_ineq])

    _symv!('L', alpha, kkt.hess, xx, beta, wx)
    if m > 0  # otherwise, CUDA causes an error
        mul!(wx, kkt.jac', dual(x), alpha, one(T))
        mul!(wy, kkt.jac,  xx, alpha, beta)
    end
    ws .= beta.*ws .- alpha.* xz
    wz .-= alpha.* xs
    _kktmul!(w,x,kkt.reg,kkt.du_diag,kkt.l_lower,kkt.u_lower,kkt.l_diag,kkt.u_diag, alpha, beta)
    return w
end

function mul_hess_blk!(wx, kkt::Union{DenseKKTSystem,DenseCondensedKKTSystem}, t)
    n = size(kkt.hess, 1)
    mul!(@view(wx[1:n]), Symmetric(kkt.hess, :L), @view(t[1:n]))
    fill!(@view(wx[n+1:end]), 0)
    wx .+= t .* kkt.pr_diag
end

function mul_hess_blk!(wx, kkt::Union{SparseKKTSystem,SparseCondensedKKTSystem}, t)
    n = size(kkt.hess_com, 1)
    mul!(@view(wx[1:n]), Symmetric(kkt.hess_com, :L), @view(t[1:n]))
    fill!(@view(wx[n+1:end]), 0)
    wx .+= t .* kkt.pr_diag
end

function mul_hess_blk!(wx, kkt::SparseUnreducedKKTSystem, t)
    ind_lb = kkt.ind_lb
    ind_ub = kkt.ind_ub

    n = size(kkt.hess_com, 1)
    mul!(@view(wx[1:n]), Symmetric(kkt.hess_com, :L), @view(t[1:n]))
    fill!(@view(wx[n+1:end]), 0)
    wx .+= t .* kkt.pr_diag
    wx[ind_lb] .-= @view(t[ind_lb]) .* (kkt.l_lower ./ kkt.l_diag)
    wx[ind_ub] .-= @view(t[ind_ub]) .* (kkt.u_lower ./ kkt.u_diag)
end

#=
    MadNLP.MadNLPOptions
=#

function MadNLP.MadNLPOptions{T}(
        nlp::MadNLP.AbstractNLPModel{T, VT};
        dense_callback = MadNLP.is_dense_callback(nlp),
        callback = dense_callback ? MadNLP.DenseCallback : MadNLP.SparseCallback,
        kkt_system = dense_callback ? MadNLP.DenseCondensedKKTSystem : MadNLP.SparseCondensedKKTSystem,
        linear_solver = dense_callback ? LapackCUDASolver : CUDSSSolver,
        tol = MadNLP.get_tolerance(T, kkt_system),
        bound_relax_factor = (kkt_system == MadNLP.SparseCondensedKKTSystem) ? tol : T(1.0e-8),
    ) where {T, VT <: CuVector{T}}
    return MadNLP.MadNLPOptions{T}(
        tol = tol,
        callback = callback,
        kkt_system = kkt_system,
        linear_solver = linear_solver,
        bound_relax_factor = bound_relax_factor,
    )
end

function MadNLP.default_options(::MadNLP.AbstractNLPModel{T, VT}, ::Type{MadNLP.SparseCondensedKKTSystem}, linear_solver::Type{CUDSSSolver}) where {T, VT <: CuVector{T}}
    opt = MadNLP.default_options(linear_solver)
    # MadNLP.set_options!(opt, Dict(:cudss_algorithm => MadNLP.CHOLESKY)) # commented out due to issue #539

    return opt
end

#=
    SparseMatrixCSC to CuSparseMatrixCSC
=#

function cuSPARSE.CuSparseMatrixCSC{Tv, Ti}(A::SparseMatrixCSC{Tv, Ti}) where {Tv, Ti}
    return cuSPARSE.CuSparseMatrixCSC{Tv, Ti}(
        CuVector(A.colptr),
        CuVector(A.rowval),
        CuVector(A.nzval),
        size(A),
    )
end

#=
    CuSparseMatrixCSC to CuMatrix
=#

MadNLPGPU.gpu_transfer!(y::CuMatrix{T}, x::cuSPARSE.CuSparseMatrixCSC{T}) where {T} =
    MadNLPGPU._gpu_sparse_csc_to_dense!(y, x)

#=
    MadNLP._ger!
=#

MadNLP._ger!(alpha::T, x::CuVector{T}, y::CuVector{T}, A::CuMatrix{T}) where {T} = cuBLAS.ger!(alpha, x, y, A)

#=
    MadNLP._syr!
=#

MadNLP._syr!(uplo::Char, alpha::T, x::CuVector{T}, A::CuMatrix{T}) where {T} = cuBLAS.syr!(uplo, alpha, x, A)

#=
    MadNLP._symv!
=#

MadNLP._symv!(uplo::Char, alpha::T, A::CuMatrix{T}, x::CuVector{T}, beta::T, y::CuVector{T}) where {T} = cuBLAS.symv!(uplo, alpha, A, x, beta, y)

#=
    MadNLP._syrk!
=#

MadNLP._syrk!(uplo::Char, trans::Char, alpha::T, A::CuMatrix{T}, beta::T, C::CuMatrix{T}) where {T} = cuBLAS.syrk!(uplo, trans, alpha, A, beta, C)

#=
    MadNLP._trsm!
=#

MadNLP._trsm!(side::Char, uplo::Char, transa::Char, diag::Char, alpha::T, A::CuMatrix{T}, B::CuMatrix{T}) where {T} = cuBLAS.trsm!(side, uplo, transa, diag, alpha, A, B)

#=
    MadNLP._dgmm!
=#

MadNLP._dgmm!(side::Char, A::CuMatrix{T}, x::CuVector{T}, B::CuMatrix{T}) where {T} = cuBLAS.dgmm!(side, A, x, B)

# Options

parse_option(::Type{Module},str::String) = eval(Symbol(str))
parse_option(::Type{<:AbstractUserCallback}, f::Any) = f
parse_option(type::Type{T},i::Int64) where {T<:Enum} = type(i)

function set_options!(opt::AbstractOptions, options)
    other_options = Dict{Symbol, Any}()
    for (key, val) in options
        if hasproperty(opt, key)
            T = fieldtype(typeof(opt), key)
            val isa T ? setproperty!(opt,key,val) :
                setproperty!(opt,key,parse_option(T,val))
        else
            other_options[key] = val
        end
    end
    return other_options
end

"""
Option | Default Value | Description
:--- | :--- | :---
||
__Primary options__||
||
tol                            | 1e-8                 | termination tolerance on KKT residual
callback                       | [`SparseCallback`](@ref) | type of callback (`SparseCallback` or `DenseCallback`)
kkt\\_system                   | [`SparseKKTSystem`](@ref) | type of primal-dual KKT system
linear\\_solver                | MumpsSolver          | linear solver used for solving primal-dual KKT system
||
__General options__||
||
rethrow\\_error                | true                 | rethrow any error encountered during the algorithm
disable\\_garbage\\_collector  | false                | disable garbage collector in MadNLP
blas\\_num\\_thread            | 1                    | number of threads to use in the BLAS backend
intermediate_callback          | AbstractUserCallback | Intermediate callback called at each IPM iteration
__Output options__||
||
output\\_file                  | `""`                 | if not `""`, the output log is teed to the file at this path
print\\_level                  | INFO                 | verbosity level in MadNLP
file\\_print\\_level           | INFO                 | verbosity level in file output
||
__Termination options__||
||
max\\_iter                     | 3000                 | maximum number of interior-point iterations
max\\_wall_time                | 1e6                  | maximum wall time in seconds
acceptable\\_tol               | 1e-6                 | acceptable tolerance on KKT residual
acceptable\\_iter              | 15                   | number of acceptable iterates before stopping algorithm
diverging\\_iter               | 1e20                 | threshold on KKT residual to declare algorithm as diverging
s\\_max                        | 100.0                | scaling threshold for KKT residual
||
__NLP options__||
||
kappa\\_d                      | 1e-5                 | weight for linear damping term
fixed\\_variable\\_treatment   | [`MakeParameter`](@ref) | treatment for the fixed variables (`MakeParameter` or `RelaxBound`)
equality\\_treatment           | [`EnforceEquality`](@ref) | treatment for the equality constraints (`EnforceEquality` or `RelaxEquality`)
bound\\_relax\\_factor         | 1e-8                 | factor for initial relaxation of bounds
jacobian\\_constant            | false                | set to true if the constraints are linear.
hessian\\_constant             | false                | set to true if the problem is linear or quadratic
hessian\\_approximation        | `ExactHessian` | method used to approximate the Hessian
quasi\\_newton\\_options       | QuasiNewtonOptions() | options for quasi-Newton algorithm
inertia\\_correction\\_method  | InertiaAuto          | inertia correction mechanism
inertia\\_free\\_tol           | 0.0                  | tolerance for inertia free method
default\\_primal\\_regularization | 0.0 | default regularization for primal variable blocks in the KKT system
default\\_dual\\_regularization   | 0.0 | default regularization for dual variable blocks in the KKT system
||
__Initialization__||
||
dual\\_initialized             | false                | specify if dual initial point is available
dual\\_initialization\\_method | DualInitializeLeastSquares | method to compute the initial dual multipliers
constr\\_mult\\_init\\_max     | 1e3                  | maximum allowable value in initial dual multipliers
bound\\_push                   | 1e-2                 | minimum absolute distance from the initial point to bound
bound\\_fac                    | 1e-2                 | minimum relative distance from the initial point to bound
nlp\\_scaling                  | true                 | scale nonlinear program
nlp\\_scaling\\_max\\_gradient | 100.0                | maximum gradient after NLP scaling
||
__Hessian perturbation__||
||
min\\_hessian\\_perturbation       | 1e-20                | smallest perturbation of Hessian block in inertia correction
first\\_hessian\\_perturbation     | 1e-4                 | first value tried in inertia correction
max\\_hessian\\_perturbation       | 1e20                 | largest perturbation of Hessian block in inertia correction
perturb\\_inc\\_fact\\_first       | 1e2                  | increase factor for primal perturbation for very first perturbation
perturb\\_inc\\_fact               | 8.                   | increase factor for primal perturbation
perturb\\_dec\\_fact               | 1/3                  | decrease factor for primal perturbation
jacobian\\_regularization\\_exponent | 1/4                | exponent for mu in the regularization of rank-defficient Jacobian
jacobian\\_regularization\\_value  | 1e-8                 | size of regularization for rank-defficient Jacobian
||
__Feasible restoration__||
||
soft\\_resto\\_pderror\\_reduction\\_factor | 0.9999          | required reduction in primal-dual error in the soft restoration phase
required\\_infeasibility\\_reduction        | 0.9             | required reduction of infeasibility before leaving restoration phase
||
__Line search__||
||
obj\\_max\\_inc                | 5.                   | upper bound on the acceptable increase of barrier objective function
kappha\\_soc                   | 0.99                 | factor in the sufficient reduction rule for second order correction
max\\_soc                      | 4                    | maximum number of second order correction trial steps at each iteration
alpha\\_min\\_frac             | 0.05                 | safety factor for the minimal step size
s\\_theta                      | 1.1                  | exponent for current constraint violation in the switching rule
s\\_phi                        | 2.3                  | exponent for linear barrier function model in the switching rule
eta\\_phi                      | 1e-4                 | relaxation factor in the Armijo condition
kappa\\_soc                    | 0.99                 | factor in the sufficient reduction rule for second order correction
gamma\\_theta                  | 1e-5                 | relaxation factor in the filter margin for the constraint violation
gamma\\_phi                    | 1e-5                 | relaxation factor in the filter margin for the barrier function
delta                          | 1.0                  | multiplier for constraint violation in the switching rule
kappa\\_sigma                  | 1e10                 | factor limiting the deviation of dual variables from primal estimates
barrier\\_tol\\_factor         | 10.0                 | factor for mu in barrier stop test
rho                            | 1000.0               | value in penalty parameter update formula
||
__Barrier__||
||
barrier                        | [`MonotoneUpdate`](@ref) | algorithm to update barrier parameter
tau\\_min                      | 0.99                 | lower bound on fraction-to-the-boundary parameter tau
||
"""
@kwdef mutable struct MadNLPOptions{T} <: AbstractOptions
    # Primary options
    tol::T
    callback::Type
    kkt_system::Type
    linear_solver::Type

    # General options
    rethrow_error::Bool = true
    disable_garbage_collector::Bool = false
    blas_num_threads::Int = 1
    iterator::Type = RichardsonIterator
    intermediate_callback::AbstractUserCallback = NoUserCallback()

    # Output options
    output_file::String = ""
    print_level::LogLevels = INFO
    file_print_level::LogLevels = INFO

    # Termination options
    acceptable_tol::T = 1e-6
    acceptable_iter::Int = 15
    diverging_iterates_tol::T = 1e20
    max_iter::Int = 3000
    max_wall_time::T = 1e6
    s_max::T = 100.

    # NLP options
    kappa_d::T = 1e-5
    fixed_variable_treatment::Type = kkt_system <: MadNLP.SparseCondensedKKTSystem ? MadNLP.RelaxBound : MadNLP.MakeParameter
    equality_treatment::Type = kkt_system <: MadNLP.SparseCondensedKKTSystem ? MadNLP.RelaxEquality : MadNLP.EnforceEquality
    bound_relax_factor::T = 1e-8
    jacobian_constant::Bool = false
    hessian_constant::Bool = false
    hessian_approximation::Type = ExactHessian
    quasi_newton_options::QuasiNewtonOptions{T} = QuasiNewtonOptions{T}()
    inertia_correction_method::Type = InertiaAuto
    inertia_free_tol::T = 0.
    default_primal_regularization::T = 0.
    default_dual_regularization::T = 0.

    # initialization options
    dual_initialized::Bool = false
    dual_initialization_method::Type = kkt_system <: MadNLP.SparseCondensedKKTSystem ? DualInitializeSetZero : DualInitializeLeastSquares
    constr_mult_init_max::T = 1e3
    bound_push::T = 1e-2
    bound_fac::T = 1e-2
    nlp_scaling::Bool = true
    nlp_scaling_max_gradient::T = 100.

    # Hessian Perturbation
    min_hessian_perturbation::T = 1e-20
    first_hessian_perturbation::T = 1e-4
    max_hessian_perturbation::T = 1e20
    perturb_inc_fact_first::T = 1e2
    perturb_inc_fact::T = 8.
    perturb_dec_fact::T = 1/3
    jacobian_regularization_exponent::T = 1/4
    jacobian_regularization_value::T = 1e-8

    # restoration options
    soft_resto_pderror_reduction_factor::T = 0.9999
    required_infeasibility_reduction::T = 0.9

    # Line search
    obj_max_inc::T = 5.
    kappha_soc::T = 0.99
    max_soc::Int = 4
    alpha_min_frac::T = 0.05
    s_theta::T = 1.1
    s_phi::T = 2.3
    eta_phi::T = 1e-4
    kappa_soc::T = 0.99
    gamma_theta::T = 1e-5
    gamma_phi::T = 1e-5
    delta::T = 1
    kappa_sigma::T = 1e10
    barrier_tol_factor::T = 10.
    rho::T = 1000.

    # Barrier
    # mu_min by courtesy of Ipopt
    barrier::AbstractBarrierUpdate{T} = MonotoneUpdate(T(tol), barrier_tol_factor)
    tau_min::T = 0.99

    # KKT system options (passed through to create_kkt_system)
    kkt_options::Dict{Symbol, Any} = Dict{Symbol, Any}()
end

is_dense_callback(nlp) = !nlp.meta.sparse_jacobian && !nlp.meta.sparse_hessian

# smart option presets
function MadNLPOptions{T}(
    nlp::AbstractNLPModel{T};
    dense_callback = MadNLP.is_dense_callback(nlp),
    callback = dense_callback ? DenseCallback : SparseCallback,
    kkt_system = dense_callback ? DenseCondensedKKTSystem : SparseKKTSystem,
    linear_solver = dense_callback ? LapackCPUSolver : default_sparse_solver(nlp),
    tol = get_tolerance(T,kkt_system)
) where {T}
    return MadNLPOptions{T}(
        tol = tol,
        callback = callback,
        kkt_system = kkt_system,
        linear_solver = linear_solver,
    )
end

get_tolerance(::Type{T},::Type{KKT}) where {T, KKT} = 10^round(log10(eps(T))/2)
get_tolerance(::Type{T},::Type{SparseCondensedKKTSystem}) where T = 10^(round(log10(eps(T))/4))

default_sparse_solver(nlp::AbstractNLPModel) = MumpsSolver

function check_option_sanity(options)
    is_kkt_dense = options.kkt_system <: AbstractDenseKKTSystem || options.kkt_system <: SchurComplementKKTSystem
    is_hess_approx_dense = options.hessian_approximation <: Union{BFGS, DampedBFGS}
    if input_type(options.linear_solver) == :csc && is_kkt_dense
        error("[options] Sparse Linear solver is not supported in dense mode.\n"*
              "Please use a dense linear solver or change `kkt_system` ")
    end
    if is_hess_approx_dense && !is_kkt_dense
        error("[options] DENSE_BFGS and DENSE_DAMPED_BFGS quasi-Newton approximations\n"*
              "require a dense KKT system (DENSE_KKT_SYSTEM or DENSE_CONDENSED_KKT_SYSTEM).")
    end
end

function print_ignored_options(logger,option_dict)
    @warn(logger,"The following options are ignored: ")
    for (key,val) in option_dict
        @warn(logger," - "*string(key))
    end
end

function _get_primary_options(options)
    primary_opt = Dict{Symbol,Any}()
    remaining_opt = Dict{Symbol,Any}()
    for (k,v) in options
        if k in [:tol, :linear_solver, :callback, :kkt_system]
            primary_opt[k] = v
        else
            remaining_opt[k] = v
        end
    end

    return primary_opt, remaining_opt
end

function load_options(nlp::AbstractNLPModel{T,VT}; options...) where {T, VT}

    primary_opt, options = _get_primary_options(options)

    # Initiate interior-point options
    opt_ipm = MadNLPOptions{T}(nlp; primary_opt...)
    linear_solver_options = set_options!(opt_ipm, options)

    check_option_sanity(opt_ipm)
    # Initiate linear-solver options
    opt_linear_solver = default_options(nlp, opt_ipm.kkt_system, opt_ipm.linear_solver)
    iterator_options = set_options!(opt_linear_solver, linear_solver_options)
    # Initiate iterator options
    opt_iterator = default_options(opt_ipm.iterator, opt_ipm.tol)
    remaining_options = set_options!(opt_iterator, iterator_options)

    # Initiate logger
    logger = MadNLPLogger(
        print_level=opt_ipm.print_level,
        file_print_level=opt_ipm.file_print_level,
        file = opt_ipm.output_file == "" ? nothing : open(opt_ipm.output_file,"w+"),
    )
    @trace(logger,"Logger is initialized.")

    # Print remaning options (unsupported)
    if !isempty(remaining_options)
        print_ignored_options(logger, remaining_options)
    end
    return (
        interior_point=opt_ipm,
        linear_solver=opt_linear_solver,
        iterative_refinement=opt_iterator,
        logger=logger,
        intermediate_callback=opt_ipm.intermediate_callback,
    )
end

"""
        default_options(
                nlp::AbstractNLPModel,
                kkt::Type,
                linear_solver::Type;
                iterator_options=Dict{Symbol,Any}(),
        )

default options for `linear_solver` associated to the KKT system `kkt_system` and `nlp`.
"""
default_options(nlp::AbstractNLPModel, kkt, linear_solver) = default_options(linear_solver)

#=
    MadNLP wrappers

    MadNLP adapts any AbstractNLPModel to avoid numerical issues.
    The `AbstractNLPModel` is wrapped as a `SparseCallback` or as a `DenseCallback`
    (if both nlp.meta.sparse_jacobian and nlp.meta.sparse_hessian are set to false).

    The wrapper reformulates the model by:
    1. scaling the objective and the constraints.
    2. removing the fixed variables from the formulation.

    The scaling can be switched off by setting `nlp_scaling=false` in the options.

    Four cases can occur for the fixed variables:

    Case #1. The problem doesn't have any fixed variable
        MadNLP sets `fixed_variable_treatment=NoFixedVariables()`
        and fallbacks to the default callbacks (that just apply the scaling).

    Case #2. `fixed_variable_treatment=RelaxBound`
        MadNLP relax slightly the bounds of the fixed variables during
        the initialization. The wrapper fallbacks to the default callbacks, similarly as with Case #1.

    Case #3. `callback=DenseCallback` and `fixed_variable_treatment=MakeParameter`
        Reformulate the fixed variables as dummy variables that are kept
        at their bounds. The problem's dimension is not modified. The wrapper
        modifies the Jacobian by filling the fixed columns with 0,
        and the Hessian by filling the fixed columns and rows with 0 for
        the non-diagonal elements, 1 for the diagonal ones.

    Case #4. `callback=SparseCallback` and `fixed_variable_treatment=MakeParameter`
        Remove the fixed variables from the model. As a consequence, the problem's
        dimension is reduced after the reformulation.
=#

"""
    AbstractFixedVariableTreatment

Abstract type to define the reformulation of the fixed variables inside MadNLP.
"""
abstract type AbstractFixedVariableTreatment end

"""
    NoFixedVariables <: AbstractFixedVariableTreatment

Do nothing if the problem has no fixed variables.
"""
struct NoFixedVariables <: AbstractFixedVariableTreatment end

"""
    MakeParameter{VT, VI} <: AbstractFixedVariableTreatment

Remove the fixed variables from the optimization variables and
define them as problem's parameters.

"""
struct MakeParameter{T, VT,VI} <: AbstractFixedVariableTreatment
    free::VI
    fixed::VI
    ind_jac_free::VI
    ind_hess_free::VI
    hash_x::Ref{T}
    x_full::VT
    g_full::VT
end

"""
    RelaxBound <: AbstractFixedVariableTreatment

Relax the fixed variables ``x = x_{fixed}`` as bounded
variables ``x_{fixed} - ϵ ≤ x ≤ x_{fixed} + ϵ``, with
``ϵ`` a small-enough parameter.

"""
struct RelaxBound <: AbstractFixedVariableTreatment end

"""
    AbstractEqualityTreatment

Abstract type to define the reformulation of the equality
constraints inside MadNLP.
"""
abstract type AbstractEqualityTreatment end

"""
    EnforceEquality <: AbstractEqualityTreatment

Keep the equality constraints intact.

The solution returned by MadNLP will respect the equality constraints.
"""
struct EnforceEquality <: AbstractEqualityTreatment end

"""
    RelaxEquality <: AbstractEqualityTreatment

Relax the equality constraints ``g(x) = 0`` with two
inequality constraints, as ``-ϵ ≤ g(x) ≤ ϵ``. The parameter
``ϵ`` is usually small.

The solution returned by MadNLP will satisfy the equality
constraints only up to a tolerance ``ϵ``.

"""
struct RelaxEquality <: AbstractEqualityTreatment end

"""
    AbstractCallback{T, VT}

Wrap the `AbstractNLPModel` passed by the user in a form amenable to MadNLP.

An `AbstractCallback` handles the scaling of the problem and the
reformulations of the equality constraints and fixed variables.

"""
abstract type AbstractCallback{T, VT, FH} end

"""
    create_callback(
        ::Type{Callback},
        nlp::AbstractNLPModel{T, VT};
        fixed_variable_treatment=MakeParameter,
        equality_treatment=EnforceEquality,
    ) where {T, VT}

Wrap the nonlinear program `nlp` using the callback wrapper
with type `Callback`. The option `fixed_variable_treatment`
decides if the fixed variables are relaxed (`RelaxBound`)
or removed (`MakeParameter`). The option `equality_treatment`
decides if the the equality constraints are keep as is
(`EnforceEquality`) or relaxed (`RelaxEquality`).

"""
function create_callback end

"""
    SparseCallback{T, VT} < AbstractCallback{T, VT}

Wrap an `AbstractNLPModel` using sparse structures.

"""
struct SparseCallback{
    T,
    VT<:AbstractVector{T},
    VI<:AbstractVector{Int},
    I<:AbstractNLPModel{T,VT},
    FH<:AbstractFixedVariableTreatment,
    EH<:AbstractEqualityTreatment,
} <: AbstractCallback{T,VT, FH}
    nlp::I
    nvar::Int
    ncon::Int
    nnzj::Int
    nnzh::Int

    con_buffer::VT
    jac_buffer::VT
    grad_buffer::VT
    hess_buffer::VT

    jac_I::VI
    jac_J::VI
    hess_I::VI
    hess_J::VI

    obj_scale::Base.RefValue{T}
    obj_sign::T
    con_scale::VT
    jac_scale::VT

    fixed_handler::FH
    equality_handler::EH

    ind_eq::VI
    ind_ineq::VI
    ind_fixed::VI
    ind_lb::VI
    ind_ub::VI
    ind_llb::VI
    ind_uub::VI
end

"""
    DenseCallback{T, VT} < AbstractCallback{T, VT}

Wrap an `AbstractNLPModel` using dense structures.

"""
struct DenseCallback{
    T,
    VT<:AbstractVector{T},
    VI<:AbstractVector{Int},
    I<:AbstractNLPModel{T,VT},
    FH<:AbstractFixedVariableTreatment,
    EH<:AbstractEqualityTreatment,
} <: AbstractCallback{T,VT, FH}
    nlp::I
    nvar::Int
    ncon::Int

    con_buffer::VT
    grad_buffer::VT

    obj_scale::Base.RefValue{T}
    obj_sign::T
    con_scale::VT

    fixed_handler::FH
    equality_handler::EH

    ind_eq::VI
    ind_ineq::VI
    ind_fixed::VI
    ind_lb::VI
    ind_ub::VI
    ind_llb::VI
    ind_uub::VI
end

create_array(cb::AbstractCallback, args...) = similar(get_x0(cb.nlp), args...)

#=
    Scaling
=#
function set_obj_scale!(obj_scale, f::VT, max_gradient) where {T,VT<:AbstractVector{T}}
    return obj_scale[] = min(one(T), max_gradient / norm(f, Inf))
end

function set_con_scale_sparse!(
    con_scale::VT,
    jac_I,
    jac_buffer,
    max_gradient,
) where {T,VT<:AbstractVector{T}}
    fill!(con_scale, one(T))
    _set_con_scale_sparse!(con_scale, jac_I, jac_buffer)
    return map!(x -> min(one(T), max_gradient / x), con_scale, con_scale)
end
function _set_con_scale_sparse!(con_scale, jac_I, jac_buffer)
    @inbounds @simd for i in 1:length(jac_I)
        row = jac_I[i]
        con_scale[row] = max(con_scale[row], abs(jac_buffer[i]))
    end
end

function set_jac_scale_sparse!(
    jac_scale::VT,
    con_scale,
    jac_I,
) where {T,VT<:AbstractVector{T}}
    return copyto!(jac_scale, @view(con_scale[jac_I]))
end

function set_con_scale_dense!(
    con_scale::VT,
    jac_buffer,
    max_gradient,
) where {T,VT<:AbstractVector{T}}
    return con_scale .=
        min.(
            one(T),
            max_gradient ./ mapreduce(abs, max, jac_buffer, dims = 2, init = one(T)),
        )
end

function create_sparse_fixed_handler(
    fixed_variable_treatment::Type{MakeParameter},
    nlp,
    jac_I,
    jac_J,
    hess_I,
    hess_J,
    hess_buffer,
)
    n = get_nvar(nlp)
    lvar = get_lvar(nlp)
    uvar = get_uvar(nlp)
    nnzj = get_nnzj(nlp.meta)
    nnzh = get_nnzh(nlp.meta)

    isfixed = (lvar .== uvar)
    isfree = (lvar .< uvar)

    fixed = findall(isfixed)
    nfixed = length(fixed)

    if nfixed == 0
        return NoFixedVariables(), n, nnzj, nnzh
    end

    free = findall(isfree)
    nx = length(free)
    map_full_to_free = similar(jac_I, n) ; fill!(map_full_to_free, -1)
    map_full_to_free[free] .= 1:nx

    ind_jac_free = findall(@view(isfree[jac_J]))
    ind_hess_free = findall(@view(isfree[hess_I]) .&& @view(isfree[hess_J]))

    nnzh = length(ind_hess_free)
    Hi, Hj = similar(hess_I, nnzh), similar(hess_J, nnzh)
    copyto!(Hi, map_full_to_free[hess_I[ind_hess_free]])
    copyto!(Hj, map_full_to_free[hess_J[ind_hess_free]])
    resize!(hess_I, nnzh)
    resize!(hess_J, nnzh)
    copyto!(hess_I, Hi)
    copyto!(hess_J, Hj)

    nnzj = length(ind_jac_free)
    Ji, Jj = similar(jac_I, nnzj), similar(jac_J, nnzj)
    copyto!(Ji, jac_I[ind_jac_free])
    copyto!(Jj, map_full_to_free[jac_J[ind_jac_free]])
    resize!(jac_I, nnzj)
    resize!(jac_J, nnzj)
    copyto!(jac_I, Ji)
    copyto!(jac_J, Jj)

    x_full = copy(lvar)

    fixed_handler = MakeParameter(
        free,
        fixed,
        ind_jac_free,
        ind_hess_free,
        Ref(NaN),
        x_full,
        similar(lvar, n),
    )

    return fixed_handler, nx, nnzj, nnzh
end


function create_dense_fixed_handler(fixed_variable_treatment::Type{MakeParameter}, nlp)
    n = get_nvar(nlp)
    lvar = get_lvar(nlp)
    uvar = get_uvar(nlp)
    isfixed = (lvar .== uvar)
    fixed = findall(lvar .== uvar)
    if length(fixed) == 0
        return NoFixedVariables()
    else
        free = findall(lvar .< uvar)
        return MakeParameter(
            free,
            fixed,
            similar(fixed, 0),
            similar(fixed, 0),
            Ref(NaN),
            similar(lvar, 0),
            similar(lvar, n),
        )
    end
end

function create_sparse_fixed_handler(
    fixed_variable_treatment::Type{RelaxBound},
    nlp,
    jac_I,
    jac_J,
    hess_I,
    hess_J,
    hess_buffer,
)
    n = get_nvar(nlp)
    fixed_handler = RelaxBound()
    return fixed_handler, n, get_nnzj(nlp.meta), get_nnzh(nlp.meta)
end

function _parse_indexes(lvar, uvar, lcon, ucon, equality_treatment)
    m = length(lcon)
    if m > 0
        if equality_treatment == EnforceEquality
            is_equality = lcon .== ucon
            ind_eq = findall(is_equality)
            ind_ineq = findall(~, is_equality)
        else
            ind_eq = similar(lvar, Int, 0)
            ind_ineq = similar(lvar, Int, m) .= 1:m
        end
        xl = [lvar; view(lcon, ind_ineq)]
        xu = [uvar; view(ucon, ind_ineq)]
    else
        ind_eq = similar(lvar, Int, 0)
        ind_ineq = similar(lvar, Int, 0)
        xl = lvar
        xu = uvar
    end

    is_upper_unbounded = uvar .== Inf
    is_lower_unbounded = lvar .==-Inf
    ind_llb = findall((.~is_lower_unbounded) .* is_upper_unbounded)
    ind_uub = findall((is_lower_unbounded) .* (.~is_upper_unbounded))
    ind_lb = findall(xl .!= -Inf)
    ind_ub = findall(xu .!= Inf)

    return (
        xl=xl,
        xu=xu,
        ind_eq=ind_eq,
        ind_ineq=ind_ineq,
        ind_lb=ind_lb,
        ind_ub=ind_ub,
        ind_llb=ind_llb,
        ind_uub=ind_uub,
    )
end

#=
    Constructors
=#

function create_callback(
    ::Type{SparseCallback},
    nlp::AbstractNLPModel{T,VT};
    fixed_variable_treatment = MakeParameter,
    equality_treatment = EnforceEquality,
) where {T,VT}
    n = get_nvar(nlp)
    m = get_ncon(nlp)
    nnzj = get_nnzj(nlp.meta)
    nnzh = get_nnzh(nlp.meta)

    x0 = get_x0(nlp)

    jac_I = similar(x0, Int, nnzj)
    jac_J = similar(x0, Int, nnzj)
    hess_I = similar(x0, Int, nnzh)
    hess_J = similar(x0, Int, nnzh)

    jac_buffer = similar(x0, nnzj)
    fill!(jac_buffer, zero(T))
    obj_scale = Ref(one(T))
    con_scale = similar(jac_buffer, m)
    fill!(con_scale, one(T))

    if nnzj > 0
        NLPModels.jac_structure!(nlp, jac_I, jac_J)
    end
    if nnzh > 0
        NLPModels.hess_structure!(nlp, hess_I, hess_J)
    end

    hess_buffer = similar(x0, nnzh)
    fill!(hess_buffer, zero(T))
    fixed_handler, nx, nnzj, nnzh = create_sparse_fixed_handler(
        fixed_variable_treatment,
        nlp,
        jac_I,
        jac_J,
        hess_I,
        hess_J,
        hess_buffer,
    )
    equality_handler = equality_treatment()

    jac_scale = similar(jac_buffer, nnzj)
    fill!(jac_scale, one(T))
    con_buffer = similar(x0, m)
    fill!(con_buffer, zero(T))
    grad_buffer = similar(x0, nx)
    fill!(grad_buffer, zero(T))

    # Get indexing
    lvar = get_lvar(nlp)
    uvar = get_uvar(nlp)
    lcon = get_lcon(nlp)
    ucon = get_ucon(nlp)

    # Get fixed variables
    ind_fixed = findall(lvar .== uvar)
    if length(ind_fixed) > 0 && fixed_variable_treatment == MakeParameter
        ind_free = findall(lvar .< uvar)
        # Remove fixed variables from problem's formulation
        lvar = lvar[ind_free]
        uvar = uvar[ind_free]
    end

    indexes = _parse_indexes(lvar, uvar, lcon, ucon, equality_treatment)

    return SparseCallback(
        nlp,
        nx,
        m,
        nnzj,
        nnzh,
        con_buffer,
        jac_buffer,
        grad_buffer,
        hess_buffer,
        jac_I,
        jac_J,
        hess_I,
        hess_J,
        obj_scale,
        get_minimize(nlp) ? one(T) : -one(T),
        con_scale,
        jac_scale,
        fixed_handler,
        equality_handler,
        indexes.ind_eq,
        indexes.ind_ineq,
        ind_fixed,
        indexes.ind_lb,
        indexes.ind_ub,
        indexes.ind_llb,
        indexes.ind_uub,
    )
end

function create_callback(
    ::Type{DenseCallback},
    nlp::AbstractNLPModel{T,VT};
    fixed_variable_treatment = MakeParameter,
    equality_treatment = EnforceEquality,
) where {T,VT}
    n = get_nvar(nlp)
    m = get_ncon(nlp)

    x0 = similar(get_x0(nlp))
    con_buffer = similar(x0, m)
    fill!(con_buffer, zero(T))
    grad_buffer = similar(x0, n)
    fill!(grad_buffer, zero(T))
    obj_scale = Ref(one(T))
    con_scale = similar(x0, m)
    fill!(con_scale, one(T))

    fixed_handler = create_dense_fixed_handler(fixed_variable_treatment, nlp)
    equality_handler = equality_treatment()

    # Get indexing
    lvar = get_lvar(nlp)
    uvar = get_uvar(nlp)
    lcon = get_lcon(nlp)
    ucon = get_ucon(nlp)

    indexes = _parse_indexes(lvar, uvar, lcon, ucon, equality_treatment)

    # Get fixed variables
    ind_fixed = findall(lvar .== uvar)
    if length(ind_fixed) > 0 && fixed_variable_treatment == MakeParameter
        # Keep fixed variables but remove them from lb/ub
        ind_lb = findall((indexes.xl .!= -Inf) .* (indexes.xl .!= indexes.xu))
        ind_ub = findall((indexes.xu .!= Inf) .* (indexes.xl .!= indexes.xu))
    else
        ind_lb = indexes.ind_lb
        ind_ub = indexes.ind_ub
    end

    return DenseCallback(
        nlp,
        n,
        m,
        con_buffer,
        grad_buffer,
        obj_scale,
        get_minimize(nlp) ? one(T) : -one(T),
        con_scale,
        fixed_handler,
        equality_handler,
        indexes.ind_eq,
        indexes.ind_ineq,
        ind_fixed,
        ind_lb,
        ind_ub,
        indexes.ind_llb,
        indexes.ind_uub,
    )
end

#=
    Callback's initialization
=#

function _treat_equality_initialize!(equality_handler::EnforceEquality, lcon, ucon, tol) end
function _treat_equality_initialize!(equality_handler::RelaxEquality, lcon, ucon, tol)
    return set_initial_bounds!(lcon, ucon, tol)
end
# Initiate fixed variables. By default, do nothing.
function _treat_fixed_variable_initialize!(cb::AbstractCallback, x0, lvar, uvar) end
function _treat_fixed_variable_initialize!(
    cb::DenseCallback{T, VT, VI, NLP, FH},
    x0,
    lvar,
    uvar,
)  where {T, VT, VI, NLP, FH<:MakeParameter}
    x0[cb.fixed_handler.fixed] .= lvar[cb.fixed_handler.fixed]
    lvar[cb.fixed_handler.fixed] .= -Inf
    uvar[cb.fixed_handler.fixed] .=  Inf
    return
end

function initialize!(
    cb::AbstractCallback,
    x,
    xl,
    xu,
    y0,
    rhs,
    ind_ineq;
    tol = 1e-8,
    bound_push = 1e-2,
    bound_fac = 1e-2,
)
    x0 = variable(x)
    lvar = variable(xl)
    uvar = variable(xu)

    nlp = cb.nlp
    con_buffer = cb.con_buffer
    grad_buffer = cb.grad_buffer

    x0 .= get_x0(cb)
    y0 .= get_y0(cb)
    lvar .= get_lvar(cb)
    uvar .= get_uvar(cb)
    lcon = copy(get_lcon(nlp))
    ucon = copy(get_ucon(nlp))

    _treat_equality_initialize!(cb.equality_handler, lcon, ucon, tol)
    _treat_fixed_variable_initialize!(cb, x0, lvar, uvar)

    set_initial_bounds!(lvar, uvar, tol)
    initialize_variables!(x0, lvar, uvar, bound_push, bound_fac)

    _eval_cons_wrapper!(cb, x0, con_buffer)

    slack(xl) .= view(lcon, ind_ineq)
    slack(xu) .= view(ucon, ind_ineq)
    rhs .= (lcon .== ucon) .* lcon
    copyto!(slack(x), @view(con_buffer[ind_ineq]))

    set_initial_bounds!(slack(xl), slack(xu), tol)
    initialize_variables!(slack(x), slack(xl), slack(xu), bound_push, bound_fac)
    return
end

#=
    Getters
=#

n_variables(cb::AbstractCallback) = get_nvar(cb.nlp)
n_constraints(cb::AbstractCallback) = get_ncon(cb.nlp)
get_x0(cb::AbstractCallback) = get_x0(cb.nlp)
get_y0(cb::AbstractCallback) = get_y0(cb.nlp)
get_lvar(cb::AbstractCallback) = get_lvar(cb.nlp)
get_uvar(cb::AbstractCallback) = get_uvar(cb.nlp)
# Getters to unpack solution
unpack_obj(cb::AbstractCallback, obj_val) = cb.obj_sign * obj_val ./ cb.obj_scale[]
function unpack_cons!(c_full::AbstractVector, cb::AbstractCallback, c::AbstractVector)
    c_full .= c ./ cb.con_scale
end
function unpack_x!(x_full, cb::AbstractCallback, x)
    x_full .= x
end
function unpack_z!(z_full, cb::AbstractCallback, z)
    z_full .= z ./ cb.obj_scale[]
end
function unpack_y!(y_full, cb::AbstractCallback, y)
    y_full .= (y .* cb.con_scale) .* (cb.obj_sign / cb.obj_scale[])
end

# N.B.: Special getters if we use SparseCallback with a MakeParameter fixed_handler,
# as the dimension of the problem is reduced.
function n_variables(cb::SparseCallback{T, VT, VI, NLP, FH}) where {T, VT, VI, NLP, FH<:MakeParameter}
    return length(cb.fixed_handler.free)
end
function get_x0(cb::SparseCallback{T, VT, VI, NLP, FH}) where {T, VT, VI, NLP, FH<:MakeParameter}
    free = cb.fixed_handler.free
    x0 = get_x0(cb.nlp)
    return x0[free]
end
function get_lvar(cb::SparseCallback{T, VT, VI, NLP, FH}) where {T, VT, VI, NLP, FH<:MakeParameter}
    free = cb.fixed_handler.free
    xl = get_lvar(cb.nlp)
    return xl[free]
end
function get_uvar(cb::SparseCallback{T, VT, VI, NLP, FH}) where {T, VT, VI, NLP, FH<:MakeParameter}
    free = cb.fixed_handler.free
    xu = get_uvar(cb.nlp)
    return xu[free]
end
function unpack_x!(x_full, cb::SparseCallback{T, VT, VI, NLP, FH}, x) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    x_full .= cb.fixed_handler.x_full
end
function unpack_z!(z_full, cb::SparseCallback{T, VT, VI, NLP, FH}, z) where {T, VT, VI, NLP, FH<:MakeParameter}
    free = cb.fixed_handler.free
    z_full[free] .= z ./ cb.obj_scale[]
end


function set_scaling!(
    cb::SparseCallback,
    x,
    xl,
    xu,
    y0,
    rhs,
    ind_ineq,
    nlp_scaling_max_gradient,
)
    x0 = variable(x)

    nlp = cb.nlp
    obj_scale = cb.obj_scale
    con_scale = cb.con_scale
    jac_scale = cb.jac_scale
    con_buffer = cb.con_buffer
    grad_buffer = cb.grad_buffer

    # Set scaling
    jac = similar(con_buffer, cb.nnzj)
    _eval_jac_wrapper!(cb, x0, jac)
    set_con_scale_sparse!(con_scale, cb.jac_I, jac, nlp_scaling_max_gradient)
    set_jac_scale_sparse!(jac_scale, con_scale, cb.jac_I)

    _eval_grad_f_wrapper!(cb, x0, grad_buffer)
    set_obj_scale!(obj_scale, grad_buffer, nlp_scaling_max_gradient)

    con_scale_slk = @view(con_scale[ind_ineq])
    y0 ./= con_scale
    rhs .*= con_scale
    slack(x) .*= con_scale_slk
    slack(xl) .*= con_scale_slk
    slack(xu) .*= con_scale_slk
    return
end

function set_scaling!(
    cb::DenseCallback,
    x,
    xl,
    xu,
    y0,
    rhs,
    ind_ineq,
    nlp_scaling_max_gradient,
)
    x0 = variable(x)

    nlp = cb.nlp
    obj_scale = cb.obj_scale
    con_scale = cb.con_scale
    con_buffer = cb.con_buffer
    grad_buffer = cb.grad_buffer
    # N.B.: Allocate jac_buffer here as it is use only once.
    #       GC should take care of it once the scaling has been initialized.
    jac_buffer = similar(grad_buffer, cb.ncon, cb.nvar)

    # Set scaling
    NLPModels.jac_dense!(nlp, x0, jac_buffer)
    set_con_scale_dense!(con_scale, jac_buffer, nlp_scaling_max_gradient)

    NLPModels.grad!(nlp, x0, grad_buffer)
    set_obj_scale!(obj_scale, grad_buffer, nlp_scaling_max_gradient)

    con_scale_slk = @view(con_scale[ind_ineq])
    y0 ./= con_scale
    rhs .*= con_scale
    slack(x) .*= con_scale_slk
    slack(xl) .*= con_scale_slk
    slack(xu) .*= con_scale_slk
    return
end

#=
    Callbacks: default
=#

function _eval_f_wrapper(cb::AbstractCallback, x::AbstractVector)
    return NLPModels.obj(cb.nlp, x) * cb.obj_scale[]
end

function _eval_cons_wrapper!(cb::AbstractCallback, x::AbstractVector, c::AbstractVector)
    NLPModels.cons!(cb.nlp, x, c)
    c .*= cb.con_scale
    return c
end

function _eval_grad_f_wrapper!(
    cb::AbstractCallback{T},
    x::AbstractVector,
    grad::AbstractVector,
) where {T}
    NLPModels.grad!(cb.nlp, x, grad)
    grad .*= cb.obj_scale[]
    return grad
end

function _eval_jtprod_wrapper!(
    cb::AbstractCallback,
    x::AbstractVector,
    v::AbstractVector,
    jvt::AbstractVector,
)
    y = cb.con_buffer
    y .= v .* cb.con_scale
    NLPModels.jtprod!(cb.nlp, x, y, jvt)
    return jvt
end

#=
    Callbacks: SparseCallback
=#

function _jac_sparsity_wrapper!(cb::SparseCallback, I::AbstractVector, J::AbstractVector)
    copyto!(I, cb.jac_I)
    copyto!(J, cb.jac_J)
    return
end

function _hess_sparsity_wrapper!(cb::SparseCallback, I::AbstractVector, J::AbstractVector)
    copyto!(I, cb.hess_I)
    copyto!(J, cb.hess_J)
    return
end

function _eval_jac_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    jac::AbstractVector,
) where {T, VT, VI, NLP, FH}
    NLPModels.jac_coord!(cb.nlp, x, jac)
    jac .*= cb.jac_scale
    return jac
end

function _eval_jac_wrapper!(
    cb::SparseCallback{T},
    x::AbstractVector,
    jac::AbstractMatrix,
) where {T}
    jac_buffer = view(cb.jac_buffer, 1:cb.nnzj)
    _eval_jac_wrapper!(cb, x, jac_buffer)
    fill!(jac, zero(T))
    @inbounds @simd for k in 1:length(cb.jac_I)
        i, j = cb.jac_I[k], cb.jac_J[k]
        jac[i, j] += jac_buffer[k]
    end
    return jac
end

function _eval_lag_hess_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    y::AbstractVector,
    hess::AbstractVector;
    obj_weight = 1.0,
) where {T, VT, VI, NLP, FH}
    cb.con_buffer .= y .* cb.con_scale
    nnzh_orig = get_nnzh(cb.nlp.meta)
    NLPModels.hess_coord!(
        cb.nlp,
        x,
        cb.con_buffer,
        view(hess, 1:nnzh_orig);
        obj_weight = obj_weight * cb.obj_scale[],
    )
    return hess
end

function _eval_lag_hess_wrapper!(
    cb::SparseCallback{T},
    x::AbstractVector,
    y::AbstractVector,
    hess::AbstractMatrix;
    obj_weight = one(T),
) where {T}
    hess_buffer = view(cb.hess_buffer, 1:cb.nnzh)
    _eval_lag_hess_wrapper!(cb, x, y, hess_buffer; obj_weight = obj_weight * cb.obj_scale[])
    fill!(hess, zero(T))
    @inbounds @simd for k in 1:length(cb.hess_I)
        i, j = cb.hess_I[k], cb.hess_J[k]
        hess[i, j] += hess_buffer[k]
        if i != j
            hess[j, i] += hess_buffer[k]
        end
    end
    return hess
end

#=
    Callback: DenseCallback
=#

function _eval_jac_wrapper!(
    cb::DenseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    jac::AbstractMatrix,
) where {T, VT, VI, NLP, FH}
    NLPModels.jac_dense!(cb.nlp, x, jac)
    jac .*= cb.con_scale
    return jac
end

function _eval_lag_hess_wrapper!(
    cb::DenseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    y::AbstractVector,
    hess::AbstractMatrix;
    obj_weight = one(T),
) where {T, VT, VI, NLP, FH}
    NLPModels.hess_dense!(cb.nlp, x, y, hess; obj_weight = obj_weight * cb.obj_scale[])
    return hess
end

#=
    Callback for SparseCallback+MakeParameter
=#

function _update_x!(fixed_handler::MakeParameter, x::AbstractVector)
    idx = norm(x, 2)
    if fixed_handler.hash_x[] == idx
        return
    end
    fixed_handler.hash_x[] = idx
    # Update x_full
    free = fixed_handler.free
    fixed_handler.x_full[free] .= x
    return
end

function _eval_f_wrapper(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    x_full = cb.fixed_handler.x_full
    return NLPModels.obj(cb.nlp, x_full) * cb.obj_scale[]
end

function _eval_cons_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    c::AbstractVector,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    x_full = cb.fixed_handler.x_full
    NLPModels.cons!(cb.nlp, x_full, c)
    c .*= cb.con_scale
    return c
end

function _eval_grad_f_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    grad::AbstractVector,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    x_full = cb.fixed_handler.x_full
    g_full = cb.fixed_handler.g_full
    NLPModels.grad!(cb.nlp, x_full, g_full)
    grad .= g_full[cb.fixed_handler.free]
    grad .*= cb.obj_scale[]
    return grad
end

function _eval_jac_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    jac::AbstractVector,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    nnzj_orig = get_nnzj(cb.nlp.meta)
    jac_full = cb.jac_buffer
    x_full = cb.fixed_handler.x_full
    @assert length(jac_full) == nnzj_orig
    NLPModels.jac_coord!(cb.nlp, x_full, jac_full)
    jac .= jac_full[cb.fixed_handler.ind_jac_free]
    jac .*= cb.jac_scale
    return jac
end

function _eval_jtprod_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    v::AbstractVector,
    jvt::AbstractVector,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    x_full = cb.fixed_handler.x_full
    jvt_full = cb.fixed_handler.g_full
    y = cb.con_buffer
    y .= v .* cb.con_scale
    NLPModels.jtprod!(cb.nlp, x_full, y, jvt_full)
    jvt .= jvt_full[cb.fixed_handler.free]
    return jvt
end

function _eval_lag_hess_wrapper!(
    cb::SparseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    y::AbstractVector,
    hess::AbstractVector;
    obj_weight = 1.0,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    _update_x!(cb.fixed_handler, x)
    x_full = cb.fixed_handler.x_full
    nnzh_orig = get_nnzh(cb.nlp.meta)
    hess_full = cb.hess_buffer
    @assert length(hess_full) == nnzh_orig
    cb.con_buffer .= y .* cb.con_scale
    NLPModels.hess_coord!(
        cb.nlp,
        x_full,
        cb.con_buffer,
        hess_full;
        obj_weight = obj_weight * cb.obj_scale[],
    )
    hess .= hess_full[cb.fixed_handler.ind_hess_free]
    return hess
end

#=
    Callback for DenseCallback+MakeParameter
=#

function _eval_grad_f_wrapper!(
    cb::DenseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    grad::AbstractVector,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    NLPModels.grad!(cb.nlp, x, grad)
    grad .*= cb.obj_scale[]
    map!(
         (x, y) -> x - y,
         @view(grad[cb.fixed_handler.fixed]),
         @view(x[cb.fixed_handler.fixed]),
         @view(get_lvar(cb.nlp)[cb.fixed_handler.fixed])
    )
    return grad
end

function _eval_jac_wrapper!(
    cb::DenseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    jac::AbstractMatrix,
) where {T, VT, VI, NLP, FH<:MakeParameter}
    NLPModels.jac_dense!(cb.nlp, x, jac)
    jac .*= cb.con_scale
    return jac[:, cb.fixed_handler.fixed] .= zero(T)
end

function _eval_lag_hess_wrapper!(
    cb::DenseCallback{T, VT, VI, NLP, FH},
    x::AbstractVector,
    y::AbstractVector,
    hess::AbstractMatrix;
    obj_weight = one(T),
) where {T, VT, VI, NLP, FH<:MakeParameter}
    NLPModels.hess_dense!(cb.nlp, x, y, hess; obj_weight = obj_weight * cb.obj_scale[])
    fixed = cb.fixed_handler.fixed
    hess[:, fixed] .= zero(T)
    hess[fixed, :] .= zero(T)
    _set_diag!(hess, fixed, one(T))
    return hess
end

#=
    Compute bounds' multipliers for fixed variables

    At a KKT solution, we have:

    Min problem:
    ∇f + ∇cᵀ y - zl + zu = 0 , (zl, zu) >= 0

    Max problem:
    ∇f + ∇cᵀ y + zl - zu = 0 , (zl, zu) >= 0
=#

# N.B.: by default do nothing as the bounds' multipliers are computed by the algorithm
function update_z!(cb, x, y, zl, zu, jacl) end

function update_z!(cb::AbstractCallback{T, VT, FH}, x, y, zl, zu, jacl) where {T, VT, FH<:MakeParameter}
    fixed_handler = cb.fixed_handler::MakeParameter
    ind_fixed = fixed_handler.fixed
    g_full = fixed_handler.g_full
    jtv = similar(g_full) ; fill!(jtv, zero(T))
    NLPModels.grad!(cb.nlp, x, g_full)       # ∇f
    NLPModels.jtprod!(cb.nlp, x, y, jtv)     # ∇cᵀ y
    g_full .+= jtv                           # ∇f + ∇cᵀ y
    g_fixed = view(g_full, ind_fixed)
    zl[ind_fixed] .= max.(zero(T), cb.obj_sign .* g_fixed)
    zu[ind_fixed] .= max.(zero(T), .-cb.obj_sign .* g_fixed)
    return
end

function _set_diag!(A, inds, a)
    @inbounds @simd for i in inds
        A[i, i] = a
    end
end

cuda_testset = [
    # Temporarily commented out since LapackCUDASolver does not currently support sparse callbacks
    [
        "CUDSS",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR
        ),
        [],
    ],
    [
        "CUDSS-AMD",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_ordering=MadNLPGPU.AMD_ORDERING,
        ),
        [],
    ],
    [
        "CUDSS-SYMAMD",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_ordering=MadNLPGPU.SYMAMD_ORDERING,
        ),
        [],
    ],
    [
        "CUDSS-COLAMD",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_ordering=MadNLPGPU.COLAMD_ORDERING,
        ),
        [],
    ],
    [
        "CUDSS-METIS",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_ordering=MadNLPGPU.METIS_ORDERING,
        ),
        [],
    ],
    [
        "CUDSS-IR",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_ir=1,
        ),
        [],
    ],
    [
        "CUDSS-HYBRID",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_hybrid_memory=true,
        ),
        [],
    ],
    [
        "CUDSS-NOPIVOTING",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.CUDSSSolver,
            print_level=MadNLP.ERROR,
            cudss_pivoting=false,
        ),
        [],
    ],
    # [
    #     "Formulation K2",
    #     ()->MadNLP.Optimizer(
    #         linear_solver=CUDSSSolver,
    #         print_level=MadNLP.ERROR,
    #         kkt_system=MadNLP.SparseKKTSystem,
    #     ),
    #     [],
    # ],
    # [
    #     "Formulation K2.5",
    #     ()->MadNLP.Optimizer(
    #         linear_solver=CUDSSSolver,
    #         print_level=MadNLP.ERROR,
    #         kkt_system=MadNLP.ScaledSparseKKTSystem,
    #     ),
    #     [],
    # ],
    [
        "LapackGPU-BUNCHKAUFMAN",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackCUDASolver,
            lapack_algorithm=MadNLP.BUNCHKAUFMAN,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackGPU-LU",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackCUDASolver,
            lapack_algorithm=MadNLP.LU,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackGPU-QR",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackCUDASolver,
            lapack_algorithm=MadNLP.QR,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackGPU-EVD",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackCUDASolver,
            lapack_algorithm=MadNLP.EVD,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackGPU-CHOLESKY",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackCUDASolver,
            lapack_algorithm=MadNLP.CHOLESKY,
            print_level=MadNLP.ERROR,
        ),
        ["infeasible", "lootsma", "eigmina", "lp_examodels_issue75"], # KKT system not PD
    ],
]

rocm_testset = [
    [
        "LapackROCmSolver-LU",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackROCmSolver,
            lapack_algorithm=MadNLP.LU,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackROCmSolver-QR",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackROCmSolver,
            lapack_algorithm=MadNLP.QR,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackROCmSolver-EVD",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackROCmSolver,
            lapack_algorithm=MadNLP.EVD,
            print_level=MadNLP.ERROR,
        ),
        [],
    ],
    [
        "LapackROCmSolver-CHOLESKY",
        ()->MadNLP.Optimizer(
            linear_solver = MadNLPGPU.LapackROCmSolver,
            lapack_algorithm=MadNLP.CHOLESKY,
            print_level=MadNLP.ERROR,
        ),
        ["infeasible", "lootsma", "eigmina", "lp_examodels_issue75"], # KKT system not PD
    ],
]

@testset "MadNLPGPU test" begin
    if HAS_CUDA && CUDA.functional()
        MadNLPTests.test_linear_solver(MadNLPGPU.LapackCUDASolver, Float32)
        MadNLPTests.test_linear_solver(MadNLPGPU.LapackCUDASolver, Float64)
        # Test LapackGPU wrapper
        for (name,optimizer_constructor,exclude) in cuda_testset
            test_madnlp(name,optimizer_constructor,exclude; Arr=CuArray)
        end
    end
    if HAS_AMDGPU && AMDGPU.functional()
        MadNLPTests.test_linear_solver(MadNLPGPU.LapackROCmSolver, Float32)
        MadNLPTests.test_linear_solver(MadNLPGPU.LapackROCmSolver, Float64)
        for (name,optimizer_constructor,exclude) in rocm_testset
            test_madnlp(name,optimizer_constructor,exclude; Arr=ROCArray)
        end
    end
end

@kwdef mutable struct Ma86Options <: AbstractOptions
    ma86_num_threads::Int = 1
    ma86_print_level::Float64 = -1
    ma86_nemin::Int = 32
    ma86_order::Ordering = METIS
    ma86_scaling::Scaling = SCALING_NONE
    ma86_small::Float64 = 1e-20
    ma86_static::Float64 = 0.0
    ma86_u::Float64 = 1e-8
    ma86_umax::Float64 = 1e-4
end

mutable struct Ma86Solver{T,INT} <: AbstractLinearSolver{T}
    csc::SparseMatrixCSC{T,INT}

    control::Ma86Control{T,INT}
    info::Ma86Info{T,INT}

    mc68_control::Mc68Control{INT}
    mc68_info::Mc68Info{INT}

    order::Vector{INT}
    keep::Vector{Ptr{Cvoid}}

    opt::Ma86Options
    logger::MadNLPLogger
end

ma86_set_num_threads(n) = HSL.omp_set_num_threads(n)

function Ma86Solver(
    csc::SparseMatrixCSC{T,INT};
    opt = Ma86Options(),
    logger = MadNLPLogger(),
) where {T,INT}

    ma86_set_num_threads(opt.ma86_num_threads)

    order = Vector{INT}(undef, csc.n)

    mc68info = Mc68Info{INT}()
    mc68control = Mc68Control{INT}()
    HSL.mc68_default_control(INT, mc68control)

    keep = [C_NULL]

    mc68control.f_array_in = 1
    mc68control.f_array_out = 1
    HSL.mc68_order(
        INT,
        INT(opt.ma86_order),
        INT(csc.n),
        csc.colptr,
        csc.rowval,
        order,
        mc68control,
        mc68info,
    )

    info = Ma86Info{T,INT}()
    control = Ma86Control{T,INT}()
    HSL.ma86_default_control(T, INT, control)
    control.diagnostics_level = INT(opt.ma86_print_level)
    control.f_arrays = 1
    control.nemin = opt.ma86_nemin
    control.small_ = opt.ma86_small
    control.u = opt.ma86_u
    control.scaling = INT(opt.ma86_scaling)

    HSL.ma86_analyse(T, INT, INT(csc.n), csc.colptr, csc.rowval, order, keep, control, info)
    info.flag < 0 && throw(SymbolicException())

    M = Ma86Solver{T,INT}(
        csc,
        control,
        info,
        mc68control,
        mc68info,
        order,
        keep,
        opt,
        logger,
    )
    finalizer(finalize, M)

    return M
end
function factorize!(M::Ma86Solver{T,INT}) where {T,INT}
    HSL.ma86_factor(
        T,
        INT,
        INT(M.csc.n),
        M.csc.colptr,
        M.csc.rowval,
        M.csc.nzval,
        M.order,
        M.keep,
        M.control,
        M.info,
        C_NULL,
    )
    M.info.flag < 0 && throw(FactorizationException())
    return M
end
function solve_linear_system!(M::Ma86Solver{T,INT}, rhs::Vector{T}) where {T,INT}
    HSL.ma86_solve(
        T,
        INT,
        INT(0),
        INT(1),
        INT(M.csc.n),
        rhs,
        M.order,
        M.keep,
        M.control,
        M.info,
        C_NULL,
    )
    M.info.flag < 0 && throw(SolveException())
    return rhs
end
is_inertia(::Ma86Solver) = true
function inertia(M::Ma86Solver)
    return (
        M.info.matrix_rank - M.info.num_neg,
        M.csc.n - M.info.matrix_rank,
        M.info.num_neg,
    )
end

function finalize(M::Ma86Solver{T,INT}) where {T,INT}
    HSL.ma86_finalise(T, INT, M.keep, M.control)
end

function improve!(M::Ma86Solver)
    if M.control.u == M.opt.ma86_umax
        @debug(M.logger, "improve quality failed.")
        return false
    end
    M.control.u = min(M.opt.ma86_umax, M.control.u^0.75)
    @debug(M.logger, "improved quality: pivtol = $(M.control.u)")
    return true
end
introduce(::Ma86Solver) = "ma86 v$(HSL.HSL_MA86_version())"
input_type(::Type{Ma86Solver}) = :csc
default_options(::Type{Ma86Solver}) = Ma86Options()
is_supported(::Type{Ma86Solver}, ::Type{T}) where T <: AbstractFloat = HSL.is_supported(Val(:hsl_ma86), T)

@kwdef mutable struct RichardsonOptions <: AbstractOptions
    richardson_max_iter::Int = 10
    richardson_tol::Float64
    richardson_acceptable_tol::Float64
end

struct RichardsonIterator{T, KKT <: AbstractKKTSystem{T}} <: AbstractIterator{T}
    kkt::KKT
    opt::RichardsonOptions
    cnt::MadNLPCounters
    logger::MadNLPLogger
end

function RichardsonIterator(
    kkt;
    opt = RichardsonOptions(),
    logger = MadNLPLogger(),
    cnt = MadNLPCounters()
)
    return RichardsonIterator(
        kkt, opt, cnt, logger
    )
end

default_options(::Type{RichardsonIterator}, tol) = RichardsonOptions(richardson_tol=tol^(5/4), richardson_acceptable_tol=tol^(5/8))

function solve_refine!(
    x::VT,
    iterator::R,
    b::VT,
    w::VT
    ) where {T, VT, R <: RichardsonIterator{T}}
    @debug(iterator.logger, "Iterative solver initiated")

    norm_b = norm(full(b), Inf)
    residual_ratio = zero(T)

    fill!(full(x), zero(T))

    if norm_b != zero(T)
        copyto!(full(w), full(b))
        iterator.cnt.ir = 0

        while true
            solve_kkt!(iterator.kkt, w)
            axpy!(1., full(w), full(x))
            copyto!(full(w), full(b))

            mul!(w, iterator.kkt, x, -one(T), one(T))

            norm_w = norm(full(w), Inf)
            norm_x = norm(full(x), Inf)
            residual_ratio = norm_w / (min(norm_x, 1e6 * norm_b) + norm_b)

            if mod(iterator.cnt.ir, 10)==0
                @debug(iterator.logger,"iterator.cnt.ir ||res||")
            end
            @debug(iterator.logger, @sprintf("%4i %6.2e", iterator.cnt.ir, residual_ratio))
            iterator.cnt.ir += 1

            if (iterator.cnt.ir >= iterator.opt.richardson_max_iter) || (residual_ratio < iterator.opt.richardson_tol)
                break
            end
        end
    end

    @debug(
        iterator.logger,
        @sprintf(
            "Iterative solver terminated with %4i refinement steps and residual = %6.2e",
            iterator.cnt.ir, residual_ratio
        ),
    )

    return residual_ratio < iterator.opt.richardson_acceptable_tol
end

# API for getting internal members of IPM
# The idea here is that a subtype of AbstractMadNLPSolver may specialize
# some or all of these and the core functionality of the IPM in MadNLP
# should function as normal.

# getters for all fields
for (k, attribute) in enumerate(fieldnames(MadNLPSolver))
    fname = "get_$(attribute)"
    @eval begin
        @inline function $(Symbol(fname))(solver::MadNLPSolver)
            return getfield(solver, $k)
        end
    end
end

# Necessary Mutators
for (k, (attribute, type)) in enumerate(zip(fieldnames(MadNLPSolver), fieldtypes(MadNLPSolver)))
    # These types shouldn't ever be set by value so we ignore them.
    if type <: Union{AbstractVector,
                     PrimalVector,
                     AbstractKKTVector,
                     MadNLPOptions,
                     MadNLPCounters,
                     MadNLPLogger,
                     AbstractKKTSystem,
                     AbstractNLPModel,
                     AbstractCallback,
                     AbstractIterator,
                     AbstractInertiaCorrector}
      continue
    end
    fname = "set_$(attribute)!"
    @eval begin
        @inline function $(Symbol(fname))(solver::MadNLPSolver, rhs)
            return setfield!(solver, $k, rhs)
        end
    end
end

# Computed quantities
# TODO(@anton) I now think these would be useful to have, but which quantities are wrapped this way is a good question
get_theta(solver::AbstractMadNLPSolver) = get_theta(get_c(solver))
get_varphi(solver::AbstractMadNLPSolver) = get_varphi(get_obj_val(solver), get_x_lr(solver), get_xl_r(solver), get_xu_r(solver), get_x_ur(solver), get_mu(solver))
get_kkt_error(solver::AbstractMadNLPSolver) = max(get_inf_pr(solver), get_inf_du(solver), get_inf_compl(solver))
get_inf_compl(solver::AbstractMadNLPSolver{T}, sc::T; mu=get_mu(solver)) where {T} = get_inf_compl(get_x_lr(solver),get_xl_r(solver),get_zl_r(solver),get_xu_r(solver),get_x_ur(solver),get_zu_r(solver), mu, sc)
get_inf_barrier(solver::AbstractMadNLPSolver) = max(get_inf_pr(solver),get_inf_du(solver),get_inf_compl_mu(solver))
get_inf_total(solver::AbstractMadNLPSolver) = max(get_inf_pr(solver),get_inf_du(solver),get_inf_compl(solver))

"""
    SparseCondensedKKTSystem{T, VT, MT, QN} <: AbstractCondensedKKTSystem{T, VT, MT, QN}

Implement the [`AbstractCondensedKKTSystem`](@ref) in sparse COO format.

"""
struct SparseCondensedKKTSystem{T, VT, MT, QN, LS, VI, VI32, VTu1, VTu2, EXT} <: AbstractCondensedKKTSystem{T, VT, MT, QN}
    # Hessian
    hess::VT
    hess_raw::SparseMatrixCOO{T, Int32, VT, VI32}
    hess_com::MT
    hess_csc_map::Union{Nothing, VI}

    # Jacobian
    jac::VT
    jt_coo::SparseMatrixCOO{T, Int32, VT, VI32}
    jt_csc::MT
    jt_csc_map::Union{Nothing, VI}

    quasi_newton::QN
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT

    # buffer
    buffer::VT
    buffer2::VT

    # Augmented system
    aug_com::MT

    # slack diagonal buffer
    diag_buffer::VT
    dptr::VTu1
    hptr::VTu1
    jptr::VTu2

    # LinearSolver
    linear_solver::LS

    # Info
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI

    # extra
    ext::EXT
end

function create_kkt_system(
    ::Type{SparseCondensedKKTSystem},
    cb::SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
) where {T, VT}
    ind_ineq = cb.ind_ineq
    n = cb.nvar
    m = cb.ncon
    n_slack = length(ind_ineq)

    if n_slack != m
        error("SparseCondensedKKTSystem does not support equality constrained NLPs.")
    end

    # Evaluate sparsity pattern
    jac_sparsity_I = create_array(cb, Int32, cb.nnzj)
    jac_sparsity_J = create_array(cb, Int32, cb.nnzj)
    _jac_sparsity_wrapper!(cb,jac_sparsity_I, jac_sparsity_J)

    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)
    hess_sparsity_I, hess_sparsity_J = build_hessian_structure(cb, hessian_approximation)

    force_lower_triangular!(hess_sparsity_I,hess_sparsity_J)

    n_jac = length(jac_sparsity_I)
    n_hess = length(hess_sparsity_I)
    n_tot = n + n_slack
    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)


    reg = VT(undef, n_tot)
    pr_diag = VT(undef, n_tot)
    du_diag = VT(undef, m)
    l_diag = VT(undef, nlb)
    u_diag = VT(undef, nub)
    l_lower = VT(undef, nlb)
    u_lower = VT(undef, nub)
    buffer = VT(undef, m)
    buffer2 = VT(undef, m)
    hess = VT(undef, n_hess)
    jac = VT(undef, n_jac)
    diag_buffer = VT(undef, m)
    fill!(jac, zero(T))

    hess_raw = SparseMatrixCOO(n, n, hess_sparsity_I, hess_sparsity_J, hess)
    jt_coo = SparseMatrixCOO(
        n, m,
        jac_sparsity_J,
        jac_sparsity_I,
        jac,
    )

    jt_csc, jt_csc_map = coo_to_csc(jt_coo)
    hess_com, hess_csc_map = coo_to_csc(hess_raw)

    aug_com, dptr, hptr, jptr = build_condensed_aug_symbolic(
        hess_com,
        jt_csc
    )

    _linear_solver = linear_solver(aug_com; opt = opt_linear_solver)
    ext = get_sparse_condensed_ext(VT, hess_com, jptr, jt_csc_map, hess_csc_map)
    return SparseCondensedKKTSystem(
        hess, hess_raw, hess_com, hess_csc_map,
        jac, jt_coo, jt_csc, jt_csc_map,
        quasi_newton,
        reg, pr_diag, du_diag,
        l_diag, u_diag, l_lower, u_lower,
        buffer, buffer2,
        aug_com, diag_buffer, dptr, hptr, jptr,
        _linear_solver,
        ind_ineq, cb.ind_lb, cb.ind_ub,
        ext
    )
end

get_sparse_condensed_ext(::Type{Vector{T}},args...) where T = nothing

num_variables(kkt::SparseCondensedKKTSystem) = length(kkt.pr_diag)
function is_inertia_correct(kkt::SparseCondensedKKTSystem, num_pos, num_zero, num_neg)
    return (num_zero == 0) && (num_pos == size(kkt.aug_com, 1))
end
should_regularize_dual(kkt::SparseCondensedKKTSystem, num_pos, num_zero, num_neg) = true

Base.size(kkt::SparseCondensedKKTSystem,n::Int) = size(kkt.aug_com,n)

function compress_jacobian!(kkt::SparseCondensedKKTSystem{T, VT, MT}) where {T, VT, MT<:SparseMatrixCSC{T, Int32}}
    ns = length(kkt.ind_ineq)
    transfer!(kkt.jt_csc, kkt.jt_coo, kkt.jt_csc_map)
end

function jtprod!(y::AbstractVector, kkt::SparseCondensedKKTSystem, x::AbstractVector)
    n = size(kkt.hess_com, 1)
    m = size(kkt.jt_csc, 2)

    mul!(view(y, 1:n), kkt.jt_csc, x)
    y[size(kkt.jt_csc,1)+1:end] .= -x
end

function _sym_length(Jt)
    len = 0
    for i=1:size(Jt,2)
        n = Jt.colptr[i+1] - Jt.colptr[i]
        len += div(n^2 + n, 2)
    end
    return len
end

function _build_condensed_aug_symbolic_hess(H, sym, sym2)
    for i in 1:size(H,2)
        for j in H.colptr[i]:H.colptr[i+1]-1
            c = H.rowval[j]
            sym[j] = (0,j,0)
            sym2[j] = (c,i)
        end
    end
end

function _build_condensed_aug_symbolic_jt(Jt, sym, sym2)

    cnt = 0
    for i in 1:size(Jt,2)
        for j in Jt.colptr[i]:Jt.colptr[i+1]-1
            for k in j:Jt.colptr[i+1]-1
                c1 = Jt.rowval[j]
                c2 = Jt.rowval[k]
                sym[cnt+=1] = (i,j,k)
                sym2[cnt] = (c2,c1)
            end
        end
    end
end

function getptr(array; by = (x,y)->x != y)
    bitarray = similar(array, Bool, length(array)+1)
    fill!(bitarray, true)
    bitarray[2:end-1] .= by.(@view(array[1:end-1]),  @view(array[2:end]))
    findall(bitarray)
end

nzval(H) = H.nzval

@inbounds function build_condensed_aug_symbolic(H::AbstractSparseMatrix{Tv,Ti}, Jt) where {Tv, Ti}
    nnzjtsj = _sym_length(Jt)

    sym = similar(nzval(H), Tuple{Int,Int,Int},
        size(H,2) + nnz(H) + nnzjtsj
    )
    sym2 = similar(nzval(H), Tuple{Int,Int},
        size(H,2) + nnz(H) + nnzjtsj
    )
    dptr = similar(nzval(H), Tuple{Ti,Ti},
        size(H,2)
    )
    hptr = similar(nzval(H), Tuple{Ti,Ti},
        nnz(H)
    )
    jptr = similar(nzval(H), Tuple{Ti,Tuple{Ti,Ti,Ti}},
        nnzjtsj
    )
    colptr = fill!(
        similar(nzval(H), Ti, size(H,1)+1),
        one(Tv)
    )

    n = size(H,2)

    # N.B.: we should ensure that zind is allocated on the proper device.
    zind = similar(nzval(H), Int, size(H, 2))
    zind .= 1:size(H, 2)
    map!(
        i->(-1,i,0),
        @view(sym[1:n]),
        zind,
    )
    map!(
        i->(i,i),
        @view(sym2[1:n]),
        zind,
    )

    _build_condensed_aug_symbolic_hess(
        H,
        @view(sym[n+1:n+nnz(H)]),
        @view(sym2[n+1:n+nnz(H)])
    )
    _build_condensed_aug_symbolic_jt(
        Jt,
        @view(sym[n+nnz(H)+1:n+nnz(H) + nnzjtsj]),
        @view(sym2[n+nnz(H)+1:n+nnz(H)+nnzjtsj])
    )

    p = sortperm(sym2; by = ((i,j),) -> (j,i))
    permute!(sym, p)
    permute!(sym2, p)

    by(x,y) = x != y

    bitarray = similar(sym2, Bool, length(sym2))
    fill!(bitarray, true)
    bitarray[2:end] .= by.(@view(sym2[1:end-1]),  @view(sym2[2:end]))
    guide = cumsum(bitarray)

    b = findall(x->x[1] == -1, sym)
    dptr = map((x,y)->(Int32(x),Int32(y[2])), @view(guide[b]), @view(sym[b]))

    b = findall(x->x[1] == 0, sym)
    hptr = map((x,y)->(Int32(x),Int32(y[2])), @view(guide[b]), @view(sym[b]))

    b = findall(x->x[1] != -1 && x[1] != 0, sym)
    jptr = map((x,y)->(Int32(x),y), @view(guide[b]), @view(sym[b]))


    ptr = findall(bitarray)
    rowval = map(((row,col),)->Int32(row), @view(sym2[ptr]))

    by2(x,y) = x[2] != y[2]
    bitarray[2:end] .= by2.(@view(sym2[1:end-1]),  @view(sym2[2:end]))
    ptr2 = findall(bitarray)

    first, last = _first_and_last_col(sym2,ptr2)

    fill!(
        @view(colptr[1:first]),
        1
    )

    _set_colptr!(colptr, ptr2, sym2, guide)

    fill!(
        @view(colptr[last+1:end]),
        length(ptr)+1
    )

    aug_com = _get_sparse_csc(
        size(H),
        colptr,
        rowval,
        similar(nzval(H), length(ptr))
    )

    return aug_com, dptr, hptr, jptr
end

function _get_sparse_csc(dims, colptr, rowval, nzval)
    SparseMatrixCSC(
        dims...,
        colptr,
        rowval,
        nzval
    )
end

function _first_and_last_col(sym2,ptr2)
    first= sym2[1][2]
    last = sym2[ptr2[end]][2]
    return (first, last)
end

function _set_colptr!(colptr, ptr2, sym2, guide)
    for i in @view(ptr2[2:end])

        (~,prevcol) = sym2[i-1]
        (row,col) = sym2[i]

        fill!(@view(colptr[prevcol+1:col]), guide[i])
    end
end

@inbounds function _build_condensed_aug_coord!(aug_com::SparseMatrixCSC{Tv,Ti}, pr_diag, H, Jt, diag_buffer, dptr, hptr, jptr) where {Tv, Ti}
    fill!(aug_com.nzval, zero(Tv))

    @simd for idx in eachindex(hptr)
        i,j = hptr[idx]
        aug_com.nzval[i] += H.nzval[j]
    end

    @simd for idx in eachindex(dptr)
        i,j = dptr[idx]
        aug_com.nzval[i] += pr_diag[j]
    end

    @simd for idx in eachindex(jptr)
        (i,(j,k,l)) = jptr[idx]
        aug_com.nzval[i] += diag_buffer[j] * Jt.nzval[k] * Jt.nzval[l]
    end
end

function build_condensed_aug_coord!(kkt::AbstractCondensedKKTSystem{T,VT,MT}) where {T, VT, MT <: SparseMatrixCSC{T}}
    _build_condensed_aug_coord!(
        kkt.aug_com, kkt.pr_diag, kkt.hess_com, kkt.jt_csc, kkt.diag_buffer,
        kkt.dptr, kkt.hptr, kkt.jptr
    )
end

function build_kkt!(kkt::SparseCondensedKKTSystem)

    n = size(kkt.hess_com, 1)
    m = size(kkt.jt_csc, 2)


    Σx = view(kkt.pr_diag, 1:n)
    Σs = view(kkt.pr_diag, n+1:n+m)
    Σd = kkt.du_diag

    kkt.diag_buffer .= Σs ./ ( 1 .- Σd .* Σs)
    build_condensed_aug_coord!(kkt)
end

get_jacobian(kkt::SparseCondensedKKTSystem) = kkt.jac

# MadNLP.jl
# Created by Sungho Shin (sungho.shin@wisc.edu)

# Options
@enum(LogLevels::Int,
      TRACE  = 1,
      DEBUG  = 2,
      INFO   = 3,
      NOTICE = 4,
      WARN   = 5,
      ERROR  = 6)

@enum(BFGSInitStrategy::Int,
      SCALAR1  = 1,
      SCALAR2  = 2,
      SCALAR3  = 3,
      SCALAR4  = 4,
      CONSTANT = 5,
)

@enum(Status::Int,
      SOLVE_SUCCEEDED = 1,
      SOLVED_TO_ACCEPTABLE_LEVEL = 2,
      SEARCH_DIRECTION_BECOMES_TOO_SMALL = 3,
      DIVERGING_ITERATES = 4,
      INFEASIBLE_PROBLEM_DETECTED = 5,
      MAXIMUM_ITERATIONS_EXCEEDED = 6,
      MAXIMUM_WALLTIME_EXCEEDED = 7,
      INITIAL = 11,
      REGULAR = 12,
      RESTORE = 13,
      ROBUST  = 14,
      LINESEARCH_SUCCEEDED = 15,
      RESTORATION_FAILED = -1,
      INVALID_NUMBER_DETECTED = -2,
      ERROR_IN_STEP_COMPUTATION = -3,
      NOT_ENOUGH_DEGREES_OF_FREEDOM = -4,
      USER_REQUESTED_STOP = -5,
      INTERNAL_ERROR = -6,
      INVALID_NUMBER_OBJECTIVE = -7,
      INVALID_NUMBER_GRADIENT = -8,
      INVALID_NUMBER_CONSTRAINTS = -9,
      INVALID_NUMBER_JACOBIAN = -10,
      INVALID_NUMBER_HESSIAN_LAGRANGIAN = -11,
)

function get_status_output(status, opt)
    if status == SOLVE_SUCCEEDED
        return @sprintf "Optimal Solution Found (tol = %5.1e)." opt.tol
    elseif status == SOLVED_TO_ACCEPTABLE_LEVEL
        return @sprintf "Solved To Acceptable Level (tol = %5.1e)." opt.acceptable_tol
    elseif status == SEARCH_DIRECTION_BECOMES_TOO_SMALL
        return "Search Direction is becoming Too Small."
    elseif status == DIVERGING_ITERATES
        return "Iterates diverging; problem might be unbounded."
    elseif status == MAXIMUM_ITERATIONS_EXCEEDED
        return "Maximum Number of Iterations Exceeded."
    elseif status == MAXIMUM_WALLTIME_EXCEEDED
        return "Maximum wall-clock Time Exceeded."
    elseif status == RESTORATION_FAILED
        return "Restoration Failed"
    elseif status == INFEASIBLE_PROBLEM_DETECTED
        return "Converged to a point of local infeasibility. Problem may be infeasible."
    elseif status == INVALID_NUMBER_DETECTED
        return "Invalid number in NLP function or derivative detected."
    elseif status == ERROR_IN_STEP_COMPUTATION
        return "Error in step computation."
    elseif status == NOT_ENOUGH_DEGREES_OF_FREEDOM
        return "Problem has too few degrees of freedom."
    elseif status == USER_REQUESTED_STOP
        return "Stopping optimization at current point as requested by user."
    elseif status == INTERNAL_ERROR
        return "Internal Error."
    elseif status == INVALID_NUMBER_OBJECTIVE
        return "Invalid number in NLP objective function detected."
    elseif status == INVALID_NUMBER_GRADIENT
        return "Invalid number in NLP objective gradient detected."
    elseif status == INVALID_NUMBER_CONSTRAINTS
        return "Invalid number in NLP constraint function detected."
    elseif status == INVALID_NUMBER_JACOBIAN
        return "Invalid number in NLP constraint Jacobian detected."
    elseif status == INVALID_NUMBER_HESSIAN_LAGRANGIAN
        return "Invalid number in NLP Hessian Lagrangian detected."
    else
        error("status code is not valid")
    end
end

testset = [
    [
        "SparseKKTSystem + Mumps",
        ()->MadNLP.Optimizer(
            linear_solver=MadNLP.MumpsSolver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "SparseKKTSystem + Umfpack",
        ()->MadNLP.Optimizer(
            linear_solver=MadNLP.UmfpackSolver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "SparseKKTSystem + InertiaFree",
        ()->MadNLP.Optimizer(
            inertia_correction_method=MadNLP.InertiaFree,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "SparseKKTSystem + RelaxBound",
        ()->MadNLP.Optimizer(
            fixed_variable_treatment=MadNLP.RelaxBound,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "ScaledSparseKKTSystem + LapackCPU",
        ()->MadNLP.Optimizer(
            linear_solver=MadNLP.LapackCPUSolver,
            kkt_system=MadNLP.ScaledSparseKKTSystem,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "DenseKKTSystem + LapackCPU-BUNCHKAUFMAN",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.DenseKKTSystem,
            linear_solver=MadNLP.LapackCPUSolver,
            lapack_algorithm=MadNLP.BUNCHKAUFMAN,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "DenseKKTSystem + LapackCPU-LU",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.DenseKKTSystem,
            linear_solver=MadNLP.LapackCPUSolver,
            lapack_algorithm=MadNLP.LU,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "DenseKKTSystem + LapackCPU-QR",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.DenseKKTSystem,
            linear_solver=MadNLP.LapackCPUSolver,
            lapack_algorithm=MadNLP.QR,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "DenseKKTSystem + LapackCPU-EVD",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.DenseKKTSystem,
            linear_solver=MadNLP.LapackCPUSolver,
            lapack_algorithm=MadNLP.EVD,
            print_level=MadNLP.ERROR),
        [
            "eigmina" # fails; regularization does not correct the inertia; inertia calculation based on EVD does not seem reliable
         ]
    ],
    [
        "DenseKKTSystem + LapackCPU-CHOLESKY",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.DenseKKTSystem,
            linear_solver=MadNLP.LapackCPUSolver,
            lapack_algorithm=MadNLP.CHOLESKY,
            print_level=MadNLP.ERROR),
        ["infeasible", "lootsma", "eigmina", "lp_examodels_issue75"]
    ],
    [
        "SparseUnreducedKKTSystem",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.SparseUnreducedKKTSystem,
            linear_solver=UmfpackSolver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "SparseUnreducedKKTSystem + InertiaFree",
        ()->MadNLP.Optimizer(
            inertia_correction_method=MadNLP.InertiaFree,
            linear_solver=UmfpackSolver,
            kkt_system=MadNLP.SparseUnreducedKKTSystem,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "SparseCondensedKKTSystem + CHOLMOD-CHOLESKY",
        ()->MadNLP.Optimizer(
            kkt_system=MadNLP.SparseCondensedKKTSystem,
            equality_treatment = MadNLP.RelaxEquality,
            fixed_variable_treatment = MadNLP.RelaxBound,
            linear_solver=MadNLP.CHOLMODSolver,
            print_level=MadNLP.ERROR),
        []
    ],
    [
        "SparseCondensedKKTSystem + InertiaFree",
        ()->MadNLP.Optimizer(
            inertia_correction_method=MadNLP.InertiaFree,
            kkt_system=MadNLP.SparseCondensedKKTSystem,
            equality_treatment = MadNLP.RelaxEquality,
            fixed_variable_treatment = MadNLP.RelaxBound,
            print_level=MadNLP.ERROR),
        []
    ],
]

# N.B. Current CHOLMOD interface is supported only starting from Julia v1.10.
if VERSION >= v"1.10"
    push!(
        testset,
        [
            "SparseCondensedKKTSystem + CHOLMOD-LDL",
            ()->MadNLP.Optimizer(
                kkt_system=MadNLP.SparseCondensedKKTSystem,
                equality_treatment = MadNLP.RelaxEquality,
                fixed_variable_treatment = MadNLP.RelaxBound,
                linear_solver=MadNLP.CHOLMODSolver,
                cholmod_algorithm=MadNLP.LDL,
                print_level=MadNLP.ERROR),
            []
        ]
    )
end

for (name,optimizer_constructor,exclude) in testset
    test_madnlp(name,optimizer_constructor,exclude)
end

@testset "HS15 problem" begin
    nlp = MadNLPTests.HS15Model()
    n, m = NLPModels.get_nvar(nlp), NLPModels.get_ncon(nlp)
    solver = MadNLP.MadNLPSolver(nlp; print_level=MadNLP.ERROR)
    MadNLP.solve!(solver)
    @test solver.status == MadNLP.SOLVE_SUCCEEDED
end

@testset "MadNLP scaling" begin
    MadNLPTests.test_scaling()
end

@testset "Max optimization problem" begin
    MadNLPTests.test_max_problem()
end

@testset "Fixed variables" begin
    nlp = MadNLPTests.HS15Model()
    solver = MadNLPSolver(nlp; print_level=MadNLP.ERROR)
    MadNLP.solve!(solver)
    @test isa(solver.cb.fixed_handler, MadNLP.NoFixedVariables)

    # Fix first variable:
    nlp.meta.lvar[1] = 0.5
    solver_sparse = MadNLP.MadNLPSolver(nlp; callback=MadNLP.SparseCallback, print_level=MadNLP.ERROR)
    sol_sparse = MadNLP.solve!(solver_sparse)
    @test length(solver_sparse.ind_fixed) == 1
    @test isa(solver_sparse.cb.fixed_handler, MadNLP.MakeParameter)
    @test solver_sparse.n == 3 # fixed variables are removed

    solver_dense = MadNLP.MadNLPSolver(nlp; callback=MadNLP.DenseCallback, print_level=MadNLP.ERROR)
    sol_dense = MadNLP.solve!(solver_dense)
    @test length(solver_dense.ind_fixed) == 1
    @test isa(solver_dense.cb.fixed_handler, MadNLP.MakeParameter)
    @test solver_dense.n == 4 # fixed variables are frozen

    @test sol_dense.iter == sol_sparse.iter
    @test sol_dense.objective == sol_sparse.objective
    @test sol_dense.solution == sol_sparse.solution
    @test sol_dense.multipliers == sol_sparse.multipliers
    @test sol_dense.multipliers_L == sol_sparse.multipliers_L
    @test sol_dense.multipliers_U == sol_sparse.multipliers_U
end

@testset "MadNLP warmstart" begin
    nlp = MadNLPTests.HS15Model()
    x0 = NLPModels.get_x0(nlp)
    y0 = NLPModels.get_y0(nlp)

    solver = MadNLP.MadNLPSolver(nlp; print_level=MadNLP.ERROR)
    @test solver.status == MadNLP.INITIAL
    MadNLP.solve!(solver; x=x0, y=y0)
    @test solver.status == MadNLP.SOLVE_SUCCEEDED
    # Update barrier term and solve again
    MadNLP.solve!(solver; x=x0, y=y0, mu_init=1e-5)
    @test solver.status == MadNLP.SOLVE_SUCCEEDED
end


@testset "NLS problem" begin
    nlp = MadNLPTests.NLSModel()
    solver = MadNLPSolver(nlp; print_level=MadNLP.ERROR)
    MadNLP.solve!(solver)
    @test solver.status == MadNLP.SOLVE_SUCCEEDED
end

@testset "MadNLP callback allocations" begin
    nlp = MadNLPTests.HS15Model()
    solver = MadNLPSolver(nlp)
    MadNLP.initialize!(solver)
    kkt = solver.kkt
    x, f, c = solver.x, solver.f, solver.c
    # Precompile
    MadNLP.eval_f_wrapper(solver, x)
    MadNLP.eval_grad_f_wrapper!(solver, f, x)
    MadNLP.eval_cons_wrapper!(solver, c, x)
    MadNLP.eval_jac_wrapper!(solver, kkt, x)
    MadNLP.eval_lag_hess_wrapper!(solver, kkt, x, solver.y)

    n_allocs = @allocated MadNLP.eval_f_wrapper(solver, x)
    @test n_allocs == 0
    n_allocs = @allocated MadNLP.eval_grad_f_wrapper!(solver, f, x)
    @test n_allocs == 0
    n_allocs = @allocated MadNLP.eval_cons_wrapper!(solver, c, x)
    @test n_allocs == 0
    n_allocs = @allocated MadNLP.eval_jac_wrapper!(solver, kkt, x)
    @test n_allocs == 0
    n_allocs = @allocated MadNLP.eval_lag_hess_wrapper!(solver, kkt, x, solver.y)
    @test n_allocs == 0
end

@testset "MadNLP timings" begin
    nlp = MadNLPTests.HS15Model()
    solver = MadNLPSolver(nlp)
    MadNLP.initialize!(solver)
    time_callbacks = MadNLP.timing_callbacks(solver)
    @test isa(time_callbacks, NamedTuple)
    time_linear_solver = MadNLP.timing_linear_solver(solver)
    @test isa(time_linear_solver, NamedTuple)
    time_madnlp = MadNLP.timing_madnlp(solver)
    @test isa(time_madnlp.time_linear_solver, NamedTuple)
    @test isa(time_madnlp.time_callbacks, NamedTuple)
end

@testset "Quadmath test" begin
    nlp = MadNLPTests.HS15Model(T = Float128)
    result = madnlp(
        nlp;
        print_level = MadNLP.ERROR,
        callback = MadNLP.SparseCallback,
        linear_solver=LDLSolver,
        kkt_system = MadNLP.SparseCondensedKKTSystem
    )
    @test result.status == MadNLP.SOLVE_SUCCEEDED
end

@testset "Adaptive barrier" begin
    nlp = MadNLPTests.HS15Model(; x0=[1.0, 1.0])
    ref = madnlp(nlp; print_level = MadNLP.ERROR)
    for barrier in [
        MadNLP.LOQOUpdate(),
        MadNLP.QualityFunctionUpdate(),
        MadNLP.QualityFunctionUpdate(; globalization=false),
    ]
        results = madnlp(nlp; print_level = MadNLP.ERROR, barrier=barrier)
        @test results.status == MadNLP.SOLVE_SUCCEEDED
        @test results.objective ≈ ref.objective
        @test results.solution ≈ ref.solution
        @test results.multipliers ≈ ref.multipliers
    end
end

@testset "Issue #430" begin
    # Test MadNLP is working with bound_relax_factor=0
    nlp = MadNLPTests.HS15Model()
    solver = MadNLPSolver(nlp; bound_relax_factor=0.0, print_level=MadNLP.ERROR)
    stats = MadNLP.solve!(solver)
    @test stats.status == MadNLP.SOLVE_SUCCEEDED
end

@kwdef struct UserCallback <: MadNLP.AbstractUserCallback
    counter::Base.RefValue{Int} = Ref(0)
end

function (cb::UserCallback)(solver::MadNLP.AbstractMadNLPSolver, mode)
    cb.counter[] += 1
    return solver.cnt.k <= 3
end

@testset "User-defined callback termination" begin
    nlp = MadNLPTests.HS15Model()
    cb = UserCallback()
    solver = MadNLPSolver(nlp; print_level = MadNLP.ERROR, intermediate_callback=cb)
    stats = MadNLP.solve!(solver)
    @test stats.status == MadNLP.USER_REQUESTED_STOP
    @test solver.cnt.k == 4
    @test cb.counter[] == 5
end

@testset "Warn on option ignore" begin
    pipe = Pipe()
    redirect_stdout(pipe) do
        MadNLPSolver(MadNLPTests.HS15Model(); fake_option = true)
    end
    @test readline(pipe) == "The following options are ignored: "
    @test readline(pipe) == " - fake_option"
end

"""
    AbstractHessian{T, VT}

Abstract type for representation of second-order information.

"""
abstract type AbstractHessian{T, VT} end

"""
    AbstractQuasiNewton{T, VT} <: AbstractHessian{T, VT}

Abstract type for quasi-Newton approximation.

"""
abstract type AbstractQuasiNewton{T, VT} <: AbstractHessian{T, VT} end

"""
    update!(
        qn::AbstractQuasiNewton,
        Bk::AbstractMatrix,
        sk::AbstractVector,
        yk::AbstractVector,
    )

Update the matrix `Bk` encoding the (direct) Hessian approximation
with the secant vectors `sk` and `yk`.

Return `true` if the update succeeded, `false` otherwise.
"""
function update! end

"""
    init!(
        qn::AbstractHessian{T},
        Bk::AbstractArray{T},
        g0::AbstractVector{T},
        f0::T,
    ) where T

Instantiate the Hessian estimate `Bk` with the quasi-Newton algorithm `qn`.
The function uses the initial gradient `g0` and the initial objective
`f0` to build the initial estimate.

"""
function init! end

curvature(::Val{SCALAR1}, sk, yk) = dot(yk, sk) / dot(sk, sk)
curvature(::Val{SCALAR2}, sk, yk) = dot(yk, yk) / dot(sk, yk)
function curvature(::Val{SCALAR3}, sk, yk)
    sᵀy = dot(sk, yk)
    sᵀs = dot(sk, sk)
    yᵀy = dot(yk, yk)
    return ((sᵀy / sᵀs) + (yᵀy / sᵀy)) / 2
end
function curvature(::Val{SCALAR4}, sk, yk)
    sᵀy = dot(sk, yk)
    sᵀs = dot(sk, sk)
    yᵀy = dot(yk, yk)
    return sqrt((sᵀy / sᵀs) * (yᵀy / sᵀy))
end

@kwdef mutable struct QuasiNewtonOptions{T} <: AbstractOptions
    init_strategy::BFGSInitStrategy = SCALAR1
    max_history::Int = 6
    init_value::T = 1.0
    sigma_min::T = 1e-8
    sigma_max::T = 1e+8
end

"""
    BFGS{T, VT} <: AbstractQuasiNewton{T, VT}

BFGS quasi-Newton method. Update the direct Hessian approximation using
```math
B_{k+1} = B_k - \frac{(B_k s_k)(B_k s_k)^⊤}{s_k^⊤ B_k s_k} + \frac{y_k y_k^⊤}{y_k^⊤ s_k}
```

### Notes
The matrix is not updated if ``s_k^⊤ y_k < 10^{-8}``.

"""
struct BFGS{T, VT <: AbstractVector{T}} <: AbstractQuasiNewton{T, VT}
    init_strategy::BFGSInitStrategy
    is_instantiated::Base.RefValue{Bool}
    sk::VT
    yk::VT
    bsk::VT
    last_g::VT
    last_x::VT
    last_jv::VT
end

function create_quasi_newton(
    ::Type{BFGS},
    cb::AbstractCallback{T,VT},
    n;
    options=QuasiNewtonOptions{T}(),
    ) where {T,VT}
    BFGS(
        options.init_strategy,
        Ref(false),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
    )
end

function update!(qn::BFGS{T, VT}, Bk::AbstractMatrix, sk::AbstractVector, yk::AbstractVector) where {T, VT}
    yksk = dot(sk, yk)
    if yksk < T(1e-8)
        return false
    end
    # Initial approximation (Nocedal & Wright, p.143)
    if !qn.is_instantiated[]
        sksk = dot(sk, sk)
        Bk[diagind(Bk)] .= yksk ./ sksk
        qn.is_instantiated[] = true
    end
    # BFGS update
    _symv!('L', one(T), Bk, sk, zero(T), qn.bsk)
    alpha1 = one(T) / dot(sk, qn.bsk)
    alpha2 = one(T) / yksk
    _syr!('L', -alpha1, qn.bsk, Bk)  # Bk = Bk - alpha1 * bsk * bsk'
    _syr!('L', alpha2, yk, Bk)       # Bk = Bk + alpha2 * yk * yk'
    return true
end

struct DampedBFGS{T, VT <: AbstractVector{T}} <: AbstractQuasiNewton{T, VT}
    init_strategy::BFGSInitStrategy
    is_instantiated::Base.RefValue{Bool}
    sk::VT
    yk::VT
    bsk::VT
    rk::VT
    last_g::VT
    last_x::VT
    last_jv::VT
end

function create_quasi_newton(
    ::Type{DampedBFGS},
    cb::AbstractCallback{T,VT},
    n;
    options=QuasiNewtonOptions{T}(),
    ) where {T,VT}
    return DampedBFGS(
        options.init_strategy,
        Ref(false),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
        VT(undef, n),
    )
end

function update!(qn::DampedBFGS{T, VT}, Bk::AbstractMatrix, sk::AbstractVector, yk::AbstractVector) where {T, VT}
    yksk = dot(sk, yk)
    # Initial approximation (Nocedal & Wright, p.143)
    if !qn.is_instantiated[]
        sksk = dot(sk, sk)
        Bk[diagind(Bk)] .= yksk ./ sksk
        qn.is_instantiated[] = true
    end

    _symv!('L', one(T), Bk, sk, zero(T), qn.bsk)
    sBs = dot(sk, qn.bsk)

    # Procedure 18.2 (Nocedal & Wright, page 537)
    theta = if dot(sk, yk) < T(0.2) * sBs
        T(0.8) * sBs / (sBs - yksk)
    else
        one(T)
    end

    fill!(qn.rk, zero(T))
    axpy!(theta, yk, qn.rk)
    axpy!(one(T) - theta, qn.bsk, qn.rk)

    alpha1 = one(T) / sBs
    alpha2 = one(T) / dot(qn.rk, qn.sk)

    _syr!('L', -alpha1, qn.bsk, Bk)
    _syr!('L', alpha2, qn.rk, Bk)
    return true
end

function init!(qn::Union{BFGS, DampedBFGS}, Bk::AbstractMatrix{T}, g0::AbstractVector{T}, f0::T) where T
    norm_g0 = dot(g0, g0)
    # Initiate B0 with Gilbert & Lemaréchal rule.
    rho0 = if norm_g0 < sqrt(eps(T))
        one(T)
    elseif f0 ≈ zero(T)
        one(T) / norm_g0
    else
        abs(f0) / norm_g0
    end
    Bk[diagind(Bk)] .= T(2) * rho0
    return
end


"""
    CompactLBFGS{T, VT} <: AbstractQuasiNewton
"""
mutable struct CompactLBFGS{T, VT <: AbstractVector{T}, MT <: AbstractMatrix{T}, B} <: AbstractQuasiNewton{T, VT}
    init_strategy::BFGSInitStrategy
    sk::VT
    yk::VT
    last_g::VT
    last_x::VT
    last_jv::VT
    init_value::T
    sigma_min::T
    sigma_max::T
    max_mem::Int
    current_mem::Int
    skipped_iter::Int
    Sk::MT       # n x p
    Yk::MT       # n x p
    Lk::MT       # p x p
    Mk::MT       # p x p (for Cholesky factorization Mₖ = Jₖ Jₖᵀ)
    Tk::MT       # 2p x 2p
    DkLk::MT     # p x p
    U::MT        # n x p
    V::MT        # n x p
    E::MT        # (n+m) x 2p
    H::MT        # (n+m) x 2p
    Dk::VT       # p
    _w1::VT
    _w2::VT
    additional_buffers::B
    max_mem_reached::Bool
end

function create_quasi_newton(
    ::Type{CompactLBFGS},
    cb::AbstractCallback{T,VT},
    n;
    options=QuasiNewtonOptions{T}(),
    ) where {T, VT}
    return CompactLBFGS(
        options.init_strategy,
        fill!(create_array(cb, n), zero(T)),
        fill!(create_array(cb, n), zero(T)),
        fill!(create_array(cb, n), zero(T)),
        fill!(create_array(cb, n), zero(T)),
        fill!(create_array(cb, n), zero(T)),
        T(options.init_value),
        T(options.sigma_min),
        T(options.sigma_max),
        options.max_history,
        0,
        0,
        fill!(create_array(cb, n, 0), zero(T)),
        fill!(create_array(cb, n, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0, 0), zero(T)),
        fill!(create_array(cb, 0), zero(T)),
        fill!(create_array(cb, 0), zero(T)),
        fill!(create_array(cb, 0), zero(T)),
        nothing,
        false,
    )
end

Base.size(qn::CompactLBFGS) = (size(qn.Sk, 1), qn.current_mem)

function _resize!(qn::CompactLBFGS{T, VT, MT}) where {T, VT, MT}
    n, k = size(qn)
    qn.Lk    = fill!(MT(undef, k, k), zero(T))
    qn.Mk    = fill!(MT(undef, k, k), zero(T))
    qn.Tk    = fill!(MT(undef, 2*k, 2*k), zero(T))
    qn.DkLk  = fill!(MT(undef, k, k), zero(T))
    qn.U     = fill!(MT(undef, n, k), zero(T))
    qn.V     = fill!(MT(undef, n, k), zero(T))
    qn._w1   = fill!(VT(undef, k), zero(T))
    qn._w2   = fill!(VT(undef, 2*k), zero(T))
    return
end

function _reset!(qn::CompactLBFGS{T, VT, MT}) where {T, VT, MT}
    n, _ = size(qn)
    qn.current_mem = 0
    qn.skipped_iter = 0
    fill!(qn.last_jv, zero(T))
    qn.Dk = VT(undef, 0)
    qn.Sk = MT(undef, n, 0)
    qn.Yk = MT(undef, n, 0)
    qn.max_mem_reached = false
    _resize!(qn)
end

function _update_S_and_Y!(qn::CompactLBFGS, s::Vector, y::Vector)
    if qn.current_mem < qn.max_mem
        qn.current_mem += 1
        n, k = size(qn)
        vec_Sk = vec(qn.Sk)
        vec_Yk = vec(qn.Yk)
        resize!(vec_Sk, n*k)
        resize!(vec_Yk, n*k)
        qn.Sk = reshape(vec_Sk, n, k)
        qn.Yk = reshape(vec_Yk, n, k)
        view(qn.Sk, 1:n, k) .= s
        view(qn.Yk, 1:n, k) .= y
        _resize!(qn)
    else
        n, k = size(qn)
        # Shift
        @inbounds for i_ in 1:k-1, j in 1:n
            qn.Sk[j, i_] = qn.Sk[j, i_+1]
            qn.Yk[j, i_] = qn.Yk[j, i_+1]
        end
        # Latest element
        @inbounds for j in 1:n
            qn.Sk[j, k] = s[j]
            qn.Yk[j, k] = y[j]
        end
    end
end

function _update_L_and_D!(qn::CompactLBFGS{T}, sk::Vector, yk::Vector) where {T}
    # Update the strict lower triangular part of S'Y
    n, k = size(qn)
    if qn.max_mem_reached
        # shift of all coefficients
        @inbounds for i in 1:k-1
            qn.Dk[i] = qn.Dk[i+1]
            @inbounds for j in 1:i-1
                qn.Lk[i, j] = qn.Lk[i+1, j+1]
            end
        end
        # Compute the new last row of tril(S'Y)
        # It can be recovered with sₖᵀY or Yᵀsₖ
        lk = view(qn.Lk, k, 1:k)
        sk = view(qn.Sk, 1:n, k)
        mul!(lk, qn.Yk', sk)
        qn.Dk[k] = qn.Lk[k,k]
        qn.Lk[k,k] = zero(T)
    else
        # To be optimized...
        p = size(qn.Lk, 1)
        mul!(qn.Lk, qn.Sk', qn.Yk)
        push!(qn.Dk, qn.Lk[k,k])
        @inbounds for i in 1:p, j in i:p
            qn.Lk[i, j] = zero(T)
        end
        if qn.current_mem == qn.max_mem
            qn.max_mem_reached = true
        end
    end
end

function update!(qn::CompactLBFGS{T}, Bk, sk, yk) where {T}
    norm_sk, norm_yk = norm(sk), norm(yk)
    # Skip update if vectors are too small or local curvature is negative.
    if ((norm_sk < T(100) * eps(T)) ||
        (norm_yk < T(100) * eps(T)) ||
        (dot(sk, yk) < sqrt(eps(T)) * norm_sk * norm_yk)
    )
        qn.skipped_iter += 1
        if qn.skipped_iter >= 2
            _reset!(qn)
        end
        return false
    end

    # Refresh internal structures
    _update_S_and_Y!(qn, sk, yk)
    _update_L_and_D!(qn, sk, yk)

    # Load buffers
    k = qn.current_mem
    δ = qn._w1

    # Compute compact representation Bₖ = σₖI -UₖUₖᵀ + VₖVₖᵀ
    # Step 1: σₖ I
    sigma = curvature(Val(qn.init_strategy), sk, yk)    # σₖ
    sigma = clamp(sigma, qn.sigma_min, qn.sigma_max)
    Bk .= sigma                                         # Hₖ .= σₖI (diagonal Hessian approx.)

    # Step 2: Mₖ = σₖ Sₖᵀ Sₖ + Lₖ Dₖ⁻¹ Lₖᵀ
    δ .= one(T) ./ sqrt.(qn.Dk)                         # δₖ = 1 / √Dₖ
    _dgmm!('L', qn.Lk', δ, qn.DkLk)                     # Compute (1 / √Dₖ) * Lₖᵀ
    if T <: BlasReal
        _syrk!('L', 'T', one(T), qn.Sk, zero(T), qn.Mk) # Mₖ = Sₖᵀ Sₖ
        _syrk!('L', 'T', one(T), qn.DkLk, sigma, qn.Mk) # Mₖ = σₖ Sₖᵀ Sₖ + Lₖ Dₖ⁻¹ Lₖᵀ
    else
        mul!(qn.Mk, qn.Sk', qn.Sk)                      # Mₖ = Sₖᵀ Sₖ
        mul!(qn.Mk, qn.DkLk', qn.DkLk, one(T), sigma)   # Mₖ = σₖ Sₖᵀ Sₖ + Lₖ Dₖ⁻¹ Lₖᵀ
    end

    # Step 3: Perform a Cholesky factorization of Mₖ
    if T <: BlasReal
        LAPACK.potrf!('L', qn.Mk)                       # Mₖ = Jₖ Jₖᵀ (factorization)
    else
        cholesky!(Symmetric(qn.Mk, :L))                 # Mₖ = Jₖ Jₖᵀ (factorization)
    end

    # Step 4: Update Uₖ and Vₖ
    _dgmm!('R', qn.Yk, δ, qn.V)                         # Vₖ = Yₖ * (1 / √Dₖ)
    copyto!(qn.U, qn.Sk)                                # Uₖ = Sₖ
    mul!(qn.U, qn.V, qn.DkLk, one(T), sigma)            # Uₖ = σₖ Sₖ + Yₖ Dₖ⁻¹ Lₖᵀ
    if T <: BlasReal
        _trsm!('R', 'L', 'T', 'N', one(T), qn.Mk, qn.U) # Uₖ = (σₖ Sₖ + Yₖ Dₖ⁻¹ Lₖᵀ) Jₖ⁻ᵀ
    else
        rdiv!(qn.U, LowerTriangular(qn.Mk)')            # Uₖ = (σₖ Sₖ + Yₖ Dₖ⁻¹ Lₖᵀ) Jₖ⁻ᵀ
    end

    return true
end

function init!(qn::CompactLBFGS{T}, Bk::AbstractVector{T}, g0::AbstractVector{T}, f0::T) where T
    norm_g0 = dot(g0, g0)
    # Initiate B0 with Gilbert & Lemaréchal rule.
    rho0 = if norm_g0 < sqrt(eps(T))
        one(T)
    elseif f0 ≈ zero(T)
        one(T) / norm_g0
    else
        abs(f0) / norm_g0
    end
    Bk .= (T(2) * rho0 * qn.init_value)
    return
end

struct ExactHessian{T, VT} <: AbstractHessian{T, VT} end
create_quasi_newton(::Type{ExactHessian}, cb::AbstractCallback{T,VT}, n; options...) where {T,VT} = ExactHessian{T, VT}()

# KKT system updates -------------------------------------------------------
# Set diagonal
function set_aug_diagonal!(kkt::AbstractKKTSystem{T}, solver::AbstractMadNLPSolver{T}) where T
    x = full(get_x(solver))
    xl = full(get_xl(solver))
    xu = full(get_xu(solver))
    zl = full(get_zl(solver))
    zu = full(get_zu(solver))

    fill!(kkt.reg, get_opt(solver).default_primal_regularization)
    fill!(kkt.du_diag, -get_opt(solver).default_dual_regularization)
    kkt.l_diag .= get_xl_r(solver) .- get_x_lr(solver)   # (Xˡ - X)
    kkt.u_diag .= get_x_ur(solver) .- get_xu_r(solver)   # (X - Xᵘ)
    copyto!(kkt.l_lower, get_zl_r(solver))
    copyto!(kkt.u_lower, get_zu_r(solver))

    _set_aug_diagonal!(kkt)
    return
end

function _set_aug_diagonal!(kkt::AbstractKKTSystem)
    copyto!(kkt.pr_diag, kkt.reg)
    @views kkt.pr_diag[kkt.ind_lb] .-= kkt.l_lower ./ kkt.l_diag
    @views kkt.pr_diag[kkt.ind_ub] .-= kkt.u_lower ./ kkt.u_diag
    return
end

function _set_aug_diagonal!(kkt::AbstractUnreducedKKTSystem)
    copyto!(kkt.pr_diag, kkt.reg)
    kkt.l_lower_aug .= sqrt.(kkt.l_lower)
    kkt.u_lower_aug .= sqrt.(kkt.u_lower)
    return
end

function set_aug_diagonal!(kkt::ScaledSparseKKTSystem{T}, solver::AbstractMadNLPSolver{T}) where T
    fill!(kkt.reg, get_opt(solver).default_primal_regularization)
    fill!(kkt.du_diag, -get_opt(solver).default_dual_regularization)
    # Ensure l_diag and u_diag have only non negative entries
    kkt.l_diag .= get_x_lr(solver) .- get_xl_r(solver)   # (X - Xˡ)
    kkt.u_diag .= get_xu_r(solver) .- get_x_ur(solver)   # (Xᵘ - X)
    copyto!(kkt.l_lower, get_zl_r(solver))
    copyto!(kkt.u_lower, get_zu_r(solver))
    _set_aug_diagonal!(kkt)
end

function _set_aug_diagonal!(kkt::ScaledSparseKKTSystem{T}) where T
    xlzu = kkt.buffer1
    xuzl = kkt.buffer2
    fill!(xlzu, zero(T))
    fill!(xuzl, zero(T))
    @views begin
        xlzu[kkt.ind_ub] .= kkt.u_lower    # zᵘ
        xlzu[kkt.ind_lb] .*= kkt.l_diag    # (X - Xˡ) zᵘ

        xuzl[kkt.ind_lb] .= kkt.l_lower    # zˡ
        xuzl[kkt.ind_ub] .*= kkt.u_diag    # (Xᵘ - X) zˡ

        kkt.pr_diag .= xlzu .+ xuzl

        fill!(kkt.scaling_factor, one(T))
        kkt.scaling_factor[kkt.ind_lb] .*= sqrt.(kkt.l_diag)
        kkt.scaling_factor[kkt.ind_ub] .*= sqrt.(kkt.u_diag)
    end
    # Scale regularization by scaling factor.
    kkt.pr_diag .+= kkt.reg .* kkt.scaling_factor.^2
    return
end


# Robust restoration
function set_aug_RR!(kkt::AbstractKKTSystem, solver::AbstractMadNLPSolver, RR::RobustRestorer)
    x = full(get_x(solver))
    xl = full(get_xl(solver))
    xu = full(get_xu(solver))
    zl = full(get_zl(solver))
    zu = full(get_zu(solver))
    kkt.reg .= get_opt(solver).default_primal_regularization .+ RR.zeta .* RR.D_R .^ 2
    kkt.du_diag .= .- get_opt(solver).default_dual_regularization .- RR.pp ./ RR.zp .- RR.nn ./ RR.zn
    copyto!(kkt.l_lower, get_zl_r(solver))
    copyto!(kkt.u_lower, get_zu_r(solver))
    kkt.l_diag .= get_xl_r(solver) .- get_x_lr(solver)
    kkt.u_diag .= get_x_ur(solver) .- get_xu_r(solver)

    _set_aug_diagonal!(kkt)
    return
end

function set_aug_RR!(kkt::ScaledSparseKKTSystem, solver::AbstractMadNLPSolver, RR::RobustRestorer)
    x = full(get_x(solver))
    xl = full(get_xl(solver))
    xu = full(get_xu(solver))
    zl = full(get_zl(solver))
    zu = full(get_zu(solver))
    kkt.reg .= get_opt(solver).default_primal_regularization .+ RR.zeta .* RR.D_R .^ 2
    kkt.du_diag .= .- get_opt(solver).default_dual_regularization .- RR.pp ./ RR.zp .- RR.nn ./ RR.zn
    copyto!(kkt.l_lower, get_zl_r(solver))
    copyto!(kkt.u_lower, get_zu_r(solver))
    kkt.l_diag .= get_x_lr(solver) .- get_xl_r(solver)
    kkt.u_diag .= get_xu_r(solver) .- get_x_ur(solver)

    _set_aug_diagonal!(kkt)
    return
end

function set_f_RR!(solver::AbstractMadNLPSolver, RR::RobustRestorer)
    x = full(get_x(solver))
    RR.f_R .= RR.zeta .* RR.D_R .^ 2 .* (x .- RR.x_ref)
    return
end

# Set RHS
function set_aug_rhs!(solver::AbstractMadNLPSolver, kkt::AbstractKKTSystem, c::AbstractVector, mu)
    px = primal(get_p(solver))
    x = primal(get_x(solver))
    f = primal(get_f(solver))
    xl = primal(get_xl(solver))
    xu = primal(get_xu(solver))
    zl = full(get_zl(solver))
    zu = full(get_zu(solver))
    py = dual(get_p(solver))
    pzl = dual_lb(get_p(solver))
    pzu = dual_ub(get_p(solver))

    px .= .-f .+ zl .- zu .- get_jacl(solver)
    py .= .-c
    pzl .= (get_xl_r(solver) .- get_x_lr(solver)) .* get_zl_r(solver) .+ mu
    pzu .= (get_xu_r(solver) .- get_x_ur(solver)) .* get_zu_r(solver) .- mu
    return
end

# Set RHS RR
function set_aug_rhs_RR!(
    solver::AbstractMadNLPSolver, kkt::AbstractKKTSystem, RR::RobustRestorer, rho,
)
    x = full(get_x(solver))
    xl = full(get_xl(solver))
    xu = full(get_xu(solver))
    zl = full(get_zl(solver))
    zu = full(get_zu(solver))

    px = primal(get_p(solver))
    py = dual(get_p(solver))
    pzl = dual_lb(get_p(solver))
    pzu = dual_ub(get_p(solver))

    mu = RR.mu_R

    px .= .- RR.f_R .+ zl .- zu .- get_jacl(solver)
    py .= .- get_c(solver) .+ RR.pp .- RR.nn .+
        (mu .- (rho .- get_y(solver)) .* RR.pp) ./ RR.zp .-
        (mu .- (rho .+ get_y(solver)) .* RR.nn) ./ RR.zn

    pzl .= (get_xl_r(solver) .- get_x_lr(solver)) .* get_zl_r(solver) .+ mu
    pzu .= (get_xu_r(solver) .- get_x_ur(solver)) .* get_zu_r(solver) .- mu

    return
end

# solving KKT system
@inbounds function _kktmul!(
    w::AbstractKKTVector,
    x::AbstractKKTVector,
    reg,
    du_diag,
    l_lower,
    u_lower,
    l_diag,
    u_diag,
    alpha,
    beta,
)
    primal(w) .+= alpha .* reg .* primal(x)
    dual(w) .+= alpha .* du_diag .* dual(x)
    w.xp_lr .-= alpha .* dual_lb(x)
    w.xp_ur .+= alpha .* dual_ub(x)
    dual_lb(w) .= beta .* dual_lb(w) .+ alpha .* (x.xp_lr .* l_lower .- dual_lb(x) .* l_diag)
    dual_ub(w) .= beta .* dual_ub(w) .+ alpha .* (x.xp_ur .* u_lower .+ dual_ub(x) .* u_diag)
    return
end

@inbounds function reduce_rhs!(
    xp_lr, wl, l_diag,
    xp_ur, wu, u_diag,
)
    xp_lr .-= wl ./ l_diag
    xp_ur .-= wu ./ u_diag
    return
end
function reduce_rhs!(kkt::AbstractKKTSystem, d::AbstractKKTVector)
    reduce_rhs!(
        d.xp_lr, dual_lb(d), kkt.l_diag,
        d.xp_ur, dual_ub(d), kkt.u_diag,
    )
end

# Finish
function finish_aug_solve!(kkt::AbstractKKTSystem, d::AbstractKKTVector)
    dlb = dual_lb(d)
    dub = dual_ub(d)
    dlb .= (.-dlb .+ kkt.l_lower .* d.xp_lr) ./ kkt.l_diag
    dub .= (  dub .- kkt.u_lower .* d.xp_ur) ./ kkt.u_diag
    return
end

function set_initial_bounds!(xl::AbstractVector{T}, xu::AbstractVector{T}, tol) where T
    # If `tol` is set to zero, keep the bounds unchanged.
    if tol > zero(T)
        map!(
            x->x - max(one(T), abs(x)) * tol,
            xl, xl
        )
        map!(
            x->x + max(one(T), abs(x)) * tol,
            xu, xu
        )
    end
end

function set_initial_rhs!(solver::AbstractMadNLPSolver{T}, kkt::AbstractKKTSystem) where T
    f = primal(get_f(solver))
    zl = primal(get_zl(solver))
    zu = primal(get_zu(solver))
    px = primal(get_p(solver))
    px .= .-f .+ zl .- zu
    fill!(dual(get_p(solver)), zero(T))
    fill!(dual_lb(get_p(solver)), zero(T))
    fill!(dual_ub(get_p(solver)), zero(T))
    return
end

# Set ifr
function set_aug_rhs_ifr!(solver::AbstractMadNLPSolver{T}, kkt::AbstractKKTSystem, p0::AbstractKKTVector) where T
    fill!(primal(p0), zero(T))
    fill!(dual_lb(p0), zero(T))
    fill!(dual_ub(p0), zero(T))
    wy = dual(p0)
    wy .= .- get_c(solver)
    return
end

function set_g_ifr!(solver::AbstractMadNLPSolver, g::AbstractArray)
    f = full(get_f(solver))
    x = full(get_x(solver))
    xl = full(get_xl(solver))
    xu = full(get_xu(solver))
    g .= f .- get_mu(solver) ./ (x .- xl) .+ get_mu(solver) ./ (xu .- x) .+ get_jacl(solver)
end

# Finish RR
function finish_aug_solve_RR!(dpp, dnn, dzp, dzn, l, dl, pp, nn, zp, zn, mu_R, rho)
    dzp .= rho .- l .- dl .- zp
    dzn .= rho .+ l .+ dl .- zn
    dpp .= .- pp .+ mu_R ./zp .- (pp./zp) .* dzp
    dnn .= .- nn .+ mu_R ./zn .- (nn./zn) .* dzn
    return
end

# Kernel functions ---------------------------------------------------------
is_valid(val::R) where R <: Real = !(isnan(val) || isinf(val))
is_valid(vec::AbstractArray) = isempty(vec) ? true : mapreduce(is_valid, &, vec)

function _get_varphi(x1::T, x2::T, mu::T) where T
    x = x1 - x2
    if x < 0
        return T(Inf)
    else
        return -mu * log(x)
    end
end

function get_varphi(obj_val, x_lr, xl_r, xu_r, x_ur, mu)
    varphi = obj_val
    for ii in eachindex(x_lr)
        varphi += _get_varphi(x_lr[ii],xl_r[ii],mu)
    end
    for ii in eachindex(xu_r)
        varphi += _get_varphi(xu_r[ii],x_ur[ii],mu)
    end
    return varphi
end

@inline get_inf_pr(c::AbstractVector) = norm(c, Inf)

function get_inf_du(f, zl, zu, jacl, sd)
    inf_du = zero(eltype(f))
    for ii in eachindex(f)
        inf_du = max(inf_du, abs(f[ii]-zl[ii]+zu[ii]+jacl[ii]))
    end
    return inf_du / sd
end

function get_inf_compl(x_lr, xl_r, zl_r, xu_r, x_ur, zu_r, mu, sc)
    inf_compl = zero(eltype(x_lr))
    for ii in eachindex(x_lr)
        inf_compl = max(inf_compl, abs((x_lr[ii]-xl_r[ii])*zl_r[ii]-mu))
    end
    for ii in eachindex(xu_r)
        inf_compl = max(inf_compl, abs((xu_r[ii]-x_ur[ii])*zu_r[ii]-mu))
    end

    return inf_compl / sc
end

function get_average_complementarity(x_lr, xl_r, zl_r, x_ur, xu_r, zu_r)
    n_lb, n_ub = length(x_lr), length(x_ur)
    # If the problem is unconstrained, average complementarity is 0
    if n_lb + n_ub == 0
        return 0.0
    end
    cc_lb = dot(x_lr, zl_r) - dot(xl_r, zl_r)
    cc_ub = dot(xu_r, zu_r) - dot(x_ur, zu_r)
    return (cc_lb + cc_ub) / (n_lb + n_ub)
end
function get_average_complementarity(solver::AbstractMadNLPSolver)
    return get_average_complementarity(
        get_x_lr(solver), get_xl_r(solver), get_zl_r(solver),
        get_x_ur(solver), get_xu_r(solver), get_zu_r(solver),
    )
end

function get_min_complementarity(x_lr::AbstractVector{T}, xl_r::AbstractVector{T}, zl_r::AbstractVector{T},
                                 x_ur::AbstractVector{T}, xu_r::AbstractVector{T}, zu_r::AbstractVector{T}) where T
    min_comp = T(Inf)
    for ii in eachindex(x_lr)
        min_comp = min(min_comp, (x_lr[ii]-xl_r[ii])*zl_r[ii])
    end
    for ii in eachindex(xu_r)
        min_comp = min(min_comp, (xu_r[ii]-x_ur[ii])*zu_r[ii])
    end
    return min_comp
end

function get_min_complementarity(solver::AbstractMadNLPSolver)
    return get_min_complementarity(
        get_x_lr(solver), get_xl_r(solver), get_zl_r(solver),
        get_x_ur(solver), get_xu_r(solver), get_zu_r(solver),
    )
end

function get_varphi_d(
    f::AbstractVector{T},
    x::AbstractVector{T},
    xl::AbstractVector{T},
    xu::AbstractVector{T},
    dx::AbstractVector{T},
    mu,
) where T
    varphi_d = zero(T)
    for ii in eachindex(f)
        varphi_d += (f[ii] - mu/(x[ii]-xl[ii]) + mu/(xu[ii]-x[ii])) * dx[ii]
    end
    return varphi_d
end

function get_alpha_max(
    x::AbstractVector{T},
    xl::AbstractVector{T},
    xu::AbstractVector{T},
    dx::AbstractVector{T},
    tau,
) where T
    alpha_max = one(T)
    for ii in eachindex(x)
        alpha_max = min(alpha_max,
                        dx[ii] < 0 ? (-x[ii]+xl[ii])*tau/dx[ii] : T(Inf),
                        dx[ii] > 0 ? (-x[ii]+xu[ii])*tau/dx[ii] : T(Inf),
                        )
    end
    return alpha_max
end

function get_alpha_z(
    zl_r::AbstractVector{T},
    zu_r::AbstractVector{T},
    dzl::AbstractVector{T},
    dzu::AbstractVector{T},
    tau,
)  where T
    alpha_z = one(T)
    for ii in eachindex(zl_r)
        alpha_z = min(alpha_z, dzl[ii] < 0 ? (-zl_r[ii])*tau/dzl[ii] : T(Inf))
    end
    for ii in eachindex(zu_r)
        alpha_z = min(alpha_z, dzu[ii] < 0 ? (-zu_r[ii])*tau/dzu[ii] : T(Inf))
    end
    return alpha_z
end

function get_obj_val_R(
    p::AbstractVector{T},
    n::AbstractVector{T},
    D_R::AbstractVector{T},
    x::AbstractVector{T},
    x_ref::AbstractVector{T},
    rho,
    zeta,
) where T
    obj_val_R = zero(T)
    for ii in eachindex(p)
        obj_val_R += rho*(p[ii]+n[ii])
    end
    for ii in eachindex(x)
        obj_val_R += zeta/2*D_R[ii]^2*(x[ii]-x_ref[ii])^2
    end
    return obj_val_R
end

@inline get_theta(c) = norm(c, 1)

function get_theta_R(
    c::AbstractVector{T},
    p::AbstractVector{T},
    n::AbstractVector{T},
) where T
    theta_R = zero(T)
    for ii in eachindex(c)
        theta_R += abs(c[ii]-p[ii]+n[ii])
    end
    return theta_R
end

function get_inf_pr_R(
    c::AbstractVector{T},
    p::AbstractVector{T},
    n::AbstractVector{T},
) where T
    inf_pr_R = zero(T)
    for ii in eachindex(c)
        inf_pr_R = max(inf_pr_R, abs(c[ii]-p[ii]+n[ii]))
    end
    return inf_pr_R
end

function get_inf_du_R(
    f_R::AbstractVector{T},
    l::AbstractVector{T},
    zl::AbstractVector{T},
    zu::AbstractVector{T},
    jacl::AbstractVector{T},
    zp::AbstractVector{T},
    zn::AbstractVector{T},
    rho,
    sd,
) where T
    inf_du_R = zero(T)
    for ii in eachindex(f_R)
        inf_du_R = max(inf_du_R, abs(f_R[ii]-zl[ii]+zu[ii]+jacl[ii]))
    end
    for ii in eachindex(l)
        inf_du_R = max(inf_du_R, abs(rho-l[ii]-zp[ii]), abs(rho+l[ii]-zn[ii]))
    end
    return inf_du_R / sd
end

function get_inf_compl_R(
    x_lr::SubVector{T, VT, VI},
    xl_r,
    zl_r,
    xu_r,
    x_ur,
    zu_r,
    pp,
    zp,
    nn,
    zn,
    mu_R,
    sc
) where {T, VT <: AbstractVector{T}, VI}
    inf_compl_R = zero(T)
    for ii in eachindex(x_lr)
        inf_compl_R = max(inf_compl_R, abs((x_lr[ii]-xl_r[ii])*zl_r[ii]-mu_R))
    end
    for ii in eachindex(xu_r)
        inf_compl_R = max(inf_compl_R, abs((xu_r[ii]-x_ur[ii])*zu_r[ii]-mu_R))
    end
    for ii in eachindex(pp)
        inf_compl_R = max(inf_compl_R, abs(pp[ii]*zp[ii]-mu_R))
    end
    for ii in eachindex(nn)
        inf_compl_R = max(inf_compl_R, abs(nn[ii]*zn[ii]-mu_R))
    end
    return inf_compl_R / sc
end

function get_alpha_max_R(
    x::AbstractVector{T},
    xl::AbstractVector{T},
    xu::AbstractVector{T},
    dx::AbstractVector{T},
    pp::AbstractVector{T},
    dpp::AbstractVector{T},
    nn::AbstractVector{T},
    dnn::AbstractVector{T},
    tau_R,
) where T
    alpha_max_R = one(T)
    for ii in eachindex(x)
        candidate = if dx[ii] < 0
            (-x[ii]+xl[ii])*tau_R/dx[ii]
        elseif dx[ii] > 0
            (-x[ii]+xu[ii])*tau_R/dx[ii]
        else
            T(Inf)
        end
        alpha_max_R = min(alpha_max_R, candidate)
    end
    for ii in eachindex(pp)
        alpha_max_R = min(alpha_max_R, dpp[ii] < 0 ? -pp[ii]*tau_R/dpp[ii] : T(Inf))
    end
    for ii in eachindex(nn)
        alpha_max_R = min(alpha_max_R, dnn[ii] < 0 ? -nn[ii]*tau_R/dnn[ii] : T(Inf))
    end
    return alpha_max_R
end

function get_alpha_z_R(
    zl_r::SubVector{T, VT, VI},
    zu_r,
    dzl,
    dzu,
    zp,
    dzp,
    zn,
    dzn,
    tau_R,
) where {T, VT <: AbstractVector{T}, VI}
    alpha_z_R = one(T)
    for ii in eachindex(dzl)
        alpha_z_R = min(alpha_z_R, dzl[ii] < 0.0 ? -zl_r[ii]*tau_R/dzl[ii] : T(Inf))
    end
    for ii in eachindex(dzu)
        alpha_z_R = min(alpha_z_R, dzu[ii] < 0.0 ? -zu_r[ii]*tau_R/dzu[ii] : T(Inf))
    end
    for ii in eachindex(dzp)
        alpha_z_R = min(alpha_z_R, dzp[ii] < 0.0 ? -zp[ii]*tau_R/dzp[ii] : T(Inf))
    end
    for ii in eachindex(dzn)
        alpha_z_R = min(alpha_z_R, dzn[ii] < 0.0 ? -zn[ii]*tau_R/dzn[ii] : T(Inf))
    end
    return alpha_z_R
end

function get_varphi_R(
    obj_val,
    x_lr::SubVector{T, VT, VI},
    xl_r,
    xu_r,
    x_ur,
    pp,
    nn,
    mu_R,
)  where {T, VT <: AbstractVector{T}, VI}
    varphi_R = obj_val
    for ii in eachindex(x_lr)
        d = x_lr[ii] - xl_r[ii]
        varphi_R -= d < 0.0 ? T(Inf) : mu_R * log(d)
    end
    for ii in eachindex(xu_r)
        d = xu_r[ii] - x_ur[ii]
        varphi_R -= d < 0.0 ? T(Inf) : mu_R * log(d)
    end
    for ii in eachindex(pp)
        varphi_R -= pp[ii] < 0.0 ? T(Inf) : mu_R*log(pp[ii])
    end
    for ii in eachindex(nn)
        varphi_R -= nn[ii] < 0.0 ? T(Inf) : mu_R*log(nn[ii])
    end
    return varphi_R
end

function get_F(
    c::AbstractVector{T},
    f,
    zl,
    zu,
    jacl,
    x_lr,
    xl_r,
    zl_r,
    xu_r,
    x_ur,
    zu_r,
    mu,
) where T
    # NOTE: Does not allocate
    F1 = mapreduce(
        abs,
        +,
        c;
        init = zero(T)
    )

    F2 = zero(T)
    for ii in eachindex(f)
        F2 += abs(f[ii]-zl[ii]+zu[ii]+jacl[ii])
    end

    F3 = zero(T)
    for ii in eachindex(x_lr)
        F3 += (x_lr[ii] >= xl_r[ii] && zl_r[ii] >= 0) ? abs((x_lr[ii]-xl_r[ii])*zl_r[ii]-mu) : T(Inf)
    end

    F4 = zero(T)
    for ii in eachindex(xu_r)
        F4 += (xu_r[ii] >= x_ur[ii] && zu_r[ii] >= 0) ? abs((xu_r[ii]-xu_r[ii])*zu_r[ii]-mu) : T(Inf)
    end

    return F1 + F2 + F3 + F4
end

function get_varphi_d_R(
    f_R::AbstractVector{T},
    x::AbstractVector{T},
    xl::AbstractVector{T},
    xu::AbstractVector{T},
    dx::AbstractVector{T},
    pp::AbstractVector{T},
    nn::AbstractVector{T},
    dpp::AbstractVector{T},
    dnn::AbstractVector{T},
    mu_R,
    rho,
) where T
    varphi_d = zero(T)
    for ii in eachindex(f_R)
        varphi_d += (f_R[ii] - mu_R/(x[ii]-xl[ii]) + mu_R/(xu[ii]-x[ii])) * dx[ii]
    end
    for ii in eachindex(pp)
        varphi_d += (rho - mu_R/pp[ii]) * dpp[ii]
    end
    for ii in eachindex(nn)
        varphi_d += (rho - mu_R/nn[ii]) * dnn[ii]
    end
    return varphi_d
end

function _initialize_variables!(x::T, xl, xu, bound_push, bound_fac) where T
    if xl!=-T(Inf) && xu!=T(Inf)
        return min(
            xu-min(bound_push*max(1,abs(xu)), bound_fac*(xu-xl)),
            max(xl+min(bound_push*max(1,abs(xl)),bound_fac*(xu-xl)),x),
        )
    elseif xl!=-T(Inf) && xu==T(Inf)
        return max(xl+bound_push*max(1,abs(xl)), x)
    elseif xl==-T(Inf) && xu!=T(Inf)
        return min(xu-bound_push*max(1,abs(xu)), x)
    end
    return x
end

function initialize_variables!(x, xl, xu, bound_push, bound_fac)
    map!((x,l,u) -> _initialize_variables!(x,l,u, bound_push, bound_fac), x, x, xl, xu)
end

function adjust_boundary!(
    x_lr::AbstractVector{T},
    xl_r::AbstractVector{T},
    x_ur::AbstractVector{T},
    xu_r::AbstractVector{T},
    mu,
) where T
    c1 = eps(T)*mu
    c2 = eps(T)^(3/4)
    map!(
        (x_lr, xl_r) -> (x_lr-xl_r < c1) ? (xl_r - c2*max(1,abs(x_lr))) : xl_r,
        xl_r, x_lr, xl_r
    )
    map!(
        (xu_r, x_ur) -> (xu_r-x_ur < c1) ? (xu_r + c2*max(1,abs(x_ur))) : xu_r,
        xu_r, xu_r, x_ur
    )
end

function get_rel_search_norm(x::AbstractVector{T}, dx::AbstractVector{T}) where T
    rel_search_norm = zero(T)
    for ii in eachindex(x)
        rel_search_norm = max(rel_search_norm, abs(dx[ii]) / (one(T) + abs(x[ii])))
    end
    return rel_search_norm
end

# Utility functions
function get_sd(l, zl_r, zu_r, s_max)
    return max(
        s_max,
        (norm(l, 1)+norm(zl_r, 1)+norm(zu_r, 1)) / max(1, (length(l)+length(zl_r)+length(zu_r))),
    ) / s_max
end
function get_sc(zl_r, zu_r, s_max)
    return max(
        s_max,
        (norm(zl_r,1)+norm(zu_r,1)) / max(1,length(zl_r)+length(zu_r)),
    ) / s_max
end

function get_mu(
    mu::T,
    mu_min,
    mu_linear_decrease_factor,
    mu_superlinear_decrease_power,
    tol,
) where {T}
    # Warning: `a * tol` should be strictly less than 100 * mu_min, see issue #242
    a = min(T(99.0) * mu_min / tol, T(0.01))
    return max(
        mu_min,
        a * tol,
        min(mu_linear_decrease_factor*mu, mu^mu_superlinear_decrease_power),
    )
end

@inline get_tau(mu, tau_min) = max(tau_min, 1-mu)

function get_alpha_min(
    theta,
    varphi_d,
    theta_min,
    gamma_theta,
    gamma_phi,
    alpha_min_frac,
    del,
    s_theta,
    s_phi,
)
    if varphi_d<0
        if theta<=theta_min
            return alpha_min_frac*min(
                gamma_theta,gamma_phi*theta/(-varphi_d),
                del*theta^s_theta/(-varphi_d)^s_phi,
            )
        else
            return alpha_min_frac*min(
                gamma_theta,
                -gamma_phi*theta/varphi_d,
            )
        end
    else
        return alpha_min_frac*gamma_theta
    end
end

function is_switching(varphi_d, alpha, s_phi, del, theta, s_theta)
    return (varphi_d < 0) && (alpha*(-varphi_d)^s_phi > del*theta^s_theta)
end

function is_armijo(varphi_trial, varphi, eta_phi, alpha, varphi_d)
    return (varphi_trial <= varphi + eta_phi*alpha*varphi_d)
end

function is_sufficient_progress(theta_trial::T, theta, gamma_theta, varphi_trial, varphi, gamma_phi, has_constraints) where T
    (has_constraints && ((theta_trial<=(1-gamma_theta)*theta+10*eps(T)*abs(theta))) || ((varphi_trial<=varphi-gamma_phi*theta +10*eps(T)*abs(varphi))))
end

function augment_filter!(filter, theta, varphi, gamma_theta)
    push!(filter, ((1-gamma_theta)*theta, varphi-gamma_theta*theta))
end

function is_filter_acceptable(filter, theta, varphi)
    !isnan(theta) || return false
    !isinf(theta) || return false
    !isnan(varphi) || return false
    !isinf(varphi) || return false

    for (theta_F,varphi_F) in filter
        theta <= theta_F || varphi <= varphi_F || return false
    end
    return true
end

function is_barr_obj_rapid_increase(varphi::T, varphi_trial, obj_max_inc) where T
    return (varphi_trial >= varphi) && (log10(varphi_trial-varphi) > obj_max_inc + max(one(T), log10(abs(varphi))))
end

function reset_bound_dual!(
    z::AbstractVector{T},
    x::AbstractVector{T},
    mu,
    kappa_sigma,
) where T
    map!(
        (z, x) -> max(min(z, (kappa_sigma*mu)/x), (mu/kappa_sigma)/x),
        z, z, x
    )
    return
end

function reset_bound_dual!(
    z::AbstractVector{T},
    x1::AbstractVector{T},
    x2::AbstractVector{T},
    mu,
    kappa_sigma,
) where T
    map!(
        (z,x1,x2) -> max(min(z, (kappa_sigma*mu)/(x1-x2)), (mu/kappa_sigma)/(x1-x2)),
        z,z,x1,x2
    )
    return
end


function get_ftype(filter,theta,theta_trial,varphi,varphi_trial,switching_condition,armijo_condition,
                   theta_min,obj_max_inc,gamma_theta,gamma_phi,has_constraints)
    is_filter_acceptable(filter,theta_trial,varphi_trial) || return " "
    !is_barr_obj_rapid_increase(varphi,varphi_trial,obj_max_inc) || return " "

    if theta <= theta_min && switching_condition
        armijo_condition && return "f"
    else
        is_sufficient_progress(
            theta_trial,theta,gamma_theta,varphi_trial,varphi,gamma_phi,has_constraints) && return "h"
    end

    return " "
end

function dual_inf_perturbation!(px, ind_llb, ind_uub, mu, kappa_d)
    @views begin
        px[ind_llb] .-= mu*kappa_d
        px[ind_uub] .+= mu*kappa_d
    end
end

function populate_RR_nn!(nn, c, mu, rho)
    for ii in eachindex(nn)
        nn[ii] = (mu - rho*c[ii])/(2*rho)+ sqrt(((mu-rho*c[ii])/(2*rho))^2 + mu*c[ii]/(2*rho))
    end
end

function eval_f_wrapper(solver::AbstractMadNLPSolver{T}, x::PrimalVector{T}) where T
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    @trace(get_logger(solver),"Evaluating objective.")
    cnt.eval_function_time += @elapsed begin
        # NOTE: we flip the objective here so the rest of MadNLP internals
        # are the same, between min and max. when showing the objective value
        # to the user (in MadNLPExecutionStats) we flip it back (#517).
        sense = (get_minimize(nlp) ? one(T) : -one(T))
        obj_val = sense * _eval_f_wrapper(get_cb(solver), variable(x))
    end
    cnt.obj_cnt += 1
    if cnt.obj_cnt == 1 && !is_valid(obj_val)
        throw(InvalidNumberException(:obj))
    end
    return obj_val
end

function eval_grad_f_wrapper!(solver::AbstractMadNLPSolver, f::PrimalVector{T}, x::PrimalVector{T}) where T
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    @trace(get_logger(solver),"Evaluating objective gradient.")
    cnt.eval_function_time += @elapsed _eval_grad_f_wrapper!(
        get_cb(solver),
        variable(x),
        variable(f),
    )
    if !get_minimize(nlp)
        variable(f) .*= -one(T)
    end
    cnt.obj_grad_cnt+=1

    if cnt.obj_grad_cnt == 1 && !is_valid(full(f))
        throw(InvalidNumberException(:grad))
    end
    return f
end

function eval_cons_wrapper!(solver::AbstractMadNLPSolver, c::AbstractVector{T}, x::PrimalVector{T}) where T
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    @trace(get_logger(solver), "Evaluating constraints.")
    cnt.eval_function_time += @elapsed _eval_cons_wrapper!(
        get_cb(solver),
        variable(x),
        c,
    )
    view(c,get_ind_ineq(solver)) .-= slack(x)
    c .-= get_rhs(solver)
    cnt.con_cnt+=1
    if cnt.con_cnt == 1 && !is_valid(c)
        throw(InvalidNumberException(:cons))
    end
    return c
end

function eval_jac_wrapper!(solver::AbstractMadNLPSolver, kkt::AbstractKKTSystem, x::PrimalVector{T}) where T
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    ns = length(get_ind_ineq(solver))
    @trace(get_logger(solver), "Evaluating constraint Jacobian.")
    jac = get_jacobian(kkt)
    cnt.eval_function_time += @elapsed _eval_jac_wrapper!(
        get_cb(solver),
        variable(x),
        jac,
        )
    compress_jacobian!(kkt)
    cnt.con_jac_cnt += 1
    if cnt.con_jac_cnt == 1 && !is_valid(jac)
        throw(InvalidNumberException(:jac))
    end
    @trace(get_logger(solver),"Constraint jacobian evaluation started.")
    return jac
end

function eval_lag_hess_wrapper!(solver::AbstractMadNLPSolver, kkt::AbstractKKTSystem, x::PrimalVector{T},l::AbstractVector{T};is_resto=false) where T
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    @trace(get_logger(solver),"Evaluating Lagrangian Hessian.")
    hess = get_hessian(kkt)
    scale = (get_minimize(nlp) ? one(T) : -one(T)) * (is_resto ? zero(T) : one(T))
    cnt.eval_function_time += @elapsed _eval_lag_hess_wrapper!(
        get_cb(solver),
        variable(x),
        l,
        hess;
        obj_weight = scale,
    )
    compress_hessian!(kkt)
    cnt.lag_hess_cnt += 1
    if cnt.lag_hess_cnt == 1 && !is_valid(hess)
        throw(InvalidNumberException(:hess))
    end
    return hess
end

function eval_jac_wrapper!(solver::AbstractMadNLPSolver, kkt::AbstractDenseKKTSystem, x::PrimalVector{T}) where T
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    ns = length(get_ind_ineq(solver))
    @trace(get_logger(solver), "Evaluating constraint Jacobian.")
    jac = get_jacobian(kkt)
    cnt.eval_function_time += @elapsed _eval_jac_wrapper!(
        get_cb(solver),
        variable(x),
        jac,
    )
    compress_jacobian!(kkt)
    cnt.con_jac_cnt+=1
    if cnt.con_jac_cnt == 1 && !is_valid(jac)
        throw(InvalidNumberException(:jac))
    end
    @trace(get_logger(solver),"Constraint jacobian evaluation started.")
    return jac
end

function eval_lag_hess_wrapper!(
    solver::AbstractMadNLPSolver,
    kkt::AbstractDenseKKTSystem{T, VT, MT, QN},
    x::PrimalVector{T},
    l::AbstractVector{T};
    is_resto=false,
) where {T, VT, MT, QN<:ExactHessian}
    nlp = get_nlp(solver)
    cnt = get_cnt(solver)
    @trace(get_logger(solver),"Evaluating Lagrangian Hessian.")
    hess = get_hessian(kkt)
    scale = is_resto ? zero(T) : get_minimize(nlp) ? one(T) : -one(T)
    cnt.eval_function_time += @elapsed _eval_lag_hess_wrapper!(
        get_cb(solver),
        variable(x),
        l,
        hess;
        obj_weight = scale,
    )
    compress_hessian!(kkt)
    cnt.lag_hess_cnt+=1
    if cnt.lag_hess_cnt == 1 && !is_valid(hess)
        throw(InvalidNumberException(:hess))
    end
    return hess
end

function eval_lag_hess_wrapper!(
    solver::AbstractMadNLPSolver,
    kkt::AbstractKKTSystem{T, VT, MT, QN},
    x::PrimalVector{T},
    l::AbstractVector{T};
    is_resto=false,
) where {T, VT, MT<:AbstractMatrix{T}, QN<:AbstractQuasiNewton{T, VT}}
    cb = get_cb(solver)
    cnt = get_cnt(solver)
    @trace(get_logger(solver), "Update BFGS matrices.")

    qn = kkt.quasi_newton
    Bk = kkt.hess
    sk, yk = qn.sk, qn.yk
    n = length(qn.sk)
    m = size(kkt.jac, 1)

    if cnt.obj_grad_cnt >= 2
        # Build sk = x+ - x
        copyto!(sk, 1, variable(get_x(solver)), 1, n)   # sₖ = x₊
        axpy!(-one(T), qn.last_x, sk)              # sₖ = x₊ - x
        # Build yk = ∇L+ - ∇L
        copyto!(yk, 1, variable(get_f(solver)), 1, n)   # yₖ = ∇f₊
        axpy!(-one(T), qn.last_g, yk)              # yₖ = ∇f₊ - ∇f
        if m > 0
            jtprod!(get_jacl(solver), kkt, l)
            yk .+= @view(get_jacl(solver)[1:n])         # yₖ += J₊ᵀ l₊
            _eval_jtprod_wrapper!(cb, qn.last_x, l, qn.last_jv)
            axpy!(-one(T), qn.last_jv, yk)         # yₖ += J₊ᵀ l₊ - Jᵀ l₊
        end
        # Update quasi-Newton approximation.
        update!(qn, Bk, sk, yk)
    else
        # Init quasi-Newton approximation
        g0 = variable(get_f(solver))
        f0 = get_obj_val(solver)
        init!(qn, Bk, g0, f0)
    end

    # Backup data for next step
    copyto!(qn.last_x, 1, variable(get_x(solver)), 1, n)
    copyto!(qn.last_g, 1, variable(get_f(solver)), 1, n)

    compress_hessian!(kkt)
    return get_hessian(kkt)
end

# File adapted from Pardiso.jl:
# https://github.com/JuliaSparse/Pardiso.jl/blob/master/deps/build.jl
#
# The Pardiso.jl package is licensed under the MIT "Expat" License:
#   Copyright (c) 2015-2020: Kristoffer Carlsson, Julia Computing
#
# Original LICENSE file: https://github.com/JuliaSparse/Pardiso.jl/blob/master/LICENSE.md

# remove deps.jl if it exists, in case build.jl fails
isfile("deps.jl") && rm("deps.jl")

using Libdl

println("Pardiso library")
println("===============")

const LIBPARDISONAMES = if Sys.iswindows()
    ["libpardiso.dll", "libpardiso600-WIN-X86-64.dll"]
elseif Sys.isapple()
    ["libpardiso.dylib", "libpardiso600-MACOS-X86-64.dylib"]
elseif Sys.islinux()
    ["libpardiso.so", "libpardiso600-GNU800-X86-64.so"]
else
    error("unhandled OS")
end

println("Looking for libraries with name: ", join(LIBPARDISONAMES, ", "), ".")

PATH_PREFIXES = [@__DIR__; get(ENV, "JULIA_PARDISO", [])]

if !haskey(ENV, "JULIA_PARDISO")
    println(
        "INFO: use the `JULIA_PARDISO` environment variable to set a path to " *
        "the folder where the Pardiso library is located",
    )
end

function find_paradisolib()
    found_lib = false
    for prefix in PATH_PREFIXES
        println("Looking in \"$(abspath(prefix))\" for libraries")
        for libname in LIBPARDISONAMES
            local path
            try
                path = joinpath(prefix, libname)
                if isfile(path)
                    println("    found \"$(abspath(path))\", attempting to load it...")
                    Libdl.dlopen(path, Libdl.RTLD_GLOBAL)
                    println("    loaded successfully!")
                    global PARDISO_LIB_FOUND = true
                    return path, true
                end
            catch e
                println("    failed to load due to:")
                Base.showerror(stderr, e)
            end
        end
    end
    println("did not find libpardiso, assuming Panua PARDISO is not installed")
    return "", false
end

pardisopath, found_pardisolib = find_paradisolib()

#################################################

println("\nMKL Pardiso")
println("=============")
function find_mklparadiso()
    if haskey(ENV, "MKLROOT")
        println("found MKLROOT environment variable, enabling local MKL")
        return true
    end
    println("did not find MKLROOT environment variable, using MKL_jll")
    return false
end

found_mklpardiso = find_mklparadiso()

open("deps.jl", "w") do f
    return print(
        f,
        """
        const LOCAL_MKL_FOUND = $found_mklpardiso
        const PARDISO_LIB_FOUND = $found_pardisolib
        const PARDISO_PATH = raw"$pardisopath"
        """,
    )
end

"""
    update_barrier!(barrier::AbstractBarrierUpdate{T}, solver::AbstractMadNLPSolver{T}, sc::T) where T

Update barrier using the rule in `barrier`. Store the results in `solver.mu`.

"""
function update_barrier! end

# Implement monotone update in a dedicated function as this code is reused
# throughout all the barrier updates.
function _update_monotone!(
    barrier::AbstractBarrierUpdate{T},
    solver::AbstractMadNLPSolver{T},
    sc::T
) where T
    set_inf_compl_mu!(solver, get_inf_compl(solver, sc))
    while (get_mu(solver) > max(barrier.mu_min, get_opt(solver).tol/10)) &&
        (get_inf_barrier(solver) <= get_opt(solver).barrier_tol_factor*get_mu(solver))
        mu_new = get_mu(
            get_mu(solver),
            barrier.mu_min,
            barrier.mu_linear_decrease_factor,
            barrier.mu_superlinear_decrease_power,
            get_opt(solver).tol,
        )
        set_inf_compl_mu!(solver, get_inf_compl(solver, sc))
        set_tau!(solver, get_tau(get_mu(solver), get_opt(solver).tau_min))
        set_mu!(solver, mu_new)
        empty!(get_filter(solver))
        push!(get_filter(solver), (get_theta_max(solver), -Inf))
    end
    return
end

# Implement monotone update for feasibility restoration.
# N.B: we always fallack to monotone update for restoration, no matter
# the barrier update being used in the regular phase.
function _update_monotone_RR!(
    barrier::AbstractBarrierUpdate{T},
    solver::AbstractMadNLPSolver{T},
    sc::T
) where T
    RR = get_RR(solver)
    inf_compl_mu_R = get_inf_compl_R(
        get_x_lr(solver),
        get_xl_r(solver),
        get_zl_r(solver),
        get_xu_r(solver),
        get_x_ur(solver),
        get_zu_r(solver),
        RR.pp,
        RR.zp,
        RR.nn,
        RR.zn,
        RR.mu_R,
        sc,
    )
    while RR.mu_R >= barrier.mu_min &&
        max(RR.inf_pr_R,RR.inf_du_R,inf_compl_mu_R) <= get_opt(solver).barrier_tol_factor*RR.mu_R
        RR.mu_R = get_mu(
            RR.mu_R,
            barrier.mu_min,
            barrier.mu_linear_decrease_factor,
            barrier.mu_superlinear_decrease_power,
            get_opt(solver).tol,
        )
        inf_compl_mu_R = get_inf_compl_R(
            get_x_lr(solver),
            get_xl_r(solver),
            get_zl_r(solver),
            get_xu_r(solver),
            get_x_ur(solver),
            get_zu_r(solver),
            RR.pp,
            RR.zp,
            RR.nn,
            RR.zn,
            RR.mu_R,
            sc,
        )
        RR.tau_R= max(get_opt(solver).tau_min,1-RR.mu_R)
        RR.zeta = sqrt(RR.mu_R)
        empty!(RR.filter)
        push!(RR.filter,(get_theta_max(solver),-Inf))
    end
    return
end

function update_barrier!(barrier::MonotoneUpdate{T}, solver::AbstractMadNLPSolver{T}, sc::T) where T
    _update_monotone!(barrier, solver, sc)
end

#=
    Adaptive updates
=#

# Initial barrier parameter used when we fallback to the monotone barrier update.
function get_fixed_mu(solver::AbstractMadNLPSolver{T}, barrier::AbstractAdaptiveUpdate{T}) where T
    mu = T(0.8) * get_average_complementarity(solver)
    return clamp(mu, barrier.mu_min, barrier.mu_max)
end

function _check_progress(barrier::AbstractAdaptiveUpdate{T}, solver::AbstractMadNLPSolver{T}) where T
    if !barrier.globalization
        return true
    end
    kappa_1 = T(1e-5) # filter margin width
    kappa_2 = T(1.0)  # filter margin maximum width
    # Check current progress using filter line search
    theta = get_theta(get_c(solver))
    varphi = get_varphi(get_obj_val(solver), get_x_lr(solver), get_xl_r(solver), get_xu_r(solver), get_x_ur(solver), get_mu(solver))
    kkt_error = max(get_inf_pr(solver), get_inf_du(solver), get_inf_compl(solver))
    delta = kappa_1 * min(kappa_2, kkt_error)
    return is_filter_acceptable(get_filter(solver), theta + delta, varphi + delta)
end

function update_barrier!(barrier::AbstractAdaptiveUpdate{T}, solver::AbstractMadNLPSolver{T}, sc::T) where T
    old_mu = get_mu(solver)
    progress = _check_progress(barrier, solver)
    # Update state of barrier algorithm
    if !barrier.free_mode
        if progress
            @trace(get_logger(solver), "Moving adaptive barrier back to free mode.")
            barrier.free_mode = true
        else
            _update_monotone!(barrier, solver, sc)
        end
    else
        if !progress
            @trace(get_logger(solver), "Moving adaptive barrier to monotone mode.")
            barrier.free_mode = false
            # Reset barrier parameter using current average complementarity
            set_mu!(solver, get_fixed_mu(solver, barrier))
        else
            @trace(get_logger(solver), "Keeping adaptive barrier in free mode.")
        end
    end
    if barrier.free_mode
        set_mu!(solver, get_adaptive_mu(solver, barrier))
    end
    # Update tau and reset filter is barrier has been updated
    if get_mu(solver) != old_mu
        set_tau!(solver, get_tau(get_mu(solver), get_opt(solver).tau_min))
        empty!(get_filter(solver))
        push!(get_filter(solver), (get_theta_max(solver), -Inf))
    end
    return
end

# Evaluate the linear quality function described in [Nocedal2009, Eq. (4.2)]
function _evaluate_quality_function(solver, sigma, step_aff, step_cen, res_dual, res_primal)
    n, m = get_n(solver), get_m(solver)
    nlb, nub = get_nlb(solver), get_nub(solver)
    tau = get_tau(solver)
    d = get_d(solver) # Load buffer
    # Δ(σ) = Δ_aff + σ Δ_cen
    full(d) .= full(step_aff) .+ sigma .* full(step_cen)
    # Primal step
    alpha_pr = get_alpha_max(
        primal(get_x(solver)),
        primal(get_xl(solver)),
        primal(get_xu(solver)),
        primal(d),
        tau,
    )
    # Dual step
    alpha_du = get_alpha_z(
        get_zl_r(solver),
        get_zu_r(solver),
        dual_lb(d),
        dual_ub(d),
        tau,
    )
    # ||(X + αp ΔX - Xl) (Zl + αd ΔZl)||^2
    inf_compl_lb = mapreduce(
        (x, xl, dx, z, dz) -> ((x + alpha_pr * dx - xl) * (z + alpha_du * dz))^2,
        +,
        get_x_lr(solver), get_xl_r(solver), get_dx_lr(solver), get_zl_r(solver), dual_lb(d);
        init=0.0,
    )

    # ||(Xu - X - αp ΔX) (Zu + αd ΔZu)||^2
    inf_compl_ub = mapreduce(
        (x, xu, dx, z, dz) -> ((xu - x - alpha_pr * dx) * (z + alpha_du * dz))^2,
        +,
        get_x_ur(solver), get_xu_r(solver), get_dx_ur(solver), get_zu_r(solver), dual_ub(d);
        init=0.0,
    )
    # Primal infeasibility
    inf_pr = (m > 0) ? (1.0 - alpha_pr)^2 * res_primal^2 / m : 0.0
    # Dual infeasibility
    inf_du = (1.0 - alpha_du)^2 * res_dual^2 / n
    # Complementarity infeasibility
    inf_compl = (inf_compl_lb + inf_compl_ub ) / (nlb + nub)

    @debug(get_logger(solver), @sprintf("sigma=%4.1e inf_pr=%4.2e inf_du=%4.2e inf_cc=%4.2e a_pr=%4.2e a_du=%4.2e", sigma, inf_pr, inf_du, inf_compl, alpha_pr, alpha_du))

    # Return quality function qL defined in Eq. (4.2)
    return inf_du + inf_pr + inf_compl
end

# Golden search algorithm to find a minimum of the linear quality function.
# The algorithm assumes the quality function is unimodular.
function _run_golden_search!(solver, barrier, sigma_lb, sigma_ub, step_aff, step_cen, res_primal, res_dual)
    gfac = 0.5 * (3.0 - sqrt(5.0))
    sigma_1, sigma_2 = sigma_lb, sigma_ub
    # Initiate Golden search
    phi_1 = _evaluate_quality_function(solver, sigma_1, step_aff, step_cen, res_primal, res_dual)
    phi_2 = _evaluate_quality_function(solver, sigma_2, step_aff, step_cen, res_primal, res_dual)
    sigma_1_in, sigma_2_in, phi_1_in, phi_2_in = sigma_1, sigma_2, phi_1, phi_2
    sigma_mid1 = sigma_lb + gfac * (sigma_ub - sigma_lb)
    sigma_mid2 = sigma_lb + (1.0 - gfac) * (sigma_ub - sigma_lb)
    phi_mid1 = _evaluate_quality_function(solver, sigma_mid1, step_aff, step_cen, res_primal, res_dual)
    phi_mid2 = _evaluate_quality_function(solver, sigma_mid2, step_aff, step_cen, res_primal, res_dual)
    # Run Golden search
    for i in 1:barrier.max_gs_iter
        if phi_mid1 > phi_mid2
            sigma_1 = sigma_mid1
            phi_1 = phi_mid1
            sigma_mid1 = sigma_mid2
            sigma_mid2 = sigma_1 + (1.0 - gfac) * (sigma_2 - sigma_1)
            phi_mid1 = phi_mid2
            phi_mid2 = _evaluate_quality_function(solver, sigma_mid2, step_aff, step_cen, res_primal, res_dual)
        else
            sigma_2 = sigma_mid2
            phi_2 = phi_mid2
            sigma_mid2 = sigma_mid1
            sigma_mid1 = sigma_1 + gfac * (sigma_2 - sigma_1)
            phi_mid1 = _evaluate_quality_function(solver, sigma_mid1, step_aff, step_cen, res_primal, res_dual)
            phi_mid2 = phi_mid1
        end
        if (sigma_2 - sigma_1 < barrier.sigma_tol * sigma_2)
            break
        end
    end
    # Compute final sigma
    sigma, phi = phi_mid1 < phi_mid2 ? (sigma_mid1, phi_mid1) : (sigma_mid2, phi_mid2)
    # Take into account that most the time the algorithm hasn't converged.
    if sigma_2 == sigma_2_in && phi_2_in < phi
        sigma = sigma_2_in
    elseif sigma_1 == sigma_1_in && phi_1_in < phi
        sigma = sigma_1_in
    end
    return sigma
end

function set_centering_aug_rhs!(solver::AbstractMadNLPSolver, kkt::AbstractKKTSystem, mu)
    px = primal(get_p(solver))
    py = dual(get_p(solver))
    pzl = dual_lb(get_p(solver))
    pzu = dual_ub(get_p(solver))
    px .= 0
    py .= 0
    pzl .= mu
    pzu .= -mu
    return
end

function get_adaptive_mu(solver::AbstractMadNLPSolver{T}, barrier::QualityFunctionUpdate{T}) where T
    # No inequality constraint: early return as barrier update is useless
    if get_nlb(solver) + get_nub(solver) == 0
        return barrier.mu_min
    end
    step_aff = get__w3(solver) # buffer 1
    step_cen = get__w4(solver) # buffer 2
    # Affine step
    set_aug_rhs!(solver, get_kkt(solver), get_c(solver), zero(T))
    # Get primal and dual infeasibility directly from the values in RHS p
    res_primal = norm(dual(get_p(solver)))
    res_dual = norm(primal(get_p(solver)))
    # Get approximate solution without iterative refinement
    copyto!(full(step_aff), full(get_p(solver)))
    solve_kkt!(get_kkt(solver), step_aff)
    # Get average complementarity
    mu = get_average_complementarity(solver)
    # Centering step
    set_centering_aug_rhs!(solver, get_kkt(solver), mu)
    # NOTE(@anton) Ipopt also applies the dual infeasibility perturbation for some reason???
    dual_inf_perturbation!(primal(get_p(solver)),get_ind_llb(solver),get_ind_uub(solver),mu,get_opt(solver).kappa_d)
    # Get (again) approximate solution without iterative refinement
    copyto!(full(step_cen), full(get_p(solver)))
    solve_kkt!(get_kkt(solver), step_cen)
    # Refine the search interval using Ipopt's heuristics
    # First, check if sigma is greater than 1.
    phi1 = _evaluate_quality_function(solver, one(T), step_aff, step_cen, res_primal, res_dual)
    sigma_1m = one(T) - T(1e-4)
    phi1m = _evaluate_quality_function(solver, sigma_1m, step_aff, step_cen, res_primal, res_dual)
    # Restrict search interval
    if phi1m > phi1
        sigma_min = one(T)
        sigma_max = min(barrier.sigma_max, barrier.mu_max / mu)
    else
        sigma_min = max(barrier.sigma_min, barrier.mu_min / mu)
        sigma_max = min(max(sigma_min, sigma_1m), barrier.mu_max / mu)
    end
    # Run Golden-section search (assume the quality function is unimodal)
    sigma_opt = _run_golden_search!(solver, barrier, sigma_min, sigma_max, step_aff, step_cen, res_primal, res_dual)
    # Increment counter
    barrier.n_update += 1
    return clamp(sigma_opt * mu, barrier.mu_min, barrier.mu_max)
end

function get_adaptive_mu(solver::AbstractMadNLPSolver{T}, barrier::LOQOUpdate{T}) where T
    # No inequality constraint: early return as barrier update is useless
    if get_nlb(solver) + get_nub(solver) == 0
        return barrier.mu_min
    end
    mu = get_average_complementarity(solver) # get average complementarity.
    ncc = get_nlb(solver) + get_nub(solver)
    min_cc = get_min_complementarity(solver)
    xi = min_cc/mu
    sigma = barrier.gamma*min((1-barrier.r)*((1-xi)/xi),2)^3
    mu = clamp(sigma * mu, barrier.mu_min, barrier.mu_max)
    return mu
end

######################################################
##### GPU wrappers for SparseCondensedKKTSystem  #####
######################################################

# Generic GPU sparse functions dispatching on AbstractGPUVector / AbstractGPUArray.
# Per-backend stubs for functions needing concrete sparse CSC types
# (transfer!, nzval, _get_sparse_csc, get_tril_to_full, _sym_length)
# remain in per-extension files.

#=
    MadNLP.mul! with SparseCondensedKKTSystem + GPU
=#

function MadNLP.mul!(
        w::MadNLP.AbstractKKTVector{T, VT},
        kkt::MadNLP.SparseCondensedKKTSystem,
        x::MadNLP.AbstractKKTVector,
        alpha = one(T),
        beta = zero(T),
    ) where {T, VT <: AbstractGPUVector{T}}
    n = size(kkt.hess_com, 1)
    m = size(kkt.jt_csc, 2)

    # Decompose results
    xx = view(MadNLP.full(x), 1:n)
    xs = view(MadNLP.full(x), (n + 1):(n + m))
    xz = view(MadNLP.full(x), (n + m + 1):(n + 2 * m))

    # Decompose buffers
    wx = view(MadNLP.full(w), 1:n)
    ws = view(MadNLP.full(w), (n + 1):(n + m))
    wz = view(MadNLP.full(w), (n + m + 1):(n + 2 * m))

    MadNLP.mul!(wx, kkt.hess_com, xx, alpha, beta)
    MadNLP.mul!(wx, kkt.hess_com', xx, alpha, one(T))
    MadNLP.mul!(wx, kkt.jt_csc, xz, alpha, beta)
    if !isempty(kkt.ext.diag_map_to)
        backend = get_backend(MadNLP.full(w))
        _diag_operation_kernel!(backend)(
            wx,
            kkt.hess_com.nzVal,
            xx,
            alpha,
            kkt.ext.diag_map_to,
            kkt.ext.diag_map_fr;
            ndrange = length(kkt.ext.diag_map_to),
        )
    end

    MadNLP.mul!(wz, kkt.jt_csc', xx, alpha, one(T))
    MadNLP.axpy!(-alpha, xz, ws)
    MadNLP.axpy!(-alpha, xs, wz)
    return MadNLP._kktmul!(
        w,
        x,
        kkt.reg,
        kkt.du_diag,
        kkt.l_lower,
        kkt.u_lower,
        kkt.l_diag,
        kkt.u_diag,
        alpha,
        beta,
    )
end

function MadNLP.mul_hess_blk!(
        wx::VT,
        kkt::Union{MadNLP.SparseKKTSystem, MadNLP.SparseCondensedKKTSystem},
        t,
    ) where {T, VT <: AbstractGPUVector{T}}
    n = size(kkt.hess_com, 1)
    wxx = @view(wx[1:n])
    tx = @view(t[1:n])

    MadNLP.mul!(wxx, kkt.hess_com, tx, one(T), zero(T))
    MadNLP.mul!(wxx, kkt.hess_com', tx, one(T), one(T))
    if !isempty(kkt.ext.diag_map_to)
        backend = get_backend(wx)
        _diag_operation_kernel!(backend)(
            wxx,
            kkt.hess_com.nzVal,
            tx,
            one(T),
            kkt.ext.diag_map_to,
            kkt.ext.diag_map_fr;
            ndrange = length(kkt.ext.diag_map_to),
        )
    end

    fill!(@view(wx[(n + 1):end]), 0)
    wx .+= t .* kkt.pr_diag
    return
end

#=
    get_sparse_condensed_ext
=#

function MadNLP.get_sparse_condensed_ext(
        ::Type{VT},
        hess_com,
        jptr,
        jt_map,
        hess_map,
    ) where {T, VT <: AbstractGPUVector{T}}
    zvals = adapt(get_backend(hess_map), collect(1:length(hess_map)))
    hess_com_ptr = map((i, j) -> (i, j), hess_map, zvals)
    if length(hess_com_ptr) > 0 # otherwise error is thrown
        sort!(hess_com_ptr)
    end

    jvals = adapt(get_backend(jt_map), collect(1:length(jt_map)))
    jt_csc_ptr = map((i, j) -> (i, j), jt_map, jvals)
    if length(jt_csc_ptr) > 0 # otherwise error is thrown
        sort!(jt_csc_ptr)
    end

    by = (i, j) -> i[1] != j[1]
    jptrptr = MadNLP.getptr(jptr, by = by)
    hess_com_ptrptr = MadNLP.getptr(hess_com_ptr, by = by)
    jt_csc_ptrptr = MadNLP.getptr(jt_csc_ptr, by = by)

    diag_map_to, diag_map_fr = get_diagonal_mapping(hess_com.colPtr, hess_com.rowVal)

    return (
        jptrptr = jptrptr,
        hess_com_ptr = hess_com_ptr,
        hess_com_ptrptr = hess_com_ptrptr,
        jt_csc_ptr = jt_csc_ptr,
        jt_csc_ptrptr = jt_csc_ptrptr,
        diag_map_to = diag_map_to,
        diag_map_fr = diag_map_fr,
    )
end

#=
    get_diagonal_mapping
=#

function get_diagonal_mapping(colptr, rowval)
    nnz = length(rowval)
    if nnz == 0
        return similar(colptr, 0), similar(colptr, 0)
    end
    inds1 = findall(
        map(
            (x, y) -> ((x <= nnz) && (x != y)),
            @view(colptr[1:(end - 1)]),
            @view(colptr[2:end])
        ),
    )
    if length(inds1) == 0
        return similar(rowval, 0), similar(colptr, 0)
    end
    ptrs = colptr[inds1]
    rows = rowval[ptrs]
    inds2 = findall(inds1 .== rows)
    if length(inds2) == 0
        return similar(rows, 0), similar(ptrs, 0)
    end

    return rows[inds2], ptrs[inds2]
end

#=
    MadNLP._first_and_last_col
=#

function MadNLP._first_and_last_col(sym2::AbstractGPUVector, ptr2)
    @allowscalar begin
        first = sym2[1][2]
        last = sym2[ptr2[end]][2]
    end
    return (first, last)
end

#=
    getij helper
=#

function getij(idx, n)
    j = ceil(Int, ((2n + 1) - sqrt((2n + 1)^2 - 8 * idx)) / 2)
    i = idx - div((j - 1) * (2n - j), 2)
    return (i, j)
end

#=
    MadNLP._set_colptr!
=#

function MadNLP._set_colptr!(colptr::AbstractGPUVector, ptr2, sym2, guide)
    if length(ptr2) > 1 # otherwise error is thrown
        backend = get_backend(colptr)
        _set_colptr_kernel!(backend)(
            colptr,
            sym2,
            ptr2,
            guide;
            ndrange = length(ptr2) - 1,
        )
    end
    return
end

#=
    MadNLP.tril_to_full! (dense GPU matrix version)
=#

function MadNLP.tril_to_full!(dense::AbstractGPUMatrix{T}) where {T}
    n = size(dense, 1)
    backend = get_backend(dense)
    _tril_to_full_kernel!(backend)(dense; ndrange = div(n^2 + n, 2))
    return
end

#=
    MadNLP.force_lower_triangular!
=#

function MadNLP.force_lower_triangular!(I::AbstractGPUVector{T}, J) where {T}
    if !isempty(I)
        backend = get_backend(I)
        _force_lower_triangular_kernel!(backend)(I, J; ndrange = length(I))
    end
    return
end

#=
    MadNLP._set_con_scale_sparse!
=#

function MadNLP._set_con_scale_sparse!(
        con_scale::VT,
        jac_I,
        jac_buffer,
    ) where {T, VT <: AbstractGPUVector{T}}
    ind_jac = adapt(get_backend(jac_I), collect(1:length(jac_I)))
    inds = map((i, j) -> (i, j), jac_I, ind_jac)
    !isempty(inds) && sort!(inds)
    ptr = MadNLP.getptr(inds; by = ((x1, x2), (y1, y2)) -> x1 != y1)
    if length(ptr) > 1
        backend = get_backend(con_scale)
        _set_con_scale_sparse_kernel!(backend)(
            con_scale,
            ptr,
            inds,
            jac_I,
            jac_buffer;
            ndrange = length(ptr) - 1,
        )
    end
    return
end

#=
    MadNLP.coo_to_csc
=#

function MadNLP.coo_to_csc(
        coo::MadNLP.SparseMatrixCOO{T, I, VT, VI},
    ) where {T, I, VT <: AbstractGPUArray, VI <: AbstractGPUArray}
    zvals = adapt(get_backend(coo.I), collect(1:length(coo.I)))
    coord = map((i, j, k) -> ((i, j), k), coo.I, coo.J, zvals)
    if length(coord) > 0
        sort!(coord, lt = (((i, j), k), ((n, m), l)) -> (j, i) < (m, n))
    end

    mapptr = MadNLP.getptr(coord; by = ((x1, x2), (y1, y2)) -> x1 != y1)

    colptr = similar(coo.I, size(coo, 2) + 1)

    coord_csc = coord[@view(mapptr[1:(end - 1)])]

    backend = get_backend(coo.I)
    if length(coord_csc) > 0
        _set_coo_to_colptr_kernel!(backend)(
            colptr,
            coord_csc,
            ndrange = length(coord_csc),
        )
    else
        fill!(colptr, one(Int))
    end

    rowval = map(x -> x[1][1], coord_csc)
    nzval = similar(rowval, T)

    csc = MadNLP._get_sparse_csc(size(coo), colptr, rowval, nzval)

    cscmap = similar(coo.I, Int)
    if length(mapptr) > 1
        _set_coo_to_csc_map_kernel!(backend)(
            cscmap,
            mapptr,
            coord,
            ndrange = length(mapptr) - 1,
        )
    end

    return csc, cscmap
end

#=
    MadNLP.build_condensed_aug_coord!
=#

function MadNLP.build_condensed_aug_coord!(
        kkt::MadNLP.AbstractCondensedKKTSystem{T, VT},
    ) where {T, VT <: AbstractGPUVector{T}}
    fill!(MadNLP.nzval(kkt.aug_com), zero(T))
    backend = get_backend(kkt.pr_diag)
    if length(kkt.hptr) > 0
        _transfer_hessian_kernel!(backend)(
            MadNLP.nzval(kkt.aug_com),
            kkt.hptr,
            MadNLP.nzval(kkt.hess_com);
            ndrange = length(kkt.hptr),
        )
    end
    if length(kkt.dptr) > 0
        _transfer_hessian_kernel!(backend)(
            MadNLP.nzval(kkt.aug_com),
            kkt.dptr,
            kkt.pr_diag;
            ndrange = length(kkt.dptr),
        )
    end
    if length(kkt.ext.jptrptr) > 1 # otherwise error is thrown
        _transfer_jtsj_kernel!(backend)(
            MadNLP.nzval(kkt.aug_com),
            kkt.jptr,
            kkt.ext.jptrptr,
            MadNLP.nzval(kkt.jt_csc),
            kkt.diag_buffer;
            ndrange = length(kkt.ext.jptrptr) - 1,
        )
    end
    return
end

#=
    MadNLP.compress_hessian!
=#

function MadNLP.compress_hessian!(
        kkt::MadNLP.AbstractSparseKKTSystem{T, VT},
    ) where {T, VT <: AbstractGPUVector{T}}
    fill!(MadNLP.nzval(kkt.hess_com), zero(T))
    backend = get_backend(kkt.pr_diag)
    if length(kkt.ext.hess_com_ptrptr) > 1
        _transfer_to_csc_kernel!(backend)(
            MadNLP.nzval(kkt.hess_com),
            kkt.ext.hess_com_ptr,
            kkt.ext.hess_com_ptrptr,
            kkt.hess_raw.V;
            ndrange = length(kkt.ext.hess_com_ptrptr) - 1,
        )
    end
    return
end

#=
    MadNLP.compress_jacobian!
=#

function MadNLP.compress_jacobian!(
        kkt::MadNLP.SparseCondensedKKTSystem{T, VT},
    ) where {T, VT <: AbstractGPUVector{T}}
    fill!(MadNLP.nzval(kkt.jt_csc), zero(T))
    backend = get_backend(kkt.pr_diag)
    if length(kkt.ext.jt_csc_ptrptr) > 1 # otherwise error is thrown
        _transfer_to_csc_kernel!(backend)(
            MadNLP.nzval(kkt.jt_csc),
            kkt.ext.jt_csc_ptr,
            kkt.ext.jt_csc_ptrptr,
            kkt.jt_coo.V;
            ndrange = length(kkt.ext.jt_csc_ptrptr) - 1,
        )
    end
    return
end

#=
    MadNLP._build_condensed_aug_symbolic_hess
=#

function MadNLP._build_condensed_aug_symbolic_hess(
        H,
        sym,
        sym2::AbstractGPUVector,
    )
    if size(H, 2) > 0
        backend = get_backend(sym2)
        _build_condensed_aug_symbolic_hess_kernel!(backend)(
            sym,
            sym2,
            H.colPtr,
            H.rowVal;
            ndrange = size(H, 2),
        )
    end
    return
end

#=
    MadNLP._build_condensed_aug_symbolic_jt
=#

function MadNLP._build_condensed_aug_symbolic_jt(
        Jt,
        sym,
        sym2::AbstractGPUVector,
    )
    if size(Jt, 2) > 0
        _offsets = map(
            (i, j) -> div((j - i)^2 + (j - i), 2),
            @view(Jt.colPtr[1:(end - 1)]),
            @view(Jt.colPtr[2:end])
        )
        offsets = cumsum(_offsets)
        backend = get_backend(sym2)
        _build_condensed_aug_symbolic_jt_kernel!(backend)(
            sym,
            sym2,
            Jt.colPtr,
            Jt.rowVal,
            offsets;
            ndrange = size(Jt, 2),
        )
    end
    return
end

#=
    MadNLP._build_scale_augmented_system_coo!
=#

function MadNLP._build_scale_augmented_system_coo!(dest, src, scaling::AbstractGPUArray, n, m)
    backend = get_backend(scaling)
    _scale_augmented_system_coo_kernel!(backend)(
        dest.V,
        src.I,
        src.J,
        src.V,
        scaling,
        n,
        m;
        ndrange = nnz(src),
    )
    return
end

setindex(tup,a,n) = (tup[1:n-1]...,a,tup[n+1:end]...)
tzeros(n) = tuple((0 for i=1:n)...)

@kwdef mutable struct MumpsOptions <: AbstractOptions
    mumps_mem_percent::Int = 35
    mumps_permuting_scaling::Int = 0
    mumps_pivot_order::Int = 0
    mumps_pivtol::Float64 = 1e-6
    mumps_pivtolmax::Float64 = 1e-1
    mumps_scaling::Int = 1
end

@kwdef mutable struct Struc{T}
    sym::Cint = 0
    par::Cint = 0
    job::Cint = 0

    comm_fortran::Cint = 0

    icntl::NTuple{60,Cint} = tzeros(60)
    keep::NTuple{500,Cint} = tzeros(500)
    cntl::NTuple{15,T} = tzeros(15)
    dkeep::NTuple{230,T} = tzeros(230)
    keep8::NTuple{150,Int64} = tzeros(150)
    n::Cint = 0
    nblk::Cint = 0

    nz_alloc::Cint = 0

    nz::Cint = 0
    nnz::Int64 = 0
    irn::Ptr{Cint} = C_NULL
    jcn::Ptr{Cint} = C_NULL
    a::Ptr{T} = C_NULL

    nz_loc::Cint = 0
    nnz_loc::Int64 = 0
    irn_loc::Ptr{Cint} = C_NULL
    jcn_loc::Ptr{Cint} = C_NULL
    a_loc::Ptr{T} = C_NULL ###

    nelt::Cint = 0
    eltptr::Ptr{Cint} = C_NULL
    eltvar::Ptr{Cint} = C_NULL
    a_elt::Ptr{T} = C_NULL

    blkptr::Ptr{Cint} = C_NULL
    blkvar::Ptr{Cint} = C_NULL

    perm_in::Ptr{Cint} = C_NULL

    sym_perm::Ptr{Cint} = C_NULL
    uns_perm::Ptr{Cint} = C_NULL

    colsca::Ptr{T} = C_NULL
    rowsca::Ptr{T} = C_NULL
    colsca_from_mumps::Cint = 0
    rowsca_from_mumps::Cint = 0

    colsca_loc::Ptr{T} = C_NULL
    rowsca_loc::Ptr{T} = C_NULL

    rowind::Ptr{Cint} = C_NULL
    colind::Ptr{Cint} = C_NULL
    pivots::Ptr{T} = C_NULL

    rhs::Ptr{T} = C_NULL
    redrhs::Ptr{T} = C_NULL
    rhs_sparse::Ptr{T} = C_NULL
    sol_loc::Ptr{T} = C_NULL
    rhs_loc::Ptr{T} = C_NULL
    rhsintr::Ptr{T} = C_NULL

    irhs_sparse::Ptr{Cint} = C_NULL
    irhs_ptr::Ptr{Cint} = C_NULL
    isol_loc::Ptr{Cint} = C_NULL
    irhs_loc::Ptr{Cint} = C_NULL

    glob2loc_rhs::Ptr{Cint} = C_NULL
    glob2loc_sol::Ptr{Cint} = C_NULL

    nrhs::Cint = 0
    lrhs::Cint = 0
    lredrhs::Cint = 0
    nz_rhs::Cint = 0
    lsol_loc::Cint = 0
    nloc_rhs::Cint = 0
    lrhs_loc::Cint = 0
    nsol_loc::Cint = 0

    schur_mloc::Cint = 0
    schur_nloc::Cint = 0
    schur_lld::Cint = 0

    mblock::Cint = 0
    nblock::Cint = 0
    nprow::Cint = 0
    npcol::Cint = 0

    ld_rhsintr::Cint = 0

    info::NTuple{80,Cint} = tzeros(80)
    infog::NTuple{80,Cint} = tzeros(80)
    rinfo::NTuple{40,T} = tzeros(40)
    rinfog::NTuple{40,T} = tzeros(40)

    pivnul_list::Ptr{Cint} = C_NULL
    mapping::Ptr{Cint} = C_NULL
    singular_values::Ptr{T} = C_NULL
    nb_singular_values::Cint = 0

    size_schur::Cint = 0
    listvar_schur::Ptr{Cint} = C_NULL
    schur::Ptr{T} = C_NULL ##

    wk_user::Ptr{T} = C_NULL

    version_number::NTuple{32,Cchar} = tzeros(32)

    ooc_tmpdir::NTuple{1024,Cchar} = tzeros(1024)
    ooc_prefix::NTuple{256,Cchar} = tzeros(256)

    write_problem::NTuple{1024,Cchar} = tzeros(1024)
    lwk_user::Cint = 0

    save_dir::NTuple{1024,Cchar} = tzeros(1024)
    save_prefix::NTuple{256,Cchar} = tzeros(256)

    metis_options::NTuple{40,Cint} = tzeros(40)
    instance_number::Cint = 0
end

mutable struct MumpsSolver{T} <: AbstractLinearSolver{T}
    csc::SparseMatrixCSC{T,Int32}
    I::Vector{Int32}
    J::Vector{Int32}
    sym_perm::Vector{Int32}
    pivnul_list::Vector{Int32}
    mumps_struc::Struc
    is_singular::Bool
    opt::MumpsOptions
    logger::MadNLPLogger
end

# this is necessary, when multi-threaded calls are made with Mumps, not to clash with MPI
mumps_lock = Threads.SpinLock()

function locked_mumps_c(mumps_struc::Struc{Float32})
    lock(mumps_lock)
    try
        @ccall MUMPS_seq_jll.libsmumps.smumps_c(mumps_struc::Ref{Struc{Float32}})::Cvoid
    finally
        unlock(mumps_lock)
    end
end

function locked_mumps_c(mumps_struc::Struc{Float64})
    lock(mumps_lock)
    try
        @ccall MUMPS_seq_jll.libdmumps.dmumps_c(mumps_struc::Ref{Struc{Float64}})::Cvoid
    finally
        unlock(mumps_lock)
    end
end
# ---------------------------------------------------------------------------------------

function MumpsSolver(csc::SparseMatrixCSC{T,Int32};
    opt=MumpsOptions(), logger=MadNLPLogger(),
) where T

    I,J = findIJ(csc)
    sym_perm = zeros(Int32,csc.n)
    pivnul_list = zeros(Int32,csc.n)

    mumps_struc = Struc{T}()

    mumps_struc.sym =  2
    mumps_struc.par =  1
    mumps_struc.job = -1
    mumps_struc.comm_fortran = -987654 # MPI.COMM_WORLD.val

    locked_mumps_c(mumps_struc)
    mumps_struc.n = csc.n;
    mumps_struc.nz= nnz(csc);
    mumps_struc.a = pointer(csc.nzval)
    mumps_struc.irn = pointer(I)
    mumps_struc.jcn = pointer(J)
    mumps_struc.sym_perm = pointer(sym_perm)
    mumps_struc.pivnul_list = pointer(pivnul_list)

    # symbolic factorization
    mumps_struc.job = 1;

    mumps_struc.icntl = setindex(mumps_struc.icntl,0,2)
    mumps_struc.icntl = setindex(mumps_struc.icntl,0,3)
    mumps_struc.icntl = setindex(mumps_struc.icntl,0,4)
    mumps_struc.icntl = setindex(mumps_struc.icntl,opt.mumps_permuting_scaling,6)
    mumps_struc.icntl = setindex(mumps_struc.icntl,opt.mumps_pivot_order,7)
    mumps_struc.icntl = setindex(mumps_struc.icntl,opt.mumps_scaling,8)
    mumps_struc.icntl = setindex(mumps_struc.icntl,0,10)
    mumps_struc.icntl = setindex(mumps_struc.icntl,1,13)
    mumps_struc.icntl = setindex(mumps_struc.icntl,opt.mumps_mem_percent,14)


    mumps_struc.cntl = setindex(mumps_struc.cntl,opt.mumps_pivtol,1)

    locked_mumps_c(mumps_struc);
    mumps_struc.info[1] < 0 && throw(SymbolicException())

    M = MumpsSolver{T}(csc,I,J,sym_perm,pivnul_list,mumps_struc,false,opt,logger)
    finalizer(finalize,M)

    return M
end

function factorize!(M::MumpsSolver)
    M.is_singular = false
    M.mumps_struc.job = 2;
    cnt = 0
    while true
        locked_mumps_c(M.mumps_struc)
        if M.mumps_struc.info[1] in (-8,-9)
            cnt >= 10 && throw(FactorizationException())
            M.mumps_struc.icntl = setindex(M.mumps_struc.icntl,M.mumps_struc.icntl[14]*2.,14)
            cnt += 1
        elseif M.mumps_struc.info[1] == -10
            M.is_singular = true
            break
        elseif M.mumps_struc.info[1] < 0
            throw(FactorizationException())
        else
            break
        end
    end
    return M
end

function solve_linear_system!(M::MumpsSolver{T},rhs::Vector{T}) where T
    M.is_singular && return rhs
    M.mumps_struc.rhs = pointer(rhs)
    M.mumps_struc.job = 3
    locked_mumps_c(M.mumps_struc)
    M.mumps_struc.info[1] < 0 && throw(SolveException())
    return rhs
end

is_inertia(::MumpsSolver) = true
function inertia(M::MumpsSolver)
    return (M.csc.n-M.is_singular-M.mumps_struc.infog[12], M.is_singular, M.mumps_struc.infog[12])
end


function improve!(M::MumpsSolver)
    if M.mumps_struc.cntl[1] == M.opt.mumps_pivtolmax
        @debug(M.logger,"improve quality failed.")
        return false
    end
    M.mumps_struc.cntl = setindex(M.mumps_struc.cntl,min(M.opt.mumps_pivtolmax,M.mumps_struc.cntl[1]^.5),1)
    @debug(M.logger,"improved quality: pivtol = $(M.mumps_struc.cntl[1])")
    return true
end

function finalize(M::MumpsSolver)
    M.mumps_struc.job = -2
    locked_mumps_c(M.mumps_struc);
end

introduce(M::MumpsSolver)="MUMPS v$(join(Char(c) for c in M.mumps_struc.version_number if c != 0))"
input_type(::Type{MumpsSolver}) = :csc
default_options(::Type{MumpsSolver}) = MumpsOptions()
is_supported(::Type{MumpsSolver},::Type{Float32}) = true
is_supported(::Type{MumpsSolver},::Type{Float64}) = true

@inline function count_lu_bounds(lb::AbstractGPUVectorOrSubVector{T}, ub::AbstractGPUVectorOrSubVector{T}) where {T}
    num_lu_bounds = sum((lb .!= -Inf) .& (ub .!=  Inf))
    num_le_bounds = sum((lb .!= -Inf) .& (ub .==  Inf))
    num_ue_bounds = sum((ub .!=  Inf) .& (lb .== -Inf))
    return num_lu_bounds, num_le_bounds, num_ue_bounds
end

using Documenter
using MadNLP

makedocs(
    sitename = "MadNLP.jl",
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        prettyurls = Base.get(ENV, "CI", nothing) == "true",
        mathengine = Documenter.KaTeX()
    ),
    modules = [MadNLP],
    repo = "https://github.com/MadNLP/MadNLP.jl/blob/{commit}{path}#{line}",
    checkdocs = :exports,
    clean=true,
    pages = [
        "Home" => "index.md",
        "Installation" => "installation.md",
        "Quickstart" => "quickstart.md",
        "Algorithm" => "algorithm.md",
        "Options" => "options.md",
        "Tutorials" => [
            "GPU acceleration" => "tutorials/gpu.md",
            "Multi-precision" => "tutorials/multiprecision.md",
            "Warm-start" => "tutorials/warmstart.md",
            "Quasi-Newton" => "tutorials/quasi_newton.md",
            "Custom KKT system" => "tutorials/kktsystem.md",
        ],
        "Manual" => [
            "KKT systems" => "man/kkt.md",
            "Linear Solvers" => "man/linear_solvers.md",
        ],
        "API Reference" => [
            "IPM solver" => "lib/ipm.md",
            "Barrier strategies" => "lib/barrier.md",
            "Callback wrappers" => "lib/callbacks.md",
            "KKT systems" => "lib/kkt.md",
            "Linear Solvers" => "lib/linear_solvers.md",
        ]
    ]
)

deploydocs(
    repo = "github.com/MadNLP/MadNLP.jl.git",
    target = "build",
    devbranch = "master",
    devurl = "dev",
    push_preview = true,
)

using Test, MadNLP, MadNLPGPU, MadNLPTests

const HAS_CUDA = try
    using CUDA
    using CUDSS
    true
catch
    false
end

const HAS_AMDGPU = try
    using AMDGPU
    true
catch
    false
end

@testset "MadNLPGPU test" begin
    include("madnlpgpu_test.jl")
    if HAS_CUDA && CUDA.functional()
        include("densekkt_cuda.jl")
        # Need to add support for CompactLBFGS in SparseCondensedKKTSystem (Issue #563)
        # include("sparsekkt_cuda.jl")
        include("schur_cuda_test.jl")
    end
    if HAS_AMDGPU && AMDGPU.functional()
        include("densekkt_rocm.jl")
        # Need to add support for CompactLBFGS in SparseCondensedKKTSystem (Issue #563)
        # include("sparsekkt_rocm.jl")
    end
end

# For templating
const AbstractDenseKKTSystem{T, VT, MT, QN} = Union{
    DenseKKTSystem{T, VT, MT, QN},
    DenseCondensedKKTSystem{T, VT, MT, QN},
}

#=
    Generic functions
=#

function jtprod!(y::AbstractVector, kkt::AbstractDenseKKTSystem, x::AbstractVector)
    nx = size(kkt.hess, 1)
    ind_ineq = kkt.ind_ineq
    ns = length(ind_ineq)
    yx = view(y, 1:nx)
    ys = view(y, 1+nx:nx+ns)
    # / x
    mul!(yx, kkt.jac', x)
    # / s
    ys .= -@view(x[ind_ineq])
    return
end

function compress_jacobian!(kkt::AbstractDenseKKTSystem)
    return
end

nnz_jacobian(kkt::AbstractDenseKKTSystem) = length(kkt.jac)

##################################################
##### GPU kernels for GPUSchurComplementKKT #####
##################################################
#
# Index convention: index maps for all scenarios are stored in flat arrays of
# length `ns * n_per_s`, concatenated in scenario order. Per-scenario A_kk
# blocks share row/col structure, so each scenario writes into its own slice
# of the batched nzval at offset `(k-1) * nnz_per_block`. The kernel global
# index `i` directly indexes the flat input arrays; the scenario index is
# `k = (i-1) ÷ n_per_s + 1`.

# Scatter src[src_idx[i]] into batched A_kk nzval at the matching scenario slot.
# Used for: Hessian diagonal entries, equality Jacobian entries, pr_diag, du_diag.
@kernel function _scatter_to_Akk_batched!(
    nzval,
    @Const(src),
    @Const(src_idx),
    @Const(nzpos_flat),
    @Const(nnz_per_block),
    @Const(n_per_s),
)
    i = @index(Global)
    offset = ((i - 1) ÷ n_per_s) * nnz_per_block
    @inbounds nzval[offset + nzpos_flat[i]] += src[src_idx[i]]
end

# Scatter src[src_idx[i]] into C_dk[v_idx, d_idx, k] (blk_size × nd × ns).
# Layout has scenario-var dim first so each C_dk[:, :, k] is a contiguous
# (blk × nd) matrix — directly usable as a cuDSS multi-RHS dense matrix.
# Used for: Hessian coupling entries, equality Jacobian coupling entries.
@kernel function _scatter_to_Cdk_batched!(
    C_dk,
    @Const(src),
    @Const(src_idx),
    @Const(v_idx_flat),       # scenario-var index (1..blk)
    @Const(d_idx_flat),       # design-var index (1..nd)
    @Const(n_per_s),
)
    i = @index(Global)
    k = (i - 1) ÷ n_per_s + 1
    @inbounds C_dk[v_idx_flat[i], d_idx_flat[i], k] += src[src_idx[i]]
end

# Inequality condensation → A_kk (lower triangle).
@kernel function _ineq_condense_Akk_kernel!(
    nzval,
    @Const(jac),
    @Const(diag_buffer),
    @Const(nzpos_flat),
    @Const(jcoo1_flat),
    @Const(jcoo2_flat),
    @Const(bufidx_flat),
    @Const(nnz_per_block),
    @Const(n_per_s),
)
    i = @index(Global)
    offset = ((i - 1) ÷ n_per_s) * nnz_per_block
    @inbounds nzval[offset + nzpos_flat[i]] += diag_buffer[bufidx_flat[i]] *
        jac[jcoo1_flat[i]] * jac[jcoo2_flat[i]]
end

# Inequality condensation → C_dk (blk_size × nd × ns; see _scatter_to_Cdk_batched!).
@kernel function _ineq_condense_Cdk_kernel!(
    C_dk,
    @Const(jac),
    @Const(diag_buffer),
    @Const(v_idx_flat),       # scenario-var index (1..blk)
    @Const(d_idx_flat),       # design-var index (1..nd)
    @Const(jcoo_d_flat),
    @Const(jcoo_v_flat),
    @Const(bufidx_flat),
    @Const(n_per_s),
)
    i = @index(Global)
    k = (i - 1) ÷ n_per_s + 1
    @inbounds C_dk[v_idx_flat[i], d_idx_flat[i], k] += diag_buffer[bufidx_flat[i]] *
        jac[jcoo_d_flat[i]] * jac[jcoo_v_flat[i]]
end

# Inequality condensation → S (atomic adds since multiple scenarios target the
# same nd × nd dense matrix).
@kernel function _ineq_condense_S_kernel!(
    S,
    @Const(jac),
    @Const(diag_buffer),
    @Const(row_flat),
    @Const(col_flat),
    @Const(jcoo1_flat),
    @Const(jcoo2_flat),
    @Const(bufidx_flat),
)
    i = @index(Global)
    @inbounds begin
        val = diag_buffer[bufidx_flat[i]] * jac[jcoo1_flat[i]] * jac[jcoo2_flat[i]]
        CUDACore.@atomic S[row_flat[i], col_flat[i]] += val
    end
end

# Initialize S from design-design Hessian
@kernel function _init_S_hess_kernel!(
    S,
    @Const(hess),
    @Const(coo_indices),
    @Const(row_indices),
    @Const(col_indices),
)
    idx = @index(Global)
    @inbounds S[row_indices[idx], col_indices[idx]] += hess[coo_indices[idx]]
end

# Add pr_diag_dd to S diagonal
@kernel function _init_S_diag_kernel!(
    S,
    @Const(pr_diag),
    @Const(diag_offset),
    @Const(nd),
)
    idx = @index(Global)
    if idx <= nd
        @inbounds S[idx, idx] += pr_diag[diag_offset + idx]
    end
end

# Extract per-scenario RHS from global wx/wy → rhs_k_batched (blk_size × ns)
@kernel function _extract_rhs_kernel!(
    rhs_k,
    @Const(wx),
    @Const(wy),
    @Const(eq_global_indices),
    @Const(nv),
    @Const(nc_eq),
    @Const(ns),
    @Const(blk_size),
)
    i = @index(Global)
    k = (i - 1) ÷ blk_size + 1
    local_idx = (i - 1) % blk_size + 1
    if k <= ns
        if local_idx <= nv
            gi = (k - 1) * nv + local_idx
            @inbounds rhs_k[local_idx, k] = wx[gi]
        else
            eq_idx = local_idx - nv
            flat_idx = (k - 1) * nc_eq + eq_idx
            @inbounds rhs_k[local_idx, k] = wy[eq_global_indices[flat_idx]]
        end
    end
end

# Write back per-scenario solution to global wx/wy
@kernel function _writeback_rhs_kernel!(
    wx,
    wy,
    @Const(rhs_k),
    @Const(eq_global_indices),
    @Const(nv),
    @Const(nc_eq),
    @Const(ns),
    @Const(blk_size),
)
    i = @index(Global)
    k = (i - 1) ÷ blk_size + 1
    local_idx = (i - 1) % blk_size + 1
    if k <= ns
        if local_idx <= nv
            gi = (k - 1) * nv + local_idx
            @inbounds wx[gi] = rhs_k[local_idx, k]
        else
            eq_idx = local_idx - nv
            flat_idx = (k - 1) * nc_eq + eq_idx
            @inbounds wy[eq_global_indices[flat_idx]] = rhs_k[local_idx, k]
        end
    end
end

#=
    MadNLP._update_S_and_Y!
=#

@kernel function _update_S_and_Y_kernel!(k, S, Y)
    i = @index(Global)
    @inbounds for j = 1:k-1
        S[i, j] = S[i, j+1]
        Y[i, j] = Y[i, j+1]
    end
end

#=
    MadNLP._update_L_and_D!
=#
@kernel function _update_L_and_D_kernel!(L)
    i, j = @index(Global, NTuple)
    T = eltype(L)
    @inbounds if i < j
        L[i, j] = zero(T)
    end
end

using Test, MadNLP, MadNLPTests, MINLPTests
using NLPModels
using Quadmath
import MathOptInterface
import SparseArrays: sparse

@testset "MadNLP test" begin
    @testset "Matrix tools" begin
        include("matrix_test.jl")
    end

    @testset "KKTSystem" begin
        include("kkt_test.jl")
    end

    @testset "MOI interface" begin
        include("MOI_interface_test.jl")
    end

    @testset "MadNLP test" begin
        include("madnlp_test.jl")
        include("madnlp_dense.jl")
        include("madnlp_quasi_newton.jl")
    end

    @testset "MINLP test" begin
        include("minlp_test.jl")
    end

    @testset "Schur complement" begin
        include("schur_test.jl")
    end
end # @testset

for (potrf, potrf_buffer, potrs, nbytes, T) in
    (
        (:cusolverDnDpotrf, :cusolverDnDpotrf_bufferSize, :cusolverDnDpotrs, :8, :Float64),
        (:cusolverDnSpotrf, :cusolverDnSpotrf_bufferSize, :cusolverDnSpotrs, :4, :Float32),
    )
    @eval begin
        function MadNLP.setup_cholesky!(M::LapackCUDASolver{$T})
            if M.legacy
                potrf_lwork_gpu = Ref{Cint}(0)
                cuSOLVER.$potrf_buffer(
                    dense_handle(),
                    CUBLAS_FILL_MODE_LOWER,
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    potrf_lwork_gpu,
                )
                M.lwork_gpu = potrf_lwork_gpu[] * $nbytes
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            else
                potrf_lwork_gpu = Ref{Csize_t}(0)
                potrf_lwork_cpu = Ref{Csize_t}(0)
                cuSOLVER.cusolverDnXpotrf_bufferSize(
                    dense_handle(),
                    M.params,
                    CUBLAS_FILL_MODE_LOWER,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    potrf_lwork_gpu,
                    potrf_lwork_cpu,
                )
                M.lwork_cpu = potrf_lwork_cpu[]
                M.lwork_gpu = potrf_lwork_gpu[]
                resize!(M.work_cpu, M.lwork_cpu |> Int64)
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            end
            return M
        end

        function MadNLP.factorize_cholesky!(M::LapackCUDASolver{$T})
            if M.legacy
                cuSOLVER.$potrf(
                    dense_handle(),
                    CUBLAS_FILL_MODE_LOWER,
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    M.work_gpu,
                    Cint(M.lwork_gpu ÷ $nbytes),
                    M.info,
                )
            else
                cuSOLVER.cusolverDnXpotrf(
                    dense_handle(),
                    M.params,
                    CUBLAS_FILL_MODE_LOWER,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    M.work_gpu,
                    M.lwork_gpu,
                    M.work_cpu,
                    M.lwork_cpu,
                    M.info,
                )
            end
            return M
        end

        function MadNLP.solve_cholesky!(M::LapackCUDASolver{$T}, x::CuVector{$T})
            if M.legacy
                cuSOLVER.$potrs(
                    dense_handle(),
                    CUBLAS_FILL_MODE_LOWER,
                    Cint(M.n),
                    one(Cint),
                    M.fact,
                    Cint(M.n),
                    x,
                    Cint(M.n),
                    M.info,
                )
            else
                cuSOLVER.cusolverDnXpotrs(
                    dense_handle(),
                    M.params,
                    CUBLAS_FILL_MODE_LOWER,
                    M.n,
                    one(Int64),
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    x,
                    M.n,
                    M.info,
                )
            end
            return x
        end
    end
end

for (sytrf_buffer, sytrf, nbytes, T) in
    (
        (:cusolverDnDsytrf_bufferSize, :cusolverDnDsytrf, :8, :Float64),
        (:cusolverDnSsytrf_bufferSize, :cusolverDnSsytrf, :4, :Float32),
    )
    @eval begin
        function MadNLP.setup_bunchkaufman!(M::LapackCUDASolver{$T})
            resize!(M.ipiv, M.n)
            resize!(M.ipiv64, M.n)
            sytrf_lwork_gpu = Ref{Cint}(0)
            cuSOLVER.$sytrf_buffer(
                dense_handle(),
                Cint(M.n),
                M.fact,
                Cint(M.n),
                sytrf_lwork_gpu,
            )
            sytrs_lwork_cpu = Ref{Csize_t}(0)
            sytrs_lwork_gpu = Ref{Csize_t}(0)
            cuSOLVER.cusolverDnXsytrs_bufferSize(
                dense_handle(),
                CUBLAS_FILL_MODE_LOWER,
                M.n,
                one(Int64),
                $T,
                M.fact,
                M.n,
                M.ipiv64,
                $T,
                M.tau, # We can use any vector of the same length as the solution, which is M.n
                M.n,
                sytrs_lwork_gpu,
                sytrs_lwork_cpu,
            )
            M.lwork_cpu = sytrs_lwork_cpu[]
            M.lwork_gpu = max(sytrs_lwork_gpu[], sytrf_lwork_gpu[] * $nbytes)
            resize!(M.work_cpu, M.lwork_cpu |> Int64)
            resize!(M.work_gpu, M.lwork_gpu |> Int64)
            return M
        end

        function MadNLP.factorize_bunchkaufman!(M::LapackCUDASolver{$T})
            # We only have the legacy API for sytrf
            cuSOLVER.$sytrf(
                dense_handle(),
                CUBLAS_FILL_MODE_LOWER,
                Cint(M.n),
                M.fact,
                Cint(M.n),
                M.ipiv,
                M.work_gpu,
                Cint(M.lwork_gpu ÷ $nbytes),
                M.info,
            )
            return M
        end

        function MadNLP.solve_bunchkaufman!(M::LapackCUDASolver{$T}, x::CuVector{$T})
            copyto!(M.ipiv64, M.ipiv)  # No workaround possible until NVIDIA implements cusolverDnXsytrf
            cuSOLVER.cusolverDnXsytrs(
                dense_handle(),
                CUBLAS_FILL_MODE_LOWER,
                M.n,
                one(Int64),
                $T,
                M.fact,
                M.n,
                M.ipiv64,
                $T,
                x,
                M.n,
                M.work_gpu,
                M.lwork_gpu,
                M.work_cpu,
                M.lwork_cpu,
                M.info,
            )
            return x
        end
    end
end

for (getrf, getrf_buffer, getrs, nbytes, T) in
    (
        (:cusolverDnDgetrf, :cusolverDnDgetrf_bufferSize, :cusolverDnDgetrs, :8, :Float64),
        (:cusolverDnSgetrf, :cusolverDnSgetrf_bufferSize, :cusolverDnSgetrs, :4, :Float32),
    )
    @eval begin
        function MadNLP.setup_lu!(M::LapackCUDASolver{$T})
            if M.legacy
                resize!(M.ipiv, M.n)
                getrf_lwork_gpu = Ref{Cint}(0)
                cuSOLVER.$getrf_buffer(
                    dense_handle(),
                    Cint(M.n),
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    getrf_lwork_gpu,
                )
                M.lwork_gpu = getrf_lwork_gpu[] * $nbytes
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            else
                resize!(M.ipiv64, M.n)
                getrf_lwork_cpu = Ref{Csize_t}(0)
                getrf_lwork_gpu = Ref{Csize_t}(0)
                cuSOLVER.cusolverDnXgetrf_bufferSize(
                    dense_handle(),
                    M.params,
                    M.n,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    getrf_lwork_gpu,
                    getrf_lwork_cpu,
                )
                M.lwork_cpu = getrf_lwork_cpu[]
                M.lwork_gpu = getrf_lwork_gpu[]
                resize!(M.work_cpu, M.lwork_cpu |> Int64)
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            end
            return M
        end

        function MadNLP.factorize_lu!(M::LapackCUDASolver{$T})
            if M.legacy
                cuSOLVER.$getrf(
                    dense_handle(),
                    Cint(M.n),
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    M.work_gpu,
                    M.ipiv,
                    M.info,
                )
            else
                cuSOLVER.cusolverDnXgetrf(
                    dense_handle(),
                    M.params,
                    M.n,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    M.ipiv64,
                    $T,
                    M.work_gpu,
                    M.lwork_gpu,
                    M.work_cpu,
                    M.lwork_cpu,
                    M.info,
                )
            end
            return M
        end

        function MadNLP.solve_lu!(M::LapackCUDASolver{$T}, x::CuVector{$T})
            if M.legacy
                cuSOLVER.$getrs(
                    dense_handle(),
                    CUBLAS_OP_N,
                    Cint(M.n),
                    one(Cint),
                    M.fact,
                    Cint(M.n),
                    M.ipiv,
                    x,
                    Cint(M.n),
                    M.info,
                )
            else
                cuSOLVER.cusolverDnXgetrs(
                    dense_handle(),
                    M.params,
                    CUBLAS_OP_N,
                    M.n,
                    one(Int64),
                    $T,
                    M.fact,
                    M.n,
                    M.ipiv64,
                    $T,
                    x,
                    M.n,
                    M.info,
                )
            end
            return x
        end
    end
end

for (geqrf, geqrf_buffer, ormqr, ormqr_buffer, trsv, nbytes, T) in
    (
        (:cusolverDnDgeqrf, :cusolverDnDgeqrf_bufferSize, :cusolverDnDormqr, :cusolverDnDormqr_bufferSize, :cublasDtrsv_v2_64, :8, :Float64),
        (:cusolverDnSgeqrf, :cusolverDnSgeqrf_bufferSize, :cusolverDnSormqr, :cusolverDnSormqr_bufferSize, :cublasStrsv_v2_64, :4, :Float32),
    )
    @eval begin
        function MadNLP.setup_qr!(M::LapackCUDASolver{$T})
            resize!(M.tau, M.n)
            ormqr_lwork_gpu = Ref{Cint}(0)
            cuSOLVER.$ormqr_buffer(
                dense_handle(),
                CUBLAS_SIDE_LEFT,
                CUBLAS_OP_T,
                Cint(M.n),
                one(Cint),
                Cint(M.n),
                M.fact,
                Cint(M.n),
                M.tau,
                M.tau,  # We can use any vector of the same length as the solution, which is M.n
                Cint(M.n),
                ormqr_lwork_gpu,
            )
            if M.legacy
                geqrf_lwork_gpu = Ref{Cint}(0)
                cuSOLVER.$geqrf_buffer(
                    dense_handle(),
                    Cint(M.n),
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    geqrf_lwork_gpu,
                )
                M.lwork_gpu = max(geqrf_lwork_gpu[], ormqr_lwork_gpu[]) * $nbytes
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            else
                geqrf_lwork_cpu = Ref{Csize_t}(0)
                geqrf_lwork_gpu = Ref{Csize_t}(0)
                cuSOLVER.cusolverDnXgeqrf_bufferSize(
                    dense_handle(),
                    M.params,
                    M.n,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    M.tau,
                    $T,
                    geqrf_lwork_gpu,
                    geqrf_lwork_cpu,
                )
                M.lwork_cpu = geqrf_lwork_cpu[]
                M.lwork_gpu = max(ormqr_lwork_gpu[] * $nbytes, geqrf_lwork_gpu[])
                resize!(M.work_cpu, M.lwork_cpu |> Int64)
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            end
            return M
        end

        function MadNLP.factorize_qr!(M::LapackCUDASolver{$T})
            if M.legacy
                cuSOLVER.$geqrf(
                    dense_handle(),
                    Cint(M.n),
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    M.tau,
                    M.work_gpu,
                    Cint(M.lwork_gpu ÷ $nbytes),
                    M.info,
                )
            else
                cuSOLVER.cusolverDnXgeqrf(
                    dense_handle(),
                    M.params,
                    M.n,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    M.tau,
                    $T,
                    M.work_gpu,
                    M.lwork_gpu,
                    M.work_cpu,
                    M.lwork_cpu,
                    M.info,
                )
            end
            return M
        end

        function MadNLP.solve_qr!(M::LapackCUDASolver{$T}, x::CuVector{$T})
            # We only have the legacy API for ormqr
            cuSOLVER.$ormqr(
                dense_handle(),
                CUBLAS_SIDE_LEFT,
                CUBLAS_OP_T,
                Cint(M.n),
                one(Cint),
                Cint(M.n),
                M.fact,
                Cint(M.n),
                M.tau,
                x,
                Cint(M.n),
                M.work_gpu,
                Cint(M.lwork_gpu ÷ $nbytes),
                M.info,
            )
            cuBLAS.$trsv(
                handle(),
                CUBLAS_FILL_MODE_UPPER,
                CUBLAS_OP_N,
                CUBLAS_DIAG_NON_UNIT,
                M.n,
                M.fact,
                M.n,
                x,
                one(Int64),
            )
            return x
        end
    end
end

for (syevd, syevd_buffer, gemv, nbytes, T) in
    (
        (:cusolverDnDsyevd, :cusolverDnDsyevd_bufferSize, :cublasDgemv_v2_64, :8, :Float64),
        (:cusolverDnSsyevd, :cusolverDnSsyevd_bufferSize, :cublasSgemv_v2_64, :4, :Float32),
    )
    @eval begin
        function MadNLP.setup_evd!(M::LapackCUDASolver{$T})
            resize!(M.tau, M.n)
            resize!(M.Λ, M.n)
            if M.legacy
                syevd_lwork_gpu = Ref{Cint}(0)
                cuSOLVER.$syevd_buffer(
                    dense_handle(),
                    CUSOLVER_EIG_MODE_VECTOR,
                    CUBLAS_FILL_MODE_LOWER,
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    M.Λ,
                    syevd_lwork_gpu,
                )
                M.lwork_gpu = syevd_lwork_gpu[] * $nbytes
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            else
                syevd_lwork_cpu = Ref{Csize_t}(0)
                syevd_lwork_gpu = Ref{Csize_t}(0)
                cuSOLVER.cusolverDnXsyevd_bufferSize(
                    dense_handle(),
                    M.params,
                    CUSOLVER_EIG_MODE_VECTOR,
                    CUBLAS_FILL_MODE_LOWER,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    M.Λ,
                    $T,
                    syevd_lwork_gpu,
                    syevd_lwork_cpu,
                )
                M.lwork_cpu = syevd_lwork_cpu[]
                M.lwork_gpu = syevd_lwork_gpu[]
                resize!(M.work_cpu, M.lwork_cpu |> Int64)
                resize!(M.work_gpu, M.lwork_gpu |> Int64)
            end
            return M
        end

        function MadNLP.factorize_evd!(M::LapackCUDASolver{$T})
            if M.legacy
                cuSOLVER.$syevd(
                    dense_handle(),
                    CUSOLVER_EIG_MODE_VECTOR,
                    CUBLAS_FILL_MODE_LOWER,
                    Cint(M.n),
                    M.fact,
                    Cint(M.n),
                    M.Λ,
                    M.work_gpu,
                    Cint(M.lwork_gpu ÷ $nbytes),
                    M.info,
                )
            else
                cuSOLVER.cusolverDnXsyevd(
                    dense_handle(),
                    M.params,
                    CUSOLVER_EIG_MODE_VECTOR,
                    CUBLAS_FILL_MODE_LOWER,
                    M.n,
                    $T,
                    M.fact,
                    M.n,
                    $T,
                    M.Λ,
                    $T,
                    M.work_gpu,
                    M.lwork_gpu,
                    M.work_cpu,
                    M.lwork_cpu,
                    M.info,
                )
            end
            return M
        end

        function MadNLP.solve_evd!(M::LapackCUDASolver{$T}, x::CuVector{$T})
            cuBLAS.$gemv(
                handle(),
                CUBLAS_OP_T,
                M.n,
                M.n,
                one($T),
                M.fact,
                M.n,
                x,
                one(Int64),
                zero($T),
                M.tau,
                one(Int64),
            )
            M.tau ./= M.Λ
            cuBLAS.$gemv(
                handle(),
                CUBLAS_OP_N,
                M.n,
                M.n,
                one($T),
                M.fact,
                M.n,
                M.tau,
                one(Int64),
                zero($T),
                x,
                one(Int64),
            )
            return x
        end
    end
end

####################################################
##### GPU kernels for SparseCondensedKKTSystem #####
####################################################

#=
    _copy_to_map_kernel!
=#

@kernel function _copy_to_map_kernel!(y, p, x)
    i = @index(Global)
    @inbounds y[p[i]] = x[i]
end

#=
    _copy_from_map_kernel!
=#

@kernel function _copy_from_map_kernel!(y, x, p)
    i = @index(Global)
    @inbounds y[i] = x[p[i]]
end

#=
    _csc_to_dense_kernel!
=#

@kernel function _csc_to_dense_kernel!(y, @Const(colptr), @Const(rowval), @Const(nzval))
    col = @index(Global)
    @inbounds for ptr in colptr[col]:colptr[col+1]-1
        row = rowval[ptr]
        y[row, col] = nzval[ptr]
    end
end

#=
    MadNLP._set_colptr!
=#

@kernel function _set_colptr_kernel!(colptr, @Const(sym2), @Const(ptr2), @Const(guide))
    idx = @index(Global)
    @inbounds begin
        i = ptr2[idx+1]

        (~, prevcol) = sym2[i-1]
        (row, col) = sym2[i]
        g = guide[i]
        for j in prevcol+1:col
            colptr[j] = g
        end
    end
end

#=
    MadNLP.tril_to_full!
=#

@kernel function _tril_to_full_kernel!(dense)
    idx = @index(Global)
    n = size(dense, 1)
    i, j = getij(idx, n)
    @inbounds dense[j, i] = dense[i, j]
end

#=
    MadNLP.force_lower_triangular!
=#

@kernel function _force_lower_triangular_kernel!(I, J)
    i = @index(Global)

    @inbounds if J[i] > I[i]
        tmp = J[i]
        J[i] = I[i]
        I[i] = tmp
    end
end

#=
    MadNLP.coo_to_csc
=#

@kernel function _set_coo_to_colptr_kernel!(colptr, @Const(coord))
    index = @index(Global)

    @inbounds begin
        if index == 1
            ((i2, j2), k2) = coord[index]
            for k in 1:j2
                colptr[k] = 1
            end
            if index == length(coord)
                ip1 = index + 1
                for k in j2+1:length(colptr)
                    colptr[k] = ip1
                end
            end
        else
            ((i1, j1), k1) = coord[index-1]
            ((i2, j2), k2) = coord[index]
            if j1 != j2
                for k in j1+1:j2
                    colptr[k] = index
                end
            end
            if index == length(coord)
                ip1 = index + 1
                for k in j2+1:length(colptr)
                    colptr[k] = ip1
                end
            end
        end
    end
end

@kernel function _set_coo_to_csc_map_kernel!(cscmap, @Const(mapptr), @Const(coord))
    index = @index(Global)
    @inbounds for l in mapptr[index]:mapptr[index+1]-1
        ((i, j), k) = coord[l]
        cscmap[k] = index
    end
end

#=
    MadNLP.build_condensed_aug_coord!
=#

@kernel function _transfer_hessian_kernel!(y, @Const(ptr), @Const(x))
    index = @index(Global)
    @inbounds i, j = ptr[index]
    @inbounds y[i] += x[j]
end

@kernel function _transfer_jtsj_kernel!(y, @Const(ptr), @Const(ptrptr), @Const(x), @Const(s))
    index = @index(Global)
    @inbounds for index2 in ptrptr[index]:ptrptr[index+1]-1
        i, (j, k, l) = ptr[index2]
        y[i] += s[j] * x[k] * x[l]
    end
end

@kernel function _diag_operation_kernel!(
    y,
    @Const(A),
    @Const(x),
    @Const(alpha),
    @Const(idx_to),
    @Const(idx_fr)
)
    i = @index(Global)
    @inbounds begin
        to = idx_to[i]
        fr = idx_fr[i]
        y[to] -= alpha * A[fr] * x[to]
    end
end

#=
    MadNLP.compress_hessian! / MadNLP.compress_jacobian!
=#

@kernel function _transfer_to_csc_kernel!(y, @Const(ptr), @Const(ptrptr), @Const(x))
    index = @index(Global)
    @inbounds for index2 in ptrptr[index]:ptrptr[index+1]-1
        i, j = ptr[index2]
        y[i] += x[j]
    end
end

#=
    MadNLP._set_con_scale_sparse!
=#

@kernel function _set_con_scale_sparse_kernel!(
    con_scale,
    @Const(ptr),
    @Const(inds),
    @Const(jac_I),
    @Const(jac_buffer)
)
    index = @index(Global)

    @inbounds begin
        rng = ptr[index]:ptr[index+1]-1

        for k in rng
            (row, i) = inds[k]
            con_scale[row] = max(con_scale[row], abs(jac_buffer[i]))
        end
    end
end

#=
    MadNLP._build_condensed_aug_symbolic_hess
=#

@kernel function _build_condensed_aug_symbolic_hess_kernel!(
    sym,
    sym2,
    @Const(colptr),
    @Const(rowval)
)
    i = @index(Global)
    @inbounds for j in colptr[i]:colptr[i+1]-1
        c = rowval[j]
        sym[j] = (0, j, 0)
        sym2[j] = (c, i)
    end
end

#=
    MadNLP._build_condensed_aug_symbolic_jt
=#

@kernel function _build_condensed_aug_symbolic_jt_kernel!(
    sym,
    sym2,
    @Const(colptr),
    @Const(rowval),
    @Const(offsets)
)
    i = @index(Global)
    @inbounds begin
        cnt = if i == 1
            0
        else
            offsets[i-1]
        end
        for j in colptr[i]:colptr[i+1]-1
            c1 = rowval[j]
            for k in j:colptr[i+1]-1
                c2 = rowval[k]
                cnt += 1
                sym[cnt] = (i, j, k)
                sym2[cnt] = (c2, c1)
            end
        end
    end
end

#=
    MadNLP._build_scale_augmented_system_coo!
=#

@kernel function _scale_augmented_system_coo_kernel!(dest_V, @Const(src_I), @Const(src_J), @Const(src_V), @Const(scaling), @Const(n), @Const(m))
    k = @index(Global, Linear)
    i = src_I[k]
    j = src_J[k]

    # Primal regularization pr_diag
    if k <= n
        dest_V[k] = src_V[k]
    # Hessian block
    elseif i <= n && j <= n
        dest_V[k] = src_V[k] * scaling[i] * scaling[j]
    # Jacobian block
    elseif n + 1 <= i <= n + m && j <= n
        dest_V[k] = src_V[k] * scaling[j]
    # Dual regularization du_diag
    elseif (n + 1 <= i <= n + m) && (n + 1 <= j <= n + m)
        dest_V[k] = src_V[k]
    end
end

abstract type AbstractWrapperModel{T,VT} <: NLPModels.AbstractNLPModel{T,VT} end

struct DenseWrapperModel{T,VT,T2,VT2,MT2, I <: NLPModels.AbstractNLPModel{T2,VT2}} <: AbstractWrapperModel{T,VT}
    inner::I
    x::VT2
    y::VT2
    con::VT2
    grad::VT2
    jac::MT2
    hess::MT2
    meta::NLPModels.NLPModelMeta{T, VT}
    counters::NLPModels.Counters
end

struct SparseWrapperModel{T,VT,T2,VI2,VT2,I <: NLPModels.AbstractNLPModel{T2,VT2}} <: AbstractWrapperModel{T,VT}
    inner::I
    jrows::VI2
    jcols::VI2
    hrows::VI2
    hcols::VI2
    x::VT2
    y::VT2
    con::VT2
    grad::VT2
    jac::VT2
    hess::VT2
    meta::NLPModels.NLPModelMeta{T, VT}
    counters::NLPModels.Counters
end

"""
    DenseWrapperModel(Arr, m)

Construct a DenseWrapperModel (a subtype of `NLPModels.AbstractNLPModel{T,typeof(Arr(m.meta.x0))}`)
from a generic NLP Model.

DenseWrapperModel can be used to interface GPU-accelerated NLP models with solvers runing on CPUs.
"""
function DenseWrapperModel(Arr, m::NLPModels.AbstractNLPModel)
    return DenseWrapperModel(
        m,
        similar(get_x0(m), m.meta.nvar),
        similar(get_x0(m), get_ncon(m)),
        similar(get_x0(m), get_ncon(m)),
        similar(get_x0(m), get_nvar(m)),
        similar(get_x0(m), get_ncon(m), get_nvar(m)),
        similar(get_x0(m), get_nvar(m), get_nvar(m)),
        NLPModels.NLPModelMeta(
            get_nvar(m),
            x0 = Arr(get_x0(m)),
            lvar = Arr(get_lvar(m)),
            uvar = Arr(get_uvar(m)),
            ncon = get_ncon(m),
            y0 = Arr(get_y0(m)),
            lcon = Arr(get_lcon(m)),
            ucon = Arr(get_ucon(m)),
            nnzj = get_nnzj(m),
            nnzh = get_nnzh(m),
            sparse_jacobian = false,
            sparse_hessian = false,
            minimize = get_minimize(m)
        ),
        NLPModels.Counters()
    )
end

"""
    SparseWrapperModel(Arr, m)

Construct a SparseWrapperModel (a subtype of `NLPModels.AbstractNLPModel{T,typeof(Arr(m.meta.x0))}`)
from a generic NLP Model.

SparseWrapperModel can be used to interface GPU-accelerated NLP models with solvers runing on CPUs.
"""
function SparseWrapperModel(Arr, m::NLPModels.AbstractNLPModel)
    return SparseWrapperModel(
        m,
        similar(get_x0(m), Int, get_nnzj(m)),
        similar(get_x0(m), Int, get_nnzj(m)),
        similar(get_x0(m), Int, get_nnzh(m)),
        similar(get_x0(m), Int, get_nnzh(m)),
        similar(get_x0(m), get_nvar(m)),
        similar(get_x0(m), get_ncon(m)),
        similar(get_x0(m), get_ncon(m)),
        similar(get_x0(m), get_nvar(m)),
        similar(get_x0(m), get_nnzj(m)),
        similar(get_x0(m), get_nnzh(m)),
        NLPModels.NLPModelMeta(
            get_nvar(m),
            x0 = Arr(get_x0(m)),
            lvar = Arr(get_lvar(m)),
            uvar = Arr(get_uvar(m)),
            ncon = get_ncon(m),
            y0 = Arr(get_y0(m)),
            lcon = Arr(get_lcon(m)),
            ucon = Arr(get_ucon(m)),
            nnzj = get_nnzj(m),
            nnzh = get_nnzh(m),
            sparse_jacobian = true,
            sparse_hessian = true,
            minimize = get_minimize(m)
        ),
        NLPModels.Counters()
    )
end

function NLPModels.obj(
    m::M,
    x::V
) where {M <: AbstractWrapperModel, V <: AbstractVector}
    copyto!(m.x, x)
    return NLPModels.obj(m.inner, m.x)
end

function NLPModels.cons!(
    m::M,
    x::V,
    g::V
) where {M <: AbstractWrapperModel, V <: AbstractVector}
    copyto!(m.x, x)
    NLPModels.cons!(m.inner, m.x, m.con)
    copyto!(g, m.con)
    return g
end

function NLPModels.grad!(
    m::M,
    x::V,
    f::V
) where {M <: AbstractWrapperModel, V <: AbstractVector}
    copyto!(m.x, x)
    NLPModels.grad!(m.inner, m.x, m.grad)
    copyto!(f, m.grad)
    return f
end

function NLPModels.jac_structure!(
    m::M,
    rows::V,
    cols::V
) where {M <: SparseWrapperModel, V <: AbstractVector}
    NLPModels.jac_structure!(m.inner, m.jrows, m.jcols)
    copyto!(rows, m.jrows)
    copyto!(cols, m.jcols)
    return rows, cols
end

function NLPModels.hess_structure!(
    m::M,
    rows::V,
    cols::V
) where {M <: SparseWrapperModel, V <: AbstractVector}
    NLPModels.hess_structure!(m.inner, m.hrows, m.hcols)
    copyto!(rows, m.hrows)
    copyto!(cols, m.hcols)
    return rows, cols
end

function NLPModels.jtprod!(
    m::SparseWrapperModel,
    x::AbstractVector,
    v::AbstractVector,
    jtv::AbstractVector,
)
    copyto!(m.x, x)
    copyto!(m.grad, jtv)
    copyto!(m.con, v)
    NLPModels.jtprod!(m.inner, m.x, m.con, m.grad)
    copyto!(jtv, m.grad)
    return jtv
end

function NLPModels.jac_coord!(
    m::SparseWrapperModel,
    x::AbstractVector,
    jac::AbstractVector,
)
    copyto!(m.x, x)
    NLPModels.jac_coord!(m.inner, m.x, m.jac)
    copyto!(jac, m.jac)
    return jac
end

function NLPModels.hess_coord!(
    m::M,
    x::AbstractVector,
    y::AbstractVector,
    hess::AbstractVector;
    obj_weight = one(eltype(x))
) where {M <: SparseWrapperModel}
    copyto!(m.x, x)
    copyto!(m.y, y)
    NLPModels.hess_coord!(m.inner, m.x, m.y, m.hess; obj_weight=obj_weight)
    copyto!(hess, m.hess)
    return hess
end

function NLPModels.jac_dense!(
    m::Model,
    x::V,
    jac::M
) where {Model <: DenseWrapperModel, V <: AbstractVector, M <: AbstractMatrix}
    copyto!(m.x, x)
    NLPModels.jac_dense!(m.inner, m.x, m.jac)
    copyto!(jac, m.jac)
    return jac
end

function NLPModels.hess_dense!(
    m::Model,
    x::V,
    y::V,
    hess::M;
    obj_weight = one(eltype(x))
) where {Model <: DenseWrapperModel, V <: AbstractVector, M <: AbstractMatrix}
    copyto!(m.x, x)
    copyto!(m.y, y)
    NLPModels.hess_dense!(m.inner, m.x, m.y, m.hess; obj_weight=obj_weight)
    copyto!(hess, m.hess)
    return hess
end

using Pkg

MADNLP_DIR = pwd()

Pkg.update()
Pkg.resolve()
Pkg.develop([
    PackageSpec(path=MADNLP_DIR),
    PackageSpec(path=joinpath(MADNLP_DIR, "lib", "MadNLPGPU")),
    PackageSpec(path=joinpath(MADNLP_DIR, "lib", "MadNLPTests")),
])
Base.compilecache(Base.identify_package("MadNLPTests"))
Base.compilecache(Base.identify_package("MadNLPGPU"))
Base.compilecache(Base.identify_package("MadNLP"))
Pkg.instantiate()

using Test
using NLPModels
using LinearAlgebra
using MadNLPTests
using SparseArrays
using Random

function _compare_dense_with_sparse(
    kkt_system, n, m, ind_fixed, ind_eq;
    inertia=MadNLP.InertiaBased,
)

    for (T,tol,atol) in [(Float32,Float32(1e-4),Float32(1e1)), (Float64,1e-8,1e-6)]

        sparse_options = Dict{Symbol, Any}(
            :kkt_system=>MadNLP.SparseKKTSystem,
            :callback=>MadNLP.SparseCallback,
            :inertia_correction_method=>inertia,
            :linear_solver=>MadNLP.LapackCPUSolver,
            :print_level=>MadNLP.ERROR,
            :dual_initialized=>true,
            :tol=>tol
        )
        dense_options = Dict{Symbol, Any}(
            :kkt_system=>kkt_system,
            :callback=>MadNLP.DenseCallback,
            :inertia_correction_method=>inertia,
            :linear_solver=>MadNLP.LapackCPUSolver,
            :print_level=>MadNLP.ERROR,
            :dual_initialized=>true,
            :tol=>tol
        )

        # N.B.: depending on the variables we fix, the problem may not satisfy
        # LICQ, implying the multipliers are non-unique at the solution.
        nlp = MadNLPTests.DenseDummyQP(zeros(T,n), m=m, fixed_variables=ind_fixed, equality_cons=ind_eq)

        solver = MadNLPSolver(nlp; sparse_options...)
        solverd = MadNLPSolver(nlp; dense_options...)

        result_sparse = MadNLP.solve!(solver)
        result_dense = MadNLP.solve!(solverd)

        # Check that dense formulation matches exactly sparse formulation
        @test result_dense.status == MadNLP.SOLVE_SUCCEEDED
        @test result_sparse.counters.k == result_dense.counters.k
        @test result_sparse.objective ≈ result_dense.objective atol=atol
        @test result_sparse.solution ≈ result_dense.solution atol=atol
        ind_free = setdiff(1:n, ind_fixed)
        n_free = length(ind_free)
        @test solver.kkt.jac_com[:, 1:n_free] == solverd.kkt.jac[:, ind_free]
    end
end

@testset "MadNLP: API $(kkt)" for kkt in [
    MadNLP.DenseKKTSystem,
    MadNLP.DenseCondensedKKTSystem,
    ]

    n = 10 # number of variables
    @testset "Unconstrained" begin
        dense_options = Dict{Symbol, Any}(
            :kkt_system=>kkt,
            :linear_solver=>MadNLP.LapackCPUSolver,
        )
        m = 0
        nlp = MadNLPTests.DenseDummyQP(zeros(n); m=m)
        solverd = MadNLPSolver(nlp; dense_options...)

        kkt = solverd.kkt
        @test isempty(kkt.jac)
        @test solverd.kkt.linear_solver.A === kkt.aug_com
        @test size(kkt.hess) == (n, n)
        @test length(kkt.pr_diag) == n
        @test length(kkt.du_diag) == m

        # Test that using a sparse solver is forbidden in dense mode
        dense_options_error = Dict{Symbol, Any}(
            :kkt_system=>kkt,
            :linear_solver=>MadNLP.UmfpackSolver,
        )
        @test_throws Exception MadNLPSolver(nlp; dense_options_error...)
    end
    @testset "Constrained" begin
        dense_options = Dict{Symbol, Any}(
            :kkt_system=>MadNLP.DenseKKTSystem,
            :linear_solver=>MadNLP.LapackCPUSolver,
        )
        m = 5
        nlp = MadNLPTests.DenseDummyQP(zeros(n); m=m)
        solverd = MadNLPSolver(nlp; dense_options...)
        ns = length(solverd.ind_ineq)

        kkt = solverd.kkt
        @test isa(kkt, MadNLP.DenseKKTSystem)
        @test size(kkt.jac) == (m, n)
        @test solverd.kkt.linear_solver.A === kkt.aug_com
        @test size(kkt.hess) == (n, n)
        @test length(kkt.pr_diag) == n + ns
        @test length(kkt.du_diag) == m
    end
end


@testset "MadNLP: option kkt_system=$(kkt)" for kkt in [MadNLP.DenseKKTSystem, MadNLP.DenseCondensedKKTSystem]
    @testset "Size: ($n, $m)" for (n, m) in [(10, 0), (10, 5), (50, 10)]
        _compare_dense_with_sparse(kkt, n, m, Int[], Int[])
        _compare_dense_with_sparse(kkt, n, m, Int[], Int[]; inertia=MadNLP.InertiaFree)
    end
    # Test with non-trivial equality constraints.
    @testset "Equality constraints" begin
        n, m = 20, 15
        _compare_dense_with_sparse(kkt, n, m, Int[], Int[1, 8])
        _compare_dense_with_sparse(kkt, n, m, Int[], Int[1, 8]; inertia=MadNLP.InertiaFree)
    end
    # @testset "Fixed variables" begin
    #     n, m = 10, 5
    #     _compare_dense_with_sparse(kkt, n, m, Int[1, 2], Int[])
    #     _compare_dense_with_sparse(kkt, n, m, Int[1, 2], Int[]; inertia=MadNLP.InertiaFree)
    # end
end

# Now we do not support custom KKT constructor
# @testset "MadNLP: custom KKT constructor" begin
#     solver = MadNLPSolver(nlp; kkt_system = MadNLP.DenseKKTSystem, linear_solver=LapackCPUSolver)
#     @test isa(solver.kkt, KKT)
# end

@testset "MadNLP: restart (PR #113)" begin
    n, m = 10, 6
    nlp = MadNLPTests.DenseDummyQP(zeros(n); m=m)
    sparse_options = Dict{Symbol, Any}(
        :kkt_system=>MadNLP.SparseKKTSystem,
        :callback=>MadNLP.SparseCallback,
        :print_level=>MadNLP.ERROR,
    )

    solver = MadNLPSolver(nlp; sparse_options...)
    MadNLP.solve!(solver)

    # Restart (should hit MadNLP.reinitialize function)
    res = MadNLP.solve!(solver)
    @test solver.status == MadNLP.SOLVE_SUCCEEDED
end

using Test
using LinearAlgebra
using CUDA
using CUDSS
using MadNLP
using MadNLPGPU
using MadNLPTests

@testset "GPUSchurComplementKKTSystem" begin

    @testset "Basic convergence — quadratic with coupling" begin
        ns, nv, nd, nc = 3, 1, 1, 1
        θ = [4.0, 6.0, 8.0]

        nlp = build_twostage_qp(
            CUDA.zeros(Float64, ns * nv + nd);
            ns, nv, nd, nc,
            hess_v = fill(2.0, nv, ns), hess_d = fill(2.0, nd),
            g_v = reshape(-2 .* θ, nv, ns), g_d = [-2.0],
            A_v = fill(1.0, nc, nv, ns), A_d = fill(1.0, nc, nd, ns),
            lcon = zeros(nc, ns), ucon = zeros(nc, ns),
            lvar_v = fill(-100.0, nv, ns), uvar_v = fill(100.0, nv, ns),
            lvar_d = fill(-100.0, nd), uvar_d = fill(100.0, nd),
        )

        result = madnlp(
            nlp;
            callback = MadNLP.SparseCallback,
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCUDASolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end

    @testset "Match CPU reference" begin
        ns, nv, nd, nc = 2, 2, 1, 1
        θ = [1.0 3.0; 2.0 4.0]

        common = (
            ns = ns, nv = nv, nd = nd, nc = nc,
            hess_v = fill(2.0, nv, ns), hess_d = fill(2.0, nd),
            g_v = -2 .* θ, g_d = [0.0],
            A_v = fill(1.0, nc, nv, ns), A_d = fill(1.0, nc, nd, ns),
            lcon = zeros(nc, ns), ucon = zeros(nc, ns),
            lvar_v = fill(-50.0, nv, ns), uvar_v = fill(50.0, nv, ns),
            lvar_d = fill(-50.0, nd), uvar_d = fill(50.0, nd),
        )

        nlp_cpu = build_twostage_qp(zeros(Float64, ns * nv + nd); common...)
        nlp_gpu = build_twostage_qp(CUDA.zeros(Float64, ns * nv + nd); common...)

        ref = madnlp(
            nlp_cpu;
            callback = MadNLP.SparseCallback,
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCPUSolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        gpu_result = madnlp(
            nlp_gpu;
            callback = MadNLP.SparseCallback,
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCUDASolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )

        @test ref.status == MadNLP.SOLVE_SUCCEEDED
        @test gpu_result.status == MadNLP.SOLVE_SUCCEEDED
        @test isapprox(gpu_result.objective, ref.objective; atol = 1.0e-6)
        @test isapprox(Array(gpu_result.solution), Array(ref.solution); atol = 1.0e-4)
    end

    @testset "Multiple recourse vars and design vars" begin
        ns, nv, nd, nc = 2, 2, 2, 1
        θ = [1.0, 2.0]
        H_v = zeros(nv, ns)
        for k in 1:ns, j in 1:nv
            H_v[j, k] = 2θ[k]
        end

        nlp = build_twostage_qp(
            CUDA.zeros(Float64, ns * nv + nd);
            ns, nv, nd, nc,
            hess_v = H_v, hess_d = fill(2.0, nd),
            g_v = zeros(nv, ns), g_d = zeros(nd),
            A_v = fill(1.0, nc, nv, ns), A_d = fill(1.0, nc, nd, ns),
            lcon = ones(nc, ns), ucon = ones(nc, ns),
            lvar_v = fill(-50.0, nv, ns), uvar_v = fill(50.0, nv, ns),
            lvar_d = fill(-50.0, nd), uvar_d = fill(50.0, nd),
        )

        result = madnlp(
            nlp;
            callback = MadNLP.SparseCallback,
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCUDASolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end

    @testset "cuDSS IR + multi-RHS invariant tripwire" begin
        # The GPU Schur path re-analyzes the scenario cuDSS handle with a
        # (blk × nd) × ns multi-RHS descriptor, and then does two solves
        # per IPM iteration: a (blk × 1) × ns single-RHS solve (forward
        # elimination) and a (blk × nd) × ns multi-RHS solve. Correctness
        # relies on "analyze with larger RHS, solve with smaller RHS". The
        # config most likely to surface a regression in that invariant is
        # iterative refinement, which in some sparse solvers keeps per-
        # column state sized from the analysis shape. Enabling cuDSS IR on
        # the scenario solver exercises that code path end-to-end; a future
        # cuDSS change that violated the invariant should trip this test.
        ns, nv, nd, nc = 2, 2, 2, 1
        θ = [1.0, 2.0]
        H_v = zeros(nv, ns)
        for k in 1:ns, j in 1:nv
            H_v[j, k] = 2θ[k]
        end

        scenario_opt = MadNLP.default_options(CUDSSSolver)
        scenario_opt.cudss_ir = 2

        nlp = build_twostage_qp(
            CUDA.zeros(Float64, ns * nv + nd);
            ns, nv, nd, nc,
            hess_v = H_v, hess_d = fill(2.0, nd),
            g_v = zeros(nv, ns), g_d = zeros(nd),
            A_v = fill(1.0, nc, nv, ns), A_d = fill(1.0, nc, nd, ns),
            lcon = ones(nc, ns), ucon = ones(nc, ns),
            lvar_v = fill(-50.0, nv, ns), uvar_v = fill(50.0, nv, ns),
            lvar_d = fill(-50.0, nd), uvar_d = fill(50.0, nd),
        )

        opts = schur_opts(; ns, nv, nd, nc)
        opts[:schur_scenario_opt_linear_solver] = scenario_opt

        result = madnlp(
            nlp;
            callback = MadNLP.SparseCallback,
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCUDASolver,
            kkt_options = opts,
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
    end

    @testset "Known solution with inactive constraints" begin
        ns, nv, nd, nc = 2, 1, 1, 1
        θ = [3.0, 7.0]

        nlp = build_twostage_qp(
            CUDA.zeros(Float64, ns * nv + nd);
            ns, nv, nd, nc,
            hess_v = fill(2.0, nv, ns), hess_d = fill(2.0, nd),
            g_v = reshape(-2 .* θ, nv, ns), g_d = [-10.0],
            A_v = fill(1.0, nc, nv, ns), A_d = fill(1.0, nc, nd, ns),
            lcon = fill(-100.0, nc, ns), ucon = fill(100.0, nc, ns),
            lvar_v = fill(-100.0, nv, ns), uvar_v = fill(100.0, nv, ns),
            lvar_d = fill(-100.0, nd), uvar_d = fill(100.0, nd),
        )

        result = madnlp(
            nlp;
            callback = MadNLP.SparseCallback,
            kkt_system = SchurComplementKKTSystem,
            linear_solver = LapackCUDASolver,
            kkt_options = schur_opts(; ns, nv, nd, nc),
            print_level = MadNLP.ERROR,
        )
        @test result.status == MadNLP.SOLVE_SUCCEEDED
        sol = Array(result.solution)
        @test isapprox(sol[1], 3.0; atol = 1.0e-3)
        @test isapprox(sol[2], 7.0; atol = 1.0e-3)
        @test isapprox(sol[3], 5.0; atol = 1.0e-3)
    end
end

"""
    AbstractKKTSystem{T, VT<:AbstractVector{T}, MT<:AbstractMatrix{T}, QN<:AbstractHessian{T}}

Abstract type for KKT system.
"""
abstract type AbstractKKTSystem{T, VT, MT<:AbstractMatrix{T}, QN<:AbstractHessian{T, VT}} end

"""
    AbstractUnreducedKKTSystem{T, VT, MT, QN} <: AbstractKKTSystem{T, VT, MT, QN}

Augmented KKT system associated to the linearization of the KKT
conditions at the current primal-dual iterate ``(x, s, y, z, ν, w)``.

The associated matrix is
```
[Wₓₓ  0   Aₑ'  Aᵢ' V½  0  ]  [Δx]
[0    0   0   -I   0   W½ ]  [Δs]
[Aₑ   0   0    0   0   0  ]  [Δy]
[Aᵢ  -I   0    0   0   0  ]  [Δz]
[V½   0   0    0  -X   0  ]  [Δτ]
[0    W½  0    0   0  -S  ]  [Δρ]
```
with
* ``Wₓₓ``: Hessian of the Lagrangian.
* ``Aₑ``: Jacobian of the equality constraints
* ``Aᵢ``: Jacobian of the inequality constraints
* ``X = diag(x)``
* ``S = diag(s)``
* ``V = diag(ν)``
* ``W = diag(w)``
* ``Δτ = -W^{-½}Δν``
* ``Δρ = -W^{-½}Δw``
"""
abstract type AbstractUnreducedKKTSystem{T, VT, MT, QN} <: AbstractKKTSystem{T, VT, MT, QN} end

"""
    AbstractReducedKKTSystem{T, VT, MT, QN} <: AbstractKKTSystem{T, VT, MT, QN}

The reduced KKT system is a simplification of the original Augmented KKT system.
Comparing to [`AbstractUnreducedKKTSystem`](@ref)), `AbstractReducedKKTSystem` removes
the two last rows associated to the bounds' duals ``(ν, w)``.

At a primal-dual iterate ``(x, s, y, z)``, the matrix writes
```
[Wₓₓ + Σₓ   0    Aₑ'   Aᵢ']  [Δx]
[0          Σₛ    0    -I ]  [Δs]
[Aₑ         0     0     0 ]  [Δy]
[Aᵢ        -I     0     0 ]  [Δz]
```
with
* ``Wₓₓ``: Hessian of the Lagrangian.
* ``Aₑ``: Jacobian of the equality constraints
* ``Aᵢ``: Jacobian of the inequality constraints
* ``Σₓ = X⁻¹ V``
* ``Σₛ = S⁻¹ W``

"""
abstract type AbstractReducedKKTSystem{T, VT, MT, QN} <: AbstractKKTSystem{T, VT, MT, QN} end

"""
    AbstractCondensedKKTSystem{T, VT, MT, QN} <: AbstractKKTSystem{T, VT, MT, QN}

The condensed KKT system simplifies further the [`AbstractReducedKKTSystem`](@ref)
by removing the rows associated to the slack variables ``s`` and the inequalities.

At the primal-dual iterate ``(x, y)``, the matrix writes
```
[Wₓₓ + Σₓ + Aᵢ' Σₛ Aᵢ    Aₑ']  [Δx]
[         Aₑ              0 ]  [Δy]
```
with
* ``Wₓₓ``: Hessian of the Lagrangian.
* ``Aₑ``: Jacobian of the equality constraints
* ``Aᵢ``: Jacobian of the inequality constraints
* ``Σₓ = X⁻¹ V``
* ``Σₛ = S⁻¹ W``
"""
abstract type AbstractCondensedKKTSystem{T, VT, MT, QN} <: AbstractKKTSystem{T, VT, MT, QN} end


#=
    Templates
=#

"""
    create_kkt_system(
        ::Type{KKT},
        cb::AbstractCallback,
        ind_cons::NamedTuple,
        linear_solver::Type{LinSol};
        opt_linear_solver=default_options(linear_solver),
        hessian_approximation=ExactHessian,
    ) where {KKT<:AbstractKKTSystem, LinSol<:AbstractLinearSolver}

Instantiate a new KKT system with type `KKT`, associated to the
the nonlinear program encoded inside the callback `cb`. The
`NamedTuple` `ind_cons` stores the indexes of all the variables and
constraints in the callback `cb`. In addition, the user should pass
the linear solver `linear_solver` that will be used to solve the KKT system
after it has been assembled.

"""
function create_kkt_system end

"Number of primal variables (including slacks) associated to the KKT system."
function num_variables end

"""
    get_kkt(kkt::AbstractKKTSystem)::AbstractMatrix

Return a pointer to the KKT matrix implemented in `kkt`.
The pointer is passed afterward to a linear solver.
"""
function get_kkt end

"Get Jacobian matrix"
function get_jacobian end

"Get Hessian matrix"
function get_hessian end

"""
    initialize!(kkt::AbstractKKTSystem)

Initialize KKT system with default values.
Called when we initialize the `MadNLPSolver` storing the current KKT system `kkt`.
"""
function initialize! end

"""
    build_kkt!(kkt::AbstractKKTSystem)

Assemble the KKT matrix before calling the factorization routine.

"""
function build_kkt! end

"""
    factorize_kkt!(kkt::AbstractKKTSystem)

Factorize the KKT matrix using the linear solver stored in `kkt`.

"""
function factorize_kkt! end

"""
    compress_hessian!(kkt::AbstractKKTSystem)

Compress the Hessian inside `kkt`'s internals.
This function is called every time a new Hessian is evaluated.

Default implementation do nothing.

"""
function compress_hessian! end

"""
    compress_jacobian!(kkt::AbstractKKTSystem)

Compress the Jacobian inside `kkt`'s internals.
This function is called every time a new Jacobian is evaluated.

By default, the function updates in the Jacobian the coefficients
associated to the slack variables.

"""
function compress_jacobian! end

"""
    jtprod!(y::AbstractVector, kkt::AbstractKKTSystem, x::AbstractVector)

Multiply with transpose of Jacobian and store the result
in `y`, such that ``y = A' x`` (with ``A`` current Jacobian).
"""
function jtprod! end

"""
    solve_kkt!(kkt::AbstractKKTSystem, w::AbstractKKTVector)

Solve the KKT system ``K x = w`` with the linear solver stored
inside `kkt` and stores the result inplace inside the `AbstractKKTVector` `w`.

"""
function solve_kkt! end

"""
    regularize_diagonal!(kkt::AbstractKKTSystem, primal_values::Number, dual_values::Number)

Regularize the values in the diagonal of the KKT system in an incremental fashion.
Called internally inside the interior-point routine.
"""
function regularize_diagonal! end

"""
    is_inertia_correct(kkt::AbstractKKTSystem, n::Int, m::Int, p::Int)

Check if the inertia ``(n, m, p)`` returned by the linear solver is adapted
to the KKT system implemented in `kkt`.

"""
function is_inertia_correct end

"Nonzero in Jacobian"
function nnz_jacobian end

#=
    Generic functions
=#
function initialize!(kkt::AbstractKKTSystem)
    fill!(kkt.reg, 1.0)
    fill!(kkt.pr_diag, 1.0)
    fill!(kkt.du_diag, 0.0)
    fill!(kkt.hess, 0.0)
    return
end

function factorize_kkt!(kkt::AbstractKKTSystem)
    return factorize!(kkt.linear_solver)
end

function regularize_diagonal!(kkt::AbstractKKTSystem, primal, dual)
    kkt.reg .+= primal
    kkt.pr_diag .+= primal
    kkt.du_diag .-= dual
end

Base.size(kkt::AbstractKKTSystem) = size(kkt.aug_com)
Base.size(kkt::AbstractKKTSystem, dim::Int) = size(kkt.aug_com, dim)

# Getters
get_kkt(kkt::AbstractKKTSystem) = kkt.aug_com
get_jacobian(kkt::AbstractKKTSystem) = kkt.jac
get_hessian(kkt::AbstractKKTSystem) = kkt.hess

"""
        is inertia_correct(kkt::AbstractKKTSystem, num_pos, num_zero, num_neg)

Check if the inertia ``(num_pos, num_zero, num_neg)`` returned by the linear solver
ensures the desired conditions
"""
function is_inertia_correct(kkt::AbstractKKTSystem, num_pos, num_zero, num_neg)
    return (num_zero == 0) && (num_pos == num_variables(kkt))
end

"""
        should_regularize_dual(kkt::AbstractKKTSystem, num_pos, num_zero, num_neg)

Check if the inertia ``(num_pos, num_zero, num_neg)`` returned by the linear solver
necessitates the dual regularization of the KKT system.
"""
function should_regularize_dual(kkt::AbstractKKTSystem, num_pos, num_zero, num_neg)
    return num_zero != 0
end

compress_hessian!(kkt::AbstractKKTSystem) = nothing

include("rhs.jl")
include("Dense/augmented.jl")
include("Dense/condensed.jl")
include("Dense/utils.jl")
include("Sparse/unreduced.jl")
include("Sparse/augmented.jl")
include("Sparse/condensed.jl")
include("Sparse/scaled_augmented.jl")
include("Sparse/utils.jl")
include("Schur/schur.jl")

# MadNLP.jl
# Created by Sungho Shin (sungho.shin@wisc.edu)

#=
    LinearSolver's interface
=#
"""
    AbstractLinearSolver

Abstract type for linear solver targeting
the resolution of the linear system ``Ax=b``.
"""
abstract type AbstractLinearSolver{T} end
abstract type AbstractLapackSolver{T, Alg} <: AbstractLinearSolver{T} end

"""
    introduce(::AbstractLinearSolver)

Print the name of the linear solver.
"""
function introduce end

"""
    factorize!(::AbstractLinearSolver)

Factorize the matrix ``A`` and updates the factors
inside the `AbstractLinearSolver` instance.
"""
function factorize! end

"""
    solve_linear_system!(::AbstractLinearSolver, x::AbstractVector)

Solve the linear system ``Ax = b``.

This function assumes the linear system has been
factorized previously with [`factorize!`](@ref).
"""
function solve_linear_system! end

"""
    is_supported(solver,T)

Return `true` if `solver` supports the floating point
number type `T`.

# Examples
```julia-repl
julia> is_supported(UmfpackSolver,Float64)
true

julia> is_supported(UmfpackSolver,Float32)
false
```
"""
function is_supported(::Type{LS},::Type{T}) where {LS <: AbstractLinearSolver, T <: AbstractFloat}
    return false
end

"""
    is_async(::AbstractLinearSolver)

Return `true` if the linear solver runs asynchronously
i.e., the `factorize!` and `solve!` functions return before
the factorization and solve operations are completed.
"""
function is_async(::AbstractLinearSolver)
    return false
end

"""
    is_inertia(::AbstractLinearSolver)

Return `true` if the linear solver supports the
computation of the inertia of the linear system.
"""
function is_inertia end

"""
    inertia(::AbstractLinearSolver)

Return the inertia `(n, m, p)` of the linear system
as a tuple.

### Note
The inertia is defined as a tuple ``(n, m, p)``,
with
- ``n``: number of positive eigenvalues
- ``m``: number of negative eigenvalues
- ``p``: number of zero eigenvalues
"""
function inertia end


function improve! end

# Default function for AbstractKKTVector
function solve_linear_system!(s::AbstractLinearSolver, x::AbstractKKTVector)
    solve_linear_system!(s, full(x))
end

function solve_linear_system!(s::AbstractLinearSolver{T}, X::AbstractMatrix) where T
    n, nrhs = size(X)
    x = zeros(T, n)
    for i in 1:nrhs
        copyto!(x, 1, X, (i-1)*n + 1, n)
        solve_linear_system!(s, x)
        copyto!(X, (i-1)*n + 1, x, 1, n)
    end
end

#=
    Iterator's interface
=#
abstract type AbstractIterator{T} end

"""
    solve_refine!(x::VT, ::AbstractIterator, b::VT, w::VT) where {VT <: AbstractKKTVector}

Solve the linear system ``Ax = b`` using iterative
refinement. The object `AbstractIterator` stores an instance
of a [`AbstractLinearSolver`](@ref) for the backsolve
operations.

### Notes
This function assumes the matrix stored in the linear solver
has been factorized previously.

"""
function solve_refine! end

# LinearSolverExceptions
struct SymbolicException <: Exception end
struct FactorizationException <: Exception end
struct SolveException <: Exception end
struct InertiaException <: Exception end
LinearSolverException=Union{SymbolicException,FactorizationException,SolveException,InertiaException}

@enum(
    LinearFactorization::Int,
    BUNCHKAUFMAN = 1,
    LU = 2,
    QR = 3,
    CHOLESKY = 4,
    LDL = 5,
    EVD = 6,
)

# iterative solvers
include("backsolve.jl")

#=
    DEFAULT SOLVERS
=#

# dense solvers
include("lapack_common.jl")
include("lapack.jl")
include("ldl.jl")
include("mumps.jl")

# These solvers are only available if Julia was built with SuiteSparse,
# which is GPL.  If not, then the `using`s here will fail.
if Base.USE_GPL_LIBS
    include("umfpack.jl")
    include("cholmod.jl")
end

@kwdef mutable struct CHOLMODOptions <: AbstractOptions
    cholmod_algorithm::LinearFactorization = CHOLESKY
end

mutable struct CHOLMODSolver{T} <: AbstractLinearSolver{T}
    inner::CHOLMOD.Factor{Float64}
    tril::SparseMatrixCSC{T,Int32}
    full::SparseMatrixCSC{Float64,Int}
    tril_to_full_view::SubVector{T}

    p::Vector{Float64}
    d::Vector{Float64}

    opt::CHOLMODOptions
    logger::MadNLPLogger
end

function CHOLMODSolver(
    csc::SparseMatrixCSC{T};
    opt=CHOLMODOptions(), logger=MadNLPLogger(),
) where T
    p = Vector{Float64}(undef,csc.n)
    d = Vector{Float64}(undef,csc.n)
    full, tril_to_full_view = get_tril_to_full(Float64, csc)

    if opt.cholmod_algorithm == LDL && VERSION <= v"1.9"
        error("[CHOLMOD] Option `cholmod_algorithm=LDL` is not supported for Julia version <= 1.9")
    end

    full = SparseMatrixCSC{Float64,Int}(
        full.m,
        full.n,
        Vector{Int64}(full.colptr),
        Vector{Int64}(full.rowval),
        full.nzval
    )
    fill!(full.nzval, one(T))

    A = CHOLMOD.Sparse(full)
    inner = CHOLMOD.symbolic(A)

    return CHOLMODSolver(inner, csc, full, tril_to_full_view, p, d, opt, logger)
end

function factorize!(M::CHOLMODSolver)
    M.full.nzval .= M.tril_to_full_view
    # We check the factorization succeeded later in the backsolve
    if M.opt.cholmod_algorithm == LDL
        CHOLMOD.ldlt!(M.inner, M.full; check=false)
    elseif M.opt.cholmod_algorithm == CHOLESKY
        CHOLMOD.cholesky!(M.inner, M.full; check=false)
    end
    return M
end

function solve_linear_system!(M::CHOLMODSolver{T}, rhs::Vector{T}) where T
    if issuccess(M.inner)
        B = CHOLMOD.Dense(rhs)
        X = CHOLMOD.solve(CHOLMOD.CHOLMOD_A, M.inner, B)
        copyto!(rhs, X)
    end
    # If the factorization failed, we return the same
    # rhs to enter into a primal-dual regularization phase.
    return rhs
end

# Utils function to copy the diagonal entries directly from CHOLMOD's factor.
function _get_diagonal!(F::CHOLMOD.Factor{T}, d::Vector{T}) where T
    s = unsafe_load(CHOLMOD.typedpointer(F))
    # Wrap in memory the factor LD stored in CHOLMOD.
    colptr = unsafe_wrap(Array, s.p, s.n+1, own=false)
    nz = unsafe_wrap(Array, s.nz, s.n, own=false)
    rowval = unsafe_wrap(Array, s.i, s.nzmax, own=false)
    nzvals = unsafe_wrap(Array, Ptr{T}(s.x), s.nzmax, own=false)
    # Read LD factor and load diagonal entries
    for j in 1:s.n
        for c in colptr[j]:colptr[j]+nz[j]-1
            i = rowval[c+1] + 1  # convert to 1-based indexing
            if i == j
                d[i] = nzvals[c+1]
            end
        end
    end
    return d
end

is_inertia(::CHOLMODSolver) = true
function _inertia_cholesky(M::CHOLMODSolver)
    n = size(M.full, 1)
    if issuccess(M.inner)
        return (n, 0, 0)
    else
        return (0, n, 0)
    end
end
function _inertia_ldlt(M::CHOLMODSolver{T}) where T
    n = size(M.full, 1)
    if !issuccess(M.inner)
        return (0, n, 0)
    end
    D = M.d
    # Extract diagonal elements
    _get_diagonal!(M.inner, D)
    (pos, zero, neg) = (0, 0, 0)
    @inbounds for i in 1:n
        d = D[i]
        if d > 0
            pos += 1
        elseif d == 0
            zero += 1
        else
            neg += 1
        end
    end
    @assert pos + zero + neg == n
    return pos, zero, neg
end
function inertia(M::CHOLMODSolver)
    if M.opt.cholmod_algorithm == CHOLESKY
        return _inertia_cholesky(M)
    elseif M.opt.cholmod_algorithm == LDL
        return _inertia_ldlt(M)
    end
end
input_type(::Type{CHOLMODSolver}) = :csc
default_options(::Type{CHOLMODSolver}) = CHOLMODOptions()

improve!(M::CHOLMODSolver) = false
introduce(::CHOLMODSolver) = "cholmod v$(CHOLMOD.BUILD_VERSION)"
is_supported(::Type{CHOLMODSolver},::Type{Float32}) = true
is_supported(::Type{CHOLMODSolver},::Type{Float64}) = true

#=
    Regular filter line-search algorithm.
=#

function filter_line_search!(solver::AbstractMadNLPSolver{T}) where T
    theta = get_theta(get_c(solver))
    varphi= get_varphi(get_obj_val(solver),get_x_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_ur(solver),get_mu(solver))
    varphi_d = get_varphi_d(
        primal(get_f(solver)),
        primal(get_x(solver)),
        primal(get_xl(solver)),
        primal(get_xu(solver)),
        primal(get_d(solver)),
        get_mu(solver),
    )

    alpha_max = get_alpha_max(
        primal(get_x(solver)),
        primal(get_xl(solver)),
        primal(get_xu(solver)),
        primal(get_d(solver)),
        get_tau(solver),
    )
    set_alpha_z!(solver, get_alpha_z(get_zl_r(solver),get_zu_r(solver),dual_lb(get_d(solver)),dual_ub(get_d(solver)),get_tau(solver)))
    alpha_min = get_alpha_min(theta,varphi_d,get_theta_min(solver),get_opt(solver).gamma_theta,get_opt(solver).gamma_phi,
                                get_opt(solver).alpha_min_frac,get_opt(solver).delta,get_opt(solver).s_theta,get_opt(solver).s_phi)
    get_cnt(solver).l = 1
    set_alpha!(solver, alpha_max)
    varphi_trial= zero(T)
    theta_trial = zero(T)
    small_search_norm = get_rel_search_norm(primal(get_x(solver)), primal(get_d(solver))) < 10*eps(T)
    switching_condition = is_switching(varphi_d,get_alpha(solver),get_opt(solver).s_phi,get_opt(solver).delta,2.,get_opt(solver).s_theta)
    armijo_condition = false
    unsuccessful_iterate = false

    while true

        copyto!(full(get_x_trial(solver)), full(get_x(solver)))
        axpy!(get_alpha(solver), primal(get_d(solver)), primal(get_x_trial(solver)))
        set_obj_val_trial!(solver, eval_f_wrapper(solver, get_x_trial(solver)))
        eval_cons_wrapper!(solver, get_c_trial(solver), get_x_trial(solver))

        theta_trial = get_theta(get_c_trial(solver))
        varphi_trial= get_varphi(get_obj_val_trial(solver),get_x_trial_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_trial_ur(solver),get_mu(solver))
        armijo_condition = is_armijo(varphi_trial,varphi,get_opt(solver).eta_phi,get_alpha(solver),varphi_d)

        small_search_norm && break

        set_ftype!(solver, get_ftype(
            get_filter(solver),theta,theta_trial,varphi,varphi_trial,switching_condition,armijo_condition,
            get_theta_min(solver),get_opt(solver).obj_max_inc,get_opt(solver).gamma_theta,get_opt(solver).gamma_phi,
            has_constraints(solver))
                   )

        if get_ftype(solver) in ("f","h")
            @trace(get_logger(solver),"Step accepted with type $(get_ftype(solver))")
            break
        end

        if get_cnt(solver).l==1 && theta_trial>=theta
            if second_order_correction(
                solver,alpha_max,theta,varphi,theta_trial,varphi_d,switching_condition
            )
                break
            end
        end

        unsuccessful_iterate = true
        set_alpha!(solver, get_alpha(solver)/2)
        get_cnt(solver).l += 1
        if get_alpha(solver) < alpha_min
            @debug(get_logger(solver),
                    "Cannot find an acceptable step at iteration $(get_cnt(solver).k). Switching to restoration phase.")
            get_cnt(solver).k+=1
            return RESTORE
        else
            @trace(get_logger(solver),"Step rejected; proceed with the next trial step.")
            if get_alpha(solver) * norm(primal(get_d(solver))) < eps(T)*10
                if (get_cnt(solver).restoration_fail_count += 1) >= 4
                    return get_cnt(solver).acceptable_cnt >0 ?
                        SOLVED_TO_ACCEPTABLE_LEVEL : SEARCH_DIRECTION_BECOMES_TOO_SMALL
                else
                    # (experimental) while giving up directly
                    # we give MadNLP.jl second chance to explore
                    # some possibility at the current iterate

                    fill!(get_y(solver), zero(T))
                    fill!(get_zl_r(solver), one(T))
                    fill!(get_zu_r(solver), one(T))
                    empty!(get_filter(solver))
                    push!(get_filter(solver),(get_theta_max(solver),-Inf))
                    get_cnt(solver).k+=1

                    return REGULAR
                end
            end
        end
    end

    # this implements the heuristics in Section 3.2 of Ipopt paper.
    # Case I is only implemented
    if unsuccessful_iterate
        if (get_cnt(solver).unsuccessful_iterate += 1) >= 4
            if get_theta_max(solver)/10 > theta_trial
                @debug(get_logger(solver), "restarting filter")
                set_theta_max!(solver, get_theta_max(solver)/10)
                empty!(get_filter(solver))
                push!(get_filter(solver),(get_theta_max(solver),-Inf))
            end
            get_cnt(solver).unsuccessful_iterate = 0
        end
    else
        get_cnt(solver).unsuccessful_iterate = 0
    end

    if !switching_condition || !armijo_condition
        @trace(get_logger(solver),"Augmenting filter.")
        augment_filter!(get_filter(solver),theta_trial,varphi_trial,get_opt(solver).gamma_theta)
    end

    return LINESEARCH_SUCCEEDED
end

#=
    Variant of filter line-search for feasibility restoration phase.
=#

function filter_line_search_RR!(solver::AbstractMadNLPSolver{T}) where T
    RR = get_RR(solver)
    theta_R = get_theta_R(get_c(solver),RR.pp,RR.nn)
    varphi_R = get_varphi_R(RR.obj_val_R,get_x_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_ur(solver),RR.pp,RR.nn,RR.mu_R)
    varphi_d_R = get_varphi_d_R(
        RR.f_R,
        primal(get_x(solver)),
        primal(get_xl(solver)),
        primal(get_xu(solver)),
        primal(get_d(solver)),
        RR.pp,RR.nn,RR.dpp,RR.dnn,RR.mu_R,get_opt(solver).rho,
    )

    # set alpha_min
    alpha_max = get_alpha_max_R(
        primal(get_x(solver)),
        primal(get_xl(solver)),
        primal(get_xu(solver)),
        primal(get_d(solver)),
        RR.pp,RR.dpp,RR.nn,RR.dnn,RR.tau_R,
    )
    set_alpha_z!(solver, get_alpha_z_R(get_zl_r(solver),get_zu_r(solver),dual_lb(get_d(solver)),dual_ub(get_d(solver)),RR.zp,RR.dzp,RR.zn,RR.dzn,RR.tau_R))
    alpha_min = get_alpha_min(theta_R,varphi_d_R,get_theta_min(solver),get_opt(solver).gamma_theta,get_opt(solver).gamma_phi,
                                get_opt(solver).alpha_min_frac,get_opt(solver).delta,get_opt(solver).s_theta,get_opt(solver).s_phi)

    set_alpha!(solver, alpha_max)
    get_cnt(solver).l = 1
    theta_R_trial = zero(T)
    varphi_R_trial = zero(T)
    small_search_norm = get_rel_search_norm(primal(get_x(solver)), primal(get_d(solver))) < 10*eps(T)
    switching_condition = is_switching(varphi_d_R,get_alpha(solver),get_opt(solver).s_phi,get_opt(solver).delta,theta_R,get_opt(solver).s_theta)
    armijo_condition = false

    while true
        copyto!(full(get_x_trial(solver)), full(get_x(solver)))
        copyto!(RR.pp_trial,RR.pp)
        copyto!(RR.nn_trial,RR.nn)
        axpy!(get_alpha(solver),primal(get_d(solver)),primal(get_x_trial(solver)))
        axpy!(get_alpha(solver),RR.dpp,RR.pp_trial)
        axpy!(get_alpha(solver),RR.dnn,RR.nn_trial)

        RR.obj_val_R_trial = get_obj_val_R(
            RR.pp_trial,RR.nn_trial,RR.D_R,primal(get_x_trial(solver)),RR.x_ref,get_opt(solver).rho,RR.zeta)
        eval_cons_wrapper!(solver, get_c_trial(solver), get_x_trial(solver))
        theta_R_trial  = get_theta_R(get_c_trial(solver),RR.pp_trial,RR.nn_trial)
        varphi_R_trial = get_varphi_R(
            RR.obj_val_R_trial,get_x_trial_lr(solver),get_xl_r(solver),get_xu_r(solver),get_x_trial_ur(solver),RR.pp_trial,RR.nn_trial,RR.mu_R)

        armijo_condition = is_armijo(varphi_R_trial,varphi_R,get_opt(solver).eta_phi,get_alpha(solver),varphi_d_R)

        small_search_norm && break
        set_ftype!(solver, get_ftype(
            RR.filter,theta_R,theta_R_trial,varphi_R,varphi_R_trial,
            switching_condition,armijo_condition,
            get_theta_min(solver),get_opt(solver).obj_max_inc,get_opt(solver).gamma_theta,get_opt(solver).gamma_phi,
            has_constraints(solver))
                )
        get_ftype(solver) in ["f","h"] && (@trace(get_logger(solver),"Step accepted with type $(get_ftype(solver))"); break)

        set_alpha!(solver, get_alpha(solver)/2)
        get_cnt(solver).l += 1
        if get_alpha(solver) < alpha_min
            @debug(get_logger(solver),"Restoration phase cannot find an acceptable step at iteration $(get_cnt(solver).k).")
            if (get_cnt(solver).restoration_fail_count += 1) >= 4
                return RESTORATION_FAILED
            else
                # (experimental) while giving up directly
                # we give MadNLP.jl second chance to explore
                # some possibility at the current iterate

                fill!(get_y(solver), zero(T))
                fill!(get_zl_r(solver), one(T))
                fill!(get_zu_r(solver), one(T))
                empty!(get_filter(solver))
                push!(get_filter(solver),(get_theta_max(solver),-Inf))

                get_cnt(solver).k+=1
                get_cnt(solver).t+=1
                return REGULAR
            end
        else
            @trace(get_logger(solver),"Step rejected; proceed with the next trial step.")
            get_alpha(solver) < eps(T)*10 && return get_cnt(solver).acceptable_cnt >0 ?
                SOLVED_TO_ACCEPTABLE_LEVEL : SEARCH_DIRECTION_BECOMES_TOO_SMALL
        end
    end

    if !switching_condition || !armijo_condition
        @trace(get_logger(solver),"Augmenting restoration phase filter.")
        augment_filter!(RR.filter,theta_R_trial,varphi_R_trial,get_opt(solver).gamma_theta)
    end

    return LINESEARCH_SUCCEEDED
end

struct NLSModel <: NLPModels.AbstractNLSModel{Float64,Vector{Float64}}
    meta::NLPModels.NLPModelMeta{Float64, Vector{Float64}}
    nls_meta::NLPModels.NLSMeta{Float64, Vector{Float64}}
    counters::NLPModels.NLSCounters
end

function NLSModel()
    x0 = [-1.2; 1.0]
    return NLSModel(
        NLPModels.NLPModelMeta(
            2,     #nvar
            ncon = 0,
            nnzj = 0,
            nnzh = 3,
            x0 = x0,
            lvar = zeros(2),
            uvar = ones(2),
            minimize = true
        ),
        NLPModels.NLSMeta(2, 2; nnzj=3, nnzh=4),
        NLPModels.NLSCounters()
    )
end

function NLPModels.residual!(nls::NLSModel, x, Fx)
    Fx[1] = x[1] - 1.0
    Fx[2] = 10.0 * (x[2] - x[1]^2)
    return Fx
end

function NLPModels.jac_structure_residual!(
    nls::NLSModel,
    rows::AbstractVector{<:Integer},
    cols::AbstractVector{<:Integer},
)
    copyto!(rows, [1, 2, 2])
    copyto!(cols, [1, 1, 2])
    return rows, cols
end

function NLPModels.jac_coord_residual!(nls::NLSModel, x::AbstractVector, vals::AbstractVector)
    vals[1] = 1.0
    vals[2] = -20.0 * x[1]
    vals[3] = 10.0
    return vals
end

function NLPModels.jprod_residual!(nls::NLSModel, x::AbstractVector, v::AbstractVector, Jv::AbstractVector)
    Jv[1] = v[1]
    Jv[2] = -20.0 * x[1] * v[1] + 10.0 * v[2]
    return Jv
end

function NLPModels.jtprod_residual!(nls::NLSModel, x::AbstractVector, v::AbstractVector, Jtv::AbstractVector)
    Jtv[1] = v[1] - 20.0 * x[1] * v[2]
    Jtv[2] = 10.0 * v[2]
    return Jtv
end

function NLPModels.hess_structure_residual!(
    nls::NLSModel,
    rows::AbstractVector{<:Integer},
    cols::AbstractVector{<:Integer},
)
    rows[1] = 1
    cols[1] = 1
    return rows, cols
end

function NLPModels.hess_coord_residual!(
    nls::NLSModel,
    x::AbstractVector,
    v::AbstractVector,
    vals::AbstractVector,
)
    vals[1] = -20.0 * v[2]
    return vals
end

function NLPModels.hess_structure!(nlp::NLSModel, rows::AbstractVector{T}, cols::AbstractVector{T}) where T
    copyto!(rows, [1, 2, 2])
    copyto!(cols, [1, 1, 2])
    return rows, cols
end

function NLPModels.hess_coord!(nlp::NLSModel, x, y, H::AbstractVector; obj_weight=1.0)
    # Objective
    H[1] = obj_weight * (1.0 - 200.0 * x[2] + 600 * x[1]^2)
    H[2] = obj_weight * (-200.0 * x[1])
    H[3] = obj_weight * 100.0
    return H
end

const OPTIMIZER = ()->MadNLP.Optimizer(
    kkt_system=MadNLP.DenseKKTSystem,
    linear_solver=MadNLP.LapackCPUSolver,
    print_level=MadNLP.ERROR
)

@testset "MINLPTests" begin
    ###
    ### src/nlp tests.
    ###

    MINLPTests.test_nlp(
        OPTIMIZER,
        exclude = [
            "005_011",  # Uses the function `\`
            "006_010",  # User-defined function without Hessian (autodiff only provides 1st order)
            "009_010",  # Objective is non-smooth
        ],
        objective_tol = 1e-5,
        primal_tol = 1e-5,
        dual_tol = NaN,
    )

    ###
    ### src/nlp-cvx tests.
    ###

    MINLPTests.test_nlp_cvx(
        OPTIMIZER,
    )
end

@kwdef mutable struct LDLFactorizationsOptions <: AbstractOptions
end
const LDLF = LDLFactorizations

mutable struct LDLSolver{T} <: AbstractLinearSolver{T}
    inner::LDLF.LDLFactorization{T, Int32}
    tril::SparseMatrixCSC{T,Int32}
    full::SparseMatrixCSC{T,Int32}
    tril_to_full_view::SubVector{T}
    opt::LDLFactorizationsOptions
    logger::MadNLPLogger
end

function LDLSolver(
    tril::SparseMatrixCSC{T};
    opt=LDLFactorizationsOptions(), logger=MadNLPLogger(),
) where T
    # TODO: convert tril to triu, not full
    full, tril_to_full_view = get_tril_to_full(T,tril)

    return LDLSolver(
        LDLF.ldl(
            full
        ),
        tril, full, tril_to_full_view, opt, logger
    )
end

function factorize!(M::LDLSolver)
    M.full.nzval .= M.tril_to_full_view
    LDLF.ldl_factorize!(M.full, M.inner)
    return M
end

function solve_linear_system!(M::LDLSolver{T},rhs::Vector{T}) where T
    ldiv!(M.inner, rhs)
    # If the factorization failed, we return the same
    # rhs to enter into a primal-dual regularization phase.
    return rhs
end

is_inertia(::LDLSolver) = true
function inertia(M::LDLSolver)
    (m, n) = size(M.tril)
    (pos, zero, neg) = (0, 0, 0)
    D = M.inner.D
    for i=1:n
        d = D[i,i]
        if d > 0
            pos += 1
        elseif d == 0
            zero += 1
        else
            neg += 1
        end
    end
    return pos, zero, neg
end
input_type(::Type{LDLSolver}) = :csc
default_options(::Type{LDLSolver}) = LDLFactorizationsOptions()

function improve!(M::LDLSolver)
    return false
end
introduce(::LDLSolver) = "LDLFactorizations v$(pkgversion(LDLF))"
is_supported(::Type{LDLSolver},::Type{T}) where T <: AbstractFloat = true

"""
    AbstractKKTVector{T, VT}

Supertype for KKT's right-hand-side vectors ``(x, s, y, z, ν, w)``.
"""
abstract type AbstractKKTVector{T, VT} end

"""
    full(X::AbstractKKTVector)

Return the all the values stored inside the KKT vector `X`.
"""
function full end

Base.length(rhs::AbstractKKTVector) = length(full(rhs))

"""
    number_primal(X::AbstractKKTVector)

Get total number of primal values ``(x, s)`` in KKT vector `X`.
"""
number_primal(rhs::AbstractKKTVector) = length(primal(rhs))

"""
    number_dual(X::AbstractKKTVector)

Get total number of dual values ``(y, z)`` in KKT vector `X`.
"""
number_dual(rhs::AbstractKKTVector) = length(dual(rhs))

"""
    primal(X::AbstractKKTVector)

Return the primal values ``(x, s)`` stored in the KKT vector `X`.
"""
function primal end

"""
    dual(X::AbstractKKTVector)

Return the dual values ``(y, z)`` stored in the KKT vector `X`.
"""
function dual end

"""
    primal_dual(X::AbstractKKTVector)

Return both the primal and the dual values ``(x, s, y, z)`` stored in the KKT vector `X`.
"""
function primal_dual end

"""
    dual_lb(X::AbstractKKTVector)

Return the dual values ``ν`` associated to the lower-bound
stored in the KKT vector `X`.
"""
function dual_lb end

"""
    dual_ub(X::AbstractKKTVector)

Return the dual values ``w`` associated to the upper-bound
stored in the KKT vector `X`.
"""
function dual_ub end

function Base.fill!(rhs::AbstractKKTVector{T}, val::T) where T
    fill!(full(rhs), val)
end

# Overload basic BLAS operations.
norm(X::AbstractKKTVector, p::Real=2.0) = norm(full(X), p)
dot(X::AbstractKKTVector, Y::AbstractKKTVector) = dot(full(X), full(Y))
function axpy!(a::Number, X::AbstractKKTVector, Y::AbstractKKTVector)
    axpy!(a, full(X), full(Y))
end

#=
    UnreducedKKTVector
=#

"""
    UnreducedKKTVector{T, VT<:AbstractVector{T}} <: AbstractKKTVector{T, VT}

Full KKT vector ``(x, s, y, z, ν, w)``, associated to a [`AbstractUnreducedKKTSystem`](@ref).

"""
struct UnreducedKKTVector{T, VT<:AbstractVector{T}, VI} <: AbstractKKTVector{T, VT}
    values::VT
    x::VT  # unsafe view
    xp::VT # unsafe view
    xp_lr::SubVector{T, VT, VI}
    xp_ur::SubVector{T, VT, VI}
    xl::VT # unsafe view
    xzl::VT # unsafe view
    xzu::VT # unsafe view
end

function UnreducedKKTVector(
    ::Type{VT}, n::Int, m::Int, nlb::Int, nub::Int, ind_lb, ind_ub
) where {T, VT <: AbstractVector{T}}
    values = VT(undef,n+m+nlb+nub)
    fill!(values, zero(T))
    # Wrap directly array x to avoid dealing with views
    x = _madnlp_unsafe_wrap(values, n + m) # Primal-Dual
    xp = _madnlp_unsafe_wrap(values, n) # Primal
    xl = _madnlp_unsafe_wrap(values, m, n+1) # Dual
    xzl = _madnlp_unsafe_wrap(values, nlb, n + m + 1) # Lower bound
    xzu = _madnlp_unsafe_wrap(values, nub, n + m + nlb + 1) # Upper bound

    xp_lr = view(xp, ind_lb)
    xp_ur = view(xp, ind_ub)

    return UnreducedKKTVector(values, x, xp, xp_lr, xp_ur, xl, xzl, xzu)
end

function UnreducedKKTVector(kkt::AbstractKKTSystem{T, VT}) where {T, VT}
    return UnreducedKKTVector(
        VT,
        length(kkt.pr_diag),
        length(kkt.du_diag),
        length(kkt.l_diag),
        length(kkt.u_diag),
        kkt.ind_lb,
        kkt.ind_ub,
    )
end

function Base.copy(rhs::UnreducedKKTVector{T, VT}) where {T, VT}
    new_rhs = UnreducedKKTVector(
        VT,
        length(rhs.xp),
        length(rhs.xl),
        length(rhs.xzl),
        length(rhs.xzu),
        rhs.xp_lr.indices[1],
        rhs.xp_ur.indices[1],
    )
    copyto!(full(new_rhs), full(rhs))
    return new_rhs
end

full(rhs::UnreducedKKTVector) = rhs.values
primal(rhs::UnreducedKKTVector) = rhs.xp
dual(rhs::UnreducedKKTVector) = rhs.xl
primal_dual(rhs::UnreducedKKTVector) = rhs.x
dual_lb(rhs::UnreducedKKTVector) = rhs.xzl
dual_ub(rhs::UnreducedKKTVector) = rhs.xzu


"""
    PrimalVector{T, VT<:AbstractVector{T}} <: AbstractKKTVector{T, VT}

Primal vector ``(x, s)``.

"""
struct PrimalVector{T, VT<:AbstractVector{T}, VI} <: AbstractKKTVector{T, VT}
    values::VT
    values_lr::SubVector{T, VT, VI}
    values_ur::SubVector{T, VT, VI}
    x::VT  # unsafe view
    s::VT # unsafe view
end

function PrimalVector(::Type{VT}, nx::Int, ns::Int, ind_lb, ind_ub) where {T, VT <: AbstractVector{T}}
    values = VT(undef, nx+ns)
    fill!(values, zero(T))
    x = _madnlp_unsafe_wrap(values, nx)
    s = _madnlp_unsafe_wrap(values, ns, nx+1)
    values_lr = view(values, ind_lb)
    values_ur = view(values, ind_ub)

    return PrimalVector(
        values, values_lr, values_ur, x, s,
    )
end

full(rhs::PrimalVector) = rhs.values
primal(rhs::PrimalVector) = rhs.values
variable(rhs::PrimalVector) = rhs.x
slack(rhs::PrimalVector) = rhs.s

module MadNLPGPUAMDGPUExt

import LinearAlgebra
import SparseArrays: SparseMatrixCSC, nonzeros, nnz
import LinearAlgebra: Symmetric

import MadNLP
import MadNLPGPU

import KernelAbstractions: synchronize, get_backend

using AMDGPU
using AMDGPU.rocBLAS, AMDGPU.rocSOLVER, AMDGPU.rocSPARSE

function __init__()
    setglobal!(MadNLPGPU, :LapackROCmSolver, LapackROCmSolver)
    return
end

include("rocm_sparse.jl")
include("rocsolver.jl")
include("rocm.jl")

end

function MadNLP._update_S_and_Y!(qn::MadNLP.CompactLBFGS, s::AbstractGPUVector, y::AbstractGPUVector)
    return if qn.current_mem < qn.max_mem
        qn.current_mem += 1
        n, k = size(qn)
        vec_Sk = vec(qn.Sk)
        vec_Yk = vec(qn.Yk)
        resize!(vec_Sk, n * k)
        resize!(vec_Yk, n * k)
        qn.Sk = reshape(vec_Sk, n, k)
        qn.Yk = reshape(vec_Yk, n, k)
        view(qn.Sk, 1:n, k) .= s
        view(qn.Yk, 1:n, k) .= y
        MadNLP._resize!(qn)
    else
        n, k = size(qn)
        # Shift
        backend = get_backend(s)
        _update_S_and_Y_kernel!(backend)(k, qn.Sk, qn.Yk, ndrange = n)
        # Latest element
        view(qn.Sk, 1:n, k) .= s
        view(qn.Yk, 1:n, k) .= y
    end
end

function MadNLP._update_L_and_D!(qn::MadNLP.CompactLBFGS{T}, sk::AbstractGPUVector, yk::AbstractGPUVector) where {T}
    # Update the strict lower triangular part of S'Y
    n, k = size(qn)
    return if qn.max_mem_reached
        # shift of all coefficients
        @inbounds for i in 1:(k - 1)
            @allowscalar qn.Dk[i] = qn.Dk[i + 1]
            @inbounds for j in 1:(i - 1)
                @allowscalar qn.Lk[i, j] = qn.Lk[i + 1, j + 1]
            end
        end
        # Compute the new last row of tril(S'Y)
        # It can be recovered with sₖᵀY or Yᵀsₖ
        lk = view(qn.Lk, k, 1:k)
        sk = view(qn.Sk, 1:n, k)
        mul!(lk, qn.Yk', sk)
        @allowscalar qn.Dk[k] = qn.Lk[k, k]
        @allowscalar qn.Lk[k, k] = zero(T)
    else
        # To be optimized...
        p = size(qn.Lk, 1)
        mul!(qn.Lk, qn.Sk', qn.Yk)
        @allowscalar push!(qn.Dk, qn.Lk[k, k])
        backend = get_backend(sk)
        _update_L_and_D_kernel!(backend)(qn.Lk, ndrange = (p, p))
        if qn.current_mem == qn.max_mem
            qn.max_mem_reached = true
        end
    end
end

@kwdef mutable struct UmfpackOptions <: AbstractOptions
    umfpack_pivtol::Float64 = 1e-4
    umfpack_pivtolmax::Float64 = 1e-1
    umfpack_sym_pivtol::Float64 = 1e-3
    umfpack_block_size::Float64 = 16
    umfpack_strategy::Float64 = 2.
end

mutable struct UmfpackSolver{T} <: AbstractLinearSolver{T}
    inner::UMFPACK.UmfpackLU{Float64, Int32}
    tril::SparseMatrixCSC{T,Int32}
    full::SparseMatrixCSC{Float64,Int32}
    tril_to_full_view::SubVector{T}

    p::Vector{Float64}
    d::Vector{Float64}

    opt::UmfpackOptions
    logger::MadNLPLogger
end

function UmfpackSolver(
    csc::SparseMatrixCSC{T};
    opt=UmfpackOptions(), logger=MadNLPLogger(),
) where T
    p = Vector{Float64}(undef,csc.n)
    d = Vector{Float64}(undef,csc.n)
    full, tril_to_full_view = get_tril_to_full(Float64,csc)
    controls = UMFPACK.get_umfpack_control(Float64, Int)
    # Override default controls with custom setting
    controls[4] = opt.umfpack_pivtol
    controls[5] = opt.umfpack_block_size
    controls[6] = opt.umfpack_strategy
    controls[12] = opt.umfpack_sym_pivtol
    inner = UMFPACK.UmfpackLU(full; control=controls)
    return UmfpackSolver(inner, csc, full, tril_to_full_view, p, d, opt, logger)
end

function factorize!(M::UmfpackSolver)
    M.full.nzval .= M.tril_to_full_view
    # We check the factorization succeeded later in the backsolve
    UMFPACK.lu!(M.inner, M.full; check=false)
    return M
end

function solve_linear_system!(M::UmfpackSolver{T},rhs::Vector{T}) where T
    if UMFPACK.issuccess(M.inner)
        M.p .= rhs
        UMFPACK.ldiv!(M.d, M.inner, M.p)
        rhs .= M.d
    end
    # If the factorization failed, we return the same
    # rhs to enter into a primal-dual regularization phase.
    return rhs
end

is_inertia(::UmfpackSolver) = false
inertia(M::UmfpackSolver) = throw(InertiaException())
input_type(::Type{UmfpackSolver}) = :csc
default_options(::Type{UmfpackSolver}) = UmfpackOptions()

function improve!(M::UmfpackSolver)
    if M.inner.control[4] == M.opt.umfpack_pivtolmax
        @debug(M.logger, "improve quality failed.")
        return false
    end
    M.inner.control[4] = min(M.opt.umfpack_pivtolmax, M.inner.control[4]^.75)
    @debug(M.logger, "improved quality: pivtol = $(M.inner.control[4])")
    return true
end
introduce(::UmfpackSolver) = "umfpack"
is_supported(::Type{UmfpackSolver},::Type{Float32}) = true
is_supported(::Type{UmfpackSolver},::Type{Float64}) = true

"""
    SparseUnreducedKKTSystem{T, VT, MT, QN} <: AbstractUnreducedKKTSystem{T, VT, MT, QN}

Implement the [`AbstractUnreducedKKTSystem`](@ref) in sparse COO format.

"""
struct SparseUnreducedKKTSystem{T, VT, MT, QN, LS, VI, VI32} <: AbstractUnreducedKKTSystem{T, VT, MT, QN}
    hess::VT
    jac_callback::VT
    jac::VT
    quasi_newton::QN
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT
    l_lower_aug::VT
    u_lower_aug::VT

    # Augmented system
    aug_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    aug_com::MT
    aug_csc_map::Union{Nothing, VI}

    # Hessian
    hess_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    hess_com::MT
    hess_csc_map::Union{Nothing, VI}

    # Jacobian
    jac_raw::SparseMatrixCOO{T,Int32,VT, VI32}
    jac_com::MT
    jac_csc_map::Union{Nothing, VI}

    # LinearSolver
    linear_solver::LS

    # Info
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
end

function create_kkt_system(
    ::Type{SparseUnreducedKKTSystem},
    cb::SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=default_options(linear_solver),
    hessian_approximation=ExactHessian,
    qn_options=QuasiNewtonOptions(),
) where {T, VT}
    ind_ineq = cb.ind_ineq
    ind_lb = cb.ind_lb
    ind_ub = cb.ind_ub

    n_slack = length(ind_ineq)
    nlb = length(cb.ind_lb)
    nub = length(cb.ind_ub)
    # Deduce KKT size.
    n = cb.nvar
    m = cb.ncon

    # Quasi-newton
    quasi_newton = create_quasi_newton(hessian_approximation, cb, n; options=qn_options)

    # Evaluate sparsity pattern
    jac_sparsity_I = create_array(cb, Int32, cb.nnzj)
    jac_sparsity_J = create_array(cb, Int32, cb.nnzj)
    _jac_sparsity_wrapper!(cb,jac_sparsity_I, jac_sparsity_J)

    hess_sparsity_I = create_array(cb, Int32, cb.nnzh)
    hess_sparsity_J = create_array(cb, Int32, cb.nnzh)
    _hess_sparsity_wrapper!(cb,hess_sparsity_I,hess_sparsity_J)

    force_lower_triangular!(hess_sparsity_I,hess_sparsity_J)

    n_slack = length(ind_ineq)
    n_jac = length(jac_sparsity_I)
    n_hess = length(hess_sparsity_I)
    n_tot = n + n_slack

    aug_mat_length = n_tot + m + n_hess + n_jac + n_slack + 2*nlb + 2*nub
    aug_vec_length = n_tot + m + nlb + nub

    I = create_array(cb, Int32, aug_mat_length)
    J = create_array(cb, Int32, aug_mat_length)
    V = zeros(aug_mat_length)

    offset = n_tot + n_jac + n_slack + n_hess + m

    I[1:n_tot] .= 1:n_tot
    I[n_tot+1:n_tot+n_hess] = hess_sparsity_I
    I[n_tot+n_hess+1:n_tot+n_hess+n_jac].=(jac_sparsity_I.+n_tot)
    I[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack].=(ind_ineq.+n_tot)
    I[n_tot+n_hess+n_jac+n_slack+1:offset].=(n_tot+1:n_tot+m)

    J[1:n_tot] .= 1:n_tot
    J[n_tot+1:n_tot+n_hess] = hess_sparsity_J
    J[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= jac_sparsity_J
    J[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= (n+1:n+n_slack)
    J[n_tot+n_hess+n_jac+n_slack+1:offset].=(n_tot+1:n_tot+m)

    I[offset+1:offset+nlb] .= (1:nlb).+(n_tot+m)
    I[offset+nlb+1:offset+2nlb] .= (1:nlb).+(n_tot+m)
    I[offset+2nlb+1:offset+2nlb+nub] .= (1:nub).+(n_tot+m+nlb)
    I[offset+2nlb+nub+1:offset+2nlb+2nub] .= (1:nub).+(n_tot+m+nlb)
    J[offset+1:offset+nlb] .= (1:nlb).+(n_tot+m)
    J[offset+nlb+1:offset+2nlb] .= ind_lb
    J[offset+2nlb+1:offset+2nlb+nub] .= (1:nub).+(n_tot+m+nlb)
    J[offset+2nlb+nub+1:offset+2nlb+2nub] .= ind_ub

    pr_diag = _madnlp_unsafe_wrap(V,n_tot)
    du_diag = _madnlp_unsafe_wrap(V,m, n_jac + n_slack+n_hess+n_tot+1)

    l_diag = _madnlp_unsafe_wrap(V, nlb, offset+1)
    u_diag = _madnlp_unsafe_wrap(V, nub, offset+2nlb+1)
    l_lower_aug = _madnlp_unsafe_wrap(V, nlb, offset+nlb+1)
    u_lower_aug = _madnlp_unsafe_wrap(V, nub, offset+2nlb+nub+1)
    reg = VT(undef, n_tot)
    l_lower = VT(undef, nlb)
    u_lower = VT(undef, nub)

    hess = _madnlp_unsafe_wrap(V, n_hess, n_tot+1)
    jac = _madnlp_unsafe_wrap(V, n_jac + n_slack, n_hess+n_tot+1)
    jac_callback = _madnlp_unsafe_wrap(V, n_jac, n_hess+n_tot+1)

    hess_raw = SparseMatrixCOO(
        n_tot, n_tot,
        hess_sparsity_I,
        hess_sparsity_J,
        hess,
    )
    aug_raw = SparseMatrixCOO(aug_vec_length,aug_vec_length,I,J,V)
    jac_raw = SparseMatrixCOO(
        m, n_tot,
        Int32[jac_sparsity_I; ind_ineq],
        Int32[jac_sparsity_J; n+1:n+n_slack],
        jac,
    )

    aug_com, aug_csc_map = coo_to_csc(aug_raw)
    jac_com, jac_csc_map = coo_to_csc(jac_raw)
    hess_com, hess_csc_map = coo_to_csc(hess_raw)

    _linear_solver = linear_solver(aug_com; opt = opt_linear_solver)
    return SparseUnreducedKKTSystem(
        hess, jac_callback, jac, quasi_newton, reg, pr_diag, du_diag,
        l_diag, u_diag, l_lower, u_lower, l_lower_aug, u_lower_aug,
        aug_raw, aug_com, aug_csc_map,
        hess_raw, hess_com, hess_csc_map,
        jac_raw, jac_com, jac_csc_map,
        _linear_solver,
        ind_ineq, ind_lb, ind_ub,
    )
end

function initialize!(kkt::SparseUnreducedKKTSystem{T}) where T
    fill!(kkt.reg, one(T))
    fill!(kkt.pr_diag, one(T))
    fill!(kkt.du_diag, zero(T))
    fill!(kkt.hess, zero(T))
    fill!(kkt.l_lower, zero(T))
    fill!(kkt.u_lower, zero(T))
    fill!(kkt.l_diag, -one(T))
    fill!(kkt.u_diag, -one(T))
    fill!(kkt.l_lower_aug, zero(T))
    fill!(kkt.u_lower_aug, zero(T))
    fill!(nonzeros(kkt.hess_com), zero(T)) # so that mul! in the initial primal-dual solve has no effect
end

num_variables(kkt::SparseUnreducedKKTSystem) = length(kkt.pr_diag)

function build_kkt!(kkt::SparseUnreducedKKTSystem)
    transfer!(kkt.aug_com, kkt.aug_raw, kkt.aug_csc_map)
end

module TestMOIWrapper

using MadNLP
using Test

using MathOptInterface
const MOI = MathOptInterface

function runtests()
    for name in names(@__MODULE__; all=true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_MOI_Test()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MadNLP.Optimizer(),
    )
    MOI.set(model, MOI.Silent(), true)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(
            atol=1e-4,
            rtol=1e-4,
            infeasible_status=MOI.LOCALLY_INFEASIBLE,
            optimal_status=MOI.LOCALLY_SOLVED,
            exclude=Any[
                MOI.ConstraintBasisStatus,
                MOI.DualObjectiveValue,
                MOI.ObjectiveBound,
            ]
        );
        exclude = [
            # MadNLP reaches maximum number of iterations instead
            # of returning infeasibility certificate.
            r"test_linear_DUAL_INFEASIBLE.*",
            "test_solve_TerminationStatus_DUAL_INFEASIBLE",
            # Symbolic exception in Mumps
            "test_solve_VariableIndex_ConstraintDual_",
            # Tests excluded on purpose
            # - Excluded because Hessian information is needed
            "test_nonlinear_hs071_hessian_vector_product",
            # - Excluded because Hessian information is needed
            "test_nonlinear_invalid",
            #  - Excluded because this test is optional
            "test_model_ScalarFunctionConstantNotZero",
            # Throw an error: "Unable to query the dual of a variable
            # bound that was reformulated using `ZerosBridge`."
            "test_linear_VectorAffineFunction_empty_row",
            "test_conic_linear_VectorOfVariables_2",
            # TODO: investigate why it is breaking.
            "test_nonlinear_expression_hs109",
        ]
    )

    return
end

function test_extra()
    model = MadNLP.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("linear_solver"), UmfpackSolver)

    @test MOI.supports(model, MOI.Name())
    @test MOI.get(model, MOI.Name()) == ""
    MOI.set(model, MOI.Name(), "Model")
    @test MOI.get(model, MOI.Name()) == "Model"

    @test MOI.get(model, MOI.BarrierIterations()) == 0

    return
end

# See issue #239 (https://github.com/MadNLP/MadNLP.jl/issues/239)
function test_invalid_number_in_hessian_lagrangian()
    model = MadNLP.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    nlp = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(nlp, :(($x - 5)^2 + ($y - 8)^2))
    MOI.Nonlinear.add_constraint(nlp, :($x * $y), MOI.EqualTo(5.0))
    ev = MOI.Nonlinear.Evaluator(nlp, MOI.Nonlinear.SparseReverseMode(), [x, y])
    MOI.set(model, MOI.NLPBlock(), MOI.NLPBlockData(ev))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    return
end

# See issue #318
function test_user_defined_function()
    model = MadNLP.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    # Define custom function.
    f(a, b) = a^2 + b^2
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.UserDefinedFunction(:f, 2), (f,))
    obj_f = MOI.ScalarNonlinearFunction(:f, Any[x[1], x[2]])
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj_f)}(), obj_f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
end

# See PR #379 (example 1)
function test_param_in_quadratic_term1()
    model = MadNLP.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x, _ = MOI.add_constrained_variable(model, MOI.Interval(0.0, 2.0))
    y, _ = MOI.add_constrained_variable(model, MOI.Interval(0.0, 2.0))
    a, _ = MOI.add_constrained_variable(model, MOI.Parameter(3.0))
    b, _ = MOI.add_constrained_variable(model, MOI.Parameter(3.0))

    # constraint : a*x^2 + b*y^2 <= 1
    sq_x = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, x, x)],
        MOI.ScalarAffineTerm{Float64}[],
        0.0
    )
    sq_y = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, y, y)],
        MOI.ScalarAffineTerm{Float64}[],
        0.0
    )
    x_term = MOI.ScalarNonlinearFunction(:*, [a, sq_x])
    y_term = MOI.ScalarNonlinearFunction(:*, [b, sq_y])
    x_y_sum = MOI.ScalarNonlinearFunction(:+, [x_term, y_term])
    lhs = MOI.ScalarNonlinearFunction(:-, [x_y_sum, 1])
    c = MOI.add_constraint(model, lhs, MOI.LessThan{Float64}(0.0))

    # objective function : x + y
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    obj_terms = [MOI.ScalarAffineTerm(1.0, x), MOI.ScalarAffineTerm(1.0, y)]
    obj_f = MOI.ScalarAffineFunction(obj_terms, 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj_f)}(), obj_f)

    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    x_val = MOI.get(model, MOI.VariablePrimal(), x)
    y_val = MOI.get(model, MOI.VariablePrimal(), y)
    @test abs(3 * x_val^2 + 3 * y_val^2 - 1) <= 1e-6 # constraint has no slack
end

# See PR #379 (example 2)
function test_param_in_quadratic_term2()
    model = MadNLP.Optimizer()
    MOI.set(model, MOI.Silent(), true)
    x, _ = MOI.add_constrained_variable(model, MOI.Interval(0.0, 2.0))
    y, _ = MOI.add_constrained_variable(model, MOI.Interval(0.0, 2.0))
    a, _ = MOI.add_constrained_variable(model, MOI.Parameter(3.0))
    b, _ = MOI.add_constrained_variable(model, MOI.Parameter(3.0))

    # constraint:  a*x + b^2*y + a*b^2 <= 42 => 3*x + 9*y <= 42 - 3*9
    sq_b = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, b, b)],
        MOI.ScalarAffineTerm{Float64}[],
        0.0
    )

    term1 = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(1.0, a, x)],
        MOI.ScalarAffineTerm{Float64}[],
        0.0
    )
    term2 = MOI.ScalarNonlinearFunction(:*, [sq_b, y])
    term3 = MOI.ScalarNonlinearFunction(:*, [a, sq_b])

    lhs = MOI.ScalarNonlinearFunction(:+, [term1, term2, term3])
    c = MOI.add_constraint(model, lhs, MOI.LessThan{Float64}(42.0))

    # objective function : x + y
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    obj_terms = [MOI.ScalarAffineTerm(1.0, x), MOI.ScalarAffineTerm(1.0, y)]
    obj_f = MOI.ScalarAffineFunction(obj_terms, 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj_f)}(), obj_f)

    MOI.optimize!(model)
    @assert MOI.get(model, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    x_val = MOI.get(model, MOI.VariablePrimal(), x)
    y_val = MOI.get(model, MOI.VariablePrimal(), y)
    @assert abs(3 * x_val + 9 * y_val - 15) <= 1e-6 # constraint has no slack
end

function test_parameter_is_valid()
    model = MadNLP.Optimizer()
    p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.is_valid(model, p)
    @test MOI.is_valid(model, ci)
    @test !MOI.is_valid(model, typeof(p)(p.value + 1))
    @test !MOI.is_valid(model, typeof(ci)(ci.value + 1))
    return
end

function test_Parameter_basic()
    F, S = MOI.VariableIndex, MOI.Parameter{Float64}
    model = MadNLP.Optimizer()
    @test MOI.supports_add_constrained_variable(model, S)
    @test !MOI.supports_constraint(model, F, S)
    @test isempty(MOI.get(model, MOI.ListOfConstraintTypesPresent()))
    p1, c1 = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    @test MOI.is_valid(model, c1)
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c1]
    p2, c2 = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 2
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [c1, c2]
    return
end

end

TestMOIWrapper.runtests()

```@meta
CurrentModule = MadNLP
```
```@setup linear_solver_example
using SparseArrays
using NLPModels
using MadNLP
using MadNLPTests
# Build nonlinear model
nlp = MadNLPTests.HS15Model()
# Build KKT
cb = MadNLP.create_callback(
    MadNLP.SparseCallback,
    nlp,
)
linear_solver = LapackCPUSolver
kkt = MadNLP.create_kkt_system(
    MadNLP.SparseKKTSystem,
    cb,
    linear_solver,
)

n = NLPModels.get_nvar(nlp)
m = NLPModels.get_ncon(nlp)
x = NLPModels.get_x0(nlp)
l = zeros(m)
hess_values = MadNLP.get_hessian(kkt)
NLPModels.hess_coord!(nlp, x, l, hess_values)

jac_values = MadNLP.get_jacobian(kkt)
NLPModels.jac_coord!(nlp, x, jac_values)
MadNLP.compress_jacobian!(kkt)

MadNLP.build_kkt!(kkt)

```
# Linear solvers

We suppose that the KKT system has been assembled previously
into a given [`AbstractKKTSystem`](@ref). Then, it remains to compute
the Newton step by solving the KKT system for a given
right-hand-side (given as a [`AbstractKKTVector`](@ref)).
That's exactly the role of the linear solver.

If we do not assume any structure, the KKT system writes in generic form
```math
K x = b
```
with $$K$$ the KKT matrix and $$b$$ the current right-hand-side.
MadNLP provides a suite of specialized linear solvers to solve
the linear system.

## Inertia detection
If the matrix $$K$$ has negative eigenvalues, we have no guarantee
that the solution of the KKT system is a descent direction with regards
to the original nonlinear problem. That's the reason why most of the linear
solvers compute the inertia
of the linear system when factorizing the matrix $$K$$.
The inertia counts the number of positive,
negative and zero eigenvalues in the matrix. If the inertia does not
meet a given criteria, then the matrix $$K$$ is regularized by adding
a multiple of the identity to it: $$K_r = K + \alpha I$$.

!!! note
    We recall that the inertia of a matrix $$K$$ is given as
    a triplet $$(n,m,p)$$, with $$n$$ the number of positive eigenvalues,
    $$m$$ the number of negative eigenvalues and $$p$$ the number of
    zero eigenvalues.


## Factorization algorithm
In nonlinear programming, it is common
to employ a LBL factorization to decompose the symmetric indefinite
matrix $$K$$, as this algorithm returns the inertia
of the matrix directly as a result of the factorization.

!!! note
    When MadNLP runs in inertia-free mode, the algorithm
    does not require to compute the inertia when factorizing
    the matrix $$K$$. In that case, MadNLP can use a classical
    LU or QR factorization to solve the linear system $$Kx = b$$.


## Solving a KKT system with MadNLP

We suppose available a [`AbstractKKTSystem`](@ref) `kkt`, properly assembled
following the procedure presented [previously](kkt.md).
We can query the assembled matrix $$K$$ as
```@example linear_solver_example
K = MadNLP.get_kkt(kkt)

```
Then, if we want to pass the KKT matrix `K` to Lapack, this
translates to
```@example linear_solver_example
linear_solver = LapackCPUSolver(K)

```
The instance `linear_solver` does not copy the matrix $$K$$ and
instead keep a reference to it.
```@example linear_solver_example
linear_solver.A === K
```
That way every time we re-assemble the matrix $$K$$ in `kkt`,
the values are directly updated inside `linear_solver`.

To compute the factorization inside `linear_solver`,
one simply as to call:
```@example linear_solver_example
MadNLP.factorize!(linear_solver)

```
Once the factorization computed, computing the backsolve
for a right-hand-side `b` amounts to
```@example linear_solver_example
nk = size(kkt, 1)
b = rand(nk)
MadNLP.solve_linear_system!(linear_solver, b)
```
The values of `b` being modified inplace to store the solution $$x$$ of the linear
system $$Kx =b$$.

# Installation
To install MadNLP, simply proceed to
```julia
pkg> add MadNLP
```

By default, MadNLP uses the sparse linear solver MUMPS.
In addition the user can install the following extensions to use a specialized linear solver.

## GPU support
MadNLPGPU provides GPU support for MadNLP:
```julia
pkg> add MadNLPGPU
```
MadNLPGPU automatically detects if you have a NVIDIA or an AMD GPU on your machine,
and adapts in consequence.

## HSL linear solver
Obtain a license and download [HSL_jll.jl](https://licences.stfc.ac.uk/products/Software/HSL/LibHSL).
Install the package into your current environment using:
```julia
import Pkg
Pkg.develop(path = "/full/path/to/HSL_jll.jl")
```

If the user has already compiled the HSL solver library, one can
simply override the path to the artifact by editing `~/.julia/artifacts/Overrides.toml`
```
# replace HSL_jll artifact /usr/local/lib/libhsl.so
ecece3e2c69a413a0e935cf52e03a3ad5492e137 = "/usr/local"
```

Once HSL_jll has been installed on your machine, you can install MadNLPHSL as
```julia
pkg> add MadNLPHSL
```

## Pardiso linear solver

To use Pardiso, the user needs to obtain the Pardiso shared libraries from
<https://panua.ch/>, provide the absolute path to the shared library:
```
julia> ENV["MADNLP_PARDISO_LIBRARY_PATH"] = "/usr/lib/libpardiso600-GNU800-X86-64.so"
```
and place the license file in the home directory.
After obtaining the library and the license file, run
```julia
pkg> add MadNLPPardiso
pkg> build MadNLPPardiso
```

The build process requires a C compiler.

# Running MadNLP in arbitrary precision

```@meta
CurrentModule = MadNLP
```
```@setup multiprecision
using NLPModels
using MadNLP

```

MadNLP supports solving optimization problems in arbitrary precision.
By default, MadNLP adapts its precision following the `NLPModel`
passed in input. Most models are using `Float64` (in fact, almost
all optimization modelers are implemented using double
precision), but for certain applications it can be useful to use
arbitrary precision to get more accurate solution.

!!! info
    There exists different packages to instantiate a optimization
    model in arbitrary precision in Julia. Most of them
    leverage the flexibility offered by [NLPModels.jl](https://github.com/JuliaSmoothOptimizers/NLPModels.jl).
    In particular, we recommend:
    - [CUTEst.jl](https://github.com/JuliaSmoothOptimizers/CUTEst.jl/): supports `Float32`, `Float64` and `Float128`.
    - [ExaModels](https://github.com/exanauts/ExaModels.jl): supports `AbstractFloat`.

## Defining a problem in arbitrary precision

As a demonstration, we implement the model [airport](https://vanderbei.princeton.edu/ampl/nlmodels/cute/airport.mod)
from CUTEst using ExaModels. The code writes:
```@example multiprecision
using ExaModels

function airport_model(T)
    N = 42
    # Data
    r = T[0.09 , 0.3, 0.09, 0.45, 0.5, 0.04, 0.1, 0.02, 0.02, 0.07, 0.4, 0.045, 0.05, 0.056, 0.36, 0.08, 0.07, 0.36, 0.67, 0.38, 0.37, 0.05, 0.4, 0.66, 0.05, 0.07, 0.08, 0.3, 0.31, 0.49, 0.09, 0.46, 0.12, 0.07, 0.07, 0.09, 0.05, 0.13, 0.16, 0.46, 0.25, 0.1]
    cx = T[-6.3, -7.8, -9.0, -7.2, -5.7, -1.9, -3.5, -0.5, 1.4, 4.0, 2.1, 5.5, 5.7, 5.7, 3.8, 5.3, 4.7, 3.3, 0.0, -1.0, -0.4, 4.2, 3.2, 1.7, 3.3, 2.0, 0.7, 0.1, -0.1, -3.5, -4.0, -2.7, -0.5, -2.9, -1.2, -0.4, -0.1, -1.0, -1.7, -2.1, -1.8, 0.0]
    cy = T[8.0, 5.1, 2.0, 2.6, 5.5, 7.1, 5.9, 6.6, 6.1, 5.6, 4.9, 4.7, 4.3, 3.6, 4.1, 3.0, 2.4, 3.0, 4.7, 3.4, 2.3, 1.5, 0.5, -1.7, -2.0, -3.1, -3.5, -2.4, -1.3, 0.0, -1.7, -2.1, -0.4, -2.9, -3.4, -4.3, -5.2, -6.5, -7.5, -6.4, -5.1, 0.0]
    # Wrap all data in a single iterator for ExaModels
    data = [(i, cx[i], cy[i], r[i]) for i in 1:N]
    IJ = [(i, j) for i in 1:N-1 for j in i+1:N]
    # Write model using ExaModels
    core = ExaModels.ExaCore(T)
    x = ExaModels.variable(core, 1:N, lvar = -10.0, uvar=10.0)
    y = ExaModels.variable(core, 1:N, lvar = -10.0, uvar=10.0)
    ExaModels.objective(
        core,
        ((x[i] - x[j])^2 + (y[i] - y[j])^2) for (i, j) in IJ
    )
    ExaModels.constraint(core, (x[i]-dcx)^2 + (y[i] - dcy)^2 - dr for (i, dcx, dcy, dr) in data; lcon=-Inf)
    return ExaModels.ExaModel(core)
end
```

The function `airport_model` takes as input the type used to define the model in ExaModels.
For example, `ExaCore(Float64)` instantiates a model with `Float64`, whereas `ExaCore(Float32)`
instantiates a model using `Float32`. Thus, instantiating the instance `airport` using `Float32`
simply amounts to
```@example multiprecision
nlp = airport_model(Float32)

```
We verify that the model is correctly instantiated using `Float32`:
```@example multiprecision
x0 = NLPModels.get_x0(nlp)
println(typeof(x0))
```

## Solving a problem in Float32
Now that we have instantiated our model in `Float32`, we solve
it using MadNLP. As `nlp` is using `Float32`, MadNLP will automatically adjust
its internal types to `Float32` during the instantiation.
By default, the convergence tolerance is also adjusted to the input type, such that `tol = sqrt(eps(T))`.
Hence, in our case the tolerance is set automatically to
```@example multiprecision
tol = sqrt(eps(Float32))
```
We solve the problem using Lapack as linear solver:
```@example multiprecision
results = madnlp(nlp; linear_solver=LapackCPUSolver)
nothing
```

!!! note
    Note that the distribution of Lapack shipped with Julia supports
    `Float32`, so here we do not have to worry whether the
    type is supported by the linear solver. Almost all linear solvers shipped
    with MadNLP supports `Float32`.

The final solution is
```@example multiprecision
results.solution

```
and the objective is
```@example multiprecision
results.objective

```

For completeness, we compare with the solution returned when we solve the
same problem using `Float64`:
```@example multiprecision
nlp_64 = airport_model(Float64)
results_64 = madnlp(nlp_64; linear_solver=LapackCPUSolver)
nothing
```
The final objective is now
```@example multiprecision
results_64.objective

```
As expected when solving an optimization problem with `Float32`,
the relative difference between the two solutions is far from being negligible:
```@example multiprecision
rel_diff = abs(results.objective - results_64.objective) / results_64.objective
```

## Solving a problem in Float128
Now, we go in the opposite direction and solve a problem using `Float128`
to get a better accuracy. We start by loading the library `Quadmath` to
work with quadruple precision:
```@example multiprecision
using Quadmath
```
We can instantiate our problem using `Float128` directly as:
```@example multiprecision
nlp_128 = airport_model(Float128)
```


!!! warning
    On the contrary to `Float32`, a few linear solvers support `Float128` out of the box.
    Currently, the only solvers suporting quadruple in MadNLP are `LDLSolver`
    and the HSL solvers (require MadNLPHSL).
    `LDLSolvers` uses [an LDL factorization implemented in pure Julia](https://github.com/JuliaSmoothOptimizers/LDLFactorizations.jl).
    The solver `LDLSolver` is not adapted to solve large-scale nonconvex nonlinear programs,
    but works if the problem is small enough (as it is the case here).

Once we have replaced the solver by `LDLSolver`, solving the problem with MadNLP in `Float128` just amounts to
```@example multiprecision
results_128 = madnlp(nlp_128; linear_solver=LDLSolver)
nothing

```
Note that the final tolerance is much lower than before. We get the solution in quadruple precision
```@example multiprecision
results_128.solution
```
as well as the final objective:
```@example multiprecision
results_128.objective
```

![Logo](assets/logo-full.svg)

MadNLP is an open-source nonlinear programming solver,
purely implemented in Julia. MadNLP implements a filter line-search
interior-point algorithm, as used in [Ipopt](https://github.com/coin-or/Ipopt). MadNLP
seeks to streamline the development of modeling and algorithmic paradigms in
order to exploit structures and to make efficient use of high-performance computers.
Notably, MadNLP is part of [MadSuite](https://madsuite.org/), a suite of GPU-accelerated optimization solvers.


## Design

### MadNLP's problem structure
MadNLP targets the solution of constrained nonlinear problems, formulating as
```math
  \begin{aligned}
    \min_{x} \; & f(x) \\
    \text{subject to} \quad & g_\ell \leq g(x) \leq g_u \\
                            & x_\ell \leq x \leq x_u
  \end{aligned}
```
where $$x \in \mathbb{R}^n$$ is the decision variable, $$f: \mathbb{R}^n \to \mathbb{R}$$
and $$g: \mathbb{R}^n \to \mathbb{R}^m$$ two smooth nonlinear functions.
MadNLP makes the distinction between the **bound constraints** $$x_\ell \leq x \leq x_u$$
and the **generic constraints** $$g_\ell \leq g(x) \leq g_u$$.
No other structure is assumed _a priori_.

MadNLP is built on top of [NLPModels.jl](https://github.com/JuliaSmoothOptimizers/NLPModels.jl/),
a generic package to represent optimization models in Julia. In addition,
MadNLP is interfaced with [ExaModels](https://github.com/exanauts/ExaModels.jl),
[JuMP](https://github.com/jump-dev/JuMP.jl) and [Plasmo](https://github.com/zavalab/Plasmo.jl).


### MadNLP's performance
In any interior-point algorithm, the two computational bottlenecks are
1. The evaluation of the first- and second-order derivatives.
2. The factorization of the primal-dual KKT system.

The first point is problem-dependent and is often related to the automatic differentiation backend being employed.
The second point is more problematic, as the primal-dual KKT system is symmetric indefinite and ill-conditioned.

### Linear solvers
By default, MadNLP is using [MUMPS](https://mumps-solver.org/) to solve the primal-dual KKT system.
Other efficient linear solvers are interfaced, all listed in the table below.


Linear solver | Type | Hardware
:--- | :--- | :---
||
__MadNLP (base)__||
||
MumpsSolver (default)   | sparse | CPU
UmfpackSolver           | sparse | CPU
LapackCPUSolver         | dense  | CPU
LDLSolver               | sparse | CPU
CHOLMODSolver           | sparse | CPU
||
__MadNLPGPU__||
||
CUDSSSolver             | sparse | CUDA
LapackCUDASolver         | dense  | CUDA
LapackROCmSolver         | dense  | AMD GPU
||
__MadNLPHSL__||
||
Ma27Solver              | sparse | CPU
Ma57Solver              | sparse | CPU
Ma86Solver              | sparse | CPU
Ma97Solver              | sparse | CPU
||
__MadNLPPardiso__||
||
PardisoSolver           | sparse | CPU
PardisoMKLSolver        | sparse | CPU

!!! warning
    In general, we recommend using a sparse linear solver as soon as the number of variables
    in the problem is greater than 1,000.


## Citing MadNLP.jl
If you use MadNLP.jl in your research, we would greatly appreciate your citing it.

```bibtex
@article{shin2024accelerating,
  title     = {Accelerating optimal power flow with {GPU}s: {SIMD} abstraction of nonlinear programs and condensed-space interior-point methods},
  author    = {Shin, Sungho and Anitescu, Mihai and Pacaud, Fran{\c{c}}ois},
  journal   = {Electric Power Systems Research},
  volume    = {236},
  pages     = {110651},
  year      = {2024},
  publisher = {Elsevier}
}

@article{shin2021graph,
  title     = {Graph-based modeling and decomposition of energy infrastructures},
  author    = {Shin, Sungho and Coffrin, Carleton and Sundar, Kaarthik and Zavala, Victor M},
  journal   = {IFAC-PapersOnLine},
  volume    = {54},
  number    = {3},
  pages     = {693--698},
  year      = {2021},
  publisher = {Elsevier}
}
```

# Quickstart

```@meta
CurrentModule = MadNLP
```
```@setup quickstart
using NLPModels

```


This page presents a quickstart guide to solve a nonlinear problem with MadNLP.

As a demonstration, we show how to implement
the HS15 nonlinear problem from the Hock & Schittkowski collection,
first by using [JuMP](https://github.com/jump-dev/Jump.jl), and then by specifying the derivatives manually in [NLPModels](https://github.com/JuliaSmoothOptimizers/NLPModels.jl/).

The HS15 problem is defined as:
```math
\begin{aligned}
\min_{x_1, x_2} \; &   100 \times (x_2 - x_1^2)^2 +(1 - x_1)^2 \\
\text{subject to} \quad &  x_1  \times x_2 \geq 1 \\
        & x_1 + x_2^2 \geq 0 \\
        & x_1 \leq 0.5
\end{aligned}

```
Despite its small dimension, its resolution remains challenging
as the problem is nonlinear nonconvex. Note that HS15 has
one bound constraint ($$x_1 \leq 0.5$$) and two generic constraints.
We display in the following picture the feasible set of HS15. The problem
has two local solutions: ``(x_1, x_2) = (0.5, 2)`` and ``(x_1, x_2) \approx (-0.792, -1.262)``.

![HS15](assets/hs15.png)


## Using MadNLP with JuMP

JuMP is the easiest way to implement a nonlinear problem.
In JuMP, the user just has only to pass the structure of the problem,
the computation of the first- and second-order derivatives being handled automatically.

Using JuMP's syntax, the HS15 problem translates to
```@example quickstart
using JuMP
model = Model()
@variable(model, x1 <= 0.5)
@variable(model, x2)

@objective(model, Min, 100.0 * (x2 - x1^2)^2 + (1.0 - x1)^2)
@constraint(model, x1 * x2 >= 1.0)
@constraint(model, x1 + x2^2 >= 0.0)

println(model)

```

Then, solving HS15 with MadNLP directly translates to
```@example quickstart
using MadNLP
JuMP.set_optimizer(model, MadNLP.Optimizer)
JuMP.optimize!(model)

```

Under the hood, JuMP builds a sparse AD backend to evaluate the first and second-order
derivatives of the objective and the constraints. Then, MadNLP takes as input the callbacks generated by JuMP
and wraps them inside a `MadNLP.MOIModel`.

## Using MadNLP with NLPModels

Alternatively, we can compute the derivatives manually in an `AbstractNLPModel`.
This second option, although more complicated, gives us more flexibility and comes without boilerplate.

We define the `HS15Model` as :
```@example quickstart
struct HS15Model <: NLPModels.AbstractNLPModel{Float64,Vector{Float64}}
    meta::NLPModels.NLPModelMeta{Float64, Vector{Float64}}
    counters::NLPModels.Counters
end

function HS15Model(x0)
    return HS15Model(
        NLPModels.NLPModelMeta(
            2,     #nvar
            ncon = 2,
            nnzj = 4,
            nnzh = 3,
            x0 = x0,
            y0 = zeros(2),
            lvar = [-Inf, -Inf],
            uvar = [0.5, Inf],
            lcon = [1.0, 0.0],
            ucon = [Inf, Inf],
            minimize = true
        ),
        NLPModels.Counters()
    )
end
```
This structure takes as input the initial position `x0` and generates
an `AbstractNLPModel`. `NLPModelMeta` stores the information about
the structure of the problem (variables and constraints' lower and upper bounds,
number of variables, number of constraints, ...). `Counters` is a utility
storing the number of time each callbacks is being called.

The objective function takes as input a `HS15Model` instance
and a vector with dimension 2 storing the current values for $$x_1$$ and $$x_2$$:
```@example quickstart
function NLPModels.obj(nlp::HS15Model, x::AbstractVector)
    return 100.0 * (x[2] - x[1]^2)^2 + (1.0 - x[1])^2
end
```
The corresponding gradient writes (note that we update the values of the gradient
`g` inplace):
```@example quickstart
function NLPModels.grad!(nlp::HS15Model, x::AbstractVector, g::AbstractVector)
    z = x[2] - x[1]^2
    g[1] = -400.0 * z * x[1] - 2.0 * (1.0 - x[1])
    g[2] = 200.0 * z
    return g
end
```

Similarly, we define the constraints
```@example quickstart
function NLPModels.cons!(nlp::HS15Model, x::AbstractVector, c::AbstractVector)
    c[1] = x[1] * x[2]
    c[2] = x[1] + x[2]^2
    return c
end
```

!!! note
    Observe that we update the values of the constraint vector `c` and the gradient vector `g` inplace.


The Jacobian is defined as
```@example quickstart
function NLPModels.jac_structure!(nlp::HS15Model, I::AbstractVector{T}, J::AbstractVector{T}) where T
    copyto!(I, [1, 1, 2, 2])
    copyto!(J, [1, 2, 1, 2])
end

function NLPModels.jac_coord!(nlp::HS15Model, x::AbstractVector, J::AbstractVector)
    J[1] = x[2]    # (1, 1)
    J[2] = x[1]    # (1, 2)
    J[3] = 1.0     # (2, 1)
    J[4] = 2*x[2]  # (2, 2)
    return J
end
```

!!! note
    As the Jacobian is sparse, we have to provide explicitly its sparsity structure.


It remains to implement the Hessian of the Lagrangian for a `HS15Model`.
The Lagrangian of the problem writes
```math
L(x_1, x_2, y_1, y_2) = 100 \times (x_2 - x_1^2)^2 +(1 - x_1)^2
+ y_1 \times (x_1 \times x_2) + y_2 \times (x_1 + x_2^2)
```
and we aim at evaluating its second-order derivative $$\nabla^2_{xx}L(x_1, x_2, y_1, y_2)$$.

We first have to define the sparsity structure of the Hessian, which is
assumed to be sparse. The Hessian is a symmetric matrix, and by convention
we pass only the lower-triangular part of the matrix to the solver. Hence,
we define the sparsity structure as
```@example quickstart
function NLPModels.hess_structure!(nlp::HS15Model, I::AbstractVector{T}, J::AbstractVector{T}) where T
    copyto!(I, [1, 2, 2])
    copyto!(J, [1, 1, 2])
end
```

Now that the sparsity structure is defined, the associated Hessian writes:
```@example quickstart
function NLPModels.hess_coord!(nlp::HS15Model, x, y, H::AbstractVector; obj_weight=1.0)
    # Objective
    H[1] = obj_weight * (-400.0 * x[2] + 1200.0 * x[1]^2 + 2.0)
    H[2] = obj_weight * (-400.0 * x[1])
    H[3] = obj_weight * 200.0
    # First constraint
    H[2] += y[1] * 1.0
    # Second constraint
    H[3] += y[2] * 2.0
    return H
end

```

Once the problem specified in NLPModels, we can create a new MadNLP instance and solve it:
```@example quickstart
x0 = zeros(2) # initial position
nlp = HS15Model(x0)
solver = MadNLP.MadNLPSolver(nlp; print_level=MadNLP.INFO)
results = MadNLP.solve!(solver)
nothing
```

MadNLP converges in 19 iterations to a (local) optimal solution.
MadNLP returns a [`MadNLPExecutionStats`](@ref) storing all the
results. We can query the primal and the dual solutions respectively by
```@example quickstart
results.solution
```
and
```@example quickstart
results.multipliers
```
If we come back at the picture displayed at the beginning of this page,
the solution found is the one at the bottom left. At this solution, only
one constraint is active, explaining why only the first element in `results.multipliers`
is non-null (up to floating point approximation).

The dual multipliers associated to the variable's lower bounds (resp. upper bounds) are stored
in `results.multipliers_L` (resp. `results.multipliers_U`):
```@example quickstart
results.multipliers_L
```

By changing the initial point in `HS15Model`, MadNLP converges to the second local solution
of the non-convex problem HS15:
```@example quickstart
x0 = ones(2)
nlp = HS15Model(x0)
results = madnlp(nlp)
nothing
```

```@example quickstart
results.solution
```
Note that we don't know beforehand towards each solution MadNLP is converging.

# Running MadNLP on the GPU

```@meta
CurrentModule = MadNLP
```
```@setup gpu
using NLPModels
using MadNLP
```

MadNLP supports the solution of large-scale optimization problems
on the GPU, [with significant speedups reported on some instances](https://arxiv.org/html/2405.14236v2).
In this tutorial, we show how to solve a nonlinear program on a NVIDIA GPU. We start
by importing MadNLPGPU:
```@example gpu
using MadNLPGPU
using CUDA
using CUDSS

```


## How to solve a problem on the GPU with ExaModels?

MadNLP has been designed to run entirely on the GPU, without data exchange between
the host and the device. We recommend implementing the model
with the modeler [ExaModels](https://github.com/exanauts/ExaModels.jl) whenever possible.

We import ExaModels as:
```@example gpu
using ExaModels
```

!!! info
    MadNLP does not yet support solving sparse optimization problems on AMD GPUs.

### Evaluating the model on the GPU with ExaModels
The first step requires implementing the model with ExaModels.

As a demonstration, we implement the model [airport](https://vanderbei.princeton.edu/ampl/nlmodels/cute/airport.mod)
from the CUTEst benchmark using ExaModels. The code writes:
```@example gpu
function airport_model(T, backend)
    N = 42
    # Data
    r = T[0.09 , 0.3, 0.09, 0.45, 0.5, 0.04, 0.1, 0.02, 0.02, 0.07, 0.4, 0.045, 0.05, 0.056, 0.36, 0.08, 0.07, 0.36, 0.67, 0.38, 0.37, 0.05, 0.4, 0.66, 0.05, 0.07, 0.08, 0.3, 0.31, 0.49, 0.09, 0.46, 0.12, 0.07, 0.07, 0.09, 0.05, 0.13, 0.16, 0.46, 0.25, 0.1]
    cx = T[-6.3, -7.8, -9.0, -7.2, -5.7, -1.9, -3.5, -0.5, 1.4, 4.0, 2.1, 5.5, 5.7, 5.7, 3.8, 5.3, 4.7, 3.3, 0.0, -1.0, -0.4, 4.2, 3.2, 1.7, 3.3, 2.0, 0.7, 0.1, -0.1, -3.5, -4.0, -2.7, -0.5, -2.9, -1.2, -0.4, -0.1, -1.0, -1.7, -2.1, -1.8, 0.0]
    cy = T[8.0, 5.1, 2.0, 2.6, 5.5, 7.1, 5.9, 6.6, 6.1, 5.6, 4.9, 4.7, 4.3, 3.6, 4.1, 3.0, 2.4, 3.0, 4.7, 3.4, 2.3, 1.5, 0.5, -1.7, -2.0, -3.1, -3.5, -2.4, -1.3, 0.0, -1.7, -2.1, -0.4, -2.9, -3.4, -4.3, -5.2, -6.5, -7.5, -6.4, -5.1, 0.0]
    # Wrap all data in a single iterator for ExaModels
    data = [(i, cx[i], cy[i], r[i]) for i in 1:N]
    IJ = [(i, j) for i in 1:N-1 for j in i+1:N]
    # Write model using ExaModels
    core = ExaModels.ExaCore(T; backend=backend)
    x = ExaModels.variable(core, 1:N, lvar = -10.0, uvar=10.0)
    y = ExaModels.variable(core, 1:N, lvar = -10.0, uvar=10.0)
    ExaModels.objective(
        core,
        ((x[i] - x[j])^2 + (y[i] - y[j])^2) for (i, j) in IJ
    )
    ExaModels.constraint(core, (x[i]-dcx)^2 + (y[i] - dcy)^2 - dr for (i, dcx, dcy, dr) in data; lcon=-Inf)
    return ExaModels.ExaModel(core)
end
```

The first argument `T` specifies the numerical precision (`Float32`, `Float64` or any `AbstractFloat`) whereas the second
argument `backend` sets the device used to evaluate the model.
We instantiate the model on the GPU with:
```@example gpu
nlp = airport_model(Float64, CUDABackend())
```
By passing a `CUDABackend()`, we make sure that all the attributes in `nlp` are instantiated on the GPU. E.g., the initial point becomes a `CuVector`:
```@example gpu
NLPModels.get_x0(nlp)
```

!!! info
    If your problem is implemented with JuMP in a given `model`, ExaModel can load it for you on the GPU just
    by using `nlp = ExaModel(model; backend=CUDABackend())`.


### Solving the problem on the GPU with MadNLP
Once the model `nlp` loaded on the GPU, you can solve it using the function `madnlp`:
```@example gpu
results = madnlp(nlp; linear_solver=CUDSSSolver)
nothing
```
Note that we are using the sparse linear solver [NVIDIA cuDSS](https://docs.nvidia.com/cuda/cudss/getting_started.html)
to solve the primal-dual KKT system entirely on the GPU.

When solving an optimization problem on the GPU, MadNLP proceeds to some automatic modifications. In order:
1. It increases the parameter `bound_relax_factor` to `1e-4`.
2. It relaxes all the equality constraints ``g(x) = 0`` as a pair of inequality constraints ``-\tau \leq g(x) \leq \tau``, with ``\tau`` being equal to `bound_relax_factor`;
3. It reduces the KKT system down to sparse condensed system, exploiting the fact that the relaxed problem has only (potentially tight) inequality constraints. Up to a given primal regularization, the resulting KKT system is positive definite and can be factorized using a pivoting-free factorization routines (e.g. a Cholesky or an LDL' decompositions). This is the so-called *Lifted-KKT* formulation documented in [this article](https://arxiv.org/html/2405.14236v2).
4. The new condensed KKT system increases the ill-conditioning inherent to the interior-point method, amplifying the loss of accuracy when the iterates get close to a local solution. As a result, the termination tolerance `tol` is also increased to `1e-4` to recover convergence.

As a result, the convergence observed can be significantly different than what we
observe on the CPU. In particular, relaxing the parameter `bound_relax_factor` has a non-marginal impact
on the feasible set's geometry. You can limit the loss of accuracy by
specifying explicitly the relaxation and tolerance parameters to MadNLP:
```@example gpu
results = madnlp(
    nlp;
    tol=1e-7,
    bound_relax_factor=1e-7,
    linear_solver=CUDSSSolver,
)
nothing
```
Decreasing the tolerance `tol` too much is likely to cause numerical issues inside the algorithm.
In general, we recommend keeping the value of `bound_relax_factor` below `tol`.


### Solving the problem on the GPU with HyKKT

Some applications require accurate solutions. In that case, we recommend using the
extension [HybridKKT.jl](https://github.com/MadNLP/HybridKKT.jl), which implements
the Golub & Greif augmented Lagrangian formulation detailed [in this article](https://www.tandfonline.com/doi/abs/10.1080/10556788.2022.2124990). Compared to Lifted-KKT, the Hybrid-KKT
strategy is more accurate (it doesn't relax the equality constraints in the problem) but
slightly slower (it computes the descent direction using a conjugate gradient at every IPM iterations).

Once the package `HybridKKT` installed, the solution proceeds as
```
using HybridKKT

results = madnlp(
    nlp;
    linear_solver=MadNLPGPU.CUDSSSolver,
    kkt_system=HybridKKT.HybridCondensedKKTSystem,
    equality_treatment=MadNLP.EnforceEquality,
    fixed_variable_treatment=MadNLP.MakeParameter,
)
```


## How to solve on the GPU a legacy model running on the CPU?

If your optimization problem is not instantiated on the GPU, you can still
solve it on the GPU by wrapping your model in a `SparseWrapperModel`.
Oftentimes, this is the most convenient solution if your problem does not formulate easilly with ExaModels.
In that case, the evaluation of the model runs on the CPU, but all MadNLP's internals
are instantiated on the GPU (including the sparse linear solver).

To give an example, we suppose we have instantiate our `airport` model on the CPU:
```@example gpu
nlp_cpu = airport_model(Float64, nothing)
```
You can wrap it on the GPU using:
```@example gpu
nlp_wrapped = MadNLP.SparseWrapperModel(CuArray, nlp_cpu)
```
Then, we proceed as above to call MadNLP:
```@example gpu
results = madnlp(nlp_wrapped; linear_solver=CUDSSSolver)
nothing
```

## How to solve on the GPU a JuMP model?

If your model is implemented with JuMP, you can solve it on the GPU using the
same trick as in the previous paragraph just by passing a new option `array_type`
specifying which array type to use to instantiate the `SparseWrapperModel`.

This is demonstrated in the following example:
```julia
using CUDA
using JuMP
using MadNLP, MadNLPGPU

model = Model(MadNLP.Optimizer)
@variable(model, x1 <= 0.5)
@variable(model, x2)

@objective(model, Min, 100.0 * (x2 - x1^2)^2 + (1.0 - x1)^2)
@constraint(model, x1 * x2 >= 1.0)
@constraint(model, x1 + x2^2 >= 0.0)

JuMP.set_optimizer_attribute(model, "array_type", CuArray)
JuMP.set_optimizer_attribute(model, "linear_solver", CUDSSSolver)
JuMP.optimize!(model) # Solve the model on the GPU!
```

```@meta
CurrentModule = MadNLP
```

# Linear solvers

## Direct linear solvers
Each linear solver employed in MadNLP
implements the following interface.

```@docs
AbstractLinearSolver
introduce
factorize!
solve_linear_system!
is_inertia
inertia
```

## Iterative refinement
MadNLP uses iterative refinement to improve the
accuracy of the solution returned by the linear solver.

```@docs
solve_refine!

```

# Quasi-Newton methods

```@meta
CurrentModule = MadNLP
```
```@setup lbfgs
using NLPModels

```

Sometimes, the second-order derivatives are just too expensive to evaluate.
In that case, it is often a good idea to approximate the Hessian matrix using a Quasi-Newton algorithm.
The BFGS algorithm uses the first-order derivatives (gradient and tranposed-Jacobian
vector product) to approximate the Hessian of the Lagrangian. LBFGS is a variant of BFGS
that computes a low-rank approximation of the Hessian matrix.
By doing so, LBFGS does not have to store a large dense matrix in memory, rendering
the algorithm appropriate in the large-scale regime.

MadNLP implements several quasi-Newton approximation for the Hessian matrix.

## How to use LBFGS in MadNLP?

First, we focus on the limited-memory version of the BFGS algorithm,
commonly known as LBFGS. We refer to [this article](https://epubs.siam.org/doi/abs/10.1137/0916069) for a detailed description of the method.

We look at the `elec` optimization problem from the [COPS benchmark](https://www.mcs.anl.gov/~more/cops/):

```@example lbfgs
using Random
using ExaModels

function elec_model(np)
    Random.seed!(1)
    # Set the starting point to a quasi-uniform distribution of electrons on a unit sphere
    theta = (2pi) .* rand(np)
    phi = pi .* rand(np)

    core = ExaModels.ExaCore(Float64)
    x = ExaModels.variable(core, 1:np; start = [cos(theta[i])*sin(phi[i]) for i=1:np])
    y = ExaModels.variable(core, 1:np; start = [sin(theta[i])*sin(phi[i]) for i=1:np])
    z = ExaModels.variable(core, 1:np; start = [cos(phi[i]) for i=1:np])
    # Coulomb potential
    itr = [(i,j) for i in 1:np-1 for j in i+1:np]
    ExaModels.objective(core, 1.0 / sqrt((x[i] - x[j])^2 + (y[i] - y[j])^2 + (z[i] - z[j])^2) for (i,j) in itr)
    # Unit-ball
    ExaModels.constraint(core, x[i]^2 + y[i]^2 + z[i]^2 - 1 for i=1:np)

    return ExaModels.ExaModel(core)
end

```

The problem computes the positions of the electrons in an atom.
The potential of each electron depends on the positions of all the other electrons,
coupling together all the variables in the problem and resulting in a dense Hessian matrix.
Hence, the problem is good candidate for a quasi-Newton algorithm.

We start by solving the problem with the default options in MadNLP,
using a dense linear solver from LAPACK:

```@example lbfgs
using MadNLP
nh = 10
nlp = elec_model(nh)
results_hess = madnlp(
    nlp;
    linear_solver=LapackCPUSolver,
)
nothing

```
We observe that MadNLP converges in 21 iterations.

To replace the second-order derivatives by an LBFGS approximation,
you should pass the option `hessian_approximation=CompactLBFGS` to MadNLP.

```@example lbfgs
results_qn = madnlp(
    nlp;
    linear_solver=LapackCPUSolver,
    hessian_approximation=MadNLP.CompactLBFGS,
)
nothing

```

We observe that MadNLP converges in 93 iterations, but the solution time has
decreased by an order of magnitude. As expected, the number of Hessian evaluations is 0.

### How to tune the options in LBFGS?

You can tune the LBFGS options by using the option `quasi_newton_options`.
The option takes as input a `QuasiNewtonOptions` structure, with the following attributes
(we put on the right their default values):
- `init_strategy::BFGSInitStrategy = SCALAR1`
- `max_history::Int = 6`
- `init_value::Float64 = 1.0`
- `sigma_min::Float64 = 1e-8`
- `sigma_max::Float64 = 1e+8`

The most important parameter is `max_history`, which encodes the number of vectors used in the low-rank
approximation. For instance, we can increase the history to use the 20 past iterates using:

```@example lbfgs
qn_options = MadNLP.QuasiNewtonOptions(; max_history=20)
results_qn = madnlp(
    nlp;
    linear_solver=LapackCPUSolver,
    hessian_approximation=MadNLP.CompactLBFGS,
    quasi_newton_options=qn_options,
)
nothing

```

We observe that the total number of iterations has been reduced from 93 to 60.


### How is LBFGS implemented in MadNLP?

MadNLP implements the compact LBFGS algorithm described [in this article](https://link.springer.com/article/10.1007/bf01582063). At each iteration, the Hessian ``W_k`` is approximated by a
low rank positive definite matrix ``B_k``, defined as
```math
B_k = \xi_k I + U_k V_k^\top

```
with ``\xi > 0`` a scaling factor, ``U_k`` and ``V_k`` two ``n \times 2p`` matrices.
The number ``p`` denotes the number of vectors used when computing the limited memory updates
(the parameter `max_history` in MadNLP): the larger, the more accurate is the low-rank approximation.

Replacing the Hessian of the Lagrangian ``W_k`` by the low-rank matrix ``B_k``,
the KKT system solved in MadNLP rewrites as
```math
\begin{bmatrix}
\xi I + U V^\top + \Sigma_x & 0 & A^\top \\
0 & \Sigma_s & -I \\
A & -I & 0
\end{bmatrix}
\begin{bmatrix}
\Delta x \\ \Delta s \\ \Delta y
\end{bmatrix}
=
\begin{bmatrix}
r_1 \\ r_2 \\ r_3
\end{bmatrix}

```
The resulting KKT system has a low-rank structure  we can leverage using the Sherman-Morrison formula.
The method is detailed e.g. in Section 3.8 of [that paper](https://link.springer.com/article/10.1007/s10107-004-0560-5).


!!! info
    As MadNLP is designed to solve generic constrained optimization problems,
    it does not approximate directly the inverse of the Hessian matrix, as done
    in classical LBFGS implementations specialized
    on solving nonlinear problems with bound constraints.
    If your problem has no generic nonlinear constraints, we recommend for optimal performance
    using [LBFGSB](https://dl.acm.org/doi/pdf/10.1145/279232.279236)
    or the LBFGS implemented in [JSOSolvers.jl](https://github.com/JuliaSmoothOptimizers/JSOSolvers.jl/blob/main/src/lbfgs.jl).


## How to use BFGS in MadNLP?

On the contrary to LBFGS, the algorithm BFGS stores the matrix approximating
the Hessian in a dense matrix with size ``(n, n)``, where ``n`` is the number of variables
in the problem. Hence, we recommend using LBFGS whenever ``n`` becomes greater than 1,000.

That being said, BFGS can be practical to solve medium-scaled instances, as it provides
a better approximation than the LBFGS method. In particular, this is the case for the `elec`
optimization problem. As all the matrices involved are dense, BFGS works only if MadNLP
is storing its KKT system in dense format. We have to specify that explicitly
by passing to MadNLP the option `kkt_system=MadNLP.DenseKKTSystem`. Apart of that detail, solving the
problem with BFGS just amounts to


```@example lbfgs
results_qn = madnlp(
    nlp;
    linear_solver=LapackCPUSolver,
    kkt_system=MadNLP.DenseKKTSystem,
    hessian_approximation=MadNLP.BFGS,
)
nothing
```
Observe that MadNLP here converges in 62 iterations.
Indeed, BFGS computes a positive definite approximation of the Hessian matrix.

If the problem is non-convex, it is usually recommended to use the damped version of the BFGS algorithm, which
can be activated by replacing `MadNLP.BFGS` by `MadNLP.DampedBFGS` in the precedent call:
```@example lbfgs
results_qn = madnlp(
    nlp;
    linear_solver=LapackCPUSolver,
    kkt_system=MadNLP.DenseKKTSystem,
    hessian_approximation=MadNLP.DampedBFGS,
)
nothing
```

# Warmstarting MadNLP

```@meta
CurrentModule = MadNLP
```
```@setup warmstart
using NLPModels
using MadNLP
include("hs15.jl")

```

We use a parameterized version of the instance HS15
used in the [introduction](../quickstart.md). This updated
version of `HS15Model` stores the parameters of the model in an
attribute `nlp.params`:
```@example warmstart

nlp = HS15Model()
println(nlp.params)
```
By default the parameters are set to `[100.0, 1.0]`.
First, we find a solution associated to these parameters.
Then, we warmstart MadNLP from the solution found in the first solve,
after a small update in the problem's parameters.

!!! info
    It is known that the interior-point method has a poor
    support of warmstarting, on the contrary to active-set methods.
    However, if the new parameters remain close enough and do not lead
    to significant changes in the active set, warmstarting the
    interior-point algorithm can significantly reduces the total number of barrier iterations
    in the second solve.

!!! warning
    The warm-start described in this tutorial remains basic.
    Its main application is updating the solution of a parametric
    problem after a small update in the parameters. **The warm-start
    always assumes that the structure of the problem remains the same between
    two consecutive solves**.
    MadNLP cannot be warm-started if variables or constraints
    are added to the problem.

## Naive solution: starting from the previous solution
By default, MadNLP starts its interior-point algorithm
at the primal variable stored in `nlp.meta.x0`. We can
access this attribute using the function `get_x0`:
```@example warmstart
x0 = NLPModels.get_x0(nlp)

```
Here, we observe that the initial solution is `[0, 0]`.
We solve the problem starting from this point using the function [`madnlp`](@ref):
```@example warmstart
results = madnlp(nlp)
nothing
```
MadNLP converges in a bit less than 20 barrier iterations.  The solution is:
```@example warmstart
println("Objective: ", results.objective)
println("Solution:  ", results.solution)
```

### Updating the initial guess
We have found a solution to the problem. Now, what happens if we update
the parameters inside `nlp`?
```@example warmstart
nlp.params .= [101.0, 1.1]
```
As MadNLP starts the algorithm at `nlp.meta.x0`, we pass
the solution found previously to the initial vector:
```@example warmstart
copyto!(NLPModels.get_x0(nlp), results.solution)
```
Solving the problem again with MadNLP, we observe that MadNLP converges
in only 6 iterations:
```@example warmstart
results_new = madnlp(nlp)
nothing

```
By decreasing the initial barrier parameter , we can reduce the total number
of iterations to 5:
```@example warmstart
results_new = madnlp(nlp; barrier=MadNLP.MonotoneUpdate(; mu_init=1e-7))
nothing

```
The struct [`MonotoneUpdate`](@ref) implements the barrier strategy used by default in MadNLP,
and has an explicit attribute `mu_init` to define the initial barrier parameter.

The solution with the new parameters is slightly different from the former one:
```@example warmstart
results_new.solution

```

!!! info
    Similarly as with the primal solution, we can pass the initial dual solution to MadNLP
    using the function `get_y0`. We can overwrite the value of `y0` in `nlp` using:
    ```
    copyto!(NLPModels.get_y0(nlp), results.multipliers)
    ```
    and we specify to MadNLP to not recompute the dual multipliers using
    the option `dual_initialized`:
    ```
    madnlp(nlp; dual_initialized=true)
    ```
    In our particular example, setting the dual multipliers has only a minor influence
    on the convergence of the algorithm.

!!! info
    MadNLP does not support passing the initial values for the bounds' multipliers ``z_l`` and ``z_u``.


## Advanced solution: keeping the solver in memory

The previous solution works but is far from being efficient: each time we call
the function [`madnlp`](@ref) we create a new instance of [`MadNLPSolver`](@ref),
leading to a significant number of memory allocations. A workaround is to keep
the solver in memory to have more fine-grained control on the warm-start.

We start by creating a new model `nlp` and we instantiate a new instance [`MadNLPSolver`](@ref) attached to this model:
```@example warmstart
nlp = HS15Model()
solver = MadNLP.MadNLPSolver(nlp)
```
Note that
```@example warmstart
nlp === solver.nlp
```
Hence, updating the parameter values in `nlp` will automatically update the
parameters in the solver.

We first solve the problem using the function [`solve!`](@ref):
```@example warmstart
results = MadNLP.solve!(solver)
```
Before warmstarting MadNLP, we update the parameters and the primal solution in `nlp`:
```@example warmstart
nlp.params .= [101.0, 1.1]
copyto!(NLPModels.get_x0(nlp), results.solution)
```
MadNLP stores in memory the dual solutions computed during the first solve.
One can access to the (scaled) multipliers as
```@example warmstart
solver.y
```
and to the multipliers of the bound constraints with
```@example warmstart
[solver.zl.values solver.zu.values]
```

As before, it is advised to decrease the initial barrier parameter:
if the initial point is close enough to the solution, this reduces drastically
the total number of iterations. We solve the problem again using:
```@example warmstart
MadNLP.solve!(solver; barrier=MadNLP.MonotoneUpdate(; mu_init=1e-7))
nothing
```
Three observations are in order:
- The iteration count starts directly from the previous count (as stored in `solver.cnt.k`).
- MadNLP converges in only 4 iterations.
- The symbolic factorization of the KKT system stored in `solver` is directly re-used, leading to significant savings.
- The warm-start does not work if the structure of the problem changes between
  two consecutive solves (e.g, if variables or constraints are added to the constraints).

!!! warning
    If we call the function [`solve!`](@ref) a second-time,
    MadNLP will use the following rule:
    - The initial primal solution is copied from `NLPModels.get_x0(nlp)`
    - The initial dual solution is directly taken from the values specified
      in `solver.y`, `solver.zl` and `solver.zu`.
      (MadNLP is not using the values stored in `nlp.meta.y0` in the second solve).

```@meta
CurrentModule = MadNLP
```

# Callbacks

In MadNLP, a nonlinear program is implemented with a given `AbstractNLPModel`.
The model may have a form unsuitable for the interior-point algorithm.
For that reason, MadNLP wraps the `AbstractNLPModel` internally
using custom data structures, encoded as a `AbstractCallback`.
Depending on the setting, choose to wrap the `AbstractNLPModel`
as a [`DenseCallback`](@ref) or alternatively, as a [`SparseCallback`](@ref).

```@docs
AbstractCallback
DenseCallback
SparseCallback

```

The function [`create_callback`](@ref) allows to instantiate a `AbstractCallback`
from a given `NLPModel`:
```@docs
create_callback

```

Internally, a [`AbstractCallback`](@ref) reformulates the inequality
constraints as equality constraints by introducing additional slack variables.
The fixed variables are reformulated as parameters (using [`MakeParameter`](@ref))
or are relaxed (using [`RelaxBound`](@ref)). The equality constraints can
be keep as is with [`EnforceEquality`](@ref) (default option) or relaxed
as inequality constraints with [`RelaxEquality`](@ref). In that later case,
MadNLP solves a relaxation of the original problem.

```@docs
AbstractFixedVariableTreatment
MakeParameter
RelaxBound

AbstractEqualityTreatment
EnforceEquality
RelaxEquality
```

MadNLP has to keep in memory all the indexes associated to the equality
and inequality constraints, as well as the indexes of the bounded variables and the fixed variables.
The indexes are stored explicitly as a `Vector{Int}` in the `AbstractCallback` structure used by MadNLP.

```@meta
CurrentModule = MadNLP
```

# KKT systems

MadNLP manipulates KKT systems using two abstractions:
an `AbstractKKTSystem` storing the KKT system' matrix
and an `AbstractKKTVector` storing the KKT system's right-hand-side.


## AbstractKKTSystem

```@docs
AbstractKKTSystem

```

MadNLP implements three different types of `AbstractKKTSystem`,
depending how far we reduce the KKT system.

```@docs
AbstractUnreducedKKTSystem
AbstractReducedKKTSystem
AbstractCondensedKKTSystem
```

Each `AbstractKKTSystem` follows the interface described below:
```@docs

create_kkt_system

num_variables
get_kkt
get_jacobian
get_hessian

initialize!
build_kkt!
factorize_kkt!
solve_kkt!
compress_hessian!
compress_jacobian!
jtprod!
regularize_diagonal!
is_inertia_correct
should_regularize_dual
nnz_jacobian
```

## Sparse KKT systems

By default, MadNLP stores a `AbstractReducedKKTSystem` in sparse format,
as implemented by `SparseKKTSystem`:
```@docs
SparseKKTSystem

```
The user has the alternative choices:
```@docs
SparseUnreducedKKTSystem
SparseCondensedKKTSystem
ScaledSparseKKTSystem
```

## Dense KKT systems

MadNLP provides also two structures to store the KKT system
in a dense matrix. Although less efficient than their sparse counterparts,
these two structures allow to store the KKT system efficiently when the
problem is instantiated on the GPU.
```@docs
DenseKKTSystem
DenseCondensedKKTSystem

```

## Schur complement KKT system

For two-stage stochastic programs with a block-arrowhead structure,
MadNLP provides a specialized KKT system that eliminates the per-scenario
blocks and reduces the linear system to a dense `nd × nd` Schur complement
on the design variables.
```@docs
SchurComplementKKTSystem

```

## AbstractKKTVector
Each instance of `AbstractKKTVector` implements the following interface.

```@docs
AbstractKKTVector

number_primal
number_dual
full
primal
dual
primal_dual
dual_lb
dual_ub

```

By default, MadNLP provides one implementation of an `AbstractKKTVector`.

```@docs
UnreducedKKTVector
```

# Interior-point algorithm

```@meta
CurrentModule = MadNLP
```

We give a brief description of the interior-point algorithm
used in MadNLP, together with [the principal options](options.md)
impacting MadNLP's behavior. The algorithm is described in more length in the
[Ipopt paper](https://link.springer.com/article/10.1007/S10107-004-0559-Y).

MadNLP searches for a local solution of the nonlinear program:
```math
  \begin{aligned}
    \min_{x} \; & f(x) \;, \\
    \text{subject to} \quad & g_\ell \leq g(x) \leq g_u \; ,\\
                            & x_\ell \leq x \leq x_u \; ,
  \end{aligned}
```
where $$x \in \mathbb{R}^n$$ is the decision variable, $$f: \mathbb{R}^n \to \mathbb{R}$$
and $$g: \mathbb{R}^n \to \mathbb{R}^m$$ two smooth nonlinear functions.

## Pre-processing

Before running the interior-point method, MadNLP applies a pre-processing to the problem
to improve the numerical performance. The pre-processing operations are described below.

### Problem's reformulation

#### Slack variables
First, MadNLP splits the equality from the inequality constraints in the definition of the feasible set:
```math
g_\ell \leq g(x) \leq g_u \; .
```
If $$g_{\ell,i} < g_{u,i}$$, the constraint is reformulated as
```math
g_i(x) - s_i = 0  \; , \quad g_{\ell, i} \leq s_i \leq g_{u,i} \; ,
```
with $$s_i$$ an additional slack variable. By doing so, all the inequality
constraints are moved into the bound constraints. This benefits directly
to the interior-point algorithm, as it becomes much easier to compute a strictly feasible
initial point.

!!! info
    MadNLP only reformulates with a slack variable the inequality constraints,
    the equality constraints are left untouched.

As a result, we obtain an equivalent problem with the following structure:
```math
  \begin{aligned}
    \min_{w} \; & f(w) \; , \\
    \text{subject to} \quad & c(w) = 0 \; , \quad w \geq 0 \; .
  \end{aligned}
```
with $$w = (x, s)$$ and $$c(w) = (g_I(x) - s, g_E(x))$$, with ``I``
the index set for the inequality constraints and ``E`` the index set for equality constraints.

!!! info
    To simplify the exposition, we have assumed that the variables
    have all their lower bound sets to zero, and no upper bound.

The KKT stationary conditions associated to the reformulated problem are:
```math
  \begin{aligned}
    & \nabla f(w) + \nabla c(w)^\top y - z = 0 \; , \\
    & c(w) = 0 \; , \\
    & 0 \leq w \perp z \geq 0 \; .
  \end{aligned}
```
MadNLP looks for a primal-dual solution $$(w, y, z)$$ satisfying the KKT conditions.

The Lagrangian of the problem is:
```math
L(w, y, z) = f(w) + c(w)^\top y - z^\top w \; .
```

#### Fixed variables
If for some ``i=1, \cdots,n`` we have ``x_{\ell,i} = x_{u,i}``, the variable's lower bound is equal
to its upper bound, meaning the variable is fixed.
By default, MadNLP removes all the fixed variables in the problem.

Alternatively, MadNLP can relax all the fixed variables with a small parameter epsilon as
```math
x_{\ell,i} - \epsilon \leq x_i \leq x_{u,i} + \epsilon \; .
```
The behavior is specified by the option `fixed_variable_treatment`:
if set to [`MakeParameter`](@ref), MadNLP removes the fixed variables,
and if it is set to [`RelaxBound`](@ref) MadNLP relaxes the bounds.

#### Equality constraints

As discussed before, MadNLP keeps the equality constraints ``g_E(x) = 0 `` untouched in the problem.
However, it is sometimes appropriate to relax the equality constraints
by converting them to (tight) inequality constraints:
```math
-\tau \leq g_E(x) \leq \tau \; .
```
That behavior is determined by the option `equality_treatment`.
It is set to [`EnforceEquality`](@ref) by default. If otherwise it is set to [`RelaxEquality`](@ref),
the equality constraints are relaxed as inequality constraints.

### Scaling

Once the problem has been reformulated, MadNLP scales the objective
and the constraints to ensure that the gradient and the rows of the Jacobian
have all a norm being less than `nlp_scaling_max_gradient` (by default equal to `100.0`).
The lower the value of `nlp_scaling_max_gradient`, the more aggressive the scaling gets.

The scaling can be deactivated by setting `nlp_scaling=false`.

### Computing the initial primal-dual iterate

The user can pass to MadNLP an initial primal point ``x_0``. MadNLP modifies
it to ensure it is strictly feasible by applying the operation
```math
x_{0,j} = \max(x_{0,j}, \kappa_1) \; ,
```
with ``\kappa_1`` the parameter specified in the option `bound_push`.

If `dual_initialized=false` (default), MadNLP computes the initial dual multiplier ``y_0``
as solution of the least-square problem
```math
\begin{bmatrix}
I & J_0^\top \\
J_0 & 0
\end{bmatrix}
\begin{bmatrix}
w \\ y_0
\end{bmatrix}
=
-
\begin{bmatrix}
 \nabla f(x_0) - z_0  \\ 0
\end{bmatrix} \; .
```
Otherwise, if `dual_initialized=true`, MadNLP uses the values passed by the user.

!!! info
    The user cannot pass the initial value of the bound multiplier.
    MadNLP automatically sets ``z_0 = 1``.


## Interior-point iterations

MadNLP solves the KKT conditions iteratively using a globalized Newton algorithm.
The interior-point method reformulates the KKT conditions using a homotopy method, with,
for a positive barrier parameter $$\mu > 0$$:
```math
\begin{aligned}
& \nabla f(w) + \nabla c(w)^\top y - z = 0 \; , \\
& c(w) = 0 \; , \\
& WZe = \mu e \;, \; (w, z) > 0 \; .
\end{aligned}
```

The algorithm stops as soon as `max(inf_pr, inf_du, inf_compl) < tol`, with
```math
\begin{aligned}
& \texttt{inf\_pr} = \| \nabla f(w) + \nabla c(w)^\top y - z \|_\infty \; , \\
& \texttt{inf\_du} = \| c(w) \|_\infty \; , \\
& \texttt{inf\_compl} = \| WZe \|_\infty \; .
\end{aligned}
```
The tolerance `tol` is set to `1e-8` by default.

If the stopping criterion is not satisfied, MadNLP moves to the next iteration (here
denoted with an index ``k``). The iteration proceeds in four steps.

### Step 1: Computing the first and second-order sensitivities

First, MadNLP evaluates the Jacobian of the constraints ``J_k = \nabla c(w_k)^\top``
and the Hessian of the Lagrangian ``H_k = \nabla_{xx}^2 L(w_k, y_k, z_k)``.

MadNLP evaluates the sensitivities inside an [`AbstractCallback`](@ref),
which acts as a buffer between the solver and the model implemented with `NLPModels`.
Compared to the original model, the `AbstractCallback` adds the slack
variable and scales the problem appropriately.

By default the two matrices ``J_k`` and ``H_k`` are assumed sparse, with only the
non-zero entries being stored. If convenient, the user can evaluate them in dense format
by switching to a [`DenseCallback`](@ref) by setting the option:
```
callback=DenseCallback
```

### Step 2: Updating the barrier parameter

Once the sensitivities are evaluated, MadNLP updates the barrier parameter $$\mu$$.
By default, MadNLP uses the monotone update rule inspired by the Fiacco-McCormick rule: [`MonotoneUpdate`](@ref).
Alternatively, MadNLP provides two adaptive update rules, implemented in the solver respectively
as [`QualityFunctionUpdate`](@ref) and [`LOQOUpdate`](@ref).
The user can change the barrier update, e.g. by setting the option
```
barrier=QualityFunctionUpdate()
```

!!! info
    We recommend using an adaptive barrier update for difficult problems,
    in particular if we have a poor initial iterate ``x_0``.

### Step 3: Solving the primal-dual KKT system

With the new barrier parameter, we can compute a new KKT residual. MadNLP aims at decreasing
this residual by computing a Newton step ``(\Delta w, \Delta y, \Delta z)`` solution of
the primal-dual KKT system:
```math
\begin{bmatrix}
H_k +\delta_x I & J_k^\top & -I \\
J_k & -\delta_y & 0 \\
Z_k & 0 & W_k
\end{bmatrix}
\begin{bmatrix}
\Delta w \\ \Delta y \\ \Delta z
\end{bmatrix}
= -
\begin{bmatrix}
 \nabla f(w_k) + \nabla c(w_k)^\top y_k - z_k \\
 c(w_k)  \\
 W_k Z_k e - \mu e
\end{bmatrix} \; ,
```
with $$\delta_x$$ and $$\delta_y$$ appropriate primal-dual regularization terms
whose exact roles are detailed hereafter.


#### Solution of the primal-dual KKT system
The linear system is called a *primal-dual KKT system*. MadNLP can solve a symmetrized
version of the primal-dual KKT system, known as an [`AbstractUnreducedKKTSystem`](@ref).
However, it is beneficial to remove the blocks associated to $$\Delta z$$  and solve
the smaller [`AbstractReducedKKTSystem`](@ref):
```math
\begin{bmatrix}
H_k + \Sigma_k + \delta_x I & J_k^\top \\
J_k & -\delta_y
\end{bmatrix}
\begin{bmatrix}
\Delta w \\ \Delta y
\end{bmatrix}
= -
\begin{bmatrix}
 \nabla f(w_k) + \nabla c(w_k)^\top y_k - \mu_k W_k^{-1} e \\
 c(w_k)
\end{bmatrix}
```
with the diagonal matrix ``\Sigma_k = W_k^{-1} Z_k``.
The default implementation of the `AbstractReducedKKTSystem` is provided in [`SparseKKTSystem`](@ref).
If the problem exhibits significant ill-conditioning, the user can also use a [`ScaledSparseKKTSystem`](@ref),
which is more numerically stable than the [`SparseKKTSystem`](@ref).

There exists a smaller system [`AbstractCondensedKKTSystem`](@ref) that also removes
the blocks associated to the inequality constraints. This system
is useful if the problem has many inequality constraints, or more importantly,
[to run MadNLP on the GPU](tutorials/gpu.md). The user can switch the KKT system by using the option
```julia
kkt_system=SparseUnreducedKKTSystem
```
For certain highly structured problem, it may be beneficial to implement
a [custom KKT system](tutorials/kktsystem.md) to exploit the problem's structure.

#### Inertia-correction

The vector $$(\Delta w, \Delta y, \Delta z)$$ is a descent direction
if the reduced Hessian (the Hessian $$H_k$$ projected on the null-space of the Jacobian
$$J_k$$) of the primal-dual KKT system is **positive definite**.
The reduced Hessian is positive definite if and only if the inertia of the reduced primal-dual KKT system (the number of positive,
zero and negative eigenvalues) should exactly be equal to ``(n, 0, m)``.

MadNLP uses an inertia correction mechanism that increases the values of the
primal and dual regularizations $$(\delta_x, \delta_y)$$ in the KKT system until the inertia
of the system is exactly ``(n, 0, m)``. This procedure requires using
an *inertia-revealing* inertia solver that returns explicitly the inertia of the system
as an output of the factorization. This procedure can be costly, as it involves
re-factorizing the linear system each time a new regularization is tried.

If the linear solver does not compute the inertia of the KKT system, MadNLP
uses the inertia-free algorithm described [in this article](https://link.springer.com/article/10.1007/s10589-015-9820-y). This procedure is less stringent than the classical inertia-based correction,
in the sense that it doesn't require the reduced Hessian to be positive definite.
The inertia-free correction can be activated explicitly by
using the option `inertia_correction_method=InertiaFree`.

### Step 4: Finding the next iterate using the filter line-search

MadNLP uses the descent direction ``(\Delta w, \Delta y, \Delta z)`` to compute the next iterate as
```math
w_{k+1} = w_k + \alpha_k^p \Delta w \; , \quad
y_{k+1} = y_k + \alpha_k^d \Delta y \; , \quad
z_{k+1} = z_k + \alpha_k^d \Delta z \; .
```
First, the algorithm computes the maximum primal-dual steps ``(\alpha_k^{p,max}, \alpha_k^{d,max})``
satisfying the *fraction-to-boundary* rule:
```math
w_k + \alpha_k^{p,max} \Delta w \geq (1-\tau) w_k  \; , \quad
z_k + \alpha_k^{d,max} \Delta z \geq (1-\tau) z_k  \; .
```
This ensures that the iterates remain positive: ``(w_{k+1}, z_{k+1}) > 0``.
In MadNLP, ``\tau = \max(\tau_{min}, 1-\mu)``, with ``\tau_{min}`` a parameter
defined by the option `tau_min`.

Once the maximum steps computed with the fraction-to-boundary rule, MadNLP finds
the new iterate by using a backtracking line-search by testing different trial
values for $$\alpha_{k,l} = \frac{1}{2^l} \alpha_k^{p,max}$$. Once a new trial
iterate $$w_{k,l} = w_k + \alpha_{k,l} \Delta w$$ achieves sufficient progress,
the line-search stops and MadNLP proceeds to the next iteration.
The progress is measured by a [filter](https://link.springer.com/article/10.1007/s101070100244),
which accepts a new point either if it reduces the value of the barrier
function $$\phi_\mu(w) = f(w) - \mu \sum_{i=1}^n \log(w_i)$$ or it reduces
the constraint violation $$\|c(w)\|_1$$, by comparing these two values with those of a list of past iterates.


#### Feasility restoration phase

If no acceptable step is found by the line search, MadNLP switches to a restoration
phase that attempts at projecting the current iterate onto the feasible set.
The problem solved by the restoration phase is:
```math
\begin{aligned}
\min_{w} \;& \| c(w) \|_1 \\
\text{subject to} \quad & x \geq 0 \; .
\end{aligned}
```
Once the constraint violation has been significantly reduced, MadNLP returns
to the classical algorithm. If the feasibility restoration phase converges
to a solution of the feasibility restoration problem with a positive objective,
the problem is detected as being locally infeasible.

```@meta
CurrentModule = MadNLP
```

# Barrier strategies

The structure `AbstractBarrierUpdate` encodes the barrier strategy currently
used in MadNLP. The strategy is defined by the option `barrier` when initializing
MadNLP.
```@docs
AbstractBarrierUpdate
update_barrier!

```

## Monotone strategy

By default, MadNLP uses a monotone strategy, following the Fiacco-McCormick approach.

```@docs
MonotoneUpdate

```

## Adaptive strategies

As an alternative to the monotone strategy, MadNLP implements several
adaptive rules, all described in [this article](https://epubs.siam.org/doi/abs/10.1137/060649513).
```@docs
AbstractAdaptiveUpdate
QualityFunctionUpdate
LOQOUpdate

```

# Implementing a custom KKT system

```@meta
CurrentModule = MadNLP
```
```@setup kktsystem
using NLPModels
using MadNLP
using Random

include("hs15.jl")
include("diag_kkt.jl")

```

This tutorial explains how to implement a custom [`AbstractKKTSystem`](@ref) in MadNLP.

## Structure exploiting methods

MadNLP gives the user the possibility to exploit the problem's structure
at the linear algebra level, when solving the KKT system at every Newton iteration.
By default, the KKT system is factorized using a sparse linear solver (like MUMPS, PARDISO or HSL MA57).
A sparse linear solver analyses the problem's algebraic structure when computing the
symbolic factorization, with a heuristic that determines an optimal elimination tree.
As an alternative, the problem's structure can be exploited directly, by specifying
the order of the pivots to perform (e.g. using a block elimination algorithm).
Doing so usually leads to significant speed-up in the algorithm.

We recall that the KKT system solved at each Newton iteration has the structure:
```math
\overline{
\begin{pmatrix}
 H       & J^\top & - I    & I \\
 J       & 0      & 0      & 0 \\
 -Z_\ell & 0      & X_\ell & 0 \\
 Z_u     & 0      & 0      & X_u
\end{pmatrix}}^{K}
\begin{pmatrix}
    \Delta x \\
    \Delta y \\
    \Delta z_\ell \\
    \Delta z_u
\end{pmatrix}
=
\begin{pmatrix}
    r_1 \\ r_2 \\ r_3 \\ r_4
\end{pmatrix}
```
with ``H`` a sparse matrix storing the (approximated) Hessian of the Lagrangian,
and ``J`` a sparse matrix storing the Jacobian of the constraints.
We note the diagonal matrices
``Z_\ell = diag(z_\ell)``,
``Z_u = diag(z_u)``,
``X_\ell = diag(x_\ell - x)``,
``X_u = diag(x - x_u)``.

In MadNLP, every linear system with the structure ``K`` is implemented as an [`AbstractKKTSystem`](@ref).
By default, MadNLP represents a KKT system as a [`SparseKKTSystem`](@ref).

```@example kktsystem
nlp = HS15Model()
results = madnlp(nlp; kkt_system=MadNLP.SparseKKTSystem, linear_solver=LapackCPUSolver)
nothing

```


## Solving an AbstractKKTSystem in MadNLP

The `AbstractKKTSystem` object is an abstraction to solve the generic
system ``K x = b``. Depending on the implementation, the structure of the linear system
is exploited in different fashions. Solving a KKT system amounts to the four
following operations:
1. Querying the current sensitivities to assemble the different blocks constituting the matrix ``K``.
2. Assembling a reduced sparse matrix condensing the sparse matrix ``K`` to an equivalent smaller symmetric system.
3. Calling a linear solver to solve the condensed system.
4. Calling a routine to unpack the condensed solution to get the original descent direction ``(\Delta x, \Delta y, \Delta z_\ell, \Delta z_u)``.

Exploiting the problem's structure usually happens in steps (2), (3) and (4).
We skim through the four successive steps in more details.

### Getting the sensitivities

The KKT system requires the following information:

- the (approximated) Hessian of the Lagrangian ``H`` ;
- the constraints' Jacobian ``J`` ;
- the diagonal matrices ``Z_\ell``, ``Z_u`` and ``X_\ell``, ``X_u``.

The Hessian and the Jacobian are assumed sparse by default.

At every IPM iteration, MadNLP updates automatically the values in
``H``, ``J`` and in the diagonal matrices ``Z_\ell, Z_u, X_\ell, X_u``.
By default, we expect the following attributes available in every instance `kkt` of an `AbstractKKTSystem`:

- `kkt.hess`: stores the nonzeros of the Hessian ``H``;
- `kkt.jac`: stores the nonzeros of the Jacobian ``J``;
- `kkt.l_diag`: stores the diagonal entries in ``X_\ell``;
- `kkt.u_diag`: stores the diagonal entries in ``X_u``;
- `kkt.l_lower`: stores the diagonal entries in ``Z_\ell``;
- `kkt.u_lower`: stores the diagonal entries in ``Z_u``.

The attributes `kkt.hess` and `kkt.jac` are accessed respectively using
the getters [`get_hessian`](@ref) and [`get_jacobian`](@ref).

Every time MadNLP queries the Hessian and the Jacobian, it updates the
nonzero values in `kkt.hess` and `kkt.jac`.
Rightafter, MadNLP calls
the functions [`compress_hessian!`](@ref) and [`compress_jacobian!`](@ref) respectively, to propagate these updates to all internal structures of the KKT system `kkt` associated with the Hessian and the Jacobian.

To recap, every time we evaluate the Hessian and the Jacobian, MadNLP
calls automatically the functions:
```julia
hess = MadNLP.get_hessian(kkt)
MadNLP.compress_hessian!(kkt)
```
to update the values in the Hessian, and for the Jacobian:
```julia
jac = MadNLP.get_jacobian(kkt)
MadNLP.compress_jacobian!(kkt)
```

### Assembling the KKT system

Once the sensitivities have been updated, we can assemble the KKT matrix ``K``
and condense it to an equivalent system ``K_{c}`` before factorizing it with a linear solver.
The assembling of the KKT system is done in the function [`build_kkt!`](@ref).

The system is usually stored in the attribute `kkt.aug_com`. Its dimension depends on the condensation used.
The matrix `kkt.aug_com` can be dense or sparse, depending on the condensation used.
MadNLP uses the getter [`get_kkt`](@ref) to query the matrix `kkt.aug_com` stored in the KKT system `kkt`.


### Solving the system

Once the matrix ``K_c`` is assembled, we pass it to the linear solver
for factorization.
The linear solver is stored internally in `kkt`.
By default, it is stored in the attribute `kkt.linear_solver`.
The factorization is handled internally in MadNLP.

Once factorized, it remains to solve the linear system using a backsolve.
The backsolve has to be implemented by the user in the function [`solve_kkt!`](@ref).
It reduces the right-hand-side (RHS) down to a form adapted to the condensed matrix
``K_c`` and calls the linear solver to perform the backsolve.
Then the condensed solution
is unpacked to recover the full solution ``(\Delta x, \Delta y, \Delta z_\ell, \Delta z_u)``.

To recap, MadNLP assembles and solves the KKT linear system using the
following operations:
```julia
# Assemble the KKT system
MadNLP.build_kkt!(kkt)

# Factorize the KKT system
MadNLP.factorize_kkt!(kkt)

# Backsolve
MadNLP.solve_kkt!(kkt, w)
```

## Example: Implementing a new KKT system

As an example, we detail how to implement a custom KKT system in MadNLP.
Note that we consider this usage as an advanced use of MadNLP.
After this work of caution, let's dive into the details!

In this example, we want to approximate the Hessian of the Lagrangian ``H`` as a diagonal matrix ``D_H``
and solve the following KKT system at each IPM iteration:
```math
\begin{pmatrix}
 D_H & J^\top & - I & I \\
 J & 0 &  0 & 0 \\
 -Z_\ell &  0 & X_\ell & 0 \\
 Z_u & 0 &  0 & X_u
\end{pmatrix}
\begin{pmatrix}
    \Delta x \\
    \Delta y \\
    \Delta z_\ell \\
    \Delta z_u
\end{pmatrix}
=
\begin{pmatrix}
    r_1 \\ r_2 \\ r_3 \\ r_4
\end{pmatrix}
```
This new system is not equivalent to the original system ``K``, but it's much easier to solve
at it does not involve the full Hessian ``H``.
If the diagonal values of ``D_H`` are constant and are equal to ``\alpha``, the algorithm becomes equivalent to a gradient descent with step ``\alpha^{-1}``.

Using the relations
``\Delta z_\ell = X_\ell^{-1} (r_3 + Z_\ell \Delta x)`` and ``\Delta z_u = X_u^{-1} (r_4 - Z_u \Delta x)``,
we condense the matrix down to the reduced form:
```math
\begin{pmatrix}
 D_H + \Sigma_x & J^\top \\
 J & 0  \\
\end{pmatrix}
\begin{pmatrix}
    \Delta x  \\
    \Delta y
\end{pmatrix}
=
\begin{pmatrix}
    r_1 + X_\ell^{-1} r_3 - X_u^{-1} r_4\\ r_2
\end{pmatrix}
```
with the diagonal matrix ``\Sigma_x = -X_\ell^{-1} Z_\ell - X_u^{-1} Z_u``.
The new system is symmetric indefinite, but much easier to solve than the original one.

The previous reduction is standard in NLP solvers: MadNLP implements the reduced KKT
system operating in the space ``(\Delta x, \Delta y)`` using the abstraction
[`AbstractReducedKKTSystem`](@ref). If ``D_H`` is replaced by the original
Hessian matrix ``H``, we recover exactly the [`SparseKKTSystem`](@ref) used by default in MadNLP.

### Creating the KKT system

We create a new KKT system `DiagonalHessianKKTSystem`, inheriting from [`AbstractReducedKKTSystem`](@ref).
Using generic types, the structure `DiagonalHessianKKTSystem` is defined as:

```julia
struct DiagonalHessianKKTSystem{T, VT, MT, QN, LS, VI, VI32} <: MadNLP.AbstractReducedKKTSystem{T, VT, MT, QN}
    # Nonzeroes values for Hessian and Jacobian
    hess::VT
    jac_callback::VT
    jac::VT
    # Diagonal matrices
    reg::VT
    pr_diag::VT
    du_diag::VT
    l_diag::VT
    u_diag::VT
    l_lower::VT
    u_lower::VT
    # Augmented system K
    aug_raw::MadNLP.SparseMatrixCOO{T,Int32,VT, VI32}
    aug_com::MT
    aug_csc_map::Union{Nothing, VI}
    # Diagonal of the Hessian
    diag_hess::VT
    # Jacobian
    jac_raw::MadNLP.SparseMatrixCOO{T,Int32,VT, VI32}
    jac_com::MT
    jac_csc_map::Union{Nothing, VI}
    # LinearSolver
    linear_solver::LS
    # Info
    n_var::Int
    n_ineq::Int
    n_tot::Int
    ind_ineq::VI
    ind_lb::VI
    ind_ub::VI
    # Quasi-Newton approximation
    quasi_newton::QN
end

```

!!! info
    Remind that the primal vector manipulated by MadNLP concatenates the
    original primal variable together with a slack variable: ``w = (x, s)``.
    The KKT system requires the following information from MadNLP:
    - `n_var` is the dimension of the original primal variable ``x``;
    - `n_tot` is the dimension of the extended primal variable ``w``;
    - `n_ineq` is the number of inequality constraints, equal to the dimension of ``s``;
    - `ind_lb` is the index of the variables in ``w`` which are lower-bounded ;
    - `ind_ub` is the index of the variables in ``w`` which are upper-bounded.

!!! info
    Here, we define a DiagonalHessianKKTSystem as a subtype
    of a [`AbstractReducedKKTSystem`](@ref). Depending on the condensation,
    the following alternatives are available:
    - [`AbstractUnreducedKKTSystem`](@ref): no condensation is applied.
    - [`AbstractCondensedKKTSystem`](@ref): the reduced KKT system is condensed further by removing the blocks associated to the slack variables and inequality constraints.


!!! info
    The attributes `pr_diag` and `du_diag` store the primal and dual regularization terms, respectively.
    The primal regularization corresponds to the entries added to the diagonal of the (1,1) block, while the dual regularization corresponds to those added to the diagonal of the (2,2) block.
    By default, the dual regularization is set to zero, whereas the primal regularization is initialized to ``\Sigma_x``.

MadNLP instantiates a new KKT system with the function [`create_kkt_system`](@ref), with the following signature:
```julia
function MadNLP.create_kkt_system(
    ::Type{DiagonalHessianKKTSystem},
    cb::MadNLP.SparseCallback{T,VT},
    linear_solver::Type;
    opt_linear_solver=MadNLP.default_options(linear_solver),
    hessian_approximation=MadNLP.ExactHessian,
    qn_options=MadNLP.QuasiNewtonOptions(),
) where {T,VT}
```
We pass as arguments:
1. the type of the KKT system to build (here, `DiagonalHessianKKTSystem`),
2. the structure used to evaluate the callbacks `cb`,
3. a generic linear solver `linear_solver`.

This function instantiates all the data structures needed in `DiagonalHessianKKTSystem`.
The most difficult part is to assemble the sparse matrices `aug_raw` and `jac_raw`,
here stored in COO format.
This is done in four steps:

**Step 1.** We import the sparsity pattern of the Jacobian :
```julia
jac_sparsity_I = MadNLP.create_array(cb, Int32, cb.nnzj)
jac_sparsity_J = MadNLP.create_array(cb, Int32, cb.nnzj)
MadNLP._jac_sparsity_wrapper!(cb, jac_sparsity_I, jac_sparsity_J)
```
**Step 2.** We build the resulting KKT matrix `aug_raw` in COO format, knowing that ``D_H`` is diagonal:
```julia
# System's dimension
n_hess = n_tot # Diagonal Hessian!
n_jac = length(jac_sparsity_I)
aug_vec_length = n_tot+m
aug_mat_length = n_tot+m+n_hess+n_jac+n_slack

# Build vectors to store COO coortinates
I = MadNLP.create_array(cb, Int32, aug_mat_length)
J = MadNLP.create_array(cb, Int32, aug_mat_length)
V = VT(undef, aug_mat_length)
fill!(V, 0.0)  # Need to initiate V to avoid NaN

offset = n_tot+n_jac+n_slack+n_hess+m

# Primal regularization block
I[1:n_tot] .= 1:n_tot
J[1:n_tot] .= 1:n_tot

# Hessian block
I[n_tot+1:n_tot+n_hess] .= 1:n_tot # diagonal Hessian!
J[n_tot+1:n_tot+n_hess] .= 1:n_tot # diagonal Hessian!

# Jacobian block
I[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= (jac_sparsity_I.+n_tot)
J[n_tot+n_hess+1:n_tot+n_hess+n_jac] .= jac_sparsity_J

# Slack block
I[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= ind_ineq .+ n_tot
J[n_tot+n_hess+n_jac+1:n_tot+n_hess+n_jac+n_slack] .= (n+1:n+n_slack)

# Dual regularization block
I[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)
J[n_tot+n_hess+n_jac+n_slack+1:offset] .= (n_tot+1:n_tot+m)

aug_raw = MadNLP.SparseMatrixCOO(aug_vec_length, aug_vec_length, I, J, V)
```
**Step 3.** We convert `aug_raw` from COO to CSC using the following utilities:

```julia
aug_com, aug_csc_map = MadNLP.coo_to_csc(aug_raw)
```

**Step 4.** We pass the matrix in CSC format to the linear solver:

```julia
_linear_solver = linear_solver(aug_com; opt = opt_linear_solver)
```

!!! info
    Storing the Hessian and Jacobian, even in sparse format, is expensive in
    term of memory. For that reason, MadNLP stores the Hessian and Jacobian
    only once in the KKT system.


### Getting the sensitivities

MadNLP requires the following getters to update the sensitivities. As much as we can,
we try to update the values inplace in the matrix `aug_raw`.
We use the default implementation of [`compress_jacobian!`](@ref) in MadNLP:
```julia
function MadNLP.compress_jacobian!(kkt::DiagonalHessianKKTSystem)
    ns = length(kkt.ind_ineq)
    kkt.jac[end-ns+1:end] .= -1.0
    MadNLP.transfer!(kkt.jac_com, kkt.jac_raw, kkt.jac_csc_map)
    return
end
```
The term `-1.0` accounts for the slack variables used to reformulate
the inequality constraints as equality constraints.

For [`compress_hessian!`](@ref), we take into account that the diagonal matrix
``D_H`` is the diagonal of the Hessian:

```julia
function MadNLP.compress_hessian!(kkt::DiagonalHessianKKTSystem)
    kkt.diag_hess .= 1.0
    return
end
```

MadNLP also needs the following basic functions to get the different matrices and
the dimension of the linear system:
```
MadNLP.num_variables(kkt::DiagonalHessianKKTSystem) = length(kkt.diag_hess)
MadNLP.get_kkt(kkt::DiagonalHessianKKTSystem) = kkt.aug_com
MadNLP.get_jacobian(kkt::DiagonalHessianKKTSystem) = kkt.jac_callback
function MadNLP.jtprod!(y::AbstractVector, kkt::DiagonalHessianKKTSystem, x::AbstractVector)
    mul!(y, kkt.jac_com', x)
end
```

### Assembling the KKT system
Once the sensitivities are updated, we assemble the new matrix ``K_c`` first
in COO format in `kkt.aug_raw`, before converting the matrix to CSC format in `kkt.aug_com`
using the utility `MadNLP.transfer!`:

```julia
function MadNLP.build_kkt!(kkt::DiagonalHessianKKTSystem)
    MadNLP.transfer!(kkt.aug_com, kkt.aug_raw, kkt.aug_csc_map)
end
```

### Solving the system

It remains to implement the backsolve. For the reduced KKT formulation, the RHS
``r_1 + X_\ell^{-1} r_3 - X_u^{-1} r_4`` is built automatically using the
function `MadNLP.reduce_rhs!`.
The backsolve solves for ``(\Delta x, \Delta y)``. The dual's descent direction
``\Delta z_\ell`` and ``\Delta z_u`` are recovered afterwards using
the function `MadNLP.finish_aug_solve!`:
```julia
function MadNLP.solve_kkt!(kkt::DiagonalHessianKKTSystem, w::MadNLP.AbstractKKTVector)
    MadNLP.reduce_rhs!(w.xp_lr, dual_lb(w), kkt.l_diag, w.xp_ur, dual_ub(w), kkt.u_diag)
    MadNLP.solve_linear_system!(kkt.linear_solver, primal_dual(w))
    MadNLP.finish_aug_solve!(kkt, w)
    return w
end
```

!!! note
    The function `solve_kkt!` takes as second argument a vector `w` being an
    [`AbstractKKTVector`](@ref). An `AbstractKKTVector` is a convenient data
    structure used in MadNLP to store and access the elements in the primal-dual vector
    ``(\Delta x, \Delta y, \Delta z_\ell, \Delta z_u)``.

!!! warning
    When calling `solve_kkt!`, the values in the vector `w` are updated inplace.
    The vector `w` should be initialized with the RHS ``(r_1, r_2, r_3, r_4)`` before calling
    the function `solve_kkt!`. The function modifies the values directly in the vector `w`
    to return the solution ``(\Delta x, \Delta y, \Delta z_\ell, \Delta z_u)``.

Last, MadNLP implements an iterative refinement method to get accurate descent
directions in the final iterations. The iterative refinement algorithm implements
Richardson's method, which requires multiplying the KKT matrix ``K`` on the right
by any vector ``w = (w_x, w_y, w_{z_l}, w_{z_u})``. This is provided in MadNLP
by overloading the function `LinearAlgebra.mul!`:

```julia
function LinearAlgebra.mul!(
    w::MadNLP.AbstractKKTVector{T},
    kkt::DiagonalHessianKKTSystem,
    x::MadNLP.AbstractKKTVector{T},
    alpha = one(T),
    beta = zero(T),
) where {T}

    mul!(primal(w), Diagonal(kkt.diag_hess), primal(x), alpha, beta)
    mul!(primal(w), kkt.jac_com', dual(x), alpha, one(T))
    mul!(dual(w), kkt.jac_com,  primal(x), alpha, beta)

    # Reduce KKT vector
    MadNLP._kktmul!(w,x,kkt.reg,kkt.du_diag,kkt.l_lower,kkt.u_lower,kkt.l_diag,kkt.u_diag, alpha, beta)
    return w
end
```


### Demonstration

We now have all the elements needed to solve the problem with the new KKT linear
system `DiagonalHessianKKTSystem`. We just have to pass the KKT system to MadNLP
using the option `kkt_system`:

```@example kktsystem
nlp = HS15Model()
results = madnlp(nlp; kkt_system=DiagonalHessianKKTSystem, linear_solver=LapackCPUSolver)
nothing
```

```@meta
CurrentModule = MadNLP
```

# MadNLP solver

MadNLP takes as input a nonlinear program encoded as
a `AbstractNLPModel` and solve it using interior-point.
The main entry point is the function `madnlp`:
```@docs
madnlp
MadNLPExecutionStats
```

In detail, the function [`madnlp`](@ref) builds a `MadNLPSolver` storing all
the required structures in the solution algorithm. Once the
`MadNLPSolver` instantiated, the function `solve!` is applied to solve the
nonlinear program with MadNLP's interior-point algorithm.

```@docs
MadNLPSolver
solve!

```

Users can also define a termination criteria by using the `intermediate_callback` solver option.
Besides termination, this is also useful for accessing the internal state of the solver and custom logging.

```@meta
CurrentModule = MadNLP
```
```@setup kkt_example
using LinearAlgebra
using SparseArrays
using NLPModels
using MadNLP
using MadNLPTests
nlp = MadNLPTests.HS15Model()

```

# KKT systems

KKT systems are linear system with a special KKT structure.
MadNLP uses a special structure [`AbstractKKTSystem`](@ref) to represent internally
the KKT system. The [`AbstractKKTSystem`](@ref) fulfills two goals:

1. Store the values of the Hessian of the Lagrangian and of the Jacobian.
2. Assemble the corresponding KKT matrix $$K$$.

## A brief look at the math

We have seen [previously](../algorithm.md) that MadNLP reformulates the
inequality constraints as equality constraints, by introducing slack variables.
In what follows, we denote by ``w = (x, s)`` the primal iterate concatenating
the original decision variable ``x`` and the slack variable ``s``.
Once reformulated, the problem has the following structure:
```math
  \begin{aligned}
    \min_{w} \; & f(w) \; , \\
    \text{subject to} \quad & c(w) = 0 \; , \quad w \geq 0 \; .
  \end{aligned}
```

At each iteration, MadNLP aims at solving the following system of nonlinear
equations, parameterized by a positive barrier parameter ``\mu``:
```math
\begin{aligned}
& \nabla f(w) + \nabla c(w)^\top y - z = 0 \; , \\
& c(w) = 0 \; , \\
& WZe = \mu e \;, \; (w, z) > 0 \; .
\end{aligned}
```

MadNLP solves this system using the Newton method, and computes a
descent direction ``(\Delta w, \Delta y, \Delta z)`` as solution of
```math
\begin{bmatrix}
H_k +\delta_x I & J_k^\top & -I \\
J_k & -\delta_y & 0 \\
Z_k & 0 & W_k
\end{bmatrix}
\begin{bmatrix}
\Delta w \\ \Delta y \\ \Delta z
\end{bmatrix}
= -
\begin{bmatrix}
 \nabla f(w_k) + \nabla c(w_k)^\top y_k - z_k \\
 c(w_k)  \\
 W_k Z_k e - \mu e
\end{bmatrix} \; ,
```
with $$\delta_x$$ and $$\delta_y$$ appropriate primal-dual regularization terms
that guarantee ``(\Delta w, \Delta y, \Delta z)`` is a descent direction for the current filter.
The system needs evaluating the Jacobian of the constraints ``J_k = \nabla c(w_k)^\top``
and the Hessian of the Lagrangian ``H_k = \nabla_{xx}^2 L(w_k, y_k, z_k)``.

We note by ``(r_1, r_2, r_3)`` the right-hand-side. The primal-dual KKT system
can be symmetrized as
```math
\begin{bmatrix}
H_k +\delta_x I & J_k^\top & Z_k^{1/2} \\
J_k & -\delta_y & 0 \\
Z_k^{1/2} & 0 & -W_k
\end{bmatrix}
\begin{bmatrix}
\Delta x \\ \Delta y \\ -Z_k^{-1/2} \Delta z
\end{bmatrix}
=
\begin{bmatrix}
r_1 \\ r_2 \\ Z_k^{-1/2} r_3
\end{bmatrix}
```
This system is implemented as an [`AbstractUnreducedKKTSystem`](@ref) in MadNLP.

We can obtain a smaller augmented KKT system by eliminating the last block
of rows associated to ``\Delta z = W_k^{-1} (r_3 - Z_k \Delta w)``:
```math
\begin{bmatrix}
H_k + \Sigma_k + \delta_x I & J_k^\top \\
J_k & -\delta_y
\end{bmatrix}
\begin{bmatrix}
\Delta w \\ \Delta y
\end{bmatrix}
=
\begin{bmatrix}
r_1 + W_k^{-1} r_3 \\ r_2
\end{bmatrix}
```
with ``\Sigma_k = W_k^{-1} Z_k``.
This system is implemented as an [`AbstractReducedKKTSystem`](@ref) in MadNLP.


## Assembling a KKT system, step by step

The primal-dual KKT systems depend on the Hessian of the Lagrangian ``H_k``
and the Jacobian ``J_k``.
Hence, we have to update the values in the KKT system at each iteration
of the interior-point algorithm.

By default, MadNLP stores the KKT system as a [`SparseKKTSystem`](@ref).
The KKT system takes as input a [`SparseCallback`](@ref) wrapping
a given `NLPModel` `nlp`. We instantiate the callback `cb` with
the function [`create_callback`](@ref):
```@example kkt_example
cb = MadNLP.create_callback(
    MadNLP.SparseCallback,
    nlp,
)

```

### Initializing a KKT system

The size of the KKT system depends directly on the problem's characteristics
(number of variables, number of of equality and inequality constraints).
A [`SparseKKTSystem`](@ref) stores the Hessian and the Jacobian in sparse
(COO) format. The KKT matrix can be factorized using either a
dense or a sparse linear solvers. Here we use the solver provided
in LAPACK:
```@example kkt_example
linear_solver = LapackCPUSolver
```

We can instantiate a `SparseKKTSystem` using
the function [`create_kkt_system`](@ref):
```@example kkt_example
kkt = MadNLP.create_kkt_system(
    MadNLP.SparseKKTSystem,
    cb,
    linear_solver,
)

```

Once the KKT system built, one has to initialize it
to use it inside the interior-point algorithm:
```@example kkt_example
MadNLP.initialize!(kkt);

```

The user can query the KKT matrix inside `kkt`, simply as
```@example kkt_example
kkt_matrix = MadNLP.get_kkt(kkt)
```
This returns a reference to the KKT matrix stores internally
inside `kkt`. Each time the matrix is assembled inside `kkt`,
`kkt_matrix` is updated automatically.


### Updating a KKT system
We suppose now we want to refresh the values stored in the KKT system.


#### Updating the values of the Hessian
The Hessian part of the KKT system can be queried as
```@example kkt_example
hess_values = MadNLP.get_hessian(kkt)

```
For a `SparseKKTSystem`, `hess_values` is a `Vector{Float64}` storing
the nonzero values of the Hessian.
Then, one can update the vector `hess_values` by using NLPModels.jl:
```@example kkt_example
n = NLPModels.get_nvar(nlp)
m = NLPModels.get_ncon(nlp)
x = NLPModels.get_x0(nlp) # primal variables
l = zeros(m) # dual variables

NLPModels.hess_coord!(nlp, x, l, hess_values)

```
Eventually, a post-processing step is applied to refresh all the values internally:
```@example kkt_example
MadNLP.compress_hessian!(kkt)

```
!!! note
    By default, the function [`compress_hessian!`](@ref) does nothing.
    But it can be required for very specific use-case, for instance building internally a
    Schur complement matrix.


#### Updating the values of the Jacobian
We proceed exaclty the same way to update the values in the Jacobian.
One queries the Jacobian values in the KKT system as
```@example kkt_example
jac_values = MadNLP.get_jacobian(kkt)

```
We can refresh the values with NLPModels as
```@example kkt_example
NLPModels.jac_coord!(nlp, x, jac_values)

```
And then applies a post-processing step as
```@example kkt_example
MadNLP.compress_jacobian!(kkt)

```

#### Updating the values of the diagonal matrices
Once the Hessian and the Jacobian updated, the algorithm
can apply primal and dual regularization terms on the diagonal
of the KKT system, to improve the numerical behavior in the linear solver.
This operation is implemented inside the [`regularize_diagonal!`](@ref) function:
```@example kkt_example
pr_value = 1.0
du_value = 0.0

MadNLP.regularize_diagonal!(kkt, pr_value, du_value)

```

### Assembling the KKT matrix
Once the values updated, one can assemble the resulting KKT matrix.
This translates to
```@example kkt_example
MadNLP.build_kkt!(kkt)
```
By doing so, the values stored inside `kkt` will be transferred
to the KKT matrix `kkt_matrix` (as returned by the function [`get_kkt`](@ref)):
```@example kkt_example
kkt_matrix
```

Internally, a [`SparseKKTSystem`](@ref) stores the KKT system in
a sparse COO format. When [`build_kkt!`](@ref) is called, the sparse COO matrix
is transferred to `SparseMatrixCSC` if the linear solver is sparse,
or alternatively to a `Matrix` if the linear solver is dense.

!!! note
    The KKT system stores only the lower-triangular part of the KKT system,
    as it is symmetric.


## Solution of the KKT system
Now the KKT system is assembled in a matrix ``K`` (here stored in `kkt_matrix`), we want
to solve a linear system ``K x = b``, for instance to evaluate the
next descent direction. To do so, we use the linear solver stored
internally inside `kkt` (here an instance of `LapackCPUSolver`).

We start by factorizing the KKT matrix ``K``:
```@example kkt_example
MadNLP.factorize!(kkt.linear_solver)

```
By default, MadNLP uses a LBL factorization to decompose the symmetric
indefinite KKT matrix.

Once the KKT matrix has been factorized, we can compute the solution of the linear
system with a backsolve. The function takes as input a [`AbstractKKTVector`](@ref),
an object used to do algebraic manipulation with a [`AbstractKKTSystem`](@ref).
We start by instantiating two [`UnreducedKKTVector`](@ref) (encoding respectively
the right-hand-side and the solution):
```@example kkt_example
b = MadNLP.UnreducedKKTVector(kkt)
fill!(MadNLP.full(b), 1.0)
x = copy(b)

```
The right-hand-side encodes a vector of 1:
```@example kkt_example
MadNLP.full(b)
```
We solve the system ``K x = b`` using the [`solve_kkt!`](@ref) function:
```@example kkt_example
MadNLP.solve_kkt!(kkt, x)
MadNLP.full(x)
```
We verify that the solution is correct by multiplying it on the left
with the KKT system, using `mul!`:
```@example kkt_example
mul!(b, kkt, x) # overwrite b!
MadNLP.full(b)
```
We recover a vector filled with `1`, which was the initial right-hand-side.
